package jp.ne.so_net.ga2.no_ji.jcom;

/**
 * IDispatchC^[tF[X߂̃NX
 *
 * @see     IUnknown
 * @see     JComException
 * @see     ReleaseManager
	@author Yoshinori Watanabe(n `)
	@version 2.10, 2000/08/23
	Copyright(C) Yoshinori Watanabe 1999-2000. All Rights Reserved.
 */
public class IDispatch extends IUnknown {
    /**
		IID_IDispatch łB
		@see       GUID
	*/
	public static GUID IID = new GUID( 0x00020400, 0x0000, 0x0000, 0xC0, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x46 );
	public static final int METHOD         = 1;
	public static final int PROPERTYGET    = 2;
	public static final int PROPERTYPUT    = 4;
	public static final int PROPERTYPUTREF = 8;

    /**
     * IDispatch쐬܂B
     * Ŏw肳ꂽProgIDCOMIuWFNg쐬܂B
     *        <pre>
     *        ReleaseManager rm = new ReleaseManager();
     *        try {
     *            IDispatch excel = new IDispatch(rm ,"Excel.Application");
     *            excel.put("Visible", new Boolean(true));  // 'ftHgFalse(\Ȃ)
     *            // ...
     *            excel.invoke("Quit", null);
     *        } catch(JComException e) {
     *            e.printStackTrace();
     *        } finally {
     *            rm.release();
     *        }</pre>
     * @param     rm     	QƃJE^ǗNX
     * @param	  ProgID	vOhcBExcel̏ꍇ"Excel.Application"Ǝw肵܂B
     * @see       #create(String)
     * @see       ReleaseManager
	 */
	public IDispatch(ReleaseManager rm, String ProgID) throws JComException {
		super(rm);
		create(ProgID);
	}

    /**
     * IDispatch쐬܂B
     * Ŏw肳ꂽIDispatch|C^COM쐬܂B
     * ʏAʂCOM̃\bhԂꂽIDispatch|C^ɑ΂āA
     * gp܂B
     * @param     rm             QƃJE^ǗNX
     * @param     pIDispatch     IDispatchC^[tF[X̃AhX
     * @see       #create(String)
     * @see       ReleaseManager
	 */
	public IDispatch(ReleaseManager rm, int pIDispatch) {
		super(rm, pIDispatch);
	}

    /**
     * IDispatch쐬܂B
     * Ŏw肳ꂽIDispatchƓ̂bnlǗ܂B
     * ʏAʂCOMIuWFNg̃\bhŕԂꂽIDispatchɑ΂āA
     * gp܂B
     * ReleaseManageŕAdisp̎̂p܂B
     * @see       #create(String)
	 */
	public IDispatch(IDispatch disp) {
		super(disp.rm, disp.pIUnknown);
	}

    /**
     * ProgIDIDispatchC^[tF[X쐬܂B
     * łɍ쐬ĂꍇAO𔭐܂B
     * @param     ProgID COM̃vOID
     * @exception JComException <BR>
     *              "Already COM allocated" łCOM蓖ĂĂB<BR>
     *              "createInstance() failed HRESULT=0x%XL" bnl̍쐬ɎsB
     */
	public synchronized void create(String ProgID) throws JComException {
		_create(ProgID);
		if(rm!=null) rm.add(this);
	}

    /**
     * vpeB̒l擾܂B
     * vpeB̌^Ƃǐ^Ƃ̑Ή͈ȉ̒ʂłB
     * <pre>
     *   VT_EMPTY    null
     *   VT_I4       Integer
     *   VT_R8       Double
     *   VT_BOOL     Boolean
     *   VT_BSTR     String
     *   VT_DATE     Date
     *   VT_CY       VariantCurrency
     *   VT_DISPATCH IDispatch
     *   VT_UNKNOWN  IUnknown
     * </pre>
     *	<pre>IDispatch xlBooks = (IDispatch)xlApp.get("Workbooks");</pre>
	 *  <pre>Boolean visible = xlApp.gut("Visible");</pre>
     * @param     property vpeB
     * @return    擾ꂽl
     * @exception JComException <BR>
     *              "IDispatch not created"   IDispatch쐬ĂȂB<BR>
     *              "getProperty() failed HRESULT=0x%XL" bnľĂяoɎsB<BR>
     *              "cannot convert VT=0x%X" ΉVARIANT^ԂꂽB
     * @see       #get(String,Object[])
     * @see       #invoke(String,Object[])
     * @see       #put(String,Object)
     */
/*	public synchronized Object get(String property) throws JComException {
		Object ret = _get(property);
		if((rm!=null) && (ret instanceof IUnknown))
			rm.add((IUnknown)ret);
		return ret;
	}
*/
	public synchronized Object get(String property) throws JComException {
		int dispid = _getIDsOfNames(property);
		Object ret = _invoke(dispid, PROPERTYGET, null);
		if((rm!=null) && (ret instanceof IUnknown))
			rm.add((IUnknown)ret);
		return ret;
	}


    /**
     * vpeB̒l擾܂BvpeB̒l̎擾ɈKvȏꍇɎgp܂B
     * vpeB̌^Ƃǐ^Ƃ̑ΉIDispatch.get(property)QƂĂB
     * ̓nIDispatch.invoke()QƂĂB
     * @param     property vpeB
     * @param     args ̔z
     * @return    擾ꂽl
     * @exception JComException <BR>
     *              "IDispatch not created"   IDispatch쐬ĂȂB<BR>
     *              "Invalid argument(index=%d)" sB͖Ή̌^nꂽB<BR>
     *              "getPropertyArg() failed HRESULT=0x%XL" bnľĂяoɎsB<BR>
     *              "cannot convert VT=0x%X" ΉVARIANT^ԂꂽB
     * @see       #get(String)
     * @see       #invoke(String,Object[])
     * @see       #put(String,Object)
     */
/*	public synchronized Object get(String property, Object[] args) throws JComException {
		Object ret = _get(property, args);
		// bnlIuWFNgԂꂽAQƃJE^ǗNXɒǉB
		if((rm!=null) && (ret instanceof IUnknown))
			rm.add((IUnknown)ret);
		return ret;
	}
*/
	public synchronized Object get(String property, Object[] args) throws JComException {
		int dispid = _getIDsOfNames(property);
		Object ret = _invoke(dispid, PROPERTYGET, args);
		// bnlIuWFNgԂꂽAQƃJE^ǗNXɒǉB
		if((rm!=null) && (ret instanceof IUnknown))
			rm.add((IUnknown)ret);
		return ret;
	}


    /**
     * vpeBɒlݒ肵܂B
     * vpeB̌^Ƃǐ^Ƃ̑ΉIDispatch.get(property)QƂĂB
			<pre>xlApp.put("Visible", new Boolean(true));</pre>
			<pre>xlRange.put("Value","JComI(^o^)");</pre>
     * @param     property vpeB
     * @param     val ݒ肷l
     * @exception JComException <BR>
     *              "IDispatch not created"   IDispatch쐬ĂȂB<BR>
     *              "Invalid argument" sB͖Ή̌^nꂽB<BR>
     *              "putProperty() failed HRESULT=0x%XL" bnľĂяoɎsB<BR>
     * @see       #get(String)
     * @see       #get(String,Object[])
     * @see       #invoke(String,Object[])
     */
/*	public synchronized void   put(String property, Object val) throws JComException {
		_put(property, val);
	}
*/
	public synchronized void   put(String property, Object val) throws JComException {
		int dispid = _getIDsOfNames(property);
		Object[] args = new Object[1];
		args[0] = val;
		_invoke(dispid, PROPERTYPUT, args);
	}



    /**
     * \bhĂяo܂B
     * vpeB̌^Ƃǐ^Ƃ̑ΉJCom.get(property)QƂĂB
     * <pre>
			Object[] arglist = new Object[3];
			arglist[0] = new Boolean(false);
			arglist[1] = null;
			arglist[2] = new Boolean(false);
			xlBook.method("Close", arglist);
     * </pre>
     * @param     method \bh
     * @param     args   
     * @exception JComException <BR>
     *              "IDispatch not created"   IDispatch쐬ĂȂB<BR>
     *              "Invalid argument(index=%d)" sB͖Ή̌^nꂽB<BR>
     *              "invokeMethod() failed HRESULT=0x%XL" bnľĂяoɎsB<BR>
     *              "cannot convert VT=0x%X" ΉVARIANT^ԂꂽB
     * @see       #get(String)
     * @see       #get(String,Object[])
     * @see       #put(String,Object)
	 */
/*
	public synchronized Object method(String method, Object[] args) throws JComException {
		Object ret = _method(method, args);
		if((rm!=null) && (ret instanceof IUnknown))
			rm.add((IUnknown)ret);
		return ret;
	}
*/
	public synchronized Object method(String method, Object[] args) throws JComException {
		int dispid = _getIDsOfNames(method);
		Object ret = _invoke(dispid, METHOD, args);
		if((rm!=null) && (ret instanceof IUnknown))
			rm.add((IUnknown)ret);
		return ret;
	}

    /**
		method()QƂĂB
		@see	#method(String,Object[])
		@deprecated	method(String,Object[])ɒu܂B
	 */
	public synchronized Object invoke(String method, Object[] args) throws JComException {
		return method(method, args);
	}

    /**
		\bhAvpeB̐ݒE擾s܂B
		vpeB̌^Ƃǐ^Ƃ̑ΉJCom.get(property)QƂĂB
		<pre>
			Object[] arglist = new Object[3];
			arglist[0] = new Boolean(false);
			arglist[1] = null;
			arglist[2] = new Boolean(false);
			xlBook.invoke("Close", IDispatch.METHOD, arglist);
		</pre>
		@param     method \bh
		@param     args   
		@exception JComException <BR>
		             "IDispatch not created"   IDispatch쐬ĂȂB<BR>
		             "Invalid argument(index=%d)" sB͖Ή̌^nꂽB<BR>
		             "invokeMethod() failed HRESULT=0x%XL" bnľĂяoɎsB<BR>
		             "cannot convert VT=0x%X" ΉVARIANT^ԂꂽB
		@see       #get(String)
		@see       #get(String,Object[])
		@see       #put(String,Object)
		@see       #method(String,Object[])
	*/
	public synchronized Object invoke(String name, int wFlags, Object[] pDispParams) throws JComException {
		int dispid = _getIDsOfNames(name);
		return _invoke(dispid, wFlags, pDispParams);
	}

    /**
    	ITypeInfo擾܂B
	*/
	public synchronized ITypeInfo getTypeInfo() throws JComException {
		int pITypeInfo = _getTypeInfo();
		return new ITypeInfo(rm, pITypeInfo);
	}

	// release()super̂łnjD

	// JNI
	private native void   _create(String ProgID) throws JComException;
	private native Object _get(String property) throws JComException;
	private native Object _get(String property, Object[] args) throws JComException;
	private native void   _put(String property, Object val) throws JComException;
	private native Object _method(String method, Object[] args) throws JComException;
	private native int    _getTypeInfo() throws JComException;
	private native Object _invoke(int dispIdMember, int wFlags, Object[] pDispParams) throws JComException;
	private native int    _getIDsOfNames(String name) throws JComException;

	// jcom.dllǂݍ݂܂B
    static {
        System.loadLibrary("jcom");
    }
}

