/* Generated By:JavaCC: Do not edit this line. JudoParser.java */
package com.judoscript.parser;

import java.util.*;
import java.io.*;
import java.sql.Types;
import com.judoscript.*;
import com.judoscript.bio.*;
import com.judoscript.db.*;
import com.judoscript.xml.*;
import com.judoscript.util.*;
import com.judoscript.parser.helper.*;


public final class JudoParser extends ParserHelper implements JudoParserConstants {
  void upgradeMsg(String newOne) {
    RT.logger.warn(
      "Warning: line "+token.beginLine+" uses the deprecated keyword '"+token.image+"';\n"+
      "         Update and use '"+newOne+"'; THE OLD ONE WILL BE REMOVED IN VERSION 1.1!");
  }

  //////////////////////////////////////////////
  // data members

  boolean needDbgDirs = false;
  Stack labelStack = new Stack();

  static { Lib.indentText = "."; }

  String setCurrentLabel() throws ParseException {
    if (labelStack.contains(token.image))
      throwParseException("Label name '" + token.image + "' is already used in an outer loop.");
    labelStack.push(token.image);
    return token.image;
  }

  public HashMap getUsage(String name, String path) {
    try {
      script.setProgramName(name);
      script.setScriptPath(path);
      CompilationUnit(true);
      close();
      return script.getUsage();
    } catch(Exception e) {}
    return null;
  }

  void setFSAction(StmtFSList fs, String name, int action) throws ParseException {
    try {
      fs.setAction(name, action);
    } catch(Exception e) {
      throwParseException(e.getMessage());
    }
  }

  void handleFSOption(StmtFSList fs, String option) throws ParseException {
    boolean error = false;
    if (option.equals("recursive"))             fs.recursive = true;
    else if (option.equals("noHidden"))         fs.noHidden = true;
    else if (option.equals("remove"))           setFSAction(fs, "remove", FS_REMOVE);
    else if (fs instanceof StmtFSCopy) {
      StmtFSCopy fscopy = (StmtFSCopy)fs;
      if (option.equals("Echo"))                { fs.doEcho = true; fscopy.verbose = true; }
      else if (option.equals("echo"))           fscopy.doEcho = true;
      else if (token.image.equals("compress"))  fscopy.compress = true;
      else if (token.image.equals("store"))     fscopy.compress = false;
      else if (token.image.equals("force"))     fscopy.force=true;
      else if (token.image.equals("keepDirs"))  fscopy.keepDirs = true;
      else if (token.image.equalsIgnoreCase("dupOk")) fscopy.dupOk = true;
      else                                      error = true;
    } else {
      if (option.equals("fileOnly"))            fs.option = FileFinder.LIST_FILE_ONLY;
      else if (option.equals("showDir"))        fs.option = FileFinder.LIST_EVERYTHING;
      else if (option.equals("dirOnly"))        fs.option = FileFinder.LIST_DIR_ONLY;
      else if (option.equals("perFile"))        fs.infoOption = FS_LIST_PER_FILE;
      else if (option.equals("size"))           fs.setAction("size", FS_LIST_SIZE);
      else if (option.equals("count"))          fs.setAction("count", FS_LIST_COUNT);
      else if (option.equals("lines"))          fs.setAction("lines", FS_LIST_COUNTLINES);
      else if (option.equals("words"))          fs.setAction("words", FS_LIST_COUNTWORDS);
      else if (option.equals("compressedSize")) fs.setAction("compressedSize", FS_LIST_COMPRESSED_SIZE);
      else if (option.equalsIgnoreCase("addToClasspath"))
        fs.setAction("addToClasspath", FS_ADD_TO_CLASSPATH);
      else
        error = true;
    }
    if (error)
      throwParseException("Invalid file operation option: " + option);
  }

  public Script CompilationUnit(String name, String path, long lastMod, boolean needDebugDir)
                               throws ParseException
  {
    this.needDbgDirs = needDebugDir;
    script.setProgramName(name);
    script.setScriptPath(path);

    token_source.judoParser = this;

    // try the init file.
    try { token_source.switchToNewFileStream(".judoscript", null); } catch(Exception e) {}

    CompilationUnit(false);

    script.setLastModified(lastMod);
    close();
    return script;
  }

  public void optionNotApplyTo(String option, String target) throws ParseException {
    throwParseException("Option '" + option + "' does not apply to '" + target + "'.");
  }

  public void throwParseException(String message, String hint) throws ParseException {
    StringBuffer sb = new StringBuffer();
    if (message != null) sb.append(message);
    else sb.append("Parsing failed");
    sb.append(" at line ");
    sb.append(token.beginLine);
    sb.append(", column ");
    sb.append(token.beginColumn);
    sb.append(".");
    sb.append(eol);
    if (hint != null) {
      sb.append(hint);
      sb.append(eol);
    }
    throw new ParseException(sb.toString());
  }

  void handleSimpleCall(String name) {
    Object[] oa = new Object[]{ name, stack.pop() };
    stack.push( reduce(new ExprPrimary(oa)) );
  }

  void shouldBe(String text) throws ParseException {
    if (token.image.equals(text)) return;
    throwParseException("Expecting \"" + text + "\".");
  }

  static ConstInt toConstInt(Token t) { return ConstInt.getInt(toLong(t)); }

  static long toLong(Token t) {
    long ret = 0;
    try {
      String s = t.image;
      if (s.charAt(0) != '0') {  // non-0 decimal
        ret = Long.parseLong(s);
      } else if (s.length() == 1) {
        ret = 0; // "0"
      } else if ((s.charAt(1) == 'x') || (s.charAt(1) == 'X')) {  // hexadecimal
        s = s.substring(2);
        ret = Long.parseLong(s,16);
      } else {   // octal
        ret = Long.parseLong(s.substring(1),8);
      }
    } catch(Exception e) {}
    if (ret==0)  return 0;
    if (ret==1)  return 1;
    if (ret==-1) return -1;
    return ret;
  }

  static double toDouble(Token t) {
    try {
      String s = t.image;
      char ch = s.charAt(s.length()-1);
      if (ch=='f' || ch=='F' || ch=='d' || ch=='D')
        s = s.substring(0,s.length()-1);
      return Double.parseDouble(s);
    } catch(Exception e) { return 0.0; }
  }

  static void showClass(Object o) {
    System.out.println("==> class: " + o.getClass().getName());
  }

  int lineNum() { return token.endLine; }

  void switchTo(int state) { token_source.SwitchTo(state); }

  int fxnDeclStack = 0;

  // Trick: use a 2nd parser to parse a string for Mixture (only).
  private JudoParser subParser = null;

/**************************
 * HALF-LEXER-HALF-PARSER *
 **************************/

// These upgradeTo???() NTs are to print out warning messages for to-be-deprecated keywords.
  final public void upgradeToVar() throws ParseException {
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case VAR:
      jj_consume_token(VAR);
      break;
    case LOCAL:
      jj_consume_token(LOCAL);
                                                                  upgradeMsg("var");
      break;
    default:
      jj_la1[0] = jj_gen;
      jj_consume_token(-1);
      throw new ParseException();
    }
  }

  final public void upgradeToLinkedList() throws ParseException {
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case LINKEDLIST:
      jj_consume_token(LINKEDLIST);
      break;
    case LINKEDLIST_:
      jj_consume_token(LINKEDLIST_);
                                                                  upgradeMsg("LinkedList");
      break;
    default:
      jj_la1[1] = jj_gen;
      jj_consume_token(-1);
      throw new ParseException();
    }
  }

  final public void upgradeToSet() throws ParseException {
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case SET:
      jj_consume_token(SET);
      break;
    case SET_:
      jj_consume_token(SET_);
                                                                  upgradeMsg("Set");
      break;
    default:
      jj_la1[2] = jj_gen;
      jj_consume_token(-1);
      throw new ParseException();
    }
  }

  final public void upgradeToSortedMap() throws ParseException {
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case SORTEDMAP:
      jj_consume_token(SORTEDMAP);
      break;
    case SORTEDMAP_:
      jj_consume_token(SORTEDMAP_);
                                                                  upgradeMsg("SortedMap");
      break;
    default:
      jj_la1[3] = jj_gen;
      jj_consume_token(-1);
      throw new ParseException();
    }
  }

  final public void upgradeToDate() throws ParseException {
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case DATE:
      jj_consume_token(DATE);
      break;
    case DATE_:
      jj_consume_token(DATE_);
                                                                  upgradeMsg("Date");
      break;
    default:
      jj_la1[4] = jj_gen;
      jj_consume_token(-1);
      throw new ParseException();
    }
  }

  final public void upgradeToString() throws ParseException {
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case STRING:
      jj_consume_token(STRING);
      break;
    case STRING_:
      jj_consume_token(STRING_);
                                                                  upgradeMsg("String");
      break;
    default:
      jj_la1[5] = jj_gen;
      jj_consume_token(-1);
      throw new ParseException();
    }
  }

  final public void upgradeToNumber() throws ParseException {
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case NUMBER:
      jj_consume_token(NUMBER);
      break;
    case NUMBER_:
      jj_consume_token(NUMBER_);
                                                                  upgradeMsg("Number");
      break;
    default:
      jj_la1[6] = jj_gen;
      jj_consume_token(-1);
      throw new ParseException();
    }
  }

  final public void upgradeToUse() throws ParseException {
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case USE:
      jj_consume_token(USE);
      break;
    case USING:
      jj_consume_token(USING);
      break;
    default:
      jj_la1[7] = jj_gen;
      jj_consume_token(-1);
      throw new ParseException();
    }
    RT.logger.warn(
      "Warning: line "+token.beginLine+" uses the deprecated SQL scripting keyword '"+token.image+"';\n"+
      "         Update and use the <connection> syntax; THE OLD SYNTAX WILL BE REMOVED IN VERSION 1.1!");
  }

// This is a performance-aware keyword substitute.
  final public void id(String s) throws ParseException {
    jj_consume_token(IDENTIFIER);
                 if (!token.image.equals(s))
                   throwParseException("Expecting '" + s + "' but get '" + token.image + "'.");
  }

/*******************************************
 * THE JUDO LANGUAGE GRAMMAR STARTS HERE   *
 *******************************************/

/*
 * Program structuring syntax follows.
 */
  final public void CompilationUnit(boolean usageOnly) throws ParseException {
  int lastMark = markStack();
  boolean hasCatch = false;
  boolean hasFinally = false;
  int firstLine = 0;
  String catchName = null;
  if (!usageOnly) RT.pushContext( pc = new ParsingContext(script) );
    try {
      label_1:
      while (true) {
        switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
        case _USAGE:
        case ANTTASK__:
        case JAVA__:
        case _EOF:
        case __EOF:
        case AS:
        case BREAK:
        case CATCH:
        case CONST:
        case CONTINUE:
        case CLASS:
        case DEFINED:
        case DELETE:
        case DO:
        case ELIF:
        case EXEC:
        case EXTENDSJAVA:
        case FALSE:
        case FINALLY:
        case FOR:
        case FUNCTION:
        case THREAD:
        case JAVACLASS:
        case IF:
        case IFDEF:
        case IFNDEF:
        case IFEXISTS:
        case IMPORT:
        case IN:
        case INFINITY:
        case INTO:
        case INCLUDE:
        case LOCAL:
        case NEW:
        case JAVANEW:
        case MAX_NUMBER:
        case MIN_NUMBER:
        case NULL:
        case PRAGMA:
        case JAVAGUICLASS:
        case JAVABASECLASS:
        case JAVAENTERPRISECLASS:
        case JAVACORBACLASS:
        case JCOMCLASS:
        case JAVAPACKAGES:
        case DEFINEJAVAPACKAGES:
        case LIMIT:
        case NAMESPACE:
        case _SKIP:
        case RESUME:
        case RETURN:
        case SUPER:
        case SWITCH:
        case THIS:
        case THROW:
        case TYPEOF:
        case ATTRIBUTESOF:
        case TRUE:
        case TRY:
        case UNDEFINED:
        case USE:
        case VAR:
        case WHILE:
        case WITH:
        case BOOLEAN:
        case BYTE:
        case CHAR:
        case SHORT:
        case INT:
        case LONG:
        case FLOAT:
        case DOUBLE:
        case MAIL__SEND:
        case MAIL__CONNECT:
        case MAIL__DISCONNECT:
        case SENDMAIL:
        case CC:
        case BCC:
        case ATTACH:
        case SUBJECT:
        case BODY:
        case HTMLBODY:
        case DATE_:
        case DATE:
        case NUMBER:
        case COLUMN:
        case ERR:
        case LOG:
        case NL:
        case OUT:
        case PIPE:
        case INPUT:
        case OUTPUT:
        case NEEDSYSTEMIN:
        case FLUSH:
        case PRINT:
        case PRINTLN:
        case PRINTTABLE:
        case PRINTTABLEDATA:
        case SCP:
        case COPY:
        case MANIFEST:
        case LIST:
        case LS:
        case RMDIR:
        case EXCEPT:
        case SETFILETIME:
        case SETREADONLY:
        case SETREADWRITE:
        case TARGET:
        case ADDBATCH:
        case CONNECT:
        case EXECUTEBATCH:
        case EXECUTEQUERY:
        case EXECUTEQUERYCALL:
        case EXECUTEANY:
        case EXECUTESQL:
        case EXECUTEUPDATE:
        case EXECUTEUPDATECALL:
        case PREPARE:
        case PREPARECALL:
        case PREPAREDEXECUTE:
        case PREPAREDEXECUTECALL:
        case PREPAREDEXECUTEQUERY:
        case PREPAREDEXECUTECALLQUERY:
        case PREPAREDEXECUTEUPDATE:
        case PREPAREDEXECUTECALLUPDATE:
        case DB__DUMPTABLE:
        case DB__ADDBATCH:
        case DB__CONNECT:
        case DB__DISCONNECT:
        case DB__BATCH:
        case DB__QUERY:
        case DB__QUERYCALL:
        case DB__ANY:
        case DB__SQL:
        case DB__CALL:
        case DB__UPDATE:
        case DB__UPDATECALL:
        case DB__PREPARE:
        case DB__PREPARECALL:
        case HIB__SETUP:
        case HIB__ADDCLASS:
        case HIB__ADDRESOURCE:
        case HIB__CLOSE:
        case HIB__TXBEGIN:
        case HIB__TXEND:
        case HIB__TXABORT:
        case HIB__LOCK:
        case HIB__QUERY:
        case HIB__ITERATE:
        case HIB__DELETE:
        case HIB__GET:
        case HIB__SAVE:
        case HIB__SAVEORUPDATECOPY:
        case HIB__UNLOCK:
        case HIB__UPDATE:
        case AFTER:
        case REPEAT:
        case SCHEDULE:
        case STARTING:
        case XML:
        case XSLT:
        case SYSTEMID:
        case OUTPUTPROPERTIES:
        case PARAMETERS:
        case XMLNS:
        case HTML:
        case SGML:
        case GUIEVENTS:
        case GUI__EVENTS:
        case INTEGER_LITERAL:
        case FLOATING_POINT_LITERAL:
        case STRING_LITERAL:
        case EXEC_RESULT_LITERAL:
        case EXEC_RESULTLINES_LITERAL:
        case IDENTIFIER:
        case CONST_NAME:
        case BANG:
        case TILDE:
        case COLONCOLON:
        case INCR:
        case DECR:
        case PLUS:
        case MINUS:
        case BIT_AND:
        case DOLLARLBRACE:
        case LBRACE:
        case LPAREN:
        case DOT:
        case SEMICOLON:
          ;
          break;
        default:
          jj_la1[8] = jj_gen;
          break label_1;
        }
        switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
        case _USAGE:
          jj_consume_token(_USAGE);
                                  firstLine = lineNum();
          jj_consume_token(LBRACE);
          label_2:
          while (true) {
            MemberInitializer();
            switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
            case SEMICOLON:
              jj_consume_token(SEMICOLON);
              break;
            case COMMA:
              jj_consume_token(COMMA);
              break;
            default:
              jj_la1[9] = jj_gen;
              jj_consume_token(-1);
              throw new ParseException();
            }
            switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
            case _USAGE:
            case ENDSCRIPT:
            case _EOF:
            case __EOF:
            case AS:
            case DEFINED:
            case DELETE:
            case ELIF:
            case EXEC:
            case EXTENDSJAVA:
            case FUNCTION:
            case LAMBDA:
            case JAVACLASS:
            case IFDEF:
            case IFNDEF:
            case IFEXISTS:
            case IN:
            case INFINITY:
            case INTO:
            case LOCAL:
            case LIMIT:
            case NAMESPACE:
            case _SKIP:
            case RESUME:
            case STRIP:
            case TYPEOF:
            case ATTRIBUTESOF:
            case UNDER:
            case UNDEFINED:
            case USING:
            case USE:
            case VAR:
            case WHERE:
            case WITH:
            case STRING:
            case STRING_:
            case CC:
            case BCC:
            case ATTACH:
            case SUBJECT:
            case BODY:
            case HTMLBODY:
            case LINKEDLIST_:
            case LINKEDLIST:
            case SET_:
            case SET:
            case SORTEDMAP_:
            case SORTEDMAP:
            case DATE_:
            case DATE:
            case NUMBER_:
            case NUMBER:
            case COLUMN:
            case ERR:
            case LOG:
            case OUT:
            case PIPE:
            case INPUT:
            case OUTPUT:
            case NEEDSYSTEMIN:
            case FLUSH:
            case PRINT:
            case PRINTLN:
            case PRINTTABLE:
            case PRINTTABLEDATA:
            case SCP:
            case COPY:
            case MANIFEST:
            case LIST:
            case LS:
            case ORDERED:
            case BY:
            case RMDIR:
            case EXCEPT:
            case SETFILETIME:
            case SETREADONLY:
            case SETREADWRITE:
            case TARGET:
            case EJBQL:
            case AFTER:
            case REPEAT:
            case SCHEDULE:
            case STARTING:
            case XML:
            case XSLT:
            case XPATH:
            case SYSTEMID:
            case OUTPUTPROPERTIES:
            case PARAMETERS:
            case DOM:
            case XMLNS:
            case HTML:
            case JSP:
            case SGML:
            case STRING_LITERAL:
            case IDENTIFIER:
            case CONST_NAME:
            case ATSIGN:
              ;
              break;
            default:
              jj_la1[10] = jj_gen;
              break label_2;
            }
          }
          jj_consume_token(RBRACE);
      if (token_source.isMain()) {
        // Only take the one for the main script. Just one usage is allowed;
        // if multiple ones specified, for now the first one is taken;
        // the following ones are silently ignored.
        AssociateList inits = handleNamedExprs(lastMark);
        int len = inits.size();
        if (len <= 0) {if (true) return;}
        HashMap u = new HashMap();
        u.put("firstLine", new Integer(firstLine));
        try {
          for (int i=0; i<len; ++i) {
            String k = JudoUtil.toParameterNameString(inits.getKeyAt(i));
            String v = ((Expr)inits.getValueAt(i)).getStringValue();
            if ("minArgs".equals(k)) {
              try { u.put(k, new Integer(Integer.parseInt(v))); }
              catch(NumberFormatException nfe) {
                throwParseException("The usage's minArgs value must be an integer: "+v+".");
              }
            } else {
              u.put(k,v);
            }
          }
          u.put("lastLine", new Integer(lineNum()));
          script.setUsage(u);
        } catch(Throwable e) {
          e.printStackTrace();
        }
      }
      if (usageOnly) {if (true) return;}
      lastMark = markStack();
          break;
        case CLASS:
          ClassDefinition();
          break;
        default:
          jj_la1[12] = jj_gen;
          if (jj_2_1(3)) {
            ConstantDefinition();
          } else {
            switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
            case FUNCTION:
              FunctionDecl();
                        addFunction(script, (Function)stack.pop());
              break;
            case THREAD:
              ThreadDecl();
              break;
            case HTML:
            case SGML:
              SgmlHandlerDecl();
              break;
            case ANTTASK__:
            case JAVA__:
            case _EOF:
            case __EOF:
            case AS:
            case BREAK:
            case CONTINUE:
            case DEFINED:
            case DELETE:
            case DO:
            case ELIF:
            case EXEC:
            case EXTENDSJAVA:
            case FALSE:
            case FOR:
            case JAVACLASS:
            case IF:
            case IFDEF:
            case IFNDEF:
            case IFEXISTS:
            case IMPORT:
            case IN:
            case INFINITY:
            case INTO:
            case INCLUDE:
            case LOCAL:
            case NEW:
            case JAVANEW:
            case MAX_NUMBER:
            case MIN_NUMBER:
            case NULL:
            case PRAGMA:
            case JAVAGUICLASS:
            case JAVABASECLASS:
            case JAVAENTERPRISECLASS:
            case JAVACORBACLASS:
            case JCOMCLASS:
            case JAVAPACKAGES:
            case DEFINEJAVAPACKAGES:
            case LIMIT:
            case NAMESPACE:
            case _SKIP:
            case RESUME:
            case RETURN:
            case SUPER:
            case SWITCH:
            case THIS:
            case THROW:
            case TYPEOF:
            case ATTRIBUTESOF:
            case TRUE:
            case TRY:
            case UNDEFINED:
            case USE:
            case VAR:
            case WHILE:
            case WITH:
            case BOOLEAN:
            case BYTE:
            case CHAR:
            case SHORT:
            case INT:
            case LONG:
            case FLOAT:
            case DOUBLE:
            case MAIL__SEND:
            case MAIL__CONNECT:
            case MAIL__DISCONNECT:
            case SENDMAIL:
            case CC:
            case BCC:
            case ATTACH:
            case SUBJECT:
            case BODY:
            case HTMLBODY:
            case DATE_:
            case DATE:
            case NUMBER:
            case COLUMN:
            case ERR:
            case LOG:
            case NL:
            case OUT:
            case PIPE:
            case INPUT:
            case OUTPUT:
            case NEEDSYSTEMIN:
            case FLUSH:
            case PRINT:
            case PRINTLN:
            case PRINTTABLE:
            case PRINTTABLEDATA:
            case SCP:
            case COPY:
            case MANIFEST:
            case LIST:
            case LS:
            case RMDIR:
            case EXCEPT:
            case SETFILETIME:
            case SETREADONLY:
            case SETREADWRITE:
            case TARGET:
            case ADDBATCH:
            case CONNECT:
            case EXECUTEBATCH:
            case EXECUTEQUERY:
            case EXECUTEQUERYCALL:
            case EXECUTEANY:
            case EXECUTESQL:
            case EXECUTEUPDATE:
            case EXECUTEUPDATECALL:
            case PREPARE:
            case PREPARECALL:
            case PREPAREDEXECUTE:
            case PREPAREDEXECUTECALL:
            case PREPAREDEXECUTEQUERY:
            case PREPAREDEXECUTECALLQUERY:
            case PREPAREDEXECUTEUPDATE:
            case PREPAREDEXECUTECALLUPDATE:
            case DB__DUMPTABLE:
            case DB__ADDBATCH:
            case DB__CONNECT:
            case DB__DISCONNECT:
            case DB__BATCH:
            case DB__QUERY:
            case DB__QUERYCALL:
            case DB__ANY:
            case DB__SQL:
            case DB__CALL:
            case DB__UPDATE:
            case DB__UPDATECALL:
            case DB__PREPARE:
            case DB__PREPARECALL:
            case HIB__SETUP:
            case HIB__ADDCLASS:
            case HIB__ADDRESOURCE:
            case HIB__CLOSE:
            case HIB__TXBEGIN:
            case HIB__TXEND:
            case HIB__TXABORT:
            case HIB__LOCK:
            case HIB__QUERY:
            case HIB__ITERATE:
            case HIB__DELETE:
            case HIB__GET:
            case HIB__SAVE:
            case HIB__SAVEORUPDATECOPY:
            case HIB__UNLOCK:
            case HIB__UPDATE:
            case AFTER:
            case REPEAT:
            case SCHEDULE:
            case STARTING:
            case XML:
            case XSLT:
            case SYSTEMID:
            case OUTPUTPROPERTIES:
            case PARAMETERS:
            case XMLNS:
            case GUIEVENTS:
            case GUI__EVENTS:
            case INTEGER_LITERAL:
            case FLOATING_POINT_LITERAL:
            case STRING_LITERAL:
            case EXEC_RESULT_LITERAL:
            case EXEC_RESULTLINES_LITERAL:
            case IDENTIFIER:
            case CONST_NAME:
            case BANG:
            case TILDE:
            case COLONCOLON:
            case INCR:
            case DECR:
            case PLUS:
            case MINUS:
            case BIT_AND:
            case DOLLARLBRACE:
            case LBRACE:
            case LPAREN:
            case DOT:
            case SEMICOLON:
              Statement();
              break;
            case CATCH:
              jj_consume_token(CATCH);
              switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
              case IDENTIFIER:
                jj_consume_token(IDENTIFIER);
                             catchName = token.image;
                break;
              default:
                jj_la1[11] = jj_gen;
                ;
              }
              jj_consume_token(COLON);
                    if (hasCatch)
                      throwParseException("No multiple catch clauses allowed.");
                    if (hasFinally)
                      throwParseException("Finally clause can not appear before catch clause.");
                    hasCatch = true;
                    stack.push("catch");
              break;
            case FINALLY:
              jj_consume_token(FINALLY);
              jj_consume_token(COLON);
                    if (hasFinally)
                      throwParseException("No multiple finally clauses allowed.");
                    hasFinally = true;
                    stack.push("finally");
              break;
            default:
              jj_la1[13] = jj_gen;
              jj_consume_token(-1);
              throw new ParseException();
            }
          }
        }
      }
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case 0:
        jj_consume_token(0);
        break;
      case ENDSCRIPT:
        jj_consume_token(ENDSCRIPT);
        LocalData();
        break;
      default:
        jj_la1[14] = jj_gen;
        jj_consume_token(-1);
        throw new ParseException();
      }
    BlockSimple blk = handleBlock(lastMark, catchName, -1);
    if (blk != BlockSimple.EMPTY) script.setStmts(blk);
    } finally {
  try { cleanup(); } catch(Exception e) {}
  if (!usageOnly) RT.popContext();
    }
  }

/*
 * Declaration syntax follows.
 */
  final public String JavaClassName() throws ParseException {
  StringBuffer sb = null;
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case CONST_NAME:
      jj_consume_token(CONST_NAME);
                                 try { {if (true) return script.resolveConst(token.image).getStringValue();} }
                                 catch(Throwable e) { throwParseException(e.getMessage()); }
      break;
    case _USAGE:
    case ENDSCRIPT:
    case _EOF:
    case __EOF:
    case AS:
    case DEFINED:
    case DELETE:
    case ELIF:
    case EXEC:
    case EXTENDSJAVA:
    case FUNCTION:
    case LAMBDA:
    case JAVACLASS:
    case IFDEF:
    case IFNDEF:
    case IFEXISTS:
    case IN:
    case INFINITY:
    case INTO:
    case LOCAL:
    case LIMIT:
    case NAMESPACE:
    case _SKIP:
    case RESUME:
    case STRIP:
    case TYPEOF:
    case ATTRIBUTESOF:
    case UNDER:
    case UNDEFINED:
    case USING:
    case USE:
    case VAR:
    case WHERE:
    case WITH:
    case STRING:
    case STRING_:
    case CC:
    case BCC:
    case ATTACH:
    case SUBJECT:
    case BODY:
    case HTMLBODY:
    case LINKEDLIST_:
    case LINKEDLIST:
    case SET_:
    case SET:
    case SORTEDMAP_:
    case SORTEDMAP:
    case DATE_:
    case DATE:
    case NUMBER_:
    case NUMBER:
    case COLUMN:
    case ERR:
    case LOG:
    case OUT:
    case PIPE:
    case INPUT:
    case OUTPUT:
    case NEEDSYSTEMIN:
    case FLUSH:
    case PRINT:
    case PRINTLN:
    case PRINTTABLE:
    case PRINTTABLEDATA:
    case SCP:
    case COPY:
    case MANIFEST:
    case LIST:
    case LS:
    case ORDERED:
    case BY:
    case RMDIR:
    case EXCEPT:
    case SETFILETIME:
    case SETREADONLY:
    case SETREADWRITE:
    case TARGET:
    case EJBQL:
    case AFTER:
    case REPEAT:
    case SCHEDULE:
    case STARTING:
    case XML:
    case XSLT:
    case XPATH:
    case SYSTEMID:
    case OUTPUTPROPERTIES:
    case PARAMETERS:
    case DOM:
    case XMLNS:
    case HTML:
    case JSP:
    case SGML:
    case IDENTIFIER:
      JavaAllowedName();
                                 sb = new StringBuffer(token.image);
      label_3:
      while (true) {
        if (jj_2_2(2)) {
          ;
        } else {
          break label_3;
        }
        jj_consume_token(DOT);
        AnyName();
                                 sb.append('.'); sb.append(token.image);
      }
                                 {if (true) return sb.toString();}
      break;
    default:
      jj_la1[15] = jj_gen;
      jj_consume_token(-1);
      throw new ParseException();
    }
    throw new Error("Missing return statement in function");
  }

  final public String JavaTypeName(boolean forVM) throws ParseException {
  String name = null;
    if (jj_2_3(2)) {
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case STRING_:
        jj_consume_token(STRING_);
        break;
      case STRING:
        jj_consume_token(STRING);
        break;
      default:
        jj_la1[16] = jj_gen;
        jj_consume_token(-1);
        throw new ParseException();
      }
                                         name = forVM ? "Ljava/lang/String;" : "java.lang.String";
    } else {
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case _USAGE:
      case ENDSCRIPT:
      case _EOF:
      case __EOF:
      case AS:
      case DEFINED:
      case DELETE:
      case ELIF:
      case EXEC:
      case EXTENDSJAVA:
      case FUNCTION:
      case LAMBDA:
      case JAVACLASS:
      case IFDEF:
      case IFNDEF:
      case IFEXISTS:
      case IN:
      case INFINITY:
      case INTO:
      case LOCAL:
      case LIMIT:
      case NAMESPACE:
      case _SKIP:
      case RESUME:
      case STRIP:
      case TYPEOF:
      case ATTRIBUTESOF:
      case UNDER:
      case UNDEFINED:
      case USING:
      case USE:
      case VAR:
      case WHERE:
      case WITH:
      case STRING:
      case STRING_:
      case CC:
      case BCC:
      case ATTACH:
      case SUBJECT:
      case BODY:
      case HTMLBODY:
      case LINKEDLIST_:
      case LINKEDLIST:
      case SET_:
      case SET:
      case SORTEDMAP_:
      case SORTEDMAP:
      case DATE_:
      case DATE:
      case NUMBER_:
      case NUMBER:
      case COLUMN:
      case ERR:
      case LOG:
      case OUT:
      case PIPE:
      case INPUT:
      case OUTPUT:
      case NEEDSYSTEMIN:
      case FLUSH:
      case PRINT:
      case PRINTLN:
      case PRINTTABLE:
      case PRINTTABLEDATA:
      case SCP:
      case COPY:
      case MANIFEST:
      case LIST:
      case LS:
      case ORDERED:
      case BY:
      case RMDIR:
      case EXCEPT:
      case SETFILETIME:
      case SETREADONLY:
      case SETREADWRITE:
      case TARGET:
      case EJBQL:
      case AFTER:
      case REPEAT:
      case SCHEDULE:
      case STARTING:
      case XML:
      case XSLT:
      case XPATH:
      case SYSTEMID:
      case OUTPUTPROPERTIES:
      case PARAMETERS:
      case DOM:
      case XMLNS:
      case HTML:
      case JSP:
      case SGML:
      case IDENTIFIER:
      case CONST_NAME:
        name = JavaClassName();
                          if (forVM) name = "L"+pc.handleSysClassName(name).replace('.','/')+';';
        break;
      case BOOLEAN:
      case BYTE:
      case CHAR:
      case SHORT:
      case INT:
      case LONG:
      case FLOAT:
      case DOUBLE:
        name = JavaPrimitiveTypeNames(forVM);
        break;
      default:
        jj_la1[17] = jj_gen;
        jj_consume_token(-1);
        throw new ParseException();
      }
    }
    {if (true) return name;}
    throw new Error("Missing return statement in function");
  }

  final public String JavaPrimitiveTypeNames(boolean forVM) throws ParseException {
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case BOOLEAN:
      jj_consume_token(BOOLEAN);
                   if (forVM) {if (true) return "Z";}
      break;
    case BYTE:
      jj_consume_token(BYTE);
                   if (forVM) {if (true) return "B";}
      break;
    case CHAR:
      jj_consume_token(CHAR);
                   if (forVM) {if (true) return "C";}
      break;
    case SHORT:
      jj_consume_token(SHORT);
                   if (forVM) {if (true) return "S";}
      break;
    case INT:
      jj_consume_token(INT);
                   if (forVM) {if (true) return "I";}
      break;
    case LONG:
      jj_consume_token(LONG);
                   if (forVM) {if (true) return "J";}
      break;
    case FLOAT:
      jj_consume_token(FLOAT);
                   if (forVM) {if (true) return "F";}
      break;
    case DOUBLE:
      jj_consume_token(DOUBLE);
                   if (forVM) {if (true) return "D";}
      break;
    default:
      jj_la1[18] = jj_gen;
      jj_consume_token(-1);
      throw new ParseException();
    }
                   {if (true) return token.image;}
    throw new Error("Missing return statement in function");
  }

  final public void ConstantDefinition() throws ParseException {
  String name;
  boolean doSet = true;
    jj_consume_token(CONST);
    jj_consume_token(CONST_NAME);
                           name = token.image;
    jj_consume_token(ASSIGN);
    ReturnableExpression();
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case IF:
    case IFNDEF:
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case IFNDEF:
        jj_consume_token(IFNDEF);
                           doSet = !script.hasConst(name);
        break;
      case IF:
        jj_consume_token(IF);
        Expression();
                           doSet = evalConstToBool(nonAssignExpr(stack.pop()), true);
        break;
      default:
        jj_la1[19] = jj_gen;
        jj_consume_token(-1);
        throw new ParseException();
      }
      break;
    default:
      jj_la1[20] = jj_gen;
      ;
    }
    jj_consume_token(SEMICOLON);
    if (!doSet) {if (true) return;}
    try { script.setConst(name, reduceIt().eval()); }
    catch(ParseException e) { throwParseException("Redefinition of constant '" + name + "'."); }
    catch(Throwable e) { throwParseException(e.getMessage()); }
  }

  final public void ClassDefinition() throws ParseException {
  String className = null;
  String parentTypes = null;
  UserDefined.UserType ot = null;
  Function f;
  Object cptr = null;
  inClassDef = true;
  String cls = null;
  FunctionUser ctor = null;
  int lastMark = markStack();
  int lineNo;
  boolean isCopy = false;
    jj_consume_token(CLASS);
    AnyName();
                                    className = token.image; lineNo = lineNum();
    if (jj_2_6(2)) {
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case EXTENDS:
        jj_consume_token(EXTENDS);
        jj_consume_token(JAVA__);
        break;
      case EXTENDSJAVA:
        jj_consume_token(EXTENDSJAVA);
                                                        upgradeMsg("extends java::");
        break;
      default:
        jj_la1[21] = jj_gen;
        jj_consume_token(-1);
        throw new ParseException();
      }
      JavaxDefinition(className);
    } else {
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case EXTENDS:
      case LBRACE:
        switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
        case EXTENDS:
          jj_consume_token(EXTENDS);
          if (jj_2_4(2)) {
            upgradeToSortedMap();
            cptr = ComparatorDecl();
          } else {
            switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
            case _USAGE:
            case ENDSCRIPT:
            case _EOF:
            case __EOF:
            case AS:
            case BREAK:
            case CASE:
            case CATCH:
            case CONST:
            case CONTINUE:
            case CONSTRUCTOR:
            case CTOR:
            case _DEFAULT:
            case CLASS:
            case DEFINED:
            case DELETE:
            case DO:
            case ELIF:
            case ELSE:
            case EXEC:
            case EXTENDS:
            case EXTENDSJAVA:
            case FALSE:
            case FINALLY:
            case FOR:
            case FROM:
            case FUNCTION:
            case LAMBDA:
            case THREAD:
            case JAVACLASS:
            case IF:
            case IFDEF:
            case IFNDEF:
            case IFEXISTS:
            case IMPORT:
            case IN:
            case INFINITY:
            case INTO:
            case LOCAL:
            case NEW:
            case MAX_NUMBER:
            case MIN_NUMBER:
            case NULL:
            case LIMIT:
            case NAMESPACE:
            case _SKIP:
            case RESUME:
            case RETURN:
            case STRIP:
            case SUPER:
            case SWITCH:
            case THIS:
            case THROW:
            case TO:
            case UPTO:
            case TYPEOF:
            case ATTRIBUTESOF:
            case ON:
            case DOWNTO:
            case TRUE:
            case TRY:
            case UNDER:
            case UNDEFINED:
            case USING:
            case USE:
            case VAR:
            case WHERE:
            case WHILE:
            case WITH:
            case BOOLEAN:
            case BYTE:
            case CHAR:
            case SHORT:
            case INT:
            case LONG:
            case FLOAT:
            case DOUBLE:
            case STRING:
            case STRING_:
            case VOID:
            case CC:
            case BCC:
            case ATTACH:
            case SUBJECT:
            case BODY:
            case HTMLBODY:
            case LINKEDLIST_:
            case LINKEDLIST:
            case SET_:
            case SET:
            case SORTEDMAP_:
            case SORTEDMAP:
            case DATE_:
            case DATE:
            case NUMBER_:
            case NUMBER:
            case COLUMN:
            case ERR:
            case LOG:
            case OUT:
            case PIPE:
            case INPUT:
            case OUTPUT:
            case NEEDSYSTEMIN:
            case FLUSH:
            case PRINT:
            case PRINTLN:
            case PRINTTABLE:
            case PRINTTABLEDATA:
            case SCP:
            case COPY:
            case MANIFEST:
            case LIST:
            case LS:
            case ORDERED:
            case BY:
            case RMDIR:
            case EXCEPT:
            case SETFILETIME:
            case SETREADONLY:
            case SETREADWRITE:
            case TARGET:
            case EJBQL:
            case AFTER:
            case REPEAT:
            case SCHEDULE:
            case STARTING:
            case XML:
            case XSLT:
            case XPATH:
            case SYSTEMID:
            case OUTPUTPROPERTIES:
            case PARAMETERS:
            case DOM:
            case XMLNS:
            case HTML:
            case JSP:
            case SGML:
            case IDENTIFIER:
              AnyName();
                                    parentTypes = token.image;
              break;
            default:
              jj_la1[22] = jj_gen;
              jj_consume_token(-1);
              throw new ParseException();
            }
          }
          break;
        default:
          jj_la1[23] = jj_gen;
          ;
        }
        jj_consume_token(LBRACE);
                                    ot = new UserDefined.Type(className,parentTypes,cptr);
        label_4:
        while (true) {
          switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
          case ANTTASK__:
          case JAVA__:
          case _EOF:
          case __EOF:
          case AS:
          case BREAK:
          case CONTINUE:
          case CONSTRUCTOR:
          case CTOR:
          case DEFINED:
          case DELETE:
          case DO:
          case ELIF:
          case EXEC:
          case EXTENDSJAVA:
          case FALSE:
          case FOR:
          case FUNCTION:
          case JAVACLASS:
          case IF:
          case IFDEF:
          case IFNDEF:
          case IFEXISTS:
          case IMPORT:
          case IN:
          case INFINITY:
          case INTO:
          case INCLUDE:
          case LOCAL:
          case NEW:
          case JAVANEW:
          case MAX_NUMBER:
          case MIN_NUMBER:
          case NULL:
          case PRAGMA:
          case JAVAGUICLASS:
          case JAVABASECLASS:
          case JAVAENTERPRISECLASS:
          case JAVACORBACLASS:
          case JCOMCLASS:
          case JAVAPACKAGES:
          case DEFINEJAVAPACKAGES:
          case LIMIT:
          case NAMESPACE:
          case _SKIP:
          case RESUME:
          case RETURN:
          case SUPER:
          case SWITCH:
          case THIS:
          case THROW:
          case TYPEOF:
          case ATTRIBUTESOF:
          case TRUE:
          case TRY:
          case UNDEFINED:
          case USE:
          case VAR:
          case WHILE:
          case WITH:
          case BOOLEAN:
          case BYTE:
          case CHAR:
          case SHORT:
          case INT:
          case LONG:
          case FLOAT:
          case DOUBLE:
          case MAIL__SEND:
          case MAIL__CONNECT:
          case MAIL__DISCONNECT:
          case SENDMAIL:
          case CC:
          case BCC:
          case ATTACH:
          case SUBJECT:
          case BODY:
          case HTMLBODY:
          case DATE_:
          case DATE:
          case NUMBER:
          case COLUMN:
          case ERR:
          case LOG:
          case NL:
          case OUT:
          case PIPE:
          case INPUT:
          case OUTPUT:
          case NEEDSYSTEMIN:
          case FLUSH:
          case PRINT:
          case PRINTLN:
          case PRINTTABLE:
          case PRINTTABLEDATA:
          case SCP:
          case COPY:
          case MANIFEST:
          case LIST:
          case LS:
          case RMDIR:
          case EXCEPT:
          case SETFILETIME:
          case SETREADONLY:
          case SETREADWRITE:
          case TARGET:
          case ADDBATCH:
          case CONNECT:
          case EXECUTEBATCH:
          case EXECUTEQUERY:
          case EXECUTEQUERYCALL:
          case EXECUTEANY:
          case EXECUTESQL:
          case EXECUTEUPDATE:
          case EXECUTEUPDATECALL:
          case PREPARE:
          case PREPARECALL:
          case PREPAREDEXECUTE:
          case PREPAREDEXECUTECALL:
          case PREPAREDEXECUTEQUERY:
          case PREPAREDEXECUTECALLQUERY:
          case PREPAREDEXECUTEUPDATE:
          case PREPAREDEXECUTECALLUPDATE:
          case DB__DUMPTABLE:
          case DB__ADDBATCH:
          case DB__CONNECT:
          case DB__DISCONNECT:
          case DB__BATCH:
          case DB__QUERY:
          case DB__QUERYCALL:
          case DB__ANY:
          case DB__SQL:
          case DB__CALL:
          case DB__UPDATE:
          case DB__UPDATECALL:
          case DB__PREPARE:
          case DB__PREPARECALL:
          case HIB__SETUP:
          case HIB__ADDCLASS:
          case HIB__ADDRESOURCE:
          case HIB__CLOSE:
          case HIB__TXBEGIN:
          case HIB__TXEND:
          case HIB__TXABORT:
          case HIB__LOCK:
          case HIB__QUERY:
          case HIB__ITERATE:
          case HIB__DELETE:
          case HIB__GET:
          case HIB__SAVE:
          case HIB__SAVEORUPDATECOPY:
          case HIB__UNLOCK:
          case HIB__UPDATE:
          case AFTER:
          case REPEAT:
          case SCHEDULE:
          case STARTING:
          case XML:
          case XSLT:
          case SYSTEMID:
          case OUTPUTPROPERTIES:
          case PARAMETERS:
          case XMLNS:
          case GUIEVENTS:
          case GUI__EVENTS:
          case INTEGER_LITERAL:
          case FLOATING_POINT_LITERAL:
          case STRING_LITERAL:
          case EXEC_RESULT_LITERAL:
          case EXEC_RESULTLINES_LITERAL:
          case IDENTIFIER:
          case CONST_NAME:
          case BANG:
          case TILDE:
          case COLONCOLON:
          case INCR:
          case DECR:
          case PLUS:
          case MINUS:
          case BIT_AND:
          case DOLLARLBRACE:
          case LBRACE:
          case LPAREN:
          case DOT:
          case SEMICOLON:
            ;
            break;
          default:
            jj_la1[24] = jj_gen;
            break label_4;
          }
          switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
          case CONSTRUCTOR:
          case CTOR:
            ctor = ConstructorDecl(false);
                                    if (ot.hasConstructor())
                                      throwParseException("Constructor already defined for class "+className);
                                    ot.setConstructor(ctor);
            break;
          default:
            jj_la1[25] = jj_gen;
            if (jj_2_5(2)) {
              FunctionDecl();
                                    addFunction(ot, (Function)stack.pop());
            } else {
              switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
              case ANTTASK__:
              case JAVA__:
              case _EOF:
              case __EOF:
              case AS:
              case BREAK:
              case CONTINUE:
              case DEFINED:
              case DELETE:
              case DO:
              case ELIF:
              case EXEC:
              case EXTENDSJAVA:
              case FALSE:
              case FOR:
              case JAVACLASS:
              case IF:
              case IFDEF:
              case IFNDEF:
              case IFEXISTS:
              case IMPORT:
              case IN:
              case INFINITY:
              case INTO:
              case INCLUDE:
              case LOCAL:
              case NEW:
              case JAVANEW:
              case MAX_NUMBER:
              case MIN_NUMBER:
              case NULL:
              case PRAGMA:
              case JAVAGUICLASS:
              case JAVABASECLASS:
              case JAVAENTERPRISECLASS:
              case JAVACORBACLASS:
              case JCOMCLASS:
              case JAVAPACKAGES:
              case DEFINEJAVAPACKAGES:
              case LIMIT:
              case NAMESPACE:
              case _SKIP:
              case RESUME:
              case RETURN:
              case SUPER:
              case SWITCH:
              case THIS:
              case THROW:
              case TYPEOF:
              case ATTRIBUTESOF:
              case TRUE:
              case TRY:
              case UNDEFINED:
              case USE:
              case VAR:
              case WHILE:
              case WITH:
              case BOOLEAN:
              case BYTE:
              case CHAR:
              case SHORT:
              case INT:
              case LONG:
              case FLOAT:
              case DOUBLE:
              case MAIL__SEND:
              case MAIL__CONNECT:
              case MAIL__DISCONNECT:
              case SENDMAIL:
              case CC:
              case BCC:
              case ATTACH:
              case SUBJECT:
              case BODY:
              case HTMLBODY:
              case DATE_:
              case DATE:
              case NUMBER:
              case COLUMN:
              case ERR:
              case LOG:
              case NL:
              case OUT:
              case PIPE:
              case INPUT:
              case OUTPUT:
              case NEEDSYSTEMIN:
              case FLUSH:
              case PRINT:
              case PRINTLN:
              case PRINTTABLE:
              case PRINTTABLEDATA:
              case SCP:
              case COPY:
              case MANIFEST:
              case LIST:
              case LS:
              case RMDIR:
              case EXCEPT:
              case SETFILETIME:
              case SETREADONLY:
              case SETREADWRITE:
              case TARGET:
              case ADDBATCH:
              case CONNECT:
              case EXECUTEBATCH:
              case EXECUTEQUERY:
              case EXECUTEQUERYCALL:
              case EXECUTEANY:
              case EXECUTESQL:
              case EXECUTEUPDATE:
              case EXECUTEUPDATECALL:
              case PREPARE:
              case PREPARECALL:
              case PREPAREDEXECUTE:
              case PREPAREDEXECUTECALL:
              case PREPAREDEXECUTEQUERY:
              case PREPAREDEXECUTECALLQUERY:
              case PREPAREDEXECUTEUPDATE:
              case PREPAREDEXECUTECALLUPDATE:
              case DB__DUMPTABLE:
              case DB__ADDBATCH:
              case DB__CONNECT:
              case DB__DISCONNECT:
              case DB__BATCH:
              case DB__QUERY:
              case DB__QUERYCALL:
              case DB__ANY:
              case DB__SQL:
              case DB__CALL:
              case DB__UPDATE:
              case DB__UPDATECALL:
              case DB__PREPARE:
              case DB__PREPARECALL:
              case HIB__SETUP:
              case HIB__ADDCLASS:
              case HIB__ADDRESOURCE:
              case HIB__CLOSE:
              case HIB__TXBEGIN:
              case HIB__TXEND:
              case HIB__TXABORT:
              case HIB__LOCK:
              case HIB__QUERY:
              case HIB__ITERATE:
              case HIB__DELETE:
              case HIB__GET:
              case HIB__SAVE:
              case HIB__SAVEORUPDATECOPY:
              case HIB__UNLOCK:
              case HIB__UPDATE:
              case AFTER:
              case REPEAT:
              case SCHEDULE:
              case STARTING:
              case XML:
              case XSLT:
              case SYSTEMID:
              case OUTPUTPROPERTIES:
              case PARAMETERS:
              case XMLNS:
              case GUIEVENTS:
              case GUI__EVENTS:
              case INTEGER_LITERAL:
              case FLOATING_POINT_LITERAL:
              case STRING_LITERAL:
              case EXEC_RESULT_LITERAL:
              case EXEC_RESULTLINES_LITERAL:
              case IDENTIFIER:
              case CONST_NAME:
              case BANG:
              case TILDE:
              case COLONCOLON:
              case INCR:
              case DECR:
              case PLUS:
              case MINUS:
              case BIT_AND:
              case DOLLARLBRACE:
              case LBRACE:
              case LPAREN:
              case DOT:
              case SEMICOLON:
                Statement();
                break;
              default:
                jj_la1[26] = jj_gen;
                jj_consume_token(-1);
                throw new ParseException();
              }
            }
          }
        }
        jj_consume_token(RBRACE);
           addClassToScript(ot); inClassDef = false;
           handleStmts(lastMark);
           if (ctor != null)
             ctor.prependStmts(stmts);
           else { // create a default constructor.
             ctor = new FunctionUser(lineNo,lineNum(),"ctor",true,null,null, new BlockSimple(stmts,null));
             ot.setConstructor(ctor);
           }
        break;
      default:
        jj_la1[27] = jj_gen;
        jj_consume_token(-1);
        throw new ParseException();
      }
    }
  }

// Returns the className.
  final public String JavaxDefinition(String className) throws ParseException {
  JavaExtensionHelper javax = new JavaExtensionHelper(className);
  inClassDef = true;
  String cls;
  FunctionUser ctor = null;
  int lineStart = 0;
  inJavax = true;
    cls = JavaClassName();
                                           javax.addParent(pc.handleSysClassName(cls));
    label_5:
    while (true) {
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case COMMA:
        ;
        break;
      default:
        jj_la1[28] = jj_gen;
        break label_5;
      }
      jj_consume_token(COMMA);
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case JAVA__:
        jj_consume_token(JAVA__);
        break;
      default:
        jj_la1[29] = jj_gen;
        ;
      }
      cls = JavaClassName();
                                           javax.addParent(pc.handleSysClassName(cls));
    }
    jj_consume_token(LBRACE);
    label_6:
    while (true) {
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case _USAGE:
      case ENDSCRIPT:
      case _EOF:
      case __EOF:
      case AS:
      case CONSTRUCTOR:
      case CTOR:
      case DEFINED:
      case DELETE:
      case ELIF:
      case EXEC:
      case EXTENDSJAVA:
      case FUNCTION:
      case LAMBDA:
      case JAVACLASS:
      case IFDEF:
      case IFNDEF:
      case IFEXISTS:
      case IN:
      case INFINITY:
      case INTO:
      case LOCAL:
      case LIMIT:
      case NAMESPACE:
      case _SKIP:
      case RESUME:
      case STRIP:
      case TYPEOF:
      case ATTRIBUTESOF:
      case UNDER:
      case UNDEFINED:
      case USING:
      case USE:
      case VAR:
      case WHERE:
      case WITH:
      case BOOLEAN:
      case BYTE:
      case CHAR:
      case SHORT:
      case INT:
      case LONG:
      case FLOAT:
      case DOUBLE:
      case STRING:
      case STRING_:
      case VOID:
      case CC:
      case BCC:
      case ATTACH:
      case SUBJECT:
      case BODY:
      case HTMLBODY:
      case LINKEDLIST_:
      case LINKEDLIST:
      case SET_:
      case SET:
      case SORTEDMAP_:
      case SORTEDMAP:
      case DATE_:
      case DATE:
      case NUMBER_:
      case NUMBER:
      case COLUMN:
      case ERR:
      case LOG:
      case OUT:
      case PIPE:
      case INPUT:
      case OUTPUT:
      case NEEDSYSTEMIN:
      case FLUSH:
      case PRINT:
      case PRINTLN:
      case PRINTTABLE:
      case PRINTTABLEDATA:
      case SCP:
      case COPY:
      case MANIFEST:
      case LIST:
      case LS:
      case ORDERED:
      case BY:
      case RMDIR:
      case EXCEPT:
      case SETFILETIME:
      case SETREADONLY:
      case SETREADWRITE:
      case TARGET:
      case EJBQL:
      case AFTER:
      case REPEAT:
      case SCHEDULE:
      case STARTING:
      case XML:
      case XSLT:
      case XPATH:
      case SYSTEMID:
      case OUTPUTPROPERTIES:
      case PARAMETERS:
      case DOM:
      case XMLNS:
      case HTML:
      case JSP:
      case SGML:
      case IDENTIFIER:
      case CONST_NAME:
        ;
        break;
      default:
        jj_la1[30] = jj_gen;
        break label_6;
      }
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case CONSTRUCTOR:
      case CTOR:
        ctor = ConstructorDecl(true);
                                 if (javax.hasConstructor())
                                   throwParseException("Constructor already defined for class "+className);
                                 javax.setConstructor(ctor);
        break;
      default:
        jj_la1[31] = jj_gen;
        if (jj_2_7(2147483647)) {
          VMType();
          AnyName();
                                 javax.addField(token.image,(String)stack.pop());
          jj_consume_token(SEMICOLON);
        } else {
          switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
          case _USAGE:
          case ENDSCRIPT:
          case _EOF:
          case __EOF:
          case AS:
          case DEFINED:
          case DELETE:
          case ELIF:
          case EXEC:
          case EXTENDSJAVA:
          case FUNCTION:
          case LAMBDA:
          case JAVACLASS:
          case IFDEF:
          case IFNDEF:
          case IFEXISTS:
          case IN:
          case INFINITY:
          case INTO:
          case LOCAL:
          case LIMIT:
          case NAMESPACE:
          case _SKIP:
          case RESUME:
          case STRIP:
          case TYPEOF:
          case ATTRIBUTESOF:
          case UNDER:
          case UNDEFINED:
          case USING:
          case USE:
          case VAR:
          case WHERE:
          case WITH:
          case BOOLEAN:
          case BYTE:
          case CHAR:
          case SHORT:
          case INT:
          case LONG:
          case FLOAT:
          case DOUBLE:
          case STRING:
          case STRING_:
          case VOID:
          case CC:
          case BCC:
          case ATTACH:
          case SUBJECT:
          case BODY:
          case HTMLBODY:
          case LINKEDLIST_:
          case LINKEDLIST:
          case SET_:
          case SET:
          case SORTEDMAP_:
          case SORTEDMAP:
          case DATE_:
          case DATE:
          case NUMBER_:
          case NUMBER:
          case COLUMN:
          case ERR:
          case LOG:
          case OUT:
          case PIPE:
          case INPUT:
          case OUTPUT:
          case NEEDSYSTEMIN:
          case FLUSH:
          case PRINT:
          case PRINTLN:
          case PRINTTABLE:
          case PRINTTABLEDATA:
          case SCP:
          case COPY:
          case MANIFEST:
          case LIST:
          case LS:
          case ORDERED:
          case BY:
          case RMDIR:
          case EXCEPT:
          case SETFILETIME:
          case SETREADONLY:
          case SETREADWRITE:
          case TARGET:
          case EJBQL:
          case AFTER:
          case REPEAT:
          case SCHEDULE:
          case STARTING:
          case XML:
          case XSLT:
          case XPATH:
          case SYSTEMID:
          case OUTPUTPROPERTIES:
          case PARAMETERS:
          case DOM:
          case XMLNS:
          case HTML:
          case JSP:
          case SGML:
          case IDENTIFIER:
          case CONST_NAME:
            VMType();
            AnyName();
                                 stack.push(token.image); lineStart = lineNum();
            JavaMethodDecl();
            Block();
                                 javax.defineMethod(stack, lineStart, lineNum()); /*4*/
            break;
          default:
            jj_la1[32] = jj_gen;
            jj_consume_token(-1);
            throw new ParseException();
          }
        }
      }
    }
    jj_consume_token(RBRACE);
    try { addClassToScript(javax.getUserType(superCalls,javaxCalls)); }
    catch(Exception e) { throwParseException(e.getMessage()); }
    finally { superCalls.clear(); javaxCalls.clear(); inJavax = false; }
    {if (true) return className;}
    throw new Error("Missing return statement in function");
  }

  final public void VMType() throws ParseException {
  String ret = null;
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case _USAGE:
    case ENDSCRIPT:
    case _EOF:
    case __EOF:
    case AS:
    case DEFINED:
    case DELETE:
    case ELIF:
    case EXEC:
    case EXTENDSJAVA:
    case FUNCTION:
    case LAMBDA:
    case JAVACLASS:
    case IFDEF:
    case IFNDEF:
    case IFEXISTS:
    case IN:
    case INFINITY:
    case INTO:
    case LOCAL:
    case LIMIT:
    case NAMESPACE:
    case _SKIP:
    case RESUME:
    case STRIP:
    case TYPEOF:
    case ATTRIBUTESOF:
    case UNDER:
    case UNDEFINED:
    case USING:
    case USE:
    case VAR:
    case WHERE:
    case WITH:
    case BOOLEAN:
    case BYTE:
    case CHAR:
    case SHORT:
    case INT:
    case LONG:
    case FLOAT:
    case DOUBLE:
    case STRING:
    case STRING_:
    case CC:
    case BCC:
    case ATTACH:
    case SUBJECT:
    case BODY:
    case HTMLBODY:
    case LINKEDLIST_:
    case LINKEDLIST:
    case SET_:
    case SET:
    case SORTEDMAP_:
    case SORTEDMAP:
    case DATE_:
    case DATE:
    case NUMBER_:
    case NUMBER:
    case COLUMN:
    case ERR:
    case LOG:
    case OUT:
    case PIPE:
    case INPUT:
    case OUTPUT:
    case NEEDSYSTEMIN:
    case FLUSH:
    case PRINT:
    case PRINTLN:
    case PRINTTABLE:
    case PRINTTABLEDATA:
    case SCP:
    case COPY:
    case MANIFEST:
    case LIST:
    case LS:
    case ORDERED:
    case BY:
    case RMDIR:
    case EXCEPT:
    case SETFILETIME:
    case SETREADONLY:
    case SETREADWRITE:
    case TARGET:
    case EJBQL:
    case AFTER:
    case REPEAT:
    case SCHEDULE:
    case STARTING:
    case XML:
    case XSLT:
    case XPATH:
    case SYSTEMID:
    case OUTPUTPROPERTIES:
    case PARAMETERS:
    case DOM:
    case XMLNS:
    case HTML:
    case JSP:
    case SGML:
    case IDENTIFIER:
    case CONST_NAME:
      ret = JavaTypeName(true);
      label_7:
      while (true) {
        switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
        case LBRACKET:
          ;
          break;
        default:
          jj_la1[33] = jj_gen;
          break label_7;
        }
        jj_consume_token(LBRACKET);
        jj_consume_token(RBRACKET);
                                     ret="["+ret;
      }
                                                          stack.push(ret);
      break;
    case VOID:
      jj_consume_token(VOID);
                                                          stack.push("V");
      break;
    default:
      jj_la1[34] = jj_gen;
      jj_consume_token(-1);
      throw new ParseException();
    }
  }

  final public void JavaMethodDecl() throws ParseException {
  ArrayList v = new ArrayList();
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case LPAREN:
      jj_consume_token(LPAREN);
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case _USAGE:
      case ENDSCRIPT:
      case _EOF:
      case __EOF:
      case AS:
      case DEFINED:
      case DELETE:
      case ELIF:
      case EXEC:
      case EXTENDSJAVA:
      case FUNCTION:
      case LAMBDA:
      case JAVACLASS:
      case IFDEF:
      case IFNDEF:
      case IFEXISTS:
      case IN:
      case INFINITY:
      case INTO:
      case LOCAL:
      case LIMIT:
      case NAMESPACE:
      case _SKIP:
      case RESUME:
      case STRIP:
      case TYPEOF:
      case ATTRIBUTESOF:
      case UNDER:
      case UNDEFINED:
      case USING:
      case USE:
      case VAR:
      case WHERE:
      case WITH:
      case BOOLEAN:
      case BYTE:
      case CHAR:
      case SHORT:
      case INT:
      case LONG:
      case FLOAT:
      case DOUBLE:
      case STRING:
      case STRING_:
      case VOID:
      case CC:
      case BCC:
      case ATTACH:
      case SUBJECT:
      case BODY:
      case HTMLBODY:
      case LINKEDLIST_:
      case LINKEDLIST:
      case SET_:
      case SET:
      case SORTEDMAP_:
      case SORTEDMAP:
      case DATE_:
      case DATE:
      case NUMBER_:
      case NUMBER:
      case COLUMN:
      case ERR:
      case LOG:
      case OUT:
      case PIPE:
      case INPUT:
      case OUTPUT:
      case NEEDSYSTEMIN:
      case FLUSH:
      case PRINT:
      case PRINTLN:
      case PRINTTABLE:
      case PRINTTABLEDATA:
      case SCP:
      case COPY:
      case MANIFEST:
      case LIST:
      case LS:
      case ORDERED:
      case BY:
      case RMDIR:
      case EXCEPT:
      case SETFILETIME:
      case SETREADONLY:
      case SETREADWRITE:
      case TARGET:
      case EJBQL:
      case AFTER:
      case REPEAT:
      case SCHEDULE:
      case STARTING:
      case XML:
      case XSLT:
      case XPATH:
      case SYSTEMID:
      case OUTPUTPROPERTIES:
      case PARAMETERS:
      case DOM:
      case XMLNS:
      case HTML:
      case JSP:
      case SGML:
      case IDENTIFIER:
      case CONST_NAME:
        VMType();
                        v.add(stack.pop());
        AnyName();
                        v.add(token.image);
        label_8:
        while (true) {
          switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
          case COMMA:
            ;
            break;
          default:
            jj_la1[35] = jj_gen;
            break label_8;
          }
          jj_consume_token(COMMA);
          VMType();
                        v.add(stack.pop());
          AnyName();
                        v.add(token.image);
        }
        break;
      default:
        jj_la1[36] = jj_gen;
        ;
      }
      jj_consume_token(RPAREN);
      break;
    default:
      jj_la1[37] = jj_gen;
      ;
    }
                        stack.push(v);
  }

  final public FunctionUser ConstructorDecl(boolean isJava) throws ParseException {
  Expr[] defvals = null;
  int lastMark = markStack();
  String[] params = null;
  inFxnThrd = true;
  inJavaCtor = isJava;
  int begin;
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case CONSTRUCTOR:
      jj_consume_token(CONSTRUCTOR);
      break;
    case CTOR:
      jj_consume_token(CTOR);
      break;
    default:
      jj_la1[38] = jj_gen;
      jj_consume_token(-1);
      throw new ParseException();
    }
                               begin = lineNum();
    defvals = FormalParameters();
                               params = handleStrings(lastMark);
    Block();
                               inFxnThrd = false;
                               inJavaCtor = false;
                               {if (true) return new FunctionUser(begin,lineNum(),"ctor",true,params,
                                                       defvals,(BlockSimple)stack.pop());}
    throw new Error("Missing return statement in function");
  }

  final public void FunctionDecl() throws ParseException {
  String name = null;
  String fxnName;
  String[] params;
  HashMap annotations = null; // (String => Variable)*
  Expr[] defvals;
  int begin;
  int lastMark = markStack();
  inFxnThrd = true;
  boolean useJavaClass = false;
  String clsName = null;
  String methodName = null;
  ++fxnDeclStack;
    jj_consume_token(FUNCTION);
                   begin = lineNum();
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case LT:
      jj_consume_token(LT);
          annotations = new HashMap();
      Annotation(annotations);
      label_9:
      while (true) {
        switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
        case COMMA:
          ;
          break;
        default:
          jj_la1[39] = jj_gen;
          break label_9;
        }
        jj_consume_token(COMMA);
        Annotation(annotations);
      }
      jj_consume_token(GT);
      break;
    default:
      jj_la1[40] = jj_gen;
      ;
    }
    LabelName();
                   fxnName = token.image;
                   if (fxnDeclStack > 1) { name = fxnName; fxnName = genTempVarName("_inner_fxn_"); }
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case IDENTIFIER:
    case LBRACE:
    case LPAREN:
    case RPAREN:
    case DOTDOT:
      defvals = FormalParameters();
                                 params = handleStrings(lastMark);
      Block();
                   stack.push(new FunctionUser(begin, lineNum(), fxnName, inClassDef, params,
                                               defvals, (BlockSimple)stack.pop(), annotations));
                   inFxnThrd = false;
      break;
    case FOR:
      jj_consume_token(FOR);
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case JAVA__:
        jj_consume_token(JAVA__);
        break;
      default:
        jj_la1[41] = jj_gen;
        ;
      }
      clsName = JavaClassName();
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case COLONCOLON:
        jj_consume_token(COLONCOLON);
        AnyName();
                                                            methodName = token.image;
        break;
      default:
        jj_la1[42] = jj_gen;
        ;
      }
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case LPAREN:
        jj_consume_token(LPAREN);
        jj_consume_token(RPAREN);
        break;
      default:
        jj_la1[43] = jj_gen;
        ;
      }
      jj_consume_token(SEMICOLON);
      if (inClassDef)
        throwParseException("Function alias not allowed for user-defined class methods.");

      if (methodName == null) {
        int idx = clsName.lastIndexOf('.');
        if (idx <= 0)
          throwParseException("No Java method is specified for function alias.");
        methodName = clsName.substring(idx+1);
//        clsName = script.handleClassName(clsName.substring(0, idx));
        clsName = clsName.substring(0, idx);
      }

      stack.push(new FunctionStaticJava(begin, fxnName, clsName, false, methodName, annotations));
      break;
    default:
      jj_la1[44] = jj_gen;
      jj_consume_token(-1);
      throw new ParseException();
    }
    if (fxnDeclStack > 1) {
      addFunction(script, (Function)stack.pop());
      stack.push( ExprAssign.createLocalVar(begin, name, new AccessFunction(fxnName)) );
    }
    --fxnDeclStack;
  }

  final public void Annotation(HashMap map) throws ParseException {
  String name, x;
  Object val;
    name = JavaClassName();
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case ASSIGN:
      jj_consume_token(ASSIGN);
      break;
    case COLON:
      jj_consume_token(COLON);
      break;
    default:
      jj_la1[45] = jj_gen;
      jj_consume_token(-1);
      throw new ParseException();
    }
    if (jj_2_8(2)) {
      Literal();
                             val = stack.pop();
    } else {
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case _USAGE:
      case ENDSCRIPT:
      case _EOF:
      case __EOF:
      case AS:
      case DEFINED:
      case DELETE:
      case ELIF:
      case EXEC:
      case EXTENDSJAVA:
      case FUNCTION:
      case LAMBDA:
      case JAVACLASS:
      case IFDEF:
      case IFNDEF:
      case IFEXISTS:
      case IN:
      case INFINITY:
      case INTO:
      case LOCAL:
      case LIMIT:
      case NAMESPACE:
      case _SKIP:
      case RESUME:
      case STRIP:
      case TYPEOF:
      case ATTRIBUTESOF:
      case UNDER:
      case UNDEFINED:
      case USING:
      case USE:
      case VAR:
      case WHERE:
      case WITH:
      case STRING:
      case STRING_:
      case CC:
      case BCC:
      case ATTACH:
      case SUBJECT:
      case BODY:
      case HTMLBODY:
      case LINKEDLIST_:
      case LINKEDLIST:
      case SET_:
      case SET:
      case SORTEDMAP_:
      case SORTEDMAP:
      case DATE_:
      case DATE:
      case NUMBER_:
      case NUMBER:
      case COLUMN:
      case ERR:
      case LOG:
      case OUT:
      case PIPE:
      case INPUT:
      case OUTPUT:
      case NEEDSYSTEMIN:
      case FLUSH:
      case PRINT:
      case PRINTLN:
      case PRINTTABLE:
      case PRINTTABLEDATA:
      case SCP:
      case COPY:
      case MANIFEST:
      case LIST:
      case LS:
      case ORDERED:
      case BY:
      case RMDIR:
      case EXCEPT:
      case SETFILETIME:
      case SETREADONLY:
      case SETREADWRITE:
      case TARGET:
      case EJBQL:
      case AFTER:
      case REPEAT:
      case SCHEDULE:
      case STARTING:
      case XML:
      case XSLT:
      case XPATH:
      case SYSTEMID:
      case OUTPUTPROPERTIES:
      case PARAMETERS:
      case DOM:
      case XMLNS:
      case HTML:
      case JSP:
      case SGML:
      case IDENTIFIER:
      case CONST_NAME:
        x = JavaClassName();
                             val = JudoUtil.toVariable(x);
        break;
      default:
        jj_la1[46] = jj_gen;
        jj_consume_token(-1);
        throw new ParseException();
      }
    }
                             map.put(name, val);
  }

  final public void AnonFunctionDecl() throws ParseException {
  String[] params = null;
  Expr[] defvals = null;
  int begin;
  int lastMark = markStack();
  inFxnThrd = true;
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case FUNCTION:
      jj_consume_token(FUNCTION);
      break;
    case LAMBDA:
      jj_consume_token(LAMBDA);
                            upgradeMsg("function");
      break;
    default:
      jj_la1[47] = jj_gen;
      jj_consume_token(-1);
      throw new ParseException();
    }
                                                          begin = token.beginLine;
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case LPAREN:
      defvals = FormalParameters1();
                                  params = handleStrings(lastMark);
      break;
    default:
      jj_la1[48] = jj_gen;
      ;
    }
    Block();
    String name = LAMBDA_PREFIX + Lib.createID();
    addFunction(script,
      new FunctionUser(begin,lineNum(),name,inClassDef,params,defvals,(BlockSimple)stack.pop()));
    stack.push(new AccessFunction(name));
    inFxnThrd = false;
  }

  final public void AnonFunctionDecl1() throws ParseException {
  String[] params = null;
  int begin;
  String s = null;
  inFxnThrd = true;
  int lastMark = markStack();
    jj_consume_token(LBRACE);
                              begin = token.beginLine;
    FormalParametersNoInit();
                              params = handleStrings(lastMark);
    jj_consume_token(BIT_OR);
                              lastMark = markStack();
    label_10:
    while (true) {
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case ANTTASK__:
      case JAVA__:
      case _EOF:
      case __EOF:
      case AS:
      case BREAK:
      case CONTINUE:
      case DEFINED:
      case DELETE:
      case DO:
      case ELIF:
      case EXEC:
      case EXTENDSJAVA:
      case FALSE:
      case FOR:
      case JAVACLASS:
      case IF:
      case IFDEF:
      case IFNDEF:
      case IFEXISTS:
      case IMPORT:
      case IN:
      case INFINITY:
      case INTO:
      case INCLUDE:
      case LOCAL:
      case NEW:
      case JAVANEW:
      case MAX_NUMBER:
      case MIN_NUMBER:
      case NULL:
      case PRAGMA:
      case JAVAGUICLASS:
      case JAVABASECLASS:
      case JAVAENTERPRISECLASS:
      case JAVACORBACLASS:
      case JCOMCLASS:
      case JAVAPACKAGES:
      case DEFINEJAVAPACKAGES:
      case LIMIT:
      case NAMESPACE:
      case _SKIP:
      case RESUME:
      case RETURN:
      case SUPER:
      case SWITCH:
      case THIS:
      case THROW:
      case TYPEOF:
      case ATTRIBUTESOF:
      case TRUE:
      case TRY:
      case UNDEFINED:
      case USE:
      case VAR:
      case WHILE:
      case WITH:
      case BOOLEAN:
      case BYTE:
      case CHAR:
      case SHORT:
      case INT:
      case LONG:
      case FLOAT:
      case DOUBLE:
      case MAIL__SEND:
      case MAIL__CONNECT:
      case MAIL__DISCONNECT:
      case SENDMAIL:
      case CC:
      case BCC:
      case ATTACH:
      case SUBJECT:
      case BODY:
      case HTMLBODY:
      case DATE_:
      case DATE:
      case NUMBER:
      case COLUMN:
      case ERR:
      case LOG:
      case NL:
      case OUT:
      case PIPE:
      case INPUT:
      case OUTPUT:
      case NEEDSYSTEMIN:
      case FLUSH:
      case PRINT:
      case PRINTLN:
      case PRINTTABLE:
      case PRINTTABLEDATA:
      case SCP:
      case COPY:
      case MANIFEST:
      case LIST:
      case LS:
      case RMDIR:
      case EXCEPT:
      case SETFILETIME:
      case SETREADONLY:
      case SETREADWRITE:
      case TARGET:
      case ADDBATCH:
      case CONNECT:
      case EXECUTEBATCH:
      case EXECUTEQUERY:
      case EXECUTEQUERYCALL:
      case EXECUTEANY:
      case EXECUTESQL:
      case EXECUTEUPDATE:
      case EXECUTEUPDATECALL:
      case PREPARE:
      case PREPARECALL:
      case PREPAREDEXECUTE:
      case PREPAREDEXECUTECALL:
      case PREPAREDEXECUTEQUERY:
      case PREPAREDEXECUTECALLQUERY:
      case PREPAREDEXECUTEUPDATE:
      case PREPAREDEXECUTECALLUPDATE:
      case DB__DUMPTABLE:
      case DB__ADDBATCH:
      case DB__CONNECT:
      case DB__DISCONNECT:
      case DB__BATCH:
      case DB__QUERY:
      case DB__QUERYCALL:
      case DB__ANY:
      case DB__SQL:
      case DB__CALL:
      case DB__UPDATE:
      case DB__UPDATECALL:
      case DB__PREPARE:
      case DB__PREPARECALL:
      case HIB__SETUP:
      case HIB__ADDCLASS:
      case HIB__ADDRESOURCE:
      case HIB__CLOSE:
      case HIB__TXBEGIN:
      case HIB__TXEND:
      case HIB__TXABORT:
      case HIB__LOCK:
      case HIB__QUERY:
      case HIB__ITERATE:
      case HIB__DELETE:
      case HIB__GET:
      case HIB__SAVE:
      case HIB__SAVEORUPDATECOPY:
      case HIB__UNLOCK:
      case HIB__UPDATE:
      case AFTER:
      case REPEAT:
      case SCHEDULE:
      case STARTING:
      case XML:
      case XSLT:
      case SYSTEMID:
      case OUTPUTPROPERTIES:
      case PARAMETERS:
      case XMLNS:
      case GUIEVENTS:
      case GUI__EVENTS:
      case INTEGER_LITERAL:
      case FLOATING_POINT_LITERAL:
      case STRING_LITERAL:
      case EXEC_RESULT_LITERAL:
      case EXEC_RESULTLINES_LITERAL:
      case IDENTIFIER:
      case CONST_NAME:
      case BANG:
      case TILDE:
      case COLONCOLON:
      case INCR:
      case DECR:
      case PLUS:
      case MINUS:
      case BIT_AND:
      case DOLLARLBRACE:
      case LBRACE:
      case LPAREN:
      case DOT:
      case SEMICOLON:
        ;
        break;
      default:
        jj_la1[49] = jj_gen;
        break label_10;
      }
      Statement();
    }
    if (jj_2_9(2)) {
      jj_consume_token(CATCH);
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case IDENTIFIER:
        jj_consume_token(IDENTIFIER);
                                          s=token.image;
        break;
      default:
        jj_la1[50] = jj_gen;
        ;
      }
      jj_consume_token(COLON);
                                                                   stack.push("catch");
      label_11:
      while (true) {
        Statement();
        switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
        case ANTTASK__:
        case JAVA__:
        case _EOF:
        case __EOF:
        case AS:
        case BREAK:
        case CONTINUE:
        case DEFINED:
        case DELETE:
        case DO:
        case ELIF:
        case EXEC:
        case EXTENDSJAVA:
        case FALSE:
        case FOR:
        case JAVACLASS:
        case IF:
        case IFDEF:
        case IFNDEF:
        case IFEXISTS:
        case IMPORT:
        case IN:
        case INFINITY:
        case INTO:
        case INCLUDE:
        case LOCAL:
        case NEW:
        case JAVANEW:
        case MAX_NUMBER:
        case MIN_NUMBER:
        case NULL:
        case PRAGMA:
        case JAVAGUICLASS:
        case JAVABASECLASS:
        case JAVAENTERPRISECLASS:
        case JAVACORBACLASS:
        case JCOMCLASS:
        case JAVAPACKAGES:
        case DEFINEJAVAPACKAGES:
        case LIMIT:
        case NAMESPACE:
        case _SKIP:
        case RESUME:
        case RETURN:
        case SUPER:
        case SWITCH:
        case THIS:
        case THROW:
        case TYPEOF:
        case ATTRIBUTESOF:
        case TRUE:
        case TRY:
        case UNDEFINED:
        case USE:
        case VAR:
        case WHILE:
        case WITH:
        case BOOLEAN:
        case BYTE:
        case CHAR:
        case SHORT:
        case INT:
        case LONG:
        case FLOAT:
        case DOUBLE:
        case MAIL__SEND:
        case MAIL__CONNECT:
        case MAIL__DISCONNECT:
        case SENDMAIL:
        case CC:
        case BCC:
        case ATTACH:
        case SUBJECT:
        case BODY:
        case HTMLBODY:
        case DATE_:
        case DATE:
        case NUMBER:
        case COLUMN:
        case ERR:
        case LOG:
        case NL:
        case OUT:
        case PIPE:
        case INPUT:
        case OUTPUT:
        case NEEDSYSTEMIN:
        case FLUSH:
        case PRINT:
        case PRINTLN:
        case PRINTTABLE:
        case PRINTTABLEDATA:
        case SCP:
        case COPY:
        case MANIFEST:
        case LIST:
        case LS:
        case RMDIR:
        case EXCEPT:
        case SETFILETIME:
        case SETREADONLY:
        case SETREADWRITE:
        case TARGET:
        case ADDBATCH:
        case CONNECT:
        case EXECUTEBATCH:
        case EXECUTEQUERY:
        case EXECUTEQUERYCALL:
        case EXECUTEANY:
        case EXECUTESQL:
        case EXECUTEUPDATE:
        case EXECUTEUPDATECALL:
        case PREPARE:
        case PREPARECALL:
        case PREPAREDEXECUTE:
        case PREPAREDEXECUTECALL:
        case PREPAREDEXECUTEQUERY:
        case PREPAREDEXECUTECALLQUERY:
        case PREPAREDEXECUTEUPDATE:
        case PREPAREDEXECUTECALLUPDATE:
        case DB__DUMPTABLE:
        case DB__ADDBATCH:
        case DB__CONNECT:
        case DB__DISCONNECT:
        case DB__BATCH:
        case DB__QUERY:
        case DB__QUERYCALL:
        case DB__ANY:
        case DB__SQL:
        case DB__CALL:
        case DB__UPDATE:
        case DB__UPDATECALL:
        case DB__PREPARE:
        case DB__PREPARECALL:
        case HIB__SETUP:
        case HIB__ADDCLASS:
        case HIB__ADDRESOURCE:
        case HIB__CLOSE:
        case HIB__TXBEGIN:
        case HIB__TXEND:
        case HIB__TXABORT:
        case HIB__LOCK:
        case HIB__QUERY:
        case HIB__ITERATE:
        case HIB__DELETE:
        case HIB__GET:
        case HIB__SAVE:
        case HIB__SAVEORUPDATECOPY:
        case HIB__UNLOCK:
        case HIB__UPDATE:
        case AFTER:
        case REPEAT:
        case SCHEDULE:
        case STARTING:
        case XML:
        case XSLT:
        case SYSTEMID:
        case OUTPUTPROPERTIES:
        case PARAMETERS:
        case XMLNS:
        case GUIEVENTS:
        case GUI__EVENTS:
        case INTEGER_LITERAL:
        case FLOATING_POINT_LITERAL:
        case STRING_LITERAL:
        case EXEC_RESULT_LITERAL:
        case EXEC_RESULTLINES_LITERAL:
        case IDENTIFIER:
        case CONST_NAME:
        case BANG:
        case TILDE:
        case COLONCOLON:
        case INCR:
        case DECR:
        case PLUS:
        case MINUS:
        case BIT_AND:
        case DOLLARLBRACE:
        case LBRACE:
        case LPAREN:
        case DOT:
        case SEMICOLON:
          ;
          break;
        default:
          jj_la1[51] = jj_gen;
          break label_11;
        }
      }
    } else {
      ;
    }
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case FINALLY:
      jj_consume_token(FINALLY);
      jj_consume_token(COLON);
                    stack.push("finally");
      label_12:
      while (true) {
        Statement();
        switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
        case ANTTASK__:
        case JAVA__:
        case _EOF:
        case __EOF:
        case AS:
        case BREAK:
        case CONTINUE:
        case DEFINED:
        case DELETE:
        case DO:
        case ELIF:
        case EXEC:
        case EXTENDSJAVA:
        case FALSE:
        case FOR:
        case JAVACLASS:
        case IF:
        case IFDEF:
        case IFNDEF:
        case IFEXISTS:
        case IMPORT:
        case IN:
        case INFINITY:
        case INTO:
        case INCLUDE:
        case LOCAL:
        case NEW:
        case JAVANEW:
        case MAX_NUMBER:
        case MIN_NUMBER:
        case NULL:
        case PRAGMA:
        case JAVAGUICLASS:
        case JAVABASECLASS:
        case JAVAENTERPRISECLASS:
        case JAVACORBACLASS:
        case JCOMCLASS:
        case JAVAPACKAGES:
        case DEFINEJAVAPACKAGES:
        case LIMIT:
        case NAMESPACE:
        case _SKIP:
        case RESUME:
        case RETURN:
        case SUPER:
        case SWITCH:
        case THIS:
        case THROW:
        case TYPEOF:
        case ATTRIBUTESOF:
        case TRUE:
        case TRY:
        case UNDEFINED:
        case USE:
        case VAR:
        case WHILE:
        case WITH:
        case BOOLEAN:
        case BYTE:
        case CHAR:
        case SHORT:
        case INT:
        case LONG:
        case FLOAT:
        case DOUBLE:
        case MAIL__SEND:
        case MAIL__CONNECT:
        case MAIL__DISCONNECT:
        case SENDMAIL:
        case CC:
        case BCC:
        case ATTACH:
        case SUBJECT:
        case BODY:
        case HTMLBODY:
        case DATE_:
        case DATE:
        case NUMBER:
        case COLUMN:
        case ERR:
        case LOG:
        case NL:
        case OUT:
        case PIPE:
        case INPUT:
        case OUTPUT:
        case NEEDSYSTEMIN:
        case FLUSH:
        case PRINT:
        case PRINTLN:
        case PRINTTABLE:
        case PRINTTABLEDATA:
        case SCP:
        case COPY:
        case MANIFEST:
        case LIST:
        case LS:
        case RMDIR:
        case EXCEPT:
        case SETFILETIME:
        case SETREADONLY:
        case SETREADWRITE:
        case TARGET:
        case ADDBATCH:
        case CONNECT:
        case EXECUTEBATCH:
        case EXECUTEQUERY:
        case EXECUTEQUERYCALL:
        case EXECUTEANY:
        case EXECUTESQL:
        case EXECUTEUPDATE:
        case EXECUTEUPDATECALL:
        case PREPARE:
        case PREPARECALL:
        case PREPAREDEXECUTE:
        case PREPAREDEXECUTECALL:
        case PREPAREDEXECUTEQUERY:
        case PREPAREDEXECUTECALLQUERY:
        case PREPAREDEXECUTEUPDATE:
        case PREPAREDEXECUTECALLUPDATE:
        case DB__DUMPTABLE:
        case DB__ADDBATCH:
        case DB__CONNECT:
        case DB__DISCONNECT:
        case DB__BATCH:
        case DB__QUERY:
        case DB__QUERYCALL:
        case DB__ANY:
        case DB__SQL:
        case DB__CALL:
        case DB__UPDATE:
        case DB__UPDATECALL:
        case DB__PREPARE:
        case DB__PREPARECALL:
        case HIB__SETUP:
        case HIB__ADDCLASS:
        case HIB__ADDRESOURCE:
        case HIB__CLOSE:
        case HIB__TXBEGIN:
        case HIB__TXEND:
        case HIB__TXABORT:
        case HIB__LOCK:
        case HIB__QUERY:
        case HIB__ITERATE:
        case HIB__DELETE:
        case HIB__GET:
        case HIB__SAVE:
        case HIB__SAVEORUPDATECOPY:
        case HIB__UNLOCK:
        case HIB__UPDATE:
        case AFTER:
        case REPEAT:
        case SCHEDULE:
        case STARTING:
        case XML:
        case XSLT:
        case SYSTEMID:
        case OUTPUTPROPERTIES:
        case PARAMETERS:
        case XMLNS:
        case GUIEVENTS:
        case GUI__EVENTS:
        case INTEGER_LITERAL:
        case FLOATING_POINT_LITERAL:
        case STRING_LITERAL:
        case EXEC_RESULT_LITERAL:
        case EXEC_RESULTLINES_LITERAL:
        case IDENTIFIER:
        case CONST_NAME:
        case BANG:
        case TILDE:
        case COLONCOLON:
        case INCR:
        case DECR:
        case PLUS:
        case MINUS:
        case BIT_AND:
        case DOLLARLBRACE:
        case LBRACE:
        case LPAREN:
        case DOT:
        case SEMICOLON:
          ;
          break;
        default:
          jj_la1[52] = jj_gen;
          break label_12;
        }
      }
      break;
    default:
      jj_la1[53] = jj_gen;
      ;
    }
    jj_consume_token(RBRACE);
    BlockSimple blk = handleBlock(lastMark, s, begin);
    String name = LAMBDA_PREFIX + Lib.createID();
    addFunction(script, new FunctionUser(begin, lineNum(), name, inClassDef, params, null, blk));
    stack.push(new AccessFunction(name));
    inFxnThrd = false;
  }

  final public void ThreadDecl() throws ParseException {
  int begin;
  int lastMark;
  String name;
  String[] params;
  Expr[] defvals;
  inFxnThrd = true;
    jj_consume_token(THREAD);
                   begin = token.beginLine;
    LabelName();
                   name = THREAD_PREFIX + token.image; lastMark = markStack();
    defvals = FormalParameters();
                               params = handleStrings(lastMark);
    Block();
                   script.addThread(new _Thread(begin, lineNum(), name, inClassDef, params,
                                    defvals, (BlockSimple)stack.pop()));
                   inFxnThrd = false;
  }

  final public Expr[] FormalParameters() throws ParseException {
  int parenthDepth = 0;
  Expr[] ret = null;
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case LPAREN:
      jj_consume_token(LPAREN);
          ++parenthDepth;
      break;
    default:
      jj_la1[54] = jj_gen;
      ;
    }
    ret = FormalParameterList();
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case RPAREN:
      jj_consume_token(RPAREN);
                                                                --parenthDepth;
      break;
    default:
      jj_la1[55] = jj_gen;
      ;
    }
    if (parenthDepth != 0) throwParseException("Unmatched parentheses.");
    {if (true) return ret;}
    throw new Error("Missing return statement in function");
  }

  final public Expr[] FormalParameters1() throws ParseException {
  Expr[] ret = null;
    jj_consume_token(LPAREN);
    ret = FormalParameterList();
    jj_consume_token(RPAREN);
                                      {if (true) return ret;}
    throw new Error("Missing return statement in function");
  }

  final public Expr[] FormalParameterList() throws ParseException {
  ArrayList defvals = null;
  int paramIdx = 0;
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case DOTDOT:
      jj_consume_token(DOTDOT);
                             stack.push("..");
      break;
    default:
      jj_la1[60] = jj_gen;
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case IDENTIFIER:
        jj_consume_token(IDENTIFIER);
                             stack.push(token.image);
        switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
        case ASSIGN:
          jj_consume_token(ASSIGN);
          ReturnableExpression();
                             if (defvals == null) defvals = new ArrayList();
                             Lib.ensureSize(defvals, paramIdx+1);
                             defvals.set(paramIdx, reduceIt());
          break;
        default:
          jj_la1[56] = jj_gen;
          ;
        }
                             ++paramIdx;
        label_13:
        while (true) {
          if (jj_2_10(2)) {
            ;
          } else {
            break label_13;
          }
          jj_consume_token(COMMA);
          jj_consume_token(IDENTIFIER);
                             stack.push(token.image);
          switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
          case ASSIGN:
            jj_consume_token(ASSIGN);
            ReturnableExpression();
                             if (defvals == null) defvals = new ArrayList();
                             Lib.ensureSize(defvals, paramIdx+1);
                             defvals.set(paramIdx, reduceIt());
            break;
          default:
            jj_la1[57] = jj_gen;
            ;
          }
                             ++paramIdx;
        }
        switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
        case COMMA:
          jj_consume_token(COMMA);
          jj_consume_token(DOTDOT);
                   stack.push("..");
          break;
        default:
          jj_la1[58] = jj_gen;
          ;
        }
        break;
      default:
        jj_la1[59] = jj_gen;
        ;
      }
                             ++paramIdx;
    }
    if (defvals == null) {if (true) return null;}
    Expr[] ret = new Expr[defvals.size()];
    for (int i=0; i<ret.length; ++i)
      ret[i] = (Expr)defvals.get(i);
    {if (true) return ret;}
    throw new Error("Missing return statement in function");
  }

  final public void FormalParametersNoInit() throws ParseException {
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case DOTDOT:
      jj_consume_token(DOTDOT);
                             stack.push("..");
      break;
    default:
      jj_la1[63] = jj_gen;
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case IDENTIFIER:
        jj_consume_token(IDENTIFIER);
                             stack.push(token.image);
        label_14:
        while (true) {
          if (jj_2_11(2)) {
            ;
          } else {
            break label_14;
          }
          jj_consume_token(COMMA);
          jj_consume_token(IDENTIFIER);
                             stack.push(token.image);
        }
        switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
        case COMMA:
          jj_consume_token(COMMA);
          jj_consume_token(DOTDOT);
                   stack.push("..");
          break;
        default:
          jj_la1[61] = jj_gen;
          ;
        }
        break;
      default:
        jj_la1[62] = jj_gen;
        ;
      }
    }
  }

/*
 * Expression syntax follows.
 */
  final public void Expression() throws ParseException {
  int lastMark = markStack();
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case DEFINED:
      jj_consume_token(DEFINED);
      Expression();
                           stack.push( new ExprDefined(reduceIt()) );
      break;
    case TYPEOF:
      jj_consume_token(TYPEOF);
      Expression();
                           stack.pop();
      break;
    case ATTRIBUTESOF:
      jj_consume_token(ATTRIBUTESOF);
      Expression();
                                 stack.pop();
      break;
    case EXEC_RESULT_LITERAL:
      jj_consume_token(EXEC_RESULT_LITERAL);
                                 stack.push(new ExprExecResult(unquote(token.image), false));
      break;
    case EXEC_RESULTLINES_LITERAL:
      jj_consume_token(EXEC_RESULTLINES_LITERAL);
                                 stack.push(new ExprExecResult(unquote(token.image, 2), true));
      break;
    default:
      jj_la1[65] = jj_gen;
      if (jj_2_12(2147483647)) {
        Assignment();
      } else {
        switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
        case JAVA__:
        case _EOF:
        case __EOF:
        case AS:
        case ELIF:
        case EXTENDSJAVA:
        case FALSE:
        case JAVACLASS:
        case IFDEF:
        case IFNDEF:
        case IFEXISTS:
        case IN:
        case INFINITY:
        case INTO:
        case NEW:
        case JAVANEW:
        case MAX_NUMBER:
        case MIN_NUMBER:
        case NULL:
        case LIMIT:
        case NAMESPACE:
        case _SKIP:
        case SUPER:
        case THIS:
        case TRUE:
        case UNDEFINED:
        case BOOLEAN:
        case BYTE:
        case CHAR:
        case SHORT:
        case INT:
        case LONG:
        case FLOAT:
        case DOUBLE:
        case MAIL__CONNECT:
        case MAIL__DISCONNECT:
        case CC:
        case BCC:
        case ATTACH:
        case SUBJECT:
        case BODY:
        case HTMLBODY:
        case DATE_:
        case DATE:
        case NUMBER:
        case COLUMN:
        case ERR:
        case LOG:
        case NL:
        case OUT:
        case PIPE:
        case INPUT:
        case OUTPUT:
        case NEEDSYSTEMIN:
        case MANIFEST:
        case EXCEPT:
        case SETFILETIME:
        case SETREADONLY:
        case SETREADWRITE:
        case TARGET:
        case DB__DISCONNECT:
        case HIB__ADDCLASS:
        case HIB__ADDRESOURCE:
        case HIB__CLOSE:
        case HIB__TXBEGIN:
        case HIB__TXEND:
        case HIB__TXABORT:
        case HIB__LOCK:
        case HIB__DELETE:
        case HIB__GET:
        case HIB__SAVE:
        case HIB__SAVEORUPDATECOPY:
        case HIB__UNLOCK:
        case HIB__UPDATE:
        case AFTER:
        case STARTING:
        case XML:
        case SYSTEMID:
        case OUTPUTPROPERTIES:
        case PARAMETERS:
        case XMLNS:
        case INTEGER_LITERAL:
        case FLOATING_POINT_LITERAL:
        case STRING_LITERAL:
        case IDENTIFIER:
        case CONST_NAME:
        case BANG:
        case TILDE:
        case COLONCOLON:
        case INCR:
        case DECR:
        case PLUS:
        case MINUS:
        case BIT_AND:
        case DOLLARLBRACE:
        case LPAREN:
          ConditionalExpression();
          label_15:
          while (true) {
            switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
            case ATSIGN:
              ;
              break;
            default:
              jj_la1[64] = jj_gen;
              break label_15;
            }
            jj_consume_token(ATSIGN);
            ConditionalExpression();
          }
    if (handleMultiBase1(lastMark)) stack.push( new ExprConcat(first,rest) );
          break;
        default:
          jj_la1[66] = jj_gen;
          jj_consume_token(-1);
          throw new ParseException();
        }
      }
    }
  }

  final public void MultiAssignment() throws ParseException {
  StmtMultiAssign sma;
    jj_consume_token(LPAREN);
                             sma = new StmtMultiAssign(lineNum(), false);
    jj_consume_token(IDENTIFIER);
                             sma.addName(token.image);
    label_16:
    while (true) {
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case COMMA:
        ;
        break;
      default:
        jj_la1[67] = jj_gen;
        break label_16;
      }
      jj_consume_token(COMMA);
      jj_consume_token(IDENTIFIER);
                             sma.addName(token.image);
    }
    jj_consume_token(RPAREN);
    jj_consume_token(ASSIGN);
    ReturnableExpression();
                                      sma.setValue(reduceIt()); stack.push(sma);
    jj_consume_token(SEMICOLON);
  }

  final public void Assignment() throws ParseException {
  int op = 0;
  Integer jtype = null;
    PrimaryExpression(true);
    op = AssignmentOperator();
    if (jj_2_13(3)) {
      jj_consume_token(LPAREN);
      jtype = JavaPrimitiveTypes();
                                                  op |= (jtype.intValue() << 8);
      jj_consume_token(RPAREN);
    } else {
      ;
    }
    ReturnableExpression();
    Expr rhs = (Expr)stack.pop();
    Expr lhs = (Expr)stack.pop();
    stack.push( new ExprAssign(lineNum(), lhs, op, rhs) );
  }

  final public void LocalVariableDecl() throws ParseException {
  StmtMultiAssign sma = null;
    upgradeToVar();
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case IDENTIFIER:
      LocalVariableDeclaration();
      label_17:
      while (true) {
        if (jj_2_14(2)) {
          ;
        } else {
          break label_17;
        }
        jj_consume_token(COMMA);
        LocalVariableDeclaration();
      }
      break;
    case LPAREN:
      jj_consume_token(LPAREN);
                             sma = new StmtMultiAssign(lineNum(), true);
      jj_consume_token(IDENTIFIER);
                             sma.addName(token.image);
      label_18:
      while (true) {
        switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
        case COMMA:
          ;
          break;
        default:
          jj_la1[68] = jj_gen;
          break label_18;
        }
        jj_consume_token(COMMA);
        jj_consume_token(IDENTIFIER);
                             sma.addName(token.image);
      }
      jj_consume_token(RPAREN);
      jj_consume_token(ASSIGN);
      ReturnableExpression();
                                     sma.setValue(reduceIt()); stack.push(sma);
      break;
    default:
      jj_la1[69] = jj_gen;
      jj_consume_token(-1);
      throw new ParseException();
    }
    jj_consume_token(SEMICOLON);
  }

  final public void LocalVariableDeclaration() throws ParseException {
  String name = null;
  int lineNo;
  int lastMark = markStack();
    jj_consume_token(IDENTIFIER);
                  name = token.image; lineNo = lineNum();
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case ASSIGN:
      jj_consume_token(ASSIGN);
      ReturnableExpression();
      break;
    default:
      jj_la1[70] = jj_gen;
      ;
    }
    Expr rhs = handleSingleExpr(lastMark);
    if (rhs == null) rhs = ValueSpecial.UNDEFINED;
    stack.push(inClassDef && !inFxnThrd
               ? ExprAssign.createField(lineNo, name, rhs)
               : ExprAssign.createLocalVar(lineNo, name, rhs, true));
  }

  final public void ObjectAllocator() throws ParseException {
  String name = null;
  Object inits = null;
  Object cptr = null;
  int[] javaTypes = null;
  int lastMark = markStack();
  int lineNo;

  int mdim = 0;
  Expr clsName;
  Arguments args = null;
    jj_consume_token(NEW);
                                  lineNo = lineNum();
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case _USAGE:
    case ENDSCRIPT:
    case _EOF:
    case __EOF:
    case AS:
    case BREAK:
    case CASE:
    case CATCH:
    case CONST:
    case CONTINUE:
    case CONSTRUCTOR:
    case CTOR:
    case _DEFAULT:
    case CLASS:
    case DEFINED:
    case DELETE:
    case DO:
    case ELIF:
    case ELSE:
    case EXEC:
    case EXTENDS:
    case EXTENDSJAVA:
    case FALSE:
    case FINALLY:
    case FOR:
    case FROM:
    case FUNCTION:
    case LAMBDA:
    case THREAD:
    case JAVACLASS:
    case IF:
    case IFDEF:
    case IFNDEF:
    case IFEXISTS:
    case IMPORT:
    case IN:
    case INFINITY:
    case INTO:
    case LOCAL:
    case NEW:
    case MAX_NUMBER:
    case MIN_NUMBER:
    case NULL:
    case LIMIT:
    case NAMESPACE:
    case _SKIP:
    case RESUME:
    case RETURN:
    case STRIP:
    case SUPER:
    case SWITCH:
    case THIS:
    case THROW:
    case TO:
    case UPTO:
    case TYPEOF:
    case ATTRIBUTESOF:
    case ON:
    case DOWNTO:
    case TRUE:
    case TRY:
    case UNDER:
    case UNDEFINED:
    case USING:
    case USE:
    case VAR:
    case WHERE:
    case WHILE:
    case WITH:
    case BOOLEAN:
    case BYTE:
    case CHAR:
    case SHORT:
    case INT:
    case LONG:
    case FLOAT:
    case DOUBLE:
    case STRING:
    case STRING_:
    case VOID:
    case CC:
    case BCC:
    case ATTACH:
    case SUBJECT:
    case BODY:
    case HTMLBODY:
    case LINKEDLIST_:
    case LINKEDLIST:
    case SET_:
    case SET:
    case SORTEDMAP_:
    case SORTEDMAP:
    case DATE_:
    case DATE:
    case NUMBER_:
    case NUMBER:
    case COLUMN:
    case ERR:
    case LOG:
    case OUT:
    case PIPE:
    case INPUT:
    case OUTPUT:
    case NEEDSYSTEMIN:
    case FLUSH:
    case PRINT:
    case PRINTLN:
    case PRINTTABLE:
    case PRINTTABLEDATA:
    case SCP:
    case COPY:
    case MANIFEST:
    case LIST:
    case LS:
    case ORDERED:
    case BY:
    case RMDIR:
    case EXCEPT:
    case SETFILETIME:
    case SETREADONLY:
    case SETREADWRITE:
    case TARGET:
    case EJBQL:
    case AFTER:
    case REPEAT:
    case SCHEDULE:
    case STARTING:
    case XML:
    case XSLT:
    case XPATH:
    case SYSTEMID:
    case OUTPUTPROPERTIES:
    case PARAMETERS:
    case DOM:
    case XMLNS:
    case HTML:
    case JSP:
    case SGML:
    case IDENTIFIER:
      if (jj_2_15(2)) {
        upgradeToSortedMap();
        cptr = ComparatorDecl();
                                  name = "SortedMap";
                                  inits = new Doublet(cptr, handleExprs(lastMark));
      } else {
        switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
        case _USAGE:
        case ENDSCRIPT:
        case _EOF:
        case __EOF:
        case AS:
        case BREAK:
        case CASE:
        case CATCH:
        case CONST:
        case CONTINUE:
        case CONSTRUCTOR:
        case CTOR:
        case _DEFAULT:
        case CLASS:
        case DEFINED:
        case DELETE:
        case DO:
        case ELIF:
        case ELSE:
        case EXEC:
        case EXTENDS:
        case EXTENDSJAVA:
        case FALSE:
        case FINALLY:
        case FOR:
        case FROM:
        case FUNCTION:
        case LAMBDA:
        case THREAD:
        case JAVACLASS:
        case IF:
        case IFDEF:
        case IFNDEF:
        case IFEXISTS:
        case IMPORT:
        case IN:
        case INFINITY:
        case INTO:
        case LOCAL:
        case NEW:
        case MAX_NUMBER:
        case MIN_NUMBER:
        case NULL:
        case LIMIT:
        case NAMESPACE:
        case _SKIP:
        case RESUME:
        case RETURN:
        case STRIP:
        case SUPER:
        case SWITCH:
        case THIS:
        case THROW:
        case TO:
        case UPTO:
        case TYPEOF:
        case ATTRIBUTESOF:
        case ON:
        case DOWNTO:
        case TRUE:
        case TRY:
        case UNDER:
        case UNDEFINED:
        case USING:
        case USE:
        case VAR:
        case WHERE:
        case WHILE:
        case WITH:
        case BOOLEAN:
        case BYTE:
        case CHAR:
        case SHORT:
        case INT:
        case LONG:
        case FLOAT:
        case DOUBLE:
        case STRING:
        case STRING_:
        case VOID:
        case CC:
        case BCC:
        case ATTACH:
        case SUBJECT:
        case BODY:
        case HTMLBODY:
        case LINKEDLIST_:
        case LINKEDLIST:
        case SET_:
        case SET:
        case SORTEDMAP_:
        case SORTEDMAP:
        case DATE_:
        case DATE:
        case NUMBER_:
        case NUMBER:
        case COLUMN:
        case ERR:
        case LOG:
        case OUT:
        case PIPE:
        case INPUT:
        case OUTPUT:
        case NEEDSYSTEMIN:
        case FLUSH:
        case PRINT:
        case PRINTLN:
        case PRINTTABLE:
        case PRINTTABLEDATA:
        case SCP:
        case COPY:
        case MANIFEST:
        case LIST:
        case LS:
        case ORDERED:
        case BY:
        case RMDIR:
        case EXCEPT:
        case SETFILETIME:
        case SETREADONLY:
        case SETREADWRITE:
        case TARGET:
        case EJBQL:
        case AFTER:
        case REPEAT:
        case SCHEDULE:
        case STARTING:
        case XML:
        case XSLT:
        case XPATH:
        case SYSTEMID:
        case OUTPUTPROPERTIES:
        case PARAMETERS:
        case DOM:
        case XMLNS:
        case HTML:
        case JSP:
        case SGML:
        case IDENTIFIER:
          AnyName();
                                  name = token.image;
                                  if ("struct".equalsIgnoreCase(name)) { upgradeMsg("Object"); name = null; }
                                  else if ("Object".equals(name)) name = null;
          break;
        default:
          jj_la1[71] = jj_gen;
          jj_consume_token(-1);
          throw new ParseException();
        }
      }
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case LPAREN:
        if (jj_2_16(2147483647)) {
          MemberInitList();
                                  inits = handleNamedExprs(lastMark);
        } else {
          switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
          case LPAREN:
            Arguments(null,0);
                                  args = (Arguments)stack.pop();
                                  inits = args.getParams();
                                  javaTypes = args.getTypes();
            break;
          default:
            jj_la1[72] = jj_gen;
            jj_consume_token(-1);
            throw new ParseException();
          }
        }
        break;
      default:
        jj_la1[73] = jj_gen;
        ;
      }
                                  NewObject no = new NewObject(name, inits, javaTypes);
                                  no.setLineNumber(lineNo);
                                  stack.push(no);
      break;
    case CONST_NAME:
    case COLON:
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case CONST_NAME:
        jj_consume_token(CONST_NAME);
                                  try {
                                    name = script.resolveConst(token.image).getStringValue();
//                                    name = script.handleClassName(name);
                                    clsName = new ConstString(name);
                                  } catch(Throwable e) {
                                    throwParseException(e.getMessage());
                                    clsName = null;
                                  }
        break;
      case COLON:
        jj_consume_token(COLON);
        AnyName();
                                  clsName = new AccessVar(token.image);
        break;
      default:
        jj_la1[74] = jj_gen;
        jj_consume_token(-1);
        throw new ParseException();
      }
      if (jj_2_17(2147483647)) {
        label_19:
        while (true) {
          jj_consume_token(LBRACKET);
          jj_consume_token(RBRACKET);
                                  ++mdim;
          switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
          case LBRACKET:
            ;
            break;
          default:
            jj_la1[75] = jj_gen;
            break label_19;
          }
        }
        MultiDimArrayInit();
                                  stack.push(new JavaMDArray(lineNo, this, clsName,mdim,stack.pop()));
      } else {
        switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
        case LBRACKET:
          label_20:
          while (true) {
            jj_consume_token(LBRACKET);
            Expression();
            jj_consume_token(RBRACKET);
            switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
            case LBRACKET:
              ;
              break;
            default:
              jj_la1[76] = jj_gen;
              break label_20;
            }
          }
                                  stack.push(new NewJavaArray(clsName, handleExprs(lastMark)));
          break;
        default:
          jj_la1[78] = jj_gen;
          switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
          case LPAREN:
            Arguments(null,0);
                                  args = (Arguments)stack.pop();
            break;
          default:
            jj_la1[77] = jj_gen;
            ;
          }
                                  stack.push(newJava(clsName, args, lineNo));
        }
      }
      break;
    default:
      jj_la1[79] = jj_gen;
      jj_consume_token(-1);
      throw new ParseException();
    }
  }

  final public void JavaAllocator() throws ParseException {
  String x = null;
  Expr clsName = null;
  Object args = null; // Arguments or AssociateList
  int mdim = 0;
  int lastMark = markStack();
  int lineNo = 0;
    if (jj_2_23(2)) {
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case NEW:
        jj_consume_token(NEW);
        jj_consume_token(JAVA__);
        break;
      case JAVANEW:
        jj_consume_token(JAVANEW);
                                 upgradeMsg("new java::");
        break;
      default:
        jj_la1[80] = jj_gen;
        jj_consume_token(-1);
        throw new ParseException();
      }
                                                                 lineNo = lineNum();
      if (jj_2_20(2147483647)) {
        x = JavaxDefinition(JudoUtil.genTempVarName("_jadapter_"));
                                      stack.push(new NewObject(x, null));
      } else {
        switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
        case _USAGE:
        case ENDSCRIPT:
        case _EOF:
        case __EOF:
        case AS:
        case DEFINED:
        case DELETE:
        case ELIF:
        case EXEC:
        case EXTENDSJAVA:
        case FUNCTION:
        case LAMBDA:
        case JAVACLASS:
        case IFDEF:
        case IFNDEF:
        case IFEXISTS:
        case IN:
        case INFINITY:
        case INTO:
        case LOCAL:
        case LIMIT:
        case NAMESPACE:
        case _SKIP:
        case RESUME:
        case STRIP:
        case TYPEOF:
        case ATTRIBUTESOF:
        case UNDER:
        case UNDEFINED:
        case USING:
        case USE:
        case VAR:
        case WHERE:
        case WITH:
        case BOOLEAN:
        case BYTE:
        case CHAR:
        case SHORT:
        case INT:
        case LONG:
        case FLOAT:
        case DOUBLE:
        case STRING:
        case STRING_:
        case CC:
        case BCC:
        case ATTACH:
        case SUBJECT:
        case BODY:
        case HTMLBODY:
        case LINKEDLIST_:
        case LINKEDLIST:
        case SET_:
        case SET:
        case SORTEDMAP_:
        case SORTEDMAP:
        case DATE_:
        case DATE:
        case NUMBER_:
        case NUMBER:
        case COLUMN:
        case ERR:
        case LOG:
        case OUT:
        case PIPE:
        case INPUT:
        case OUTPUT:
        case NEEDSYSTEMIN:
        case FLUSH:
        case PRINT:
        case PRINTLN:
        case PRINTTABLE:
        case PRINTTABLEDATA:
        case SCP:
        case COPY:
        case MANIFEST:
        case LIST:
        case LS:
        case ORDERED:
        case BY:
        case RMDIR:
        case EXCEPT:
        case SETFILETIME:
        case SETREADONLY:
        case SETREADWRITE:
        case TARGET:
        case EJBQL:
        case AFTER:
        case REPEAT:
        case SCHEDULE:
        case STARTING:
        case XML:
        case XSLT:
        case XPATH:
        case SYSTEMID:
        case OUTPUTPROPERTIES:
        case PARAMETERS:
        case DOM:
        case XMLNS:
        case HTML:
        case JSP:
        case SGML:
        case IDENTIFIER:
        case CONST_NAME:
        case COLON:
          switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
          case _USAGE:
          case ENDSCRIPT:
          case _EOF:
          case __EOF:
          case AS:
          case DEFINED:
          case DELETE:
          case ELIF:
          case EXEC:
          case EXTENDSJAVA:
          case FUNCTION:
          case LAMBDA:
          case JAVACLASS:
          case IFDEF:
          case IFNDEF:
          case IFEXISTS:
          case IN:
          case INFINITY:
          case INTO:
          case LOCAL:
          case LIMIT:
          case NAMESPACE:
          case _SKIP:
          case RESUME:
          case STRIP:
          case TYPEOF:
          case ATTRIBUTESOF:
          case UNDER:
          case UNDEFINED:
          case USING:
          case USE:
          case VAR:
          case WHERE:
          case WITH:
          case BOOLEAN:
          case BYTE:
          case CHAR:
          case SHORT:
          case INT:
          case LONG:
          case FLOAT:
          case DOUBLE:
          case STRING:
          case STRING_:
          case CC:
          case BCC:
          case ATTACH:
          case SUBJECT:
          case BODY:
          case HTMLBODY:
          case LINKEDLIST_:
          case LINKEDLIST:
          case SET_:
          case SET:
          case SORTEDMAP_:
          case SORTEDMAP:
          case DATE_:
          case DATE:
          case NUMBER_:
          case NUMBER:
          case COLUMN:
          case ERR:
          case LOG:
          case OUT:
          case PIPE:
          case INPUT:
          case OUTPUT:
          case NEEDSYSTEMIN:
          case FLUSH:
          case PRINT:
          case PRINTLN:
          case PRINTTABLE:
          case PRINTTABLEDATA:
          case SCP:
          case COPY:
          case MANIFEST:
          case LIST:
          case LS:
          case ORDERED:
          case BY:
          case RMDIR:
          case EXCEPT:
          case SETFILETIME:
          case SETREADONLY:
          case SETREADWRITE:
          case TARGET:
          case EJBQL:
          case AFTER:
          case REPEAT:
          case SCHEDULE:
          case STARTING:
          case XML:
          case XSLT:
          case XPATH:
          case SYSTEMID:
          case OUTPUTPROPERTIES:
          case PARAMETERS:
          case DOM:
          case XMLNS:
          case HTML:
          case JSP:
          case SGML:
          case IDENTIFIER:
          case CONST_NAME:
            x = JavaTypeName(false);
                                      clsName = new ConstString(x);
            break;
          case COLON:
            jj_consume_token(COLON);
            AnyName();
                                      clsName = new AccessVar(token.image);
            break;
          default:
            jj_la1[81] = jj_gen;
            jj_consume_token(-1);
            throw new ParseException();
          }
          if (jj_2_18(2147483647)) {
            label_21:
            while (true) {
              jj_consume_token(LBRACKET);
              jj_consume_token(RBRACKET);
                                      ++mdim;
              switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
              case LBRACKET:
                ;
                break;
              default:
                jj_la1[82] = jj_gen;
                break label_21;
              }
            }
            MultiDimArrayInit();
                                      stack.push(new JavaMDArray(lineNo, this, clsName, mdim, stack.pop()));
          } else {
            switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
            case LBRACKET:
              label_22:
              while (true) {
                jj_consume_token(LBRACKET);
                Expression();
                jj_consume_token(RBRACKET);
                switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
                case LBRACKET:
                  ;
                  break;
                default:
                  jj_la1[83] = jj_gen;
                  break label_22;
                }
              }
                                      stack.push(new NewJavaArray(clsName, handleExprs(lastMark)));
              break;
            default:
              jj_la1[85] = jj_gen;
              if (jj_2_19(2147483647)) {
                MemberInitList();
                                      stack.push(newJava(clsName, handleNamedExprs(lastMark), lineNo));
              } else {
                switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
                case LPAREN:
                  Arguments(null,0);
                                      args = (Arguments)stack.pop();
                  break;
                default:
                  jj_la1[84] = jj_gen;
                  ;
                }
                                      stack.push(newJava(clsName, args, lineNo));
              }
            }
          }
          break;
        default:
          jj_la1[86] = jj_gen;
          jj_consume_token(-1);
          throw new ParseException();
        }
      }
    } else {
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case NEW:
        jj_consume_token(NEW);
                                      lineNo = lineNum();
        x = JavaPrimitiveTypeNames(false);
                                      clsName = new ConstString(x);
        if (jj_2_21(2147483647)) {
          label_23:
          while (true) {
            jj_consume_token(LBRACKET);
            jj_consume_token(RBRACKET);
                                      ++mdim;
            switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
            case LBRACKET:
              ;
              break;
            default:
              jj_la1[87] = jj_gen;
              break label_23;
            }
          }
          MultiDimArrayInit();
                                      stack.push(new JavaMDArray(lineNo, this, clsName, mdim, stack.pop()));
        } else {
          switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
          case LBRACKET:
            label_24:
            while (true) {
              jj_consume_token(LBRACKET);
              Expression();
              jj_consume_token(RBRACKET);
              switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
              case LBRACKET:
                ;
                break;
              default:
                jj_la1[88] = jj_gen;
                break label_24;
              }
            }
                                      stack.push(new NewJavaArray(clsName, handleExprs(lastMark)));
            break;
          default:
            jj_la1[90] = jj_gen;
            if (jj_2_22(2147483647)) {
              MemberInitList();
                                      stack.push(newJava(clsName, handleNamedExprs(lastMark), lineNo));
            } else {
              switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
              case LPAREN:
                Arguments(null,0);
                                      args = (Arguments)stack.pop();
                break;
              default:
                jj_la1[89] = jj_gen;
                ;
              }
                                      stack.push(newJava(clsName, args, lineNo));
            }
          }
        }
        break;
      default:
        jj_la1[91] = jj_gen;
        jj_consume_token(-1);
        throw new ParseException();
      }
    }
  }

  final public void ComAllocator() throws ParseException {
  String x;
  Expr clsName[] = new Expr[1];
  int lineNo;
    jj_consume_token(NEW);
    jj_consume_token(COM__);
                                      lineNo = lineNum();
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case _USAGE:
    case ENDSCRIPT:
    case _EOF:
    case __EOF:
    case AS:
    case DEFINED:
    case DELETE:
    case ELIF:
    case EXEC:
    case EXTENDSJAVA:
    case FUNCTION:
    case LAMBDA:
    case JAVACLASS:
    case IFDEF:
    case IFNDEF:
    case IFEXISTS:
    case IN:
    case INFINITY:
    case INTO:
    case LOCAL:
    case LIMIT:
    case NAMESPACE:
    case _SKIP:
    case RESUME:
    case STRIP:
    case TYPEOF:
    case ATTRIBUTESOF:
    case UNDER:
    case UNDEFINED:
    case USING:
    case USE:
    case VAR:
    case WHERE:
    case WITH:
    case STRING:
    case STRING_:
    case CC:
    case BCC:
    case ATTACH:
    case SUBJECT:
    case BODY:
    case HTMLBODY:
    case LINKEDLIST_:
    case LINKEDLIST:
    case SET_:
    case SET:
    case SORTEDMAP_:
    case SORTEDMAP:
    case DATE_:
    case DATE:
    case NUMBER_:
    case NUMBER:
    case COLUMN:
    case ERR:
    case LOG:
    case OUT:
    case PIPE:
    case INPUT:
    case OUTPUT:
    case NEEDSYSTEMIN:
    case FLUSH:
    case PRINT:
    case PRINTLN:
    case PRINTTABLE:
    case PRINTTABLEDATA:
    case SCP:
    case COPY:
    case MANIFEST:
    case LIST:
    case LS:
    case ORDERED:
    case BY:
    case RMDIR:
    case EXCEPT:
    case SETFILETIME:
    case SETREADONLY:
    case SETREADWRITE:
    case TARGET:
    case EJBQL:
    case AFTER:
    case REPEAT:
    case SCHEDULE:
    case STARTING:
    case XML:
    case XSLT:
    case XPATH:
    case SYSTEMID:
    case OUTPUTPROPERTIES:
    case PARAMETERS:
    case DOM:
    case XMLNS:
    case HTML:
    case JSP:
    case SGML:
    case IDENTIFIER:
    case CONST_NAME:
      x = JavaClassName();
                                      clsName[0] = new ConstString(x);
      break;
    case STRING_LITERAL:
      jj_consume_token(STRING_LITERAL);
                                      clsName[0] = new ConstString(token.image);
      break;
    case COLON:
      jj_consume_token(COLON);
      AnyName();
                                      clsName[0] = new AccessVar(token.image);
      break;
    default:
      jj_la1[92] = jj_gen;
      jj_consume_token(-1);
      throw new ParseException();
    }
    stack.push( newCall((String)null, "createCOMObject", clsName, null) );
  }

  final public void MultiDimArrayInit() throws ParseException {
  ArrayList ret = new ArrayList();
    jj_consume_token(LBRACE);
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case JAVA__:
    case _EOF:
    case __EOF:
    case AS:
    case DEFINED:
    case ELIF:
    case EXTENDSJAVA:
    case FALSE:
    case JAVACLASS:
    case IFDEF:
    case IFNDEF:
    case IFEXISTS:
    case IN:
    case INFINITY:
    case INTO:
    case NEW:
    case JAVANEW:
    case MAX_NUMBER:
    case MIN_NUMBER:
    case NULL:
    case LIMIT:
    case NAMESPACE:
    case _SKIP:
    case SUPER:
    case THIS:
    case TYPEOF:
    case ATTRIBUTESOF:
    case TRUE:
    case UNDEFINED:
    case BOOLEAN:
    case BYTE:
    case CHAR:
    case SHORT:
    case INT:
    case LONG:
    case FLOAT:
    case DOUBLE:
    case MAIL__CONNECT:
    case MAIL__DISCONNECT:
    case CC:
    case BCC:
    case ATTACH:
    case SUBJECT:
    case BODY:
    case HTMLBODY:
    case DATE_:
    case DATE:
    case NUMBER:
    case COLUMN:
    case ERR:
    case LOG:
    case NL:
    case OUT:
    case PIPE:
    case INPUT:
    case OUTPUT:
    case NEEDSYSTEMIN:
    case MANIFEST:
    case EXCEPT:
    case SETFILETIME:
    case SETREADONLY:
    case SETREADWRITE:
    case TARGET:
    case DB__DISCONNECT:
    case HIB__ADDCLASS:
    case HIB__ADDRESOURCE:
    case HIB__CLOSE:
    case HIB__TXBEGIN:
    case HIB__TXEND:
    case HIB__TXABORT:
    case HIB__LOCK:
    case HIB__DELETE:
    case HIB__GET:
    case HIB__SAVE:
    case HIB__SAVEORUPDATECOPY:
    case HIB__UNLOCK:
    case HIB__UPDATE:
    case AFTER:
    case STARTING:
    case XML:
    case SYSTEMID:
    case OUTPUTPROPERTIES:
    case PARAMETERS:
    case XMLNS:
    case INTEGER_LITERAL:
    case FLOATING_POINT_LITERAL:
    case STRING_LITERAL:
    case EXEC_RESULT_LITERAL:
    case EXEC_RESULTLINES_LITERAL:
    case IDENTIFIER:
    case CONST_NAME:
    case BANG:
    case TILDE:
    case COLONCOLON:
    case INCR:
    case DECR:
    case PLUS:
    case MINUS:
    case BIT_AND:
    case DOLLARLBRACE:
    case LBRACE:
    case LPAREN:
      MDArrayInitializer();
                                      ret.add(stack.pop());
      label_25:
      while (true) {
        switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
        case COMMA:
          ;
          break;
        default:
          jj_la1[93] = jj_gen;
          break label_25;
        }
        jj_consume_token(COMMA);
        MDArrayInitializer();
                                      ret.add(stack.pop());
      }
      break;
    default:
      jj_la1[94] = jj_gen;
      ;
    }
    jj_consume_token(RBRACE);
                                      stack.push(ret);
  }

  final public void MDArrayInitializer() throws ParseException {
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case LBRACE:
      MultiDimArrayInit();
      break;
    case JAVA__:
    case _EOF:
    case __EOF:
    case AS:
    case DEFINED:
    case ELIF:
    case EXTENDSJAVA:
    case FALSE:
    case JAVACLASS:
    case IFDEF:
    case IFNDEF:
    case IFEXISTS:
    case IN:
    case INFINITY:
    case INTO:
    case NEW:
    case JAVANEW:
    case MAX_NUMBER:
    case MIN_NUMBER:
    case NULL:
    case LIMIT:
    case NAMESPACE:
    case _SKIP:
    case SUPER:
    case THIS:
    case TYPEOF:
    case ATTRIBUTESOF:
    case TRUE:
    case UNDEFINED:
    case BOOLEAN:
    case BYTE:
    case CHAR:
    case SHORT:
    case INT:
    case LONG:
    case FLOAT:
    case DOUBLE:
    case MAIL__CONNECT:
    case MAIL__DISCONNECT:
    case CC:
    case BCC:
    case ATTACH:
    case SUBJECT:
    case BODY:
    case HTMLBODY:
    case DATE_:
    case DATE:
    case NUMBER:
    case COLUMN:
    case ERR:
    case LOG:
    case NL:
    case OUT:
    case PIPE:
    case INPUT:
    case OUTPUT:
    case NEEDSYSTEMIN:
    case MANIFEST:
    case EXCEPT:
    case SETFILETIME:
    case SETREADONLY:
    case SETREADWRITE:
    case TARGET:
    case DB__DISCONNECT:
    case HIB__ADDCLASS:
    case HIB__ADDRESOURCE:
    case HIB__CLOSE:
    case HIB__TXBEGIN:
    case HIB__TXEND:
    case HIB__TXABORT:
    case HIB__LOCK:
    case HIB__DELETE:
    case HIB__GET:
    case HIB__SAVE:
    case HIB__SAVEORUPDATECOPY:
    case HIB__UNLOCK:
    case HIB__UPDATE:
    case AFTER:
    case STARTING:
    case XML:
    case SYSTEMID:
    case OUTPUTPROPERTIES:
    case PARAMETERS:
    case XMLNS:
    case INTEGER_LITERAL:
    case FLOATING_POINT_LITERAL:
    case STRING_LITERAL:
    case EXEC_RESULT_LITERAL:
    case EXEC_RESULTLINES_LITERAL:
    case IDENTIFIER:
    case CONST_NAME:
    case BANG:
    case TILDE:
    case COLONCOLON:
    case INCR:
    case DECR:
    case PLUS:
    case MINUS:
    case BIT_AND:
    case DOLLARLBRACE:
    case LPAREN:
      Expression();
      break;
    default:
      jj_la1[95] = jj_gen;
      jj_consume_token(-1);
      throw new ParseException();
    }
  }

  final public void MemberInitList() throws ParseException {
    jj_consume_token(LPAREN);
    MemberInitList1();
    jj_consume_token(RPAREN);
  }

  final public void MemberInitList1() throws ParseException {
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case _USAGE:
    case ENDSCRIPT:
    case _EOF:
    case __EOF:
    case AS:
    case DEFINED:
    case DELETE:
    case ELIF:
    case EXEC:
    case EXTENDSJAVA:
    case FUNCTION:
    case LAMBDA:
    case JAVACLASS:
    case IFDEF:
    case IFNDEF:
    case IFEXISTS:
    case IN:
    case INFINITY:
    case INTO:
    case LOCAL:
    case LIMIT:
    case NAMESPACE:
    case _SKIP:
    case RESUME:
    case STRIP:
    case TYPEOF:
    case ATTRIBUTESOF:
    case UNDER:
    case UNDEFINED:
    case USING:
    case USE:
    case VAR:
    case WHERE:
    case WITH:
    case STRING:
    case STRING_:
    case CC:
    case BCC:
    case ATTACH:
    case SUBJECT:
    case BODY:
    case HTMLBODY:
    case LINKEDLIST_:
    case LINKEDLIST:
    case SET_:
    case SET:
    case SORTEDMAP_:
    case SORTEDMAP:
    case DATE_:
    case DATE:
    case NUMBER_:
    case NUMBER:
    case COLUMN:
    case ERR:
    case LOG:
    case OUT:
    case PIPE:
    case INPUT:
    case OUTPUT:
    case NEEDSYSTEMIN:
    case FLUSH:
    case PRINT:
    case PRINTLN:
    case PRINTTABLE:
    case PRINTTABLEDATA:
    case SCP:
    case COPY:
    case MANIFEST:
    case LIST:
    case LS:
    case ORDERED:
    case BY:
    case RMDIR:
    case EXCEPT:
    case SETFILETIME:
    case SETREADONLY:
    case SETREADWRITE:
    case TARGET:
    case EJBQL:
    case AFTER:
    case REPEAT:
    case SCHEDULE:
    case STARTING:
    case XML:
    case XSLT:
    case XPATH:
    case SYSTEMID:
    case OUTPUTPROPERTIES:
    case PARAMETERS:
    case DOM:
    case XMLNS:
    case HTML:
    case JSP:
    case SGML:
    case STRING_LITERAL:
    case IDENTIFIER:
    case CONST_NAME:
    case ATSIGN:
      MemberInitializer();
      label_26:
      while (true) {
        switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
        case COMMA:
          ;
          break;
        default:
          jj_la1[96] = jj_gen;
          break label_26;
        }
        jj_consume_token(COMMA);
        MemberInitializer();
      }
      break;
    default:
      jj_la1[97] = jj_gen;
      ;
    }
  }

  final public void MemberInitializer() throws ParseException {
  String x;
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case STRING_LITERAL:
      jj_consume_token(STRING_LITERAL);
                            stack.push(unquote(token.image));
      break;
    case _USAGE:
    case ENDSCRIPT:
    case _EOF:
    case __EOF:
    case AS:
    case DEFINED:
    case DELETE:
    case ELIF:
    case EXEC:
    case EXTENDSJAVA:
    case FUNCTION:
    case LAMBDA:
    case JAVACLASS:
    case IFDEF:
    case IFNDEF:
    case IFEXISTS:
    case IN:
    case INFINITY:
    case INTO:
    case LOCAL:
    case LIMIT:
    case NAMESPACE:
    case _SKIP:
    case RESUME:
    case STRIP:
    case TYPEOF:
    case ATTRIBUTESOF:
    case UNDER:
    case UNDEFINED:
    case USING:
    case USE:
    case VAR:
    case WHERE:
    case WITH:
    case STRING:
    case STRING_:
    case CC:
    case BCC:
    case ATTACH:
    case SUBJECT:
    case BODY:
    case HTMLBODY:
    case LINKEDLIST_:
    case LINKEDLIST:
    case SET_:
    case SET:
    case SORTEDMAP_:
    case SORTEDMAP:
    case DATE_:
    case DATE:
    case NUMBER_:
    case NUMBER:
    case COLUMN:
    case ERR:
    case LOG:
    case OUT:
    case PIPE:
    case INPUT:
    case OUTPUT:
    case NEEDSYSTEMIN:
    case FLUSH:
    case PRINT:
    case PRINTLN:
    case PRINTTABLE:
    case PRINTTABLEDATA:
    case SCP:
    case COPY:
    case MANIFEST:
    case LIST:
    case LS:
    case ORDERED:
    case BY:
    case RMDIR:
    case EXCEPT:
    case SETFILETIME:
    case SETREADONLY:
    case SETREADWRITE:
    case TARGET:
    case EJBQL:
    case AFTER:
    case REPEAT:
    case SCHEDULE:
    case STARTING:
    case XML:
    case XSLT:
    case XPATH:
    case SYSTEMID:
    case OUTPUTPROPERTIES:
    case PARAMETERS:
    case DOM:
    case XMLNS:
    case HTML:
    case JSP:
    case SGML:
    case IDENTIFIER:
    case CONST_NAME:
      x = JavaClassName();
                            stack.push(x);
      break;
    case ATSIGN:
      jj_consume_token(ATSIGN);
      PrimarySimpleExpression(false);
      break;
    default:
      jj_la1[98] = jj_gen;
      jj_consume_token(-1);
      throw new ParseException();
    }
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case ASSIGN:
      jj_consume_token(ASSIGN);
      break;
    case COLON:
      jj_consume_token(COLON);
      break;
    default:
      jj_la1[99] = jj_gen;
      jj_consume_token(-1);
      throw new ParseException();
    }
    ReturnableExpression();
  }

  final public int AssignmentOperator() throws ParseException {
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case ASSIGN:
      jj_consume_token(ASSIGN);
              {if (true) return OP_ASSIGN;}
      break;
    case _COPY:
      jj_consume_token(_COPY);
              {if (true) return OP_COPY;}
      break;
    case ATASSIGN:
      jj_consume_token(ATASSIGN);
              {if (true) return OP_CONCAT_ASSIGN;}
      break;
    case STARASSIGN:
      jj_consume_token(STARASSIGN);
              {if (true) return OP_MUL_ASSIGN;}
      break;
    case SLASHASSIGN:
      jj_consume_token(SLASHASSIGN);
              {if (true) return OP_DIV_ASSIGN;}
      break;
    case REMASSIGN:
      jj_consume_token(REMASSIGN);
              {if (true) return OP_MOD_ASSIGN;}
      break;
    case PLUSASSIGN:
      jj_consume_token(PLUSASSIGN);
              {if (true) return OP_PLUS_ASSIGN;}
      break;
    case MINUSASSIGN:
      jj_consume_token(MINUSASSIGN);
              {if (true) return OP_MINUS_ASSIGN;}
      break;
    case LSHIFTASSIGN:
      jj_consume_token(LSHIFTASSIGN);
              {if (true) return OP_LSHIFT_ASSIGN;}
      break;
    case RSIGNEDSHIFTASSIGN:
      jj_consume_token(RSIGNEDSHIFTASSIGN);
              {if (true) return OP_RSHIFT_ASSIGN;}
      break;
    case RUNSIGNEDSHIFTASSIGN:
      jj_consume_token(RUNSIGNEDSHIFTASSIGN);
              {if (true) return OP_RUSHIFT_ASSIGN;}
      break;
    case ANDASSIGN:
      jj_consume_token(ANDASSIGN);
              {if (true) return OP_AND_ASSIGN;}
      break;
    case XORASSIGN:
      jj_consume_token(XORASSIGN);
              {if (true) return OP_XOR_ASSIGN;}
      break;
    case ORASSIGN:
      jj_consume_token(ORASSIGN);
              {if (true) return OP_OR_ASSIGN;}
      break;
    case ANDANDASSIGN:
      jj_consume_token(ANDANDASSIGN);
              {if (true) return OP_LOGIC_AND_ASSIGN;}
      break;
    case ORORASSIGN:
      jj_consume_token(ORORASSIGN);
              {if (true) return OP_LOGIC_OR_ASSIGN;}
      break;
    default:
      jj_la1[100] = jj_gen;
      jj_consume_token(-1);
      throw new ParseException();
    }
    throw new Error("Missing return statement in function");
  }

  final public void ConditionalExpression() throws ParseException {
  int lastMark = markStack();
    ConditionalOrExpression();
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case HOOK:
      jj_consume_token(HOOK);
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case HEREDOC_BEGIN:
      case HEREDOC_BEGIN_:
        HereDoc();
        break;
      case JAVA__:
      case _EOF:
      case __EOF:
      case AS:
      case DEFINED:
      case ELIF:
      case EXTENDSJAVA:
      case FALSE:
      case JAVACLASS:
      case IFDEF:
      case IFNDEF:
      case IFEXISTS:
      case IN:
      case INFINITY:
      case INTO:
      case NEW:
      case JAVANEW:
      case MAX_NUMBER:
      case MIN_NUMBER:
      case NULL:
      case LIMIT:
      case NAMESPACE:
      case _SKIP:
      case SUPER:
      case THIS:
      case TYPEOF:
      case ATTRIBUTESOF:
      case TRUE:
      case UNDEFINED:
      case BOOLEAN:
      case BYTE:
      case CHAR:
      case SHORT:
      case INT:
      case LONG:
      case FLOAT:
      case DOUBLE:
      case MAIL__CONNECT:
      case MAIL__DISCONNECT:
      case CC:
      case BCC:
      case ATTACH:
      case SUBJECT:
      case BODY:
      case HTMLBODY:
      case DATE_:
      case DATE:
      case NUMBER:
      case COLUMN:
      case ERR:
      case LOG:
      case NL:
      case OUT:
      case PIPE:
      case INPUT:
      case OUTPUT:
      case NEEDSYSTEMIN:
      case MANIFEST:
      case EXCEPT:
      case SETFILETIME:
      case SETREADONLY:
      case SETREADWRITE:
      case TARGET:
      case DB__DISCONNECT:
      case HIB__ADDCLASS:
      case HIB__ADDRESOURCE:
      case HIB__CLOSE:
      case HIB__TXBEGIN:
      case HIB__TXEND:
      case HIB__TXABORT:
      case HIB__LOCK:
      case HIB__DELETE:
      case HIB__GET:
      case HIB__SAVE:
      case HIB__SAVEORUPDATECOPY:
      case HIB__UNLOCK:
      case HIB__UPDATE:
      case AFTER:
      case STARTING:
      case XML:
      case SYSTEMID:
      case OUTPUTPROPERTIES:
      case PARAMETERS:
      case XMLNS:
      case INTEGER_LITERAL:
      case FLOATING_POINT_LITERAL:
      case STRING_LITERAL:
      case EXEC_RESULT_LITERAL:
      case EXEC_RESULTLINES_LITERAL:
      case IDENTIFIER:
      case CONST_NAME:
      case BANG:
      case TILDE:
      case COLONCOLON:
      case INCR:
      case DECR:
      case PLUS:
      case MINUS:
      case BIT_AND:
      case DOLLARLBRACE:
      case LPAREN:
        Expression();
        break;
      default:
        jj_la1[101] = jj_gen;
        jj_consume_token(-1);
        throw new ParseException();
      }
      jj_consume_token(COLON);
      ConditionalExpression();
      break;
    default:
      jj_la1[102] = jj_gen;
      ;
    }
    if (countOnStack(lastMark) < 3) {if (true) return;}
    Expr rhs = (Expr)stack.pop();
    Expr lhs = (Expr)stack.pop();
    stack.push( new ExprConditional((Expr)stack.pop(), lhs, rhs) );
  }

  final public void ConditionalOrExpression() throws ParseException {
  int lastMark = markStack();
    ConditionalAndExpression();
    label_27:
    while (true) {
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case SC_OR:
        ;
        break;
      default:
        jj_la1[103] = jj_gen;
        break label_27;
      }
      jj_consume_token(SC_OR);
      ConditionalAndExpression();
    }
    if (handleMultiBase1(lastMark)) stack.push(new ExprConditionalAndOr(OP_OR,first,rest));
  }

  final public void ConditionalAndExpression() throws ParseException {
  int lastMark = markStack();
    InclusiveOrExpression();
    label_28:
    while (true) {
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case SC_AND:
        ;
        break;
      default:
        jj_la1[104] = jj_gen;
        break label_28;
      }
      jj_consume_token(SC_AND);
      InclusiveOrExpression();
    }
    if (handleMultiBase1(lastMark)) stack.push(new ExprConditionalAndOr(OP_AND,first,rest));
  }

  final public void InclusiveOrExpression() throws ParseException {
  int lastMark = markStack();
    ExclusiveOrExpression();
    label_29:
    while (true) {
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case BIT_OR:
        ;
        break;
      default:
        jj_la1[105] = jj_gen;
        break label_29;
      }
      jj_consume_token(BIT_OR);
      ExclusiveOrExpression();
    }
    if (handleMultiBase1(lastMark)) stack.push(new ExprAndOrXor(OP_OR,first,rest));
  }

  final public void ExclusiveOrExpression() throws ParseException {
  int lastMark = markStack();
    AndExpression();
    label_30:
    while (true) {
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case XOR:
        ;
        break;
      default:
        jj_la1[106] = jj_gen;
        break label_30;
      }
      jj_consume_token(XOR);
      AndExpression();
    }
    if (handleMultiBase1(lastMark)) stack.push(new ExprAndOrXor(OP_XOR,first,rest));
  }

  final public void AndExpression() throws ParseException {
  int lastMark = markStack();
    EqualityExpression();
    label_31:
    while (true) {
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case BIT_AND:
        ;
        break;
      default:
        jj_la1[107] = jj_gen;
        break label_31;
      }
      jj_consume_token(BIT_AND);
      EqualityExpression();
    }
    if (handleMultiBase1(lastMark)) stack.push(new ExprAndOrXor(OP_AND,first,rest) );
  }

  final public void EqualityExpression() throws ParseException {
  int lastMark = markStack();
    RelationalExpression();
    label_32:
    while (true) {
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case EQ:
      case EQ_:
      case NE:
      case NE_:
        ;
        break;
      default:
        jj_la1[108] = jj_gen;
        break label_32;
      }
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case EQ:
      case EQ_:
        switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
        case EQ:
          jj_consume_token(EQ);
          break;
        case EQ_:
          jj_consume_token(EQ_);
          break;
        default:
          jj_la1[109] = jj_gen;
          jj_consume_token(-1);
          throw new ParseException();
        }
                             stack.push(new Integer(OP_EQ));
        break;
      case NE:
      case NE_:
        switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
        case NE:
          jj_consume_token(NE);
          break;
        case NE_:
          jj_consume_token(NE_);
          break;
        default:
          jj_la1[110] = jj_gen;
          jj_consume_token(-1);
          throw new ParseException();
        }
                             stack.push(new Integer(OP_NE));
        break;
      default:
        jj_la1[111] = jj_gen;
        jj_consume_token(-1);
        throw new ParseException();
      }
      RelationalExpression();
    }
    if (handleMultiBase(lastMark)) stack.push(new ExprRelational(first,ops,rest));
  }

  final public void RelationalExpression() throws ParseException {
  int lastMark = markStack();
    ShiftExpression();
    label_33:
    while (true) {
      if (jj_2_24(2)) {
        ;
      } else {
        break label_33;
      }
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case LT:
        jj_consume_token(LT);
                 stack.push(new Integer(OP_LT));
        break;
      case GT:
        jj_consume_token(GT);
                 stack.push(new Integer(OP_GT));
        break;
      case LE:
        jj_consume_token(LE);
                 stack.push(new Integer(OP_LE));
        break;
      case GE:
        jj_consume_token(GE);
                 stack.push(new Integer(OP_GE));
        break;
      default:
        jj_la1[112] = jj_gen;
        jj_consume_token(-1);
        throw new ParseException();
      }
      ShiftExpression();
    }
    if (handleMultiBase(lastMark)) stack.push(new ExprRelational(first,ops,rest));
  }

  final public void ShiftExpression() throws ParseException {
  int op = 0;
  int lastMark = markStack();
    AdditiveExpression();
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case LSHIFT:
    case RSIGNEDSHIFT:
    case RUNSIGNEDSHIFT:
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case LSHIFT:
        jj_consume_token(LSHIFT);
                 op = OP_LSHIFT;
        break;
      case RSIGNEDSHIFT:
        jj_consume_token(RSIGNEDSHIFT);
                 op = OP_RSHIFT;
        break;
      case RUNSIGNEDSHIFT:
        jj_consume_token(RUNSIGNEDSHIFT);
                 op = OP_RUSHIFT;
        break;
      default:
        jj_la1[113] = jj_gen;
        jj_consume_token(-1);
        throw new ParseException();
      }
      AdditiveExpression();
      break;
    default:
      jj_la1[114] = jj_gen;
      ;
    }
    if (countOnStack(lastMark) == 2) {
      Expr rhs = (Expr)stack.pop();
      stack.push(new ExprShift((Expr)stack.pop(),op,rhs));
    }
  }

  final public void AdditiveExpression() throws ParseException {
  int lastMark = markStack();
    MultiplicativeExpression();
    label_34:
    while (true) {
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case PLUS:
      case MINUS:
        ;
        break;
      default:
        jj_la1[115] = jj_gen;
        break label_34;
      }
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case PLUS:
        jj_consume_token(PLUS);
                 stack.push(new Integer(OP_PLUS));
        break;
      case MINUS:
        jj_consume_token(MINUS);
                 stack.push(new Integer(OP_MINUS));
        break;
      default:
        jj_la1[116] = jj_gen;
        jj_consume_token(-1);
        throw new ParseException();
      }
      MultiplicativeExpression();
    }
    if (handleMultiBase(lastMark)) stack.push( new ExprAddMinus(first, ops, rest) );
  }

  final public void MultiplicativeExpression() throws ParseException {
  int lastMark = markStack();
    PowerExpression();
    label_35:
    while (true) {
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case STAR:
      case SLASH:
      case REM:
        ;
        break;
      default:
        jj_la1[117] = jj_gen;
        break label_35;
      }
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case STAR:
        jj_consume_token(STAR);
                 stack.push(new Integer(OP_MUL));
        break;
      case SLASH:
        jj_consume_token(SLASH);
                 stack.push(new Integer(OP_DIV));
        break;
      case REM:
        jj_consume_token(REM);
                 stack.push(new Integer(OP_MOD));
        break;
      default:
        jj_la1[118] = jj_gen;
        jj_consume_token(-1);
        throw new ParseException();
      }
      PowerExpression();
    }
    if (handleMultiBase(lastMark)) stack.push(new ExprMulDivMod(first, ops, rest));
  }

  final public void PowerExpression() throws ParseException {
    UnaryExpression();
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case STARSTAR:
      jj_consume_token(STARSTAR);
      UnaryExpression();
                              Expr x=reduceIt(); stack.push(new ExprPower(reduceIt(), x));
      break;
    default:
      jj_la1[119] = jj_gen;
      ;
    }
  }

  final public void UnaryExpression() throws ParseException {
  int op = OP_PLUS;
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case PLUS:
    case MINUS:
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case PLUS:
        jj_consume_token(PLUS);
        break;
      case MINUS:
        jj_consume_token(MINUS);
                op=OP_MINUS;
        break;
      default:
        jj_la1[120] = jj_gen;
        jj_consume_token(-1);
        throw new ParseException();
      }
      UnaryExpression();
    if (op==OP_MINUS) stack.push(new ExprNegate((Expr)stack.pop()));
      break;
    case INCR:
    case DECR:
      PrefixExpression();
      break;
    case JAVA__:
    case _EOF:
    case __EOF:
    case AS:
    case ELIF:
    case EXTENDSJAVA:
    case FALSE:
    case JAVACLASS:
    case IFDEF:
    case IFNDEF:
    case IFEXISTS:
    case IN:
    case INFINITY:
    case INTO:
    case NEW:
    case JAVANEW:
    case MAX_NUMBER:
    case MIN_NUMBER:
    case NULL:
    case LIMIT:
    case NAMESPACE:
    case _SKIP:
    case SUPER:
    case THIS:
    case TRUE:
    case UNDEFINED:
    case BOOLEAN:
    case BYTE:
    case CHAR:
    case SHORT:
    case INT:
    case LONG:
    case FLOAT:
    case DOUBLE:
    case MAIL__CONNECT:
    case MAIL__DISCONNECT:
    case CC:
    case BCC:
    case ATTACH:
    case SUBJECT:
    case BODY:
    case HTMLBODY:
    case DATE_:
    case DATE:
    case NUMBER:
    case COLUMN:
    case ERR:
    case LOG:
    case NL:
    case OUT:
    case PIPE:
    case INPUT:
    case OUTPUT:
    case NEEDSYSTEMIN:
    case MANIFEST:
    case EXCEPT:
    case SETFILETIME:
    case SETREADONLY:
    case SETREADWRITE:
    case TARGET:
    case DB__DISCONNECT:
    case HIB__ADDCLASS:
    case HIB__ADDRESOURCE:
    case HIB__CLOSE:
    case HIB__TXBEGIN:
    case HIB__TXEND:
    case HIB__TXABORT:
    case HIB__LOCK:
    case HIB__DELETE:
    case HIB__GET:
    case HIB__SAVE:
    case HIB__SAVEORUPDATECOPY:
    case HIB__UNLOCK:
    case HIB__UPDATE:
    case AFTER:
    case STARTING:
    case XML:
    case SYSTEMID:
    case OUTPUTPROPERTIES:
    case PARAMETERS:
    case XMLNS:
    case INTEGER_LITERAL:
    case FLOATING_POINT_LITERAL:
    case STRING_LITERAL:
    case IDENTIFIER:
    case CONST_NAME:
    case BANG:
    case TILDE:
    case COLONCOLON:
    case BIT_AND:
    case DOLLARLBRACE:
    case LPAREN:
      UnaryExpressionNotPlusMinus();
      break;
    default:
      jj_la1[121] = jj_gen;
      jj_consume_token(-1);
      throw new ParseException();
    }
  }

  final public void PrefixExpression() throws ParseException {
  int op = OP_PLUS_ASSIGN;
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case INCR:
      jj_consume_token(INCR);
      break;
    case DECR:
      jj_consume_token(DECR);
                  op=OP_MINUS_ASSIGN;
      break;
    default:
      jj_la1[122] = jj_gen;
      jj_consume_token(-1);
      throw new ParseException();
    }
    PrimaryExpression(false);
    stack.push( new ExprAssign(lineNum(), (ExprPrimary)stack.pop(), op, ConstInt.ONE) );
  }

  final public void UnaryExpressionNotPlusMinus() throws ParseException {
  boolean isNot = false;
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case BANG:
    case TILDE:
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case TILDE:
        jj_consume_token(TILDE);
        break;
      case BANG:
        jj_consume_token(BANG);
                isNot = true;
        break;
      default:
        jj_la1[123] = jj_gen;
        jj_consume_token(-1);
        throw new ParseException();
      }
      UnaryExpression();
    Expr e = reduceIt();
    stack.push(isNot ? (Expr)new ExprNot(e) : new ExprComplement(e) );
      break;
    default:
      jj_la1[124] = jj_gen;
      if (jj_2_25(2)) {
        PostfixExpression();
      } else {
        switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
        case _EOF:
        case __EOF:
        case FALSE:
        case INFINITY:
        case MAX_NUMBER:
        case MIN_NUMBER:
        case NULL:
        case TRUE:
        case UNDEFINED:
        case NL:
        case INTEGER_LITERAL:
        case FLOATING_POINT_LITERAL:
        case STRING_LITERAL:
          Literal();
          break;
        default:
          jj_la1[125] = jj_gen;
          jj_consume_token(-1);
          throw new ParseException();
        }
      }
    }
  }

  final public void PostfixExpression() throws ParseException {
  int op = 0;
    PrimaryExpression(false);
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case INCR:
    case DECR:
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case INCR:
        jj_consume_token(INCR);
                                    op=OP_PLUS_ASSIGN;
        break;
      case DECR:
        jj_consume_token(DECR);
                                                                  op=OP_MINUS_ASSIGN;
        break;
      default:
        jj_la1[126] = jj_gen;
        jj_consume_token(-1);
        throw new ParseException();
      }
      break;
    default:
      jj_la1[127] = jj_gen;
      ;
    }
    if (op == 0)
      stack.push(reduceIt());
    else
      stack.push( new ExprPostInc(lineNum(), (ExprPrimary)stack.pop(), op) );
  }

  final public void PrimaryExpression(boolean left) throws ParseException {
  String x;
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case BIT_AND:
      jj_consume_token(BIT_AND);
      AnyName();
                       stack.push( new AccessFunction(token.image) );
      break;
    default:
      jj_la1[129] = jj_gen;
      if (jj_2_26(2)) {
        JavaAllocator();
      } else if (jj_2_27(2)) {
        ObjectAllocator();
      } else {
        switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
        case NEW:
          ComAllocator();
          break;
        case JAVA__:
        case JAVACLASS:
          switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
          case JAVA__:
            jj_consume_token(JAVA__);
            break;
          case JAVACLASS:
            jj_consume_token(JAVACLASS);
                             upgradeMsg("java::");
            break;
          default:
            jj_la1[128] = jj_gen;
            jj_consume_token(-1);
            throw new ParseException();
          }
          x = JavaClassName();
                       stack.push( newJava(new ConstString(x), lineNum()) );
          break;
        case AS:
        case ELIF:
        case EXTENDSJAVA:
        case IFDEF:
        case IFNDEF:
        case IFEXISTS:
        case IN:
        case INTO:
        case LIMIT:
        case NAMESPACE:
        case _SKIP:
        case SUPER:
        case THIS:
        case BOOLEAN:
        case BYTE:
        case CHAR:
        case SHORT:
        case INT:
        case LONG:
        case FLOAT:
        case DOUBLE:
        case MAIL__CONNECT:
        case MAIL__DISCONNECT:
        case CC:
        case BCC:
        case ATTACH:
        case SUBJECT:
        case BODY:
        case HTMLBODY:
        case DATE_:
        case DATE:
        case NUMBER:
        case COLUMN:
        case ERR:
        case LOG:
        case OUT:
        case PIPE:
        case INPUT:
        case OUTPUT:
        case NEEDSYSTEMIN:
        case MANIFEST:
        case EXCEPT:
        case SETFILETIME:
        case SETREADONLY:
        case SETREADWRITE:
        case TARGET:
        case DB__DISCONNECT:
        case HIB__ADDCLASS:
        case HIB__ADDRESOURCE:
        case HIB__CLOSE:
        case HIB__TXBEGIN:
        case HIB__TXEND:
        case HIB__TXABORT:
        case HIB__LOCK:
        case HIB__DELETE:
        case HIB__GET:
        case HIB__SAVE:
        case HIB__SAVEORUPDATECOPY:
        case HIB__UNLOCK:
        case HIB__UPDATE:
        case AFTER:
        case STARTING:
        case XML:
        case SYSTEMID:
        case OUTPUTPROPERTIES:
        case PARAMETERS:
        case XMLNS:
        case STRING_LITERAL:
        case IDENTIFIER:
        case CONST_NAME:
        case COLONCOLON:
        case DOLLARLBRACE:
        case LPAREN:
          PrimarySimpleExpression(left);
          break;
        default:
          jj_la1[130] = jj_gen;
          jj_consume_token(-1);
          throw new ParseException();
        }
      }
    }
  }

  final public void PrimarySimpleExpression(boolean left) throws ParseException {
  int lastMark = markStack();
  boolean isJavaRef = false;
  boolean b;
  String x;
    PrimaryPrefix();
    label_36:
    while (true) {
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case SINGLE_ARROW:
      case COLONCOLON:
      case LPAREN:
      case LBRACKET:
      case DOT:
        ;
        break;
      default:
        jj_la1[131] = jj_gen;
        break label_36;
      }
      b = PrimarySuffix(left);
                                            isJavaRef|=b;
    }
    Object[] oa = handleAny(lastMark);
    //checkMemberAccess(oa);
    if (isJavaRef) {
      StringBuffer sb = new StringBuffer();
      int i=0;
      for (; i<oa.length; i++) {
        if (oa[i].equals("::")) break; // guaranteed
        if (!(oa[i] instanceof String) || oa[i].toString().startsWith("#"))
          throwParseException("Invalid Java class name is used to reference a Java static member.");
        if (i>0) sb.append('.');
        sb.append(oa[i]);
      }
      Object[] oa1 = new Object[oa.length - i];
//      oa1[0] = newJava(toVariable(script.handleClassName(sb.toString())), lineNum());
      oa1[0] = newJava(toVariable(sb.toString()), lineNum());
      System.arraycopy(oa, i+1, oa1, 1, oa1.length-1);
      oa = oa1;
    }
    if (oa.length==1 && (oa[0] instanceof Expr)) {
      stack.push(oa[0]);
      {if (true) return;}
    } else if (oa.length==1 && (oa[0] instanceof String) && left) {
      x = (String)oa[0];
      if (x.startsWith("$$"))
        throwParseException(x + " can not be assigned.");
    }
    stack.push(new ExprPrimary(oa));
  }

  final public void PrimaryPrefix() throws ParseException {
  String x = "";
  boolean global = false;
    if (jj_2_28(2)) {
      jj_consume_token(COLUMN);
      jj_consume_token(LPAREN);
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case STRING_LITERAL:
        jj_consume_token(STRING_LITERAL);
                                stack.push( new ExprColumn(unquote(token.image)) );
        break;
      case INTEGER_LITERAL:
        jj_consume_token(INTEGER_LITERAL);
                                stack.push( new ExprColumn((int)toLong(token)) );
        break;
      default:
        jj_la1[132] = jj_gen;
        jj_consume_token(-1);
        throw new ParseException();
      }
      jj_consume_token(RPAREN);
    } else {
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case CONST_NAME:
        jj_consume_token(CONST_NAME);
                                stack.push(token.image);
        break;
      case DATE_:
      case DATE:
        upgradeToDate();
                                stack.push("Date");
        break;
      case SUPER:
        jj_consume_token(SUPER);
        jj_consume_token(DOT);
        AnyName();
                                if (!inClassDef) throwParseException("'super' can not be used here.");
                                stack.push(".." + token.image);
                                if (inJavax) superCalls.add(token.image);
        break;
      case THIS:
        jj_consume_token(THIS);
                                if (!inClassDef) throwParseException("'this' can not be used here.");
                                stack.push(new AccessThis());
        break;
      case LPAREN:
        jj_consume_token(LPAREN);
        Expression();
        jj_consume_token(RPAREN);
        break;
      case DOLLARLBRACE:
        jj_consume_token(DOLLARLBRACE);
        switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
        case _USAGE:
        case ENDSCRIPT:
        case _EOF:
        case __EOF:
        case AS:
        case BREAK:
        case CASE:
        case CATCH:
        case CONST:
        case CONTINUE:
        case CONSTRUCTOR:
        case CTOR:
        case _DEFAULT:
        case CLASS:
        case DEFINED:
        case DELETE:
        case DO:
        case ELIF:
        case ELSE:
        case EXEC:
        case EXTENDS:
        case EXTENDSJAVA:
        case FALSE:
        case FINALLY:
        case FOR:
        case FROM:
        case FUNCTION:
        case LAMBDA:
        case THREAD:
        case JAVACLASS:
        case IF:
        case IFDEF:
        case IFNDEF:
        case IFEXISTS:
        case IMPORT:
        case IN:
        case INFINITY:
        case INTO:
        case LOCAL:
        case NEW:
        case MAX_NUMBER:
        case MIN_NUMBER:
        case NULL:
        case LIMIT:
        case NAMESPACE:
        case _SKIP:
        case RESUME:
        case RETURN:
        case STRIP:
        case SUPER:
        case SWITCH:
        case THIS:
        case THROW:
        case TO:
        case UPTO:
        case TYPEOF:
        case ATTRIBUTESOF:
        case ON:
        case DOWNTO:
        case TRUE:
        case TRY:
        case UNDER:
        case UNDEFINED:
        case USING:
        case USE:
        case VAR:
        case WHERE:
        case WHILE:
        case WITH:
        case BOOLEAN:
        case BYTE:
        case CHAR:
        case SHORT:
        case INT:
        case LONG:
        case FLOAT:
        case DOUBLE:
        case STRING:
        case STRING_:
        case VOID:
        case CC:
        case BCC:
        case ATTACH:
        case SUBJECT:
        case BODY:
        case HTMLBODY:
        case LINKEDLIST_:
        case LINKEDLIST:
        case SET_:
        case SET:
        case SORTEDMAP_:
        case SORTEDMAP:
        case DATE_:
        case DATE:
        case NUMBER_:
        case NUMBER:
        case COLUMN:
        case ERR:
        case LOG:
        case OUT:
        case PIPE:
        case INPUT:
        case OUTPUT:
        case NEEDSYSTEMIN:
        case FLUSH:
        case PRINT:
        case PRINTLN:
        case PRINTTABLE:
        case PRINTTABLEDATA:
        case SCP:
        case COPY:
        case MANIFEST:
        case LIST:
        case LS:
        case ORDERED:
        case BY:
        case RMDIR:
        case EXCEPT:
        case SETFILETIME:
        case SETREADONLY:
        case SETREADWRITE:
        case TARGET:
        case EJBQL:
        case AFTER:
        case REPEAT:
        case SCHEDULE:
        case STARTING:
        case XML:
        case XSLT:
        case XPATH:
        case SYSTEMID:
        case OUTPUTPROPERTIES:
        case PARAMETERS:
        case DOM:
        case XMLNS:
        case HTML:
        case JSP:
        case SGML:
        case IDENTIFIER:
        case COLONCOLON:
          switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
          case COLONCOLON:
            jj_consume_token(COLONCOLON);
             global = true;
            break;
          default:
            jj_la1[133] = jj_gen;
            ;
          }
          AnyName();
                                x = token.image;
          label_37:
          while (true) {
            switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
            case DOT:
              ;
              break;
            default:
              jj_la1[134] = jj_gen;
              break label_37;
            }
            jj_consume_token(DOT);
            AnyName();
                                x += "." + token.image;
          }
          break;
        case TILDE:
        case COLON:
        case SLASH:
        case DOT:
          switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
          case TILDE:
            jj_consume_token(TILDE);
            break;
          case DOT:
            jj_consume_token(DOT);
            break;
          case COLON:
            jj_consume_token(COLON);
            break;
          case SLASH:
            jj_consume_token(SLASH);
            break;
          default:
            jj_la1[135] = jj_gen;
            jj_consume_token(-1);
            throw new ParseException();
          }
                                x = token.image;
          break;
        default:
          jj_la1[136] = jj_gen;
          jj_consume_token(-1);
          throw new ParseException();
        }
        stack.push(new AccessVar(x, global ? AccessVar.ACCESS_GLOBAL : AccessVar.ACCESS_VAR_ENV));
        jj_consume_token(RBRACE);
        break;
      case BOOLEAN:
      case BYTE:
      case CHAR:
      case SHORT:
      case INT:
      case LONG:
      case FLOAT:
      case DOUBLE:
        switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
        case BOOLEAN:
          jj_consume_token(BOOLEAN);
          break;
        case BYTE:
          jj_consume_token(BYTE);
          break;
        case CHAR:
          jj_consume_token(CHAR);
          break;
        case SHORT:
          jj_consume_token(SHORT);
          break;
        case INT:
          jj_consume_token(INT);
          break;
        case LONG:
          jj_consume_token(LONG);
          break;
        case FLOAT:
          jj_consume_token(FLOAT);
          break;
        case DOUBLE:
          jj_consume_token(DOUBLE);
          break;
        default:
          jj_la1[137] = jj_gen;
          jj_consume_token(-1);
          throw new ParseException();
        }
                                                                      stack.push(token.image);
        jj_consume_token(LPAREN);
        Expression();
        jj_consume_token(RPAREN);
                                Object[] ea = new Object[] { stack.pop(), JavaObject.JAVA_ANY_I };
                                stack.push(new Arguments(this, ea, false));
        break;
      default:
        jj_la1[140] = jj_gen;
        if (jj_2_29(2147483647)) {
          LabelName();
                                x = token.image;
          label_38:
          while (true) {
            switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
            case DOT:
              ;
              break;
            default:
              jj_la1[138] = jj_gen;
              break label_38;
            }
            jj_consume_token(DOT);
            AnyName();
                                x += "." + token.image;
          }
          jj_consume_token(COLONCOLON);
          AnyName();
                                stack.push(x + "::" + token.image);
        } else {
          switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
          case AS:
          case ELIF:
          case EXTENDSJAVA:
          case IFDEF:
          case IFNDEF:
          case IFEXISTS:
          case IN:
          case INTO:
          case LIMIT:
          case NAMESPACE:
          case _SKIP:
          case MAIL__CONNECT:
          case MAIL__DISCONNECT:
          case CC:
          case BCC:
          case ATTACH:
          case SUBJECT:
          case BODY:
          case HTMLBODY:
          case NUMBER:
          case COLUMN:
          case ERR:
          case LOG:
          case OUT:
          case PIPE:
          case INPUT:
          case OUTPUT:
          case NEEDSYSTEMIN:
          case MANIFEST:
          case EXCEPT:
          case SETFILETIME:
          case SETREADONLY:
          case SETREADWRITE:
          case TARGET:
          case DB__DISCONNECT:
          case HIB__ADDCLASS:
          case HIB__ADDRESOURCE:
          case HIB__CLOSE:
          case HIB__TXBEGIN:
          case HIB__TXEND:
          case HIB__TXABORT:
          case HIB__LOCK:
          case HIB__DELETE:
          case HIB__GET:
          case HIB__SAVE:
          case HIB__SAVEORUPDATECOPY:
          case HIB__UNLOCK:
          case HIB__UPDATE:
          case AFTER:
          case STARTING:
          case XML:
          case SYSTEMID:
          case OUTPUTPROPERTIES:
          case PARAMETERS:
          case XMLNS:
          case IDENTIFIER:
          case COLONCOLON:
            switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
            case COLONCOLON:
              jj_consume_token(COLONCOLON);
                                x = "::";
              break;
            default:
              jj_la1[139] = jj_gen;
              ;
            }
            PotentialFunctionName();
                                x += token.image;
                                stack.push(x);
                                if (!x.startsWith("::") && inJavax) javaxCalls.add(x);
            break;
          case STRING_LITERAL:
            jj_consume_token(STRING_LITERAL);
                                stack.push(JudoUtil.parseString(unquote(token.image)));
            break;
          default:
            jj_la1[141] = jj_gen;
            jj_consume_token(-1);
            throw new ParseException();
          }
        }
      }
    }
  }

  final public boolean PrimarySuffix(boolean left) throws ParseException {
  String s = null;
  boolean ret = false;
  int lastMark = markStack();
  Expr expr = null;
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case LBRACKET:
      jj_consume_token(LBRACKET);
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case COLON:
        jj_consume_token(COLON);
        Expression();
                               if (left)
                                 throwParseException("Range operator is not applicable on the left.");
                               stack.push(new Expr[]{ ConstInt.ZERO, reduceIt() });
        break;
      case JAVA__:
      case _EOF:
      case __EOF:
      case AS:
      case DEFINED:
      case ELIF:
      case EXTENDSJAVA:
      case FALSE:
      case JAVACLASS:
      case IFDEF:
      case IFNDEF:
      case IFEXISTS:
      case IN:
      case INFINITY:
      case INTO:
      case NEW:
      case JAVANEW:
      case MAX_NUMBER:
      case MIN_NUMBER:
      case NULL:
      case LIMIT:
      case NAMESPACE:
      case _SKIP:
      case SUPER:
      case THIS:
      case TYPEOF:
      case ATTRIBUTESOF:
      case TRUE:
      case UNDEFINED:
      case BOOLEAN:
      case BYTE:
      case CHAR:
      case SHORT:
      case INT:
      case LONG:
      case FLOAT:
      case DOUBLE:
      case MAIL__CONNECT:
      case MAIL__DISCONNECT:
      case CC:
      case BCC:
      case ATTACH:
      case SUBJECT:
      case BODY:
      case HTMLBODY:
      case DATE_:
      case DATE:
      case NUMBER:
      case COLUMN:
      case ERR:
      case LOG:
      case NL:
      case OUT:
      case PIPE:
      case INPUT:
      case OUTPUT:
      case NEEDSYSTEMIN:
      case MANIFEST:
      case EXCEPT:
      case SETFILETIME:
      case SETREADONLY:
      case SETREADWRITE:
      case TARGET:
      case DB__DISCONNECT:
      case HIB__ADDCLASS:
      case HIB__ADDRESOURCE:
      case HIB__CLOSE:
      case HIB__TXBEGIN:
      case HIB__TXEND:
      case HIB__TXABORT:
      case HIB__LOCK:
      case HIB__DELETE:
      case HIB__GET:
      case HIB__SAVE:
      case HIB__SAVEORUPDATECOPY:
      case HIB__UNLOCK:
      case HIB__UPDATE:
      case AFTER:
      case STARTING:
      case XML:
      case SYSTEMID:
      case OUTPUTPROPERTIES:
      case PARAMETERS:
      case XMLNS:
      case INTEGER_LITERAL:
      case FLOATING_POINT_LITERAL:
      case STRING_LITERAL:
      case EXEC_RESULT_LITERAL:
      case EXEC_RESULTLINES_LITERAL:
      case IDENTIFIER:
      case CONST_NAME:
      case BANG:
      case TILDE:
      case COLONCOLON:
      case INCR:
      case DECR:
      case PLUS:
      case MINUS:
      case BIT_AND:
      case DOLLARLBRACE:
      case LPAREN:
        Expression();
        switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
        case COLON:
          jj_consume_token(COLON);
          switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
          case JAVA__:
          case _EOF:
          case __EOF:
          case AS:
          case DEFINED:
          case ELIF:
          case EXTENDSJAVA:
          case FALSE:
          case JAVACLASS:
          case IFDEF:
          case IFNDEF:
          case IFEXISTS:
          case IN:
          case INFINITY:
          case INTO:
          case NEW:
          case JAVANEW:
          case MAX_NUMBER:
          case MIN_NUMBER:
          case NULL:
          case LIMIT:
          case NAMESPACE:
          case _SKIP:
          case SUPER:
          case THIS:
          case TYPEOF:
          case ATTRIBUTESOF:
          case TRUE:
          case UNDEFINED:
          case BOOLEAN:
          case BYTE:
          case CHAR:
          case SHORT:
          case INT:
          case LONG:
          case FLOAT:
          case DOUBLE:
          case MAIL__CONNECT:
          case MAIL__DISCONNECT:
          case CC:
          case BCC:
          case ATTACH:
          case SUBJECT:
          case BODY:
          case HTMLBODY:
          case DATE_:
          case DATE:
          case NUMBER:
          case COLUMN:
          case ERR:
          case LOG:
          case NL:
          case OUT:
          case PIPE:
          case INPUT:
          case OUTPUT:
          case NEEDSYSTEMIN:
          case MANIFEST:
          case EXCEPT:
          case SETFILETIME:
          case SETREADONLY:
          case SETREADWRITE:
          case TARGET:
          case DB__DISCONNECT:
          case HIB__ADDCLASS:
          case HIB__ADDRESOURCE:
          case HIB__CLOSE:
          case HIB__TXBEGIN:
          case HIB__TXEND:
          case HIB__TXABORT:
          case HIB__LOCK:
          case HIB__DELETE:
          case HIB__GET:
          case HIB__SAVE:
          case HIB__SAVEORUPDATECOPY:
          case HIB__UNLOCK:
          case HIB__UPDATE:
          case AFTER:
          case STARTING:
          case XML:
          case SYSTEMID:
          case OUTPUTPROPERTIES:
          case PARAMETERS:
          case XMLNS:
          case INTEGER_LITERAL:
          case FLOATING_POINT_LITERAL:
          case STRING_LITERAL:
          case EXEC_RESULT_LITERAL:
          case EXEC_RESULTLINES_LITERAL:
          case IDENTIFIER:
          case CONST_NAME:
          case BANG:
          case TILDE:
          case COLONCOLON:
          case INCR:
          case DECR:
          case PLUS:
          case MINUS:
          case BIT_AND:
          case DOLLARLBRACE:
          case LPAREN:
            Expression();
                             expr = reduceIt();
            break;
          default:
            jj_la1[142] = jj_gen;
            ;
          }
                               if (left)
                                 throwParseException("Range operator is not applicable on the left.");
                               if (expr == null)
                                 expr = ConstInt.MAX;
                               stack.push(new Expr[]{ reduceIt(), expr });
          break;
        default:
          jj_la1[144] = jj_gen;
          label_39:
          while (true) {
            switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
            case COMMA:
              ;
              break;
            default:
              jj_la1[143] = jj_gen;
              break label_39;
            }
            jj_consume_token(COMMA);
            Expression();
          }
        }
        break;
      default:
        jj_la1[145] = jj_gen;
        jj_consume_token(-1);
        throw new ParseException();
      }
      jj_consume_token(RBRACKET);
      break;
    case COLONCOLON:
    case DOT:
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case DOT:
        jj_consume_token(DOT);
        break;
      case COLONCOLON:
        jj_consume_token(COLONCOLON);
                               stack.push("::"); ret = true;
        break;
      default:
        jj_la1[146] = jj_gen;
        jj_consume_token(-1);
        throw new ParseException();
      }
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case _USAGE:
      case ENDSCRIPT:
      case _EOF:
      case __EOF:
      case AS:
      case BREAK:
      case CASE:
      case CATCH:
      case CONST:
      case CONTINUE:
      case CONSTRUCTOR:
      case CTOR:
      case _DEFAULT:
      case CLASS:
      case DEFINED:
      case DELETE:
      case DO:
      case ELIF:
      case ELSE:
      case EXEC:
      case EXTENDS:
      case EXTENDSJAVA:
      case FALSE:
      case FINALLY:
      case FOR:
      case FROM:
      case FUNCTION:
      case LAMBDA:
      case THREAD:
      case JAVACLASS:
      case IF:
      case IFDEF:
      case IFNDEF:
      case IFEXISTS:
      case IMPORT:
      case IN:
      case INFINITY:
      case INTO:
      case LOCAL:
      case NEW:
      case MAX_NUMBER:
      case MIN_NUMBER:
      case NULL:
      case LIMIT:
      case NAMESPACE:
      case _SKIP:
      case RESUME:
      case RETURN:
      case STRIP:
      case SUPER:
      case SWITCH:
      case THIS:
      case THROW:
      case TO:
      case UPTO:
      case TYPEOF:
      case ATTRIBUTESOF:
      case ON:
      case DOWNTO:
      case TRUE:
      case TRY:
      case UNDER:
      case UNDEFINED:
      case USING:
      case USE:
      case VAR:
      case WHERE:
      case WHILE:
      case WITH:
      case BOOLEAN:
      case BYTE:
      case CHAR:
      case SHORT:
      case INT:
      case LONG:
      case FLOAT:
      case DOUBLE:
      case STRING:
      case STRING_:
      case VOID:
      case CC:
      case BCC:
      case ATTACH:
      case SUBJECT:
      case BODY:
      case HTMLBODY:
      case LINKEDLIST_:
      case LINKEDLIST:
      case SET_:
      case SET:
      case SORTEDMAP_:
      case SORTEDMAP:
      case DATE_:
      case DATE:
      case NUMBER_:
      case NUMBER:
      case COLUMN:
      case ERR:
      case LOG:
      case OUT:
      case PIPE:
      case INPUT:
      case OUTPUT:
      case NEEDSYSTEMIN:
      case FLUSH:
      case PRINT:
      case PRINTLN:
      case PRINTTABLE:
      case PRINTTABLEDATA:
      case SCP:
      case COPY:
      case MANIFEST:
      case LIST:
      case LS:
      case ORDERED:
      case BY:
      case RMDIR:
      case EXCEPT:
      case SETFILETIME:
      case SETREADONLY:
      case SETREADWRITE:
      case TARGET:
      case EJBQL:
      case AFTER:
      case REPEAT:
      case SCHEDULE:
      case STARTING:
      case XML:
      case XSLT:
      case XPATH:
      case SYSTEMID:
      case OUTPUTPROPERTIES:
      case PARAMETERS:
      case DOM:
      case XMLNS:
      case HTML:
      case JSP:
      case SGML:
      case IDENTIFIER:
        AnyName();
                               stack.push(token.image);
                               if (inJavax) javaxCalls.add(token.image);
        break;
      case STRING_LITERAL:
        jj_consume_token(STRING_LITERAL);
                               stack.push(unquote(token.image));
        break;
      case LPAREN:
        jj_consume_token(LPAREN);
        Expression();
        jj_consume_token(RPAREN);
                               stack.push(new ExprPrimary.AccessExpr(reduceIt()));
        break;
      case LT:
        jj_consume_token(LT);
        AnyName();
                               s = token.image;
        switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
        case COLON:
          jj_consume_token(COLON);
          AnyName();
                               s = token.image + "+" + s;
          break;
        default:
          jj_la1[147] = jj_gen;
          ;
        }
        jj_consume_token(GT);
                               stack.push(NODE_PREFIX + s);
        break;
      default:
        jj_la1[148] = jj_gen;
        jj_consume_token(-1);
        throw new ParseException();
      }
      break;
    default:
      jj_la1[150] = jj_gen;
      if (jj_2_30(2147483647)) {
        MemberInitList();
                               stack.push(handleNamedExprs(lastMark));
      } else {
        switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
        case SINGLE_ARROW:
        case LPAREN:
          switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
          case SINGLE_ARROW:
            jj_consume_token(SINGLE_ARROW);
                               stack.push("->");
            break;
          default:
            jj_la1[149] = jj_gen;
            ;
          }
          Arguments(null,0);
          break;
        default:
          jj_la1[151] = jj_gen;
          jj_consume_token(-1);
          throw new ParseException();
        }
      }
    }
                               {if (true) return ret;}
    throw new Error("Missing return statement in function");
  }

  final public void Literal() throws ParseException {
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case INTEGER_LITERAL:
      jj_consume_token(INTEGER_LITERAL);
                               stack.push( toConstInt(token));
      break;
    case FLOATING_POINT_LITERAL:
      jj_consume_token(FLOATING_POINT_LITERAL);
                               stack.push( new ConstDouble(toDouble(token)) );
      break;
    case STRING_LITERAL:
      jj_consume_token(STRING_LITERAL);
                               stack.push( JudoUtil.parseString(unquote(token.image)) );
      break;
    case FALSE:
    case TRUE:
      BooleanLiteral();
      break;
    case NULL:
      jj_consume_token(NULL);
                               stack.push(ValueSpecial.NIL);
      break;
    case UNDEFINED:
      jj_consume_token(UNDEFINED);
                               stack.push(ValueSpecial.UNDEFINED);
      break;
    case MAX_NUMBER:
      jj_consume_token(MAX_NUMBER);
                               stack.push(ValueSpecial.MAX_NUMBER);
      break;
    case MIN_NUMBER:
      jj_consume_token(MIN_NUMBER);
                               stack.push(ValueSpecial.MIN_NUMBER);
      break;
    case INFINITY:
      jj_consume_token(INFINITY);
                               stack.push(ValueSpecial.POSITIVE_INFINITY);
      break;
    case _EOF:
    case __EOF:
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case _EOF:
        jj_consume_token(_EOF);
        break;
      case __EOF:
        jj_consume_token(__EOF);
        break;
      default:
        jj_la1[152] = jj_gen;
        jj_consume_token(-1);
        throw new ParseException();
      }
                               stack.push(ConstString.EOF);
      break;
    case NL:
      jj_consume_token(NL);
                               stack.push(ConstString.NL);
      break;
    default:
      jj_la1[153] = jj_gen;
      jj_consume_token(-1);
      throw new ParseException();
    }
  }

  final public void BooleanLiteral() throws ParseException {
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case TRUE:
      jj_consume_token(TRUE);
      break;
    case FALSE:
      jj_consume_token(FALSE);
      break;
    default:
      jj_la1[154] = jj_gen;
      jj_consume_token(-1);
      throw new ParseException();
    }
                               stack.push( token.image.charAt(0)=='t' ? ConstInt.TRUE : ConstInt.FALSE );
  }

  final public void Arguments(Expr firstParam, int type) throws ParseException {
  boolean paramsExpand = false;
    jj_consume_token(LPAREN);
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case LLBRACE:
      jj_consume_token(LLBRACE);
               paramsExpand=true;
      break;
    default:
      jj_la1[155] = jj_gen;
      ;
    }
    ArgumentList(firstParam,type,paramsExpand);
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case RRBRACE:
      jj_consume_token(RRBRACE);
      break;
    default:
      jj_la1[156] = jj_gen;
      ;
    }
    jj_consume_token(RPAREN);
  }

  final public void ArgumentList(Expr firstParam, int type, boolean paramsExpand) throws ParseException {
  int lastMark = markStack();
  if (firstParam != null) {
    stack.push(firstParam);
    stack.push(new Integer(type));
  }
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case JAVA__:
    case XML__:
    case _EOF:
    case __EOF:
    case AS:
    case DEFINED:
    case DO:
    case ELIF:
    case EXTENDSJAVA:
    case FALSE:
    case FUNCTION:
    case LAMBDA:
    case JAVACLASS:
    case IFDEF:
    case IFNDEF:
    case IFEXISTS:
    case IN:
    case INFINITY:
    case INTO:
    case NEW:
    case JAVANEW:
    case MAX_NUMBER:
    case MIN_NUMBER:
    case NULL:
    case LIMIT:
    case NAMESPACE:
    case _SKIP:
    case SUPER:
    case THIS:
    case TYPEOF:
    case ATTRIBUTESOF:
    case TRUE:
    case UNDEFINED:
    case BOOLEAN:
    case BYTE:
    case CHAR:
    case SHORT:
    case INT:
    case LONG:
    case FLOAT:
    case DOUBLE:
    case VOID:
    case MAIL__CONNECT:
    case MAIL__DISCONNECT:
    case CC:
    case BCC:
    case ATTACH:
    case SUBJECT:
    case BODY:
    case HTMLBODY:
    case LINKEDLIST_:
    case LINKEDLIST:
    case SET_:
    case SET:
    case DATE_:
    case DATE:
    case NUMBER:
    case COLUMN:
    case ERR:
    case LOG:
    case NL:
    case OUT:
    case PIPE:
    case INPUT:
    case OUTPUT:
    case NEEDSYSTEMIN:
    case MANIFEST:
    case EXCEPT:
    case SETFILETIME:
    case SETREADONLY:
    case SETREADWRITE:
    case TARGET:
    case DB__DISCONNECT:
    case HIB__ADDCLASS:
    case HIB__ADDRESOURCE:
    case HIB__CLOSE:
    case HIB__TXBEGIN:
    case HIB__TXEND:
    case HIB__TXABORT:
    case HIB__LOCK:
    case HIB__DELETE:
    case HIB__GET:
    case HIB__SAVE:
    case HIB__SAVEORUPDATECOPY:
    case HIB__UNLOCK:
    case HIB__UPDATE:
    case WSDL__:
    case AFTER:
    case STARTING:
    case XML:
    case SYSTEMID:
    case OUTPUTPROPERTIES:
    case PARAMETERS:
    case XMLNS:
    case INTEGER_LITERAL:
    case FLOATING_POINT_LITERAL:
    case STRING_LITERAL:
    case EXEC_RESULT_LITERAL:
    case EXEC_RESULTLINES_LITERAL:
    case IDENTIFIER:
    case CONST_NAME:
    case BANG:
    case TILDE:
    case HEREDOC_BEGIN:
    case HEREDOC_BEGIN_:
    case COLONCOLON:
    case INCR:
    case DECR:
    case PLUS:
    case MINUS:
    case BIT_AND:
    case DOLLARLBRACE:
    case LBRACE:
    case LPAREN:
    case LBRACKET:
      Parameter();
      label_40:
      while (true) {
        switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
        case COMMA:
          ;
          break;
        default:
          jj_la1[157] = jj_gen;
          break label_40;
        }
        jj_consume_token(COMMA);
        Parameter();
      }
      break;
    default:
      jj_la1[158] = jj_gen;
      ;
    }
                                         stack.push(new Arguments(this, handleAny(lastMark),paramsExpand));
  }

  final public void Parameter() throws ParseException {
  Integer jType = JavaObject.JAVA_ANY_I;
    if (jj_2_31(3)) {
      jj_consume_token(LPAREN);
      jType = JavaPrimitiveTypes();
      jj_consume_token(RPAREN);
    } else {
      ;
    }
    ReturnableExpression();
                                                                               stack.push(jType);
  }

  final public Integer JavaPrimitiveTypes() throws ParseException {
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case BOOLEAN:
      jj_consume_token(BOOLEAN);
                      {if (true) return JAVA_BOOLEAN_I;}
      break;
    case BYTE:
      jj_consume_token(BYTE);
                      {if (true) return JAVA_BYTE_I;}
      break;
    case CHAR:
      jj_consume_token(CHAR);
                      {if (true) return JAVA_CHAR_I;}
      break;
    case SHORT:
      jj_consume_token(SHORT);
                      {if (true) return JAVA_SHORT_I;}
      break;
    case INT:
      jj_consume_token(INT);
                      {if (true) return JAVA_INT_I;}
      break;
    case LONG:
      jj_consume_token(LONG);
                      {if (true) return JAVA_LONG_I;}
      break;
    case FLOAT:
      jj_consume_token(FLOAT);
                      {if (true) return JAVA_FLOAT_I;}
      break;
    case DOUBLE:
      jj_consume_token(DOUBLE);
                      {if (true) return JAVA_DOUBLE_I;}
      break;
    case STRING:
    case STRING_:
      upgradeToString();
                      {if (true) return JAVA_STRING_I;}
      break;
    case IDENTIFIER:
      id("currency");
                      {if (true) return JAVA_CURRENCY_I;}
      break;
    default:
      jj_la1[159] = jj_gen;
      jj_consume_token(-1);
      throw new ParseException();
    }
    throw new Error("Missing return statement in function");
  }

/*
 * Statement syntax follows.
 */
  final public void Statement() throws ParseException {
  int lastMark = markStack();
  String s = null;
  int line;
    if (jj_2_34(2)) {
      Block();
    } else {
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case ANTTASK__:
      case JAVA__:
      case _EOF:
      case __EOF:
      case AS:
      case BREAK:
      case CONTINUE:
      case DEFINED:
      case DELETE:
      case DO:
      case ELIF:
      case EXEC:
      case EXTENDSJAVA:
      case FALSE:
      case FOR:
      case JAVACLASS:
      case IF:
      case IFDEF:
      case IFNDEF:
      case IFEXISTS:
      case IMPORT:
      case IN:
      case INFINITY:
      case INTO:
      case INCLUDE:
      case LOCAL:
      case NEW:
      case JAVANEW:
      case MAX_NUMBER:
      case MIN_NUMBER:
      case NULL:
      case PRAGMA:
      case JAVAGUICLASS:
      case JAVABASECLASS:
      case JAVAENTERPRISECLASS:
      case JAVACORBACLASS:
      case JCOMCLASS:
      case JAVAPACKAGES:
      case DEFINEJAVAPACKAGES:
      case LIMIT:
      case NAMESPACE:
      case _SKIP:
      case RESUME:
      case RETURN:
      case SUPER:
      case SWITCH:
      case THIS:
      case THROW:
      case TYPEOF:
      case ATTRIBUTESOF:
      case TRUE:
      case UNDEFINED:
      case USE:
      case VAR:
      case WHILE:
      case WITH:
      case BOOLEAN:
      case BYTE:
      case CHAR:
      case SHORT:
      case INT:
      case LONG:
      case FLOAT:
      case DOUBLE:
      case MAIL__SEND:
      case MAIL__CONNECT:
      case MAIL__DISCONNECT:
      case SENDMAIL:
      case CC:
      case BCC:
      case ATTACH:
      case SUBJECT:
      case BODY:
      case HTMLBODY:
      case DATE_:
      case DATE:
      case NUMBER:
      case COLUMN:
      case ERR:
      case LOG:
      case NL:
      case OUT:
      case PIPE:
      case INPUT:
      case OUTPUT:
      case NEEDSYSTEMIN:
      case FLUSH:
      case PRINT:
      case PRINTLN:
      case PRINTTABLE:
      case PRINTTABLEDATA:
      case SCP:
      case COPY:
      case MANIFEST:
      case LIST:
      case LS:
      case RMDIR:
      case EXCEPT:
      case SETFILETIME:
      case SETREADONLY:
      case SETREADWRITE:
      case TARGET:
      case ADDBATCH:
      case CONNECT:
      case EXECUTEBATCH:
      case EXECUTEQUERY:
      case EXECUTEQUERYCALL:
      case EXECUTEANY:
      case EXECUTESQL:
      case EXECUTEUPDATE:
      case EXECUTEUPDATECALL:
      case PREPARE:
      case PREPARECALL:
      case PREPAREDEXECUTE:
      case PREPAREDEXECUTECALL:
      case PREPAREDEXECUTEQUERY:
      case PREPAREDEXECUTECALLQUERY:
      case PREPAREDEXECUTEUPDATE:
      case PREPAREDEXECUTECALLUPDATE:
      case DB__DUMPTABLE:
      case DB__ADDBATCH:
      case DB__CONNECT:
      case DB__DISCONNECT:
      case DB__BATCH:
      case DB__QUERY:
      case DB__QUERYCALL:
      case DB__ANY:
      case DB__SQL:
      case DB__CALL:
      case DB__UPDATE:
      case DB__UPDATECALL:
      case DB__PREPARE:
      case DB__PREPARECALL:
      case HIB__SETUP:
      case HIB__ADDCLASS:
      case HIB__ADDRESOURCE:
      case HIB__CLOSE:
      case HIB__TXBEGIN:
      case HIB__TXEND:
      case HIB__TXABORT:
      case HIB__LOCK:
      case HIB__QUERY:
      case HIB__ITERATE:
      case HIB__DELETE:
      case HIB__GET:
      case HIB__SAVE:
      case HIB__SAVEORUPDATECOPY:
      case HIB__UNLOCK:
      case HIB__UPDATE:
      case AFTER:
      case REPEAT:
      case SCHEDULE:
      case STARTING:
      case XML:
      case XSLT:
      case SYSTEMID:
      case OUTPUTPROPERTIES:
      case PARAMETERS:
      case XMLNS:
      case GUIEVENTS:
      case GUI__EVENTS:
      case INTEGER_LITERAL:
      case FLOATING_POINT_LITERAL:
      case STRING_LITERAL:
      case EXEC_RESULT_LITERAL:
      case EXEC_RESULTLINES_LITERAL:
      case IDENTIFIER:
      case CONST_NAME:
      case BANG:
      case TILDE:
      case COLONCOLON:
      case INCR:
      case DECR:
      case PLUS:
      case MINUS:
      case BIT_AND:
      case DOLLARLBRACE:
      case LPAREN:
      case DOT:
      case SEMICOLON:
        IndividualStatement();
        break;
      case TRY:
        jj_consume_token(TRY);
                             line = lineNum();
        SimpleBlock(null,true);
        if (jj_2_32(2)) {
          jj_consume_token(CATCH);
          switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
          case IDENTIFIER:
            jj_consume_token(IDENTIFIER);
                                         s=token.image;
            break;
          default:
            jj_la1[160] = jj_gen;
            ;
          }
                                                             stack.push("catch");
          SimpleBlock(null,true);
        } else {
          ;
        }
        if (jj_2_33(2)) {
          jj_consume_token(FINALLY);
                             stack.push("finally");
          SimpleBlock(null,true);
        } else {
          ;
        }
    stack.push(handleBlock(lastMark, s, line));
        break;
      default:
        jj_la1[161] = jj_gen;
        jj_consume_token(-1);
        throw new ParseException();
      }
    }
  }

  final public void IndividualStatement() throws ParseException {
  String name = null;
  String label = null;
  Expr first = null;
  int lastMark = markStack();
  int lineNo = -1;
    if (jj_2_35(3)) {
      StartThreadStatement();
    } else if (jj_2_36(2147483647)) {
      Expression();
      jj_consume_token(SEMICOLON);
    Expr ex = reduceIt();
    if (ex instanceof Stmt) {
      ((Stmt)ex).setLineNumber(lineNum());
      stack.push(ex);
    } else {
      stack.push(new StmtExpr(lineNum(),ex));
    }
    } else if (jj_2_37(2147483647)) {
      PotentialFunctionName();
                                  name = token.image;
      ArgumentList(null,0,false);
                                  handleSimpleCall(name);
      jj_consume_token(SEMICOLON);
    } else if (jj_2_38(2147483647)) {
      PotentialFunctionName();
                                  name = token.image;
      ArgumentList(first,0,false);
                                  handleSimpleCall(name);
      jj_consume_token(SEMICOLON);
    } else if (jj_2_39(2147483647)) {
      PotentialFunctionName();
                                  name = token.image;
      Arguments(first,0);
                                  handleSimpleCall(name);
      jj_consume_token(SEMICOLON);
    } else if (jj_2_40(2)) {
      jj_consume_token(SUPER);
      Arguments(null,0);
    if (!inJavaCtor) throwParseException("'super' can not be used here.");
    stack.push(reduce(new ExprPrimary( new Object[]{"super",stack.pop()} )));
    } else if (jj_2_41(2147483647)) {
      LocalVariableDecl();
    } else if (jj_2_42(2147483647)) {
      MultiAssignment();
    } else if (jj_2_43(2)) {
      Expression();
      jj_consume_token(SEMICOLON);
    Expr ex = reduceIt();
    int line = lineNum();
    if (ex instanceof Stmt) {
      ((Stmt)ex).setLineNumber(line);
      stack.push(ex);
    } else {
      stack.push(new StmtExpr(line, ex));
    }
    } else {
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case SEMICOLON:
        jj_consume_token(SEMICOLON);
                   stack.push(Stmt.NoOp);
        break;
      case BREAK:
        jj_consume_token(BREAK);
                   lineNo = lineNum();
        switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
        case AS:
        case ELIF:
        case EXTENDSJAVA:
        case IFDEF:
        case IFNDEF:
        case IFEXISTS:
        case IN:
        case INTO:
        case LIMIT:
        case NAMESPACE:
        case _SKIP:
        case CC:
        case BCC:
        case ATTACH:
        case SUBJECT:
        case BODY:
        case HTMLBODY:
        case NUMBER:
        case COLUMN:
        case ERR:
        case LOG:
        case OUT:
        case PIPE:
        case INPUT:
        case OUTPUT:
        case NEEDSYSTEMIN:
        case MANIFEST:
        case EXCEPT:
        case SETFILETIME:
        case SETREADONLY:
        case SETREADWRITE:
        case TARGET:
        case AFTER:
        case SCHEDULE:
        case STARTING:
        case XML:
        case SYSTEMID:
        case OUTPUTPROPERTIES:
        case PARAMETERS:
        case XMLNS:
        case IDENTIFIER:
          switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
          case AS:
          case ELIF:
          case EXTENDSJAVA:
          case IFDEF:
          case IFNDEF:
          case IFEXISTS:
          case IN:
          case INTO:
          case LIMIT:
          case NAMESPACE:
          case _SKIP:
          case CC:
          case BCC:
          case ATTACH:
          case SUBJECT:
          case BODY:
          case HTMLBODY:
          case NUMBER:
          case COLUMN:
          case ERR:
          case LOG:
          case OUT:
          case PIPE:
          case INPUT:
          case OUTPUT:
          case NEEDSYSTEMIN:
          case MANIFEST:
          case EXCEPT:
          case SETFILETIME:
          case SETREADONLY:
          case SETREADWRITE:
          case TARGET:
          case AFTER:
          case STARTING:
          case XML:
          case SYSTEMID:
          case OUTPUTPROPERTIES:
          case PARAMETERS:
          case XMLNS:
          case IDENTIFIER:
            LabelName();
                   label = token.image;
            break;
          case SCHEDULE:
            jj_consume_token(SCHEDULE);
                   label = LABEL_SCHEDULE;
            break;
          default:
            jj_la1[162] = jj_gen;
            jj_consume_token(-1);
            throw new ParseException();
          }
          break;
        default:
          jj_la1[163] = jj_gen;
          ;
        }
                   stack.push(new StmtBreakContinueResume(lineNo,label,ExceptionControl.CTL_BREAK));
        jj_consume_token(SEMICOLON);
        break;
      case CONTINUE:
        jj_consume_token(CONTINUE);
                   lineNo = lineNum();
        switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
        case AS:
        case ELIF:
        case EXTENDSJAVA:
        case IFDEF:
        case IFNDEF:
        case IFEXISTS:
        case IN:
        case INTO:
        case LIMIT:
        case NAMESPACE:
        case _SKIP:
        case CC:
        case BCC:
        case ATTACH:
        case SUBJECT:
        case BODY:
        case HTMLBODY:
        case NUMBER:
        case COLUMN:
        case ERR:
        case LOG:
        case OUT:
        case PIPE:
        case INPUT:
        case OUTPUT:
        case NEEDSYSTEMIN:
        case MANIFEST:
        case EXCEPT:
        case SETFILETIME:
        case SETREADONLY:
        case SETREADWRITE:
        case TARGET:
        case AFTER:
        case SCHEDULE:
        case STARTING:
        case XML:
        case SYSTEMID:
        case OUTPUTPROPERTIES:
        case PARAMETERS:
        case XMLNS:
        case IDENTIFIER:
          switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
          case AS:
          case ELIF:
          case EXTENDSJAVA:
          case IFDEF:
          case IFNDEF:
          case IFEXISTS:
          case IN:
          case INTO:
          case LIMIT:
          case NAMESPACE:
          case _SKIP:
          case CC:
          case BCC:
          case ATTACH:
          case SUBJECT:
          case BODY:
          case HTMLBODY:
          case NUMBER:
          case COLUMN:
          case ERR:
          case LOG:
          case OUT:
          case PIPE:
          case INPUT:
          case OUTPUT:
          case NEEDSYSTEMIN:
          case MANIFEST:
          case EXCEPT:
          case SETFILETIME:
          case SETREADONLY:
          case SETREADWRITE:
          case TARGET:
          case AFTER:
          case STARTING:
          case XML:
          case SYSTEMID:
          case OUTPUTPROPERTIES:
          case PARAMETERS:
          case XMLNS:
          case IDENTIFIER:
            LabelName();
                   label = token.image;
            break;
          case SCHEDULE:
            jj_consume_token(SCHEDULE);
                   label = LABEL_SCHEDULE;
            break;
          default:
            jj_la1[164] = jj_gen;
            jj_consume_token(-1);
            throw new ParseException();
          }
          break;
        default:
          jj_la1[165] = jj_gen;
          ;
        }
                   stack.push(new StmtBreakContinueResume(lineNo,label,ExceptionControl.CTL_CONTINUE));
        jj_consume_token(SEMICOLON);
        break;
      case RETURN:
        jj_consume_token(RETURN);
                   lineNo = lineNum();
        switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
        case JAVA__:
        case XML__:
        case _EOF:
        case __EOF:
        case AS:
        case DEFINED:
        case DO:
        case ELIF:
        case EXTENDSJAVA:
        case FALSE:
        case FUNCTION:
        case LAMBDA:
        case JAVACLASS:
        case IFDEF:
        case IFNDEF:
        case IFEXISTS:
        case IN:
        case INFINITY:
        case INTO:
        case NEW:
        case JAVANEW:
        case MAX_NUMBER:
        case MIN_NUMBER:
        case NULL:
        case LIMIT:
        case NAMESPACE:
        case _SKIP:
        case SUPER:
        case THIS:
        case TYPEOF:
        case ATTRIBUTESOF:
        case TRUE:
        case UNDEFINED:
        case BOOLEAN:
        case BYTE:
        case CHAR:
        case SHORT:
        case INT:
        case LONG:
        case FLOAT:
        case DOUBLE:
        case VOID:
        case MAIL__CONNECT:
        case MAIL__DISCONNECT:
        case CC:
        case BCC:
        case ATTACH:
        case SUBJECT:
        case BODY:
        case HTMLBODY:
        case LINKEDLIST_:
        case LINKEDLIST:
        case SET_:
        case SET:
        case DATE_:
        case DATE:
        case NUMBER:
        case COLUMN:
        case ERR:
        case LOG:
        case NL:
        case OUT:
        case PIPE:
        case INPUT:
        case OUTPUT:
        case NEEDSYSTEMIN:
        case MANIFEST:
        case EXCEPT:
        case SETFILETIME:
        case SETREADONLY:
        case SETREADWRITE:
        case TARGET:
        case DB__DISCONNECT:
        case HIB__ADDCLASS:
        case HIB__ADDRESOURCE:
        case HIB__CLOSE:
        case HIB__TXBEGIN:
        case HIB__TXEND:
        case HIB__TXABORT:
        case HIB__LOCK:
        case HIB__DELETE:
        case HIB__GET:
        case HIB__SAVE:
        case HIB__SAVEORUPDATECOPY:
        case HIB__UNLOCK:
        case HIB__UPDATE:
        case WSDL__:
        case AFTER:
        case STARTING:
        case XML:
        case SYSTEMID:
        case OUTPUTPROPERTIES:
        case PARAMETERS:
        case XMLNS:
        case INTEGER_LITERAL:
        case FLOATING_POINT_LITERAL:
        case STRING_LITERAL:
        case EXEC_RESULT_LITERAL:
        case EXEC_RESULTLINES_LITERAL:
        case IDENTIFIER:
        case CONST_NAME:
        case BANG:
        case TILDE:
        case HEREDOC_BEGIN:
        case HEREDOC_BEGIN_:
        case COLONCOLON:
        case INCR:
        case DECR:
        case PLUS:
        case MINUS:
        case BIT_AND:
        case DOLLARLBRACE:
        case LBRACE:
        case LPAREN:
        case LBRACKET:
          ReturnableExpression();
          break;
        default:
          jj_la1[166] = jj_gen;
          ;
        }
        jj_consume_token(SEMICOLON);
                   stack.push( new StmtReturn(lineNo, reduce(handleSingleExpr(lastMark))) );
        break;
      case RESUME:
        jj_consume_token(RESUME);
                   lineNo = lineNum();
        jj_consume_token(SEMICOLON);
                   stack.push(new StmtBreakContinueResume(lineNo,null,ExceptionControl.CTL_RESUME));
        break;
      case DELETE:
        jj_consume_token(DELETE);
                   lineNo = lineNum();
        PrimaryExpression(false);
        jj_consume_token(SEMICOLON);
                                 stack.push( new ExprAssign(lineNum(),(Expr)stack.pop(),ValueSpecial.UNDEFINED) );
        break;
      case WITH:
        jj_consume_token(WITH);
                   lineNo = lineNum();
        Expression();
        Block();
                   stack.push(new StmtWith(lineNo,(BlockSimple)stack.pop(),reduceIt()));
        break;
      default:
        jj_la1[167] = jj_gen;
        if (jj_2_44(2147483647)) {
          XmlStatement();
        } else if (jj_2_45(2147483647)) {
          LinesStatement();
        } else if (jj_2_46(2147483647)) {
          WhileStatement();
        } else if (jj_2_47(2147483647)) {
          ForStatement();
        } else if (jj_2_48(2147483647)) {
          DoWhileStatement();
        } else if (jj_2_49(2147483647)) {
          RepeatStatement();
        } else {
          switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
          case IF:
            IfStatement();
            break;
          case SWITCH:
            SwitchStatement();
            break;
          case THROW:
            ThrowStatement();
            break;
          case EXEC:
            RunStatement();
            break;
          case FLUSH:
          case PRINT:
          case PRINTLN:
          case DOT:
            PrintStatement();
            break;
          case PRINTTABLE:
          case PRINTTABLEDATA:
            PrintTableStatement();
            break;
          case MAIL__SEND:
          case SENDMAIL:
            MailStatement();
            break;
          case ADDBATCH:
          case CONNECT:
          case EXECUTEBATCH:
          case EXECUTEQUERY:
          case EXECUTEQUERYCALL:
          case EXECUTEANY:
          case EXECUTESQL:
          case EXECUTEUPDATE:
          case EXECUTEUPDATECALL:
          case PREPARE:
          case PREPARECALL:
          case PREPAREDEXECUTE:
          case PREPAREDEXECUTECALL:
          case PREPAREDEXECUTEQUERY:
          case PREPAREDEXECUTECALLQUERY:
          case PREPAREDEXECUTEUPDATE:
          case PREPAREDEXECUTECALLUPDATE:
          case DB__DUMPTABLE:
          case DB__ADDBATCH:
          case DB__CONNECT:
          case DB__BATCH:
          case DB__QUERY:
          case DB__QUERYCALL:
          case DB__ANY:
          case DB__SQL:
          case DB__CALL:
          case DB__UPDATE:
          case DB__UPDATECALL:
          case DB__PREPARE:
          case DB__PREPARECALL:
            JdbcStatements();
            break;
          case HIB__SETUP:
          case HIB__QUERY:
          case HIB__ITERATE:
          case HIB__DELETE:
            HqlStatements();
            break;
          case SCHEDULE:
            ScheduleStatement();
            break;
          case DO:
            SgmlStatement();
            break;
          case XSLT:
            XsltStatement();
            break;
          case GUIEVENTS:
          case GUI__EVENTS:
            GuiEventsStatement();
            break;
          case SCP:
            SCPStatement();
            break;
          case COPY:
          case LIST:
          case LS:
          case RMDIR:
            FileSystemStatements();
            break;
          case USE:
            jj_consume_token(USE);
            jj_consume_token(NAMESPACE);
            LabelName();
            jj_consume_token(SEMICOLON);
            break;
          case IMPORT:
          case INCLUDE:
          case PRAGMA:
          case JAVAGUICLASS:
          case JAVABASECLASS:
          case JAVAENTERPRISECLASS:
          case JAVACORBACLASS:
          case JCOMCLASS:
          case JAVAPACKAGES:
          case DEFINEJAVAPACKAGES:
            Directives();
            break;
          case ANTTASK__:
            jj_consume_token(ANTTASK__);
                              lineNo = lineNum();
            label = XMLLiteral();
                              if (checkAntTask(label))
                                throwParseException("Unsupported anttask: " + label);
                              Markup mu = (Markup)stack.pop();
                              stack.push( new StmtAntTask(lineNo, mu) );
            break;
          default:
            jj_la1[168] = jj_gen;
            jj_consume_token(-1);
            throw new ParseException();
          }
        }
      }
    }
  }

  final public void SimpleBlock(Stmt[] preStmts, boolean leaveOnStack) throws ParseException {
  int lastMark = markStack();
  if (preStmts != null) {
    for (int i=0; i<preStmts.length; ++i)
      stack.push(preStmts[i]);
  }
  ++fxnDeclStack;
    jj_consume_token(LBRACE);
    label_41:
    while (true) {
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case ANTTASK__:
      case JAVA__:
      case _EOF:
      case __EOF:
      case AS:
      case BREAK:
      case CONTINUE:
      case DEFINED:
      case DELETE:
      case DO:
      case ELIF:
      case EXEC:
      case EXTENDSJAVA:
      case FALSE:
      case FOR:
      case FUNCTION:
      case JAVACLASS:
      case IF:
      case IFDEF:
      case IFNDEF:
      case IFEXISTS:
      case IMPORT:
      case IN:
      case INFINITY:
      case INTO:
      case INCLUDE:
      case LOCAL:
      case NEW:
      case JAVANEW:
      case MAX_NUMBER:
      case MIN_NUMBER:
      case NULL:
      case PRAGMA:
      case JAVAGUICLASS:
      case JAVABASECLASS:
      case JAVAENTERPRISECLASS:
      case JAVACORBACLASS:
      case JCOMCLASS:
      case JAVAPACKAGES:
      case DEFINEJAVAPACKAGES:
      case LIMIT:
      case NAMESPACE:
      case _SKIP:
      case RESUME:
      case RETURN:
      case SUPER:
      case SWITCH:
      case THIS:
      case THROW:
      case TYPEOF:
      case ATTRIBUTESOF:
      case TRUE:
      case TRY:
      case UNDEFINED:
      case USE:
      case VAR:
      case WHILE:
      case WITH:
      case BOOLEAN:
      case BYTE:
      case CHAR:
      case SHORT:
      case INT:
      case LONG:
      case FLOAT:
      case DOUBLE:
      case MAIL__SEND:
      case MAIL__CONNECT:
      case MAIL__DISCONNECT:
      case SENDMAIL:
      case CC:
      case BCC:
      case ATTACH:
      case SUBJECT:
      case BODY:
      case HTMLBODY:
      case DATE_:
      case DATE:
      case NUMBER:
      case COLUMN:
      case ERR:
      case LOG:
      case NL:
      case OUT:
      case PIPE:
      case INPUT:
      case OUTPUT:
      case NEEDSYSTEMIN:
      case FLUSH:
      case PRINT:
      case PRINTLN:
      case PRINTTABLE:
      case PRINTTABLEDATA:
      case SCP:
      case COPY:
      case MANIFEST:
      case LIST:
      case LS:
      case RMDIR:
      case EXCEPT:
      case SETFILETIME:
      case SETREADONLY:
      case SETREADWRITE:
      case TARGET:
      case ADDBATCH:
      case CONNECT:
      case EXECUTEBATCH:
      case EXECUTEQUERY:
      case EXECUTEQUERYCALL:
      case EXECUTEANY:
      case EXECUTESQL:
      case EXECUTEUPDATE:
      case EXECUTEUPDATECALL:
      case PREPARE:
      case PREPARECALL:
      case PREPAREDEXECUTE:
      case PREPAREDEXECUTECALL:
      case PREPAREDEXECUTEQUERY:
      case PREPAREDEXECUTECALLQUERY:
      case PREPAREDEXECUTEUPDATE:
      case PREPAREDEXECUTECALLUPDATE:
      case DB__DUMPTABLE:
      case DB__ADDBATCH:
      case DB__CONNECT:
      case DB__DISCONNECT:
      case DB__BATCH:
      case DB__QUERY:
      case DB__QUERYCALL:
      case DB__ANY:
      case DB__SQL:
      case DB__CALL:
      case DB__UPDATE:
      case DB__UPDATECALL:
      case DB__PREPARE:
      case DB__PREPARECALL:
      case HIB__SETUP:
      case HIB__ADDCLASS:
      case HIB__ADDRESOURCE:
      case HIB__CLOSE:
      case HIB__TXBEGIN:
      case HIB__TXEND:
      case HIB__TXABORT:
      case HIB__LOCK:
      case HIB__QUERY:
      case HIB__ITERATE:
      case HIB__DELETE:
      case HIB__GET:
      case HIB__SAVE:
      case HIB__SAVEORUPDATECOPY:
      case HIB__UNLOCK:
      case HIB__UPDATE:
      case AFTER:
      case REPEAT:
      case SCHEDULE:
      case STARTING:
      case XML:
      case XSLT:
      case SYSTEMID:
      case OUTPUTPROPERTIES:
      case PARAMETERS:
      case XMLNS:
      case GUIEVENTS:
      case GUI__EVENTS:
      case INTEGER_LITERAL:
      case FLOATING_POINT_LITERAL:
      case STRING_LITERAL:
      case EXEC_RESULT_LITERAL:
      case EXEC_RESULTLINES_LITERAL:
      case IDENTIFIER:
      case CONST_NAME:
      case BANG:
      case TILDE:
      case COLONCOLON:
      case INCR:
      case DECR:
      case PLUS:
      case MINUS:
      case BIT_AND:
      case DOLLARLBRACE:
      case LBRACE:
      case LPAREN:
      case DOT:
      case SEMICOLON:
        ;
        break;
      default:
        jj_la1[169] = jj_gen;
        break label_41;
      }
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case ANTTASK__:
      case JAVA__:
      case _EOF:
      case __EOF:
      case AS:
      case BREAK:
      case CONTINUE:
      case DEFINED:
      case DELETE:
      case DO:
      case ELIF:
      case EXEC:
      case EXTENDSJAVA:
      case FALSE:
      case FOR:
      case JAVACLASS:
      case IF:
      case IFDEF:
      case IFNDEF:
      case IFEXISTS:
      case IMPORT:
      case IN:
      case INFINITY:
      case INTO:
      case INCLUDE:
      case LOCAL:
      case NEW:
      case JAVANEW:
      case MAX_NUMBER:
      case MIN_NUMBER:
      case NULL:
      case PRAGMA:
      case JAVAGUICLASS:
      case JAVABASECLASS:
      case JAVAENTERPRISECLASS:
      case JAVACORBACLASS:
      case JCOMCLASS:
      case JAVAPACKAGES:
      case DEFINEJAVAPACKAGES:
      case LIMIT:
      case NAMESPACE:
      case _SKIP:
      case RESUME:
      case RETURN:
      case SUPER:
      case SWITCH:
      case THIS:
      case THROW:
      case TYPEOF:
      case ATTRIBUTESOF:
      case TRUE:
      case TRY:
      case UNDEFINED:
      case USE:
      case VAR:
      case WHILE:
      case WITH:
      case BOOLEAN:
      case BYTE:
      case CHAR:
      case SHORT:
      case INT:
      case LONG:
      case FLOAT:
      case DOUBLE:
      case MAIL__SEND:
      case MAIL__CONNECT:
      case MAIL__DISCONNECT:
      case SENDMAIL:
      case CC:
      case BCC:
      case ATTACH:
      case SUBJECT:
      case BODY:
      case HTMLBODY:
      case DATE_:
      case DATE:
      case NUMBER:
      case COLUMN:
      case ERR:
      case LOG:
      case NL:
      case OUT:
      case PIPE:
      case INPUT:
      case OUTPUT:
      case NEEDSYSTEMIN:
      case FLUSH:
      case PRINT:
      case PRINTLN:
      case PRINTTABLE:
      case PRINTTABLEDATA:
      case SCP:
      case COPY:
      case MANIFEST:
      case LIST:
      case LS:
      case RMDIR:
      case EXCEPT:
      case SETFILETIME:
      case SETREADONLY:
      case SETREADWRITE:
      case TARGET:
      case ADDBATCH:
      case CONNECT:
      case EXECUTEBATCH:
      case EXECUTEQUERY:
      case EXECUTEQUERYCALL:
      case EXECUTEANY:
      case EXECUTESQL:
      case EXECUTEUPDATE:
      case EXECUTEUPDATECALL:
      case PREPARE:
      case PREPARECALL:
      case PREPAREDEXECUTE:
      case PREPAREDEXECUTECALL:
      case PREPAREDEXECUTEQUERY:
      case PREPAREDEXECUTECALLQUERY:
      case PREPAREDEXECUTEUPDATE:
      case PREPAREDEXECUTECALLUPDATE:
      case DB__DUMPTABLE:
      case DB__ADDBATCH:
      case DB__CONNECT:
      case DB__DISCONNECT:
      case DB__BATCH:
      case DB__QUERY:
      case DB__QUERYCALL:
      case DB__ANY:
      case DB__SQL:
      case DB__CALL:
      case DB__UPDATE:
      case DB__UPDATECALL:
      case DB__PREPARE:
      case DB__PREPARECALL:
      case HIB__SETUP:
      case HIB__ADDCLASS:
      case HIB__ADDRESOURCE:
      case HIB__CLOSE:
      case HIB__TXBEGIN:
      case HIB__TXEND:
      case HIB__TXABORT:
      case HIB__LOCK:
      case HIB__QUERY:
      case HIB__ITERATE:
      case HIB__DELETE:
      case HIB__GET:
      case HIB__SAVE:
      case HIB__SAVEORUPDATECOPY:
      case HIB__UNLOCK:
      case HIB__UPDATE:
      case AFTER:
      case REPEAT:
      case SCHEDULE:
      case STARTING:
      case XML:
      case XSLT:
      case SYSTEMID:
      case OUTPUTPROPERTIES:
      case PARAMETERS:
      case XMLNS:
      case GUIEVENTS:
      case GUI__EVENTS:
      case INTEGER_LITERAL:
      case FLOATING_POINT_LITERAL:
      case STRING_LITERAL:
      case EXEC_RESULT_LITERAL:
      case EXEC_RESULTLINES_LITERAL:
      case IDENTIFIER:
      case CONST_NAME:
      case BANG:
      case TILDE:
      case COLONCOLON:
      case INCR:
      case DECR:
      case PLUS:
      case MINUS:
      case BIT_AND:
      case DOLLARLBRACE:
      case LBRACE:
      case LPAREN:
      case DOT:
      case SEMICOLON:
        Statement();
        break;
      case FUNCTION:
        FunctionDecl();
        break;
      default:
        jj_la1[170] = jj_gen;
        jj_consume_token(-1);
        throw new ParseException();
      }
    }
    jj_consume_token(RBRACE);
    --fxnDeclStack;
    if (leaveOnStack) {if (true) return;}
    BlockSimple b = new BlockSimple();
    if (handleStmts(lastMark)) b.setStmts(stmts,labels);
    stack.push(b);
  }

  final public void Block() throws ParseException {
  int lastMark = markStack();
  String s = null;
  int lineNo;
  ++fxnDeclStack;
    jj_consume_token(LBRACE);
          lineNo = lineNum();
    label_42:
    while (true) {
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case ANTTASK__:
      case JAVA__:
      case _EOF:
      case __EOF:
      case AS:
      case BREAK:
      case CONTINUE:
      case DEFINED:
      case DELETE:
      case DO:
      case ELIF:
      case EXEC:
      case EXTENDSJAVA:
      case FALSE:
      case FOR:
      case FUNCTION:
      case JAVACLASS:
      case IF:
      case IFDEF:
      case IFNDEF:
      case IFEXISTS:
      case IMPORT:
      case IN:
      case INFINITY:
      case INTO:
      case INCLUDE:
      case LOCAL:
      case NEW:
      case JAVANEW:
      case MAX_NUMBER:
      case MIN_NUMBER:
      case NULL:
      case PRAGMA:
      case JAVAGUICLASS:
      case JAVABASECLASS:
      case JAVAENTERPRISECLASS:
      case JAVACORBACLASS:
      case JCOMCLASS:
      case JAVAPACKAGES:
      case DEFINEJAVAPACKAGES:
      case LIMIT:
      case NAMESPACE:
      case _SKIP:
      case RESUME:
      case RETURN:
      case SUPER:
      case SWITCH:
      case THIS:
      case THROW:
      case TYPEOF:
      case ATTRIBUTESOF:
      case TRUE:
      case TRY:
      case UNDEFINED:
      case USE:
      case VAR:
      case WHILE:
      case WITH:
      case BOOLEAN:
      case BYTE:
      case CHAR:
      case SHORT:
      case INT:
      case LONG:
      case FLOAT:
      case DOUBLE:
      case MAIL__SEND:
      case MAIL__CONNECT:
      case MAIL__DISCONNECT:
      case SENDMAIL:
      case CC:
      case BCC:
      case ATTACH:
      case SUBJECT:
      case BODY:
      case HTMLBODY:
      case DATE_:
      case DATE:
      case NUMBER:
      case COLUMN:
      case ERR:
      case LOG:
      case NL:
      case OUT:
      case PIPE:
      case INPUT:
      case OUTPUT:
      case NEEDSYSTEMIN:
      case FLUSH:
      case PRINT:
      case PRINTLN:
      case PRINTTABLE:
      case PRINTTABLEDATA:
      case SCP:
      case COPY:
      case MANIFEST:
      case LIST:
      case LS:
      case RMDIR:
      case EXCEPT:
      case SETFILETIME:
      case SETREADONLY:
      case SETREADWRITE:
      case TARGET:
      case ADDBATCH:
      case CONNECT:
      case EXECUTEBATCH:
      case EXECUTEQUERY:
      case EXECUTEQUERYCALL:
      case EXECUTEANY:
      case EXECUTESQL:
      case EXECUTEUPDATE:
      case EXECUTEUPDATECALL:
      case PREPARE:
      case PREPARECALL:
      case PREPAREDEXECUTE:
      case PREPAREDEXECUTECALL:
      case PREPAREDEXECUTEQUERY:
      case PREPAREDEXECUTECALLQUERY:
      case PREPAREDEXECUTEUPDATE:
      case PREPAREDEXECUTECALLUPDATE:
      case DB__DUMPTABLE:
      case DB__ADDBATCH:
      case DB__CONNECT:
      case DB__DISCONNECT:
      case DB__BATCH:
      case DB__QUERY:
      case DB__QUERYCALL:
      case DB__ANY:
      case DB__SQL:
      case DB__CALL:
      case DB__UPDATE:
      case DB__UPDATECALL:
      case DB__PREPARE:
      case DB__PREPARECALL:
      case HIB__SETUP:
      case HIB__ADDCLASS:
      case HIB__ADDRESOURCE:
      case HIB__CLOSE:
      case HIB__TXBEGIN:
      case HIB__TXEND:
      case HIB__TXABORT:
      case HIB__LOCK:
      case HIB__QUERY:
      case HIB__ITERATE:
      case HIB__DELETE:
      case HIB__GET:
      case HIB__SAVE:
      case HIB__SAVEORUPDATECOPY:
      case HIB__UNLOCK:
      case HIB__UPDATE:
      case AFTER:
      case REPEAT:
      case SCHEDULE:
      case STARTING:
      case XML:
      case XSLT:
      case SYSTEMID:
      case OUTPUTPROPERTIES:
      case PARAMETERS:
      case XMLNS:
      case GUIEVENTS:
      case GUI__EVENTS:
      case INTEGER_LITERAL:
      case FLOATING_POINT_LITERAL:
      case STRING_LITERAL:
      case EXEC_RESULT_LITERAL:
      case EXEC_RESULTLINES_LITERAL:
      case IDENTIFIER:
      case CONST_NAME:
      case BANG:
      case TILDE:
      case COLONCOLON:
      case INCR:
      case DECR:
      case PLUS:
      case MINUS:
      case BIT_AND:
      case DOLLARLBRACE:
      case LBRACE:
      case LPAREN:
      case DOT:
      case SEMICOLON:
        ;
        break;
      default:
        jj_la1[171] = jj_gen;
        break label_42;
      }
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case ANTTASK__:
      case JAVA__:
      case _EOF:
      case __EOF:
      case AS:
      case BREAK:
      case CONTINUE:
      case DEFINED:
      case DELETE:
      case DO:
      case ELIF:
      case EXEC:
      case EXTENDSJAVA:
      case FALSE:
      case FOR:
      case JAVACLASS:
      case IF:
      case IFDEF:
      case IFNDEF:
      case IFEXISTS:
      case IMPORT:
      case IN:
      case INFINITY:
      case INTO:
      case INCLUDE:
      case LOCAL:
      case NEW:
      case JAVANEW:
      case MAX_NUMBER:
      case MIN_NUMBER:
      case NULL:
      case PRAGMA:
      case JAVAGUICLASS:
      case JAVABASECLASS:
      case JAVAENTERPRISECLASS:
      case JAVACORBACLASS:
      case JCOMCLASS:
      case JAVAPACKAGES:
      case DEFINEJAVAPACKAGES:
      case LIMIT:
      case NAMESPACE:
      case _SKIP:
      case RESUME:
      case RETURN:
      case SUPER:
      case SWITCH:
      case THIS:
      case THROW:
      case TYPEOF:
      case ATTRIBUTESOF:
      case TRUE:
      case TRY:
      case UNDEFINED:
      case USE:
      case VAR:
      case WHILE:
      case WITH:
      case BOOLEAN:
      case BYTE:
      case CHAR:
      case SHORT:
      case INT:
      case LONG:
      case FLOAT:
      case DOUBLE:
      case MAIL__SEND:
      case MAIL__CONNECT:
      case MAIL__DISCONNECT:
      case SENDMAIL:
      case CC:
      case BCC:
      case ATTACH:
      case SUBJECT:
      case BODY:
      case HTMLBODY:
      case DATE_:
      case DATE:
      case NUMBER:
      case COLUMN:
      case ERR:
      case LOG:
      case NL:
      case OUT:
      case PIPE:
      case INPUT:
      case OUTPUT:
      case NEEDSYSTEMIN:
      case FLUSH:
      case PRINT:
      case PRINTLN:
      case PRINTTABLE:
      case PRINTTABLEDATA:
      case SCP:
      case COPY:
      case MANIFEST:
      case LIST:
      case LS:
      case RMDIR:
      case EXCEPT:
      case SETFILETIME:
      case SETREADONLY:
      case SETREADWRITE:
      case TARGET:
      case ADDBATCH:
      case CONNECT:
      case EXECUTEBATCH:
      case EXECUTEQUERY:
      case EXECUTEQUERYCALL:
      case EXECUTEANY:
      case EXECUTESQL:
      case EXECUTEUPDATE:
      case EXECUTEUPDATECALL:
      case PREPARE:
      case PREPARECALL:
      case PREPAREDEXECUTE:
      case PREPAREDEXECUTECALL:
      case PREPAREDEXECUTEQUERY:
      case PREPAREDEXECUTECALLQUERY:
      case PREPAREDEXECUTEUPDATE:
      case PREPAREDEXECUTECALLUPDATE:
      case DB__DUMPTABLE:
      case DB__ADDBATCH:
      case DB__CONNECT:
      case DB__DISCONNECT:
      case DB__BATCH:
      case DB__QUERY:
      case DB__QUERYCALL:
      case DB__ANY:
      case DB__SQL:
      case DB__CALL:
      case DB__UPDATE:
      case DB__UPDATECALL:
      case DB__PREPARE:
      case DB__PREPARECALL:
      case HIB__SETUP:
      case HIB__ADDCLASS:
      case HIB__ADDRESOURCE:
      case HIB__CLOSE:
      case HIB__TXBEGIN:
      case HIB__TXEND:
      case HIB__TXABORT:
      case HIB__LOCK:
      case HIB__QUERY:
      case HIB__ITERATE:
      case HIB__DELETE:
      case HIB__GET:
      case HIB__SAVE:
      case HIB__SAVEORUPDATECOPY:
      case HIB__UNLOCK:
      case HIB__UPDATE:
      case AFTER:
      case REPEAT:
      case SCHEDULE:
      case STARTING:
      case XML:
      case XSLT:
      case SYSTEMID:
      case OUTPUTPROPERTIES:
      case PARAMETERS:
      case XMLNS:
      case GUIEVENTS:
      case GUI__EVENTS:
      case INTEGER_LITERAL:
      case FLOATING_POINT_LITERAL:
      case STRING_LITERAL:
      case EXEC_RESULT_LITERAL:
      case EXEC_RESULTLINES_LITERAL:
      case IDENTIFIER:
      case CONST_NAME:
      case BANG:
      case TILDE:
      case COLONCOLON:
      case INCR:
      case DECR:
      case PLUS:
      case MINUS:
      case BIT_AND:
      case DOLLARLBRACE:
      case LBRACE:
      case LPAREN:
      case DOT:
      case SEMICOLON:
        Statement();
        break;
      case FUNCTION:
        FunctionDecl();
        break;
      default:
        jj_la1[172] = jj_gen;
        jj_consume_token(-1);
        throw new ParseException();
      }
    }
    if (jj_2_50(2)) {
      jj_consume_token(CATCH);
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case IDENTIFIER:
        jj_consume_token(IDENTIFIER);
                                          s=token.image;
        break;
      default:
        jj_la1[173] = jj_gen;
        ;
      }
      jj_consume_token(COLON);
                                                                   stack.push("catch");
      label_43:
      while (true) {
        Statement();
        switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
        case ANTTASK__:
        case JAVA__:
        case _EOF:
        case __EOF:
        case AS:
        case BREAK:
        case CONTINUE:
        case DEFINED:
        case DELETE:
        case DO:
        case ELIF:
        case EXEC:
        case EXTENDSJAVA:
        case FALSE:
        case FOR:
        case JAVACLASS:
        case IF:
        case IFDEF:
        case IFNDEF:
        case IFEXISTS:
        case IMPORT:
        case IN:
        case INFINITY:
        case INTO:
        case INCLUDE:
        case LOCAL:
        case NEW:
        case JAVANEW:
        case MAX_NUMBER:
        case MIN_NUMBER:
        case NULL:
        case PRAGMA:
        case JAVAGUICLASS:
        case JAVABASECLASS:
        case JAVAENTERPRISECLASS:
        case JAVACORBACLASS:
        case JCOMCLASS:
        case JAVAPACKAGES:
        case DEFINEJAVAPACKAGES:
        case LIMIT:
        case NAMESPACE:
        case _SKIP:
        case RESUME:
        case RETURN:
        case SUPER:
        case SWITCH:
        case THIS:
        case THROW:
        case TYPEOF:
        case ATTRIBUTESOF:
        case TRUE:
        case TRY:
        case UNDEFINED:
        case USE:
        case VAR:
        case WHILE:
        case WITH:
        case BOOLEAN:
        case BYTE:
        case CHAR:
        case SHORT:
        case INT:
        case LONG:
        case FLOAT:
        case DOUBLE:
        case MAIL__SEND:
        case MAIL__CONNECT:
        case MAIL__DISCONNECT:
        case SENDMAIL:
        case CC:
        case BCC:
        case ATTACH:
        case SUBJECT:
        case BODY:
        case HTMLBODY:
        case DATE_:
        case DATE:
        case NUMBER:
        case COLUMN:
        case ERR:
        case LOG:
        case NL:
        case OUT:
        case PIPE:
        case INPUT:
        case OUTPUT:
        case NEEDSYSTEMIN:
        case FLUSH:
        case PRINT:
        case PRINTLN:
        case PRINTTABLE:
        case PRINTTABLEDATA:
        case SCP:
        case COPY:
        case MANIFEST:
        case LIST:
        case LS:
        case RMDIR:
        case EXCEPT:
        case SETFILETIME:
        case SETREADONLY:
        case SETREADWRITE:
        case TARGET:
        case ADDBATCH:
        case CONNECT:
        case EXECUTEBATCH:
        case EXECUTEQUERY:
        case EXECUTEQUERYCALL:
        case EXECUTEANY:
        case EXECUTESQL:
        case EXECUTEUPDATE:
        case EXECUTEUPDATECALL:
        case PREPARE:
        case PREPARECALL:
        case PREPAREDEXECUTE:
        case PREPAREDEXECUTECALL:
        case PREPAREDEXECUTEQUERY:
        case PREPAREDEXECUTECALLQUERY:
        case PREPAREDEXECUTEUPDATE:
        case PREPAREDEXECUTECALLUPDATE:
        case DB__DUMPTABLE:
        case DB__ADDBATCH:
        case DB__CONNECT:
        case DB__DISCONNECT:
        case DB__BATCH:
        case DB__QUERY:
        case DB__QUERYCALL:
        case DB__ANY:
        case DB__SQL:
        case DB__CALL:
        case DB__UPDATE:
        case DB__UPDATECALL:
        case DB__PREPARE:
        case DB__PREPARECALL:
        case HIB__SETUP:
        case HIB__ADDCLASS:
        case HIB__ADDRESOURCE:
        case HIB__CLOSE:
        case HIB__TXBEGIN:
        case HIB__TXEND:
        case HIB__TXABORT:
        case HIB__LOCK:
        case HIB__QUERY:
        case HIB__ITERATE:
        case HIB__DELETE:
        case HIB__GET:
        case HIB__SAVE:
        case HIB__SAVEORUPDATECOPY:
        case HIB__UNLOCK:
        case HIB__UPDATE:
        case AFTER:
        case REPEAT:
        case SCHEDULE:
        case STARTING:
        case XML:
        case XSLT:
        case SYSTEMID:
        case OUTPUTPROPERTIES:
        case PARAMETERS:
        case XMLNS:
        case GUIEVENTS:
        case GUI__EVENTS:
        case INTEGER_LITERAL:
        case FLOATING_POINT_LITERAL:
        case STRING_LITERAL:
        case EXEC_RESULT_LITERAL:
        case EXEC_RESULTLINES_LITERAL:
        case IDENTIFIER:
        case CONST_NAME:
        case BANG:
        case TILDE:
        case COLONCOLON:
        case INCR:
        case DECR:
        case PLUS:
        case MINUS:
        case BIT_AND:
        case DOLLARLBRACE:
        case LBRACE:
        case LPAREN:
        case DOT:
        case SEMICOLON:
          ;
          break;
        default:
          jj_la1[174] = jj_gen;
          break label_43;
        }
      }
    } else {
      ;
    }
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case FINALLY:
      jj_consume_token(FINALLY);
      jj_consume_token(COLON);
                    stack.push("finally");
      label_44:
      while (true) {
        Statement();
        switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
        case ANTTASK__:
        case JAVA__:
        case _EOF:
        case __EOF:
        case AS:
        case BREAK:
        case CONTINUE:
        case DEFINED:
        case DELETE:
        case DO:
        case ELIF:
        case EXEC:
        case EXTENDSJAVA:
        case FALSE:
        case FOR:
        case JAVACLASS:
        case IF:
        case IFDEF:
        case IFNDEF:
        case IFEXISTS:
        case IMPORT:
        case IN:
        case INFINITY:
        case INTO:
        case INCLUDE:
        case LOCAL:
        case NEW:
        case JAVANEW:
        case MAX_NUMBER:
        case MIN_NUMBER:
        case NULL:
        case PRAGMA:
        case JAVAGUICLASS:
        case JAVABASECLASS:
        case JAVAENTERPRISECLASS:
        case JAVACORBACLASS:
        case JCOMCLASS:
        case JAVAPACKAGES:
        case DEFINEJAVAPACKAGES:
        case LIMIT:
        case NAMESPACE:
        case _SKIP:
        case RESUME:
        case RETURN:
        case SUPER:
        case SWITCH:
        case THIS:
        case THROW:
        case TYPEOF:
        case ATTRIBUTESOF:
        case TRUE:
        case TRY:
        case UNDEFINED:
        case USE:
        case VAR:
        case WHILE:
        case WITH:
        case BOOLEAN:
        case BYTE:
        case CHAR:
        case SHORT:
        case INT:
        case LONG:
        case FLOAT:
        case DOUBLE:
        case MAIL__SEND:
        case MAIL__CONNECT:
        case MAIL__DISCONNECT:
        case SENDMAIL:
        case CC:
        case BCC:
        case ATTACH:
        case SUBJECT:
        case BODY:
        case HTMLBODY:
        case DATE_:
        case DATE:
        case NUMBER:
        case COLUMN:
        case ERR:
        case LOG:
        case NL:
        case OUT:
        case PIPE:
        case INPUT:
        case OUTPUT:
        case NEEDSYSTEMIN:
        case FLUSH:
        case PRINT:
        case PRINTLN:
        case PRINTTABLE:
        case PRINTTABLEDATA:
        case SCP:
        case COPY:
        case MANIFEST:
        case LIST:
        case LS:
        case RMDIR:
        case EXCEPT:
        case SETFILETIME:
        case SETREADONLY:
        case SETREADWRITE:
        case TARGET:
        case ADDBATCH:
        case CONNECT:
        case EXECUTEBATCH:
        case EXECUTEQUERY:
        case EXECUTEQUERYCALL:
        case EXECUTEANY:
        case EXECUTESQL:
        case EXECUTEUPDATE:
        case EXECUTEUPDATECALL:
        case PREPARE:
        case PREPARECALL:
        case PREPAREDEXECUTE:
        case PREPAREDEXECUTECALL:
        case PREPAREDEXECUTEQUERY:
        case PREPAREDEXECUTECALLQUERY:
        case PREPAREDEXECUTEUPDATE:
        case PREPAREDEXECUTECALLUPDATE:
        case DB__DUMPTABLE:
        case DB__ADDBATCH:
        case DB__CONNECT:
        case DB__DISCONNECT:
        case DB__BATCH:
        case DB__QUERY:
        case DB__QUERYCALL:
        case DB__ANY:
        case DB__SQL:
        case DB__CALL:
        case DB__UPDATE:
        case DB__UPDATECALL:
        case DB__PREPARE:
        case DB__PREPARECALL:
        case HIB__SETUP:
        case HIB__ADDCLASS:
        case HIB__ADDRESOURCE:
        case HIB__CLOSE:
        case HIB__TXBEGIN:
        case HIB__TXEND:
        case HIB__TXABORT:
        case HIB__LOCK:
        case HIB__QUERY:
        case HIB__ITERATE:
        case HIB__DELETE:
        case HIB__GET:
        case HIB__SAVE:
        case HIB__SAVEORUPDATECOPY:
        case HIB__UNLOCK:
        case HIB__UPDATE:
        case AFTER:
        case REPEAT:
        case SCHEDULE:
        case STARTING:
        case XML:
        case XSLT:
        case SYSTEMID:
        case OUTPUTPROPERTIES:
        case PARAMETERS:
        case XMLNS:
        case GUIEVENTS:
        case GUI__EVENTS:
        case INTEGER_LITERAL:
        case FLOATING_POINT_LITERAL:
        case STRING_LITERAL:
        case EXEC_RESULT_LITERAL:
        case EXEC_RESULTLINES_LITERAL:
        case IDENTIFIER:
        case CONST_NAME:
        case BANG:
        case TILDE:
        case COLONCOLON:
        case INCR:
        case DECR:
        case PLUS:
        case MINUS:
        case BIT_AND:
        case DOLLARLBRACE:
        case LBRACE:
        case LPAREN:
        case DOT:
        case SEMICOLON:
          ;
          break;
        default:
          jj_la1[175] = jj_gen;
          break label_44;
        }
      }
      break;
    default:
      jj_la1[176] = jj_gen;
      ;
    }
    jj_consume_token(RBRACE);
    --fxnDeclStack; stack.push(handleBlock(lastMark, s, lineNo));
  }

  final public void SwitchStatement() throws ParseException {
  StmtSwitch ss = null;
  ArrayList v = new ArrayList();
    jj_consume_token(SWITCH);
    Expression();
                              ss = new StmtSwitch(lineNum(),reduceIt());
    jj_consume_token(LBRACE);
    label_45:
    while (true) {
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case CASE:
      case _DEFAULT:
        ;
        break;
      default:
        jj_la1[177] = jj_gen;
        break label_45;
      }
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case CASE:
        jj_consume_token(CASE);
        Expression();
                              ss.addCase(reduceIt(), v.size());
        label_46:
        while (true) {
          switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
          case COMMA:
            ;
            break;
          default:
            jj_la1[178] = jj_gen;
            break label_46;
          }
          jj_consume_token(COMMA);
          Expression();
                              ss.addCase(reduceIt(), v.size());
        }
        break;
      case _DEFAULT:
        jj_consume_token(_DEFAULT);
                              ss.setDefaultIndex(v.size());
        break;
      default:
        jj_la1[179] = jj_gen;
        jj_consume_token(-1);
        throw new ParseException();
      }
      jj_consume_token(COLON);
      label_47:
      while (true) {
        switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
        case ANTTASK__:
        case JAVA__:
        case _EOF:
        case __EOF:
        case AS:
        case BREAK:
        case CONTINUE:
        case DEFINED:
        case DELETE:
        case DO:
        case ELIF:
        case EXEC:
        case EXTENDSJAVA:
        case FALSE:
        case FOR:
        case JAVACLASS:
        case IF:
        case IFDEF:
        case IFNDEF:
        case IFEXISTS:
        case IMPORT:
        case IN:
        case INFINITY:
        case INTO:
        case INCLUDE:
        case LOCAL:
        case NEW:
        case JAVANEW:
        case MAX_NUMBER:
        case MIN_NUMBER:
        case NULL:
        case PRAGMA:
        case JAVAGUICLASS:
        case JAVABASECLASS:
        case JAVAENTERPRISECLASS:
        case JAVACORBACLASS:
        case JCOMCLASS:
        case JAVAPACKAGES:
        case DEFINEJAVAPACKAGES:
        case LIMIT:
        case NAMESPACE:
        case _SKIP:
        case RESUME:
        case RETURN:
        case SUPER:
        case SWITCH:
        case THIS:
        case THROW:
        case TYPEOF:
        case ATTRIBUTESOF:
        case TRUE:
        case TRY:
        case UNDEFINED:
        case USE:
        case VAR:
        case WHILE:
        case WITH:
        case BOOLEAN:
        case BYTE:
        case CHAR:
        case SHORT:
        case INT:
        case LONG:
        case FLOAT:
        case DOUBLE:
        case MAIL__SEND:
        case MAIL__CONNECT:
        case MAIL__DISCONNECT:
        case SENDMAIL:
        case CC:
        case BCC:
        case ATTACH:
        case SUBJECT:
        case BODY:
        case HTMLBODY:
        case DATE_:
        case DATE:
        case NUMBER:
        case COLUMN:
        case ERR:
        case LOG:
        case NL:
        case OUT:
        case PIPE:
        case INPUT:
        case OUTPUT:
        case NEEDSYSTEMIN:
        case FLUSH:
        case PRINT:
        case PRINTLN:
        case PRINTTABLE:
        case PRINTTABLEDATA:
        case SCP:
        case COPY:
        case MANIFEST:
        case LIST:
        case LS:
        case RMDIR:
        case EXCEPT:
        case SETFILETIME:
        case SETREADONLY:
        case SETREADWRITE:
        case TARGET:
        case ADDBATCH:
        case CONNECT:
        case EXECUTEBATCH:
        case EXECUTEQUERY:
        case EXECUTEQUERYCALL:
        case EXECUTEANY:
        case EXECUTESQL:
        case EXECUTEUPDATE:
        case EXECUTEUPDATECALL:
        case PREPARE:
        case PREPARECALL:
        case PREPAREDEXECUTE:
        case PREPAREDEXECUTECALL:
        case PREPAREDEXECUTEQUERY:
        case PREPAREDEXECUTECALLQUERY:
        case PREPAREDEXECUTEUPDATE:
        case PREPAREDEXECUTECALLUPDATE:
        case DB__DUMPTABLE:
        case DB__ADDBATCH:
        case DB__CONNECT:
        case DB__DISCONNECT:
        case DB__BATCH:
        case DB__QUERY:
        case DB__QUERYCALL:
        case DB__ANY:
        case DB__SQL:
        case DB__CALL:
        case DB__UPDATE:
        case DB__UPDATECALL:
        case DB__PREPARE:
        case DB__PREPARECALL:
        case HIB__SETUP:
        case HIB__ADDCLASS:
        case HIB__ADDRESOURCE:
        case HIB__CLOSE:
        case HIB__TXBEGIN:
        case HIB__TXEND:
        case HIB__TXABORT:
        case HIB__LOCK:
        case HIB__QUERY:
        case HIB__ITERATE:
        case HIB__DELETE:
        case HIB__GET:
        case HIB__SAVE:
        case HIB__SAVEORUPDATECOPY:
        case HIB__UNLOCK:
        case HIB__UPDATE:
        case AFTER:
        case REPEAT:
        case SCHEDULE:
        case STARTING:
        case XML:
        case XSLT:
        case SYSTEMID:
        case OUTPUTPROPERTIES:
        case PARAMETERS:
        case XMLNS:
        case GUIEVENTS:
        case GUI__EVENTS:
        case INTEGER_LITERAL:
        case FLOATING_POINT_LITERAL:
        case STRING_LITERAL:
        case EXEC_RESULT_LITERAL:
        case EXEC_RESULTLINES_LITERAL:
        case IDENTIFIER:
        case CONST_NAME:
        case BANG:
        case TILDE:
        case COLONCOLON:
        case INCR:
        case DECR:
        case PLUS:
        case MINUS:
        case BIT_AND:
        case DOLLARLBRACE:
        case LBRACE:
        case LPAREN:
        case DOT:
        case SEMICOLON:
          ;
          break;
        default:
          jj_la1[180] = jj_gen;
          break label_47;
        }
        Statement();
                              v.add(stack.pop());
      }
    }
    jj_consume_token(RBRACE);
                              ss.setStmts(v); stack.push(ss);
  }

  final public void IfStatement() throws ParseException {
  int lastMark = markStack();
    jj_consume_token(IF);
    if (jj_2_51(2147483647)) {
      Expression();
      SimpleBlock(null,false);
    } else {
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case LPAREN:
        jj_consume_token(LPAREN);
        Expression();
        jj_consume_token(RPAREN);
        IndividualStatement();
        break;
      default:
        jj_la1[181] = jj_gen;
        jj_consume_token(-1);
        throw new ParseException();
      }
    }
    label_48:
    while (true) {
      if (jj_2_52(2)) {
        ;
      } else {
        break label_48;
      }
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case ELIF:
        jj_consume_token(ELIF);
        break;
      case ELSE:
        jj_consume_token(ELSE);
        jj_consume_token(IF);
        break;
      default:
        jj_la1[182] = jj_gen;
        jj_consume_token(-1);
        throw new ParseException();
      }
      if (jj_2_53(2147483647)) {
        Expression();
        SimpleBlock(null,false);
      } else {
        switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
        case LPAREN:
          jj_consume_token(LPAREN);
          Expression();
          jj_consume_token(RPAREN);
          Statement();
          break;
        default:
          jj_la1[183] = jj_gen;
          jj_consume_token(-1);
          throw new ParseException();
        }
      }
    }
    if (jj_2_54(2)) {
      jj_consume_token(ELSE);
      Statement();
    } else {
      ;
    }
    int cnt = countOnStack(lastMark);
    // if cnt is odd, last one is "else"
    Stmt elsePart = ((cnt & 1) == 1) ? (Stmt)stack.pop() : null;
    if (elsePart != null) {
      if (elsePart instanceof BlockSimple)
        elsePart = reduceBlock((BlockSimple)elsePart);
    }
    cnt /= 2;
    Expr[] conds = new Expr[cnt];
    Stmt[] ifParts = new Stmt[cnt];
    Stmt stmt;
    for (int i=cnt-1; i>=0; i--) {
      stmt = (Stmt)stack.pop();
      if (stmt instanceof BlockSimple) stmt = reduceBlock((BlockSimple)stmt);
      ifParts[i] = stmt;
      conds[i] = nonAssignExpr(stack.pop());
    }
    stack.push( new StmtIf(lineNum(), conds, ifParts, elsePart) );
  }

  final public void WhileStatement() throws ParseException {
  String label = null;
  Expr cond = ConstInt.TRUE;
  int lineNo;
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case AS:
    case ELIF:
    case EXTENDSJAVA:
    case IFDEF:
    case IFNDEF:
    case IFEXISTS:
    case IN:
    case INTO:
    case LIMIT:
    case NAMESPACE:
    case _SKIP:
    case CC:
    case BCC:
    case ATTACH:
    case SUBJECT:
    case BODY:
    case HTMLBODY:
    case NUMBER:
    case COLUMN:
    case ERR:
    case LOG:
    case OUT:
    case PIPE:
    case INPUT:
    case OUTPUT:
    case NEEDSYSTEMIN:
    case MANIFEST:
    case EXCEPT:
    case SETFILETIME:
    case SETREADONLY:
    case SETREADWRITE:
    case TARGET:
    case AFTER:
    case STARTING:
    case XML:
    case SYSTEMID:
    case OUTPUTPROPERTIES:
    case PARAMETERS:
    case XMLNS:
    case IDENTIFIER:
      LabelName();
                         label = setCurrentLabel();
      jj_consume_token(COLON);
      break;
    default:
      jj_la1[184] = jj_gen;
      ;
    }
    jj_consume_token(WHILE);
                         lineNo = token.endLine;
    if (jj_2_55(2147483647)) {
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case JAVA__:
      case _EOF:
      case __EOF:
      case AS:
      case DEFINED:
      case ELIF:
      case EXTENDSJAVA:
      case FALSE:
      case JAVACLASS:
      case IFDEF:
      case IFNDEF:
      case IFEXISTS:
      case IN:
      case INFINITY:
      case INTO:
      case NEW:
      case JAVANEW:
      case MAX_NUMBER:
      case MIN_NUMBER:
      case NULL:
      case LIMIT:
      case NAMESPACE:
      case _SKIP:
      case SUPER:
      case THIS:
      case TYPEOF:
      case ATTRIBUTESOF:
      case TRUE:
      case UNDEFINED:
      case BOOLEAN:
      case BYTE:
      case CHAR:
      case SHORT:
      case INT:
      case LONG:
      case FLOAT:
      case DOUBLE:
      case MAIL__CONNECT:
      case MAIL__DISCONNECT:
      case CC:
      case BCC:
      case ATTACH:
      case SUBJECT:
      case BODY:
      case HTMLBODY:
      case DATE_:
      case DATE:
      case NUMBER:
      case COLUMN:
      case ERR:
      case LOG:
      case NL:
      case OUT:
      case PIPE:
      case INPUT:
      case OUTPUT:
      case NEEDSYSTEMIN:
      case MANIFEST:
      case EXCEPT:
      case SETFILETIME:
      case SETREADONLY:
      case SETREADWRITE:
      case TARGET:
      case DB__DISCONNECT:
      case HIB__ADDCLASS:
      case HIB__ADDRESOURCE:
      case HIB__CLOSE:
      case HIB__TXBEGIN:
      case HIB__TXEND:
      case HIB__TXABORT:
      case HIB__LOCK:
      case HIB__DELETE:
      case HIB__GET:
      case HIB__SAVE:
      case HIB__SAVEORUPDATECOPY:
      case HIB__UNLOCK:
      case HIB__UPDATE:
      case AFTER:
      case STARTING:
      case XML:
      case SYSTEMID:
      case OUTPUTPROPERTIES:
      case PARAMETERS:
      case XMLNS:
      case INTEGER_LITERAL:
      case FLOATING_POINT_LITERAL:
      case STRING_LITERAL:
      case EXEC_RESULT_LITERAL:
      case EXEC_RESULTLINES_LITERAL:
      case IDENTIFIER:
      case CONST_NAME:
      case BANG:
      case TILDE:
      case COLONCOLON:
      case INCR:
      case DECR:
      case PLUS:
      case MINUS:
      case BIT_AND:
      case DOLLARLBRACE:
      case LPAREN:
        Expression();
                         cond = nonAssignExpr(stack.pop());
        break;
      default:
        jj_la1[185] = jj_gen;
        ;
      }
      SimpleBlock(null,false);
    } else {
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case LPAREN:
        jj_consume_token(LPAREN);
        Expression();
                         cond = nonAssignExpr(stack.pop());
        jj_consume_token(RPAREN);
        IndividualStatement();
        break;
      default:
        jj_la1[186] = jj_gen;
        jj_consume_token(-1);
        throw new ParseException();
      }
    }
    stack.push( new StmtWhile(lineNo,label,(Stmt)stack.pop(),cond,false) );
    if (label != null) labelStack.pop();
  }

  final public void DoWhileStatement() throws ParseException {
  String label = null;
  int lineNo;
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case AS:
    case ELIF:
    case EXTENDSJAVA:
    case IFDEF:
    case IFNDEF:
    case IFEXISTS:
    case IN:
    case INTO:
    case LIMIT:
    case NAMESPACE:
    case _SKIP:
    case CC:
    case BCC:
    case ATTACH:
    case SUBJECT:
    case BODY:
    case HTMLBODY:
    case NUMBER:
    case COLUMN:
    case ERR:
    case LOG:
    case OUT:
    case PIPE:
    case INPUT:
    case OUTPUT:
    case NEEDSYSTEMIN:
    case MANIFEST:
    case EXCEPT:
    case SETFILETIME:
    case SETREADONLY:
    case SETREADWRITE:
    case TARGET:
    case AFTER:
    case STARTING:
    case XML:
    case SYSTEMID:
    case OUTPUTPROPERTIES:
    case PARAMETERS:
    case XMLNS:
    case IDENTIFIER:
      LabelName();
                     label = setCurrentLabel();
      jj_consume_token(COLON);
      break;
    default:
      jj_la1[187] = jj_gen;
      ;
    }
    jj_consume_token(DO);
                     lineNo = token.endLine;
    SimpleBlock(null,false);
    jj_consume_token(WHILE);
    Expression();
    jj_consume_token(SEMICOLON);
    Expr cond = nonAssignExpr(stack.pop());
    stack.push( new StmtWhile(lineNo,label,(BlockSimple)stack.pop(),cond,true) );
    if (label != null) labelStack.pop();
  }

  final public void RepeatStatement() throws ParseException {
  int     lineNo;
  Expr    count = null;
  String  label = null;
  BlockSimple stmt = null;
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case AS:
    case ELIF:
    case EXTENDSJAVA:
    case IFDEF:
    case IFNDEF:
    case IFEXISTS:
    case IN:
    case INTO:
    case LIMIT:
    case NAMESPACE:
    case _SKIP:
    case CC:
    case BCC:
    case ATTACH:
    case SUBJECT:
    case BODY:
    case HTMLBODY:
    case NUMBER:
    case COLUMN:
    case ERR:
    case LOG:
    case OUT:
    case PIPE:
    case INPUT:
    case OUTPUT:
    case NEEDSYSTEMIN:
    case MANIFEST:
    case EXCEPT:
    case SETFILETIME:
    case SETREADONLY:
    case SETREADWRITE:
    case TARGET:
    case AFTER:
    case STARTING:
    case XML:
    case SYSTEMID:
    case OUTPUTPROPERTIES:
    case PARAMETERS:
    case XMLNS:
    case IDENTIFIER:
      LabelName();
                            label = setCurrentLabel();
      jj_consume_token(COLON);
      break;
    default:
      jj_la1[188] = jj_gen;
      ;
    }
                            lineNo = token.endLine;
    jj_consume_token(REPEAT);
    Expression();
                            stmt = new StmtForFrom(lineNo,label,JudoUtil.genTempVarName("_?rEpEaT_"),
                                                   ConstInt.ONE,reduceIt(),ConstInt.ONE,false);
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case IDENTIFIER:
      id("times");
      break;
    default:
      jj_la1[189] = jj_gen;
      ;
    }
    SimpleBlock(null,false);
                            stmt.setStmts((BlockSimple)stack.pop());
                            stack.push(stmt);
                            if (label != null) labelStack.pop();
  }

  final public void ForStatement() throws ParseException {
  String  label = null;
  int     lineNo;
  BlockSimple stmt;
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case AS:
    case ELIF:
    case EXTENDSJAVA:
    case IFDEF:
    case IFNDEF:
    case IFEXISTS:
    case IN:
    case INTO:
    case LIMIT:
    case NAMESPACE:
    case _SKIP:
    case CC:
    case BCC:
    case ATTACH:
    case SUBJECT:
    case BODY:
    case HTMLBODY:
    case NUMBER:
    case COLUMN:
    case ERR:
    case LOG:
    case OUT:
    case PIPE:
    case INPUT:
    case OUTPUT:
    case NEEDSYSTEMIN:
    case MANIFEST:
    case EXCEPT:
    case SETFILETIME:
    case SETREADONLY:
    case SETREADWRITE:
    case TARGET:
    case AFTER:
    case STARTING:
    case XML:
    case SYSTEMID:
    case OUTPUTPROPERTIES:
    case PARAMETERS:
    case XMLNS:
    case IDENTIFIER:
      LabelName();
                            label = setCurrentLabel();
      jj_consume_token(COLON);
      break;
    default:
      jj_la1[190] = jj_gen;
      ;
    }
    jj_consume_token(FOR);
                            lineNo = token.endLine;
    if (jj_2_56(2147483647)) {
      stmt = _ForInClause(lineNo,label);
      SimpleBlock(null,false);
                                  stmt.setStmts((BlockSimple)stack.pop());
    } else if (jj_2_57(2147483647)) {
      jj_consume_token(LPAREN);
      stmt = _ForInClause(lineNo,label);
      jj_consume_token(RPAREN);
      Statement();
                  stmt.setStmts((Stmt)stack.pop());
    } else if (jj_2_58(2147483647)) {
      stmt = _ForFromToClause(lineNo,label);
      SimpleBlock(null,false);
                                  stmt.setStmts((BlockSimple)stack.pop());
    } else if (jj_2_59(2147483647)) {
      jj_consume_token(LPAREN);
      stmt = _ForFromToClause(lineNo,label);
      jj_consume_token(RPAREN);
      Statement();
                  stmt.setStmts((Stmt)stack.pop());
    } else if (jj_2_60(2147483647)) {
      jj_consume_token(LPAREN);
      stmt = _ForClause(lineNo,label);
      jj_consume_token(RPAREN);
      Statement();
                  stmt.setStmts((Stmt)stack.pop());
    } else {
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case JAVA__:
      case _EOF:
      case __EOF:
      case AS:
      case DEFINED:
      case ELIF:
      case EXTENDSJAVA:
      case FALSE:
      case JAVACLASS:
      case IFDEF:
      case IFNDEF:
      case IFEXISTS:
      case IN:
      case INFINITY:
      case INTO:
      case NEW:
      case JAVANEW:
      case MAX_NUMBER:
      case MIN_NUMBER:
      case NULL:
      case LIMIT:
      case NAMESPACE:
      case _SKIP:
      case SUPER:
      case THIS:
      case TYPEOF:
      case ATTRIBUTESOF:
      case TRUE:
      case UNDEFINED:
      case BOOLEAN:
      case BYTE:
      case CHAR:
      case SHORT:
      case INT:
      case LONG:
      case FLOAT:
      case DOUBLE:
      case MAIL__CONNECT:
      case MAIL__DISCONNECT:
      case CC:
      case BCC:
      case ATTACH:
      case SUBJECT:
      case BODY:
      case HTMLBODY:
      case DATE_:
      case DATE:
      case NUMBER:
      case COLUMN:
      case ERR:
      case LOG:
      case NL:
      case OUT:
      case PIPE:
      case INPUT:
      case OUTPUT:
      case NEEDSYSTEMIN:
      case MANIFEST:
      case EXCEPT:
      case SETFILETIME:
      case SETREADONLY:
      case SETREADWRITE:
      case TARGET:
      case DB__DISCONNECT:
      case HIB__ADDCLASS:
      case HIB__ADDRESOURCE:
      case HIB__CLOSE:
      case HIB__TXBEGIN:
      case HIB__TXEND:
      case HIB__TXABORT:
      case HIB__LOCK:
      case HIB__DELETE:
      case HIB__GET:
      case HIB__SAVE:
      case HIB__SAVEORUPDATECOPY:
      case HIB__UNLOCK:
      case HIB__UPDATE:
      case AFTER:
      case STARTING:
      case XML:
      case SYSTEMID:
      case OUTPUTPROPERTIES:
      case PARAMETERS:
      case XMLNS:
      case INTEGER_LITERAL:
      case FLOATING_POINT_LITERAL:
      case STRING_LITERAL:
      case EXEC_RESULT_LITERAL:
      case EXEC_RESULTLINES_LITERAL:
      case IDENTIFIER:
      case CONST_NAME:
      case BANG:
      case TILDE:
      case COLONCOLON:
      case INCR:
      case DECR:
      case PLUS:
      case MINUS:
      case BIT_AND:
      case DOLLARLBRACE:
      case LPAREN:
      case SEMICOLON:
        stmt = _ForClause(lineNo,label);
        SimpleBlock(null,false);
                                  stmt.setStmts((BlockSimple)stack.pop());
        break;
      default:
        jj_la1[191] = jj_gen;
        jj_consume_token(-1);
        throw new ParseException();
      }
    }
    stack.push(stmt);
    if (label != null) labelStack.pop();
  }

  final public StmtFor _ForClause(int lineNo, String label) throws ParseException {
  Expr[]  forInit  = null;
  Expr[]  forNext  = null;
  Expr    forCond  = null;
  int     lastMark = markStack();
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case JAVA__:
    case _EOF:
    case __EOF:
    case AS:
    case DEFINED:
    case ELIF:
    case EXTENDSJAVA:
    case FALSE:
    case JAVACLASS:
    case IFDEF:
    case IFNDEF:
    case IFEXISTS:
    case IN:
    case INFINITY:
    case INTO:
    case NEW:
    case JAVANEW:
    case MAX_NUMBER:
    case MIN_NUMBER:
    case NULL:
    case LIMIT:
    case NAMESPACE:
    case _SKIP:
    case SUPER:
    case THIS:
    case TYPEOF:
    case ATTRIBUTESOF:
    case TRUE:
    case UNDEFINED:
    case BOOLEAN:
    case BYTE:
    case CHAR:
    case SHORT:
    case INT:
    case LONG:
    case FLOAT:
    case DOUBLE:
    case MAIL__CONNECT:
    case MAIL__DISCONNECT:
    case CC:
    case BCC:
    case ATTACH:
    case SUBJECT:
    case BODY:
    case HTMLBODY:
    case DATE_:
    case DATE:
    case NUMBER:
    case COLUMN:
    case ERR:
    case LOG:
    case NL:
    case OUT:
    case PIPE:
    case INPUT:
    case OUTPUT:
    case NEEDSYSTEMIN:
    case MANIFEST:
    case EXCEPT:
    case SETFILETIME:
    case SETREADONLY:
    case SETREADWRITE:
    case TARGET:
    case DB__DISCONNECT:
    case HIB__ADDCLASS:
    case HIB__ADDRESOURCE:
    case HIB__CLOSE:
    case HIB__TXBEGIN:
    case HIB__TXEND:
    case HIB__TXABORT:
    case HIB__LOCK:
    case HIB__DELETE:
    case HIB__GET:
    case HIB__SAVE:
    case HIB__SAVEORUPDATECOPY:
    case HIB__UNLOCK:
    case HIB__UPDATE:
    case AFTER:
    case STARTING:
    case XML:
    case SYSTEMID:
    case OUTPUTPROPERTIES:
    case PARAMETERS:
    case XMLNS:
    case INTEGER_LITERAL:
    case FLOATING_POINT_LITERAL:
    case STRING_LITERAL:
    case EXEC_RESULT_LITERAL:
    case EXEC_RESULTLINES_LITERAL:
    case IDENTIFIER:
    case CONST_NAME:
    case BANG:
    case TILDE:
    case COLONCOLON:
    case INCR:
    case DECR:
    case PLUS:
    case MINUS:
    case BIT_AND:
    case DOLLARLBRACE:
    case LPAREN:
      ExpressionList();
      break;
    default:
      jj_la1[192] = jj_gen;
      ;
    }
    jj_consume_token(SEMICOLON);
                             forInit = handleExprs(lastMark);
                             lastMark = markStack();
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case JAVA__:
    case _EOF:
    case __EOF:
    case AS:
    case DEFINED:
    case ELIF:
    case EXTENDSJAVA:
    case FALSE:
    case JAVACLASS:
    case IFDEF:
    case IFNDEF:
    case IFEXISTS:
    case IN:
    case INFINITY:
    case INTO:
    case NEW:
    case JAVANEW:
    case MAX_NUMBER:
    case MIN_NUMBER:
    case NULL:
    case LIMIT:
    case NAMESPACE:
    case _SKIP:
    case SUPER:
    case THIS:
    case TYPEOF:
    case ATTRIBUTESOF:
    case TRUE:
    case UNDEFINED:
    case BOOLEAN:
    case BYTE:
    case CHAR:
    case SHORT:
    case INT:
    case LONG:
    case FLOAT:
    case DOUBLE:
    case MAIL__CONNECT:
    case MAIL__DISCONNECT:
    case CC:
    case BCC:
    case ATTACH:
    case SUBJECT:
    case BODY:
    case HTMLBODY:
    case DATE_:
    case DATE:
    case NUMBER:
    case COLUMN:
    case ERR:
    case LOG:
    case NL:
    case OUT:
    case PIPE:
    case INPUT:
    case OUTPUT:
    case NEEDSYSTEMIN:
    case MANIFEST:
    case EXCEPT:
    case SETFILETIME:
    case SETREADONLY:
    case SETREADWRITE:
    case TARGET:
    case DB__DISCONNECT:
    case HIB__ADDCLASS:
    case HIB__ADDRESOURCE:
    case HIB__CLOSE:
    case HIB__TXBEGIN:
    case HIB__TXEND:
    case HIB__TXABORT:
    case HIB__LOCK:
    case HIB__DELETE:
    case HIB__GET:
    case HIB__SAVE:
    case HIB__SAVEORUPDATECOPY:
    case HIB__UNLOCK:
    case HIB__UPDATE:
    case AFTER:
    case STARTING:
    case XML:
    case SYSTEMID:
    case OUTPUTPROPERTIES:
    case PARAMETERS:
    case XMLNS:
    case INTEGER_LITERAL:
    case FLOATING_POINT_LITERAL:
    case STRING_LITERAL:
    case EXEC_RESULT_LITERAL:
    case EXEC_RESULTLINES_LITERAL:
    case IDENTIFIER:
    case CONST_NAME:
    case BANG:
    case TILDE:
    case COLONCOLON:
    case INCR:
    case DECR:
    case PLUS:
    case MINUS:
    case BIT_AND:
    case DOLLARLBRACE:
    case LPAREN:
      Expression();
      break;
    default:
      jj_la1[193] = jj_gen;
      ;
    }
    jj_consume_token(SEMICOLON);
                             forCond = reduce(handleSingleExpr(lastMark));
                             lastMark = markStack();
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case JAVA__:
    case _EOF:
    case __EOF:
    case AS:
    case DEFINED:
    case ELIF:
    case EXTENDSJAVA:
    case FALSE:
    case JAVACLASS:
    case IFDEF:
    case IFNDEF:
    case IFEXISTS:
    case IN:
    case INFINITY:
    case INTO:
    case NEW:
    case JAVANEW:
    case MAX_NUMBER:
    case MIN_NUMBER:
    case NULL:
    case LIMIT:
    case NAMESPACE:
    case _SKIP:
    case SUPER:
    case THIS:
    case TYPEOF:
    case ATTRIBUTESOF:
    case TRUE:
    case UNDEFINED:
    case BOOLEAN:
    case BYTE:
    case CHAR:
    case SHORT:
    case INT:
    case LONG:
    case FLOAT:
    case DOUBLE:
    case MAIL__CONNECT:
    case MAIL__DISCONNECT:
    case CC:
    case BCC:
    case ATTACH:
    case SUBJECT:
    case BODY:
    case HTMLBODY:
    case DATE_:
    case DATE:
    case NUMBER:
    case COLUMN:
    case ERR:
    case LOG:
    case NL:
    case OUT:
    case PIPE:
    case INPUT:
    case OUTPUT:
    case NEEDSYSTEMIN:
    case MANIFEST:
    case EXCEPT:
    case SETFILETIME:
    case SETREADONLY:
    case SETREADWRITE:
    case TARGET:
    case DB__DISCONNECT:
    case HIB__ADDCLASS:
    case HIB__ADDRESOURCE:
    case HIB__CLOSE:
    case HIB__TXBEGIN:
    case HIB__TXEND:
    case HIB__TXABORT:
    case HIB__LOCK:
    case HIB__DELETE:
    case HIB__GET:
    case HIB__SAVE:
    case HIB__SAVEORUPDATECOPY:
    case HIB__UNLOCK:
    case HIB__UPDATE:
    case AFTER:
    case STARTING:
    case XML:
    case SYSTEMID:
    case OUTPUTPROPERTIES:
    case PARAMETERS:
    case XMLNS:
    case INTEGER_LITERAL:
    case FLOATING_POINT_LITERAL:
    case STRING_LITERAL:
    case EXEC_RESULT_LITERAL:
    case EXEC_RESULTLINES_LITERAL:
    case IDENTIFIER:
    case CONST_NAME:
    case BANG:
    case TILDE:
    case COLONCOLON:
    case INCR:
    case DECR:
    case PLUS:
    case MINUS:
    case BIT_AND:
    case DOLLARLBRACE:
    case LPAREN:
      ExpressionList();
      break;
    default:
      jj_la1[194] = jj_gen;
      ;
    }
                             forNext = handleExprs(lastMark);
                             {if (true) return new StmtFor(lineNo,label,forInit,forCond,forNext,null);}
    throw new Error("Missing return statement in function");
  }

  final public StmtForFrom _ForFromToClause(int lineNo, String label) throws ParseException {
  String varName = null;
  Expr from = null;
  Expr to   = null;
  Expr step = null;
  boolean backward = false;
  boolean upto = false;
    jj_consume_token(IDENTIFIER);
                              varName = token.image;
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case FROM:
      jj_consume_token(FROM);
      Expression();
                              from = reduceIt();
      break;
    default:
      jj_la1[195] = jj_gen;
      ;
    }
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case TO:
      jj_consume_token(TO);
      break;
    case UPTO:
      jj_consume_token(UPTO);
                              upto = true;
      break;
    case DOWNTO:
      jj_consume_token(DOWNTO);
                              backward = true;
      break;
    default:
      jj_la1[196] = jj_gen;
      jj_consume_token(-1);
      throw new ParseException();
    }
    Expression();
                              to = reduceIt();
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case IDENTIFIER:
      id("step");
      Expression();
                              step = reduceIt();
      break;
    default:
      jj_la1[197] = jj_gen;
      ;
    }
                              {if (true) return new StmtForFrom(lineNo,label,varName,from,to,step,upto,backward);}
    throw new Error("Missing return statement in function");
  }

  final public StmtForIn _ForInClause(int lineNo, String label) throws ParseException {
  String varName = null;
  Expr col = null;
  Expr from = null;
  Expr to   = null;
  Expr step = null;
  boolean backward = false;
  boolean upto = false;
    jj_consume_token(IDENTIFIER);
                                  varName = token.image;
    jj_consume_token(IN);
    ReturnableExpression();
                                  col = reduceIt();
    if (jj_2_61(2)) {
      id("backward");
                                  backward = true;
    } else {
      ;
    }
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case FROM:
      jj_consume_token(FROM);
      Expression();
                              from = reduceIt();
                              if (backward)
                                throwParseException(
                                  "'from' can not be used after 'backward', line "+lineNum());
      break;
    default:
      jj_la1[198] = jj_gen;
      ;
    }
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case TO:
    case UPTO:
    case DOWNTO:
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case TO:
        jj_consume_token(TO);
        break;
      case UPTO:
        jj_consume_token(UPTO);
                              upto = true;
        break;
      case DOWNTO:
        jj_consume_token(DOWNTO);
                              if (backward)
                                throwParseException(
                                  "'to'/'downto' can not be used after 'backward', line "+lineNum());
                              backward = true;
        break;
      default:
        jj_la1[199] = jj_gen;
        jj_consume_token(-1);
        throw new ParseException();
      }
      Expression();
                              to = reduceIt();
      break;
    default:
      jj_la1[200] = jj_gen;
      ;
    }
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case IDENTIFIER:
      id("step");
      Expression();
                              step = reduceIt();
      break;
    default:
      jj_la1[201] = jj_gen;
      ;
    }
                              {if (true) return new StmtForIn(lineNo,label,varName,col,from,to,step,upto,backward);}
    throw new Error("Missing return statement in function");
  }

  final public void ExpressionList() throws ParseException {
    Expression();
                       stack.push(reduceIt());
    label_49:
    while (true) {
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case COMMA:
        ;
        break;
      default:
        jj_la1[202] = jj_gen;
        break label_49;
      }
      jj_consume_token(COMMA);
      Expression();
                       stack.push(reduceIt());
    }
  }

  final public void ReturnableExpression() throws ParseException {
  // Handle set:
  int lastMark = markStack();
  Object cptr = null;
  int lineNo;
    if (jj_2_63(2147483647)) {
      ArrayAllocator();
    } else if (jj_2_64(2147483647)) {
      AnonFunctionDecl1();
    } else {
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case FUNCTION:
      case LAMBDA:
        AnonFunctionDecl();
        break;
      case JAVA__:
      case _EOF:
      case __EOF:
      case AS:
      case DEFINED:
      case ELIF:
      case EXTENDSJAVA:
      case FALSE:
      case JAVACLASS:
      case IFDEF:
      case IFNDEF:
      case IFEXISTS:
      case IN:
      case INFINITY:
      case INTO:
      case NEW:
      case JAVANEW:
      case MAX_NUMBER:
      case MIN_NUMBER:
      case NULL:
      case LIMIT:
      case NAMESPACE:
      case _SKIP:
      case SUPER:
      case THIS:
      case TYPEOF:
      case ATTRIBUTESOF:
      case TRUE:
      case UNDEFINED:
      case BOOLEAN:
      case BYTE:
      case CHAR:
      case SHORT:
      case INT:
      case LONG:
      case FLOAT:
      case DOUBLE:
      case MAIL__CONNECT:
      case MAIL__DISCONNECT:
      case CC:
      case BCC:
      case ATTACH:
      case SUBJECT:
      case BODY:
      case HTMLBODY:
      case DATE_:
      case DATE:
      case NUMBER:
      case COLUMN:
      case ERR:
      case LOG:
      case NL:
      case OUT:
      case PIPE:
      case INPUT:
      case OUTPUT:
      case NEEDSYSTEMIN:
      case MANIFEST:
      case EXCEPT:
      case SETFILETIME:
      case SETREADONLY:
      case SETREADWRITE:
      case TARGET:
      case DB__DISCONNECT:
      case HIB__ADDCLASS:
      case HIB__ADDRESOURCE:
      case HIB__CLOSE:
      case HIB__TXBEGIN:
      case HIB__TXEND:
      case HIB__TXABORT:
      case HIB__LOCK:
      case HIB__DELETE:
      case HIB__GET:
      case HIB__SAVE:
      case HIB__SAVEORUPDATECOPY:
      case HIB__UNLOCK:
      case HIB__UPDATE:
      case AFTER:
      case STARTING:
      case XML:
      case SYSTEMID:
      case OUTPUTPROPERTIES:
      case PARAMETERS:
      case XMLNS:
      case INTEGER_LITERAL:
      case FLOATING_POINT_LITERAL:
      case STRING_LITERAL:
      case EXEC_RESULT_LITERAL:
      case EXEC_RESULTLINES_LITERAL:
      case IDENTIFIER:
      case CONST_NAME:
      case BANG:
      case TILDE:
      case COLONCOLON:
      case INCR:
      case DECR:
      case PLUS:
      case MINUS:
      case BIT_AND:
      case DOLLARLBRACE:
      case LPAREN:
        Expression();
        break;
      case SET_:
      case SET:
        upgradeToSet();
        cptr = ComparatorDecl();
        jj_consume_token(LBRACKET);
        switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
        case JAVA__:
        case _EOF:
        case __EOF:
        case AS:
        case DEFINED:
        case ELIF:
        case EXTENDSJAVA:
        case FALSE:
        case JAVACLASS:
        case IFDEF:
        case IFNDEF:
        case IFEXISTS:
        case IN:
        case INFINITY:
        case INTO:
        case NEW:
        case JAVANEW:
        case MAX_NUMBER:
        case MIN_NUMBER:
        case NULL:
        case LIMIT:
        case NAMESPACE:
        case _SKIP:
        case SUPER:
        case THIS:
        case TYPEOF:
        case ATTRIBUTESOF:
        case TRUE:
        case UNDEFINED:
        case BOOLEAN:
        case BYTE:
        case CHAR:
        case SHORT:
        case INT:
        case LONG:
        case FLOAT:
        case DOUBLE:
        case MAIL__CONNECT:
        case MAIL__DISCONNECT:
        case CC:
        case BCC:
        case ATTACH:
        case SUBJECT:
        case BODY:
        case HTMLBODY:
        case DATE_:
        case DATE:
        case NUMBER:
        case COLUMN:
        case ERR:
        case LOG:
        case NL:
        case OUT:
        case PIPE:
        case INPUT:
        case OUTPUT:
        case NEEDSYSTEMIN:
        case MANIFEST:
        case EXCEPT:
        case SETFILETIME:
        case SETREADONLY:
        case SETREADWRITE:
        case TARGET:
        case DB__DISCONNECT:
        case HIB__ADDCLASS:
        case HIB__ADDRESOURCE:
        case HIB__CLOSE:
        case HIB__TXBEGIN:
        case HIB__TXEND:
        case HIB__TXABORT:
        case HIB__LOCK:
        case HIB__DELETE:
        case HIB__GET:
        case HIB__SAVE:
        case HIB__SAVEORUPDATECOPY:
        case HIB__UNLOCK:
        case HIB__UPDATE:
        case AFTER:
        case STARTING:
        case XML:
        case SYSTEMID:
        case OUTPUTPROPERTIES:
        case PARAMETERS:
        case XMLNS:
        case INTEGER_LITERAL:
        case FLOATING_POINT_LITERAL:
        case STRING_LITERAL:
        case EXEC_RESULT_LITERAL:
        case EXEC_RESULTLINES_LITERAL:
        case IDENTIFIER:
        case CONST_NAME:
        case BANG:
        case TILDE:
        case COLONCOLON:
        case INCR:
        case DECR:
        case PLUS:
        case MINUS:
        case BIT_AND:
        case DOLLARLBRACE:
        case LPAREN:
          Expression();
          label_50:
          while (true) {
            if (jj_2_62(2)) {
              ;
            } else {
              break label_50;
            }
            jj_consume_token(COMMA);
            Expression();
          }
          break;
        default:
          jj_la1[203] = jj_gen;
          ;
        }
        switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
        case COMMA:
          jj_consume_token(COMMA);
          break;
        default:
          jj_la1[204] = jj_gen;
          ;
        }
        jj_consume_token(RBRACKET);
    stack.push( new NewObject("Set", new Doublet(cptr,handleExprs(lastMark))) );
        break;
      case HEREDOC_BEGIN:
      case HEREDOC_BEGIN_:
        HereDoc();
        break;
      case DO:
        Dom();
        break;
      case WSDL__:
        WSDLAllocator();
        break;
      case LBRACE:
        jj_consume_token(LBRACE);
        lineNo=lineNum();
        MemberInitList1();
        jj_consume_token(RBRACE);
    NewObject no = new NewObject(null, handleNamedExprs(lastMark));
    no.setLineNumber(lineNo);
    stack.push(no);
        break;
      case VOID:
        jj_consume_token(VOID);
        Expression();
                         stack.pop(); stack.push(ValueSpecial.UNDEFINED);
        break;
      case XML__:
        jj_consume_token(XML__);
        XMLLiteral();
                         stack.push( JudoUtil.toVariable(stack.pop()) );
        break;
      default:
        jj_la1[205] = jj_gen;
        jj_consume_token(-1);
        throw new ParseException();
      }
    }
  }

  final public void WSDLAllocator() throws ParseException {
  ExprWSDL expr;
    jj_consume_token(WSDL__);
    Expression();
                                     expr = new ExprWSDL(reduceIt());
    if (jj_2_65(2)) {
      jj_consume_token(COLON);
      Expression();
                                     expr.setServiceName(reduceIt());
    } else {
      ;
    }
                                     stack.push(expr);
  }

  final public void ArrayAllocator() throws ParseException {
  int lastMark = markStack();
  boolean isList = false;
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case LINKEDLIST_:
    case LINKEDLIST:
      upgradeToLinkedList();
                             isList=true;
      break;
    default:
      jj_la1[206] = jj_gen;
      ;
    }
    jj_consume_token(LBRACKET);
    if (jj_2_67(2147483647)) {
      Expression();
      jj_consume_token(DOTDOT);
      Expression();
      stack.push( new NewRangeArray(reduceIt(), reduceIt()) );
    } else {
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case JAVA__:
      case _EOF:
      case __EOF:
      case AS:
      case DEFINED:
      case DO:
      case ELIF:
      case EXTENDSJAVA:
      case FALSE:
      case JAVACLASS:
      case IFDEF:
      case IFNDEF:
      case IFEXISTS:
      case IN:
      case INFINITY:
      case INTO:
      case NEW:
      case JAVANEW:
      case MAX_NUMBER:
      case MIN_NUMBER:
      case NULL:
      case LIMIT:
      case NAMESPACE:
      case _SKIP:
      case SUPER:
      case THIS:
      case TYPEOF:
      case ATTRIBUTESOF:
      case TRUE:
      case UNDEFINED:
      case BOOLEAN:
      case BYTE:
      case CHAR:
      case SHORT:
      case INT:
      case LONG:
      case FLOAT:
      case DOUBLE:
      case MAIL__CONNECT:
      case MAIL__DISCONNECT:
      case CC:
      case BCC:
      case ATTACH:
      case SUBJECT:
      case BODY:
      case HTMLBODY:
      case LINKEDLIST_:
      case LINKEDLIST:
      case DATE_:
      case DATE:
      case NUMBER:
      case COLUMN:
      case ERR:
      case LOG:
      case NL:
      case OUT:
      case PIPE:
      case INPUT:
      case OUTPUT:
      case NEEDSYSTEMIN:
      case MANIFEST:
      case EXCEPT:
      case SETFILETIME:
      case SETREADONLY:
      case SETREADWRITE:
      case TARGET:
      case DB__DISCONNECT:
      case HIB__ADDCLASS:
      case HIB__ADDRESOURCE:
      case HIB__CLOSE:
      case HIB__TXBEGIN:
      case HIB__TXEND:
      case HIB__TXABORT:
      case HIB__LOCK:
      case HIB__DELETE:
      case HIB__GET:
      case HIB__SAVE:
      case HIB__SAVEORUPDATECOPY:
      case HIB__UNLOCK:
      case HIB__UPDATE:
      case AFTER:
      case STARTING:
      case XML:
      case SYSTEMID:
      case OUTPUTPROPERTIES:
      case PARAMETERS:
      case XMLNS:
      case INTEGER_LITERAL:
      case FLOATING_POINT_LITERAL:
      case STRING_LITERAL:
      case EXEC_RESULT_LITERAL:
      case EXEC_RESULTLINES_LITERAL:
      case IDENTIFIER:
      case CONST_NAME:
      case BANG:
      case TILDE:
      case HEREDOC_BEGIN:
      case HEREDOC_BEGIN_:
      case COLONCOLON:
      case INCR:
      case DECR:
      case PLUS:
      case MINUS:
      case BIT_AND:
      case DOLLARLBRACE:
      case LPAREN:
      case LBRACKET:
        switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
        case LINKEDLIST_:
        case LINKEDLIST:
        case LBRACKET:
          ArrayAllocator();
          break;
        case JAVA__:
        case _EOF:
        case __EOF:
        case AS:
        case DEFINED:
        case ELIF:
        case EXTENDSJAVA:
        case FALSE:
        case JAVACLASS:
        case IFDEF:
        case IFNDEF:
        case IFEXISTS:
        case IN:
        case INFINITY:
        case INTO:
        case NEW:
        case JAVANEW:
        case MAX_NUMBER:
        case MIN_NUMBER:
        case NULL:
        case LIMIT:
        case NAMESPACE:
        case _SKIP:
        case SUPER:
        case THIS:
        case TYPEOF:
        case ATTRIBUTESOF:
        case TRUE:
        case UNDEFINED:
        case BOOLEAN:
        case BYTE:
        case CHAR:
        case SHORT:
        case INT:
        case LONG:
        case FLOAT:
        case DOUBLE:
        case MAIL__CONNECT:
        case MAIL__DISCONNECT:
        case CC:
        case BCC:
        case ATTACH:
        case SUBJECT:
        case BODY:
        case HTMLBODY:
        case DATE_:
        case DATE:
        case NUMBER:
        case COLUMN:
        case ERR:
        case LOG:
        case NL:
        case OUT:
        case PIPE:
        case INPUT:
        case OUTPUT:
        case NEEDSYSTEMIN:
        case MANIFEST:
        case EXCEPT:
        case SETFILETIME:
        case SETREADONLY:
        case SETREADWRITE:
        case TARGET:
        case DB__DISCONNECT:
        case HIB__ADDCLASS:
        case HIB__ADDRESOURCE:
        case HIB__CLOSE:
        case HIB__TXBEGIN:
        case HIB__TXEND:
        case HIB__TXABORT:
        case HIB__LOCK:
        case HIB__DELETE:
        case HIB__GET:
        case HIB__SAVE:
        case HIB__SAVEORUPDATECOPY:
        case HIB__UNLOCK:
        case HIB__UPDATE:
        case AFTER:
        case STARTING:
        case XML:
        case SYSTEMID:
        case OUTPUTPROPERTIES:
        case PARAMETERS:
        case XMLNS:
        case INTEGER_LITERAL:
        case FLOATING_POINT_LITERAL:
        case STRING_LITERAL:
        case EXEC_RESULT_LITERAL:
        case EXEC_RESULTLINES_LITERAL:
        case IDENTIFIER:
        case CONST_NAME:
        case BANG:
        case TILDE:
        case COLONCOLON:
        case INCR:
        case DECR:
        case PLUS:
        case MINUS:
        case BIT_AND:
        case DOLLARLBRACE:
        case LPAREN:
          Expression();
          break;
        case HEREDOC_BEGIN:
        case HEREDOC_BEGIN_:
          HereDoc();
          break;
        case DO:
          Dom();
          break;
        default:
          jj_la1[207] = jj_gen;
          jj_consume_token(-1);
          throw new ParseException();
        }
        label_51:
        while (true) {
          if (jj_2_66(2)) {
            ;
          } else {
            break label_51;
          }
          jj_consume_token(COMMA);
          switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
          case LINKEDLIST_:
          case LINKEDLIST:
          case LBRACKET:
            ArrayAllocator();
            break;
          case JAVA__:
          case _EOF:
          case __EOF:
          case AS:
          case DEFINED:
          case ELIF:
          case EXTENDSJAVA:
          case FALSE:
          case JAVACLASS:
          case IFDEF:
          case IFNDEF:
          case IFEXISTS:
          case IN:
          case INFINITY:
          case INTO:
          case NEW:
          case JAVANEW:
          case MAX_NUMBER:
          case MIN_NUMBER:
          case NULL:
          case LIMIT:
          case NAMESPACE:
          case _SKIP:
          case SUPER:
          case THIS:
          case TYPEOF:
          case ATTRIBUTESOF:
          case TRUE:
          case UNDEFINED:
          case BOOLEAN:
          case BYTE:
          case CHAR:
          case SHORT:
          case INT:
          case LONG:
          case FLOAT:
          case DOUBLE:
          case MAIL__CONNECT:
          case MAIL__DISCONNECT:
          case CC:
          case BCC:
          case ATTACH:
          case SUBJECT:
          case BODY:
          case HTMLBODY:
          case DATE_:
          case DATE:
          case NUMBER:
          case COLUMN:
          case ERR:
          case LOG:
          case NL:
          case OUT:
          case PIPE:
          case INPUT:
          case OUTPUT:
          case NEEDSYSTEMIN:
          case MANIFEST:
          case EXCEPT:
          case SETFILETIME:
          case SETREADONLY:
          case SETREADWRITE:
          case TARGET:
          case DB__DISCONNECT:
          case HIB__ADDCLASS:
          case HIB__ADDRESOURCE:
          case HIB__CLOSE:
          case HIB__TXBEGIN:
          case HIB__TXEND:
          case HIB__TXABORT:
          case HIB__LOCK:
          case HIB__DELETE:
          case HIB__GET:
          case HIB__SAVE:
          case HIB__SAVEORUPDATECOPY:
          case HIB__UNLOCK:
          case HIB__UPDATE:
          case AFTER:
          case STARTING:
          case XML:
          case SYSTEMID:
          case OUTPUTPROPERTIES:
          case PARAMETERS:
          case XMLNS:
          case INTEGER_LITERAL:
          case FLOATING_POINT_LITERAL:
          case STRING_LITERAL:
          case EXEC_RESULT_LITERAL:
          case EXEC_RESULTLINES_LITERAL:
          case IDENTIFIER:
          case CONST_NAME:
          case BANG:
          case TILDE:
          case COLONCOLON:
          case INCR:
          case DECR:
          case PLUS:
          case MINUS:
          case BIT_AND:
          case DOLLARLBRACE:
          case LPAREN:
            Expression();
            break;
          case HEREDOC_BEGIN:
          case HEREDOC_BEGIN_:
            HereDoc();
            break;
          case DO:
            Dom();
            break;
          default:
            jj_la1[208] = jj_gen;
            jj_consume_token(-1);
            throw new ParseException();
          }
        }
        break;
      default:
        jj_la1[209] = jj_gen;
        ;
      }
      stack.push( new NewObject(isList?"LinkedList":"Array", handleExprs(lastMark)) );
    }
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case COMMA:
      jj_consume_token(COMMA);
      break;
    default:
      jj_la1[210] = jj_gen;
      ;
    }
    jj_consume_token(RBRACKET);
  }

  final public Object ComparatorDecl() throws ParseException {
  int sortType = 0;
    if (jj_2_69(2)) {
      jj_consume_token(LT);
                       sortType = 1;
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case JAVA__:
      case _EOF:
      case __EOF:
      case AS:
      case DEFINED:
      case ELIF:
      case EXTENDSJAVA:
      case FALSE:
      case JAVACLASS:
      case IFDEF:
      case IFNDEF:
      case IFEXISTS:
      case IN:
      case INFINITY:
      case INTO:
      case NEW:
      case JAVANEW:
      case MAX_NUMBER:
      case MIN_NUMBER:
      case NULL:
      case LIMIT:
      case NAMESPACE:
      case _SKIP:
      case SUPER:
      case THIS:
      case TYPEOF:
      case ATTRIBUTESOF:
      case TRUE:
      case UNDEFINED:
      case BOOLEAN:
      case BYTE:
      case CHAR:
      case SHORT:
      case INT:
      case LONG:
      case FLOAT:
      case DOUBLE:
      case STRING:
      case STRING_:
      case MAIL__CONNECT:
      case MAIL__DISCONNECT:
      case CC:
      case BCC:
      case ATTACH:
      case SUBJECT:
      case BODY:
      case HTMLBODY:
      case DATE_:
      case DATE:
      case NUMBER_:
      case NUMBER:
      case COLUMN:
      case ERR:
      case LOG:
      case NL:
      case OUT:
      case PIPE:
      case INPUT:
      case OUTPUT:
      case NEEDSYSTEMIN:
      case MANIFEST:
      case EXCEPT:
      case SETFILETIME:
      case SETREADONLY:
      case SETREADWRITE:
      case TARGET:
      case DB__DISCONNECT:
      case HIB__ADDCLASS:
      case HIB__ADDRESOURCE:
      case HIB__CLOSE:
      case HIB__TXBEGIN:
      case HIB__TXEND:
      case HIB__TXABORT:
      case HIB__LOCK:
      case HIB__DELETE:
      case HIB__GET:
      case HIB__SAVE:
      case HIB__SAVEORUPDATECOPY:
      case HIB__UNLOCK:
      case HIB__UPDATE:
      case AFTER:
      case STARTING:
      case XML:
      case SYSTEMID:
      case OUTPUTPROPERTIES:
      case PARAMETERS:
      case XMLNS:
      case INTEGER_LITERAL:
      case FLOATING_POINT_LITERAL:
      case STRING_LITERAL:
      case EXEC_RESULT_LITERAL:
      case EXEC_RESULTLINES_LITERAL:
      case IDENTIFIER:
      case CONST_NAME:
      case BANG:
      case TILDE:
      case COLONCOLON:
      case INCR:
      case DECR:
      case PLUS:
      case MINUS:
      case BIT_AND:
      case DOLLARLBRACE:
      case LPAREN:
        if (jj_2_68(2)) {
          switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
          case NUMBER_:
          case NUMBER:
            upgradeToNumber();
                               sortType = 2;
            break;
          case STRING:
          case STRING_:
            upgradeToString();
                               sortType = 3;
            break;
          case DATE_:
          case DATE:
            upgradeToDate();
                               sortType = 4;
            break;
          default:
            jj_la1[211] = jj_gen;
            jj_consume_token(-1);
            throw new ParseException();
          }
          switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
          case PLUS:
          case MINUS:
            switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
            case MINUS:
              jj_consume_token(MINUS);
                       sortType = -sortType;
              break;
            case PLUS:
              jj_consume_token(PLUS);
              break;
            default:
              jj_la1[212] = jj_gen;
              jj_consume_token(-1);
              throw new ParseException();
            }
            break;
          default:
            jj_la1[213] = jj_gen;
            ;
          }
        } else {
          switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
          case JAVA__:
          case _EOF:
          case __EOF:
          case AS:
          case DEFINED:
          case ELIF:
          case EXTENDSJAVA:
          case FALSE:
          case JAVACLASS:
          case IFDEF:
          case IFNDEF:
          case IFEXISTS:
          case IN:
          case INFINITY:
          case INTO:
          case NEW:
          case JAVANEW:
          case MAX_NUMBER:
          case MIN_NUMBER:
          case NULL:
          case LIMIT:
          case NAMESPACE:
          case _SKIP:
          case SUPER:
          case THIS:
          case TYPEOF:
          case ATTRIBUTESOF:
          case TRUE:
          case UNDEFINED:
          case BOOLEAN:
          case BYTE:
          case CHAR:
          case SHORT:
          case INT:
          case LONG:
          case FLOAT:
          case DOUBLE:
          case MAIL__CONNECT:
          case MAIL__DISCONNECT:
          case CC:
          case BCC:
          case ATTACH:
          case SUBJECT:
          case BODY:
          case HTMLBODY:
          case DATE_:
          case DATE:
          case NUMBER:
          case COLUMN:
          case ERR:
          case LOG:
          case NL:
          case OUT:
          case PIPE:
          case INPUT:
          case OUTPUT:
          case NEEDSYSTEMIN:
          case MANIFEST:
          case EXCEPT:
          case SETFILETIME:
          case SETREADONLY:
          case SETREADWRITE:
          case TARGET:
          case DB__DISCONNECT:
          case HIB__ADDCLASS:
          case HIB__ADDRESOURCE:
          case HIB__CLOSE:
          case HIB__TXBEGIN:
          case HIB__TXEND:
          case HIB__TXABORT:
          case HIB__LOCK:
          case HIB__DELETE:
          case HIB__GET:
          case HIB__SAVE:
          case HIB__SAVEORUPDATECOPY:
          case HIB__UNLOCK:
          case HIB__UPDATE:
          case AFTER:
          case STARTING:
          case XML:
          case SYSTEMID:
          case OUTPUTPROPERTIES:
          case PARAMETERS:
          case XMLNS:
          case INTEGER_LITERAL:
          case FLOATING_POINT_LITERAL:
          case STRING_LITERAL:
          case EXEC_RESULT_LITERAL:
          case EXEC_RESULTLINES_LITERAL:
          case IDENTIFIER:
          case CONST_NAME:
          case BANG:
          case TILDE:
          case COLONCOLON:
          case INCR:
          case DECR:
          case PLUS:
          case MINUS:
          case BIT_AND:
          case DOLLARLBRACE:
          case LPAREN:
            Expression();
                       {if (true) return stack.pop();}
            break;
          default:
            jj_la1[214] = jj_gen;
            jj_consume_token(-1);
            throw new ParseException();
          }
        }
        break;
      default:
        jj_la1[215] = jj_gen;
        ;
      }
      jj_consume_token(GT);
    } else {
      ;
    }
    switch(sortType) {
    case 1:  {if (true) return UserDefinedComparator.theNaturalComparator;} break;
    case 2:  {if (true) return UserDefinedComparator.theNumberComparator;} break;
    case 3:  {if (true) return UserDefinedComparator.theStringComparator;} break;
    case 4:  {if (true) return UserDefinedComparator.theDateComparator;} break;
    case -2: {if (true) return UserDefinedComparator.theDescendingNumberComparator;} break;
    case -3: {if (true) return UserDefinedComparator.theDescendingStringComparator;} break;
    case -4: {if (true) return UserDefinedComparator.theDescendingDateComparator;} break;
    default: {if (true) return null;}
    }
    throw new Error("Missing return statement in function");
  }

/*******************************************
 * GENERAL APPLICATION SYNTAX STARTS HERE  *
 *******************************************/
  final public void PrintStatement() throws ParseException {
  int target = PRINT_OUT;
  boolean isFlush = false;
  boolean printLn = false;
  int lastMark = markStack();
  Expr printer = null;
  Expr cond = null;
  String logLevel = null;
  Expr logExcpt = null;
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case FLUSH:
      jj_consume_token(FLUSH);
                             isFlush = true;
      break;
    case PRINT:
      jj_consume_token(PRINT);
      break;
    case PRINTLN:
      jj_consume_token(PRINTLN);
                             printLn = true;
      break;
    case DOT:
      jj_consume_token(DOT);
                             printLn = true;
      break;
    default:
      jj_la1[216] = jj_gen;
      jj_consume_token(-1);
      throw new ParseException();
    }
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case LBRACE:
      jj_consume_token(LBRACE);
      Expression();
                             cond = reduceIt(); lastMark = markStack();
      jj_consume_token(RBRACE);
      break;
    default:
      jj_la1[217] = jj_gen;
      ;
    }
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case LT:
      jj_consume_token(LT);
      if (jj_2_70(2)) {
        jj_consume_token(OUT);
                             target = PRINT_OUT;
      } else if (jj_2_71(2)) {
        jj_consume_token(ERR);
                             target = PRINT_ERR;
      } else if (jj_2_72(2)) {
        jj_consume_token(LOG);
                             target = PRINT_LOG;
        switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
        case COLON:
          jj_consume_token(COLON);
          jj_consume_token(IDENTIFIER);
                             logLevel = token.image.toLowerCase();
          switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
          case LPAREN:
            jj_consume_token(LPAREN);
            Expression();
                             logExcpt = reduceIt();
            jj_consume_token(RPAREN);
            break;
          default:
            jj_la1[218] = jj_gen;
            ;
          }
          break;
        default:
          jj_la1[219] = jj_gen;
          ;
        }
      } else if (jj_2_73(2)) {
        jj_consume_token(PIPE);
                             target = PRINT_PIPE;
      } else {
        switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
        case JAVA__:
        case AS:
        case ELIF:
        case EXTENDSJAVA:
        case JAVACLASS:
        case IFDEF:
        case IFNDEF:
        case IFEXISTS:
        case IN:
        case INTO:
        case NEW:
        case JAVANEW:
        case LIMIT:
        case NAMESPACE:
        case _SKIP:
        case SUPER:
        case THIS:
        case BOOLEAN:
        case BYTE:
        case CHAR:
        case SHORT:
        case INT:
        case LONG:
        case FLOAT:
        case DOUBLE:
        case MAIL__CONNECT:
        case MAIL__DISCONNECT:
        case CC:
        case BCC:
        case ATTACH:
        case SUBJECT:
        case BODY:
        case HTMLBODY:
        case DATE_:
        case DATE:
        case NUMBER:
        case COLUMN:
        case ERR:
        case LOG:
        case OUT:
        case PIPE:
        case INPUT:
        case OUTPUT:
        case NEEDSYSTEMIN:
        case MANIFEST:
        case EXCEPT:
        case SETFILETIME:
        case SETREADONLY:
        case SETREADWRITE:
        case TARGET:
        case DB__DISCONNECT:
        case HIB__ADDCLASS:
        case HIB__ADDRESOURCE:
        case HIB__CLOSE:
        case HIB__TXBEGIN:
        case HIB__TXEND:
        case HIB__TXABORT:
        case HIB__LOCK:
        case HIB__DELETE:
        case HIB__GET:
        case HIB__SAVE:
        case HIB__SAVEORUPDATECOPY:
        case HIB__UNLOCK:
        case HIB__UPDATE:
        case AFTER:
        case STARTING:
        case XML:
        case SYSTEMID:
        case OUTPUTPROPERTIES:
        case PARAMETERS:
        case XMLNS:
        case STRING_LITERAL:
        case IDENTIFIER:
        case CONST_NAME:
        case COLONCOLON:
        case BIT_AND:
        case DOLLARLBRACE:
        case LPAREN:
          PrimaryExpression(false);
                                 target = PRINT_USER;
                                 printer = reduceIt();
                                 lastMark = markStack();
          break;
        default:
          jj_la1[220] = jj_gen;
          jj_consume_token(-1);
          throw new ParseException();
        }
      }
      jj_consume_token(GT);
      break;
    default:
      jj_la1[221] = jj_gen;
      ;
    }
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case JAVA__:
    case _EOF:
    case __EOF:
    case AS:
    case DEFINED:
    case ELIF:
    case EXTENDSJAVA:
    case FALSE:
    case JAVACLASS:
    case IFDEF:
    case IFNDEF:
    case IFEXISTS:
    case IN:
    case INFINITY:
    case INTO:
    case NEW:
    case JAVANEW:
    case MAX_NUMBER:
    case MIN_NUMBER:
    case NULL:
    case LIMIT:
    case NAMESPACE:
    case _SKIP:
    case SUPER:
    case THIS:
    case TYPEOF:
    case ATTRIBUTESOF:
    case TRUE:
    case UNDEFINED:
    case BOOLEAN:
    case BYTE:
    case CHAR:
    case SHORT:
    case INT:
    case LONG:
    case FLOAT:
    case DOUBLE:
    case MAIL__CONNECT:
    case MAIL__DISCONNECT:
    case CC:
    case BCC:
    case ATTACH:
    case SUBJECT:
    case BODY:
    case HTMLBODY:
    case DATE_:
    case DATE:
    case NUMBER:
    case COLUMN:
    case ERR:
    case LOG:
    case NL:
    case OUT:
    case PIPE:
    case INPUT:
    case OUTPUT:
    case NEEDSYSTEMIN:
    case MANIFEST:
    case EXCEPT:
    case SETFILETIME:
    case SETREADONLY:
    case SETREADWRITE:
    case TARGET:
    case DB__DISCONNECT:
    case HIB__ADDCLASS:
    case HIB__ADDRESOURCE:
    case HIB__CLOSE:
    case HIB__TXBEGIN:
    case HIB__TXEND:
    case HIB__TXABORT:
    case HIB__LOCK:
    case HIB__DELETE:
    case HIB__GET:
    case HIB__SAVE:
    case HIB__SAVEORUPDATECOPY:
    case HIB__UNLOCK:
    case HIB__UPDATE:
    case AFTER:
    case STARTING:
    case XML:
    case SYSTEMID:
    case OUTPUTPROPERTIES:
    case PARAMETERS:
    case XMLNS:
    case INTEGER_LITERAL:
    case FLOATING_POINT_LITERAL:
    case STRING_LITERAL:
    case EXEC_RESULT_LITERAL:
    case EXEC_RESULTLINES_LITERAL:
    case IDENTIFIER:
    case CONST_NAME:
    case BANG:
    case TILDE:
    case HEREDOC_BEGIN:
    case HEREDOC_BEGIN_:
    case COLONCOLON:
    case INCR:
    case DECR:
    case PLUS:
    case MINUS:
    case BIT_AND:
    case DOLLARLBRACE:
    case LPAREN:
      PrintArgumentList();
      break;
    default:
      jj_la1[222] = jj_gen;
      ;
    }
    jj_consume_token(SEMICOLON);
    Expr[] params = reduce(handleExprs(lastMark));
    if (!isFlush && !printLn && (params==null)) {if (true) return;} // ignore empty print;
    stack.push(new StmtPrint(lineNum(), printLn, isFlush, target, logLevel, logExcpt, printer, params, cond));
  }

  final public void PrintArgumentList() throws ParseException {
    PrintArgument();
    label_52:
    while (true) {
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case COMMA:
        ;
        break;
      default:
        jj_la1[223] = jj_gen;
        break label_52;
      }
      jj_consume_token(COMMA);
      PrintArgument();
    }
  }

  final public void PrintArgument() throws ParseException {
  boolean force = false;
  Expr subj = null;
  int  align = 1;
  Expr width = null;
  Expr repeating = null;
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case HEREDOC_BEGIN:
    case HEREDOC_BEGIN_:
      HereDoc();
      break;
    case JAVA__:
    case _EOF:
    case __EOF:
    case AS:
    case DEFINED:
    case ELIF:
    case EXTENDSJAVA:
    case FALSE:
    case JAVACLASS:
    case IFDEF:
    case IFNDEF:
    case IFEXISTS:
    case IN:
    case INFINITY:
    case INTO:
    case NEW:
    case JAVANEW:
    case MAX_NUMBER:
    case MIN_NUMBER:
    case NULL:
    case LIMIT:
    case NAMESPACE:
    case _SKIP:
    case SUPER:
    case THIS:
    case TYPEOF:
    case ATTRIBUTESOF:
    case TRUE:
    case UNDEFINED:
    case BOOLEAN:
    case BYTE:
    case CHAR:
    case SHORT:
    case INT:
    case LONG:
    case FLOAT:
    case DOUBLE:
    case MAIL__CONNECT:
    case MAIL__DISCONNECT:
    case CC:
    case BCC:
    case ATTACH:
    case SUBJECT:
    case BODY:
    case HTMLBODY:
    case DATE_:
    case DATE:
    case NUMBER:
    case COLUMN:
    case ERR:
    case LOG:
    case NL:
    case OUT:
    case PIPE:
    case INPUT:
    case OUTPUT:
    case NEEDSYSTEMIN:
    case MANIFEST:
    case EXCEPT:
    case SETFILETIME:
    case SETREADONLY:
    case SETREADWRITE:
    case TARGET:
    case DB__DISCONNECT:
    case HIB__ADDCLASS:
    case HIB__ADDRESOURCE:
    case HIB__CLOSE:
    case HIB__TXBEGIN:
    case HIB__TXEND:
    case HIB__TXABORT:
    case HIB__LOCK:
    case HIB__DELETE:
    case HIB__GET:
    case HIB__SAVE:
    case HIB__SAVEORUPDATECOPY:
    case HIB__UNLOCK:
    case HIB__UPDATE:
    case AFTER:
    case STARTING:
    case XML:
    case SYSTEMID:
    case OUTPUTPROPERTIES:
    case PARAMETERS:
    case XMLNS:
    case INTEGER_LITERAL:
    case FLOATING_POINT_LITERAL:
    case STRING_LITERAL:
    case EXEC_RESULT_LITERAL:
    case EXEC_RESULTLINES_LITERAL:
    case IDENTIFIER:
    case CONST_NAME:
    case BANG:
    case TILDE:
    case COLONCOLON:
    case INCR:
    case DECR:
    case PLUS:
    case MINUS:
    case BIT_AND:
    case DOLLARLBRACE:
    case LPAREN:
      Expression();
      break;
    default:
      jj_la1[224] = jj_gen;
      jj_consume_token(-1);
      throw new ParseException();
    }
                                 subj = reduceIt();
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case COLON:
      jj_consume_token(COLON);
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case GT:
      case LT:
      case STAR:
        switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
        case LT:
          jj_consume_token(LT);
                            align = 1;
          break;
        case GT:
          jj_consume_token(GT);
                            align = 2;
          break;
        case STAR:
          jj_consume_token(STAR);
                            align = 3;
          break;
        default:
          jj_la1[225] = jj_gen;
          jj_consume_token(-1);
          throw new ParseException();
        }
        break;
      default:
        jj_la1[226] = jj_gen;
        ;
      }
      Expression();
                            width = reduceIt();
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case BANG:
        jj_consume_token(BANG);
                force=true;
        break;
      default:
        jj_la1[227] = jj_gen;
        ;
      }
      break;
    default:
      jj_la1[228] = jj_gen;
      ;
    }
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case REPEAT:
    case LBRACE:
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case LBRACE:
        jj_consume_token(LBRACE);
        Expression();
        jj_consume_token(RBRACE);
                            repeating = reduceIt();
        break;
      case REPEAT:
        jj_consume_token(REPEAT);
        Expression();
                            repeating = reduceIt();
        break;
      default:
        jj_la1[229] = jj_gen;
        jj_consume_token(-1);
        throw new ParseException();
      }
      break;
    default:
      jj_la1[230] = jj_gen;
      ;
    }
    if ((width!=null) || (repeating!=null))
      subj = new StmtPrint.Align(subj, align, width, repeating, force);
    stack.push(subj);
  }

  final public void PrintTableStatement() throws ParseException {
  int target = PRINT_OUT;
  int lastMark = 0;
  Expr printer = null;
  Expr table = null;
  Expr skip = null;
  Expr limit = null;
  int lineNo = 0;
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case PRINTTABLE:
      jj_consume_token(PRINTTABLE);
      break;
    case PRINTTABLEDATA:
      jj_consume_token(PRINTTABLEDATA);
      break;
    default:
      jj_la1[231] = jj_gen;
      jj_consume_token(-1);
      throw new ParseException();
    }
                                        lineNo = lineNum();
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case LT:
      jj_consume_token(LT);
      if (jj_2_74(2)) {
        jj_consume_token(OUT);
                             target = PRINT_OUT;
      } else if (jj_2_75(2)) {
        jj_consume_token(ERR);
                             target = PRINT_ERR;
      } else if (jj_2_76(2)) {
        jj_consume_token(LOG);
                             target = PRINT_LOG;
      } else if (jj_2_77(2)) {
        jj_consume_token(PIPE);
                             target = PRINT_PIPE;
      } else {
        switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
        case JAVA__:
        case AS:
        case ELIF:
        case EXTENDSJAVA:
        case JAVACLASS:
        case IFDEF:
        case IFNDEF:
        case IFEXISTS:
        case IN:
        case INTO:
        case NEW:
        case JAVANEW:
        case LIMIT:
        case NAMESPACE:
        case _SKIP:
        case SUPER:
        case THIS:
        case BOOLEAN:
        case BYTE:
        case CHAR:
        case SHORT:
        case INT:
        case LONG:
        case FLOAT:
        case DOUBLE:
        case MAIL__CONNECT:
        case MAIL__DISCONNECT:
        case CC:
        case BCC:
        case ATTACH:
        case SUBJECT:
        case BODY:
        case HTMLBODY:
        case DATE_:
        case DATE:
        case NUMBER:
        case COLUMN:
        case ERR:
        case LOG:
        case OUT:
        case PIPE:
        case INPUT:
        case OUTPUT:
        case NEEDSYSTEMIN:
        case MANIFEST:
        case EXCEPT:
        case SETFILETIME:
        case SETREADONLY:
        case SETREADWRITE:
        case TARGET:
        case DB__DISCONNECT:
        case HIB__ADDCLASS:
        case HIB__ADDRESOURCE:
        case HIB__CLOSE:
        case HIB__TXBEGIN:
        case HIB__TXEND:
        case HIB__TXABORT:
        case HIB__LOCK:
        case HIB__DELETE:
        case HIB__GET:
        case HIB__SAVE:
        case HIB__SAVEORUPDATECOPY:
        case HIB__UNLOCK:
        case HIB__UPDATE:
        case AFTER:
        case STARTING:
        case XML:
        case SYSTEMID:
        case OUTPUTPROPERTIES:
        case PARAMETERS:
        case XMLNS:
        case STRING_LITERAL:
        case IDENTIFIER:
        case CONST_NAME:
        case COLONCOLON:
        case BIT_AND:
        case DOLLARLBRACE:
        case LPAREN:
          PrimaryExpression(false);
                                 target = PRINT_USER; printer = reduceIt();
          break;
        default:
          jj_la1[232] = jj_gen;
          jj_consume_token(-1);
          throw new ParseException();
        }
      }
      jj_consume_token(GT);
      break;
    default:
      jj_la1[233] = jj_gen;
      ;
    }
    Expression();
                             table = reduceIt();
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case _SKIP:
      jj_consume_token(_SKIP);
      Expression();
                             skip = reduceIt();
      break;
    default:
      jj_la1[234] = jj_gen;
      ;
    }
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case LIMIT:
      jj_consume_token(LIMIT);
      Expression();
                             limit = reduceIt();
      break;
    default:
      jj_la1[235] = jj_gen;
      ;
    }
    jj_consume_token(FOR);
                             lastMark = markStack();
    PrintArgumentList();
    jj_consume_token(SEMICOLON);
    Expr[] params = reduce(handleExprs(lastMark));
    stack.push( new StmtPrintTable(lineNo, target, printer, table, params, skip, limit) );
  }

  final public void ThrowStatement() throws ParseException {
  int lineNo;
  Expr excpt = null;
    jj_consume_token(THROW);
                                   lineNo = lineNum();
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case JAVA__:
    case _EOF:
    case __EOF:
    case AS:
    case DEFINED:
    case ELIF:
    case EXTENDSJAVA:
    case FALSE:
    case JAVACLASS:
    case IFDEF:
    case IFNDEF:
    case IFEXISTS:
    case IN:
    case INFINITY:
    case INTO:
    case NEW:
    case JAVANEW:
    case MAX_NUMBER:
    case MIN_NUMBER:
    case NULL:
    case LIMIT:
    case NAMESPACE:
    case _SKIP:
    case SUPER:
    case THIS:
    case TYPEOF:
    case ATTRIBUTESOF:
    case TRUE:
    case UNDEFINED:
    case BOOLEAN:
    case BYTE:
    case CHAR:
    case SHORT:
    case INT:
    case LONG:
    case FLOAT:
    case DOUBLE:
    case MAIL__CONNECT:
    case MAIL__DISCONNECT:
    case CC:
    case BCC:
    case ATTACH:
    case SUBJECT:
    case BODY:
    case HTMLBODY:
    case DATE_:
    case DATE:
    case NUMBER:
    case COLUMN:
    case ERR:
    case LOG:
    case NL:
    case OUT:
    case PIPE:
    case INPUT:
    case OUTPUT:
    case NEEDSYSTEMIN:
    case MANIFEST:
    case EXCEPT:
    case SETFILETIME:
    case SETREADONLY:
    case SETREADWRITE:
    case TARGET:
    case DB__DISCONNECT:
    case HIB__ADDCLASS:
    case HIB__ADDRESOURCE:
    case HIB__CLOSE:
    case HIB__TXBEGIN:
    case HIB__TXEND:
    case HIB__TXABORT:
    case HIB__LOCK:
    case HIB__DELETE:
    case HIB__GET:
    case HIB__SAVE:
    case HIB__SAVEORUPDATECOPY:
    case HIB__UNLOCK:
    case HIB__UPDATE:
    case AFTER:
    case STARTING:
    case XML:
    case SYSTEMID:
    case OUTPUTPROPERTIES:
    case PARAMETERS:
    case XMLNS:
    case INTEGER_LITERAL:
    case FLOATING_POINT_LITERAL:
    case STRING_LITERAL:
    case EXEC_RESULT_LITERAL:
    case EXEC_RESULTLINES_LITERAL:
    case IDENTIFIER:
    case CONST_NAME:
    case BANG:
    case TILDE:
    case HEREDOC_BEGIN:
    case HEREDOC_BEGIN_:
    case COLONCOLON:
    case INCR:
    case DECR:
    case PLUS:
    case MINUS:
    case BIT_AND:
    case DOLLARLBRACE:
    case LPAREN:
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case HEREDOC_BEGIN:
      case HEREDOC_BEGIN_:
        HereDoc();
        break;
      case JAVA__:
      case _EOF:
      case __EOF:
      case AS:
      case DEFINED:
      case ELIF:
      case EXTENDSJAVA:
      case FALSE:
      case JAVACLASS:
      case IFDEF:
      case IFNDEF:
      case IFEXISTS:
      case IN:
      case INFINITY:
      case INTO:
      case NEW:
      case JAVANEW:
      case MAX_NUMBER:
      case MIN_NUMBER:
      case NULL:
      case LIMIT:
      case NAMESPACE:
      case _SKIP:
      case SUPER:
      case THIS:
      case TYPEOF:
      case ATTRIBUTESOF:
      case TRUE:
      case UNDEFINED:
      case BOOLEAN:
      case BYTE:
      case CHAR:
      case SHORT:
      case INT:
      case LONG:
      case FLOAT:
      case DOUBLE:
      case MAIL__CONNECT:
      case MAIL__DISCONNECT:
      case CC:
      case BCC:
      case ATTACH:
      case SUBJECT:
      case BODY:
      case HTMLBODY:
      case DATE_:
      case DATE:
      case NUMBER:
      case COLUMN:
      case ERR:
      case LOG:
      case NL:
      case OUT:
      case PIPE:
      case INPUT:
      case OUTPUT:
      case NEEDSYSTEMIN:
      case MANIFEST:
      case EXCEPT:
      case SETFILETIME:
      case SETREADONLY:
      case SETREADWRITE:
      case TARGET:
      case DB__DISCONNECT:
      case HIB__ADDCLASS:
      case HIB__ADDRESOURCE:
      case HIB__CLOSE:
      case HIB__TXBEGIN:
      case HIB__TXEND:
      case HIB__TXABORT:
      case HIB__LOCK:
      case HIB__DELETE:
      case HIB__GET:
      case HIB__SAVE:
      case HIB__SAVEORUPDATECOPY:
      case HIB__UNLOCK:
      case HIB__UPDATE:
      case AFTER:
      case STARTING:
      case XML:
      case SYSTEMID:
      case OUTPUTPROPERTIES:
      case PARAMETERS:
      case XMLNS:
      case INTEGER_LITERAL:
      case FLOATING_POINT_LITERAL:
      case STRING_LITERAL:
      case EXEC_RESULT_LITERAL:
      case EXEC_RESULTLINES_LITERAL:
      case IDENTIFIER:
      case CONST_NAME:
      case BANG:
      case TILDE:
      case COLONCOLON:
      case INCR:
      case DECR:
      case PLUS:
      case MINUS:
      case BIT_AND:
      case DOLLARLBRACE:
      case LPAREN:
        Expression();
        break;
      default:
        jj_la1[236] = jj_gen;
        jj_consume_token(-1);
        throw new ParseException();
      }
                                   excpt = reduceIt();
      break;
    default:
      jj_la1[237] = jj_gen;
      ;
    }
    jj_consume_token(SEMICOLON);
                                   stack.push( new StmtThrow(lineNo,excpt) );
  }

/****************************************
 * MAIL APPLICATION SYNTAX STARTS HERE  *
 ****************************************/
  final public void MailStatement() throws ParseException {
  String clause;
  StmtSendMail ssm;
  int fld;
  Expr gcharset = null;
  Expr charset = null;
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case MAIL__SEND:
      jj_consume_token(MAIL__SEND);
      break;
    case SENDMAIL:
      jj_consume_token(SENDMAIL);
                                upgradeMsg("mail::send");
      break;
    default:
      jj_la1[238] = jj_gen;
      jj_consume_token(-1);
      throw new ParseException();
    }
                                                                ssm = new StmtSendMail(lineNum());
    if (jj_2_78(2)) {
      Expression();
                                gcharset = reduceIt();
    } else {
      ;
    }
    label_53:
    while (true) {
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case TO:
        jj_consume_token(TO);
                             fld = StmtSendMail.FLD_TO;       charset = gcharset;
        break;
      case FROM:
        jj_consume_token(FROM);
                             fld = StmtSendMail.FLD_FROM;     charset = gcharset;
        break;
      case CC:
        jj_consume_token(CC);
                             fld = StmtSendMail.FLD_CC;       charset = gcharset;
        break;
      case BCC:
        jj_consume_token(BCC);
                             fld = StmtSendMail.FLD_BCC;      charset = gcharset;
        break;
      case SUBJECT:
        jj_consume_token(SUBJECT);
                             fld = StmtSendMail.FLD_SUBJECT;  charset = gcharset;
        break;
      case ATTACH:
        jj_consume_token(ATTACH);
                             fld = StmtSendMail.FLD_ATTACH;   charset = gcharset;
        break;
      case BODY:
        jj_consume_token(BODY);
                             fld = StmtSendMail.FLD_BODY;     charset = gcharset;
        break;
      case HTMLBODY:
        jj_consume_token(HTMLBODY);
                             fld = StmtSendMail.FLD_HTMLBODY; charset = gcharset;
        break;
      default:
        jj_la1[239] = jj_gen;
        jj_consume_token(-1);
        throw new ParseException();
      }
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case JAVA__:
      case _EOF:
      case __EOF:
      case AS:
      case DEFINED:
      case ELIF:
      case EXTENDSJAVA:
      case FALSE:
      case JAVACLASS:
      case IFDEF:
      case IFNDEF:
      case IFEXISTS:
      case IN:
      case INFINITY:
      case INTO:
      case NEW:
      case JAVANEW:
      case MAX_NUMBER:
      case MIN_NUMBER:
      case NULL:
      case LIMIT:
      case NAMESPACE:
      case _SKIP:
      case SUPER:
      case THIS:
      case TYPEOF:
      case ATTRIBUTESOF:
      case TRUE:
      case UNDEFINED:
      case BOOLEAN:
      case BYTE:
      case CHAR:
      case SHORT:
      case INT:
      case LONG:
      case FLOAT:
      case DOUBLE:
      case MAIL__CONNECT:
      case MAIL__DISCONNECT:
      case CC:
      case BCC:
      case ATTACH:
      case SUBJECT:
      case BODY:
      case HTMLBODY:
      case DATE_:
      case DATE:
      case NUMBER:
      case COLUMN:
      case ERR:
      case LOG:
      case NL:
      case OUT:
      case PIPE:
      case INPUT:
      case OUTPUT:
      case NEEDSYSTEMIN:
      case MANIFEST:
      case EXCEPT:
      case SETFILETIME:
      case SETREADONLY:
      case SETREADWRITE:
      case TARGET:
      case DB__DISCONNECT:
      case HIB__ADDCLASS:
      case HIB__ADDRESOURCE:
      case HIB__CLOSE:
      case HIB__TXBEGIN:
      case HIB__TXEND:
      case HIB__TXABORT:
      case HIB__LOCK:
      case HIB__DELETE:
      case HIB__GET:
      case HIB__SAVE:
      case HIB__SAVEORUPDATECOPY:
      case HIB__UNLOCK:
      case HIB__UPDATE:
      case AFTER:
      case STARTING:
      case XML:
      case SYSTEMID:
      case OUTPUTPROPERTIES:
      case PARAMETERS:
      case XMLNS:
      case INTEGER_LITERAL:
      case FLOATING_POINT_LITERAL:
      case STRING_LITERAL:
      case EXEC_RESULT_LITERAL:
      case EXEC_RESULTLINES_LITERAL:
      case IDENTIFIER:
      case CONST_NAME:
      case BANG:
      case TILDE:
      case COLONCOLON:
      case INCR:
      case DECR:
      case PLUS:
      case MINUS:
      case BIT_AND:
      case DOLLARLBRACE:
      case LPAREN:
        Expression();
                             charset = reduceIt();
        break;
      default:
        jj_la1[240] = jj_gen;
        ;
      }
      jj_consume_token(COLON);
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case JAVA__:
      case _EOF:
      case __EOF:
      case AS:
      case DEFINED:
      case ELIF:
      case EXTENDSJAVA:
      case FALSE:
      case JAVACLASS:
      case IFDEF:
      case IFNDEF:
      case IFEXISTS:
      case IN:
      case INFINITY:
      case INTO:
      case NEW:
      case JAVANEW:
      case MAX_NUMBER:
      case MIN_NUMBER:
      case NULL:
      case LIMIT:
      case NAMESPACE:
      case _SKIP:
      case SUPER:
      case THIS:
      case TYPEOF:
      case ATTRIBUTESOF:
      case TRUE:
      case UNDEFINED:
      case BOOLEAN:
      case BYTE:
      case CHAR:
      case SHORT:
      case INT:
      case LONG:
      case FLOAT:
      case DOUBLE:
      case MAIL__CONNECT:
      case MAIL__DISCONNECT:
      case CC:
      case BCC:
      case ATTACH:
      case SUBJECT:
      case BODY:
      case HTMLBODY:
      case DATE_:
      case DATE:
      case NUMBER:
      case COLUMN:
      case ERR:
      case LOG:
      case NL:
      case OUT:
      case PIPE:
      case INPUT:
      case OUTPUT:
      case NEEDSYSTEMIN:
      case MANIFEST:
      case EXCEPT:
      case SETFILETIME:
      case SETREADONLY:
      case SETREADWRITE:
      case TARGET:
      case DB__DISCONNECT:
      case HIB__ADDCLASS:
      case HIB__ADDRESOURCE:
      case HIB__CLOSE:
      case HIB__TXBEGIN:
      case HIB__TXEND:
      case HIB__TXABORT:
      case HIB__LOCK:
      case HIB__DELETE:
      case HIB__GET:
      case HIB__SAVE:
      case HIB__SAVEORUPDATECOPY:
      case HIB__UNLOCK:
      case HIB__UPDATE:
      case AFTER:
      case STARTING:
      case XML:
      case SYSTEMID:
      case OUTPUTPROPERTIES:
      case PARAMETERS:
      case XMLNS:
      case INTEGER_LITERAL:
      case FLOATING_POINT_LITERAL:
      case STRING_LITERAL:
      case EXEC_RESULT_LITERAL:
      case EXEC_RESULTLINES_LITERAL:
      case IDENTIFIER:
      case CONST_NAME:
      case BANG:
      case TILDE:
      case COLONCOLON:
      case INCR:
      case DECR:
      case PLUS:
      case MINUS:
      case BIT_AND:
      case DOLLARLBRACE:
      case LPAREN:
        Expression();
        break;
      case HEREDOC_BEGIN:
      case HEREDOC_BEGIN_:
        HereDoc();
        break;
      default:
        jj_la1[241] = jj_gen;
        jj_consume_token(-1);
        throw new ParseException();
      }
                             try { ssm.setExpr(fld,reduceIt(),charset); }
                             catch(Throwable e) { throwParseException(e.getMessage()); }
                             charset = null;
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case FROM:
      case TO:
      case CC:
      case BCC:
      case ATTACH:
      case SUBJECT:
      case BODY:
      case HTMLBODY:
        ;
        break;
      default:
        jj_la1[242] = jj_gen;
        break label_53;
      }
    }
    jj_consume_token(SEMICOLON);
                             stack.push(ssm);
  }

/****************************************
 * JDBC APPLICATION SYNTAX STARTS HERE  *
 ****************************************/
  final public void JdbcStatements() throws ParseException {
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case CONNECT:
    case DB__CONNECT:
      ConnectStatement();
      break;
    case PREPARE:
    case PREPARECALL:
    case DB__PREPARE:
    case DB__PREPARECALL:
      PrepareStatement();
      break;
    case EXECUTEQUERY:
    case EXECUTEQUERYCALL:
    case PREPAREDEXECUTEQUERY:
    case PREPAREDEXECUTECALLQUERY:
    case DB__QUERY:
    case DB__QUERYCALL:
      ExecuteQueryStatement();
      break;
    case EXECUTEUPDATE:
    case EXECUTEUPDATECALL:
    case PREPAREDEXECUTEUPDATE:
    case PREPAREDEXECUTECALLUPDATE:
    case DB__UPDATE:
    case DB__UPDATECALL:
      ExecuteUpdateStatement();
      break;
    case EXECUTESQL:
    case PREPAREDEXECUTE:
    case PREPAREDEXECUTECALL:
    case DB__SQL:
    case DB__CALL:
      ExecuteSqlStatement();
      break;
    case EXECUTEBATCH:
    case DB__BATCH:
      ExecuteBatchStatement();
      break;
    case EXECUTEANY:
    case DB__ANY:
      ExecuteAnyStatement();
      break;
    case ADDBATCH:
    case DB__ADDBATCH:
      AddBatchStatement();
      break;
    case DB__DUMPTABLE:
      DumpTableStatement();
      break;
    default:
      jj_la1[243] = jj_gen;
      jj_consume_token(-1);
      throw new ParseException();
    }
  }

  final public void ConnectStatement() throws ParseException {
  String connName = DBConnect.DEFAULT_CONNECTION_NAME;
  AssociateList inits = null;
  int lastMark = markStack();
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case DB__CONNECT:
      jj_consume_token(DB__CONNECT);
      break;
    case CONNECT:
      jj_consume_token(CONNECT);
                                upgradeMsg("db::connect");
      break;
    default:
      jj_la1[244] = jj_gen;
      jj_consume_token(-1);
      throw new ParseException();
    }
    if (jj_2_79(2)) {
      label_54:
      while (true) {
        switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
        case AS:
        case ELIF:
        case EXTENDSJAVA:
        case IFDEF:
        case IFNDEF:
        case IFEXISTS:
        case IN:
        case INTO:
        case LIMIT:
        case NAMESPACE:
        case _SKIP:
        case CC:
        case BCC:
        case ATTACH:
        case SUBJECT:
        case BODY:
        case HTMLBODY:
        case NUMBER:
        case COLUMN:
        case ERR:
        case LOG:
        case OUT:
        case PIPE:
        case INPUT:
        case OUTPUT:
        case NEEDSYSTEMIN:
        case MANIFEST:
        case EXCEPT:
        case SETFILETIME:
        case SETREADONLY:
        case SETREADWRITE:
        case TARGET:
        case AFTER:
        case STARTING:
        case XML:
        case SYSTEMID:
        case OUTPUTPROPERTIES:
        case PARAMETERS:
        case XMLNS:
        case IDENTIFIER:
        case LT:
        case LPAREN:
          ;
          break;
        default:
          jj_la1[245] = jj_gen;
          break label_54;
        }
        switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
        case LPAREN:
          MemberInitList();
                          inits = handleNamedExprs(lastMark);
          break;
        case AS:
        case ELIF:
        case EXTENDSJAVA:
        case IFDEF:
        case IFNDEF:
        case IFEXISTS:
        case IN:
        case INTO:
        case LIMIT:
        case NAMESPACE:
        case _SKIP:
        case CC:
        case BCC:
        case ATTACH:
        case SUBJECT:
        case BODY:
        case HTMLBODY:
        case NUMBER:
        case COLUMN:
        case ERR:
        case LOG:
        case OUT:
        case PIPE:
        case INPUT:
        case OUTPUT:
        case NEEDSYSTEMIN:
        case MANIFEST:
        case EXCEPT:
        case SETFILETIME:
        case SETREADONLY:
        case SETREADWRITE:
        case TARGET:
        case AFTER:
        case STARTING:
        case XML:
        case SYSTEMID:
        case OUTPUTPROPERTIES:
        case PARAMETERS:
        case XMLNS:
        case IDENTIFIER:
          LabelName();
                          connName = token.image;
          break;
        case LT:
          jj_consume_token(LT);
          LabelName();
                          connName = token.image;
          jj_consume_token(GT);
          break;
        default:
          jj_la1[246] = jj_gen;
          jj_consume_token(-1);
          throw new ParseException();
        }
      }
      jj_consume_token(TO);
    } else {
      ;
    }
                          if (inits == null) inits = new AssociateList();
    Expression();
                          inits.add(DBConnect.OPTION_JDBC_URL, reduceIt());
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case COMMA:
      jj_consume_token(COMMA);
      Expression();
                          inits.add(DBConnect.OPTION_JDBC_USERNAME, reduceIt());
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case COMMA:
        jj_consume_token(COMMA);
        Expression();
                          inits.add(DBConnect.OPTION_JDBC_PASSWORD, reduceIt());
        break;
      default:
        jj_la1[247] = jj_gen;
        ;
      }
      break;
    default:
      jj_la1[248] = jj_gen;
      ;
    }
    jj_consume_token(SEMICOLON);
    stack.push( ExprAssign.createRootVar(lineNum(), connName, new NewObject("db_connect", inits)) );
  }

  final public void PrepareStatement() throws ParseException {
  boolean isCall = false;
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case DB__PREPARE:
      jj_consume_token(DB__PREPARE);
      break;
    case DB__PREPARECALL:
      jj_consume_token(DB__PREPARECALL);
                          isCall = true;
      break;
    case PREPARE:
      jj_consume_token(PREPARE);
                          upgradeMsg("db::prepare");
      break;
    case PREPARECALL:
      jj_consume_token(PREPARECALL);
                          upgradeMsg("db::prepareCall"); isCall = true;
      break;
    default:
      jj_la1[249] = jj_gen;
      jj_consume_token(-1);
      throw new ParseException();
    }
    PrepareClause(isCall);
  }

  final public void _onSuccessClause(String handleName) throws ParseException {
  int lineNo;
    jj_consume_token(ONSUCCESS);
                          lineNo = lineNum();
    Statement();
                          // construct this:  if (handleName.next()) { ... }
                          Object[] oa = new Object[]{handleName,"next",new Arguments(this, null, false) };
                          Expr[] conds = new Expr[] { reduce(new ExprPrimary(oa)) };
                          stack.push( new StmtIf(lineNo, conds, new Stmt[]{(Stmt)stack.pop()}, null) );
    if (jj_2_80(2)) {
      jj_consume_token(ELSE);
      Statement();
                          ((StmtIf)stack.peek()).setElsePart((Stmt)stack.pop());
    } else {
      ;
    }
  }

  final public String PrepareClause(boolean isCall) throws ParseException {
  String s;
  int line;
  String hndlName = Consts.THIS_NAME;
  Expr[] inits = new Expr[]{ DBConnect.DEFAULT_CONNECTION_ACCESS, null,
                             ConstInt.getBool(isCall), null, null, null};
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case LT:
      jj_consume_token(LT);
      PrimaryExpression(false);
                                   inits[0] = reduceIt();
      jj_consume_token(GT);
      break;
    default:
      jj_la1[250] = jj_gen;
      ;
    }
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case AS:
    case ELIF:
    case EXTENDSJAVA:
    case IFDEF:
    case IFNDEF:
    case IFEXISTS:
    case IN:
    case INTO:
    case LIMIT:
    case NAMESPACE:
    case _SKIP:
    case CC:
    case BCC:
    case ATTACH:
    case SUBJECT:
    case BODY:
    case HTMLBODY:
    case NUMBER:
    case COLUMN:
    case ERR:
    case LOG:
    case OUT:
    case PIPE:
    case INPUT:
    case OUTPUT:
    case NEEDSYSTEMIN:
    case MANIFEST:
    case EXCEPT:
    case SETFILETIME:
    case SETREADONLY:
    case SETREADWRITE:
    case TARGET:
    case AFTER:
    case STARTING:
    case XML:
    case SYSTEMID:
    case OUTPUTPROPERTIES:
    case PARAMETERS:
    case XMLNS:
    case IDENTIFIER:
      LabelName();
                  hndlName = token.image;
      break;
    default:
      jj_la1[251] = jj_gen;
      ;
    }
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case LPAREN:
      jj_consume_token(LPAREN);
      QueryOption(inits);
      label_55:
      while (true) {
        switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
        case COMMA:
          ;
          break;
        default:
          jj_la1[252] = jj_gen;
          break label_55;
        }
        jj_consume_token(COMMA);
        QueryOption(inits);
      }
      jj_consume_token(RPAREN);
      break;
    default:
      jj_la1[253] = jj_gen;
      ;
    }
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case USING:
    case USE:
      upgradeToUse();
      AnyName();
                                inits[0] = new AccessVar(token.image);
      break;
    default:
      jj_la1[254] = jj_gen;
      ;
    }
    jj_consume_token(COLON);
    Mixture(token.beginLine, token.beginColumn);
    jj_consume_token(SEMICOLON);
    inits[1] = reduceIt();
    stack.push(ExprAssign.createLocalVar(lineNum(), hndlName, new NewObject("db_handle", inits), true));
    {if (true) return hndlName;}
    throw new Error("Missing return statement in function");
  }

  final public void QueryOption(Expr[] inits) throws ParseException {
  int idx = -1;
    jj_consume_token(IDENTIFIER);
                 int line = lineNum();
                 String s = token.image;
                 if (s.equalsIgnoreCase("type"))   idx = 3;
                 if (s.equalsIgnoreCase("fetch"))  idx = 4;
                 if (s.equalsIgnoreCase("concur")) idx = 5;
                 else throwParseException("Unknown result set attribute at line " + line + ": " + s);
    jj_consume_token(ASSIGN);
    ReturnableExpression();
                               inits[idx] = reduceIt();
  }

  final public void AddBatchStatement() throws ParseException {
  String batchName = null;
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case DB__ADDBATCH:
      jj_consume_token(DB__ADDBATCH);
      break;
    case ADDBATCH:
      jj_consume_token(ADDBATCH);
                                  upgradeMsg("db::addBatch");
      break;
    default:
      jj_la1[255] = jj_gen;
      jj_consume_token(-1);
      throw new ParseException();
    }
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case TO:
      jj_consume_token(TO);
      break;
    default:
      jj_la1[256] = jj_gen;
      ;
    }
    LabelName();
                         batchName = token.image;
    jj_consume_token(COLON);
    Mixture(token.beginLine,token.beginColumn);
    jj_consume_token(SEMICOLON);
    stack.push( newCall(batchName, "add", new Expr[]{ reduce(handleSingleExpr()) }, null) );
  }

  final public void DumpTableStatement() throws ParseException {
  Expr using = null;
  Expr into  = null;
  Expr limit = null;
  StmtDumpTable stmt = null;
    jj_consume_token(DB__DUMPTABLE);
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case LT:
      jj_consume_token(LT);
      PrimaryExpression(false);
                                   stmt.setConnection(reduceIt());
      jj_consume_token(GT);
      break;
    default:
      jj_la1[257] = jj_gen;
      ;
    }
    Expression();
                                  stmt = new StmtDumpTable(lineNum(), reduceIt());
    label_56:
    while (true) {
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case INTO:
      case LIMIT:
      case USING:
      case USE:
      case IDENTIFIER:
        ;
        break;
      default:
        jj_la1[258] = jj_gen;
        break label_56;
      }
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case USING:
      case USE:
        upgradeToUse();
        AnyName();
                                  stmt.setConnection(new AccessVar(token.image));
        break;
      case INTO:
        jj_consume_token(INTO);
        Expression();
                                  stmt.setInto(reduceIt());
        break;
      case LIMIT:
        jj_consume_token(LIMIT);
        Expression();
                                  stmt.setLimit(reduceIt());
        break;
      case IDENTIFIER:
        id("prompt");
        Expression();
                                  stmt.setPrompt(reduceIt());
        break;
      default:
        jj_la1[259] = jj_gen;
        jj_consume_token(-1);
        throw new ParseException();
      }
    }
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case SEMICOLON:
      jj_consume_token(SEMICOLON);
      break;
    case WHERE:
      jj_consume_token(WHERE);
      Mixture(token.beginLine,token.beginColumn);
      jj_consume_token(SEMICOLON);
                                                             stmt.setWhere(reduce(handleSingleExpr()));
      break;
    default:
      jj_la1[260] = jj_gen;
      jj_consume_token(-1);
      throw new ParseException();
    }
                                  stack.push(stmt);
  }

  final public void ExecuteQueryStatement() throws ParseException {
  String hndlName = Consts.THIS_NAME;
  boolean isCall = false;
  boolean hasExt = false;
  boolean hasOnSucc = false;
  Expr[] ea = JudoUtil.emptyExprs;
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case DB__QUERY:
      jj_consume_token(DB__QUERY);
      break;
    case DB__QUERYCALL:
      jj_consume_token(DB__QUERYCALL);
                                                  isCall = true;
      break;
    case EXECUTEQUERY:
      jj_consume_token(EXECUTEQUERY);
                                                  upgradeMsg("db::query");
      break;
    case EXECUTEQUERYCALL:
      jj_consume_token(EXECUTEQUERYCALL);
                                                  upgradeMsg("db::queryCall");
      break;
    case PREPAREDEXECUTEQUERY:
      jj_consume_token(PREPAREDEXECUTEQUERY);
                                                  upgradeMsg("db::query");
      break;
    case PREPAREDEXECUTECALLQUERY:
      jj_consume_token(PREPAREDEXECUTECALLQUERY);
                                                  upgradeMsg("db::queryCall");
      break;
    default:
      jj_la1[261] = jj_gen;
      jj_consume_token(-1);
      throw new ParseException();
    }
                                                  isCall = token.image.endsWith("Call");
    if (jj_2_82(2147483647)) {
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case AS:
      case ELIF:
      case EXTENDSJAVA:
      case IFDEF:
      case IFNDEF:
      case IFEXISTS:
      case IN:
      case INTO:
      case LIMIT:
      case NAMESPACE:
      case _SKIP:
      case CC:
      case BCC:
      case ATTACH:
      case SUBJECT:
      case BODY:
      case HTMLBODY:
      case NUMBER:
      case COLUMN:
      case ERR:
      case LOG:
      case OUT:
      case PIPE:
      case INPUT:
      case OUTPUT:
      case NEEDSYSTEMIN:
      case MANIFEST:
      case EXCEPT:
      case SETFILETIME:
      case SETREADONLY:
      case SETREADWRITE:
      case TARGET:
      case AFTER:
      case STARTING:
      case XML:
      case SYSTEMID:
      case OUTPUTPROPERTIES:
      case PARAMETERS:
      case XMLNS:
      case IDENTIFIER:
        LabelName();
                                                  hndlName = token.image;
        break;
      default:
        jj_la1[262] = jj_gen;
        ;
      }
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case WITH:
        ea = BindVariableList(false);
        break;
      default:
        jj_la1[263] = jj_gen;
        ;
      }
                                                  stack.push( newCall(hndlName, "executeQuery", ea, null) );
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case SEMICOLON:
        jj_consume_token(SEMICOLON);
        break;
      case ONSUCCESS:
        _onSuccessClause(hndlName);
        break;
      default:
        jj_la1[264] = jj_gen;
        jj_consume_token(-1);
        throw new ParseException();
      }
    } else {
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case AS:
      case ELIF:
      case EXTENDSJAVA:
      case IFDEF:
      case IFNDEF:
      case IFEXISTS:
      case IN:
      case INTO:
      case LIMIT:
      case NAMESPACE:
      case _SKIP:
      case USING:
      case USE:
      case CC:
      case BCC:
      case ATTACH:
      case SUBJECT:
      case BODY:
      case HTMLBODY:
      case NUMBER:
      case COLUMN:
      case ERR:
      case LOG:
      case OUT:
      case PIPE:
      case INPUT:
      case OUTPUT:
      case NEEDSYSTEMIN:
      case MANIFEST:
      case EXCEPT:
      case SETFILETIME:
      case SETREADONLY:
      case SETREADWRITE:
      case TARGET:
      case AFTER:
      case STARTING:
      case XML:
      case SYSTEMID:
      case OUTPUTPROPERTIES:
      case PARAMETERS:
      case XMLNS:
      case IDENTIFIER:
      case LT:
      case COLON:
      case LPAREN:
        hndlName = PrepareClause(isCall);
                                                  hasExt = false;
        if (jj_2_81(3)) {
          switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
          case WITH:
            ea = BindVariableList(false);
                                                  stack.push(newCall(hndlName, "executeQuery", ea, null));
                                                  hasExt = true;
            switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
            case SEMICOLON:
              jj_consume_token(SEMICOLON);
              break;
            case ONSUCCESS:
              _onSuccessClause(hndlName);
              break;
            default:
              jj_la1[265] = jj_gen;
              jj_consume_token(-1);
              throw new ParseException();
            }
            break;
          case ONSUCCESS:
            _onSuccessClause(hndlName);
                                       hasOnSucc = true;
            break;
          default:
            jj_la1[266] = jj_gen;
            jj_consume_token(-1);
            throw new ParseException();
          }
        } else {
          ;
        }
      if (!hasExt) { // need to exec it!
        Object tmp = newCall(hndlName, "executeQuery", JudoUtil.emptyExprs, null);
        if (hasOnSucc) {          // if we have onSuccess clause, swap it.
          Object o = stack.pop(); // The StmtIf from _onSuccessClause().
          stack.push(tmp);
          stack.push(o);
        } else {
          stack.push(tmp);
        }
      }
        break;
      default:
        jj_la1[267] = jj_gen;
        jj_consume_token(-1);
        throw new ParseException();
      }
    }
  }

  final public void ExecuteUpdateStatement() throws ParseException {
  Expr conn = DBConnect.DEFAULT_CONNECTION_ACCESS;
  String hndlName = Consts.THIS_NAME;
  boolean isCall = false;
  Expr[] ea = JudoUtil.emptyExprs;
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case DB__UPDATE:
      jj_consume_token(DB__UPDATE);
      break;
    case DB__UPDATECALL:
      jj_consume_token(DB__UPDATECALL);
      break;
    case EXECUTEUPDATE:
      jj_consume_token(EXECUTEUPDATE);
                                  upgradeMsg("db::update");
      break;
    case EXECUTEUPDATECALL:
      jj_consume_token(EXECUTEUPDATECALL);
                                  upgradeMsg("db::updateCall");
      break;
    case PREPAREDEXECUTEUPDATE:
      jj_consume_token(PREPAREDEXECUTEUPDATE);
                                  upgradeMsg("db::update");
      break;
    case PREPAREDEXECUTECALLUPDATE:
      jj_consume_token(PREPAREDEXECUTECALLUPDATE);
                                  upgradeMsg("db::updateCall");
      break;
    default:
      jj_la1[268] = jj_gen;
      jj_consume_token(-1);
      throw new ParseException();
    }
                                  isCall = token.image.endsWith("Call");
    if (jj_2_84(2147483647)) {
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case AS:
      case ELIF:
      case EXTENDSJAVA:
      case IFDEF:
      case IFNDEF:
      case IFEXISTS:
      case IN:
      case INTO:
      case LIMIT:
      case NAMESPACE:
      case _SKIP:
      case CC:
      case BCC:
      case ATTACH:
      case SUBJECT:
      case BODY:
      case HTMLBODY:
      case NUMBER:
      case COLUMN:
      case ERR:
      case LOG:
      case OUT:
      case PIPE:
      case INPUT:
      case OUTPUT:
      case NEEDSYSTEMIN:
      case MANIFEST:
      case EXCEPT:
      case SETFILETIME:
      case SETREADONLY:
      case SETREADWRITE:
      case TARGET:
      case AFTER:
      case STARTING:
      case XML:
      case SYSTEMID:
      case OUTPUTPROPERTIES:
      case PARAMETERS:
      case XMLNS:
      case IDENTIFIER:
        LabelName();
                    hndlName=token.image;
        break;
      default:
        jj_la1[269] = jj_gen;
        ;
      }
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case WITH:
        ea = BindVariableList(false);
        break;
      default:
        jj_la1[270] = jj_gen;
        ;
      }
      jj_consume_token(SEMICOLON);
    } else {
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case AS:
      case ELIF:
      case EXTENDSJAVA:
      case IFDEF:
      case IFNDEF:
      case IFEXISTS:
      case IN:
      case INTO:
      case LIMIT:
      case NAMESPACE:
      case _SKIP:
      case USING:
      case USE:
      case CC:
      case BCC:
      case ATTACH:
      case SUBJECT:
      case BODY:
      case HTMLBODY:
      case NUMBER:
      case COLUMN:
      case ERR:
      case LOG:
      case OUT:
      case PIPE:
      case INPUT:
      case OUTPUT:
      case NEEDSYSTEMIN:
      case MANIFEST:
      case EXCEPT:
      case SETFILETIME:
      case SETREADONLY:
      case SETREADWRITE:
      case TARGET:
      case AFTER:
      case STARTING:
      case XML:
      case SYSTEMID:
      case OUTPUTPROPERTIES:
      case PARAMETERS:
      case XMLNS:
      case IDENTIFIER:
      case LT:
      case COLON:
      case LPAREN:
        hndlName = PrepareClause(isCall);
        if (jj_2_83(3)) {
          ea = BindVariableList(false);
          jj_consume_token(SEMICOLON);
        } else {
          ;
        }
        break;
      default:
        jj_la1[271] = jj_gen;
        jj_consume_token(-1);
        throw new ParseException();
      }
    }
    stack.push(newCall(hndlName, "executeUpdate", ea, null));
  }

  final public void ExecuteSqlStatement() throws ParseException {
  Expr conn = DBConnect.DEFAULT_CONNECTION_ACCESS;
  String hndlName = Consts.THIS_NAME;
  Expr[] ea = JudoUtil.emptyExprs;
  int lastMark = markStack();
  Expr result = null;
  int lineNo = 0;
  boolean isCall = false;
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case DB__SQL:
      jj_consume_token(DB__SQL);
      break;
    case DB__CALL:
      jj_consume_token(DB__CALL);
                                   isCall = true;
      break;
    case EXECUTESQL:
      jj_consume_token(EXECUTESQL);
                                   upgradeMsg("db::sql");
      break;
    case PREPAREDEXECUTE:
      jj_consume_token(PREPAREDEXECUTE);
                                   upgradeMsg("db::sql");
      break;
    case PREPAREDEXECUTECALL:
      jj_consume_token(PREPAREDEXECUTECALL);
                                   upgradeMsg("db::call"); isCall = true;
      break;
    default:
      jj_la1[272] = jj_gen;
      jj_consume_token(-1);
      throw new ParseException();
    }
                                   lineNo = lineNum();
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case USING:
    case USE:
    case LT:
    case COLON:
    case LBRACE:
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case USING:
      case USE:
      case LT:
        switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
        case USING:
        case USE:
          upgradeToUse();
          AnyName();
                                   conn = new AccessVar(token.image);
          break;
        case LT:
          jj_consume_token(LT);
          PrimaryExpression(false);
                                     conn = reduceIt();
          jj_consume_token(GT);
          break;
        default:
          jj_la1[273] = jj_gen;
          jj_consume_token(-1);
          throw new ParseException();
        }
        break;
      default:
        jj_la1[274] = jj_gen;
        ;
      }
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case LBRACE:
        ea = RawSqlList();
                                   stack.push(newCall(conn, "executeSQL", ea, null));
        break;
      case COLON:
        jj_consume_token(COLON);
        Mixture(token.beginLine, token.beginColumn);
        jj_consume_token(SEMICOLON);
                                   result = handleMixture(handleAny(lastMark));
        if (jj_2_85(3)) {
          ea = BindVariableList(false);
          jj_consume_token(SEMICOLON);
        } else {
          ;
        }
        if (ea == JudoUtil.emptyExprs) { // not prepared.
          stack.push(newCall(conn, "executeSQL", new Expr[]{ result }, null));
        } else { // prepared.
          Expr[] inits = new Expr[]{ conn, result, ConstInt.getBool(isCall), null, null, null };
          stack.push(ExprAssign.createLocalVar(lineNo, hndlName, new NewObject("db_handle", inits), true));
        }
        {if (true) return;}
        break;
      default:
        jj_la1[275] = jj_gen;
        jj_consume_token(-1);
        throw new ParseException();
      }
      break;
    case AS:
    case ELIF:
    case EXTENDSJAVA:
    case IFDEF:
    case IFNDEF:
    case IFEXISTS:
    case IN:
    case INTO:
    case LIMIT:
    case NAMESPACE:
    case _SKIP:
    case WITH:
    case CC:
    case BCC:
    case ATTACH:
    case SUBJECT:
    case BODY:
    case HTMLBODY:
    case NUMBER:
    case COLUMN:
    case ERR:
    case LOG:
    case OUT:
    case PIPE:
    case INPUT:
    case OUTPUT:
    case NEEDSYSTEMIN:
    case MANIFEST:
    case EXCEPT:
    case SETFILETIME:
    case SETREADONLY:
    case SETREADWRITE:
    case TARGET:
    case AFTER:
    case STARTING:
    case XML:
    case SYSTEMID:
    case OUTPUTPROPERTIES:
    case PARAMETERS:
    case XMLNS:
    case IDENTIFIER:
    case SEMICOLON:
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case AS:
      case ELIF:
      case EXTENDSJAVA:
      case IFDEF:
      case IFNDEF:
      case IFEXISTS:
      case IN:
      case INTO:
      case LIMIT:
      case NAMESPACE:
      case _SKIP:
      case CC:
      case BCC:
      case ATTACH:
      case SUBJECT:
      case BODY:
      case HTMLBODY:
      case NUMBER:
      case COLUMN:
      case ERR:
      case LOG:
      case OUT:
      case PIPE:
      case INPUT:
      case OUTPUT:
      case NEEDSYSTEMIN:
      case MANIFEST:
      case EXCEPT:
      case SETFILETIME:
      case SETREADONLY:
      case SETREADWRITE:
      case TARGET:
      case AFTER:
      case STARTING:
      case XML:
      case SYSTEMID:
      case OUTPUTPROPERTIES:
      case PARAMETERS:
      case XMLNS:
      case IDENTIFIER:
        LabelName();
                    hndlName = token.image;
        break;
      default:
        jj_la1[276] = jj_gen;
        ;
      }
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case WITH:
        ea = BindVariableList(false);
        break;
      default:
        jj_la1[277] = jj_gen;
        ;
      }
      jj_consume_token(SEMICOLON);
        stack.push(newCall(hndlName, "executeSQL", ea, null));
      break;
    default:
      jj_la1[278] = jj_gen;
      jj_consume_token(-1);
      throw new ParseException();
    }
  }

  final public void ExecuteAnyStatement() throws ParseException {
  Expr conn = DBConnect.DEFAULT_CONNECTION_ACCESS;
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case DB__ANY:
      jj_consume_token(DB__ANY);
      break;
    case EXECUTEANY:
      jj_consume_token(EXECUTEANY);
                               upgradeMsg("db::any");
      break;
    default:
      jj_la1[279] = jj_gen;
      jj_consume_token(-1);
      throw new ParseException();
    }
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case USING:
    case USE:
    case LT:
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case USING:
      case USE:
        upgradeToUse();
        AnyName();
                               conn = new AccessVar(token.image);
        break;
      case LT:
        jj_consume_token(LT);
        PrimaryExpression(false);
                                   conn = reduceIt();
        jj_consume_token(GT);
        break;
      default:
        jj_la1[280] = jj_gen;
        jj_consume_token(-1);
        throw new ParseException();
      }
      break;
    default:
      jj_la1[281] = jj_gen;
      ;
    }
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case JAVA__:
    case _EOF:
    case __EOF:
    case AS:
    case DEFINED:
    case ELIF:
    case EXTENDSJAVA:
    case FALSE:
    case JAVACLASS:
    case IFDEF:
    case IFNDEF:
    case IFEXISTS:
    case IN:
    case INFINITY:
    case INTO:
    case NEW:
    case JAVANEW:
    case MAX_NUMBER:
    case MIN_NUMBER:
    case NULL:
    case LIMIT:
    case NAMESPACE:
    case _SKIP:
    case SUPER:
    case THIS:
    case TYPEOF:
    case ATTRIBUTESOF:
    case TRUE:
    case UNDEFINED:
    case BOOLEAN:
    case BYTE:
    case CHAR:
    case SHORT:
    case INT:
    case LONG:
    case FLOAT:
    case DOUBLE:
    case MAIL__CONNECT:
    case MAIL__DISCONNECT:
    case CC:
    case BCC:
    case ATTACH:
    case SUBJECT:
    case BODY:
    case HTMLBODY:
    case DATE_:
    case DATE:
    case NUMBER:
    case COLUMN:
    case ERR:
    case LOG:
    case NL:
    case OUT:
    case PIPE:
    case INPUT:
    case OUTPUT:
    case NEEDSYSTEMIN:
    case MANIFEST:
    case EXCEPT:
    case SETFILETIME:
    case SETREADONLY:
    case SETREADWRITE:
    case TARGET:
    case DB__DISCONNECT:
    case HIB__ADDCLASS:
    case HIB__ADDRESOURCE:
    case HIB__CLOSE:
    case HIB__TXBEGIN:
    case HIB__TXEND:
    case HIB__TXABORT:
    case HIB__LOCK:
    case HIB__DELETE:
    case HIB__GET:
    case HIB__SAVE:
    case HIB__SAVEORUPDATECOPY:
    case HIB__UNLOCK:
    case HIB__UPDATE:
    case AFTER:
    case STARTING:
    case XML:
    case SYSTEMID:
    case OUTPUTPROPERTIES:
    case PARAMETERS:
    case XMLNS:
    case INTEGER_LITERAL:
    case FLOATING_POINT_LITERAL:
    case STRING_LITERAL:
    case EXEC_RESULT_LITERAL:
    case EXEC_RESULTLINES_LITERAL:
    case IDENTIFIER:
    case CONST_NAME:
    case BANG:
    case TILDE:
    case COLONCOLON:
    case INCR:
    case DECR:
    case PLUS:
    case MINUS:
    case BIT_AND:
    case DOLLARLBRACE:
    case LPAREN:
      Expression();
      break;
    case HEREDOC_BEGIN:
    case HEREDOC_BEGIN_:
      HereDoc();
      break;
    default:
      jj_la1[282] = jj_gen;
      jj_consume_token(-1);
      throw new ParseException();
    }
    jj_consume_token(SEMICOLON);
    stack.push( newCall(conn, "executeSQL", new Expr[]{(Expr)stack.pop()}, null) );
  }

  final public void ExecuteBatchStatement() throws ParseException {
  Expr conn = DBConnect.DEFAULT_CONNECTION_ACCESS;
  Expr[] ea = JudoUtil.emptyExprs;
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case DB__BATCH:
      jj_consume_token(DB__BATCH);
      break;
    case EXECUTEBATCH:
      jj_consume_token(EXECUTEBATCH);
                                   upgradeMsg("db::batch");
      break;
    default:
      jj_la1[283] = jj_gen;
      jj_consume_token(-1);
      throw new ParseException();
    }
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case IDENTIFIER:
      jj_consume_token(IDENTIFIER);
                   stack.push( newCall(token.image, "executeBatch", ea, null) );
      break;
    case USING:
    case USE:
    case LT:
    case LBRACE:
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case USING:
      case USE:
      case LT:
        switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
        case USING:
        case USE:
          upgradeToUse();
          AnyName();
                                 conn = new AccessVar(token.image);
          break;
        case LT:
          jj_consume_token(LT);
          PrimaryExpression(false);
                                     conn = reduceIt();
          jj_consume_token(GT);
          break;
        default:
          jj_la1[284] = jj_gen;
          jj_consume_token(-1);
          throw new ParseException();
        }
        break;
      default:
        jj_la1[285] = jj_gen;
        ;
      }
      ea = RawSqlList();
      stack.push( ExprAssign.createLocalVar(lineNum(), Consts.THIS_NAME,
                                            newCall(conn, "executeBatch", ea, null), true) );
      break;
    default:
      jj_la1[286] = jj_gen;
      jj_consume_token(-1);
      throw new ParseException();
    }
  }

  final public Expr[] BindVariableList(boolean forHib) throws ParseException {
  int lastMark = markStack();
    jj_consume_token(WITH);
    BindVariable(forHib);
    label_57:
    while (true) {
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case COMMA:
        ;
        break;
      default:
        jj_la1[287] = jj_gen;
        break label_57;
      }
      jj_consume_token(COMMA);
      BindVariable(forHib);
    }
                                                               {if (true) return reduce(handleExprs(lastMark));}
    throw new Error("Missing return statement in function");
  }

  final public void BindVariable(boolean forHib) throws ParseException {
  String name = null;
  int idx = -1;
  int type = 0;
  String typeName = null;
  Integer jtype = null;
  String mthdName = null;
  Variable Idx = null;
  Boolean op = null;
  Expr typeObj = null;
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case ATSIGN:
      jj_consume_token(ATSIGN);
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case INTEGER_LITERAL:
        jj_consume_token(INTEGER_LITERAL);
                              idx = parseInt(token.image);
                              if (forHib)
                                throwParseException("hib:query/iterate doesn't take indexed bind variables.");
        break;
      case _USAGE:
      case ENDSCRIPT:
      case _EOF:
      case __EOF:
      case AS:
      case BREAK:
      case CASE:
      case CATCH:
      case CONST:
      case CONTINUE:
      case CONSTRUCTOR:
      case CTOR:
      case _DEFAULT:
      case CLASS:
      case DEFINED:
      case DELETE:
      case DO:
      case ELIF:
      case ELSE:
      case EXEC:
      case EXTENDS:
      case EXTENDSJAVA:
      case FALSE:
      case FINALLY:
      case FOR:
      case FROM:
      case FUNCTION:
      case LAMBDA:
      case THREAD:
      case JAVACLASS:
      case IF:
      case IFDEF:
      case IFNDEF:
      case IFEXISTS:
      case IMPORT:
      case IN:
      case INFINITY:
      case INTO:
      case LOCAL:
      case NEW:
      case MAX_NUMBER:
      case MIN_NUMBER:
      case NULL:
      case LIMIT:
      case NAMESPACE:
      case _SKIP:
      case RESUME:
      case RETURN:
      case STRIP:
      case SUPER:
      case SWITCH:
      case THIS:
      case THROW:
      case TO:
      case UPTO:
      case TYPEOF:
      case ATTRIBUTESOF:
      case ON:
      case DOWNTO:
      case TRUE:
      case TRY:
      case UNDER:
      case UNDEFINED:
      case USING:
      case USE:
      case VAR:
      case WHERE:
      case WHILE:
      case WITH:
      case BOOLEAN:
      case BYTE:
      case CHAR:
      case SHORT:
      case INT:
      case LONG:
      case FLOAT:
      case DOUBLE:
      case STRING:
      case STRING_:
      case VOID:
      case CC:
      case BCC:
      case ATTACH:
      case SUBJECT:
      case BODY:
      case HTMLBODY:
      case LINKEDLIST_:
      case LINKEDLIST:
      case SET_:
      case SET:
      case SORTEDMAP_:
      case SORTEDMAP:
      case DATE_:
      case DATE:
      case NUMBER_:
      case NUMBER:
      case COLUMN:
      case ERR:
      case LOG:
      case OUT:
      case PIPE:
      case INPUT:
      case OUTPUT:
      case NEEDSYSTEMIN:
      case FLUSH:
      case PRINT:
      case PRINTLN:
      case PRINTTABLE:
      case PRINTTABLEDATA:
      case SCP:
      case COPY:
      case MANIFEST:
      case LIST:
      case LS:
      case ORDERED:
      case BY:
      case RMDIR:
      case EXCEPT:
      case SETFILETIME:
      case SETREADONLY:
      case SETREADWRITE:
      case TARGET:
      case EJBQL:
      case AFTER:
      case REPEAT:
      case SCHEDULE:
      case STARTING:
      case XML:
      case XSLT:
      case XPATH:
      case SYSTEMID:
      case OUTPUTPROPERTIES:
      case PARAMETERS:
      case DOM:
      case XMLNS:
      case HTML:
      case JSP:
      case SGML:
      case IDENTIFIER:
        AnyName();
                              name = token.image;
        break;
      default:
        jj_la1[288] = jj_gen;
        jj_consume_token(-1);
        throw new ParseException();
      }
      break;
    case _USAGE:
    case ENDSCRIPT:
    case _EOF:
    case __EOF:
    case AS:
    case BREAK:
    case CASE:
    case CATCH:
    case CONST:
    case CONTINUE:
    case CONSTRUCTOR:
    case CTOR:
    case _DEFAULT:
    case CLASS:
    case DEFINED:
    case DELETE:
    case DO:
    case ELIF:
    case ELSE:
    case EXEC:
    case EXTENDS:
    case EXTENDSJAVA:
    case FALSE:
    case FINALLY:
    case FOR:
    case FROM:
    case FUNCTION:
    case LAMBDA:
    case THREAD:
    case JAVACLASS:
    case IF:
    case IFDEF:
    case IFNDEF:
    case IFEXISTS:
    case IMPORT:
    case IN:
    case INFINITY:
    case INTO:
    case LOCAL:
    case NEW:
    case MAX_NUMBER:
    case MIN_NUMBER:
    case NULL:
    case LIMIT:
    case NAMESPACE:
    case _SKIP:
    case RESUME:
    case RETURN:
    case STRIP:
    case SUPER:
    case SWITCH:
    case THIS:
    case THROW:
    case TO:
    case UPTO:
    case TYPEOF:
    case ATTRIBUTESOF:
    case ON:
    case DOWNTO:
    case TRUE:
    case TRY:
    case UNDER:
    case UNDEFINED:
    case USING:
    case USE:
    case VAR:
    case WHERE:
    case WHILE:
    case WITH:
    case BOOLEAN:
    case BYTE:
    case CHAR:
    case SHORT:
    case INT:
    case LONG:
    case FLOAT:
    case DOUBLE:
    case STRING:
    case STRING_:
    case VOID:
    case CC:
    case BCC:
    case ATTACH:
    case SUBJECT:
    case BODY:
    case HTMLBODY:
    case LINKEDLIST_:
    case LINKEDLIST:
    case SET_:
    case SET:
    case SORTEDMAP_:
    case SORTEDMAP:
    case DATE_:
    case DATE:
    case NUMBER_:
    case NUMBER:
    case COLUMN:
    case ERR:
    case LOG:
    case OUT:
    case PIPE:
    case INPUT:
    case OUTPUT:
    case NEEDSYSTEMIN:
    case FLUSH:
    case PRINT:
    case PRINTLN:
    case PRINTTABLE:
    case PRINTTABLEDATA:
    case SCP:
    case COPY:
    case MANIFEST:
    case LIST:
    case LS:
    case ORDERED:
    case BY:
    case RMDIR:
    case EXCEPT:
    case SETFILETIME:
    case SETREADONLY:
    case SETREADWRITE:
    case TARGET:
    case EJBQL:
    case AFTER:
    case REPEAT:
    case SCHEDULE:
    case STARTING:
    case XML:
    case XSLT:
    case XPATH:
    case SYSTEMID:
    case OUTPUTPROPERTIES:
    case PARAMETERS:
    case DOM:
    case XMLNS:
    case HTML:
    case JSP:
    case SGML:
    case IDENTIFIER:
      AnyName();
                              name = token.image;
      break;
    default:
      jj_la1[289] = jj_gen;
      jj_consume_token(-1);
      throw new ParseException();
    }
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case ARROW:
    case TWOWAYARROW:
    case ASSIGN:
    case COLON:
    case DOT:
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case DOT:
        jj_consume_token(DOT);
        AnyName();
                              mthdName = token.image; Idx = ConstInt.getInt(idx);
        Arguments(Idx,JAVA_INT);
                              Arguments args = (Arguments)stack.pop();
                              stack.push(newBindVar(idx, name, PREPARED_STMT_CALL, null,
                                newCall(null, mthdName, args.getParams(), args.getTypes(), args.doExpand())));
        break;
      case ARROW:
      case TWOWAYARROW:
      case ASSIGN:
      case COLON:
        switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
        case COLON:
          jj_consume_token(COLON);
          switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
          case BOOLEAN:
          case BYTE:
          case CHAR:
          case SHORT:
          case INT:
          case LONG:
          case FLOAT:
          case DOUBLE:
          case STRING:
          case STRING_:
          case DATE_:
          case DATE:
          case NUMBER_:
          case NUMBER:
            switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
            case BOOLEAN:
              jj_consume_token(BOOLEAN);
              break;
            case BYTE:
              jj_consume_token(BYTE);
              break;
            case CHAR:
              jj_consume_token(CHAR);
              break;
            case SHORT:
              jj_consume_token(SHORT);
              break;
            case INT:
              jj_consume_token(INT);
              break;
            case LONG:
              jj_consume_token(LONG);
              break;
            case FLOAT:
              jj_consume_token(FLOAT);
              break;
            case DOUBLE:
              jj_consume_token(DOUBLE);
              break;
            case DATE:
              jj_consume_token(DATE);
              break;
            case DATE_:
              jj_consume_token(DATE_);
              break;
            case NUMBER:
              jj_consume_token(NUMBER);
              break;
            case NUMBER_:
              jj_consume_token(NUMBER_);
              break;
            case STRING_:
              jj_consume_token(STRING_);
              break;
            case STRING:
              jj_consume_token(STRING);
              break;
            default:
              jj_la1[290] = jj_gen;
              jj_consume_token(-1);
              throw new ParseException();
            }
                                      typeName = token.image;
            break;
          case IDENTIFIER:
            jj_consume_token(IDENTIFIER);
                                      typeName = token.image;
            switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
            case LPAREN:
              jj_consume_token(LPAREN);
              Expression();
              jj_consume_token(RPAREN);
                                      typeObj  = reduceIt();
              break;
            default:
              jj_la1[291] = jj_gen;
              ;
            }
            break;
          default:
            jj_la1[292] = jj_gen;
            jj_consume_token(-1);
            throw new ParseException();
          }
          break;
        default:
          jj_la1[293] = jj_gen;
          ;
        }
        switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
        case ASSIGN:
          jj_consume_token(ASSIGN);
          switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
          case JAVA__:
          case _EOF:
          case __EOF:
          case AS:
          case DEFINED:
          case ELIF:
          case EXTENDSJAVA:
          case FALSE:
          case JAVACLASS:
          case IFDEF:
          case IFNDEF:
          case IFEXISTS:
          case IN:
          case INFINITY:
          case INTO:
          case NEW:
          case JAVANEW:
          case MAX_NUMBER:
          case MIN_NUMBER:
          case NULL:
          case LIMIT:
          case NAMESPACE:
          case _SKIP:
          case SUPER:
          case THIS:
          case TYPEOF:
          case ATTRIBUTESOF:
          case TRUE:
          case UNDEFINED:
          case BOOLEAN:
          case BYTE:
          case CHAR:
          case SHORT:
          case INT:
          case LONG:
          case FLOAT:
          case DOUBLE:
          case MAIL__CONNECT:
          case MAIL__DISCONNECT:
          case CC:
          case BCC:
          case ATTACH:
          case SUBJECT:
          case BODY:
          case HTMLBODY:
          case DATE_:
          case DATE:
          case NUMBER:
          case COLUMN:
          case ERR:
          case LOG:
          case NL:
          case OUT:
          case PIPE:
          case INPUT:
          case OUTPUT:
          case NEEDSYSTEMIN:
          case MANIFEST:
          case EXCEPT:
          case SETFILETIME:
          case SETREADONLY:
          case SETREADWRITE:
          case TARGET:
          case DB__DISCONNECT:
          case HIB__ADDCLASS:
          case HIB__ADDRESOURCE:
          case HIB__CLOSE:
          case HIB__TXBEGIN:
          case HIB__TXEND:
          case HIB__TXABORT:
          case HIB__LOCK:
          case HIB__DELETE:
          case HIB__GET:
          case HIB__SAVE:
          case HIB__SAVEORUPDATECOPY:
          case HIB__UNLOCK:
          case HIB__UPDATE:
          case AFTER:
          case STARTING:
          case XML:
          case SYSTEMID:
          case OUTPUTPROPERTIES:
          case PARAMETERS:
          case XMLNS:
          case INTEGER_LITERAL:
          case FLOATING_POINT_LITERAL:
          case STRING_LITERAL:
          case EXEC_RESULT_LITERAL:
          case EXEC_RESULTLINES_LITERAL:
          case IDENTIFIER:
          case CONST_NAME:
          case BANG:
          case TILDE:
          case COLONCOLON:
          case INCR:
          case DECR:
          case PLUS:
          case MINUS:
          case BIT_AND:
          case DOLLARLBRACE:
          case LPAREN:
            Expression();
            break;
          case HEREDOC_BEGIN:
          case HEREDOC_BEGIN_:
            HereDoc();
            break;
          default:
            jj_la1[294] = jj_gen;
            jj_consume_token(-1);
            throw new ParseException();
          }
          break;
        case ARROW:
        case TWOWAYARROW:
          switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
          case ARROW:
            jj_consume_token(ARROW);
            PrimaryExpression(false);
                                           op = Boolean.FALSE;
            break;
          case TWOWAYARROW:
            jj_consume_token(TWOWAYARROW);
            PrimaryExpression(false);
                                           op = Boolean.TRUE;
            break;
          default:
            jj_la1[295] = jj_gen;
            jj_consume_token(-1);
            throw new ParseException();
          }
            if (forHib) throwParseException("HQL doesn't take out-bound variables.");
          break;
        default:
          jj_la1[296] = jj_gen;
          jj_consume_token(-1);
          throw new ParseException();
        }
            Expr val = reduceIt();

            if (forHib) {
              if (typeName == null)
                throwParseException("The HQL bind variable '" + name + "' must have type specified.");
              if (typeName.equals("string")) typeName = "String";
              try { val = StmtHQL.getBindVar(name, typeName, typeObj, val); }
              catch(Exception e) { throwParseException("Invalid Hibernate type '" + typeName + '\''); }
            } else {
              if (typeName != null) typeName = typeName.toLowerCase();
              if (typeName == null)                      type = Types.VARCHAR;
              else if (typeName.equals("boolean"))       type = 16; /* Types.BOOLEAN - JDK1.4 */
              else if (typeName.equals("byte"))          type = Types.TINYINT;
              else if (typeName.equals("date"))          type = Types.DATE;
              else if (typeName.equals("double"))        type = Types.DOUBLE;
              else if (typeName.equals("float"))         type = Types.FLOAT;
              else if (typeName.equals("int"))           type = Types.INTEGER;
              else if (typeName.equals("long"))          type = Types.BIGINT;
              else if (typeName.equals("number"))        type = Types.NUMERIC;
              else if (typeName.equals("short"))         type = Types.SMALLINT;
              else if (typeName.equals("string"))        type = Types.VARCHAR;
              else if (typeName.equals("char"))          type = Types.VARCHAR;
              else if (typeName.equals("varchar"))       type = Types.VARCHAR;
              else if (typeName.equals("struct"))        type = Types.STRUCT;
              else if (typeName.equals("array"))         type = Types.ARRAY;
              else if (typeName.equals("bytes"))         type = Types.VARBINARY;
              else if (typeName.equals("bigDecimal"))    type = Types.BIGINT;
              else if (typeName.equals("blob"))          type = Types.BLOB;
              else if (typeName.equals("clob"))          type = Types.CLOB;
              else if (typeName.equals("time"))          type = Types.TIME;
              else if (typeName.equals("timestamp"))     type = Types.TIMESTAMP;
              else if (typeName.equals("numeric"))       type = Types.NUMERIC;
              else if (typeName.equals("ref"))           type = Types.REF;
              else if (typeName.equals("bit"))           type = Types.BIT;
              else if (typeName.equals("longvarchar"))   type = Types.LONGVARCHAR;
              else if (typeName.equals("other"))         type = Types.OTHER;
              else if (typeName.equals("java_object"))   type = Types.JAVA_OBJECT;
              else if (typeName.equals("oracle_rowid"))  type = ORACLE_ROWID;
              else if (typeName.equals("oracle_cursor")) type = ORACLE_CURSOR;
              else if (typeName.equals("oracle_bfile"))  type = ORACLE_BFILE;
              else throwParseException("Unsupported SQL type: " + token.image);

              val = op == null ? (Expr)newBindVar(idx, name, type, typeName, val)
                               : newOutBoundVar(idx, name, type, val, op.booleanValue());
            }
            stack.push(val);
        break;
      default:
        jj_la1[297] = jj_gen;
        jj_consume_token(-1);
        throw new ParseException();
      }
      break;
    default:
      jj_la1[298] = jj_gen;
      ;
    }
  }

/****************************************
 * HQL APPLICATION SYNTAX STARTS HERE   *
 ****************************************/
  final public void HqlStatements() throws ParseException {
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case HIB__SETUP:
      HibSetupStatement();
      break;
    case HIB__QUERY:
    case HIB__ITERATE:
    case HIB__DELETE:
      HibQueryStatement();
      break;
    default:
      jj_la1[299] = jj_gen;
      jj_consume_token(-1);
      throw new ParseException();
    }
  }

  final public void HibSetupStatement() throws ParseException {
  int lastMark = markStack();
  StmtHQL.Setup stmt;
  String x = null;
    jj_consume_token(HIB__SETUP);
                               stmt = new StmtHQL.Setup(lineNum()); stack.push(stmt);
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case LT:
      jj_consume_token(LT);
      AnyName();
                    x=token.image;
      jj_consume_token(GT);
      break;
    default:
      jj_la1[300] = jj_gen;
      ;
    }
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case LPAREN:
      MemberInitList();
                               stmt.init = handleNamedExprs(lastMark);
      break;
    default:
      jj_la1[301] = jj_gen;
      ;
    }
                               if (x != null) stmt.setName(x);
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case _USAGE:
    case JAVA__:
    case ENDSCRIPT:
    case _EOF:
    case __EOF:
    case AS:
    case DEFINED:
    case DELETE:
    case ELIF:
    case EXEC:
    case EXTENDSJAVA:
    case FUNCTION:
    case LAMBDA:
    case JAVACLASS:
    case IFDEF:
    case IFNDEF:
    case IFEXISTS:
    case IN:
    case INFINITY:
    case INTO:
    case LOCAL:
    case LIMIT:
    case NAMESPACE:
    case _SKIP:
    case RESUME:
    case STRIP:
    case TYPEOF:
    case ATTRIBUTESOF:
    case UNDER:
    case UNDEFINED:
    case USING:
    case USE:
    case VAR:
    case WHERE:
    case WITH:
    case STRING:
    case STRING_:
    case CC:
    case BCC:
    case ATTACH:
    case SUBJECT:
    case BODY:
    case HTMLBODY:
    case LINKEDLIST_:
    case LINKEDLIST:
    case SET_:
    case SET:
    case SORTEDMAP_:
    case SORTEDMAP:
    case DATE_:
    case DATE:
    case NUMBER_:
    case NUMBER:
    case COLUMN:
    case ERR:
    case LOG:
    case OUT:
    case PIPE:
    case INPUT:
    case OUTPUT:
    case NEEDSYSTEMIN:
    case FLUSH:
    case PRINT:
    case PRINTLN:
    case PRINTTABLE:
    case PRINTTABLEDATA:
    case SCP:
    case COPY:
    case MANIFEST:
    case LIST:
    case LS:
    case ORDERED:
    case BY:
    case RMDIR:
    case EXCEPT:
    case SETFILETIME:
    case SETREADONLY:
    case SETREADWRITE:
    case TARGET:
    case EJBQL:
    case AFTER:
    case REPEAT:
    case SCHEDULE:
    case STARTING:
    case XML:
    case XSLT:
    case XPATH:
    case SYSTEMID:
    case OUTPUTPROPERTIES:
    case PARAMETERS:
    case DOM:
    case XMLNS:
    case HTML:
    case JSP:
    case SGML:
    case STRING_LITERAL:
    case IDENTIFIER:
    case CONST_NAME:
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case STRING_LITERAL:
        jj_consume_token(STRING_LITERAL);
                                             stmt.addResource(Lib.unquote(token.image));
        break;
      case _USAGE:
      case JAVA__:
      case ENDSCRIPT:
      case _EOF:
      case __EOF:
      case AS:
      case DEFINED:
      case DELETE:
      case ELIF:
      case EXEC:
      case EXTENDSJAVA:
      case FUNCTION:
      case LAMBDA:
      case JAVACLASS:
      case IFDEF:
      case IFNDEF:
      case IFEXISTS:
      case IN:
      case INFINITY:
      case INTO:
      case LOCAL:
      case LIMIT:
      case NAMESPACE:
      case _SKIP:
      case RESUME:
      case STRIP:
      case TYPEOF:
      case ATTRIBUTESOF:
      case UNDER:
      case UNDEFINED:
      case USING:
      case USE:
      case VAR:
      case WHERE:
      case WITH:
      case STRING:
      case STRING_:
      case CC:
      case BCC:
      case ATTACH:
      case SUBJECT:
      case BODY:
      case HTMLBODY:
      case LINKEDLIST_:
      case LINKEDLIST:
      case SET_:
      case SET:
      case SORTEDMAP_:
      case SORTEDMAP:
      case DATE_:
      case DATE:
      case NUMBER_:
      case NUMBER:
      case COLUMN:
      case ERR:
      case LOG:
      case OUT:
      case PIPE:
      case INPUT:
      case OUTPUT:
      case NEEDSYSTEMIN:
      case FLUSH:
      case PRINT:
      case PRINTLN:
      case PRINTTABLE:
      case PRINTTABLEDATA:
      case SCP:
      case COPY:
      case MANIFEST:
      case LIST:
      case LS:
      case ORDERED:
      case BY:
      case RMDIR:
      case EXCEPT:
      case SETFILETIME:
      case SETREADONLY:
      case SETREADWRITE:
      case TARGET:
      case EJBQL:
      case AFTER:
      case REPEAT:
      case SCHEDULE:
      case STARTING:
      case XML:
      case XSLT:
      case XPATH:
      case SYSTEMID:
      case OUTPUTPROPERTIES:
      case PARAMETERS:
      case DOM:
      case XMLNS:
      case HTML:
      case JSP:
      case SGML:
      case IDENTIFIER:
      case CONST_NAME:
        switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
        case JAVA__:
          jj_consume_token(JAVA__);
          break;
        default:
          jj_la1[302] = jj_gen;
          ;
        }
        x = JavaClassName();
                                             stmt.addClass(x);
        break;
      default:
        jj_la1[303] = jj_gen;
        jj_consume_token(-1);
        throw new ParseException();
      }
      label_58:
      while (true) {
        switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
        case COMMA:
          ;
          break;
        default:
          jj_la1[304] = jj_gen;
          break label_58;
        }
        jj_consume_token(COMMA);
        switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
        case STRING_LITERAL:
          jj_consume_token(STRING_LITERAL);
                                             stmt.addResource(Lib.unquote(token.image));
          break;
        case _USAGE:
        case JAVA__:
        case ENDSCRIPT:
        case _EOF:
        case __EOF:
        case AS:
        case DEFINED:
        case DELETE:
        case ELIF:
        case EXEC:
        case EXTENDSJAVA:
        case FUNCTION:
        case LAMBDA:
        case JAVACLASS:
        case IFDEF:
        case IFNDEF:
        case IFEXISTS:
        case IN:
        case INFINITY:
        case INTO:
        case LOCAL:
        case LIMIT:
        case NAMESPACE:
        case _SKIP:
        case RESUME:
        case STRIP:
        case TYPEOF:
        case ATTRIBUTESOF:
        case UNDER:
        case UNDEFINED:
        case USING:
        case USE:
        case VAR:
        case WHERE:
        case WITH:
        case STRING:
        case STRING_:
        case CC:
        case BCC:
        case ATTACH:
        case SUBJECT:
        case BODY:
        case HTMLBODY:
        case LINKEDLIST_:
        case LINKEDLIST:
        case SET_:
        case SET:
        case SORTEDMAP_:
        case SORTEDMAP:
        case DATE_:
        case DATE:
        case NUMBER_:
        case NUMBER:
        case COLUMN:
        case ERR:
        case LOG:
        case OUT:
        case PIPE:
        case INPUT:
        case OUTPUT:
        case NEEDSYSTEMIN:
        case FLUSH:
        case PRINT:
        case PRINTLN:
        case PRINTTABLE:
        case PRINTTABLEDATA:
        case SCP:
        case COPY:
        case MANIFEST:
        case LIST:
        case LS:
        case ORDERED:
        case BY:
        case RMDIR:
        case EXCEPT:
        case SETFILETIME:
        case SETREADONLY:
        case SETREADWRITE:
        case TARGET:
        case EJBQL:
        case AFTER:
        case REPEAT:
        case SCHEDULE:
        case STARTING:
        case XML:
        case XSLT:
        case XPATH:
        case SYSTEMID:
        case OUTPUTPROPERTIES:
        case PARAMETERS:
        case DOM:
        case XMLNS:
        case HTML:
        case JSP:
        case SGML:
        case IDENTIFIER:
        case CONST_NAME:
          switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
          case JAVA__:
            jj_consume_token(JAVA__);
            break;
          default:
            jj_la1[305] = jj_gen;
            ;
          }
          x = JavaClassName();
                                             stmt.addClass(x);
          break;
        default:
          jj_la1[306] = jj_gen;
          jj_consume_token(-1);
          throw new ParseException();
        }
      }
      break;
    default:
      jj_la1[307] = jj_gen;
      ;
    }
    jj_consume_token(SEMICOLON);
  }

  final public void HibQueryStatement() throws ParseException {
  StmtHQL stmt = new StmtHQL();
  stack.push(stmt);
  Object[] oa;
  boolean isColl;
    if (jj_2_87(2147483647)) {
      jj_consume_token(HIB__DELETE);
                               oa = new Object[]{ "hib::delete", null };
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case LT:
        jj_consume_token(LT);
        AnyName();
                      stmt.envName = token.image;
        jj_consume_token(GT);
        break;
      default:
        jj_la1[308] = jj_gen;
        ;
      }
      ArgumentList(null,0,false);
                                 oa[1] = stack.pop(); stack.push( reduce(new ExprPrimary(oa)) );
      jj_consume_token(SEMICOLON);
    } else {
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case HIB__QUERY:
      case HIB__ITERATE:
      case HIB__DELETE:
        switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
        case HIB__QUERY:
          jj_consume_token(HIB__QUERY);
          break;
        case HIB__ITERATE:
          jj_consume_token(HIB__ITERATE);
                               stmt.action = stmt.ACTION_ITERATE;
          break;
        case HIB__DELETE:
          jj_consume_token(HIB__DELETE);
                               stmt.action = stmt.ACTION_DELETE;
          break;
        default:
          jj_la1[309] = jj_gen;
          jj_consume_token(-1);
          throw new ParseException();
        }
                               stmt.setLineNumber(lineNum());
        switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
        case LT:
          jj_consume_token(LT);
          AnyName();
                      stmt.envName = token.image;
          jj_consume_token(GT);
          break;
        default:
          jj_la1[310] = jj_gen;
          ;
        }
        switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
        case IDENTIFIER:
          jj_consume_token(IDENTIFIER);
                               stmt.returnName=token.image;
          break;
        default:
          jj_la1[311] = jj_gen;
          ;
        }
        label_59:
        while (true) {
          switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
          case FROM:
          case IN:
          case LIMIT:
            ;
            break;
          default:
            jj_la1[312] = jj_gen;
            break label_59;
          }
          switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
          case FROM:
            jj_consume_token(FROM);
            Expression();
                                 stmt.from = reduceIt(); isColl = false;
            break;
          case LIMIT:
            jj_consume_token(LIMIT);
            Expression();
                                 stmt.limit = reduceIt(); isColl = false;
            break;
          case IN:
            jj_consume_token(IN);
            Expression();
                                 stmt.collection = reduceIt(); isColl = true;
            break;
          default:
            jj_la1[313] = jj_gen;
            jj_consume_token(-1);
            throw new ParseException();
          }
        if (stmt.action == stmt.ACTION_DELETE)
          throwParseException(isColl ? "hib::delete in a collection is not supported."
                                     : "hib::delete doesn't take pagination options.");
        }
        jj_consume_token(COLON);
        Mixture(token.beginLine,token.beginColumn);
                                                     stmt.hql = reduce(handleSingleExpr());
        jj_consume_token(SEMICOLON);
        if (jj_2_86(2)) {
          stmt.bindVars = BindVariableList(true);
          jj_consume_token(SEMICOLON);
            try { stmt.checkBindVars(); } catch(Exception e) { throwParseException(e.getMessage()); }
        } else {
          ;
        }
        break;
      default:
        jj_la1[314] = jj_gen;
        jj_consume_token(-1);
        throw new ParseException();
      }
    }
  }

/*******************************************
 * Here-Doc, Mixture and RawSqlList Syntax *
 *******************************************/
  final public void HereDoc() throws ParseException {
  int lastMark = markStack();
  int row = 0;
  int column = 0;
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case HEREDOC_BEGIN:
      jj_consume_token(HEREDOC_BEGIN);
      break;
    case HEREDOC_BEGIN_:
      jj_consume_token(HEREDOC_BEGIN_);
      break;
    default:
      jj_la1[315] = jj_gen;
      jj_consume_token(-1);
      throw new ParseException();
    }
                       row=token.beginLine; column=token.beginColumn+token.image.length();
    HereDocProcContent(token.image.length()==3, row, column);
    jj_consume_token(316);
    stack.push( handleMixture(row, token.endLine, handleAny(lastMark)) );
  }

  final public void HereDocContent() throws ParseException {
  token_source.inHereDoc = true;
  switchTo(HEREDOC);
    label_60:
    while (true) {
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case HEREDOC_PART:
        jj_consume_token(HEREDOC_PART);
                      stack.push(JudoUtil.parseString(unicodify(token.image)));
        break;
      case INEXPR_START:
        jj_consume_token(INEXPR_START);
        Expression();
        jj_consume_token(INEXPR_END);
        break;
      default:
        jj_la1[316] = jj_gen;
        jj_consume_token(-1);
        throw new ParseException();
      }
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case INEXPR_START:
      case HEREDOC_PART:
        ;
        break;
      default:
        jj_la1[317] = jj_gen;
        break label_60;
      }
    }
                      token_source.inHereDoc = false;
  }

  final public void Mixture(int row, int column) throws ParseException {
  Object o;
    o = MixtureList(false, row, column);
                                      stack.push(o);
  }

  final public Expr SingleMixture() throws ParseException {
  int lastMark = markStack();
  int beginLine = -1;
  int endLine = -1;
  switchTo(MIXTURE);
    label_61:
    while (true) {
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case MIXTURE_PART:
        jj_consume_token(MIXTURE_PART);
                     stack.push(token.image);
                     if (beginLine < 0) beginLine = token.beginLine;
                     if (token.endLine > endLine) endLine = token.endLine;
        break;
      case INEXPR_START:
        jj_consume_token(INEXPR_START);
                     if (beginLine < 0) beginLine = token.beginLine;
        Expression();
        jj_consume_token(INEXPR_END);
                     if (token.endLine > endLine) endLine = token.endLine;
        break;
      default:
        jj_la1[318] = jj_gen;
        jj_consume_token(-1);
        throw new ParseException();
      }
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case INEXPR_START:
      case MIXTURE_PART:
        ;
        break;
      default:
        jj_la1[319] = jj_gen;
        break label_61;
      }
    }
    {if (true) return handleMixture(beginLine, endLine, handleAny(lastMark));}
    throw new Error("Missing return statement in function");
  }

  final public Expr[] MultiMixture() throws ParseException {
  Object o;
  int lastMark = markStack();
    label_62:
    while (true) {
      o = SingleMixture();
      jj_consume_token(SEMICOLON);
                            stack.push(o); switchTo(MIXTURE);
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case INEXPR_START:
      case MIXTURE_PART:
        ;
        break;
      default:
        jj_la1[320] = jj_gen;
        break label_62;
      }
    }
    {if (true) return handleExprs(lastMark);}
    throw new Error("Missing return statement in function");
  }

  final public Expr[] RawSqlList() throws ParseException {
  Object o;
  int row = 0;
  int column = 0;
    jj_consume_token(LBRACE);
        row = token.beginLine; column = token.beginColumn;
    o = MixtureList(true, row, column);
    jj_consume_token(RBRACE);
         {if (true) return (Expr[])o;}
    throw new Error("Missing return statement in function");
  }

  Object MixtureList(boolean multi, int row, int column) throws ParseException {
                                                         // returns multi ? Expr[] : Expr.
  try {
    CharStream instrm = token_source.getInputStream();
    StringReader sr = new StringReader(unicodify(mixtureParser.parse(instrm, multi).trim()));
    if (subParser != null)
      subParser.ReInit(new JudoCharStream(sr));
    else
      subParser = new JudoParser(new JudoCharStream(sr));

    ((JavaCharStream)subParser.token_source.getInputStream()).ReInit(sr, row, column);

    subParser.switchTo(MIXTURE);
    try {
      subParser.stack.clear();
      return multi ? (Object)subParser.MultiMixture() : subParser.SingleMixture();
    } finally {
      subParser.ReInit((JudoCharStream)null);  // to avoid memory leak
    }
  } catch(IOException ioe) {
    throwParseException("Unfinished SQL statement list.");
  }
  return null;
  }

  void HereDocProcContent(boolean doProc, int beginLine, int beginColumn) throws ParseException {
  char ch;
  StringBuffer sb = new StringBuffer();
  CharStream instrm = token_source.getInputStream();

  try {
    // Step 1. collect all char's up to "*]]" into sb.
    while (true) {
      ch = instrm.readChar();
      if (ch != '*') {
        if (ch == EOF) break; // failure.
        sb.append(ch);
      } else {
        ch = instrm.readChar();
        if (ch != ']') {
          sb.append('*');
          sb.append(ch);
        } else {
          ch = instrm.readChar();
          if (ch != ']') { // got the end.
            sb.append("*]");
            sb.append(ch);
          } else {
            instrm.backup(3);
            break;
          }
        }
      }
    }

    // Step 2. Process the indentation
    //         We use a StringReader and read lines.
    //         For the first up to 3 non-empty lines, get the leading white spaces;
    //         the shortest of them is chosen as indentation.
    //         all the lines starting with that indentation are stripped.
    int i=0;
    if (doProc) {
      BufferedReader br = new BufferedReader(new StringReader(sb.toString()));
      sb.setLength(0);
      ArrayList lines = new ArrayList();
      String indent = null;
      String line = br.readLine();
      if (Lib.isEmpty(line)) // skip the first empty line.
        line = br.readLine();
      // now, for the first 3 non-empty lines, find the indent:
lp:   while (true) {
        if (line == null) break;
        lines.add(line);
        if (Lib.isEmpty(line)) {
          lines.add("");
        } else {  // for the first line only; it's ok.
          int j=0;
          while (Character.isWhitespace(line.charAt(j))) ++j;
          if ( (j>0) && ( (indent==null) || (j<indent.length()) ) )
            indent = line.substring(0, j);
        }
        if (++i >= 3) break lp;
        while (true) {
          line = br.readLine();
          if (line == null) break lp;
          if (Lib.isNotEmpty(line)) break;
          lines.add(line);
        }
      }
      // process the first lines contributed to the finding of indent:
      for (i=0; i<lines.size(); i++) {
        line = (String)lines.get(i);
        if ((indent==null) || !line.startsWith(indent))
          sb.append(line);
        else
          sb.append(line.substring(indent.length()));
        sb.append(ConstString.newline);
      }
      lines = null;
      // process the rest of lines:
      while(true) {
        line = br.readLine();
        if (line == null) break;
        if ((indent==null) || !line.startsWith(indent))
          sb.append(line);
        else
          sb.append(line.substring(indent.length()));
        sb.append(ConstString.newline);
      }
      // remove the last newline:
      if (sb.length() >= ConstString.newline.length()) {
        sb.setLength(sb.length() - ConstString.newline.length());
        // remove the trailing whitespaces
        for (i=sb.length()-1; i>=0; --i) {
          ch = sb.charAt(i);
          if (Character.isWhitespace(ch)) {
            if ((ch=='\n') || (ch=='\r'))
              break;
          } else
            break;
        }
        sb.setLength(i+1);
      }
    }

    // Step 3. Do the parsing with subParser.
    StringReader sr = new StringReader(unicodify(sb.toString()));
    if (subParser != null)
      subParser.ReInit(new JudoCharStream(sr));
    else
      subParser = new JudoParser(new JudoCharStream(sr));
    try {
      subParser.stack.clear();
      // do the parsing
      ((JavaCharStream)subParser.token_source.getInputStream()).ReInit(sr, beginLine, beginColumn);
      subParser.switchTo(HEREDOC);
      subParser.HereDocContent();
      // move what is found here.
      for (i=0; i<subParser.stack.size(); ++i)
        stack.push(subParser.stack.get(i));
    } finally {
      subParser.stack.clear();
      subParser.ReInit((JudoCharStream)null);  // to avoid memory leak
    }

  } catch(IOException ioe) {
    throwParseException("Unfinished HereDoc list.");
  }
  }

  final public void LinesStatement() throws ParseException {
  int lastMark = 0;
  ExprLines col = new ExprLines();
  String label = null;
  int lineNo = 0;
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case AS:
    case ELIF:
    case EXTENDSJAVA:
    case IFDEF:
    case IFNDEF:
    case IFEXISTS:
    case IN:
    case INTO:
    case LIMIT:
    case NAMESPACE:
    case _SKIP:
    case CC:
    case BCC:
    case ATTACH:
    case SUBJECT:
    case BODY:
    case HTMLBODY:
    case NUMBER:
    case COLUMN:
    case ERR:
    case LOG:
    case OUT:
    case PIPE:
    case INPUT:
    case OUTPUT:
    case NEEDSYSTEMIN:
    case MANIFEST:
    case EXCEPT:
    case SETFILETIME:
    case SETREADONLY:
    case SETREADWRITE:
    case TARGET:
    case AFTER:
    case STARTING:
    case XML:
    case SYSTEMID:
    case OUTPUTPROPERTIES:
    case PARAMETERS:
    case XMLNS:
    case IDENTIFIER:
      LabelName();
                         label = setCurrentLabel(); lineNo = lineNum();
      jj_consume_token(COLON);
      break;
    default:
      jj_la1[321] = jj_gen;
      ;
    }
    jj_consume_token(DO);
    Expression();
                         col.src = reduceIt();
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case IN:
      jj_consume_token(IN);
      Expression();
                         col.root = reduceIt();
      break;
    default:
      jj_la1[322] = jj_gen;
      ;
    }
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case LBRACE:
      Encoding();
                         col.encoding = reduceIt();
      break;
    default:
      jj_la1[323] = jj_gen;
      ;
    }
    jj_consume_token(AS);
    id("lines");
                         lastMark = markStack();
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case FOR:
    case EXCEPT:
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case FOR:
        jj_consume_token(FOR);
        break;
      case EXCEPT:
        jj_consume_token(EXCEPT);
                         col.filterNegative = true;
        break;
      default:
        jj_la1[324] = jj_gen;
        jj_consume_token(-1);
        throw new ParseException();
      }
      Expression();
                         col.filter = reduceIt();
      break;
    default:
      jj_la1[325] = jj_gen;
      ;
    }
    jj_consume_token(LBRACE);
    label_63:
    while (true) {
      Statement();
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case ANTTASK__:
      case JAVA__:
      case _EOF:
      case __EOF:
      case AS:
      case BREAK:
      case CONTINUE:
      case DEFINED:
      case DELETE:
      case DO:
      case ELIF:
      case EXEC:
      case EXTENDSJAVA:
      case FALSE:
      case FOR:
      case JAVACLASS:
      case IF:
      case IFDEF:
      case IFNDEF:
      case IFEXISTS:
      case IMPORT:
      case IN:
      case INFINITY:
      case INTO:
      case INCLUDE:
      case LOCAL:
      case NEW:
      case JAVANEW:
      case MAX_NUMBER:
      case MIN_NUMBER:
      case NULL:
      case PRAGMA:
      case JAVAGUICLASS:
      case JAVABASECLASS:
      case JAVAENTERPRISECLASS:
      case JAVACORBACLASS:
      case JCOMCLASS:
      case JAVAPACKAGES:
      case DEFINEJAVAPACKAGES:
      case LIMIT:
      case NAMESPACE:
      case _SKIP:
      case RESUME:
      case RETURN:
      case SUPER:
      case SWITCH:
      case THIS:
      case THROW:
      case TYPEOF:
      case ATTRIBUTESOF:
      case TRUE:
      case TRY:
      case UNDEFINED:
      case USE:
      case VAR:
      case WHILE:
      case WITH:
      case BOOLEAN:
      case BYTE:
      case CHAR:
      case SHORT:
      case INT:
      case LONG:
      case FLOAT:
      case DOUBLE:
      case MAIL__SEND:
      case MAIL__CONNECT:
      case MAIL__DISCONNECT:
      case SENDMAIL:
      case CC:
      case BCC:
      case ATTACH:
      case SUBJECT:
      case BODY:
      case HTMLBODY:
      case DATE_:
      case DATE:
      case NUMBER:
      case COLUMN:
      case ERR:
      case LOG:
      case NL:
      case OUT:
      case PIPE:
      case INPUT:
      case OUTPUT:
      case NEEDSYSTEMIN:
      case FLUSH:
      case PRINT:
      case PRINTLN:
      case PRINTTABLE:
      case PRINTTABLEDATA:
      case SCP:
      case COPY:
      case MANIFEST:
      case LIST:
      case LS:
      case RMDIR:
      case EXCEPT:
      case SETFILETIME:
      case SETREADONLY:
      case SETREADWRITE:
      case TARGET:
      case ADDBATCH:
      case CONNECT:
      case EXECUTEBATCH:
      case EXECUTEQUERY:
      case EXECUTEQUERYCALL:
      case EXECUTEANY:
      case EXECUTESQL:
      case EXECUTEUPDATE:
      case EXECUTEUPDATECALL:
      case PREPARE:
      case PREPARECALL:
      case PREPAREDEXECUTE:
      case PREPAREDEXECUTECALL:
      case PREPAREDEXECUTEQUERY:
      case PREPAREDEXECUTECALLQUERY:
      case PREPAREDEXECUTEUPDATE:
      case PREPAREDEXECUTECALLUPDATE:
      case DB__DUMPTABLE:
      case DB__ADDBATCH:
      case DB__CONNECT:
      case DB__DISCONNECT:
      case DB__BATCH:
      case DB__QUERY:
      case DB__QUERYCALL:
      case DB__ANY:
      case DB__SQL:
      case DB__CALL:
      case DB__UPDATE:
      case DB__UPDATECALL:
      case DB__PREPARE:
      case DB__PREPARECALL:
      case HIB__SETUP:
      case HIB__ADDCLASS:
      case HIB__ADDRESOURCE:
      case HIB__CLOSE:
      case HIB__TXBEGIN:
      case HIB__TXEND:
      case HIB__TXABORT:
      case HIB__LOCK:
      case HIB__QUERY:
      case HIB__ITERATE:
      case HIB__DELETE:
      case HIB__GET:
      case HIB__SAVE:
      case HIB__SAVEORUPDATECOPY:
      case HIB__UNLOCK:
      case HIB__UPDATE:
      case AFTER:
      case REPEAT:
      case SCHEDULE:
      case STARTING:
      case XML:
      case XSLT:
      case SYSTEMID:
      case OUTPUTPROPERTIES:
      case PARAMETERS:
      case XMLNS:
      case GUIEVENTS:
      case GUI__EVENTS:
      case INTEGER_LITERAL:
      case FLOATING_POINT_LITERAL:
      case STRING_LITERAL:
      case EXEC_RESULT_LITERAL:
      case EXEC_RESULTLINES_LITERAL:
      case IDENTIFIER:
      case CONST_NAME:
      case BANG:
      case TILDE:
      case COLONCOLON:
      case INCR:
      case DECR:
      case PLUS:
      case MINUS:
      case BIT_AND:
      case DOLLARLBRACE:
      case LBRACE:
      case LPAREN:
      case DOT:
      case SEMICOLON:
        ;
        break;
      default:
        jj_la1[326] = jj_gen;
        break label_63;
      }
    }
                         handleStmts(lastMark);
                         StmtForIn stmt = new StmtForIn(lineNo, label, "$_", col, ConstInt.ZERO,
                                                        ConstInt.ZERO, ConstInt.ONE, false);
                         stmt.setStmts(stmts,labels);
                         stack.push(stmt);
                         if (label != null) labelStack.pop();
    jj_consume_token(RBRACE);
  }

/**********************************************
 * SCHEDULING APPLICATION SYNTAX STARTS HERE  *
 **********************************************/
  final public void ScheduleStatement() throws ParseException {
  boolean isAbs = false;
  boolean isStart = false;
  Expr start_after = null;
  Expr period = null;
  StmtSchedule ss;
    jj_consume_token(SCHEDULE);
                        ss = new StmtSchedule(lineNum());
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case IDENTIFIER:
      id("absolute");
                        ss.isAbsolute = true;
      break;
    default:
      jj_la1[327] = jj_gen;
      ;
    }
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case AFTER:
    case STARTING:
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case STARTING:
        jj_consume_token(STARTING);
                        ss.isStart = true;
        break;
      case AFTER:
        jj_consume_token(AFTER);
                        ss.isStart = false;
        break;
      default:
        jj_la1[328] = jj_gen;
        jj_consume_token(-1);
        throw new ParseException();
      }
      Expression();
                        ss.start_delay = reduceIt();
      break;
    default:
      jj_la1[329] = jj_gen;
      ;
    }
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case REPEAT:
      jj_consume_token(REPEAT);
      Expression();
                        ss.period = reduceIt();
      break;
    default:
      jj_la1[330] = jj_gen;
      ;
    }
    SimpleBlock(null,false);
                              ss.block = (BlockSimple)stack.pop();
    if (jj_2_88(2)) {
      id("listen");
      jj_consume_token(ON);
      Expression();
                        ss.port = reduceIt();
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case IDENTIFIER:
        jj_consume_token(IDENTIFIER);
                        shouldBe("title");
        Expression();
                        ss.title = reduceIt();
        break;
      default:
        jj_la1[331] = jj_gen;
        ;
      }
      SimpleBlock(null,false);
                              ss.listener = (BlockSimple)stack.pop();
    } else {
      ;
    }
                        stack.push(ss);
  }

/***************************************
 * XML APPLICATION SYNTAX STARTS HERE  *
 ***************************************/
  final public void Dom() throws ParseException {
  Expr src = null;
  Expr sysid = null;
  AssociateList inits = null;
  XmlProperty xp = new XmlProperty();
    jj_consume_token(DO);
    Expression();
                               src = reduceIt();
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case SYSTEMID:
      jj_consume_token(SYSTEMID);
      Expression();
                               sysid = reduceIt();
      break;
    default:
      jj_la1[332] = jj_gen;
      ;
    }
    jj_consume_token(AS);
    jj_consume_token(DOM);
    if (jj_2_89(2)) {
      XmlInitList(xp);
    } else {
      ;
    }
    stack.push(new ExprDom(src,sysid,xp.xmlns,xp.namespace,xp.validate,
                           xp.schema,xp.ignoreWhitespace,xp.ignoreComment));
  }

  final public void XmlStatement() throws ParseException {
  XmlHandler hndr = null;
  int lineNo = 0;
  int lastMark = 0;
  XmlProperty xp = new XmlProperty();
  String type = null;
    jj_consume_token(DO);
                              lineNo = lineNum();
    Expression();
                              hndr = new XmlHandler(lineNo,reduceIt(),null);
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case IN:
      jj_consume_token(IN);
      Expression();
                              hndr.setRoot(reduceIt());
      break;
    default:
      jj_la1[333] = jj_gen;
      ;
    }
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case LBRACE:
      Encoding();
                              hndr.setEncoding(reduceIt());
      break;
    default:
      jj_la1[334] = jj_gen;
      ;
    }
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case SYSTEMID:
      jj_consume_token(SYSTEMID);
      Expression();
                              hndr.systemID = reduceIt();
      break;
    default:
      jj_la1[335] = jj_gen;
      ;
    }
    jj_consume_token(AS);
    jj_consume_token(XML);
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case WITH:
      XmlInitList(xp);
      break;
    default:
      jj_la1[336] = jj_gen;
      ;
    }
    jj_consume_token(LBRACE);
                              hndr.doNamespace = xp.namespace;
                              hndr.doValidate = xp.validate;
                              hndr.doSchema = xp.schema;
                              hndr.xmlns = xp.xmlns;
    label_64:
    while (true) {
      if (jj_2_92(2)) {
        XmlTagHandler(hndr);
      } else if (jj_2_93(2147483647)) {
        switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
        case LT:
          jj_consume_token(LT);
          jj_consume_token(GT);
                         type = ANY_TAG_SYMBOL;
          break;
        case COLON:
          jj_consume_token(COLON);
          jj_consume_token(IDENTIFIER);
                         String x = token.image.toUpperCase();
                         if (x.equals("TEXT"))
                           type = ANY_TEXT_SYMBOL;
                         else if (x.equals("WARNING")         ||
                                  x.equals("ERROR")           ||
                                  x.equals("START_DOC")       ||
                                  x.equals("END_DOC")         ||
                                  x.equals("START_NS_MAP")    ||
                                  x.equals("END_NS_MAP")      ||
                                  x.equals("PI")              ||
                                  x.equals("WHITESPACE")      ||
                                  x.equals("COMMENT")         ||
                                  x.equals("START_CDATA")     ||
                                  x.equals("END_CDATA")       ||
                                  x.equals("START_DTD")       ||
                                  x.equals("END_DTD")         ||
                                  x.equals("START_ENTITY")    ||
                                  x.equals("END_ENTITY")      ||
                                  x.equals("ELEMENT_DECL")    ||
                                  x.equals("ATTR_DECL")       ||
                                  x.equals("ENTITY_DECL")     ||
                                  x.equals("EXT_ENTITY_DECL") ||
                                  x.equals("SKIPPED_ENTITY")
                                 )
                           type = XML_EVENT_PREFIX + x;
                         else if (x.equals("BEFORE") || x.equals("AFTER"))
                           type = x;
                         else
                           throwParseException("Unknown XML event: " + token.image);
          break;
        default:
          jj_la1[337] = jj_gen;
          jj_consume_token(-1);
          throw new ParseException();
        }
        jj_consume_token(COLON);
                         lastMark = markStack(); lineNo = lineNum();
        label_65:
        while (true) {
          Statement();
          if (jj_2_90(2)) {
            ;
          } else {
            break label_65;
          }
        }
                         handleStmts(lastMark);
                         if (type.equals("BEFORE"))     hndr.setInit(stmts);
                         else if (type.equals("AFTER")) hndr.setFinish(stmts);
                         else                           hndr.addHandler(lineNo, type, stmts);
        jj_consume_token(COLON);
        label_66:
        while (true) {
          Statement();
          if (jj_2_91(2)) {
            ;
          } else {
            break label_66;
          }
        }
      } else {
        jj_consume_token(-1);
        throw new ParseException();
      }
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case LT:
      case LTSLASH:
      case COLON:
        ;
        break;
      default:
        jj_la1[338] = jj_gen;
        break label_64;
      }
    }
    jj_consume_token(RBRACE);
                         stack.push(hndr);
  }

  final public void XmlInitList(XmlProperty xp) throws ParseException {
    jj_consume_token(WITH);
    XmlInitializer(xp);
    label_67:
    while (true) {
      if (jj_2_94(2)) {
        ;
      } else {
        break label_67;
      }
      jj_consume_token(COMMA);
      XmlInitializer(xp);
    }
  }

  final public void XmlInitializer(XmlProperty xp) throws ParseException {
  String s = null;
  boolean val = true;
    if (jj_2_95(2)) {
      jj_consume_token(XMLNS);
                           s = DEFAULT_NS_SYMBOL;
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case COLON:
        jj_consume_token(COLON);
        AnyName();
                           s = token.image;
        break;
      default:
        jj_la1[339] = jj_gen;
        ;
      }
      jj_consume_token(ASSIGN);
      jj_consume_token(STRING_LITERAL);
                           xp.addXmlNS(s, unquote(token.image));
    } else {
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case _USAGE:
      case ENDSCRIPT:
      case _EOF:
      case __EOF:
      case AS:
      case BREAK:
      case CASE:
      case CATCH:
      case CONST:
      case CONTINUE:
      case CONSTRUCTOR:
      case CTOR:
      case _DEFAULT:
      case CLASS:
      case DEFINED:
      case DELETE:
      case DO:
      case ELIF:
      case ELSE:
      case EXEC:
      case EXTENDS:
      case EXTENDSJAVA:
      case FALSE:
      case FINALLY:
      case FOR:
      case FROM:
      case FUNCTION:
      case LAMBDA:
      case THREAD:
      case JAVACLASS:
      case IF:
      case IFDEF:
      case IFNDEF:
      case IFEXISTS:
      case IMPORT:
      case IN:
      case INFINITY:
      case INTO:
      case LOCAL:
      case NEW:
      case MAX_NUMBER:
      case MIN_NUMBER:
      case NULL:
      case LIMIT:
      case NAMESPACE:
      case _SKIP:
      case RESUME:
      case RETURN:
      case STRIP:
      case SUPER:
      case SWITCH:
      case THIS:
      case THROW:
      case TO:
      case UPTO:
      case TYPEOF:
      case ATTRIBUTESOF:
      case ON:
      case DOWNTO:
      case TRUE:
      case TRY:
      case UNDER:
      case UNDEFINED:
      case USING:
      case USE:
      case VAR:
      case WHERE:
      case WHILE:
      case WITH:
      case BOOLEAN:
      case BYTE:
      case CHAR:
      case SHORT:
      case INT:
      case LONG:
      case FLOAT:
      case DOUBLE:
      case STRING:
      case STRING_:
      case VOID:
      case CC:
      case BCC:
      case ATTACH:
      case SUBJECT:
      case BODY:
      case HTMLBODY:
      case LINKEDLIST_:
      case LINKEDLIST:
      case SET_:
      case SET:
      case SORTEDMAP_:
      case SORTEDMAP:
      case DATE_:
      case DATE:
      case NUMBER_:
      case NUMBER:
      case COLUMN:
      case ERR:
      case LOG:
      case OUT:
      case PIPE:
      case INPUT:
      case OUTPUT:
      case NEEDSYSTEMIN:
      case FLUSH:
      case PRINT:
      case PRINTLN:
      case PRINTTABLE:
      case PRINTTABLEDATA:
      case SCP:
      case COPY:
      case MANIFEST:
      case LIST:
      case LS:
      case ORDERED:
      case BY:
      case RMDIR:
      case EXCEPT:
      case SETFILETIME:
      case SETREADONLY:
      case SETREADWRITE:
      case TARGET:
      case EJBQL:
      case AFTER:
      case REPEAT:
      case SCHEDULE:
      case STARTING:
      case XML:
      case XSLT:
      case XPATH:
      case SYSTEMID:
      case OUTPUTPROPERTIES:
      case PARAMETERS:
      case DOM:
      case XMLNS:
      case HTML:
      case JSP:
      case SGML:
      case IDENTIFIER:
        AnyName();
                           s = token.image;
        switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
        case ASSIGN:
          jj_consume_token(ASSIGN);
          BooleanLiteral();
                           val = token.image.equalsIgnoreCase("true");
          break;
        default:
          jj_la1[340] = jj_gen;
          ;
        }
                           if (s.equals("namespace"))            xp.namespace = val;
                           else if (s.startsWith("validat"))     xp.validate = val;
                           else if (s.equals("schema"))          xp.schema = val;
                           else if (s.startsWith("ignoreWhite")) xp.ignoreWhitespace = val;
                           else if (s.startsWith("ignoreComm"))  xp.ignoreComment = val;
                           else throwParseException("Unsupported XML option: " + s);
        break;
      default:
        jj_la1[341] = jj_gen;
        jj_consume_token(-1);
        throw new ParseException();
      }
    }
  }

  final public void XsltStatement() throws ParseException {
  StmtXslt stmt = null;
  int lastMark = 0;
    jj_consume_token(XSLT);
                                stmt = new StmtXslt(lineNum());
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case COPY:
      jj_consume_token(COPY);
                                stmt.mode = StmtXslt.MODE_COPY;
      break;
    case JAVA__:
    case _EOF:
    case __EOF:
    case AS:
    case DEFINED:
    case ELIF:
    case EXTENDSJAVA:
    case FALSE:
    case JAVACLASS:
    case IFDEF:
    case IFNDEF:
    case IFEXISTS:
    case IN:
    case INFINITY:
    case INTO:
    case NEW:
    case JAVANEW:
    case MAX_NUMBER:
    case MIN_NUMBER:
    case NULL:
    case LIMIT:
    case NAMESPACE:
    case _SKIP:
    case SUPER:
    case THIS:
    case TYPEOF:
    case ATTRIBUTESOF:
    case TRUE:
    case UNDEFINED:
    case BOOLEAN:
    case BYTE:
    case CHAR:
    case SHORT:
    case INT:
    case LONG:
    case FLOAT:
    case DOUBLE:
    case MAIL__CONNECT:
    case MAIL__DISCONNECT:
    case CC:
    case BCC:
    case ATTACH:
    case SUBJECT:
    case BODY:
    case HTMLBODY:
    case DATE_:
    case DATE:
    case NUMBER:
    case COLUMN:
    case ERR:
    case LOG:
    case NL:
    case OUT:
    case PIPE:
    case INPUT:
    case OUTPUT:
    case NEEDSYSTEMIN:
    case MANIFEST:
    case EXCEPT:
    case SETFILETIME:
    case SETREADONLY:
    case SETREADWRITE:
    case TARGET:
    case DB__DISCONNECT:
    case HIB__ADDCLASS:
    case HIB__ADDRESOURCE:
    case HIB__CLOSE:
    case HIB__TXBEGIN:
    case HIB__TXEND:
    case HIB__TXABORT:
    case HIB__LOCK:
    case HIB__DELETE:
    case HIB__GET:
    case HIB__SAVE:
    case HIB__SAVEORUPDATECOPY:
    case HIB__UNLOCK:
    case HIB__UPDATE:
    case AFTER:
    case STARTING:
    case XML:
    case XPATH:
    case SYSTEMID:
    case OUTPUTPROPERTIES:
    case PARAMETERS:
    case XMLNS:
    case INTEGER_LITERAL:
    case FLOATING_POINT_LITERAL:
    case STRING_LITERAL:
    case EXEC_RESULT_LITERAL:
    case EXEC_RESULTLINES_LITERAL:
    case IDENTIFIER:
    case CONST_NAME:
    case BANG:
    case TILDE:
    case COLONCOLON:
    case INCR:
    case DECR:
    case PLUS:
    case MINUS:
    case BIT_AND:
    case DOLLARLBRACE:
    case LPAREN:
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case XPATH:
        jj_consume_token(XPATH);
                                stmt.mode = StmtXslt.MODE_XPATH;
        jj_consume_token(LPAREN);
        break;
      default:
        jj_la1[342] = jj_gen;
        ;
      }
      Expression();
                                stmt.transform = reduceIt(); lastMark = markStack();
      if (jj_2_96(2)) {
        jj_consume_token(SYSTEMID);
        Expression();
                                stmt.xslSysID = reduceIt();
      } else {
        ;
      }
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case RPAREN:
        jj_consume_token(RPAREN);
        break;
      default:
        jj_la1[343] = jj_gen;
        ;
      }
      jj_consume_token(ON);
      break;
    default:
      jj_la1[344] = jj_gen;
      jj_consume_token(-1);
      throw new ParseException();
    }
    Expression();
                                stmt.src = reduceIt();
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case SYSTEMID:
      jj_consume_token(SYSTEMID);
      Expression();
                                stmt.inSysID = reduceIt();
      break;
    default:
      jj_la1[345] = jj_gen;
      ;
    }
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case AS:
      jj_consume_token(AS);
      jj_consume_token(DOM);
      break;
    case INTO:
    case TO:
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case TO:
        jj_consume_token(TO);
        break;
      case INTO:
        jj_consume_token(INTO);
        break;
      default:
        jj_la1[346] = jj_gen;
        jj_consume_token(-1);
        throw new ParseException();
      }
      Expression();
                                      stmt.dest = reduceIt();
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case SYSTEMID:
        jj_consume_token(SYSTEMID);
        Expression();
                                stmt.outSysID = reduceIt();
        break;
      default:
        jj_la1[347] = jj_gen;
        ;
      }
      break;
    default:
      jj_la1[348] = jj_gen;
      jj_consume_token(-1);
      throw new ParseException();
    }
    label_68:
    while (true) {
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case OUTPUTPROPERTIES:
      case PARAMETERS:
        ;
        break;
      default:
        jj_la1[349] = jj_gen;
        break label_68;
      }
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case OUTPUTPROPERTIES:
        jj_consume_token(OUTPUTPROPERTIES);
        MemberInitList();
                                          stmt.addOutputProperties(handleNamedExprs(lastMark));
        break;
      case PARAMETERS:
        jj_consume_token(PARAMETERS);
        MemberInitList();
                                          stmt.addParameters(handleNamedExprs(lastMark));
        break;
      default:
        jj_la1[350] = jj_gen;
        jj_consume_token(-1);
        throw new ParseException();
      }
    }
                                stack.push(stmt);
    jj_consume_token(SEMICOLON);
  }

  final public void XmlTagHandler(XmlHandler hndr) throws ParseException {
  String[] tagName = null;
  int embeddedOption = XmlHandler.COPY_EMBEDDED_TAG;
  int lineNo = 0;
  int lastMark = markStack();
  boolean isText = false;
  boolean endTag = false;
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case LT:
      jj_consume_token(LT);
      break;
    case LTSLASH:
      jj_consume_token(LTSLASH);
                 endTag=true;
      break;
    default:
      jj_la1[351] = jj_gen;
      jj_consume_token(-1);
      throw new ParseException();
    }
    tagName = XmlTagName();
    jj_consume_token(GT);
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case IDENTIFIER:
      jj_consume_token(IDENTIFIER);
                            lineNo = lineNum();
                            if (!token.image.equalsIgnoreCase("text"))
                              throwParseException("Only 'text' is allowed to follow an XML tag event.");
                            isText = true;
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case PLUS:
      case MINUS:
        switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
        case PLUS:
          jj_consume_token(PLUS);
                            embeddedOption = XmlHandler.COPY_EMBEDDED_TAG;
          break;
        case MINUS:
          jj_consume_token(MINUS);
                            embeddedOption = XmlHandler.IGNORE_EMBEDDED_TAG;
          break;
        default:
          jj_la1[352] = jj_gen;
          jj_consume_token(-1);
          throw new ParseException();
        }
        break;
      default:
        jj_la1[353] = jj_gen;
        ;
      }
      break;
    default:
      jj_la1[354] = jj_gen;
      ;
    }
    jj_consume_token(COLON);
    label_69:
    while (true) {
      Statement();
      if (jj_2_97(2)) {
        ;
      } else {
        break label_69;
      }
    }
                            handleStmts(lastMark);
                            if (isText) hndr.addTextHandler(lineNo,embeddedOption,tagName,stmts);
                            else        hndr.addTagHandler(lineNo,endTag,tagName,stmts);
  }

  final public String[] XmlTagName() throws ParseException {
  String[] ret = new String[]{ null, null, null };
    AnyName();
                     ret[1] = token.image; ret[2] = ret[1];
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case COLON:
      jj_consume_token(COLON);
      AnyName();
                     ret[0] = ret[1]; ret[1] = token.image; ret[2] = ret[0]+":"+ret[1];
      break;
    default:
      jj_la1[355] = jj_gen;
      ;
    }
                     {if (true) return ret;}
    throw new Error("Missing return statement in function");
  }

/****************************************
 * HTML APPLICATION SYNTAX STARTS HERE  *
 ****************************************/
  final public void SgmlStatement() throws ParseException {
  Expr src = null;
  StmtHtml hndr = null;
  boolean caseSens = false;
  String enc;
    jj_consume_token(DO);
    Expression();
                               hndr = new StmtHtml(lineNum(),reduceIt());
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case IN:
      jj_consume_token(IN);
      Expression();
                               hndr.setRoot(reduceIt());
      break;
    default:
      jj_la1[356] = jj_gen;
      ;
    }
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case LBRACE:
      Encoding();
                               hndr.setEncoding(reduceIt());
      break;
    default:
      jj_la1[357] = jj_gen;
      ;
    }
    jj_consume_token(AS);
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case SGML:
      jj_consume_token(SGML);
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case CASE:
        jj_consume_token(CASE);
                               hndr.setCaseSensitive(true);
        break;
      default:
        jj_la1[358] = jj_gen;
        ;
      }
      break;
    case HTML:
      jj_consume_token(HTML);
      break;
    case JSP:
      jj_consume_token(JSP);
                               hndr.setIsJSP();
      break;
    default:
      jj_la1[359] = jj_gen;
      jj_consume_token(-1);
      throw new ParseException();
    }
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case WITH:
      jj_consume_token(WITH);
      jj_consume_token(IDENTIFIER);
                               hndr.setHandler(token.image); stack.push(hndr);
      jj_consume_token(SEMICOLON);
      break;
    case EXTENDS:
    case LBRACE:
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case EXTENDS:
        jj_consume_token(EXTENDS);
        jj_consume_token(IDENTIFIER);
                               hndr.setExtends(token.image);
        break;
      default:
        jj_la1[360] = jj_gen;
        ;
      }
      jj_consume_token(LBRACE);
      label_70:
      while (true) {
        switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
        case SGML_COMMENT:
        case LTBAN:
        case LTQUES:
        case LTPERCAMP:
        case LTPERCBAN:
        case LTPERCEQ:
        case LTPERCDASHDASH:
        case LTPERC:
        case LT:
        case LTSLASH:
        case COLON:
          ;
          break;
        default:
          jj_la1[361] = jj_gen;
          break label_70;
        }
        SgmlEventHandler(hndr);
      }
      jj_consume_token(RBRACE);
                                            stack.push(hndr);
      break;
    default:
      jj_la1[362] = jj_gen;
      jj_consume_token(-1);
      throw new ParseException();
    }
  }

  final public void Encoding() throws ParseException {
    jj_consume_token(LBRACE);
    Expression();
    jj_consume_token(RBRACE);
  }

  final public void SgmlHandlerDecl() throws ParseException {
  Expr src = null;
  StmtHtml hndr = null;
  String name = null;
  int lastMark = 0;
  boolean caseSens = false;
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case SGML:
      jj_consume_token(SGML);
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case CASE:
        jj_consume_token(CASE);
                      caseSens = true;
        break;
      default:
        jj_la1[363] = jj_gen;
        ;
      }
      break;
    case HTML:
      jj_consume_token(HTML);
      break;
    default:
      jj_la1[364] = jj_gen;
      jj_consume_token(-1);
      throw new ParseException();
    }
                               hndr = new StmtHtml(lineNum(), caseSens);
    jj_consume_token(IDENTIFIER);
                               name = token.image;
                               if (script.existsSgmlHandler(name))
                                 throwParseException("SGML Handler '"+name+"' already defined.");
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case EXTENDS:
      jj_consume_token(EXTENDS);
      jj_consume_token(IDENTIFIER);
                               hndr.setExtends(token.image);
      break;
    default:
      jj_la1[365] = jj_gen;
      ;
    }
    jj_consume_token(LBRACE);
    label_71:
    while (true) {
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case SGML_COMMENT:
      case LTBAN:
      case LTQUES:
      case LTPERCAMP:
      case LTPERCBAN:
      case LTPERCEQ:
      case LTPERCDASHDASH:
      case LTPERC:
      case LT:
      case LTSLASH:
      case COLON:
        ;
        break;
      default:
        jj_la1[366] = jj_gen;
        break label_71;
      }
      SgmlEventHandler(hndr);
    }
    jj_consume_token(RBRACE);
                                          script.addSgmlHandler(name,hndr);
  }

  final public void SgmlEventHandler(StmtHtml hndr) throws ParseException {
  ArrayList v = new ArrayList();
  SgmlEvent evt = null;
  int lastMark = markStack();
    evt = SgmlEvent(hndr);
                                 v.add(evt);
    label_72:
    while (true) {
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case COMMA:
        ;
        break;
      default:
        jj_la1[367] = jj_gen;
        break label_72;
      }
      jj_consume_token(COMMA);
      evt = SgmlEvent(hndr);
                                 v.add(evt);
    }
    jj_consume_token(COLON);
    label_73:
    while (true) {
      Statement();
      if (jj_2_98(2)) {
        ;
      } else {
        break label_73;
      }
    }
    handleStmts(lastMark);
    for (int i=0; i<v.size(); ++i) {
      evt = (SgmlEvent)v.get(i);
      addSgmlHandler(evt, hndr);
    }
  }

  final public SgmlEvent SgmlEvent(StmtHtml hndr) throws ParseException {
  SgmlEvent evt = new SgmlEvent();
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case LTSLASH:
      jj_consume_token(LTSLASH);
                       evt.isEnd = true; evt.type = SGML_TAG;
      AnyName();
                       evt.name = hndr.caseSens ? token.image : token.image.toLowerCase();
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case COLON:
        jj_consume_token(COLON);
        AnyName();
                       evt.name += ':' + token.image;
        break;
      default:
        jj_la1[368] = jj_gen;
        ;
      }
      jj_consume_token(GT);
      break;
    case LT:
      jj_consume_token(LT);
                       evt.type = SGML_DEFAULT_TAG;
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case _USAGE:
      case ENDSCRIPT:
      case _EOF:
      case __EOF:
      case AS:
      case BREAK:
      case CASE:
      case CATCH:
      case CONST:
      case CONTINUE:
      case CONSTRUCTOR:
      case CTOR:
      case _DEFAULT:
      case CLASS:
      case DEFINED:
      case DELETE:
      case DO:
      case ELIF:
      case ELSE:
      case EXEC:
      case EXTENDS:
      case EXTENDSJAVA:
      case FALSE:
      case FINALLY:
      case FOR:
      case FROM:
      case FUNCTION:
      case LAMBDA:
      case THREAD:
      case JAVACLASS:
      case IF:
      case IFDEF:
      case IFNDEF:
      case IFEXISTS:
      case IMPORT:
      case IN:
      case INFINITY:
      case INTO:
      case LOCAL:
      case NEW:
      case MAX_NUMBER:
      case MIN_NUMBER:
      case NULL:
      case LIMIT:
      case NAMESPACE:
      case _SKIP:
      case RESUME:
      case RETURN:
      case STRIP:
      case SUPER:
      case SWITCH:
      case THIS:
      case THROW:
      case TO:
      case UPTO:
      case TYPEOF:
      case ATTRIBUTESOF:
      case ON:
      case DOWNTO:
      case TRUE:
      case TRY:
      case UNDER:
      case UNDEFINED:
      case USING:
      case USE:
      case VAR:
      case WHERE:
      case WHILE:
      case WITH:
      case BOOLEAN:
      case BYTE:
      case CHAR:
      case SHORT:
      case INT:
      case LONG:
      case FLOAT:
      case DOUBLE:
      case STRING:
      case STRING_:
      case VOID:
      case CC:
      case BCC:
      case ATTACH:
      case SUBJECT:
      case BODY:
      case HTMLBODY:
      case LINKEDLIST_:
      case LINKEDLIST:
      case SET_:
      case SET:
      case SORTEDMAP_:
      case SORTEDMAP:
      case DATE_:
      case DATE:
      case NUMBER_:
      case NUMBER:
      case COLUMN:
      case ERR:
      case LOG:
      case OUT:
      case PIPE:
      case INPUT:
      case OUTPUT:
      case NEEDSYSTEMIN:
      case FLUSH:
      case PRINT:
      case PRINTLN:
      case PRINTTABLE:
      case PRINTTABLEDATA:
      case SCP:
      case COPY:
      case MANIFEST:
      case LIST:
      case LS:
      case ORDERED:
      case BY:
      case RMDIR:
      case EXCEPT:
      case SETFILETIME:
      case SETREADONLY:
      case SETREADWRITE:
      case TARGET:
      case EJBQL:
      case AFTER:
      case REPEAT:
      case SCHEDULE:
      case STARTING:
      case XML:
      case XSLT:
      case XPATH:
      case SYSTEMID:
      case OUTPUTPROPERTIES:
      case PARAMETERS:
      case DOM:
      case XMLNS:
      case HTML:
      case JSP:
      case SGML:
      case IDENTIFIER:
        AnyName();
                       evt.name = hndr.caseSens ? token.image : token.image.toLowerCase();
                       evt.type = SGML_TAG;
        switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
        case COLON:
          jj_consume_token(COLON);
          AnyName();
                       evt.name += ':' + token.image;
          break;
        default:
          jj_la1[369] = jj_gen;
          ;
        }
        break;
      default:
        jj_la1[370] = jj_gen;
        ;
      }
      jj_consume_token(GT);
      break;
    case COLON:
      jj_consume_token(COLON);
      jj_consume_token(IDENTIFIER);
                       String x = token.image.toLowerCase();
                       if (x.equals("text"))        evt.type = SGML_TEXT;
                       else if (x.equals("before")) evt.type = SGML_BEFORE;
                       else if (x.equals("after"))  evt.type = SGML_AFTER;
                       else throwParseException("Unknown SGML event: " + token.image);
      break;
    case SGML_COMMENT:
    case LTBAN:
    case LTQUES:
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case SGML_COMMENT:
        jj_consume_token(SGML_COMMENT);
        jj_consume_token(GT);
                       evt.name = TYPE3_SYMBOL;
        break;
      case LTBAN:
        jj_consume_token(LTBAN);
        jj_consume_token(GT);
                       evt.name = TYPE1_SYMBOL;
        break;
      case LTQUES:
        jj_consume_token(LTQUES);
        jj_consume_token(GT);
                       evt.name = TYPE2_SYMBOL;
        break;
      default:
        jj_la1[371] = jj_gen;
        jj_consume_token(-1);
        throw new ParseException();
      }
                       evt.type = SGML_SPECIAL;
      break;
    case LTPERCAMP:
    case LTPERCBAN:
    case LTPERCEQ:
    case LTPERCDASHDASH:
    case LTPERC:
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case LTPERCAMP:
        jj_consume_token(LTPERCAMP);
                       evt.name = "<%@";
        switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
        case _USAGE:
        case ENDSCRIPT:
        case _EOF:
        case __EOF:
        case AS:
        case BREAK:
        case CASE:
        case CATCH:
        case CONST:
        case CONTINUE:
        case CONSTRUCTOR:
        case CTOR:
        case _DEFAULT:
        case CLASS:
        case DEFINED:
        case DELETE:
        case DO:
        case ELIF:
        case ELSE:
        case EXEC:
        case EXTENDS:
        case EXTENDSJAVA:
        case FALSE:
        case FINALLY:
        case FOR:
        case FROM:
        case FUNCTION:
        case LAMBDA:
        case THREAD:
        case JAVACLASS:
        case IF:
        case IFDEF:
        case IFNDEF:
        case IFEXISTS:
        case IMPORT:
        case IN:
        case INFINITY:
        case INTO:
        case LOCAL:
        case NEW:
        case MAX_NUMBER:
        case MIN_NUMBER:
        case NULL:
        case LIMIT:
        case NAMESPACE:
        case _SKIP:
        case RESUME:
        case RETURN:
        case STRIP:
        case SUPER:
        case SWITCH:
        case THIS:
        case THROW:
        case TO:
        case UPTO:
        case TYPEOF:
        case ATTRIBUTESOF:
        case ON:
        case DOWNTO:
        case TRUE:
        case TRY:
        case UNDER:
        case UNDEFINED:
        case USING:
        case USE:
        case VAR:
        case WHERE:
        case WHILE:
        case WITH:
        case BOOLEAN:
        case BYTE:
        case CHAR:
        case SHORT:
        case INT:
        case LONG:
        case FLOAT:
        case DOUBLE:
        case STRING:
        case STRING_:
        case VOID:
        case CC:
        case BCC:
        case ATTACH:
        case SUBJECT:
        case BODY:
        case HTMLBODY:
        case LINKEDLIST_:
        case LINKEDLIST:
        case SET_:
        case SET:
        case SORTEDMAP_:
        case SORTEDMAP:
        case DATE_:
        case DATE:
        case NUMBER_:
        case NUMBER:
        case COLUMN:
        case ERR:
        case LOG:
        case OUT:
        case PIPE:
        case INPUT:
        case OUTPUT:
        case NEEDSYSTEMIN:
        case FLUSH:
        case PRINT:
        case PRINTLN:
        case PRINTTABLE:
        case PRINTTABLEDATA:
        case SCP:
        case COPY:
        case MANIFEST:
        case LIST:
        case LS:
        case ORDERED:
        case BY:
        case RMDIR:
        case EXCEPT:
        case SETFILETIME:
        case SETREADONLY:
        case SETREADWRITE:
        case TARGET:
        case EJBQL:
        case AFTER:
        case REPEAT:
        case SCHEDULE:
        case STARTING:
        case XML:
        case XSLT:
        case XPATH:
        case SYSTEMID:
        case OUTPUTPROPERTIES:
        case PARAMETERS:
        case DOM:
        case XMLNS:
        case HTML:
        case JSP:
        case SGML:
        case IDENTIFIER:
          AnyName();
                       evt.name += token.image;
          break;
        default:
          jj_la1[372] = jj_gen;
          ;
        }
        jj_consume_token(GT);
        break;
      case LTPERCBAN:
        jj_consume_token(LTPERCBAN);
        jj_consume_token(GT);
                       evt.name = "<%!";
        break;
      case LTPERCEQ:
        jj_consume_token(LTPERCEQ);
        jj_consume_token(GT);
                       evt.name = "<%=";
        break;
      case LTPERCDASHDASH:
        jj_consume_token(LTPERCDASHDASH);
        jj_consume_token(GT);
                       evt.name = "<%--";
        break;
      case LTPERC:
        jj_consume_token(LTPERC);
        jj_consume_token(GT);
                       evt.name = "<%";
        break;
      default:
        jj_la1[373] = jj_gen;
        jj_consume_token(-1);
        throw new ParseException();
      }
                       evt.type = SGML_SPECIAL;
      break;
    default:
      jj_la1[374] = jj_gen;
      jj_consume_token(-1);
      throw new ParseException();
    }
                       evt.lineNum=lineNum(); {if (true) return evt;}
    throw new Error("Missing return statement in function");
  }

/***************************************
 * GUI APPLICATION SYNTAX STARTS HERE  *
 ***************************************/
  final public void GuiEventsStatement() throws ParseException {
  StmtGuiEvents guistmt = null;
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case GUI__EVENTS:
      jj_consume_token(GUI__EVENTS);
      break;
    case GUIEVENTS:
      jj_consume_token(GUIEVENTS);
                                  upgradeMsg("gui::events");
      break;
    default:
      jj_la1[375] = jj_gen;
      jj_consume_token(-1);
      throw new ParseException();
    }
    jj_consume_token(LBRACE);
                               guistmt = new StmtGuiEvents(lineNum());
    label_74:
    while (true) {
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case LT:
        ;
        break;
      default:
        jj_la1[376] = jj_gen;
        break label_74;
      }
      GuiListener(guistmt);
    }
    jj_consume_token(RBRACE);
                               stack.push(guistmt);
  }

  final public void GuiListener(StmtGuiEvents guistmt) throws ParseException {
  int lastMark = markStack();
  int lineNo = 0;
  Object[] msgs = null;
    jj_consume_token(LT);
    GuiEventList();
                           msgs = handleAny(lastMark);
    jj_consume_token(GT);
    jj_consume_token(COLON);
                           lastMark = markStack(); lineNo = lineNum();
    label_75:
    while (true) {
      Statement();
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case ANTTASK__:
      case JAVA__:
      case _EOF:
      case __EOF:
      case AS:
      case BREAK:
      case CONTINUE:
      case DEFINED:
      case DELETE:
      case DO:
      case ELIF:
      case EXEC:
      case EXTENDSJAVA:
      case FALSE:
      case FOR:
      case JAVACLASS:
      case IF:
      case IFDEF:
      case IFNDEF:
      case IFEXISTS:
      case IMPORT:
      case IN:
      case INFINITY:
      case INTO:
      case INCLUDE:
      case LOCAL:
      case NEW:
      case JAVANEW:
      case MAX_NUMBER:
      case MIN_NUMBER:
      case NULL:
      case PRAGMA:
      case JAVAGUICLASS:
      case JAVABASECLASS:
      case JAVAENTERPRISECLASS:
      case JAVACORBACLASS:
      case JCOMCLASS:
      case JAVAPACKAGES:
      case DEFINEJAVAPACKAGES:
      case LIMIT:
      case NAMESPACE:
      case _SKIP:
      case RESUME:
      case RETURN:
      case SUPER:
      case SWITCH:
      case THIS:
      case THROW:
      case TYPEOF:
      case ATTRIBUTESOF:
      case TRUE:
      case TRY:
      case UNDEFINED:
      case USE:
      case VAR:
      case WHILE:
      case WITH:
      case BOOLEAN:
      case BYTE:
      case CHAR:
      case SHORT:
      case INT:
      case LONG:
      case FLOAT:
      case DOUBLE:
      case MAIL__SEND:
      case MAIL__CONNECT:
      case MAIL__DISCONNECT:
      case SENDMAIL:
      case CC:
      case BCC:
      case ATTACH:
      case SUBJECT:
      case BODY:
      case HTMLBODY:
      case DATE_:
      case DATE:
      case NUMBER:
      case COLUMN:
      case ERR:
      case LOG:
      case NL:
      case OUT:
      case PIPE:
      case INPUT:
      case OUTPUT:
      case NEEDSYSTEMIN:
      case FLUSH:
      case PRINT:
      case PRINTLN:
      case PRINTTABLE:
      case PRINTTABLEDATA:
      case SCP:
      case COPY:
      case MANIFEST:
      case LIST:
      case LS:
      case RMDIR:
      case EXCEPT:
      case SETFILETIME:
      case SETREADONLY:
      case SETREADWRITE:
      case TARGET:
      case ADDBATCH:
      case CONNECT:
      case EXECUTEBATCH:
      case EXECUTEQUERY:
      case EXECUTEQUERYCALL:
      case EXECUTEANY:
      case EXECUTESQL:
      case EXECUTEUPDATE:
      case EXECUTEUPDATECALL:
      case PREPARE:
      case PREPARECALL:
      case PREPAREDEXECUTE:
      case PREPAREDEXECUTECALL:
      case PREPAREDEXECUTEQUERY:
      case PREPAREDEXECUTECALLQUERY:
      case PREPAREDEXECUTEUPDATE:
      case PREPAREDEXECUTECALLUPDATE:
      case DB__DUMPTABLE:
      case DB__ADDBATCH:
      case DB__CONNECT:
      case DB__DISCONNECT:
      case DB__BATCH:
      case DB__QUERY:
      case DB__QUERYCALL:
      case DB__ANY:
      case DB__SQL:
      case DB__CALL:
      case DB__UPDATE:
      case DB__UPDATECALL:
      case DB__PREPARE:
      case DB__PREPARECALL:
      case HIB__SETUP:
      case HIB__ADDCLASS:
      case HIB__ADDRESOURCE:
      case HIB__CLOSE:
      case HIB__TXBEGIN:
      case HIB__TXEND:
      case HIB__TXABORT:
      case HIB__LOCK:
      case HIB__QUERY:
      case HIB__ITERATE:
      case HIB__DELETE:
      case HIB__GET:
      case HIB__SAVE:
      case HIB__SAVEORUPDATECOPY:
      case HIB__UNLOCK:
      case HIB__UPDATE:
      case AFTER:
      case REPEAT:
      case SCHEDULE:
      case STARTING:
      case XML:
      case XSLT:
      case SYSTEMID:
      case OUTPUTPROPERTIES:
      case PARAMETERS:
      case XMLNS:
      case GUIEVENTS:
      case GUI__EVENTS:
      case INTEGER_LITERAL:
      case FLOATING_POINT_LITERAL:
      case STRING_LITERAL:
      case EXEC_RESULT_LITERAL:
      case EXEC_RESULTLINES_LITERAL:
      case IDENTIFIER:
      case CONST_NAME:
      case BANG:
      case TILDE:
      case COLONCOLON:
      case INCR:
      case DECR:
      case PLUS:
      case MINUS:
      case BIT_AND:
      case DOLLARLBRACE:
      case LBRACE:
      case LPAREN:
      case DOT:
      case SEMICOLON:
        ;
        break;
      default:
        jj_la1[377] = jj_gen;
        break label_75;
      }
    }
    handleStmts(lastMark);
    StmtListStmt sls = new StmtListStmt(stmts);
    for (int i=0; i<msgs.length; i++) {
      Triplet tri = (Triplet)msgs[i];
      if (tri.o1 instanceof String) { // named handler
        try { script.addGuiNamedHandler(lineNo, tri, sls); }
        catch(Exception e) { throwParseException(e.getMessage()); }
      } else {
        guistmt.addHandler(lineNo, tri, sls);
      }
    }
  }

  final public void GuiEventList() throws ParseException {
    GuiEvent();
    label_76:
    while (true) {
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case COMMA:
        ;
        break;
      default:
        jj_la1[378] = jj_gen;
        break label_76;
      }
      jj_consume_token(COMMA);
      GuiEvent();
    }
  }

  final public void GuiEvent() throws ParseException {
  ArrayList compNames = new ArrayList();
  ArrayList msgNames  = new ArrayList();
  String eventName;
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case HOOK:
      jj_consume_token(HOOK);
      AnyName();
                                compNames.add(token.image);
      break;
    case JAVA__:
    case AS:
    case ELIF:
    case EXTENDSJAVA:
    case JAVACLASS:
    case IFDEF:
    case IFNDEF:
    case IFEXISTS:
    case IN:
    case INTO:
    case NEW:
    case JAVANEW:
    case LIMIT:
    case NAMESPACE:
    case _SKIP:
    case SUPER:
    case THIS:
    case BOOLEAN:
    case BYTE:
    case CHAR:
    case SHORT:
    case INT:
    case LONG:
    case FLOAT:
    case DOUBLE:
    case MAIL__CONNECT:
    case MAIL__DISCONNECT:
    case CC:
    case BCC:
    case ATTACH:
    case SUBJECT:
    case BODY:
    case HTMLBODY:
    case DATE_:
    case DATE:
    case NUMBER:
    case COLUMN:
    case ERR:
    case LOG:
    case OUT:
    case PIPE:
    case INPUT:
    case OUTPUT:
    case NEEDSYSTEMIN:
    case MANIFEST:
    case EXCEPT:
    case SETFILETIME:
    case SETREADONLY:
    case SETREADWRITE:
    case TARGET:
    case DB__DISCONNECT:
    case HIB__ADDCLASS:
    case HIB__ADDRESOURCE:
    case HIB__CLOSE:
    case HIB__TXBEGIN:
    case HIB__TXEND:
    case HIB__TXABORT:
    case HIB__LOCK:
    case HIB__DELETE:
    case HIB__GET:
    case HIB__SAVE:
    case HIB__SAVEORUPDATECOPY:
    case HIB__UNLOCK:
    case HIB__UPDATE:
    case AFTER:
    case STARTING:
    case XML:
    case SYSTEMID:
    case OUTPUTPROPERTIES:
    case PARAMETERS:
    case XMLNS:
    case STRING_LITERAL:
    case IDENTIFIER:
    case CONST_NAME:
    case COLONCOLON:
    case BIT_AND:
    case DOLLARLBRACE:
    case LPAREN:
      PrimaryExpression(false);
                                     compNames.add(reduceIt());
      label_77:
      while (true) {
        switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
        case COMMA:
          ;
          break;
        default:
          jj_la1[379] = jj_gen;
          break label_77;
        }
        jj_consume_token(COMMA);
        PrimaryExpression(false);
                                     compNames.add(reduceIt());
      }
      break;
    default:
      jj_la1[380] = jj_gen;
      jj_consume_token(-1);
      throw new ParseException();
    }
    jj_consume_token(COLON);
    AnyName();
                                eventName = token.image;
    jj_consume_token(COLON);
    AnyName();
                                msgNames.add(token.image);
    label_78:
    while (true) {
      if (jj_2_99(2)) {
        ;
      } else {
        break label_78;
      }
      jj_consume_token(COMMA);
      AnyName();
                                msgNames.add(token.image);
    }
    int len1 = compNames.size();
    for (int i=0; i<len1; i++) {
      Object o = compNames.get(i);
      if (msgNames.size() == 1)
        stack.push( new Triplet(o,eventName,msgNames.get(0)) );
      else
        stack.push( new Triplet(o,eventName,msgNames) );
    }
  }

/***************************************
 * COM APPLICATION SYNTAX STARTS HERE  *
 ***************************************/

/*
void COMEventsStatement() :
{
  JacobEventHandler eh = null;
  int lastMark = 0;
  String name = null;
  String handlerName = null;
}
{
  "comEvents"                  { eh = new JacobEventHandler(lineNum()); }
  ( [ "as" ] AnyName()     { handlerName = token.image; }
  | "(" Expression()           { eh.setSource(reduceIt()); }
    [ "," <STRING_LITERAL>     { eh.setProgID(unquote(token.image)); }
    ] ")"
  )
  "{"
  ( "<" AnyName()              { name = token.image; lastMark = markStack(); }
    ">" ":" ( Statement() )+   { handleStmts(lastMark); eh.addHandler(name, stmts, labels); }
  )+
  "}"                          { if (handlerName == null) stack.push(eh);
                                 else eh.putAsNamedHandler(handlerName);
                               }
}
*/

/*****************************************
 * DYNAMIC STATEMENT SYNTAX STARTS HERE  *
 *****************************************/
  final public void RunStatement() throws ParseException {
  StmtExec exec;
  BlockSimple outputPart = null;
  BlockSimple intputPart = null;
  int lastMark;
    jj_consume_token(EXEC);
                                 exec = new StmtExec(lineNum());
    label_79:
    while (true) {
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case SLASH:
        ;
        break;
      default:
        jj_la1[381] = jj_gen;
        break label_79;
      }
      jj_consume_token(SLASH);
      jj_consume_token(IDENTIFIER);
                                 String x = token.image.toLowerCase();
                                 if (x.equals("needsystemin"))
                                   exec.setNeedSystemIn();
                                 else if (x.equals("bg") || x.equals("background"))
                                   exec.setReturnVariable(null);
                                 else if (x.equals("asis"))
                                   exec.setAsIs(true);
                                 else
                                   RT.logger.warn("Unknown exec option: " + token.image);
    }
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case LT:
    case SC_AND:
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case LT:
        jj_consume_token(LT);
        switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
        case IDENTIFIER:
          jj_consume_token(IDENTIFIER);
                         exec.setReturnVariable(token.image);
          break;
        default:
          jj_la1[382] = jj_gen;
          ;
        }
        jj_consume_token(GT);
        break;
      case SC_AND:
        jj_consume_token(SC_AND);
                                 exec.setReturnVariable(null);
        break;
      default:
        jj_la1[383] = jj_gen;
        jj_consume_token(-1);
        throw new ParseException();
      }
      break;
    default:
      jj_la1[384] = jj_gen;
      ;
    }
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case JAVA__:
    case _EOF:
    case __EOF:
    case AS:
    case DEFINED:
    case ELIF:
    case EXTENDSJAVA:
    case FALSE:
    case JAVACLASS:
    case IFDEF:
    case IFNDEF:
    case IFEXISTS:
    case IN:
    case INFINITY:
    case INTO:
    case NEW:
    case JAVANEW:
    case MAX_NUMBER:
    case MIN_NUMBER:
    case NULL:
    case LIMIT:
    case NAMESPACE:
    case _SKIP:
    case SUPER:
    case THIS:
    case TYPEOF:
    case ATTRIBUTESOF:
    case TRUE:
    case UNDEFINED:
    case BOOLEAN:
    case BYTE:
    case CHAR:
    case SHORT:
    case INT:
    case LONG:
    case FLOAT:
    case DOUBLE:
    case MAIL__CONNECT:
    case MAIL__DISCONNECT:
    case CC:
    case BCC:
    case ATTACH:
    case SUBJECT:
    case BODY:
    case HTMLBODY:
    case DATE_:
    case DATE:
    case NUMBER:
    case COLUMN:
    case ERR:
    case LOG:
    case NL:
    case OUT:
    case PIPE:
    case INPUT:
    case OUTPUT:
    case NEEDSYSTEMIN:
    case MANIFEST:
    case EXCEPT:
    case SETFILETIME:
    case SETREADONLY:
    case SETREADWRITE:
    case TARGET:
    case DB__DISCONNECT:
    case HIB__ADDCLASS:
    case HIB__ADDRESOURCE:
    case HIB__CLOSE:
    case HIB__TXBEGIN:
    case HIB__TXEND:
    case HIB__TXABORT:
    case HIB__LOCK:
    case HIB__DELETE:
    case HIB__GET:
    case HIB__SAVE:
    case HIB__SAVEORUPDATECOPY:
    case HIB__UNLOCK:
    case HIB__UPDATE:
    case AFTER:
    case STARTING:
    case XML:
    case SYSTEMID:
    case OUTPUTPROPERTIES:
    case PARAMETERS:
    case XMLNS:
    case INTEGER_LITERAL:
    case FLOATING_POINT_LITERAL:
    case STRING_LITERAL:
    case EXEC_RESULT_LITERAL:
    case EXEC_RESULTLINES_LITERAL:
    case IDENTIFIER:
    case CONST_NAME:
    case BANG:
    case TILDE:
    case COLONCOLON:
    case INCR:
    case DECR:
    case PLUS:
    case MINUS:
    case BIT_AND:
    case DOLLARLBRACE:
    case LPAREN:
      Expression();
      break;
    case HEREDOC_BEGIN:
    case HEREDOC_BEGIN_:
      HereDoc();
      break;
    default:
      jj_la1[385] = jj_gen;
      jj_consume_token(-1);
      throw new ParseException();
    }
                                 exec.setCmdLine(reduceIt());
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case FROM:
      jj_consume_token(FROM);
      Expression();
                          exec.setWorkingDir(reduceIt());
      break;
    default:
      jj_la1[386] = jj_gen;
      ;
    }
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case WITH:
      jj_consume_token(WITH);
                                 lastMark = markStack();
      if (jj_2_101(2147483647)) {
        jj_consume_token(LT);
        jj_consume_token(NEW);
        jj_consume_token(GT);
                      exec.setNoInherit();
      } else {
        switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
        case _USAGE:
        case JAVA__:
        case ENDSCRIPT:
        case _EOF:
        case __EOF:
        case AS:
        case BREAK:
        case CASE:
        case CATCH:
        case CONST:
        case CONTINUE:
        case CONSTRUCTOR:
        case CTOR:
        case _DEFAULT:
        case CLASS:
        case DEFINED:
        case DELETE:
        case DO:
        case ELIF:
        case ELSE:
        case EXEC:
        case EXTENDS:
        case EXTENDSJAVA:
        case FALSE:
        case FINALLY:
        case FOR:
        case FROM:
        case FUNCTION:
        case LAMBDA:
        case THREAD:
        case JAVACLASS:
        case IF:
        case IFDEF:
        case IFNDEF:
        case IFEXISTS:
        case IMPORT:
        case IN:
        case INFINITY:
        case INTO:
        case LOCAL:
        case NEW:
        case JAVANEW:
        case MAX_NUMBER:
        case MIN_NUMBER:
        case NULL:
        case LIMIT:
        case NAMESPACE:
        case _SKIP:
        case RESUME:
        case RETURN:
        case STRIP:
        case SUPER:
        case SWITCH:
        case THIS:
        case THROW:
        case TO:
        case UPTO:
        case TYPEOF:
        case ATTRIBUTESOF:
        case ON:
        case DOWNTO:
        case TRUE:
        case TRY:
        case UNDER:
        case UNDEFINED:
        case USING:
        case USE:
        case VAR:
        case WHERE:
        case WHILE:
        case WITH:
        case BOOLEAN:
        case BYTE:
        case CHAR:
        case SHORT:
        case INT:
        case LONG:
        case FLOAT:
        case DOUBLE:
        case STRING:
        case STRING_:
        case VOID:
        case MAIL__CONNECT:
        case MAIL__DISCONNECT:
        case CC:
        case BCC:
        case ATTACH:
        case SUBJECT:
        case BODY:
        case HTMLBODY:
        case LINKEDLIST_:
        case LINKEDLIST:
        case SET_:
        case SET:
        case SORTEDMAP_:
        case SORTEDMAP:
        case DATE_:
        case DATE:
        case NUMBER_:
        case NUMBER:
        case COLUMN:
        case ERR:
        case LOG:
        case NL:
        case OUT:
        case PIPE:
        case INPUT:
        case OUTPUT:
        case NEEDSYSTEMIN:
        case FLUSH:
        case PRINT:
        case PRINTLN:
        case PRINTTABLE:
        case PRINTTABLEDATA:
        case SCP:
        case COPY:
        case MANIFEST:
        case LIST:
        case LS:
        case ORDERED:
        case BY:
        case RMDIR:
        case EXCEPT:
        case SETFILETIME:
        case SETREADONLY:
        case SETREADWRITE:
        case TARGET:
        case DB__DISCONNECT:
        case EJBQL:
        case HIB__ADDCLASS:
        case HIB__ADDRESOURCE:
        case HIB__CLOSE:
        case HIB__TXBEGIN:
        case HIB__TXEND:
        case HIB__TXABORT:
        case HIB__LOCK:
        case HIB__DELETE:
        case HIB__GET:
        case HIB__SAVE:
        case HIB__SAVEORUPDATECOPY:
        case HIB__UNLOCK:
        case HIB__UPDATE:
        case AFTER:
        case REPEAT:
        case SCHEDULE:
        case STARTING:
        case XML:
        case XSLT:
        case XPATH:
        case SYSTEMID:
        case OUTPUTPROPERTIES:
        case PARAMETERS:
        case DOM:
        case XMLNS:
        case HTML:
        case JSP:
        case SGML:
        case INTEGER_LITERAL:
        case FLOATING_POINT_LITERAL:
        case STRING_LITERAL:
        case EXEC_RESULT_LITERAL:
        case EXEC_RESULTLINES_LITERAL:
        case IDENTIFIER:
        case CONST_NAME:
        case LT:
        case BANG:
        case TILDE:
        case COLONCOLON:
        case INCR:
        case DECR:
        case PLUS:
        case MINUS:
        case BIT_AND:
        case DOLLARLBRACE:
        case LPAREN:
          switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
          case LT:
            jj_consume_token(LT);
            jj_consume_token(NEW);
            jj_consume_token(GT);
                        exec.setNoInherit();
            break;
          default:
            jj_la1[387] = jj_gen;
            ;
          }
          if (jj_2_100(2)) {
            AnyName();
                                 stack.push(token.image);
            jj_consume_token(ASSIGN);
            Expression();
            label_80:
            while (true) {
              switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
              case COMMA:
                ;
                break;
              default:
                jj_la1[388] = jj_gen;
                break label_80;
              }
              jj_consume_token(COMMA);
              AnyName();
                                 stack.push(token.image);
              jj_consume_token(ASSIGN);
              Expression();
            }
                                 exec.setEnv(handleNamedExprs(lastMark));
          } else {
            switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
            case JAVA__:
            case _EOF:
            case __EOF:
            case AS:
            case DEFINED:
            case ELIF:
            case EXTENDSJAVA:
            case FALSE:
            case JAVACLASS:
            case IFDEF:
            case IFNDEF:
            case IFEXISTS:
            case IN:
            case INFINITY:
            case INTO:
            case NEW:
            case JAVANEW:
            case MAX_NUMBER:
            case MIN_NUMBER:
            case NULL:
            case LIMIT:
            case NAMESPACE:
            case _SKIP:
            case SUPER:
            case THIS:
            case TYPEOF:
            case ATTRIBUTESOF:
            case TRUE:
            case UNDEFINED:
            case BOOLEAN:
            case BYTE:
            case CHAR:
            case SHORT:
            case INT:
            case LONG:
            case FLOAT:
            case DOUBLE:
            case MAIL__CONNECT:
            case MAIL__DISCONNECT:
            case CC:
            case BCC:
            case ATTACH:
            case SUBJECT:
            case BODY:
            case HTMLBODY:
            case DATE_:
            case DATE:
            case NUMBER:
            case COLUMN:
            case ERR:
            case LOG:
            case NL:
            case OUT:
            case PIPE:
            case INPUT:
            case OUTPUT:
            case NEEDSYSTEMIN:
            case MANIFEST:
            case EXCEPT:
            case SETFILETIME:
            case SETREADONLY:
            case SETREADWRITE:
            case TARGET:
            case DB__DISCONNECT:
            case HIB__ADDCLASS:
            case HIB__ADDRESOURCE:
            case HIB__CLOSE:
            case HIB__TXBEGIN:
            case HIB__TXEND:
            case HIB__TXABORT:
            case HIB__LOCK:
            case HIB__DELETE:
            case HIB__GET:
            case HIB__SAVE:
            case HIB__SAVEORUPDATECOPY:
            case HIB__UNLOCK:
            case HIB__UPDATE:
            case AFTER:
            case STARTING:
            case XML:
            case SYSTEMID:
            case OUTPUTPROPERTIES:
            case PARAMETERS:
            case XMLNS:
            case INTEGER_LITERAL:
            case FLOATING_POINT_LITERAL:
            case STRING_LITERAL:
            case EXEC_RESULT_LITERAL:
            case EXEC_RESULTLINES_LITERAL:
            case IDENTIFIER:
            case CONST_NAME:
            case BANG:
            case TILDE:
            case COLONCOLON:
            case INCR:
            case DECR:
            case PLUS:
            case MINUS:
            case BIT_AND:
            case DOLLARLBRACE:
            case LPAREN:
              Expression();
                                 exec.setEnv(reduceIt());
              break;
            default:
              jj_la1[389] = jj_gen;
              jj_consume_token(-1);
              throw new ParseException();
            }
          }
          break;
        default:
          jj_la1[390] = jj_gen;
          jj_consume_token(-1);
          throw new ParseException();
        }
      }
      break;
    default:
      jj_la1[391] = jj_gen;
      ;
    }
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case INPUT:
      jj_consume_token(INPUT);
      Block();
                                 exec.setPipeInPart((BlockSimple)stack.pop());
      if (jj_2_102(2147483647)) {
        jj_consume_token(OUTPUT);
        Block();
                                 exec.setPipeOutPart((BlockSimple)stack.pop());
      } else {
        ;
      }
      break;
    case OUTPUT:
    case NEEDSYSTEMIN:
    case SEMICOLON:
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case NEEDSYSTEMIN:
        jj_consume_token(NEEDSYSTEMIN);
                                 exec.setNeedSystemIn(); upgradeMsg("/needSystemIn option");
        break;
      default:
        jj_la1[392] = jj_gen;
        ;
      }
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case SEMICOLON:
        jj_consume_token(SEMICOLON);
        break;
      case OUTPUT:
        jj_consume_token(OUTPUT);
        Block();
                                 exec.setPipeOutPart((BlockSimple)stack.pop());
        break;
      default:
        jj_la1[393] = jj_gen;
        jj_consume_token(-1);
        throw new ParseException();
      }
      break;
    default:
      jj_la1[394] = jj_gen;
      jj_consume_token(-1);
      throw new ParseException();
    }
    stack.push(exec);
  }

/**********************************
 * DIRECTIVES SYNTAX STARTS HERE  *
 **********************************/
  final public void Directives() throws ParseException {
  String pkgName = null;
  String x = null;
  int lineNo;
  boolean doInc    = true;
  boolean ifexists = false;
  String parentRef = null;
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case IMPORT:
      jj_consume_token(IMPORT);
      importElement();
      label_81:
      while (true) {
        switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
        case COMMA:
          ;
          break;
        default:
          jj_la1[395] = jj_gen;
          break label_81;
        }
        jj_consume_token(COMMA);
        importElement();
      }
      jj_consume_token(SEMICOLON);
      break;
    case INCLUDE:
      jj_consume_token(INCLUDE);
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case IF:
      case IFDEF:
      case IFNDEF:
      case IFEXISTS:
        switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
        case IFNDEF:
          jj_consume_token(IFNDEF);
          jj_consume_token(CONST_NAME);
                              doInc = !script.hasConst(token.image);
          break;
        case IFDEF:
          jj_consume_token(IFDEF);
          jj_consume_token(CONST_NAME);
                              doInc = script.hasConst(token.image);
          break;
        case IF:
          jj_consume_token(IF);
          Expression();
                              doInc = evalConstToBool(nonAssignExpr(stack.pop()), true);
          break;
        case IFEXISTS:
          jj_consume_token(IFEXISTS);
                              doInc = false; ifexists = true;
          break;
        default:
          jj_la1[396] = jj_gen;
          jj_consume_token(-1);
          throw new ParseException();
        }
        break;
      default:
        jj_la1[397] = jj_gen;
        ;
      }
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case LT:
        jj_consume_token(LT);
        jj_consume_token(STRING_LITERAL);
                              parentRef = unquote(token.image);
        jj_consume_token(GT);
        break;
      default:
        jj_la1[398] = jj_gen;
        ;
      }
      jj_consume_token(STRING_LITERAL);
                              x = script.getScriptPath();
                              String path = JudoUtil.fixIncludeFilePath(unquote(token.image), x);
                              if (doInc || (ifexists && new File(path).isFile()))
                                token_source.switchToNewFileStream(path, encoding);
      break;
    case PRAGMA:
      jj_consume_token(PRAGMA);
      x = JavaClassName();
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case ASSIGN:
        jj_consume_token(ASSIGN);
        break;
      default:
        jj_la1[399] = jj_gen;
        ;
      }
      Literal();
                              handlePragma(lineNum(), x, (Variable)stack.pop());
      break;
    case JAVAGUICLASS:
    case JAVABASECLASS:
    case JAVAENTERPRISECLASS:
    case JAVACORBACLASS:
    case JCOMCLASS:
    case JAVAPACKAGES:
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case JAVAGUICLASS:
        jj_consume_token(JAVAGUICLASS);
                              pkgName = "gui";
        break;
      case JAVABASECLASS:
        jj_consume_token(JAVABASECLASS);
                              pkgName = "base";
        break;
      case JAVAENTERPRISECLASS:
        jj_consume_token(JAVAENTERPRISECLASS);
                              pkgName = "enterprise";
        break;
      case JAVACORBACLASS:
        jj_consume_token(JAVACORBACLASS);
                              pkgName = "corba";
        break;
      case JCOMCLASS:
        jj_consume_token(JCOMCLASS);
                              pkgName = "jcom";
        break;
      case JAVAPACKAGES:
        jj_consume_token(JAVAPACKAGES);
        jj_consume_token(LT);
        AnyName();
                                    pkgName = token.image;
        jj_consume_token(GT);
        break;
      default:
        jj_la1[400] = jj_gen;
        jj_consume_token(-1);
        throw new ParseException();
      }
      jj_consume_token(CONST_NAME);
                              handleJavaPackages(lineNum(), pkgName, token.image);
      label_82:
      while (true) {
        switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
        case COMMA:
          ;
          break;
        default:
          jj_la1[401] = jj_gen;
          break label_82;
        }
        jj_consume_token(COMMA);
        jj_consume_token(CONST_NAME);
                              handleJavaPackages(lineNum(), pkgName, token.image);
      }
      break;
    case DEFINEJAVAPACKAGES:
      jj_consume_token(DEFINEJAVAPACKAGES);
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case LT:
        jj_consume_token(LT);
        break;
      default:
        jj_la1[402] = jj_gen;
        ;
      }
      AnyName();
                                          pkgName = token.image;
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case GT:
        jj_consume_token(GT);
        break;
      default:
        jj_la1[403] = jj_gen;
        ;
      }
      jj_consume_token(LBRACE);
      x = JavaClassName();
                              defineJavaPackages(pkgName, x);
      label_83:
      while (true) {
        switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
        case COMMA:
          ;
          break;
        default:
          jj_la1[404] = jj_gen;
          break label_83;
        }
        jj_consume_token(COMMA);
        x = JavaClassName();
                              defineJavaPackages(pkgName, x);
      }
      jj_consume_token(RBRACE);
      break;
    default:
      jj_la1[405] = jj_gen;
      jj_consume_token(-1);
      throw new ParseException();
    }
  }

  final public void importElement() throws ParseException {
  String x;
    x = JavaClassName();
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case DOT:
      jj_consume_token(DOT);
      jj_consume_token(STAR);
                                x+='.';
      break;
    default:
      jj_la1[406] = jj_gen;
      ;
    }
    stack.push(new StmtImport(x)); // add to the runtime import list.

    // Add to the parser's import list for class resolutions during compiling.
    // In these situations, classes are resolved at compile-time:
    //  1. Java extension classes.
    //  2. Java adapters.
    //  3. const's for Java classes.
    // Compile-time class resolution is done by ParsingContext (RT uses that, too.)
    if (pc != null) pc.addImport(x);
  }

  final public void SCPStatement() throws ParseException {
  StmtSCP stmt = null;
  boolean set = false;
    jj_consume_token(SCP);
    Expression();
                              stmt = new StmtSCP(lineNum(), reduceIt());
    jj_consume_token(COMMA);
    Expression();
                              stmt.username = reduceIt();
    jj_consume_token(COMMA);
    Expression();
                              stmt.password = reduceIt();
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case COMMA:
      jj_consume_token(COMMA);
      Expression();
                              stmt.cipher   = reduceIt();
      break;
    default:
      jj_la1[407] = jj_gen;
      ;
    }
    jj_consume_token(FROM);
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case IDENTIFIER:
      id("remote");
                              stmt.toRemote = false;
      break;
    case LOCAL:
      jj_consume_token(LOCAL);
                              stmt.toRemote = true;
      break;
    default:
      jj_la1[408] = jj_gen;
      jj_consume_token(-1);
      throw new ParseException();
    }
    Expression();
                              stmt.src  = reduceIt();
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case TO:
      jj_consume_token(TO);
      Expression();
                              stmt.dest = reduceIt();
      break;
    default:
      jj_la1[409] = jj_gen;
      ;
    }
    label_84:
    while (true) {
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case IDENTIFIER:
        ;
        break;
      default:
        jj_la1[410] = jj_gen;
        break label_84;
      }
      jj_consume_token(IDENTIFIER);
                              if (token.image.equals("recursive")) stmt.recursive = true;
                              else if (token.image.equalsIgnoreCase("Echo")) stmt.verbose = true;
                              throwParseException("Invalid SCP option: " + token.image);
    }
    jj_consume_token(SEMICOLON);
                              stack.push(stmt);
  }

  final public void FileSystemStatements() throws ParseException {
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case LIST:
    case LS:
      FSListStatements();
      break;
    case COPY:
      FSCopyStatement();
      break;
    case RMDIR:
      FSRemoveDirStatements();
      break;
    default:
      jj_la1[411] = jj_gen;
      jj_consume_token(-1);
      throw new ParseException();
    }
  }

  final public void FSListStatements() throws ParseException {
  StmtFSList fs = new StmtFSList();
  stack.push(fs);
  Expr to_store = null;
  Expr to_dest = null;
  String name = null;
  int lineNo;
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case LIST:
      jj_consume_token(LIST);
                                     name="listFiles";
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case LT:
        jj_consume_token(LT);
        PrimaryExpression(false);
                                     fs.mergeResult = reduceIt();
        jj_consume_token(GT);
        break;
      default:
        jj_la1[412] = jj_gen;
        ;
      }
      break;
    case LS:
      jj_consume_token(LS);
                                     name="ls"; fs.doEcho = true;
      break;
    default:
      jj_la1[413] = jj_gen;
      jj_consume_token(-1);
      throw new ParseException();
    }
                                     fs.setLineNumber(lineNum());
    if (jj_2_103(2147483647)) {
      Expression();
                    Expr ex = reduceIt();
                    String x = null;
                    if (ex instanceof AccessVar) {
                      x = ((AccessVar)ex).getName();
                      if (x.equals("in") || x.equals("except") || x.equals("ordered") ||
                          x.equals("as") || x.equals("limit") || x.equalsIgnoreCase("addToClasspath"))
                        throwParseException("You must specify an inclusive list (such as '*') to use the " +
                                            x + " clause in the " + name + " command");
                    }
                    try { // in case it is an IDENTIFIER, check for options first
                      if (x != null) {
                        handleFSOption(fs, x);
                        ex = null;
                      }
                    } catch(Exception e) {}
                    if (ex != null) fs.incls = ex;
    } else {
      ;
    }
    label_85:
    while (true) {
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case AS:
      case IN:
      case LIMIT:
      case ORDERED:
      case EXCEPT:
      case IDENTIFIER:
        ;
        break;
      default:
        jj_la1[414] = jj_gen;
        break label_85;
      }
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case EXCEPT:
        jj_consume_token(EXCEPT);
        Expression();
                              fs.excls = reduceIt();
        break;
      case IN:
        jj_consume_token(IN);
        Expression();
                              fs.base = reduceIt();
        break;
      case ORDERED:
        jj_consume_token(ORDERED);
                              fs.listOption = FS_LIST_BY_NAME;
        switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
        case BY:
          jj_consume_token(BY);
          switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
          case DATE_:
            jj_consume_token(DATE_);
                              fs.listOption = FS_LIST_BY_DATE;
            break;
          case IDENTIFIER:
            jj_consume_token(IDENTIFIER);
                              if (token.image.equals("size"))           fs.listOption = FS_LIST_BY_SIZE;
                              else if (token.image.equals("extention")) fs.listOption = FS_LIST_BY_EXT;
                              else if (token.image.equals("name"))      ;
                              else optionNotApplyTo(token.image, "ordered by " + name);
            break;
          default:
            jj_la1[415] = jj_gen;
            jj_consume_token(-1);
            throw new ParseException();
          }
          break;
        default:
          jj_la1[416] = jj_gen;
          ;
        }
        break;
      case LIMIT:
        jj_consume_token(LIMIT);
        Expression();
                              fs.limit = reduceIt();
        break;
      case AS:
        jj_consume_token(AS);
        id("tree");
                              fs.asTree = true;
        break;
      case IDENTIFIER:
        jj_consume_token(IDENTIFIER);
                              handleFSOption(fs, token.image);
        break;
      default:
        jj_la1[417] = jj_gen;
        jj_consume_token(-1);
        throw new ParseException();
      }
    }
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case EXEC:
    case SETFILETIME:
    case SETREADONLY:
    case SEMICOLON:
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case EXEC:
      case SETFILETIME:
      case SETREADONLY:
        switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
        case SETFILETIME:
          jj_consume_token(SETFILETIME);
                              setFSAction(fs, "setFileTime", FS_SETFILETIME);
          switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
          case JAVA__:
          case _EOF:
          case __EOF:
          case AS:
          case DEFINED:
          case ELIF:
          case EXTENDSJAVA:
          case FALSE:
          case JAVACLASS:
          case IFDEF:
          case IFNDEF:
          case IFEXISTS:
          case IN:
          case INFINITY:
          case INTO:
          case NEW:
          case JAVANEW:
          case MAX_NUMBER:
          case MIN_NUMBER:
          case NULL:
          case LIMIT:
          case NAMESPACE:
          case _SKIP:
          case SUPER:
          case THIS:
          case TYPEOF:
          case ATTRIBUTESOF:
          case TRUE:
          case UNDEFINED:
          case BOOLEAN:
          case BYTE:
          case CHAR:
          case SHORT:
          case INT:
          case LONG:
          case FLOAT:
          case DOUBLE:
          case MAIL__CONNECT:
          case MAIL__DISCONNECT:
          case CC:
          case BCC:
          case ATTACH:
          case SUBJECT:
          case BODY:
          case HTMLBODY:
          case DATE_:
          case DATE:
          case NUMBER:
          case COLUMN:
          case ERR:
          case LOG:
          case NL:
          case OUT:
          case PIPE:
          case INPUT:
          case OUTPUT:
          case NEEDSYSTEMIN:
          case MANIFEST:
          case EXCEPT:
          case SETFILETIME:
          case SETREADONLY:
          case SETREADWRITE:
          case TARGET:
          case DB__DISCONNECT:
          case HIB__ADDCLASS:
          case HIB__ADDRESOURCE:
          case HIB__CLOSE:
          case HIB__TXBEGIN:
          case HIB__TXEND:
          case HIB__TXABORT:
          case HIB__LOCK:
          case HIB__DELETE:
          case HIB__GET:
          case HIB__SAVE:
          case HIB__SAVEORUPDATECOPY:
          case HIB__UNLOCK:
          case HIB__UPDATE:
          case AFTER:
          case STARTING:
          case XML:
          case SYSTEMID:
          case OUTPUTPROPERTIES:
          case PARAMETERS:
          case XMLNS:
          case INTEGER_LITERAL:
          case FLOATING_POINT_LITERAL:
          case STRING_LITERAL:
          case EXEC_RESULT_LITERAL:
          case EXEC_RESULTLINES_LITERAL:
          case IDENTIFIER:
          case CONST_NAME:
          case BANG:
          case TILDE:
          case COLONCOLON:
          case INCR:
          case DECR:
          case PLUS:
          case MINUS:
          case BIT_AND:
          case DOLLARLBRACE:
          case LPAREN:
            Expression();
                       fs.value = reduceIt();
            break;
          default:
            jj_la1[418] = jj_gen;
            ;
          }
          break;
        case SETREADONLY:
          jj_consume_token(SETREADONLY);
                              setFSAction(fs, "setReadOnly", FS_SETREADONLY);
          switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
          case JAVA__:
          case _EOF:
          case __EOF:
          case AS:
          case DEFINED:
          case ELIF:
          case EXTENDSJAVA:
          case FALSE:
          case JAVACLASS:
          case IFDEF:
          case IFNDEF:
          case IFEXISTS:
          case IN:
          case INFINITY:
          case INTO:
          case NEW:
          case JAVANEW:
          case MAX_NUMBER:
          case MIN_NUMBER:
          case NULL:
          case LIMIT:
          case NAMESPACE:
          case _SKIP:
          case SUPER:
          case THIS:
          case TYPEOF:
          case ATTRIBUTESOF:
          case TRUE:
          case UNDEFINED:
          case BOOLEAN:
          case BYTE:
          case CHAR:
          case SHORT:
          case INT:
          case LONG:
          case FLOAT:
          case DOUBLE:
          case MAIL__CONNECT:
          case MAIL__DISCONNECT:
          case CC:
          case BCC:
          case ATTACH:
          case SUBJECT:
          case BODY:
          case HTMLBODY:
          case DATE_:
          case DATE:
          case NUMBER:
          case COLUMN:
          case ERR:
          case LOG:
          case NL:
          case OUT:
          case PIPE:
          case INPUT:
          case OUTPUT:
          case NEEDSYSTEMIN:
          case MANIFEST:
          case EXCEPT:
          case SETFILETIME:
          case SETREADONLY:
          case SETREADWRITE:
          case TARGET:
          case DB__DISCONNECT:
          case HIB__ADDCLASS:
          case HIB__ADDRESOURCE:
          case HIB__CLOSE:
          case HIB__TXBEGIN:
          case HIB__TXEND:
          case HIB__TXABORT:
          case HIB__LOCK:
          case HIB__DELETE:
          case HIB__GET:
          case HIB__SAVE:
          case HIB__SAVEORUPDATECOPY:
          case HIB__UNLOCK:
          case HIB__UPDATE:
          case AFTER:
          case STARTING:
          case XML:
          case SYSTEMID:
          case OUTPUTPROPERTIES:
          case PARAMETERS:
          case XMLNS:
          case INTEGER_LITERAL:
          case FLOATING_POINT_LITERAL:
          case STRING_LITERAL:
          case EXEC_RESULT_LITERAL:
          case EXEC_RESULTLINES_LITERAL:
          case IDENTIFIER:
          case CONST_NAME:
          case BANG:
          case TILDE:
          case COLONCOLON:
          case INCR:
          case DECR:
          case PLUS:
          case MINUS:
          case BIT_AND:
          case DOLLARLBRACE:
          case LPAREN:
            Expression();
                       fs.value = reduceIt();
            break;
          default:
            jj_la1[419] = jj_gen;
            ;
          }
          break;
        case EXEC:
          jj_consume_token(EXEC);
          Expression();
                              setFSAction(fs, "exec", FS_DO); fs.value = reduceIt();
          break;
        default:
          jj_la1[420] = jj_gen;
          jj_consume_token(-1);
          throw new ParseException();
        }
        break;
      default:
        jj_la1[421] = jj_gen;
        ;
      }
      jj_consume_token(SEMICOLON);
      break;
    case LBRACE:
      Block();
                              fs.setCustomAction((BlockSimple)stack.pop());
      break;
    default:
      jj_la1[422] = jj_gen;
      jj_consume_token(-1);
      throw new ParseException();
    }
  }

  final public void FSCopyStatement() throws ParseException {
  StmtFSCopy fs = new StmtFSCopy();
  stack.push(fs);
  String[] params=null;
  int begin = 0;
    jj_consume_token(COPY);
                              fs.setAction(token.image, FS_COPY); fs.setLineNumber(lineNum());
    Expression();
                              fs.incls = reduceIt();
    label_86:
    while (true) {
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case AS:
      case IN:
      case INTO:
      case STRIP:
      case TO:
      case UNDER:
      case MANIFEST:
      case EXCEPT:
      case IDENTIFIER:
        ;
        break;
      default:
        jj_la1[423] = jj_gen;
        break label_86;
      }
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case EXCEPT:
        jj_consume_token(EXCEPT);
        Expression();
                              fs.excls = reduceIt();
        break;
      case IN:
        jj_consume_token(IN);
        Expression();
                              fs.base  = reduceIt();
        break;
      case STRIP:
        jj_consume_token(STRIP);
        Expression();
                              fs.strip = reduceIt();
        break;
      case UNDER:
        jj_consume_token(UNDER);
        Expression();
                              fs.under = reduceIt();
        break;
      case AS:
        jj_consume_token(AS);
        Expression();
                              fs.as    = reduceIt();
        break;
      case INTO:
      case TO:
        switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
        case TO:
          jj_consume_token(TO);
          break;
        case INTO:
          jj_consume_token(INTO);
          break;
        default:
          jj_la1[424] = jj_gen;
          jj_consume_token(-1);
          throw new ParseException();
        }
                              fs.archive = token.image.equals("into");
        Expression();
                              fs.value = reduceIt();
        break;
      case IDENTIFIER:
        jj_consume_token(IDENTIFIER);
                              handleFSOption(fs, token.image);
        break;
      case MANIFEST:
        jj_consume_token(MANIFEST);
        switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
        case HEREDOC_BEGIN:
        case HEREDOC_BEGIN_:
          HereDoc();
          break;
        case JAVA__:
        case _EOF:
        case __EOF:
        case AS:
        case DEFINED:
        case ELIF:
        case EXTENDSJAVA:
        case FALSE:
        case JAVACLASS:
        case IFDEF:
        case IFNDEF:
        case IFEXISTS:
        case IN:
        case INFINITY:
        case INTO:
        case NEW:
        case JAVANEW:
        case MAX_NUMBER:
        case MIN_NUMBER:
        case NULL:
        case LIMIT:
        case NAMESPACE:
        case _SKIP:
        case SUPER:
        case THIS:
        case TYPEOF:
        case ATTRIBUTESOF:
        case TRUE:
        case UNDEFINED:
        case BOOLEAN:
        case BYTE:
        case CHAR:
        case SHORT:
        case INT:
        case LONG:
        case FLOAT:
        case DOUBLE:
        case MAIL__CONNECT:
        case MAIL__DISCONNECT:
        case CC:
        case BCC:
        case ATTACH:
        case SUBJECT:
        case BODY:
        case HTMLBODY:
        case DATE_:
        case DATE:
        case NUMBER:
        case COLUMN:
        case ERR:
        case LOG:
        case NL:
        case OUT:
        case PIPE:
        case INPUT:
        case OUTPUT:
        case NEEDSYSTEMIN:
        case MANIFEST:
        case EXCEPT:
        case SETFILETIME:
        case SETREADONLY:
        case SETREADWRITE:
        case TARGET:
        case DB__DISCONNECT:
        case HIB__ADDCLASS:
        case HIB__ADDRESOURCE:
        case HIB__CLOSE:
        case HIB__TXBEGIN:
        case HIB__TXEND:
        case HIB__TXABORT:
        case HIB__LOCK:
        case HIB__DELETE:
        case HIB__GET:
        case HIB__SAVE:
        case HIB__SAVEORUPDATECOPY:
        case HIB__UNLOCK:
        case HIB__UPDATE:
        case AFTER:
        case STARTING:
        case XML:
        case SYSTEMID:
        case OUTPUTPROPERTIES:
        case PARAMETERS:
        case XMLNS:
        case INTEGER_LITERAL:
        case FLOATING_POINT_LITERAL:
        case STRING_LITERAL:
        case EXEC_RESULT_LITERAL:
        case EXEC_RESULTLINES_LITERAL:
        case IDENTIFIER:
        case CONST_NAME:
        case BANG:
        case TILDE:
        case COLONCOLON:
        case INCR:
        case DECR:
        case PLUS:
        case MINUS:
        case BIT_AND:
        case DOLLARLBRACE:
        case LPAREN:
          Expression();
          break;
        default:
          jj_la1[425] = jj_gen;
          jj_consume_token(-1);
          throw new ParseException();
        }
                                              fs.manifest = reduceIt();
        break;
      default:
        jj_la1[426] = jj_gen;
        jj_consume_token(-1);
        throw new ParseException();
      }
    }
    jj_consume_token(SEMICOLON);
    if (!fs.archive) {
      String name = null;
      if (fs.as != null)            name = "as";
      else if (fs.under != null)    name = "under";
      else if (fs.manifest != null) name = "manifest";

      if (name != null)
        throwParseException("Option \"" + name + "\" is not applicable to file system copying.");
    }
  }

  final public void FSRemoveDirStatements() throws ParseException {
  Variable force = ConstInt.FALSE;
    jj_consume_token(RMDIR);
    Expression();
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case IDENTIFIER:
      id("force");
                                       force = ConstInt.TRUE;
      break;
    default:
      jj_la1[427] = jj_gen;
      ;
    }
    jj_consume_token(SEMICOLON);
    stack.push(new ExprCall(null, "rmdir", new Expr[]{reduceIt(), force}, null));
  }

  final public void StartThreadStatement() throws ParseException {
  String name = null;
  int begin;
  boolean daemon = false;
  Arguments args = null;
  ArrayList paramNames = null;
  ArrayList paramValues = null;
  int paramIdx = 0;
  String[] params = null;
  Expr[] ea = JudoUtil.emptyExprs;
  int lastMark = markStack();
    id("start");
                begin=lineNum();
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case IDENTIFIER:
      id("daemon");
                                                    daemon=true;
      break;
    default:
      jj_la1[428] = jj_gen;
      ;
    }
    jj_consume_token(THREAD);
    if (jj_2_104(2)) {
      LabelName();
                               name = THREAD_PREFIX + token.image;
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case LPAREN:
        Arguments(null,0);
                               args = (Arguments)stack.pop();
        break;
      default:
        jj_la1[429] = jj_gen;
        ;
      }
      jj_consume_token(SEMICOLON);
                               stack.push(new ExprCall(daemon,name,(args==null)?null:args.getParams()));
    } else {
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case IDENTIFIER:
      case LBRACE:
      case LPAREN:
      case RPAREN:
      case DOTDOT:
        ea = FormalParameters();
                               params = handleStrings(lastMark);
        Block();
                               name = THREAD_PREFIX + Lib.createID();
                               script.addThread( new _Thread(begin,lineNum(),name,inClassDef,params,
                                                             null,(BlockSimple)stack.pop()) );
                               int len1 = (params==null) ? 0 : params.length;
                               int len2 = (ea==null) ? 0 : ea.length;
                               Expr[] defvals = null;
                               if (len1 > 0) {
                                 defvals = new Expr[len1];
                                 for (int i=0; i<len1; ++i) {
                                   if ((i<len2) && (ea[i]!=null))
                                     defvals[i] = ea[i];
                                   else
                                     defvals[i] = new AccessVar(params[i]);
                                 }
                               }
                               stack.push(new ExprCall(daemon,name,defvals));
        break;
      default:
        jj_la1[430] = jj_gen;
        jj_consume_token(-1);
        throw new ParseException();
      }
    }
  }

  String XMLLiteral() throws ParseException {
  // returns the tag name of the root.
  try {
    Markup mu = MarkupParser.parseXMLTree(token_source.getInputStream());
    String rootName = mu.getName();
    JudoUtil.processMarkup(mu);
    stack.push(mu);
    return rootName;
  } catch(Exception e) {
    e.printStackTrace();
    throwParseException(e.getMessage());
    return null; // not reachable.
  }
  }

  void LocalData() throws ParseException {
  StringBuffer sb = new StringBuffer();
  CharStream instrm = token_source.getInputStream();
  try {
    // ignore the rest of the line of EndScript:
    boolean started = false;
    while (true) {
      char ch = instrm.readChar();
      if (ch <= 0) break;
      if (!started) {
        if (ch == '\n' || ch == '\r')
          started = true;
      } else {
        sb.append(ch);
      }
    }
  } catch(Exception e) {}

  /*
   * Filter out the leading empty lines.
   */
  String text;
  int i=0;
  for (; i<sb.length(); ++i) {
    if (!Character.isWhitespace(sb.charAt(i)))
      break;
  }
  if (i >= sb.length())
    text = "";
  else {
    // now, go back to the first \n or \r
    for (--i; i>=0; --i) {
      char c = sb.charAt(i);
      if ((c == '\r') || (c == '\n')) {
        ++i;
        break;
      }
    }
    text = (i<=0) ? sb.toString() : sb.substring(i);
  }

  if (Lib.isNotEmpty(text))
    script.setLocalDataSource(text);
  }

/***
// code sample
JAVACODE
void skip_to_matching_brace() {
  Token tok;
  int nesting = 1;
  while (true) {
    tok = getToken(1);
    if (tok.kind == LBRACE) nesting++;
    if (tok.kind == RBRACE) {
      nesting--;
      if (nesting == 0) break;
    }
    tok = getNextToken();
  }
}
***/
  final public void LabelName() throws ParseException {
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case IDENTIFIER:
      jj_consume_token(IDENTIFIER);
      break;
    case AS:
      jj_consume_token(AS);
      break;
    case ELIF:
      jj_consume_token(ELIF);
      break;
    case EXTENDSJAVA:
      jj_consume_token(EXTENDSJAVA);
      break;
    case IFDEF:
      jj_consume_token(IFDEF);
      break;
    case IFNDEF:
      jj_consume_token(IFNDEF);
      break;
    case IFEXISTS:
      jj_consume_token(IFEXISTS);
      break;
    case IN:
      jj_consume_token(IN);
      break;
    case INTO:
      jj_consume_token(INTO);
      break;
    case LIMIT:
      jj_consume_token(LIMIT);
      break;
    case NAMESPACE:
      jj_consume_token(NAMESPACE);
      break;
    case _SKIP:
      jj_consume_token(_SKIP);
      break;
    case NUMBER:
      jj_consume_token(NUMBER);
      break;
    case COLUMN:
      jj_consume_token(COLUMN);
      break;
    case ERR:
      jj_consume_token(ERR);
      break;
    case LOG:
      jj_consume_token(LOG);
      break;
    case OUT:
      jj_consume_token(OUT);
      break;
    case PIPE:
      jj_consume_token(PIPE);
      break;
    case INPUT:
      jj_consume_token(INPUT);
      break;
    case OUTPUT:
      jj_consume_token(OUTPUT);
      break;
    case NEEDSYSTEMIN:
      jj_consume_token(NEEDSYSTEMIN);
      break;
    case EXCEPT:
      jj_consume_token(EXCEPT);
      break;
    case SETFILETIME:
      jj_consume_token(SETFILETIME);
      break;
    case SETREADONLY:
      jj_consume_token(SETREADONLY);
      break;
    case SETREADWRITE:
      jj_consume_token(SETREADWRITE);
      break;
    case TARGET:
      jj_consume_token(TARGET);
      break;
    case AFTER:
      jj_consume_token(AFTER);
      break;
    case STARTING:
      jj_consume_token(STARTING);
      break;
    case XML:
      jj_consume_token(XML);
      break;
    case SYSTEMID:
      jj_consume_token(SYSTEMID);
      break;
    case OUTPUTPROPERTIES:
      jj_consume_token(OUTPUTPROPERTIES);
      break;
    case PARAMETERS:
      jj_consume_token(PARAMETERS);
      break;
    case XMLNS:
      jj_consume_token(XMLNS);
      break;
    case CC:
      jj_consume_token(CC);
      break;
    case BCC:
      jj_consume_token(BCC);
      break;
    case BODY:
      jj_consume_token(BODY);
      break;
    case HTMLBODY:
      jj_consume_token(HTMLBODY);
      break;
    case ATTACH:
      jj_consume_token(ATTACH);
      break;
    case SUBJECT:
      jj_consume_token(SUBJECT);
      break;
    case MANIFEST:
      jj_consume_token(MANIFEST);
      break;
    default:
      jj_la1[431] = jj_gen;
      jj_consume_token(-1);
      throw new ParseException();
    }
  }

  final public void JavaAllowedName() throws ParseException {
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case AS:
    case ELIF:
    case EXTENDSJAVA:
    case IFDEF:
    case IFNDEF:
    case IFEXISTS:
    case IN:
    case INTO:
    case LIMIT:
    case NAMESPACE:
    case _SKIP:
    case CC:
    case BCC:
    case ATTACH:
    case SUBJECT:
    case BODY:
    case HTMLBODY:
    case NUMBER:
    case COLUMN:
    case ERR:
    case LOG:
    case OUT:
    case PIPE:
    case INPUT:
    case OUTPUT:
    case NEEDSYSTEMIN:
    case MANIFEST:
    case EXCEPT:
    case SETFILETIME:
    case SETREADONLY:
    case SETREADWRITE:
    case TARGET:
    case AFTER:
    case STARTING:
    case XML:
    case SYSTEMID:
    case OUTPUTPROPERTIES:
    case PARAMETERS:
    case XMLNS:
    case IDENTIFIER:
      LabelName();
      break;
    case _USAGE:
      jj_consume_token(_USAGE);
      break;
    case ENDSCRIPT:
      jj_consume_token(ENDSCRIPT);
      break;
    case _EOF:
      jj_consume_token(_EOF);
      break;
    case __EOF:
      jj_consume_token(__EOF);
      break;
    case DEFINED:
      jj_consume_token(DEFINED);
      break;
    case DELETE:
      jj_consume_token(DELETE);
      break;
    case EXEC:
      jj_consume_token(EXEC);
      break;
    case FUNCTION:
      jj_consume_token(FUNCTION);
      break;
    case LAMBDA:
      jj_consume_token(LAMBDA);
      break;
    case INFINITY:
      jj_consume_token(INFINITY);
      break;
    case JAVACLASS:
      jj_consume_token(JAVACLASS);
      break;
    case LOCAL:
      jj_consume_token(LOCAL);
      break;
    case RESUME:
      jj_consume_token(RESUME);
      break;
    case STRIP:
      jj_consume_token(STRIP);
      break;
    case TYPEOF:
      jj_consume_token(TYPEOF);
      break;
    case ATTRIBUTESOF:
      jj_consume_token(ATTRIBUTESOF);
      break;
    case UNDER:
      jj_consume_token(UNDER);
      break;
    case UNDEFINED:
      jj_consume_token(UNDEFINED);
      break;
    case USING:
      jj_consume_token(USING);
      break;
    case USE:
      jj_consume_token(USE);
      break;
    case VAR:
      jj_consume_token(VAR);
      break;
    case WHERE:
      jj_consume_token(WHERE);
      break;
    case WITH:
      jj_consume_token(WITH);
      break;
    case STRING:
      jj_consume_token(STRING);
      break;
    case STRING_:
      jj_consume_token(STRING_);
      break;
    case LINKEDLIST_:
      jj_consume_token(LINKEDLIST_);
      break;
    case LINKEDLIST:
      jj_consume_token(LINKEDLIST);
      break;
    case SET_:
      jj_consume_token(SET_);
      break;
    case SET:
      jj_consume_token(SET);
      break;
    case SORTEDMAP_:
      jj_consume_token(SORTEDMAP_);
      break;
    case SORTEDMAP:
      jj_consume_token(SORTEDMAP);
      break;
    case DATE_:
      jj_consume_token(DATE_);
      break;
    case DATE:
      jj_consume_token(DATE);
      break;
    case NUMBER_:
      jj_consume_token(NUMBER_);
      break;
    case FLUSH:
      jj_consume_token(FLUSH);
      break;
    case PRINT:
      jj_consume_token(PRINT);
      break;
    case PRINTLN:
      jj_consume_token(PRINTLN);
      break;
    case PRINTTABLE:
      jj_consume_token(PRINTTABLE);
      break;
    case PRINTTABLEDATA:
      jj_consume_token(PRINTTABLEDATA);
      break;
    case SCP:
      jj_consume_token(SCP);
      break;
    case COPY:
      jj_consume_token(COPY);
      break;
    case LIST:
      jj_consume_token(LIST);
      break;
    case LS:
      jj_consume_token(LS);
      break;
    case ORDERED:
      jj_consume_token(ORDERED);
      break;
    case BY:
      jj_consume_token(BY);
      break;
    case RMDIR:
      jj_consume_token(RMDIR);
      break;
    case EJBQL:
      jj_consume_token(EJBQL);
      break;
    case REPEAT:
      jj_consume_token(REPEAT);
      break;
    case SCHEDULE:
      jj_consume_token(SCHEDULE);
      break;
    case XSLT:
      jj_consume_token(XSLT);
      break;
    case XPATH:
      jj_consume_token(XPATH);
      break;
    case DOM:
      jj_consume_token(DOM);
      break;
    case JSP:
      jj_consume_token(JSP);
      break;
    case HTML:
      jj_consume_token(HTML);
      break;
    case SGML:
      jj_consume_token(SGML);
      break;
    default:
      jj_la1[432] = jj_gen;
      jj_consume_token(-1);
      throw new ParseException();
    }
  }

  final public void AnyName() throws ParseException {
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case _USAGE:
    case ENDSCRIPT:
    case _EOF:
    case __EOF:
    case AS:
    case DEFINED:
    case DELETE:
    case ELIF:
    case EXEC:
    case EXTENDSJAVA:
    case FUNCTION:
    case LAMBDA:
    case JAVACLASS:
    case IFDEF:
    case IFNDEF:
    case IFEXISTS:
    case IN:
    case INFINITY:
    case INTO:
    case LOCAL:
    case LIMIT:
    case NAMESPACE:
    case _SKIP:
    case RESUME:
    case STRIP:
    case TYPEOF:
    case ATTRIBUTESOF:
    case UNDER:
    case UNDEFINED:
    case USING:
    case USE:
    case VAR:
    case WHERE:
    case WITH:
    case STRING:
    case STRING_:
    case CC:
    case BCC:
    case ATTACH:
    case SUBJECT:
    case BODY:
    case HTMLBODY:
    case LINKEDLIST_:
    case LINKEDLIST:
    case SET_:
    case SET:
    case SORTEDMAP_:
    case SORTEDMAP:
    case DATE_:
    case DATE:
    case NUMBER_:
    case NUMBER:
    case COLUMN:
    case ERR:
    case LOG:
    case OUT:
    case PIPE:
    case INPUT:
    case OUTPUT:
    case NEEDSYSTEMIN:
    case FLUSH:
    case PRINT:
    case PRINTLN:
    case PRINTTABLE:
    case PRINTTABLEDATA:
    case SCP:
    case COPY:
    case MANIFEST:
    case LIST:
    case LS:
    case ORDERED:
    case BY:
    case RMDIR:
    case EXCEPT:
    case SETFILETIME:
    case SETREADONLY:
    case SETREADWRITE:
    case TARGET:
    case EJBQL:
    case AFTER:
    case REPEAT:
    case SCHEDULE:
    case STARTING:
    case XML:
    case XSLT:
    case XPATH:
    case SYSTEMID:
    case OUTPUTPROPERTIES:
    case PARAMETERS:
    case DOM:
    case XMLNS:
    case HTML:
    case JSP:
    case SGML:
    case IDENTIFIER:
      JavaAllowedName();
      break;
    case IMPORT:
      jj_consume_token(IMPORT);
      break;
    case BREAK:
      jj_consume_token(BREAK);
      break;
    case CASE:
      jj_consume_token(CASE);
      break;
    case CATCH:
      jj_consume_token(CATCH);
      break;
    case CLASS:
      jj_consume_token(CLASS);
      break;
    case CONST:
      jj_consume_token(CONST);
      break;
    case CONTINUE:
      jj_consume_token(CONTINUE);
      break;
    case CONSTRUCTOR:
      jj_consume_token(CONSTRUCTOR);
      break;
    case CTOR:
      jj_consume_token(CTOR);
      break;
    case _DEFAULT:
      jj_consume_token(_DEFAULT);
      break;
    case DO:
      jj_consume_token(DO);
      break;
    case ELSE:
      jj_consume_token(ELSE);
      break;
    case EXTENDS:
      jj_consume_token(EXTENDS);
      break;
    case FALSE:
      jj_consume_token(FALSE);
      break;
    case FINALLY:
      jj_consume_token(FINALLY);
      break;
    case FOR:
      jj_consume_token(FOR);
      break;
    case THREAD:
      jj_consume_token(THREAD);
      break;
    case IF:
      jj_consume_token(IF);
      break;
    case NEW:
      jj_consume_token(NEW);
      break;
    case NULL:
      jj_consume_token(NULL);
      break;
    case RETURN:
      jj_consume_token(RETURN);
      break;
    case SUPER:
      jj_consume_token(SUPER);
      break;
    case SWITCH:
      jj_consume_token(SWITCH);
      break;
    case THIS:
      jj_consume_token(THIS);
      break;
    case THROW:
      jj_consume_token(THROW);
      break;
    case TRUE:
      jj_consume_token(TRUE);
      break;
    case TRY:
      jj_consume_token(TRY);
      break;
    case WHILE:
      jj_consume_token(WHILE);
      break;
    case BOOLEAN:
      jj_consume_token(BOOLEAN);
      break;
    case BYTE:
      jj_consume_token(BYTE);
      break;
    case CHAR:
      jj_consume_token(CHAR);
      break;
    case SHORT:
      jj_consume_token(SHORT);
      break;
    case INT:
      jj_consume_token(INT);
      break;
    case LONG:
      jj_consume_token(LONG);
      break;
    case FLOAT:
      jj_consume_token(FLOAT);
      break;
    case DOUBLE:
      jj_consume_token(DOUBLE);
      break;
    case VOID:
      jj_consume_token(VOID);
      break;
    case FROM:
      jj_consume_token(FROM);
      break;
    case TO:
      jj_consume_token(TO);
      break;
    case UPTO:
      jj_consume_token(UPTO);
      break;
    case DOWNTO:
      jj_consume_token(DOWNTO);
      break;
    case ON:
      jj_consume_token(ON);
      break;
    case MAX_NUMBER:
      jj_consume_token(MAX_NUMBER);
      break;
    case MIN_NUMBER:
      jj_consume_token(MIN_NUMBER);
      break;
    default:
      jj_la1[433] = jj_gen;
      jj_consume_token(-1);
      throw new ParseException();
    }
  }

  final public void PotentialFunctionName() throws ParseException {
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case AS:
    case ELIF:
    case EXTENDSJAVA:
    case IFDEF:
    case IFNDEF:
    case IFEXISTS:
    case IN:
    case INTO:
    case LIMIT:
    case NAMESPACE:
    case _SKIP:
    case CC:
    case BCC:
    case ATTACH:
    case SUBJECT:
    case BODY:
    case HTMLBODY:
    case NUMBER:
    case COLUMN:
    case ERR:
    case LOG:
    case OUT:
    case PIPE:
    case INPUT:
    case OUTPUT:
    case NEEDSYSTEMIN:
    case MANIFEST:
    case EXCEPT:
    case SETFILETIME:
    case SETREADONLY:
    case SETREADWRITE:
    case TARGET:
    case AFTER:
    case STARTING:
    case XML:
    case SYSTEMID:
    case OUTPUTPROPERTIES:
    case PARAMETERS:
    case XMLNS:
    case IDENTIFIER:
      LabelName();
      break;
    case DB__DISCONNECT:
      jj_consume_token(DB__DISCONNECT);
      break;
    case HIB__ADDCLASS:
      jj_consume_token(HIB__ADDCLASS);
      break;
    case HIB__ADDRESOURCE:
      jj_consume_token(HIB__ADDRESOURCE);
      break;
    case HIB__CLOSE:
      jj_consume_token(HIB__CLOSE);
      break;
    case HIB__DELETE:
      jj_consume_token(HIB__DELETE);
      break;
    case HIB__LOCK:
      jj_consume_token(HIB__LOCK);
      break;
    case HIB__SAVE:
      jj_consume_token(HIB__SAVE);
      break;
    case HIB__SAVEORUPDATECOPY:
      jj_consume_token(HIB__SAVEORUPDATECOPY);
      break;
    case HIB__TXABORT:
      jj_consume_token(HIB__TXABORT);
      break;
    case HIB__TXBEGIN:
      jj_consume_token(HIB__TXBEGIN);
      break;
    case HIB__TXEND:
      jj_consume_token(HIB__TXEND);
      break;
    case HIB__UNLOCK:
      jj_consume_token(HIB__UNLOCK);
      break;
    case HIB__UPDATE:
      jj_consume_token(HIB__UPDATE);
      break;
    case HIB__GET:
      jj_consume_token(HIB__GET);
      break;
    case MAIL__CONNECT:
      jj_consume_token(MAIL__CONNECT);
      break;
    case MAIL__DISCONNECT:
      jj_consume_token(MAIL__DISCONNECT);
      break;
    default:
      jj_la1[434] = jj_gen;
      jj_consume_token(-1);
      throw new ParseException();
    }
  }

  final private boolean jj_2_1(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    try { return !jj_3_1(); }
    catch(LookaheadSuccess ls) { return true; }
    finally { jj_save(0, xla); }
  }

  final private boolean jj_2_2(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    try { return !jj_3_2(); }
    catch(LookaheadSuccess ls) { return true; }
    finally { jj_save(1, xla); }
  }

  final private boolean jj_2_3(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    try { return !jj_3_3(); }
    catch(LookaheadSuccess ls) { return true; }
    finally { jj_save(2, xla); }
  }

  final private boolean jj_2_4(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    try { return !jj_3_4(); }
    catch(LookaheadSuccess ls) { return true; }
    finally { jj_save(3, xla); }
  }

  final private boolean jj_2_5(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    try { return !jj_3_5(); }
    catch(LookaheadSuccess ls) { return true; }
    finally { jj_save(4, xla); }
  }

  final private boolean jj_2_6(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    try { return !jj_3_6(); }
    catch(LookaheadSuccess ls) { return true; }
    finally { jj_save(5, xla); }
  }

  final private boolean jj_2_7(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    try { return !jj_3_7(); }
    catch(LookaheadSuccess ls) { return true; }
    finally { jj_save(6, xla); }
  }

  final private boolean jj_2_8(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    try { return !jj_3_8(); }
    catch(LookaheadSuccess ls) { return true; }
    finally { jj_save(7, xla); }
  }

  final private boolean jj_2_9(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    try { return !jj_3_9(); }
    catch(LookaheadSuccess ls) { return true; }
    finally { jj_save(8, xla); }
  }

  final private boolean jj_2_10(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    try { return !jj_3_10(); }
    catch(LookaheadSuccess ls) { return true; }
    finally { jj_save(9, xla); }
  }

  final private boolean jj_2_11(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    try { return !jj_3_11(); }
    catch(LookaheadSuccess ls) { return true; }
    finally { jj_save(10, xla); }
  }

  final private boolean jj_2_12(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    try { return !jj_3_12(); }
    catch(LookaheadSuccess ls) { return true; }
    finally { jj_save(11, xla); }
  }

  final private boolean jj_2_13(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    try { return !jj_3_13(); }
    catch(LookaheadSuccess ls) { return true; }
    finally { jj_save(12, xla); }
  }

  final private boolean jj_2_14(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    try { return !jj_3_14(); }
    catch(LookaheadSuccess ls) { return true; }
    finally { jj_save(13, xla); }
  }

  final private boolean jj_2_15(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    try { return !jj_3_15(); }
    catch(LookaheadSuccess ls) { return true; }
    finally { jj_save(14, xla); }
  }

  final private boolean jj_2_16(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    try { return !jj_3_16(); }
    catch(LookaheadSuccess ls) { return true; }
    finally { jj_save(15, xla); }
  }

  final private boolean jj_2_17(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    try { return !jj_3_17(); }
    catch(LookaheadSuccess ls) { return true; }
    finally { jj_save(16, xla); }
  }

  final private boolean jj_2_18(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    try { return !jj_3_18(); }
    catch(LookaheadSuccess ls) { return true; }
    finally { jj_save(17, xla); }
  }

  final private boolean jj_2_19(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    try { return !jj_3_19(); }
    catch(LookaheadSuccess ls) { return true; }
    finally { jj_save(18, xla); }
  }

  final private boolean jj_2_20(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    try { return !jj_3_20(); }
    catch(LookaheadSuccess ls) { return true; }
    finally { jj_save(19, xla); }
  }

  final private boolean jj_2_21(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    try { return !jj_3_21(); }
    catch(LookaheadSuccess ls) { return true; }
    finally { jj_save(20, xla); }
  }

  final private boolean jj_2_22(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    try { return !jj_3_22(); }
    catch(LookaheadSuccess ls) { return true; }
    finally { jj_save(21, xla); }
  }

  final private boolean jj_2_23(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    try { return !jj_3_23(); }
    catch(LookaheadSuccess ls) { return true; }
    finally { jj_save(22, xla); }
  }

  final private boolean jj_2_24(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    try { return !jj_3_24(); }
    catch(LookaheadSuccess ls) { return true; }
    finally { jj_save(23, xla); }
  }

  final private boolean jj_2_25(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    try { return !jj_3_25(); }
    catch(LookaheadSuccess ls) { return true; }
    finally { jj_save(24, xla); }
  }

  final private boolean jj_2_26(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    try { return !jj_3_26(); }
    catch(LookaheadSuccess ls) { return true; }
    finally { jj_save(25, xla); }
  }

  final private boolean jj_2_27(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    try { return !jj_3_27(); }
    catch(LookaheadSuccess ls) { return true; }
    finally { jj_save(26, xla); }
  }

  final private boolean jj_2_28(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    try { return !jj_3_28(); }
    catch(LookaheadSuccess ls) { return true; }
    finally { jj_save(27, xla); }
  }

  final private boolean jj_2_29(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    try { return !jj_3_29(); }
    catch(LookaheadSuccess ls) { return true; }
    finally { jj_save(28, xla); }
  }

  final private boolean jj_2_30(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    try { return !jj_3_30(); }
    catch(LookaheadSuccess ls) { return true; }
    finally { jj_save(29, xla); }
  }

  final private boolean jj_2_31(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    try { return !jj_3_31(); }
    catch(LookaheadSuccess ls) { return true; }
    finally { jj_save(30, xla); }
  }

  final private boolean jj_2_32(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    try { return !jj_3_32(); }
    catch(LookaheadSuccess ls) { return true; }
    finally { jj_save(31, xla); }
  }

  final private boolean jj_2_33(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    try { return !jj_3_33(); }
    catch(LookaheadSuccess ls) { return true; }
    finally { jj_save(32, xla); }
  }

  final private boolean jj_2_34(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    try { return !jj_3_34(); }
    catch(LookaheadSuccess ls) { return true; }
    finally { jj_save(33, xla); }
  }

  final private boolean jj_2_35(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    try { return !jj_3_35(); }
    catch(LookaheadSuccess ls) { return true; }
    finally { jj_save(34, xla); }
  }

  final private boolean jj_2_36(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    try { return !jj_3_36(); }
    catch(LookaheadSuccess ls) { return true; }
    finally { jj_save(35, xla); }
  }

  final private boolean jj_2_37(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    try { return !jj_3_37(); }
    catch(LookaheadSuccess ls) { return true; }
    finally { jj_save(36, xla); }
  }

  final private boolean jj_2_38(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    try { return !jj_3_38(); }
    catch(LookaheadSuccess ls) { return true; }
    finally { jj_save(37, xla); }
  }

  final private boolean jj_2_39(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    try { return !jj_3_39(); }
    catch(LookaheadSuccess ls) { return true; }
    finally { jj_save(38, xla); }
  }

  final private boolean jj_2_40(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    try { return !jj_3_40(); }
    catch(LookaheadSuccess ls) { return true; }
    finally { jj_save(39, xla); }
  }

  final private boolean jj_2_41(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    try { return !jj_3_41(); }
    catch(LookaheadSuccess ls) { return true; }
    finally { jj_save(40, xla); }
  }

  final private boolean jj_2_42(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    try { return !jj_3_42(); }
    catch(LookaheadSuccess ls) { return true; }
    finally { jj_save(41, xla); }
  }

  final private boolean jj_2_43(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    try { return !jj_3_43(); }
    catch(LookaheadSuccess ls) { return true; }
    finally { jj_save(42, xla); }
  }

  final private boolean jj_2_44(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    try { return !jj_3_44(); }
    catch(LookaheadSuccess ls) { return true; }
    finally { jj_save(43, xla); }
  }

  final private boolean jj_2_45(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    try { return !jj_3_45(); }
    catch(LookaheadSuccess ls) { return true; }
    finally { jj_save(44, xla); }
  }

  final private boolean jj_2_46(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    try { return !jj_3_46(); }
    catch(LookaheadSuccess ls) { return true; }
    finally { jj_save(45, xla); }
  }

  final private boolean jj_2_47(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    try { return !jj_3_47(); }
    catch(LookaheadSuccess ls) { return true; }
    finally { jj_save(46, xla); }
  }

  final private boolean jj_2_48(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    try { return !jj_3_48(); }
    catch(LookaheadSuccess ls) { return true; }
    finally { jj_save(47, xla); }
  }

  final private boolean jj_2_49(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    try { return !jj_3_49(); }
    catch(LookaheadSuccess ls) { return true; }
    finally { jj_save(48, xla); }
  }

  final private boolean jj_2_50(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    try { return !jj_3_50(); }
    catch(LookaheadSuccess ls) { return true; }
    finally { jj_save(49, xla); }
  }

  final private boolean jj_2_51(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    try { return !jj_3_51(); }
    catch(LookaheadSuccess ls) { return true; }
    finally { jj_save(50, xla); }
  }

  final private boolean jj_2_52(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    try { return !jj_3_52(); }
    catch(LookaheadSuccess ls) { return true; }
    finally { jj_save(51, xla); }
  }

  final private boolean jj_2_53(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    try { return !jj_3_53(); }
    catch(LookaheadSuccess ls) { return true; }
    finally { jj_save(52, xla); }
  }

  final private boolean jj_2_54(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    try { return !jj_3_54(); }
    catch(LookaheadSuccess ls) { return true; }
    finally { jj_save(53, xla); }
  }

  final private boolean jj_2_55(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    try { return !jj_3_55(); }
    catch(LookaheadSuccess ls) { return true; }
    finally { jj_save(54, xla); }
  }

  final private boolean jj_2_56(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    try { return !jj_3_56(); }
    catch(LookaheadSuccess ls) { return true; }
    finally { jj_save(55, xla); }
  }

  final private boolean jj_2_57(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    try { return !jj_3_57(); }
    catch(LookaheadSuccess ls) { return true; }
    finally { jj_save(56, xla); }
  }

  final private boolean jj_2_58(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    try { return !jj_3_58(); }
    catch(LookaheadSuccess ls) { return true; }
    finally { jj_save(57, xla); }
  }

  final private boolean jj_2_59(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    try { return !jj_3_59(); }
    catch(LookaheadSuccess ls) { return true; }
    finally { jj_save(58, xla); }
  }

  final private boolean jj_2_60(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    try { return !jj_3_60(); }
    catch(LookaheadSuccess ls) { return true; }
    finally { jj_save(59, xla); }
  }

  final private boolean jj_2_61(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    try { return !jj_3_61(); }
    catch(LookaheadSuccess ls) { return true; }
    finally { jj_save(60, xla); }
  }

  final private boolean jj_2_62(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    try { return !jj_3_62(); }
    catch(LookaheadSuccess ls) { return true; }
    finally { jj_save(61, xla); }
  }

  final private boolean jj_2_63(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    try { return !jj_3_63(); }
    catch(LookaheadSuccess ls) { return true; }
    finally { jj_save(62, xla); }
  }

  final private boolean jj_2_64(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    try { return !jj_3_64(); }
    catch(LookaheadSuccess ls) { return true; }
    finally { jj_save(63, xla); }
  }

  final private boolean jj_2_65(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    try { return !jj_3_65(); }
    catch(LookaheadSuccess ls) { return true; }
    finally { jj_save(64, xla); }
  }

  final private boolean jj_2_66(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    try { return !jj_3_66(); }
    catch(LookaheadSuccess ls) { return true; }
    finally { jj_save(65, xla); }
  }

  final private boolean jj_2_67(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    try { return !jj_3_67(); }
    catch(LookaheadSuccess ls) { return true; }
    finally { jj_save(66, xla); }
  }

  final private boolean jj_2_68(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    try { return !jj_3_68(); }
    catch(LookaheadSuccess ls) { return true; }
    finally { jj_save(67, xla); }
  }

  final private boolean jj_2_69(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    try { return !jj_3_69(); }
    catch(LookaheadSuccess ls) { return true; }
    finally { jj_save(68, xla); }
  }

  final private boolean jj_2_70(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    try { return !jj_3_70(); }
    catch(LookaheadSuccess ls) { return true; }
    finally { jj_save(69, xla); }
  }

  final private boolean jj_2_71(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    try { return !jj_3_71(); }
    catch(LookaheadSuccess ls) { return true; }
    finally { jj_save(70, xla); }
  }

  final private boolean jj_2_72(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    try { return !jj_3_72(); }
    catch(LookaheadSuccess ls) { return true; }
    finally { jj_save(71, xla); }
  }

  final private boolean jj_2_73(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    try { return !jj_3_73(); }
    catch(LookaheadSuccess ls) { return true; }
    finally { jj_save(72, xla); }
  }

  final private boolean jj_2_74(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    try { return !jj_3_74(); }
    catch(LookaheadSuccess ls) { return true; }
    finally { jj_save(73, xla); }
  }

  final private boolean jj_2_75(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    try { return !jj_3_75(); }
    catch(LookaheadSuccess ls) { return true; }
    finally { jj_save(74, xla); }
  }

  final private boolean jj_2_76(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    try { return !jj_3_76(); }
    catch(LookaheadSuccess ls) { return true; }
    finally { jj_save(75, xla); }
  }

  final private boolean jj_2_77(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    try { return !jj_3_77(); }
    catch(LookaheadSuccess ls) { return true; }
    finally { jj_save(76, xla); }
  }

  final private boolean jj_2_78(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    try { return !jj_3_78(); }
    catch(LookaheadSuccess ls) { return true; }
    finally { jj_save(77, xla); }
  }

  final private boolean jj_2_79(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    try { return !jj_3_79(); }
    catch(LookaheadSuccess ls) { return true; }
    finally { jj_save(78, xla); }
  }

  final private boolean jj_2_80(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    try { return !jj_3_80(); }
    catch(LookaheadSuccess ls) { return true; }
    finally { jj_save(79, xla); }
  }

  final private boolean jj_2_81(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    try { return !jj_3_81(); }
    catch(LookaheadSuccess ls) { return true; }
    finally { jj_save(80, xla); }
  }

  final private boolean jj_2_82(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    try { return !jj_3_82(); }
    catch(LookaheadSuccess ls) { return true; }
    finally { jj_save(81, xla); }
  }

  final private boolean jj_2_83(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    try { return !jj_3_83(); }
    catch(LookaheadSuccess ls) { return true; }
    finally { jj_save(82, xla); }
  }

  final private boolean jj_2_84(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    try { return !jj_3_84(); }
    catch(LookaheadSuccess ls) { return true; }
    finally { jj_save(83, xla); }
  }

  final private boolean jj_2_85(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    try { return !jj_3_85(); }
    catch(LookaheadSuccess ls) { return true; }
    finally { jj_save(84, xla); }
  }

  final private boolean jj_2_86(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    try { return !jj_3_86(); }
    catch(LookaheadSuccess ls) { return true; }
    finally { jj_save(85, xla); }
  }

  final private boolean jj_2_87(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    try { return !jj_3_87(); }
    catch(LookaheadSuccess ls) { return true; }
    finally { jj_save(86, xla); }
  }

  final private boolean jj_2_88(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    try { return !jj_3_88(); }
    catch(LookaheadSuccess ls) { return true; }
    finally { jj_save(87, xla); }
  }

  final private boolean jj_2_89(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    try { return !jj_3_89(); }
    catch(LookaheadSuccess ls) { return true; }
    finally { jj_save(88, xla); }
  }

  final private boolean jj_2_90(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    try { return !jj_3_90(); }
    catch(LookaheadSuccess ls) { return true; }
    finally { jj_save(89, xla); }
  }

  final private boolean jj_2_91(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    try { return !jj_3_91(); }
    catch(LookaheadSuccess ls) { return true; }
    finally { jj_save(90, xla); }
  }

  final private boolean jj_2_92(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    try { return !jj_3_92(); }
    catch(LookaheadSuccess ls) { return true; }
    finally { jj_save(91, xla); }
  }

  final private boolean jj_2_93(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    try { return !jj_3_93(); }
    catch(LookaheadSuccess ls) { return true; }
    finally { jj_save(92, xla); }
  }

  final private boolean jj_2_94(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    try { return !jj_3_94(); }
    catch(LookaheadSuccess ls) { return true; }
    finally { jj_save(93, xla); }
  }

  final private boolean jj_2_95(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    try { return !jj_3_95(); }
    catch(LookaheadSuccess ls) { return true; }
    finally { jj_save(94, xla); }
  }

  final private boolean jj_2_96(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    try { return !jj_3_96(); }
    catch(LookaheadSuccess ls) { return true; }
    finally { jj_save(95, xla); }
  }

  final private boolean jj_2_97(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    try { return !jj_3_97(); }
    catch(LookaheadSuccess ls) { return true; }
    finally { jj_save(96, xla); }
  }

  final private boolean jj_2_98(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    try { return !jj_3_98(); }
    catch(LookaheadSuccess ls) { return true; }
    finally { jj_save(97, xla); }
  }

  final private boolean jj_2_99(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    try { return !jj_3_99(); }
    catch(LookaheadSuccess ls) { return true; }
    finally { jj_save(98, xla); }
  }

  final private boolean jj_2_100(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    try { return !jj_3_100(); }
    catch(LookaheadSuccess ls) { return true; }
    finally { jj_save(99, xla); }
  }

  final private boolean jj_2_101(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    try { return !jj_3_101(); }
    catch(LookaheadSuccess ls) { return true; }
    finally { jj_save(100, xla); }
  }

  final private boolean jj_2_102(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    try { return !jj_3_102(); }
    catch(LookaheadSuccess ls) { return true; }
    finally { jj_save(101, xla); }
  }

  final private boolean jj_2_103(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    try { return !jj_3_103(); }
    catch(LookaheadSuccess ls) { return true; }
    finally { jj_save(102, xla); }
  }

  final private boolean jj_2_104(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    try { return !jj_3_104(); }
    catch(LookaheadSuccess ls) { return true; }
    finally { jj_save(103, xla); }
  }

  final private boolean jj_3R_103() {
    if (jj_3R_104()) return true;
    return false;
  }

  final private boolean jj_3R_105() {
    if (jj_scan_token(COMMA)) return true;
    if (jj_3R_104()) return true;
    return false;
  }

  final private boolean jj_3_21() {
    if (jj_scan_token(LBRACKET)) return true;
    if (jj_scan_token(RBRACKET)) return true;
    return false;
  }

  final private boolean jj_3R_646() {
    if (jj_scan_token(HIB__DELETE)) return true;
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_715()) jj_scanpos = xsp;
    if (jj_3R_127()) return true;
    if (jj_scan_token(SEMICOLON)) return true;
    return false;
  }

  final private boolean jj_3R_441() {
    if (jj_3R_128()) return true;
    return false;
  }

  final private boolean jj_3R_572() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_646()) {
    jj_scanpos = xsp;
    if (jj_3R_647()) return true;
    }
    return false;
  }

  final private boolean jj_3R_368() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_441()) jj_scanpos = xsp;
    return false;
  }

  final private boolean jj_3_19() {
    if (jj_scan_token(LPAREN)) return true;
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_103()) {
    jj_scanpos = xsp;
    if (jj_scan_token(235)) return true;
    }
    xsp = jj_scanpos;
    if (jj_scan_token(248)) {
    jj_scanpos = xsp;
    if (jj_scan_token(260)) return true;
    }
    return false;
  }

  final private boolean jj_3R_440() {
    if (jj_scan_token(LBRACKET)) return true;
    if (jj_3R_130()) return true;
    if (jj_scan_token(RBRACKET)) return true;
    return false;
  }

  final private boolean jj_3R_367() {
    if (jj_3R_294()) return true;
    return false;
  }

  final private boolean jj_3R_366() {
    Token xsp;
    if (jj_3R_440()) return true;
    while (true) {
      xsp = jj_scanpos;
      if (jj_3R_440()) { jj_scanpos = xsp; break; }
    }
    return false;
  }

  final private boolean jj_3R_438() {
    if (jj_scan_token(LBRACKET)) return true;
    if (jj_scan_token(RBRACKET)) return true;
    return false;
  }

  final private boolean jj_3R_896() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_scan_token(13)) jj_scanpos = xsp;
    if (jj_3R_104()) return true;
    return false;
  }

  final private boolean jj_3R_895() {
    if (jj_scan_token(STRING_LITERAL)) return true;
    return false;
  }

  final private boolean jj_3_18() {
    if (jj_scan_token(LBRACKET)) return true;
    if (jj_scan_token(RBRACKET)) return true;
    return false;
  }

  final private boolean jj_3R_365() {
    Token xsp;
    if (jj_3R_438()) return true;
    while (true) {
      xsp = jj_scanpos;
      if (jj_3R_438()) { jj_scanpos = xsp; break; }
    }
    if (jj_3R_439()) return true;
    return false;
  }

  final private boolean jj_3R_536() {
    if (jj_3R_128()) return true;
    return false;
  }

  final private boolean jj_3R_108() {
    if (jj_scan_token(JAVANEW)) return true;
    return false;
  }

  final private boolean jj_3R_224() {
    if (jj_scan_token(NEW)) return true;
    if (jj_3R_275()) return true;
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_365()) {
    jj_scanpos = xsp;
    if (jj_3R_366()) {
    jj_scanpos = xsp;
    if (jj_3R_367()) {
    jj_scanpos = xsp;
    if (jj_3R_368()) return true;
    }
    }
    }
    return false;
  }

  final private boolean jj_3R_437() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_536()) jj_scanpos = xsp;
    return false;
  }

  final private boolean jj_3R_875() {
    if (jj_scan_token(COMMA)) return true;
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_895()) {
    jj_scanpos = xsp;
    if (jj_3R_896()) return true;
    }
    return false;
  }

  final private boolean jj_3R_535() {
    if (jj_scan_token(LBRACKET)) return true;
    if (jj_3R_130()) return true;
    if (jj_scan_token(RBRACKET)) return true;
    return false;
  }

  final private boolean jj_3R_436() {
    if (jj_3R_294()) return true;
    return false;
  }

  final private boolean jj_3R_714() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_scan_token(13)) jj_scanpos = xsp;
    if (jj_3R_104()) return true;
    return false;
  }

  final private boolean jj_3R_534() {
    if (jj_scan_token(LBRACKET)) return true;
    if (jj_scan_token(RBRACKET)) return true;
    return false;
  }

  final private boolean jj_3_20() {
    if (jj_3R_104()) return true;
    Token xsp;
    while (true) {
      xsp = jj_scanpos;
      if (jj_3R_105()) { jj_scanpos = xsp; break; }
    }
    if (jj_scan_token(LBRACE)) return true;
    return false;
  }

  final private boolean jj_3R_435() {
    Token xsp;
    if (jj_3R_535()) return true;
    while (true) {
      xsp = jj_scanpos;
      if (jj_3R_535()) { jj_scanpos = xsp; break; }
    }
    return false;
  }

  final private boolean jj_3R_713() {
    if (jj_scan_token(STRING_LITERAL)) return true;
    return false;
  }

  final private boolean jj_3R_667() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_713()) {
    jj_scanpos = xsp;
    if (jj_3R_714()) return true;
    }
    while (true) {
      xsp = jj_scanpos;
      if (jj_3R_875()) { jj_scanpos = xsp; break; }
    }
    return false;
  }

  final private boolean jj_3R_434() {
    Token xsp;
    if (jj_3R_534()) return true;
    while (true) {
      xsp = jj_scanpos;
      if (jj_3R_534()) { jj_scanpos = xsp; break; }
    }
    if (jj_3R_439()) return true;
    return false;
  }

  final private boolean jj_3R_666() {
    if (jj_3R_294()) return true;
    return false;
  }

  final private boolean jj_3R_221() {
    if (jj_scan_token(COLON)) return true;
    if (jj_3R_88()) return true;
    return false;
  }

  final private boolean jj_3R_665() {
    if (jj_scan_token(LT)) return true;
    if (jj_3R_88()) return true;
    if (jj_scan_token(GT)) return true;
    return false;
  }

  final private boolean jj_3R_220() {
    if (jj_3R_266()) return true;
    return false;
  }

  final private boolean jj_3R_110() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_220()) {
    jj_scanpos = xsp;
    if (jj_3R_221()) return true;
    }
    xsp = jj_scanpos;
    if (jj_3R_434()) {
    jj_scanpos = xsp;
    if (jj_3R_435()) {
    jj_scanpos = xsp;
    if (jj_3R_436()) {
    jj_scanpos = xsp;
    if (jj_3R_437()) return true;
    }
    }
    }
    return false;
  }

  final private boolean jj_3R_571() {
    if (jj_scan_token(HIB__SETUP)) return true;
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_665()) jj_scanpos = xsp;
    xsp = jj_scanpos;
    if (jj_3R_666()) jj_scanpos = xsp;
    xsp = jj_scanpos;
    if (jj_3R_667()) jj_scanpos = xsp;
    if (jj_scan_token(SEMICOLON)) return true;
    return false;
  }

  final private boolean jj_3R_109() {
    if (jj_3R_94()) return true;
    return false;
  }

  final private boolean jj_3R_107() {
    if (jj_scan_token(NEW)) return true;
    if (jj_scan_token(JAVA__)) return true;
    return false;
  }

  final private boolean jj_3_23() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_107()) {
    jj_scanpos = xsp;
    if (jj_3R_108()) return true;
    }
    xsp = jj_scanpos;
    if (jj_3R_109()) {
    jj_scanpos = xsp;
    if (jj_3R_110()) return true;
    }
    return false;
  }

  final private boolean jj_3R_117() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3_23()) {
    jj_scanpos = xsp;
    if (jj_3R_224()) return true;
    }
    return false;
  }

  final private boolean jj_3R_488() {
    if (jj_3R_572()) return true;
    return false;
  }

  final private boolean jj_3R_487() {
    if (jj_3R_571()) return true;
    return false;
  }

  final private boolean jj_3R_418() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_487()) {
    jj_scanpos = xsp;
    if (jj_3R_488()) return true;
    }
    return false;
  }

  final private boolean jj_3_17() {
    if (jj_scan_token(LBRACKET)) return true;
    if (jj_scan_token(RBRACKET)) return true;
    return false;
  }

  final private boolean jj_3R_446() {
    if (jj_3R_128()) return true;
    return false;
  }

  final private boolean jj_3R_445() {
    if (jj_scan_token(LBRACKET)) return true;
    if (jj_3R_130()) return true;
    if (jj_scan_token(RBRACKET)) return true;
    return false;
  }

  final private boolean jj_3R_372() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_446()) jj_scanpos = xsp;
    return false;
  }

  final private boolean jj_3R_371() {
    Token xsp;
    if (jj_3R_445()) return true;
    while (true) {
      xsp = jj_scanpos;
      if (jj_3R_445()) { jj_scanpos = xsp; break; }
    }
    return false;
  }

  final private boolean jj_3R_444() {
    if (jj_scan_token(LBRACKET)) return true;
    if (jj_scan_token(RBRACKET)) return true;
    return false;
  }

  final private boolean jj_3R_829() {
    if (jj_scan_token(ASSIGN)) return true;
    if (jj_3R_318()) return true;
    return false;
  }

  final private boolean jj_3R_370() {
    Token xsp;
    if (jj_3R_444()) return true;
    while (true) {
      xsp = jj_scanpos;
      if (jj_3R_444()) { jj_scanpos = xsp; break; }
    }
    if (jj_3R_439()) return true;
    return false;
  }

  final private boolean jj_3R_278() {
    if (jj_scan_token(COLON)) return true;
    if (jj_3R_88()) return true;
    return false;
  }

  final private boolean jj_3R_102() {
    if (jj_3R_104()) return true;
    return false;
  }

  final private boolean jj_3_16() {
    if (jj_scan_token(LPAREN)) return true;
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_102()) {
    jj_scanpos = xsp;
    if (jj_scan_token(235)) return true;
    }
    xsp = jj_scanpos;
    if (jj_scan_token(248)) {
    jj_scanpos = xsp;
    if (jj_scan_token(260)) return true;
    }
    return false;
  }

  final private boolean jj_3R_277() {
    if (jj_scan_token(CONST_NAME)) return true;
    return false;
  }

  final private boolean jj_3R_226() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_277()) {
    jj_scanpos = xsp;
    if (jj_3R_278()) return true;
    }
    xsp = jj_scanpos;
    if (jj_3R_370()) {
    jj_scanpos = xsp;
    if (jj_3R_371()) {
    jj_scanpos = xsp;
    if (jj_3R_372()) return true;
    }
    }
    return false;
  }

  final private boolean jj_3R_443() {
    if (jj_3R_128()) return true;
    return false;
  }

  final private boolean jj_3R_369() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_442()) {
    jj_scanpos = xsp;
    if (jj_3R_443()) return true;
    }
    return false;
  }

  final private boolean jj_3R_442() {
    if (jj_3R_294()) return true;
    return false;
  }

  final private boolean jj_3R_929() {
    if (jj_3R_248()) return true;
    return false;
  }

  final private boolean jj_3R_276() {
    if (jj_3R_88()) return true;
    return false;
  }

  final private boolean jj_3_15() {
    if (jj_3R_89()) return true;
    if (jj_3R_90()) return true;
    return false;
  }

  final private boolean jj_3R_225() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3_15()) {
    jj_scanpos = xsp;
    if (jj_3R_276()) return true;
    }
    xsp = jj_scanpos;
    if (jj_3R_369()) jj_scanpos = xsp;
    return false;
  }

  final private boolean jj_3R_118() {
    if (jj_scan_token(NEW)) return true;
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_225()) {
    jj_scanpos = xsp;
    if (jj_3R_226()) return true;
    }
    return false;
  }

  final private boolean jj_3R_928() {
    if (jj_3R_130()) return true;
    return false;
  }

  final private boolean jj_3R_930() {
    if (jj_scan_token(LPAREN)) return true;
    if (jj_3R_130()) return true;
    if (jj_scan_token(RPAREN)) return true;
    return false;
  }

  final private boolean jj_3R_500() {
    if (jj_scan_token(TWOWAYARROW)) return true;
    if (jj_3R_98()) return true;
    return false;
  }

  final private boolean jj_3R_499() {
    if (jj_scan_token(ARROW)) return true;
    if (jj_3R_98()) return true;
    return false;
  }

  final private boolean jj_3_14() {
    if (jj_scan_token(COMMA)) return true;
    if (jj_3R_101()) return true;
    return false;
  }

  final private boolean jj_3R_927() {
    if (jj_scan_token(IDENTIFIER)) return true;
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_930()) jj_scanpos = xsp;
    return false;
  }

  final private boolean jj_3R_430() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_499()) {
    jj_scanpos = xsp;
    if (jj_3R_500()) return true;
    }
    return false;
  }

  final private boolean jj_3R_429() {
    if (jj_scan_token(ASSIGN)) return true;
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_928()) {
    jj_scanpos = xsp;
    if (jj_3R_929()) return true;
    }
    return false;
  }

  final private boolean jj_3R_926() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_scan_token(94)) {
    jj_scanpos = xsp;
    if (jj_scan_token(95)) {
    jj_scanpos = xsp;
    if (jj_scan_token(96)) {
    jj_scanpos = xsp;
    if (jj_scan_token(97)) {
    jj_scanpos = xsp;
    if (jj_scan_token(98)) {
    jj_scanpos = xsp;
    if (jj_scan_token(99)) {
    jj_scanpos = xsp;
    if (jj_scan_token(100)) {
    jj_scanpos = xsp;
    if (jj_scan_token(101)) {
    jj_scanpos = xsp;
    if (jj_scan_token(122)) {
    jj_scanpos = xsp;
    if (jj_scan_token(121)) {
    jj_scanpos = xsp;
    if (jj_scan_token(124)) {
    jj_scanpos = xsp;
    if (jj_scan_token(123)) {
    jj_scanpos = xsp;
    if (jj_scan_token(103)) {
    jj_scanpos = xsp;
    if (jj_scan_token(102)) return true;
    }
    }
    }
    }
    }
    }
    }
    }
    }
    }
    }
    }
    }
    return false;
  }

  final private boolean jj_3R_428() {
    if (jj_scan_token(COLON)) return true;
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_926()) {
    jj_scanpos = xsp;
    if (jj_3R_927()) return true;
    }
    return false;
  }

  final private boolean jj_3R_364() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_428()) jj_scanpos = xsp;
    xsp = jj_scanpos;
    if (jj_3R_429()) {
    jj_scanpos = xsp;
    if (jj_3R_430()) return true;
    }
    return false;
  }

  final private boolean jj_3R_261() {
    if (jj_scan_token(COMMA)) return true;
    if (jj_3R_260()) return true;
    return false;
  }

  final private boolean jj_3R_101() {
    if (jj_scan_token(IDENTIFIER)) return true;
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_829()) jj_scanpos = xsp;
    return false;
  }

  final private boolean jj_3R_362() {
    if (jj_3R_88()) return true;
    return false;
  }

  final private boolean jj_3R_297() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_363()) {
    jj_scanpos = xsp;
    if (jj_3R_364()) return true;
    }
    return false;
  }

  final private boolean jj_3R_363() {
    if (jj_scan_token(DOT)) return true;
    if (jj_3R_88()) return true;
    if (jj_3R_128()) return true;
    return false;
  }

  final private boolean jj_3R_296() {
    if (jj_3R_88()) return true;
    return false;
  }

  final private boolean jj_3R_361() {
    if (jj_scan_token(INTEGER_LITERAL)) return true;
    return false;
  }

  final private boolean jj_3R_798() {
    if (jj_scan_token(COMMA)) return true;
    if (jj_scan_token(IDENTIFIER)) return true;
    return false;
  }

  final private boolean jj_3R_295() {
    if (jj_scan_token(ATSIGN)) return true;
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_361()) {
    jj_scanpos = xsp;
    if (jj_3R_362()) return true;
    }
    return false;
  }

  final private boolean jj_3R_502() {
    if (jj_scan_token(LPAREN)) return true;
    if (jj_scan_token(IDENTIFIER)) return true;
    Token xsp;
    while (true) {
      xsp = jj_scanpos;
      if (jj_3R_798()) { jj_scanpos = xsp; break; }
    }
    if (jj_scan_token(RPAREN)) return true;
    if (jj_scan_token(ASSIGN)) return true;
    if (jj_3R_318()) return true;
    return false;
  }

  final private boolean jj_3R_260() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_295()) {
    jj_scanpos = xsp;
    if (jj_3R_296()) return true;
    }
    xsp = jj_scanpos;
    if (jj_3R_297()) jj_scanpos = xsp;
    return false;
  }

  final private boolean jj_3R_501() {
    if (jj_3R_101()) return true;
    Token xsp;
    while (true) {
      xsp = jj_scanpos;
      if (jj_3_14()) { jj_scanpos = xsp; break; }
    }
    return false;
  }

  final private boolean jj_3R_402() {
    if (jj_3R_468()) return true;
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_501()) {
    jj_scanpos = xsp;
    if (jj_3R_502()) return true;
    }
    if (jj_scan_token(SEMICOLON)) return true;
    return false;
  }

  final private boolean jj_3R_708() {
    if (jj_3R_164()) return true;
    return false;
  }

  final private boolean jj_3_13() {
    if (jj_scan_token(LPAREN)) return true;
    if (jj_3R_100()) return true;
    if (jj_scan_token(RPAREN)) return true;
    return false;
  }

  final private boolean jj_3R_286() {
    if (jj_scan_token(ATSIGN)) return true;
    if (jj_3R_285()) return true;
    return false;
  }

  final private boolean jj_3R_164() {
    if (jj_scan_token(WITH)) return true;
    if (jj_3R_260()) return true;
    Token xsp;
    while (true) {
      xsp = jj_scanpos;
      if (jj_3R_261()) { jj_scanpos = xsp; break; }
    }
    return false;
  }

  final private boolean jj_3R_643() {
    if (jj_scan_token(EXECUTEBATCH)) return true;
    return false;
  }

  final private boolean jj_3R_284() {
    if (jj_3R_98()) return true;
    if (jj_3R_99()) return true;
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3_13()) jj_scanpos = xsp;
    if (jj_3R_318()) return true;
    return false;
  }

  final private boolean jj_3R_734() {
    if (jj_scan_token(LT)) return true;
    if (jj_3R_98()) return true;
    if (jj_scan_token(GT)) return true;
    return false;
  }

  final private boolean jj_3R_663() {
    if (jj_3R_248()) return true;
    return false;
  }

  final private boolean jj_3R_733() {
    if (jj_3R_730()) return true;
    if (jj_3R_88()) return true;
    return false;
  }

  final private boolean jj_3R_709() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_733()) {
    jj_scanpos = xsp;
    if (jj_3R_734()) return true;
    }
    return false;
  }

  final private boolean jj_3R_758() {
    if (jj_scan_token(COMMA)) return true;
    if (jj_scan_token(IDENTIFIER)) return true;
    return false;
  }

  final private boolean jj_3R_660() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_709()) jj_scanpos = xsp;
    if (jj_3R_710()) return true;
    return false;
  }

  final private boolean jj_3R_659() {
    if (jj_scan_token(IDENTIFIER)) return true;
    return false;
  }

  final private boolean jj_3_12() {
    if (jj_3R_98()) return true;
    if (jj_3R_99()) return true;
    return false;
  }

  final private boolean jj_3R_644() {
    if (jj_scan_token(EXECUTEANY)) return true;
    return false;
  }

  final private boolean jj_3R_567() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_scan_token(174)) {
    jj_scanpos = xsp;
    if (jj_3R_643()) return true;
    }
    xsp = jj_scanpos;
    if (jj_3R_659()) {
    jj_scanpos = xsp;
    if (jj_3R_660()) return true;
    }
    return false;
  }

  final private boolean jj_3R_403() {
    if (jj_scan_token(LPAREN)) return true;
    if (jj_scan_token(IDENTIFIER)) return true;
    Token xsp;
    while (true) {
      xsp = jj_scanpos;
      if (jj_3R_758()) { jj_scanpos = xsp; break; }
    }
    if (jj_scan_token(RPAREN)) return true;
    if (jj_scan_token(ASSIGN)) return true;
    if (jj_3R_318()) return true;
    if (jj_scan_token(SEMICOLON)) return true;
    return false;
  }

  final private boolean jj_3R_662() {
    if (jj_3R_130()) return true;
    return false;
  }

  final private boolean jj_3R_240() {
    if (jj_3R_285()) return true;
    Token xsp;
    while (true) {
      xsp = jj_scanpos;
      if (jj_3R_286()) { jj_scanpos = xsp; break; }
    }
    return false;
  }

  final private boolean jj_3R_712() {
    if (jj_scan_token(LT)) return true;
    if (jj_3R_98()) return true;
    if (jj_scan_token(GT)) return true;
    return false;
  }

  final private boolean jj_3R_239() {
    if (jj_3R_284()) return true;
    return false;
  }

  final private boolean jj_3R_711() {
    if (jj_3R_730()) return true;
    if (jj_3R_88()) return true;
    return false;
  }

  final private boolean jj_3R_661() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_711()) {
    jj_scanpos = xsp;
    if (jj_3R_712()) return true;
    }
    return false;
  }

  final private boolean jj_3R_238() {
    if (jj_scan_token(EXEC_RESULTLINES_LITERAL)) return true;
    return false;
  }

  final private boolean jj_3R_237() {
    if (jj_scan_token(EXEC_RESULT_LITERAL)) return true;
    return false;
  }

  final private boolean jj_3R_236() {
    if (jj_scan_token(ATTRIBUTESOF)) return true;
    if (jj_3R_130()) return true;
    return false;
  }

  final private boolean jj_3R_568() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_scan_token(177)) {
    jj_scanpos = xsp;
    if (jj_3R_644()) return true;
    }
    xsp = jj_scanpos;
    if (jj_3R_661()) jj_scanpos = xsp;
    xsp = jj_scanpos;
    if (jj_3R_662()) {
    jj_scanpos = xsp;
    if (jj_3R_663()) return true;
    }
    if (jj_scan_token(SEMICOLON)) return true;
    return false;
  }

  final private boolean jj_3R_235() {
    if (jj_scan_token(TYPEOF)) return true;
    if (jj_3R_130()) return true;
    return false;
  }

  final private boolean jj_3R_130() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_234()) {
    jj_scanpos = xsp;
    if (jj_3R_235()) {
    jj_scanpos = xsp;
    if (jj_3R_236()) {
    jj_scanpos = xsp;
    if (jj_3R_237()) {
    jj_scanpos = xsp;
    if (jj_3R_238()) {
    jj_scanpos = xsp;
    if (jj_3R_239()) {
    jj_scanpos = xsp;
    if (jj_3R_240()) return true;
    }
    }
    }
    }
    }
    }
    return false;
  }

  final private boolean jj_3R_234() {
    if (jj_scan_token(DEFINED)) return true;
    if (jj_3R_130()) return true;
    return false;
  }

  final private boolean jj_3R_703() {
    if (jj_3R_164()) return true;
    return false;
  }

  final private boolean jj_3R_707() {
    if (jj_3R_119()) return true;
    return false;
  }

  final private boolean jj_3R_658() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_707()) jj_scanpos = xsp;
    xsp = jj_scanpos;
    if (jj_3R_708()) jj_scanpos = xsp;
    if (jj_scan_token(SEMICOLON)) return true;
    return false;
  }

  final private boolean jj_3R_358() {
    if (jj_scan_token(COMMA)) return true;
    if (jj_scan_token(DOTDOT)) return true;
    return false;
  }

  final private boolean jj_3_11() {
    if (jj_scan_token(COMMA)) return true;
    if (jj_scan_token(IDENTIFIER)) return true;
    return false;
  }

  final private boolean jj_3_83() {
    if (jj_3R_164()) return true;
    if (jj_scan_token(SEMICOLON)) return true;
    return false;
  }

  final private boolean jj_3_85() {
    if (jj_3R_164()) return true;
    if (jj_scan_token(SEMICOLON)) return true;
    return false;
  }

  final private boolean jj_3R_289() {
    if (jj_scan_token(IDENTIFIER)) return true;
    Token xsp;
    while (true) {
      xsp = jj_scanpos;
      if (jj_3_11()) { jj_scanpos = xsp; break; }
    }
    xsp = jj_scanpos;
    if (jj_3R_358()) jj_scanpos = xsp;
    return false;
  }

  final private boolean jj_3R_706() {
    if (jj_scan_token(COLON)) return true;
    if (jj_3R_848()) return true;
    return false;
  }

  final private boolean jj_3R_246() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_289()) jj_scanpos = xsp;
    return false;
  }

  final private boolean jj_3R_317() {
    if (jj_scan_token(RPAREN)) return true;
    return false;
  }

  final private boolean jj_3R_705() {
    if (jj_3R_710()) return true;
    return false;
  }

  final private boolean jj_3R_245() {
    if (jj_scan_token(DOTDOT)) return true;
    return false;
  }

  final private boolean jj_3R_732() {
    if (jj_scan_token(LT)) return true;
    if (jj_3R_98()) return true;
    if (jj_scan_token(GT)) return true;
    return false;
  }

  final private boolean jj_3R_620() {
    if (jj_3R_145()) return true;
    return false;
  }

  final private boolean jj_3R_150() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_245()) {
    jj_scanpos = xsp;
    if (jj_3R_246()) return true;
    }
    return false;
  }

  final private boolean jj_3R_731() {
    if (jj_3R_730()) return true;
    if (jj_3R_88()) return true;
    return false;
  }

  final private boolean jj_3R_704() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_731()) {
    jj_scanpos = xsp;
    if (jj_3R_732()) return true;
    }
    return false;
  }

  final private boolean jj_3R_657() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_704()) jj_scanpos = xsp;
    xsp = jj_scanpos;
    if (jj_3R_705()) {
    jj_scanpos = xsp;
    if (jj_3R_706()) return true;
    }
    return false;
  }

  final private boolean jj_3R_642() {
    if (jj_scan_token(PREPAREDEXECUTECALL)) return true;
    return false;
  }

  final private boolean jj_3R_641() {
    if (jj_scan_token(PREPAREDEXECUTE)) return true;
    return false;
  }

  final private boolean jj_3R_640() {
    if (jj_scan_token(EXECUTESQL)) return true;
    return false;
  }

  final private boolean jj_3R_639() {
    if (jj_scan_token(DB__CALL)) return true;
    return false;
  }

  final private boolean jj_3R_752() {
    if (jj_scan_token(COMMA)) return true;
    if (jj_scan_token(DOTDOT)) return true;
    return false;
  }

  final private boolean jj_3R_566() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_scan_token(178)) {
    jj_scanpos = xsp;
    if (jj_3R_639()) {
    jj_scanpos = xsp;
    if (jj_3R_640()) {
    jj_scanpos = xsp;
    if (jj_3R_641()) {
    jj_scanpos = xsp;
    if (jj_3R_642()) return true;
    }
    }
    }
    }
    xsp = jj_scanpos;
    if (jj_3R_657()) {
    jj_scanpos = xsp;
    if (jj_3R_658()) return true;
    }
    return false;
  }

  final private boolean jj_3R_792() {
    if (jj_scan_token(ASSIGN)) return true;
    if (jj_3R_318()) return true;
    return false;
  }

  final private boolean jj_3R_165() {
    if (jj_3R_119()) return true;
    return false;
  }

  final private boolean jj_3_84() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_165()) jj_scanpos = xsp;
    xsp = jj_scanpos;
    if (jj_scan_token(93)) {
    jj_scanpos = xsp;
    if (jj_scan_token(313)) return true;
    }
    return false;
  }

  final private boolean jj_3_10() {
    if (jj_scan_token(COMMA)) return true;
    if (jj_scan_token(IDENTIFIER)) return true;
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_792()) jj_scanpos = xsp;
    return false;
  }

  final private boolean jj_3R_751() {
    if (jj_scan_token(ASSIGN)) return true;
    if (jj_3R_318()) return true;
    return false;
  }

  final private boolean jj_3R_702() {
    if (jj_3R_119()) return true;
    return false;
  }

  final private boolean jj_3R_656() {
    if (jj_3R_652()) return true;
    return false;
  }

  final private boolean jj_3R_655() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_702()) jj_scanpos = xsp;
    xsp = jj_scanpos;
    if (jj_3R_703()) jj_scanpos = xsp;
    if (jj_scan_token(SEMICOLON)) return true;
    return false;
  }

  final private boolean jj_3R_460() {
    if (jj_scan_token(IDENTIFIER)) return true;
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_751()) jj_scanpos = xsp;
    while (true) {
      xsp = jj_scanpos;
      if (jj_3_10()) { jj_scanpos = xsp; break; }
    }
    xsp = jj_scanpos;
    if (jj_3R_752()) jj_scanpos = xsp;
    return false;
  }

  final private boolean jj_3R_638() {
    if (jj_scan_token(PREPAREDEXECUTECALLUPDATE)) return true;
    return false;
  }

  final private boolean jj_3R_386() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_460()) jj_scanpos = xsp;
    return false;
  }

  final private boolean jj_3R_637() {
    if (jj_scan_token(PREPAREDEXECUTEUPDATE)) return true;
    return false;
  }

  final private boolean jj_3R_385() {
    if (jj_scan_token(DOTDOT)) return true;
    return false;
  }

  final private boolean jj_3R_636() {
    if (jj_scan_token(EXECUTEUPDATECALL)) return true;
    return false;
  }

  final private boolean jj_3R_635() {
    if (jj_scan_token(EXECUTEUPDATE)) return true;
    return false;
  }

  final private boolean jj_3R_316() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_385()) {
    jj_scanpos = xsp;
    if (jj_3R_386()) return true;
    }
    return false;
  }

  final private boolean jj_3R_565() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_scan_token(180)) {
    jj_scanpos = xsp;
    if (jj_scan_token(181)) {
    jj_scanpos = xsp;
    if (jj_3R_635()) {
    jj_scanpos = xsp;
    if (jj_3R_636()) {
    jj_scanpos = xsp;
    if (jj_3R_637()) {
    jj_scanpos = xsp;
    if (jj_3R_638()) return true;
    }
    }
    }
    }
    }
    xsp = jj_scanpos;
    if (jj_3R_655()) {
    jj_scanpos = xsp;
    if (jj_3R_656()) return true;
    }
    return false;
  }

  final private boolean jj_3R_622() {
    if (jj_scan_token(LPAREN)) return true;
    if (jj_3R_316()) return true;
    if (jj_scan_token(RPAREN)) return true;
    return false;
  }

  final private boolean jj_3R_621() {
    if (jj_3R_145()) return true;
    return false;
  }

  final private boolean jj_3R_126() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_231()) {
    jj_scanpos = xsp;
    if (jj_scan_token(173)) {
    jj_scanpos = xsp;
    if (jj_scan_token(186)) {
    jj_scanpos = xsp;
    if (jj_scan_token(187)) {
    jj_scanpos = xsp;
    if (jj_scan_token(188)) {
    jj_scanpos = xsp;
    if (jj_scan_token(195)) {
    jj_scanpos = xsp;
    if (jj_scan_token(192)) {
    jj_scanpos = xsp;
    if (jj_scan_token(197)) {
    jj_scanpos = xsp;
    if (jj_scan_token(198)) {
    jj_scanpos = xsp;
    if (jj_scan_token(191)) {
    jj_scanpos = xsp;
    if (jj_scan_token(189)) {
    jj_scanpos = xsp;
    if (jj_scan_token(190)) {
    jj_scanpos = xsp;
    if (jj_scan_token(199)) {
    jj_scanpos = xsp;
    if (jj_scan_token(200)) {
    jj_scanpos = xsp;
    if (jj_scan_token(196)) {
    jj_scanpos = xsp;
    if (jj_scan_token(106)) {
    jj_scanpos = xsp;
    if (jj_scan_token(107)) return true;
    }
    }
    }
    }
    }
    }
    }
    }
    }
    }
    }
    }
    }
    }
    }
    }
    return false;
  }

  final private boolean jj_3R_231() {
    if (jj_3R_119()) return true;
    return false;
  }

  final private boolean jj_3R_162() {
    if (jj_3R_164()) return true;
    Token xsp;
    xsp = jj_scanpos;
    if (jj_scan_token(313)) {
    jj_scanpos = xsp;
    if (jj_3R_258()) return true;
    }
    return false;
  }

  final private boolean jj_3R_258() {
    if (jj_3R_259()) return true;
    return false;
  }

  final private boolean jj_3R_315() {
    if (jj_scan_token(LPAREN)) return true;
    return false;
  }

  final private boolean jj_3R_281() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_315()) jj_scanpos = xsp;
    if (jj_3R_316()) return true;
    xsp = jj_scanpos;
    if (jj_3R_317()) jj_scanpos = xsp;
    return false;
  }

  final private boolean jj_3R_163() {
    if (jj_3R_259()) return true;
    return false;
  }

  final private boolean jj_3R_701() {
    if (jj_3R_259()) return true;
    return false;
  }

  final private boolean jj_3_82() {
    if (jj_3R_119()) return true;
    Token xsp;
    xsp = jj_scanpos;
    if (jj_scan_token(93)) {
    jj_scanpos = xsp;
    if (jj_scan_token(313)) return true;
    }
    return false;
  }

  final private boolean jj_3_81() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_162()) {
    jj_scanpos = xsp;
    if (jj_3R_163()) return true;
    }
    return false;
  }

  final private boolean jj_3R_97() {
    if (jj_scan_token(IDENTIFIER)) return true;
    return false;
  }

  final private boolean jj_3R_700() {
    if (jj_3R_164()) return true;
    return false;
  }

  final private boolean jj_3R_654() {
    if (jj_3R_652()) return true;
    return false;
  }

  final private boolean jj_3R_699() {
    if (jj_3R_119()) return true;
    return false;
  }

  final private boolean jj_3R_653() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_699()) jj_scanpos = xsp;
    xsp = jj_scanpos;
    if (jj_3R_700()) jj_scanpos = xsp;
    xsp = jj_scanpos;
    if (jj_scan_token(313)) {
    jj_scanpos = xsp;
    if (jj_3R_701()) return true;
    }
    return false;
  }

  final private boolean jj_3R_756() {
    if (jj_scan_token(LPAREN)) return true;
    if (jj_scan_token(RPAREN)) return true;
    return false;
  }

  final private boolean jj_3R_634() {
    if (jj_scan_token(PREPAREDEXECUTECALLQUERY)) return true;
    return false;
  }

  final private boolean jj_3R_633() {
    if (jj_scan_token(PREPAREDEXECUTEQUERY)) return true;
    return false;
  }

  final private boolean jj_3R_632() {
    if (jj_scan_token(EXECUTEQUERYCALL)) return true;
    return false;
  }

  final private boolean jj_3R_631() {
    if (jj_scan_token(EXECUTEQUERY)) return true;
    return false;
  }

  final private boolean jj_3R_630() {
    if (jj_scan_token(DB__QUERYCALL)) return true;
    return false;
  }

  final private boolean jj_3R_564() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_scan_token(175)) {
    jj_scanpos = xsp;
    if (jj_3R_630()) {
    jj_scanpos = xsp;
    if (jj_3R_631()) {
    jj_scanpos = xsp;
    if (jj_3R_632()) {
    jj_scanpos = xsp;
    if (jj_3R_633()) {
    jj_scanpos = xsp;
    if (jj_3R_634()) return true;
    }
    }
    }
    }
    }
    xsp = jj_scanpos;
    if (jj_3R_653()) {
    jj_scanpos = xsp;
    if (jj_3R_654()) return true;
    }
    return false;
  }

  final private boolean jj_3R_554() {
    if (jj_scan_token(FINALLY)) return true;
    if (jj_scan_token(COLON)) return true;
    Token xsp;
    if (jj_3R_621()) return true;
    while (true) {
      xsp = jj_scanpos;
      if (jj_3R_621()) { jj_scanpos = xsp; break; }
    }
    return false;
  }

  final private boolean jj_3_9() {
    if (jj_scan_token(CATCH)) return true;
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_97()) jj_scanpos = xsp;
    if (jj_scan_token(COLON)) return true;
    if (jj_3R_620()) return true;
    while (true) {
      xsp = jj_scanpos;
      if (jj_3R_620()) { jj_scanpos = xsp; break; }
    }
    return false;
  }

  final private boolean jj_3R_553() {
    if (jj_3R_145()) return true;
    return false;
  }

  final private boolean jj_3R_850() {
    if (jj_scan_token(WHERE)) return true;
    if (jj_3R_848()) return true;
    return false;
  }

  final private boolean jj_3R_874() {
    if (jj_3R_148()) return true;
    if (jj_3R_130()) return true;
    return false;
  }

  final private boolean jj_3R_873() {
    if (jj_scan_token(LIMIT)) return true;
    if (jj_3R_130()) return true;
    return false;
  }

  final private boolean jj_3R_461() {
    if (jj_scan_token(LBRACE)) return true;
    if (jj_3R_150()) return true;
    if (jj_scan_token(BIT_OR)) return true;
    Token xsp;
    while (true) {
      xsp = jj_scanpos;
      if (jj_3R_553()) { jj_scanpos = xsp; break; }
    }
    xsp = jj_scanpos;
    if (jj_3_9()) jj_scanpos = xsp;
    xsp = jj_scanpos;
    if (jj_3R_554()) jj_scanpos = xsp;
    if (jj_scan_token(RBRACE)) return true;
    return false;
  }

  final private boolean jj_3R_872() {
    if (jj_scan_token(INTO)) return true;
    if (jj_3R_130()) return true;
    return false;
  }

  final private boolean jj_3R_871() {
    if (jj_3R_730()) return true;
    if (jj_3R_88()) return true;
    return false;
  }

  final private boolean jj_3R_849() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_871()) {
    jj_scanpos = xsp;
    if (jj_3R_872()) {
    jj_scanpos = xsp;
    if (jj_3R_873()) {
    jj_scanpos = xsp;
    if (jj_3R_874()) return true;
    }
    }
    }
    return false;
  }

  final private boolean jj_3R_172() {
    if (jj_3R_265()) return true;
    return false;
  }

  final private boolean jj_3R_88() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_172()) {
    jj_scanpos = xsp;
    if (jj_scan_token(49)) {
    jj_scanpos = xsp;
    if (jj_scan_token(20)) {
    jj_scanpos = xsp;
    if (jj_scan_token(21)) {
    jj_scanpos = xsp;
    if (jj_scan_token(22)) {
    jj_scanpos = xsp;
    if (jj_scan_token(28)) {
    jj_scanpos = xsp;
    if (jj_scan_token(23)) {
    jj_scanpos = xsp;
    if (jj_scan_token(24)) {
    jj_scanpos = xsp;
    if (jj_scan_token(25)) {
    jj_scanpos = xsp;
    if (jj_scan_token(26)) {
    jj_scanpos = xsp;
    if (jj_scan_token(27)) {
    jj_scanpos = xsp;
    if (jj_scan_token(31)) {
    jj_scanpos = xsp;
    if (jj_scan_token(33)) {
    jj_scanpos = xsp;
    if (jj_scan_token(35)) {
    jj_scanpos = xsp;
    if (jj_scan_token(37)) {
    jj_scanpos = xsp;
    if (jj_scan_token(38)) {
    jj_scanpos = xsp;
    if (jj_scan_token(39)) {
    jj_scanpos = xsp;
    if (jj_scan_token(43)) {
    jj_scanpos = xsp;
    if (jj_scan_token(45)) {
    jj_scanpos = xsp;
    if (jj_scan_token(55)) {
    jj_scanpos = xsp;
    if (jj_scan_token(59)) {
    jj_scanpos = xsp;
    if (jj_scan_token(72)) {
    jj_scanpos = xsp;
    if (jj_scan_token(74)) {
    jj_scanpos = xsp;
    if (jj_scan_token(75)) {
    jj_scanpos = xsp;
    if (jj_scan_token(76)) {
    jj_scanpos = xsp;
    if (jj_scan_token(77)) {
    jj_scanpos = xsp;
    if (jj_scan_token(84)) {
    jj_scanpos = xsp;
    if (jj_scan_token(85)) {
    jj_scanpos = xsp;
    if (jj_scan_token(92)) {
    jj_scanpos = xsp;
    if (jj_scan_token(94)) {
    jj_scanpos = xsp;
    if (jj_scan_token(95)) {
    jj_scanpos = xsp;
    if (jj_scan_token(96)) {
    jj_scanpos = xsp;
    if (jj_scan_token(97)) {
    jj_scanpos = xsp;
    if (jj_scan_token(98)) {
    jj_scanpos = xsp;
    if (jj_scan_token(99)) {
    jj_scanpos = xsp;
    if (jj_scan_token(100)) {
    jj_scanpos = xsp;
    if (jj_scan_token(101)) {
    jj_scanpos = xsp;
    if (jj_scan_token(104)) {
    jj_scanpos = xsp;
    if (jj_scan_token(40)) {
    jj_scanpos = xsp;
    if (jj_scan_token(78)) {
    jj_scanpos = xsp;
    if (jj_scan_token(79)) {
    jj_scanpos = xsp;
    if (jj_scan_token(83)) {
    jj_scanpos = xsp;
    if (jj_scan_token(82)) {
    jj_scanpos = xsp;
    if (jj_scan_token(57)) {
    jj_scanpos = xsp;
    if (jj_scan_token(58)) return true;
    }
    }
    }
    }
    }
    }
    }
    }
    }
    }
    }
    }
    }
    }
    }
    }
    }
    }
    }
    }
    }
    }
    }
    }
    }
    }
    }
    }
    }
    }
    }
    }
    }
    }
    }
    }
    }
    }
    }
    }
    }
    }
    }
    }
    return false;
  }

  final private boolean jj_3R_645() {
    if (jj_scan_token(ADDBATCH)) return true;
    return false;
  }

  final private boolean jj_3R_664() {
    if (jj_scan_token(LT)) return true;
    if (jj_3R_98()) return true;
    if (jj_scan_token(GT)) return true;
    return false;
  }

  final private boolean jj_3R_555() {
    if (jj_scan_token(LAMBDA)) return true;
    return false;
  }

  final private boolean jj_3R_570() {
    if (jj_scan_token(DB__DUMPTABLE)) return true;
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_664()) jj_scanpos = xsp;
    if (jj_3R_130()) return true;
    while (true) {
      xsp = jj_scanpos;
      if (jj_3R_849()) { jj_scanpos = xsp; break; }
    }
    xsp = jj_scanpos;
    if (jj_scan_token(313)) {
    jj_scanpos = xsp;
    if (jj_3R_850()) return true;
    }
    return false;
  }

  final private boolean jj_3R_556() {
    if (jj_3R_622()) return true;
    return false;
  }

  final private boolean jj_3R_462() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_scan_token(41)) {
    jj_scanpos = xsp;
    if (jj_3R_555()) return true;
    }
    xsp = jj_scanpos;
    if (jj_3R_556()) jj_scanpos = xsp;
    if (jj_3R_124()) return true;
    return false;
  }

  final private boolean jj_3R_569() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_scan_token(171)) {
    jj_scanpos = xsp;
    if (jj_3R_645()) return true;
    }
    xsp = jj_scanpos;
    if (jj_scan_token(78)) jj_scanpos = xsp;
    if (jj_3R_119()) return true;
    if (jj_scan_token(COLON)) return true;
    if (jj_3R_848()) return true;
    return false;
  }

  final private boolean jj_3R_894() {
    if (jj_scan_token(COMMA)) return true;
    if (jj_3R_893()) return true;
    return false;
  }

  final private boolean jj_3R_755() {
    if (jj_scan_token(COLONCOLON)) return true;
    if (jj_3R_88()) return true;
    return false;
  }

  final private boolean jj_3R_793() {
    if (jj_3R_104()) return true;
    return false;
  }

  final private boolean jj_3_8() {
    if (jj_3R_96()) return true;
    return false;
  }

  final private boolean jj_3R_753() {
    if (jj_3R_104()) return true;
    Token xsp;
    xsp = jj_scanpos;
    if (jj_scan_token(248)) {
    jj_scanpos = xsp;
    if (jj_scan_token(260)) return true;
    }
    xsp = jj_scanpos;
    if (jj_3_8()) {
    jj_scanpos = xsp;
    if (jj_3R_793()) return true;
    }
    return false;
  }

  final private boolean jj_3R_893() {
    if (jj_scan_token(IDENTIFIER)) return true;
    if (jj_scan_token(ASSIGN)) return true;
    if (jj_3R_318()) return true;
    return false;
  }

  final private boolean jj_3R_698() {
    if (jj_3R_730()) return true;
    if (jj_3R_88()) return true;
    return false;
  }

  final private boolean jj_3R_754() {
    if (jj_scan_token(COMMA)) return true;
    if (jj_3R_753()) return true;
    return false;
  }

  final private boolean jj_3R_697() {
    if (jj_scan_token(LPAREN)) return true;
    if (jj_3R_893()) return true;
    Token xsp;
    while (true) {
      xsp = jj_scanpos;
      if (jj_3R_894()) { jj_scanpos = xsp; break; }
    }
    if (jj_scan_token(RPAREN)) return true;
    return false;
  }

  final private boolean jj_3R_696() {
    if (jj_3R_119()) return true;
    return false;
  }

  final private boolean jj_3R_695() {
    if (jj_scan_token(LT)) return true;
    if (jj_3R_98()) return true;
    if (jj_scan_token(GT)) return true;
    return false;
  }

  final private boolean jj_3R_652() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_695()) jj_scanpos = xsp;
    xsp = jj_scanpos;
    if (jj_3R_696()) jj_scanpos = xsp;
    xsp = jj_scanpos;
    if (jj_3R_697()) jj_scanpos = xsp;
    xsp = jj_scanpos;
    if (jj_3R_698()) jj_scanpos = xsp;
    if (jj_scan_token(COLON)) return true;
    if (jj_3R_848()) return true;
    return false;
  }

  final private boolean jj_3R_265() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_298()) {
    jj_scanpos = xsp;
    if (jj_scan_token(11)) {
    jj_scanpos = xsp;
    if (jj_scan_token(16)) {
    jj_scanpos = xsp;
    if (jj_scan_token(17)) {
    jj_scanpos = xsp;
    if (jj_scan_token(18)) {
    jj_scanpos = xsp;
    if (jj_scan_token(29)) {
    jj_scanpos = xsp;
    if (jj_scan_token(30)) {
    jj_scanpos = xsp;
    if (jj_scan_token(34)) {
    jj_scanpos = xsp;
    if (jj_scan_token(41)) {
    jj_scanpos = xsp;
    if (jj_scan_token(42)) {
    jj_scanpos = xsp;
    if (jj_scan_token(51)) {
    jj_scanpos = xsp;
    if (jj_scan_token(44)) {
    jj_scanpos = xsp;
    if (jj_scan_token(54)) {
    jj_scanpos = xsp;
    if (jj_scan_token(71)) {
    jj_scanpos = xsp;
    if (jj_scan_token(73)) {
    jj_scanpos = xsp;
    if (jj_scan_token(80)) {
    jj_scanpos = xsp;
    if (jj_scan_token(81)) {
    jj_scanpos = xsp;
    if (jj_scan_token(86)) {
    jj_scanpos = xsp;
    if (jj_scan_token(87)) {
    jj_scanpos = xsp;
    if (jj_scan_token(88)) {
    jj_scanpos = xsp;
    if (jj_scan_token(89)) {
    jj_scanpos = xsp;
    if (jj_scan_token(90)) {
    jj_scanpos = xsp;
    if (jj_scan_token(91)) {
    jj_scanpos = xsp;
    if (jj_scan_token(93)) {
    jj_scanpos = xsp;
    if (jj_scan_token(102)) {
    jj_scanpos = xsp;
    if (jj_scan_token(103)) {
    jj_scanpos = xsp;
    if (jj_scan_token(115)) {
    jj_scanpos = xsp;
    if (jj_scan_token(116)) {
    jj_scanpos = xsp;
    if (jj_scan_token(117)) {
    jj_scanpos = xsp;
    if (jj_scan_token(118)) {
    jj_scanpos = xsp;
    if (jj_scan_token(119)) {
    jj_scanpos = xsp;
    if (jj_scan_token(120)) {
    jj_scanpos = xsp;
    if (jj_scan_token(121)) {
    jj_scanpos = xsp;
    if (jj_scan_token(122)) {
    jj_scanpos = xsp;
    if (jj_scan_token(123)) {
    jj_scanpos = xsp;
    if (jj_scan_token(134)) {
    jj_scanpos = xsp;
    if (jj_scan_token(135)) {
    jj_scanpos = xsp;
    if (jj_scan_token(136)) {
    jj_scanpos = xsp;
    if (jj_scan_token(137)) {
    jj_scanpos = xsp;
    if (jj_scan_token(138)) {
    jj_scanpos = xsp;
    if (jj_scan_token(139)) {
    jj_scanpos = xsp;
    if (jj_scan_token(140)) {
    jj_scanpos = xsp;
    if (jj_scan_token(142)) {
    jj_scanpos = xsp;
    if (jj_scan_token(143)) {
    jj_scanpos = xsp;
    if (jj_scan_token(144)) {
    jj_scanpos = xsp;
    if (jj_scan_token(145)) {
    jj_scanpos = xsp;
    if (jj_scan_token(146)) {
    jj_scanpos = xsp;
    if (jj_scan_token(184)) {
    jj_scanpos = xsp;
    if (jj_scan_token(203)) {
    jj_scanpos = xsp;
    if (jj_scan_token(204)) {
    jj_scanpos = xsp;
    if (jj_scan_token(207)) {
    jj_scanpos = xsp;
    if (jj_scan_token(208)) {
    jj_scanpos = xsp;
    if (jj_scan_token(212)) {
    jj_scanpos = xsp;
    if (jj_scan_token(215)) {
    jj_scanpos = xsp;
    if (jj_scan_token(214)) {
    jj_scanpos = xsp;
    if (jj_scan_token(216)) return true;
    }
    }
    }
    }
    }
    }
    }
    }
    }
    }
    }
    }
    }
    }
    }
    }
    }
    }
    }
    }
    }
    }
    }
    }
    }
    }
    }
    }
    }
    }
    }
    }
    }
    }
    }
    }
    }
    }
    }
    }
    }
    }
    }
    }
    }
    }
    }
    }
    }
    }
    }
    }
    }
    }
    }
    return false;
  }

  final private boolean jj_3R_298() {
    if (jj_3R_119()) return true;
    return false;
  }

  final private boolean jj_3R_744() {
    if (jj_scan_token(FOR)) return true;
    Token xsp;
    xsp = jj_scanpos;
    if (jj_scan_token(13)) jj_scanpos = xsp;
    if (jj_3R_104()) return true;
    xsp = jj_scanpos;
    if (jj_3R_755()) jj_scanpos = xsp;
    xsp = jj_scanpos;
    if (jj_3R_756()) jj_scanpos = xsp;
    if (jj_scan_token(SEMICOLON)) return true;
    return false;
  }

  final private boolean jj_3_80() {
    if (jj_scan_token(ELSE)) return true;
    if (jj_3R_145()) return true;
    return false;
  }

  final private boolean jj_3R_743() {
    if (jj_3R_281()) return true;
    if (jj_3R_124()) return true;
    return false;
  }

  final private boolean jj_3R_259() {
    if (jj_scan_token(ONSUCCESS)) return true;
    if (jj_3R_145()) return true;
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3_80()) jj_scanpos = xsp;
    return false;
  }

  final private boolean jj_3R_174() {
    if (jj_scan_token(LT)) return true;
    if (jj_3R_753()) return true;
    Token xsp;
    while (true) {
      xsp = jj_scanpos;
      if (jj_3R_754()) { jj_scanpos = xsp; break; }
    }
    if (jj_scan_token(GT)) return true;
    return false;
  }

  final private boolean jj_3R_91() {
    if (jj_scan_token(FUNCTION)) return true;
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_174()) jj_scanpos = xsp;
    if (jj_3R_119()) return true;
    xsp = jj_scanpos;
    if (jj_3R_743()) {
    jj_scanpos = xsp;
    if (jj_3R_744()) return true;
    }
    return false;
  }

  final private boolean jj_3R_629() {
    if (jj_scan_token(PREPARECALL)) return true;
    return false;
  }

  final private boolean jj_3R_628() {
    if (jj_scan_token(PREPARE)) return true;
    return false;
  }

  final private boolean jj_3R_627() {
    if (jj_scan_token(DB__PREPARECALL)) return true;
    return false;
  }

  final private boolean jj_3R_563() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_scan_token(182)) {
    jj_scanpos = xsp;
    if (jj_3R_627()) {
    jj_scanpos = xsp;
    if (jj_3R_628()) {
    jj_scanpos = xsp;
    if (jj_3R_629()) return true;
    }
    }
    }
    if (jj_3R_652()) return true;
    return false;
  }

  final private boolean jj_3R_626() {
    if (jj_scan_token(CONNECT)) return true;
    return false;
  }

  final private boolean jj_3R_870() {
    if (jj_scan_token(COMMA)) return true;
    if (jj_3R_130()) return true;
    return false;
  }

  final private boolean jj_3R_847() {
    if (jj_scan_token(COMMA)) return true;
    if (jj_3R_130()) return true;
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_870()) jj_scanpos = xsp;
    return false;
  }

  final private boolean jj_3R_257() {
    if (jj_scan_token(LT)) return true;
    if (jj_3R_119()) return true;
    if (jj_scan_token(GT)) return true;
    return false;
  }

  final private boolean jj_3R_256() {
    if (jj_3R_119()) return true;
    return false;
  }

  final private boolean jj_3R_676() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_scan_token(25)) {
    jj_scanpos = xsp;
    if (jj_scan_token(26)) return true;
    }
    if (jj_3R_281()) return true;
    if (jj_3R_124()) return true;
    return false;
  }

  final private boolean jj_3R_161() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_255()) {
    jj_scanpos = xsp;
    if (jj_3R_256()) {
    jj_scanpos = xsp;
    if (jj_3R_257()) return true;
    }
    }
    return false;
  }

  final private boolean jj_3R_255() {
    if (jj_3R_294()) return true;
    return false;
  }

  final private boolean jj_3_79() {
    Token xsp;
    while (true) {
      xsp = jj_scanpos;
      if (jj_3R_161()) { jj_scanpos = xsp; break; }
    }
    if (jj_scan_token(TO)) return true;
    return false;
  }

  final private boolean jj_3R_267() {
    if (jj_scan_token(LBRACKET)) return true;
    if (jj_scan_token(RBRACKET)) return true;
    return false;
  }

  final private boolean jj_3R_119() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_scan_token(238)) {
    jj_scanpos = xsp;
    if (jj_scan_token(19)) {
    jj_scanpos = xsp;
    if (jj_scan_token(32)) {
    jj_scanpos = xsp;
    if (jj_scan_token(36)) {
    jj_scanpos = xsp;
    if (jj_scan_token(46)) {
    jj_scanpos = xsp;
    if (jj_scan_token(47)) {
    jj_scanpos = xsp;
    if (jj_scan_token(48)) {
    jj_scanpos = xsp;
    if (jj_scan_token(50)) {
    jj_scanpos = xsp;
    if (jj_scan_token(52)) {
    jj_scanpos = xsp;
    if (jj_scan_token(68)) {
    jj_scanpos = xsp;
    if (jj_scan_token(69)) {
    jj_scanpos = xsp;
    if (jj_scan_token(70)) {
    jj_scanpos = xsp;
    if (jj_scan_token(124)) {
    jj_scanpos = xsp;
    if (jj_scan_token(125)) {
    jj_scanpos = xsp;
    if (jj_scan_token(126)) {
    jj_scanpos = xsp;
    if (jj_scan_token(127)) {
    jj_scanpos = xsp;
    if (jj_scan_token(129)) {
    jj_scanpos = xsp;
    if (jj_scan_token(130)) {
    jj_scanpos = xsp;
    if (jj_scan_token(131)) {
    jj_scanpos = xsp;
    if (jj_scan_token(132)) {
    jj_scanpos = xsp;
    if (jj_scan_token(133)) {
    jj_scanpos = xsp;
    if (jj_scan_token(147)) {
    jj_scanpos = xsp;
    if (jj_scan_token(148)) {
    jj_scanpos = xsp;
    if (jj_scan_token(149)) {
    jj_scanpos = xsp;
    if (jj_scan_token(150)) {
    jj_scanpos = xsp;
    if (jj_scan_token(151)) {
    jj_scanpos = xsp;
    if (jj_scan_token(202)) {
    jj_scanpos = xsp;
    if (jj_scan_token(205)) {
    jj_scanpos = xsp;
    if (jj_scan_token(206)) {
    jj_scanpos = xsp;
    if (jj_scan_token(209)) {
    jj_scanpos = xsp;
    if (jj_scan_token(210)) {
    jj_scanpos = xsp;
    if (jj_scan_token(211)) {
    jj_scanpos = xsp;
    if (jj_scan_token(213)) {
    jj_scanpos = xsp;
    if (jj_scan_token(109)) {
    jj_scanpos = xsp;
    if (jj_scan_token(110)) {
    jj_scanpos = xsp;
    if (jj_scan_token(113)) {
    jj_scanpos = xsp;
    if (jj_scan_token(114)) {
    jj_scanpos = xsp;
    if (jj_scan_token(111)) {
    jj_scanpos = xsp;
    if (jj_scan_token(112)) {
    jj_scanpos = xsp;
    if (jj_scan_token(141)) return true;
    }
    }
    }
    }
    }
    }
    }
    }
    }
    }
    }
    }
    }
    }
    }
    }
    }
    }
    }
    }
    }
    }
    }
    }
    }
    }
    }
    }
    }
    }
    }
    }
    }
    }
    }
    }
    }
    }
    }
    return false;
  }

  final private boolean jj_3R_562() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_scan_token(172)) {
    jj_scanpos = xsp;
    if (jj_3R_626()) return true;
    }
    xsp = jj_scanpos;
    if (jj_3_79()) jj_scanpos = xsp;
    if (jj_3R_130()) return true;
    xsp = jj_scanpos;
    if (jj_3R_847()) jj_scanpos = xsp;
    if (jj_scan_token(SEMICOLON)) return true;
    return false;
  }

  final private boolean jj_3R_748() {
    if (jj_scan_token(COMMA)) return true;
    if (jj_3R_95()) return true;
    if (jj_3R_88()) return true;
    return false;
  }

  final private boolean jj_3R_814() {
    if (jj_3R_248()) return true;
    return false;
  }

  final private boolean jj_3R_741() {
    if (jj_3R_95()) return true;
    if (jj_3R_88()) return true;
    Token xsp;
    while (true) {
      xsp = jj_scanpos;
      if (jj_3R_748()) { jj_scanpos = xsp; break; }
    }
    return false;
  }

  final private boolean jj_3R_486() {
    if (jj_3R_570()) return true;
    return false;
  }

  final private boolean jj_3R_485() {
    if (jj_3R_569()) return true;
    return false;
  }

  final private boolean jj_3R_484() {
    if (jj_3R_568()) return true;
    return false;
  }

  final private boolean jj_3R_727() {
    if (jj_scan_token(LPAREN)) return true;
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_741()) jj_scanpos = xsp;
    if (jj_scan_token(RPAREN)) return true;
    return false;
  }

  final private boolean jj_3R_483() {
    if (jj_3R_567()) return true;
    return false;
  }

  final private boolean jj_3R_482() {
    if (jj_3R_566()) return true;
    return false;
  }

  final private boolean jj_3R_677() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_727()) jj_scanpos = xsp;
    return false;
  }

  final private boolean jj_3R_481() {
    if (jj_3R_565()) return true;
    return false;
  }

  final private boolean jj_3R_480() {
    if (jj_3R_564()) return true;
    return false;
  }

  final private boolean jj_3R_479() {
    if (jj_3R_563()) return true;
    return false;
  }

  final private boolean jj_3R_478() {
    if (jj_3R_562()) return true;
    return false;
  }

  final private boolean jj_3R_417() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_478()) {
    jj_scanpos = xsp;
    if (jj_3R_479()) {
    jj_scanpos = xsp;
    if (jj_3R_480()) {
    jj_scanpos = xsp;
    if (jj_3R_481()) {
    jj_scanpos = xsp;
    if (jj_3R_482()) {
    jj_scanpos = xsp;
    if (jj_3R_483()) {
    jj_scanpos = xsp;
    if (jj_3R_484()) {
    jj_scanpos = xsp;
    if (jj_3R_485()) {
    jj_scanpos = xsp;
    if (jj_3R_486()) return true;
    }
    }
    }
    }
    }
    }
    }
    }
    return false;
  }

  final private boolean jj_3R_813() {
    if (jj_3R_130()) return true;
    return false;
  }

  final private boolean jj_3R_176() {
    if (jj_scan_token(VOID)) return true;
    return false;
  }

  final private boolean jj_3R_175() {
    if (jj_3R_266()) return true;
    Token xsp;
    while (true) {
      xsp = jj_scanpos;
      if (jj_3R_267()) { jj_scanpos = xsp; break; }
    }
    return false;
  }

  final private boolean jj_3R_95() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_175()) {
    jj_scanpos = xsp;
    if (jj_3R_176()) return true;
    }
    return false;
  }

  final private boolean jj_3R_812() {
    if (jj_3R_130()) return true;
    return false;
  }

  final private boolean jj_3R_477() {
    if (jj_scan_token(SENDMAIL)) return true;
    return false;
  }

  final private boolean jj_3R_601() {
    if (jj_scan_token(HTMLBODY)) return true;
    return false;
  }

  final private boolean jj_3_7() {
    if (jj_3R_95()) return true;
    if (jj_3R_88()) return true;
    if (jj_scan_token(SEMICOLON)) return true;
    return false;
  }

  final private boolean jj_3R_600() {
    if (jj_scan_token(BODY)) return true;
    return false;
  }

  final private boolean jj_3R_599() {
    if (jj_scan_token(ATTACH)) return true;
    return false;
  }

  final private boolean jj_3R_598() {
    if (jj_scan_token(SUBJECT)) return true;
    return false;
  }

  final private boolean jj_3R_597() {
    if (jj_scan_token(BCC)) return true;
    return false;
  }

  final private boolean jj_3R_596() {
    if (jj_scan_token(CC)) return true;
    return false;
  }

  final private boolean jj_3R_595() {
    if (jj_scan_token(FROM)) return true;
    return false;
  }

  final private boolean jj_3R_610() {
    if (jj_3R_95()) return true;
    if (jj_3R_88()) return true;
    if (jj_3R_677()) return true;
    if (jj_3R_124()) return true;
    return false;
  }

  final private boolean jj_3R_594() {
    if (jj_scan_token(TO)) return true;
    return false;
  }

  final private boolean jj_3R_526() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_594()) {
    jj_scanpos = xsp;
    if (jj_3R_595()) {
    jj_scanpos = xsp;
    if (jj_3R_596()) {
    jj_scanpos = xsp;
    if (jj_3R_597()) {
    jj_scanpos = xsp;
    if (jj_3R_598()) {
    jj_scanpos = xsp;
    if (jj_3R_599()) {
    jj_scanpos = xsp;
    if (jj_3R_600()) {
    jj_scanpos = xsp;
    if (jj_3R_601()) return true;
    }
    }
    }
    }
    }
    }
    }
    xsp = jj_scanpos;
    if (jj_3R_812()) jj_scanpos = xsp;
    if (jj_scan_token(COLON)) return true;
    xsp = jj_scanpos;
    if (jj_3R_813()) {
    jj_scanpos = xsp;
    if (jj_3R_814()) return true;
    }
    return false;
  }

  final private boolean jj_3R_609() {
    if (jj_3R_95()) return true;
    if (jj_3R_88()) return true;
    if (jj_scan_token(SEMICOLON)) return true;
    return false;
  }

  final private boolean jj_3_78() {
    if (jj_3R_130()) return true;
    return false;
  }

  final private boolean jj_3R_608() {
    if (jj_3R_676()) return true;
    return false;
  }

  final private boolean jj_3R_533() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_608()) {
    jj_scanpos = xsp;
    if (jj_3R_609()) {
    jj_scanpos = xsp;
    if (jj_3R_610()) return true;
    }
    }
    return false;
  }

  final private boolean jj_3R_416() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_scan_token(105)) {
    jj_scanpos = xsp;
    if (jj_3R_477()) return true;
    }
    xsp = jj_scanpos;
    if (jj_3_78()) jj_scanpos = xsp;
    if (jj_3R_526()) return true;
    while (true) {
      xsp = jj_scanpos;
      if (jj_3R_526()) { jj_scanpos = xsp; break; }
    }
    if (jj_scan_token(SEMICOLON)) return true;
    return false;
  }

  final private boolean jj_3R_590() {
    if (jj_3R_130()) return true;
    return false;
  }

  final private boolean jj_3R_532() {
    if (jj_scan_token(COMMA)) return true;
    Token xsp;
    xsp = jj_scanpos;
    if (jj_scan_token(13)) jj_scanpos = xsp;
    if (jj_3R_104()) return true;
    return false;
  }

  final private boolean jj_3R_93() {
    if (jj_scan_token(EXTENDSJAVA)) return true;
    return false;
  }

  final private boolean jj_3R_94() {
    if (jj_3R_104()) return true;
    Token xsp;
    while (true) {
      xsp = jj_scanpos;
      if (jj_3R_532()) { jj_scanpos = xsp; break; }
    }
    if (jj_scan_token(LBRACE)) return true;
    while (true) {
      xsp = jj_scanpos;
      if (jj_3R_533()) { jj_scanpos = xsp; break; }
    }
    if (jj_scan_token(RBRACE)) return true;
    return false;
  }

  final private boolean jj_3R_589() {
    if (jj_3R_248()) return true;
    return false;
  }

  final private boolean jj_3R_517() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_589()) {
    jj_scanpos = xsp;
    if (jj_3R_590()) return true;
    }
    return false;
  }

  final private boolean jj_3R_412() {
    if (jj_scan_token(THROW)) return true;
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_517()) jj_scanpos = xsp;
    if (jj_scan_token(SEMICOLON)) return true;
    return false;
  }

  final private boolean jj_3R_92() {
    if (jj_scan_token(EXTENDS)) return true;
    if (jj_scan_token(JAVA__)) return true;
    return false;
  }

  final private boolean jj_3_5() {
    if (jj_3R_91()) return true;
    return false;
  }

  final private boolean jj_3R_775() {
    if (jj_scan_token(LIMIT)) return true;
    if (jj_3R_130()) return true;
    return false;
  }

  final private boolean jj_3R_774() {
    if (jj_scan_token(_SKIP)) return true;
    if (jj_3R_130()) return true;
    return false;
  }

  final private boolean jj_3_4() {
    if (jj_3R_89()) return true;
    if (jj_3R_90()) return true;
    return false;
  }

  final private boolean jj_3R_810() {
    if (jj_3R_98()) return true;
    return false;
  }

  final private boolean jj_3_77() {
    if (jj_scan_token(PIPE)) return true;
    return false;
  }

  final private boolean jj_3_76() {
    if (jj_scan_token(LOG)) return true;
    return false;
  }

  final private boolean jj_3_75() {
    if (jj_scan_token(ERR)) return true;
    return false;
  }

  final private boolean jj_3_6() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_92()) {
    jj_scanpos = xsp;
    if (jj_3R_93()) return true;
    }
    if (jj_3R_94()) return true;
    return false;
  }

  final private boolean jj_3_74() {
    if (jj_scan_token(OUT)) return true;
    return false;
  }

  final private boolean jj_3R_525() {
    if (jj_scan_token(LT)) return true;
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3_74()) {
    jj_scanpos = xsp;
    if (jj_3_75()) {
    jj_scanpos = xsp;
    if (jj_3_76()) {
    jj_scanpos = xsp;
    if (jj_3_77()) {
    jj_scanpos = xsp;
    if (jj_3R_810()) return true;
    }
    }
    }
    }
    if (jj_scan_token(GT)) return true;
    return false;
  }

  final private boolean jj_3R_415() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_scan_token(137)) {
    jj_scanpos = xsp;
    if (jj_scan_token(138)) return true;
    }
    xsp = jj_scanpos;
    if (jj_3R_525()) jj_scanpos = xsp;
    if (jj_3R_130()) return true;
    xsp = jj_scanpos;
    if (jj_3R_774()) jj_scanpos = xsp;
    xsp = jj_scanpos;
    if (jj_3R_775()) jj_scanpos = xsp;
    if (jj_scan_token(FOR)) return true;
    if (jj_3R_593()) return true;
    if (jj_scan_token(SEMICOLON)) return true;
    return false;
  }

  final private boolean jj_3R_694() {
    if (jj_3R_130()) return true;
    return false;
  }

  final private boolean jj_3R_867() {
    if (jj_scan_token(BANG)) return true;
    return false;
  }

  final private boolean jj_3R_892() {
    if (jj_scan_token(STAR)) return true;
    return false;
  }

  final private boolean jj_3R_891() {
    if (jj_scan_token(GT)) return true;
    return false;
  }

  final private boolean jj_3R_869() {
    if (jj_scan_token(REPEAT)) return true;
    if (jj_3R_130()) return true;
    return false;
  }

  final private boolean jj_3R_890() {
    if (jj_scan_token(LT)) return true;
    return false;
  }

  final private boolean jj_3R_868() {
    if (jj_scan_token(LBRACE)) return true;
    if (jj_3R_130()) return true;
    if (jj_scan_token(RBRACE)) return true;
    return false;
  }

  final private boolean jj_3R_866() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_890()) {
    jj_scanpos = xsp;
    if (jj_3R_891()) {
    jj_scanpos = xsp;
    if (jj_3R_892()) return true;
    }
    }
    return false;
  }

  final private boolean jj_3R_846() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_868()) {
    jj_scanpos = xsp;
    if (jj_3R_869()) return true;
    }
    return false;
  }

  final private boolean jj_3R_229() {
    if (jj_3R_148()) return true;
    return false;
  }

  final private boolean jj_3R_811() {
    if (jj_scan_token(COMMA)) return true;
    if (jj_3R_651()) return true;
    return false;
  }

  final private boolean jj_3R_845() {
    if (jj_scan_token(COLON)) return true;
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_866()) jj_scanpos = xsp;
    if (jj_3R_130()) return true;
    xsp = jj_scanpos;
    if (jj_3R_867()) jj_scanpos = xsp;
    return false;
  }

  final private boolean jj_3R_693() {
    if (jj_3R_248()) return true;
    return false;
  }

  final private boolean jj_3R_87() {
    if (jj_scan_token(CONST)) return true;
    if (jj_scan_token(CONST_NAME)) return true;
    if (jj_scan_token(ASSIGN)) return true;
    return false;
  }

  final private boolean jj_3R_651() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_693()) {
    jj_scanpos = xsp;
    if (jj_3R_694()) return true;
    }
    xsp = jj_scanpos;
    if (jj_3R_845()) jj_scanpos = xsp;
    xsp = jj_scanpos;
    if (jj_3R_846()) jj_scanpos = xsp;
    return false;
  }

  final private boolean jj_3R_314() {
    if (jj_scan_token(DOUBLE)) return true;
    return false;
  }

  final private boolean jj_3R_313() {
    if (jj_scan_token(FLOAT)) return true;
    return false;
  }

  final private boolean jj_3R_312() {
    if (jj_scan_token(LONG)) return true;
    return false;
  }

  final private boolean jj_3R_311() {
    if (jj_scan_token(INT)) return true;
    return false;
  }

  final private boolean jj_3R_310() {
    if (jj_scan_token(SHORT)) return true;
    return false;
  }

  final private boolean jj_3R_593() {
    if (jj_3R_651()) return true;
    Token xsp;
    while (true) {
      xsp = jj_scanpos;
      if (jj_3R_811()) { jj_scanpos = xsp; break; }
    }
    return false;
  }

  final private boolean jj_3R_309() {
    if (jj_scan_token(CHAR)) return true;
    return false;
  }

  final private boolean jj_3R_308() {
    if (jj_scan_token(BYTE)) return true;
    return false;
  }

  final private boolean jj_3R_307() {
    if (jj_scan_token(BOOLEAN)) return true;
    return false;
  }

  final private boolean jj_3R_275() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_307()) {
    jj_scanpos = xsp;
    if (jj_3R_308()) {
    jj_scanpos = xsp;
    if (jj_3R_309()) {
    jj_scanpos = xsp;
    if (jj_3R_310()) {
    jj_scanpos = xsp;
    if (jj_3R_311()) {
    jj_scanpos = xsp;
    if (jj_3R_312()) {
    jj_scanpos = xsp;
    if (jj_3R_313()) {
    jj_scanpos = xsp;
    if (jj_3R_314()) return true;
    }
    }
    }
    }
    }
    }
    }
    return false;
  }

  final private boolean jj_3R_171() {
    if (jj_3R_128()) return true;
    return false;
  }

  final private boolean jj_3R_230() {
    if (jj_3R_281()) return true;
    if (jj_3R_124()) return true;
    return false;
  }

  final private boolean jj_3R_524() {
    if (jj_3R_593()) return true;
    return false;
  }

  final private boolean jj_3R_855() {
    if (jj_3R_148()) return true;
    return false;
  }

  final private boolean jj_3R_300() {
    if (jj_3R_275()) return true;
    return false;
  }

  final private boolean jj_3_104() {
    if (jj_3R_119()) return true;
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_171()) jj_scanpos = xsp;
    if (jj_scan_token(SEMICOLON)) return true;
    return false;
  }

  final private boolean jj_3R_299() {
    if (jj_3R_104()) return true;
    return false;
  }

  final private boolean jj_3_3() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_scan_token(103)) {
    jj_scanpos = xsp;
    if (jj_scan_token(102)) return true;
    }
    return false;
  }

  final private boolean jj_3R_865() {
    if (jj_scan_token(LPAREN)) return true;
    if (jj_3R_130()) return true;
    if (jj_scan_token(RPAREN)) return true;
    return false;
  }

  final private boolean jj_3R_809() {
    if (jj_3R_98()) return true;
    return false;
  }

  final private boolean jj_3R_125() {
    if (jj_3R_148()) return true;
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_229()) jj_scanpos = xsp;
    if (jj_scan_token(THREAD)) return true;
    xsp = jj_scanpos;
    if (jj_3_104()) {
    jj_scanpos = xsp;
    if (jj_3R_230()) return true;
    }
    return false;
  }

  final private boolean jj_3R_266() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3_3()) {
    jj_scanpos = xsp;
    if (jj_3R_299()) {
    jj_scanpos = xsp;
    if (jj_3R_300()) return true;
    }
    }
    return false;
  }

  final private boolean jj_3_73() {
    if (jj_scan_token(PIPE)) return true;
    return false;
  }

  final private boolean jj_3R_160() {
    if (jj_scan_token(COLON)) return true;
    if (jj_scan_token(IDENTIFIER)) return true;
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_865()) jj_scanpos = xsp;
    return false;
  }

  final private boolean jj_3_2() {
    if (jj_scan_token(DOT)) return true;
    if (jj_3R_88()) return true;
    return false;
  }

  final private boolean jj_3_72() {
    if (jj_scan_token(LOG)) return true;
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_160()) jj_scanpos = xsp;
    return false;
  }

  final private boolean jj_3R_154() {
    if (jj_3R_249()) return true;
    return false;
  }

  final private boolean jj_3_71() {
    if (jj_scan_token(ERR)) return true;
    return false;
  }

  final private boolean jj_3_70() {
    if (jj_scan_token(OUT)) return true;
    return false;
  }

  final private boolean jj_3R_219() {
    if (jj_3R_265()) return true;
    Token xsp;
    while (true) {
      xsp = jj_scanpos;
      if (jj_3_2()) { jj_scanpos = xsp; break; }
    }
    return false;
  }

  final private boolean jj_3R_523() {
    if (jj_scan_token(LT)) return true;
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3_70()) {
    jj_scanpos = xsp;
    if (jj_3_71()) {
    jj_scanpos = xsp;
    if (jj_3_72()) {
    jj_scanpos = xsp;
    if (jj_3_73()) {
    jj_scanpos = xsp;
    if (jj_3R_809()) return true;
    }
    }
    }
    }
    if (jj_scan_token(GT)) return true;
    return false;
  }

  final private boolean jj_3R_906() {
    if (jj_3R_130()) return true;
    return false;
  }

  final private boolean jj_3R_218() {
    if (jj_scan_token(CONST_NAME)) return true;
    return false;
  }

  final private boolean jj_3R_104() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_218()) {
    jj_scanpos = xsp;
    if (jj_3R_219()) return true;
    }
    return false;
  }

  final private boolean jj_3R_522() {
    if (jj_scan_token(LBRACE)) return true;
    if (jj_3R_130()) return true;
    if (jj_scan_token(RBRACE)) return true;
    return false;
  }

  final private boolean jj_3R_476() {
    if (jj_scan_token(DOT)) return true;
    return false;
  }

  final private boolean jj_3R_475() {
    if (jj_scan_token(PRINTLN)) return true;
    return false;
  }

  final private boolean jj_3R_474() {
    if (jj_scan_token(FLUSH)) return true;
    return false;
  }

  final private boolean jj_3R_575() {
    if (jj_scan_token(RMDIR)) return true;
    if (jj_3R_130()) return true;
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_855()) jj_scanpos = xsp;
    if (jj_scan_token(SEMICOLON)) return true;
    return false;
  }

  final private boolean jj_3R_153() {
    if (jj_3R_248()) return true;
    return false;
  }

  final private boolean jj_3R_414() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_474()) {
    jj_scanpos = xsp;
    if (jj_scan_token(135)) {
    jj_scanpos = xsp;
    if (jj_3R_475()) {
    jj_scanpos = xsp;
    if (jj_3R_476()) return true;
    }
    }
    }
    xsp = jj_scanpos;
    if (jj_3R_522()) jj_scanpos = xsp;
    xsp = jj_scanpos;
    if (jj_3R_523()) jj_scanpos = xsp;
    xsp = jj_scanpos;
    if (jj_3R_524()) jj_scanpos = xsp;
    if (jj_scan_token(SEMICOLON)) return true;
    return false;
  }

  final private boolean jj_3R_905() {
    if (jj_3R_248()) return true;
    return false;
  }

  final private boolean jj_3R_686() {
    if (jj_3R_249()) return true;
    return false;
  }

  final private boolean jj_3R_152() {
    if (jj_3R_130()) return true;
    return false;
  }

  final private boolean jj_3R_887() {
    if (jj_scan_token(MANIFEST)) return true;
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_905()) {
    jj_scanpos = xsp;
    if (jj_3R_906()) return true;
    }
    return false;
  }

  final private boolean jj_3R_886() {
    if (jj_scan_token(IDENTIFIER)) return true;
    return false;
  }

  final private boolean jj_3R_685() {
    if (jj_3R_248()) return true;
    return false;
  }

  final private boolean jj_3R_885() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_scan_token(78)) {
    jj_scanpos = xsp;
    if (jj_scan_token(52)) return true;
    }
    if (jj_3R_130()) return true;
    return false;
  }

  final private boolean jj_3R_884() {
    if (jj_scan_token(AS)) return true;
    if (jj_3R_130()) return true;
    return false;
  }

  final private boolean jj_3R_883() {
    if (jj_scan_token(UNDER)) return true;
    if (jj_3R_130()) return true;
    return false;
  }

  final private boolean jj_3R_882() {
    if (jj_scan_token(STRIP)) return true;
    if (jj_3R_130()) return true;
    return false;
  }

  final private boolean jj_3R_881() {
    if (jj_scan_token(IN)) return true;
    if (jj_3R_130()) return true;
    return false;
  }

  final private boolean jj_3R_880() {
    if (jj_scan_token(EXCEPT)) return true;
    if (jj_3R_130()) return true;
    return false;
  }

  final private boolean jj_3R_854() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_880()) {
    jj_scanpos = xsp;
    if (jj_3R_881()) {
    jj_scanpos = xsp;
    if (jj_3R_882()) {
    jj_scanpos = xsp;
    if (jj_3R_883()) {
    jj_scanpos = xsp;
    if (jj_3R_884()) {
    jj_scanpos = xsp;
    if (jj_3R_885()) {
    jj_scanpos = xsp;
    if (jj_3R_886()) {
    jj_scanpos = xsp;
    if (jj_3R_887()) return true;
    }
    }
    }
    }
    }
    }
    }
    return false;
  }

  final private boolean jj_3R_574() {
    if (jj_scan_token(COPY)) return true;
    if (jj_3R_130()) return true;
    Token xsp;
    while (true) {
      xsp = jj_scanpos;
      if (jj_3R_854()) { jj_scanpos = xsp; break; }
    }
    if (jj_scan_token(SEMICOLON)) return true;
    return false;
  }

  final private boolean jj_3R_254() {
    if (jj_3R_130()) return true;
    return false;
  }

  final private boolean jj_3R_158() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_253()) {
    jj_scanpos = xsp;
    if (jj_scan_token(272)) return true;
    }
    return false;
  }

  final private boolean jj_3R_253() {
    if (jj_scan_token(MINUS)) return true;
    return false;
  }

  final private boolean jj_3R_157() {
    if (jj_3R_252()) return true;
    return false;
  }

  final private boolean jj_3R_156() {
    if (jj_3R_251()) return true;
    return false;
  }

  final private boolean jj_3R_151() {
    if (jj_3R_247()) return true;
    return false;
  }

  final private boolean jj_3_62() {
    if (jj_scan_token(COMMA)) return true;
    if (jj_3R_130()) return true;
    return false;
  }

  final private boolean jj_3R_684() {
    if (jj_3R_130()) return true;
    return false;
  }

  final private boolean jj_3_1() {
    if (jj_3R_87()) return true;
    return false;
  }

  final private boolean jj_3R_155() {
    if (jj_3R_250()) return true;
    return false;
  }

  final private boolean jj_3R_159() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3_68()) {
    jj_scanpos = xsp;
    if (jj_3R_254()) return true;
    }
    return false;
  }

  final private boolean jj_3_68() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_155()) {
    jj_scanpos = xsp;
    if (jj_3R_156()) {
    jj_scanpos = xsp;
    if (jj_3R_157()) return true;
    }
    }
    xsp = jj_scanpos;
    if (jj_3R_158()) jj_scanpos = xsp;
    return false;
  }

  final private boolean jj_3R_923() {
    if (jj_3R_130()) return true;
    return false;
  }

  final private boolean jj_3R_740() {
    if (jj_scan_token(EXEC)) return true;
    if (jj_3R_130()) return true;
    return false;
  }

  final private boolean jj_3R_671() {
    if (jj_3R_124()) return true;
    return false;
  }

  final private boolean jj_3R_922() {
    if (jj_3R_130()) return true;
    return false;
  }

  final private boolean jj_3_69() {
    if (jj_scan_token(LT)) return true;
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_159()) jj_scanpos = xsp;
    if (jj_scan_token(GT)) return true;
    return false;
  }

  final private boolean jj_3R_739() {
    if (jj_scan_token(SETREADONLY)) return true;
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_923()) jj_scanpos = xsp;
    return false;
  }

  final private boolean jj_3R_90() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3_69()) jj_scanpos = xsp;
    return false;
  }

  final private boolean jj_3R_738() {
    if (jj_scan_token(SETFILETIME)) return true;
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_922()) jj_scanpos = xsp;
    return false;
  }

  final private boolean jj_3R_726() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_738()) {
    jj_scanpos = xsp;
    if (jj_3R_739()) {
    jj_scanpos = xsp;
    if (jj_3R_740()) return true;
    }
    }
    return false;
  }

  final private boolean jj_3R_670() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_726()) jj_scanpos = xsp;
    if (jj_scan_token(SEMICOLON)) return true;
    return false;
  }

  final private boolean jj_3R_921() {
    if (jj_scan_token(IDENTIFIER)) return true;
    return false;
  }

  final private boolean jj_3R_725() {
    if (jj_scan_token(IDENTIFIER)) return true;
    return false;
  }

  final private boolean jj_3R_920() {
    if (jj_scan_token(DATE_)) return true;
    return false;
  }

  final private boolean jj_3R_724() {
    if (jj_scan_token(AS)) return true;
    if (jj_3R_148()) return true;
    return false;
  }

  final private boolean jj_3R_464() {
    if (jj_3R_130()) return true;
    Token xsp;
    while (true) {
      xsp = jj_scanpos;
      if (jj_3_62()) { jj_scanpos = xsp; break; }
    }
    return false;
  }

  final private boolean jj_3R_723() {
    if (jj_scan_token(LIMIT)) return true;
    if (jj_3R_130()) return true;
    return false;
  }

  final private boolean jj_3_67() {
    if (jj_3R_130()) return true;
    if (jj_scan_token(DOTDOT)) return true;
    return false;
  }

  final private boolean jj_3_66() {
    if (jj_scan_token(COMMA)) return true;
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_151()) {
    jj_scanpos = xsp;
    if (jj_3R_152()) {
    jj_scanpos = xsp;
    if (jj_3R_153()) {
    jj_scanpos = xsp;
    if (jj_3R_154()) return true;
    }
    }
    }
    return false;
  }

  final private boolean jj_3R_683() {
    if (jj_3R_247()) return true;
    return false;
  }

  final private boolean jj_3R_904() {
    if (jj_scan_token(BY)) return true;
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_920()) {
    jj_scanpos = xsp;
    if (jj_3R_921()) return true;
    }
    return false;
  }

  final private boolean jj_3R_619() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_683()) {
    jj_scanpos = xsp;
    if (jj_3R_684()) {
    jj_scanpos = xsp;
    if (jj_3R_685()) {
    jj_scanpos = xsp;
    if (jj_3R_686()) return true;
    }
    }
    }
    while (true) {
      xsp = jj_scanpos;
      if (jj_3_66()) { jj_scanpos = xsp; break; }
    }
    return false;
  }

  final private boolean jj_3R_552() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_619()) jj_scanpos = xsp;
    return false;
  }

  final private boolean jj_3R_291() {
    if (jj_scan_token(NUMBER_)) return true;
    return false;
  }

  final private boolean jj_3R_722() {
    if (jj_scan_token(ORDERED)) return true;
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_904()) jj_scanpos = xsp;
    return false;
  }

  final private boolean jj_3R_292() {
    if (jj_scan_token(STRING_)) return true;
    return false;
  }

  final private boolean jj_3R_721() {
    if (jj_scan_token(IN)) return true;
    if (jj_3R_130()) return true;
    return false;
  }

  final private boolean jj_3R_293() {
    if (jj_scan_token(DATE_)) return true;
    return false;
  }

  final private boolean jj_3R_720() {
    if (jj_scan_token(EXCEPT)) return true;
    if (jj_3R_130()) return true;
    return false;
  }

  final private boolean jj_3R_669() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_720()) {
    jj_scanpos = xsp;
    if (jj_3R_721()) {
    jj_scanpos = xsp;
    if (jj_3R_722()) {
    jj_scanpos = xsp;
    if (jj_3R_723()) {
    jj_scanpos = xsp;
    if (jj_3R_724()) {
    jj_scanpos = xsp;
    if (jj_3R_725()) return true;
    }
    }
    }
    }
    }
    return false;
  }

  final private boolean jj_3R_551() {
    if (jj_3R_130()) return true;
    if (jj_scan_token(DOTDOT)) return true;
    if (jj_3R_130()) return true;
    return false;
  }

  final private boolean jj_3R_173() {
    if (jj_scan_token(SORTEDMAP_)) return true;
    return false;
  }

  final private boolean jj_3R_557() {
    if (jj_scan_token(SET_)) return true;
    return false;
  }

  final private boolean jj_3R_290() {
    if (jj_3R_359()) return true;
    return false;
  }

  final private boolean jj_3R_426() {
    if (jj_scan_token(LINKEDLIST_)) return true;
    return false;
  }

  final private boolean jj_3R_561() {
    if (jj_scan_token(LOCAL)) return true;
    return false;
  }

  final private boolean jj_3R_247() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_290()) jj_scanpos = xsp;
    if (jj_scan_token(LBRACKET)) return true;
    xsp = jj_scanpos;
    if (jj_3R_551()) {
    jj_scanpos = xsp;
    if (jj_3R_552()) return true;
    }
    xsp = jj_scanpos;
    if (jj_scan_token(307)) jj_scanpos = xsp;
    if (jj_scan_token(RBRACKET)) return true;
    return false;
  }

  final private boolean jj_3_103() {
    if (jj_3R_130()) return true;
    return false;
  }

  final private boolean jj_3_65() {
    if (jj_scan_token(COLON)) return true;
    if (jj_3R_130()) return true;
    return false;
  }

  final private boolean jj_3R_730() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_scan_token(89)) {
    jj_scanpos = xsp;
    if (jj_scan_token(88)) return true;
    }
    return false;
  }

  final private boolean jj_3R_465() {
    if (jj_scan_token(WSDL__)) return true;
    if (jj_3R_130()) return true;
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3_65()) jj_scanpos = xsp;
    return false;
  }

  final private boolean jj_3R_250() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_scan_token(124)) {
    jj_scanpos = xsp;
    if (jj_3R_291()) return true;
    }
    return false;
  }

  final private boolean jj_3R_251() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_scan_token(102)) {
    jj_scanpos = xsp;
    if (jj_3R_292()) return true;
    }
    return false;
  }

  final private boolean jj_3R_252() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_scan_token(122)) {
    jj_scanpos = xsp;
    if (jj_3R_293()) return true;
    }
    return false;
  }

  final private boolean jj_3R_89() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_scan_token(120)) {
    jj_scanpos = xsp;
    if (jj_3R_173()) return true;
    }
    return false;
  }

  final private boolean jj_3R_463() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_scan_token(118)) {
    jj_scanpos = xsp;
    if (jj_3R_557()) return true;
    }
    return false;
  }

  final private boolean jj_3R_668() {
    if (jj_3R_130()) return true;
    return false;
  }

  final private boolean jj_3R_359() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_scan_token(116)) {
    jj_scanpos = xsp;
    if (jj_3R_426()) return true;
    }
    return false;
  }

  final private boolean jj_3R_468() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_scan_token(90)) {
    jj_scanpos = xsp;
    if (jj_3R_561()) return true;
    }
    return false;
  }

  final private boolean jj_3R_719() {
    if (jj_scan_token(LT)) return true;
    if (jj_3R_98()) return true;
    if (jj_scan_token(GT)) return true;
    return false;
  }

  final private boolean jj_3R_649() {
    if (jj_scan_token(LS)) return true;
    return false;
  }

  final private boolean jj_3R_397() {
    if (jj_scan_token(XML__)) return true;
    if (true) { jj_la = 0; jj_scanpos = jj_lastpos; return false;}
    return false;
  }

  final private boolean jj_3R_396() {
    if (jj_scan_token(VOID)) return true;
    if (jj_3R_130()) return true;
    return false;
  }

  final private boolean jj_3R_648() {
    if (jj_scan_token(LIST)) return true;
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_719()) jj_scanpos = xsp;
    return false;
  }

  final private boolean jj_3R_149() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_scan_token(115)) {
    jj_scanpos = xsp;
    if (jj_scan_token(116)) return true;
    }
    return false;
  }

  final private boolean jj_3_64() {
    if (jj_scan_token(LBRACE)) return true;
    if (jj_3R_150()) return true;
    if (jj_scan_token(BIT_OR)) return true;
    return false;
  }

  final private boolean jj_3R_573() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_648()) {
    jj_scanpos = xsp;
    if (jj_3R_649()) return true;
    }
    xsp = jj_scanpos;
    if (jj_3R_668()) jj_scanpos = xsp;
    while (true) {
      xsp = jj_scanpos;
      if (jj_3R_669()) { jj_scanpos = xsp; break; }
    }
    xsp = jj_scanpos;
    if (jj_3R_670()) {
    jj_scanpos = xsp;
    if (jj_3R_671()) return true;
    }
    return false;
  }

  final private boolean jj_3_63() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_149()) jj_scanpos = xsp;
    if (jj_scan_token(LBRACKET)) return true;
    return false;
  }

  final private boolean jj_3R_395() {
    if (jj_scan_token(LBRACE)) return true;
    if (jj_3R_360()) return true;
    if (jj_scan_token(RBRACE)) return true;
    return false;
  }

  final private boolean jj_3R_394() {
    if (jj_3R_465()) return true;
    return false;
  }

  final private boolean jj_3R_393() {
    if (jj_3R_249()) return true;
    return false;
  }

  final private boolean jj_3R_392() {
    if (jj_3R_248()) return true;
    return false;
  }

  final private boolean jj_3R_391() {
    if (jj_3R_463()) return true;
    if (jj_3R_90()) return true;
    if (jj_scan_token(LBRACKET)) return true;
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_464()) jj_scanpos = xsp;
    xsp = jj_scanpos;
    if (jj_scan_token(307)) jj_scanpos = xsp;
    if (jj_scan_token(RBRACKET)) return true;
    return false;
  }

  final private boolean jj_3R_390() {
    if (jj_3R_130()) return true;
    return false;
  }

  final private boolean jj_3R_148() {
    if (jj_scan_token(IDENTIFIER)) return true;
    return false;
  }

  final private boolean jj_3R_389() {
    if (jj_3R_462()) return true;
    return false;
  }

  final private boolean jj_3R_388() {
    if (jj_3R_461()) return true;
    return false;
  }

  final private boolean jj_3R_318() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_387()) {
    jj_scanpos = xsp;
    if (jj_3R_388()) {
    jj_scanpos = xsp;
    if (jj_3R_389()) {
    jj_scanpos = xsp;
    if (jj_3R_390()) {
    jj_scanpos = xsp;
    if (jj_3R_391()) {
    jj_scanpos = xsp;
    if (jj_3R_392()) {
    jj_scanpos = xsp;
    if (jj_3R_393()) {
    jj_scanpos = xsp;
    if (jj_3R_394()) {
    jj_scanpos = xsp;
    if (jj_3R_395()) {
    jj_scanpos = xsp;
    if (jj_3R_396()) {
    jj_scanpos = xsp;
    if (jj_3R_397()) return true;
    }
    }
    }
    }
    }
    }
    }
    }
    }
    }
    return false;
  }

  final private boolean jj_3R_387() {
    if (jj_3R_247()) return true;
    return false;
  }

  final private boolean jj_3R_492() {
    if (jj_3R_575()) return true;
    return false;
  }

  final private boolean jj_3R_491() {
    if (jj_3R_574()) return true;
    return false;
  }

  final private boolean jj_3R_490() {
    if (jj_3R_573()) return true;
    return false;
  }

  final private boolean jj_3R_424() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_490()) {
    jj_scanpos = xsp;
    if (jj_3R_491()) {
    jj_scanpos = xsp;
    if (jj_3R_492()) return true;
    }
    }
    return false;
  }

  final private boolean jj_3R_288() {
    if (jj_scan_token(COMMA)) return true;
    if (jj_3R_130()) return true;
    return false;
  }

  final private boolean jj_3R_789() {
    if (jj_scan_token(LOCAL)) return true;
    return false;
  }

  final private boolean jj_3R_788() {
    if (jj_3R_148()) return true;
    return false;
  }

  final private boolean jj_3R_244() {
    if (jj_3R_130()) return true;
    Token xsp;
    while (true) {
      xsp = jj_scanpos;
      if (jj_3R_288()) { jj_scanpos = xsp; break; }
    }
    return false;
  }

  final private boolean jj_3R_791() {
    if (jj_scan_token(IDENTIFIER)) return true;
    return false;
  }

  final private boolean jj_3R_790() {
    if (jj_scan_token(TO)) return true;
    if (jj_3R_130()) return true;
    return false;
  }

  final private boolean jj_3R_834() {
    if (jj_3R_148()) return true;
    if (jj_3R_130()) return true;
    return false;
  }

  final private boolean jj_3R_787() {
    if (jj_scan_token(COMMA)) return true;
    if (jj_3R_130()) return true;
    return false;
  }

  final private boolean jj_3R_863() {
    if (jj_scan_token(DOWNTO)) return true;
    return false;
  }

  final private boolean jj_3R_862() {
    if (jj_scan_token(UPTO)) return true;
    return false;
  }

  final private boolean jj_3R_856() {
    if (jj_scan_token(DOT)) return true;
    if (jj_scan_token(STAR)) return true;
    return false;
  }

  final private boolean jj_3R_423() {
    if (jj_scan_token(SCP)) return true;
    if (jj_3R_130()) return true;
    if (jj_scan_token(COMMA)) return true;
    if (jj_3R_130()) return true;
    if (jj_scan_token(COMMA)) return true;
    if (jj_3R_130()) return true;
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_787()) jj_scanpos = xsp;
    if (jj_scan_token(FROM)) return true;
    xsp = jj_scanpos;
    if (jj_3R_788()) {
    jj_scanpos = xsp;
    if (jj_3R_789()) return true;
    }
    if (jj_3R_130()) return true;
    xsp = jj_scanpos;
    if (jj_3R_790()) jj_scanpos = xsp;
    while (true) {
      xsp = jj_scanpos;
      if (jj_3R_791()) { jj_scanpos = xsp; break; }
    }
    if (jj_scan_token(SEMICOLON)) return true;
    return false;
  }

  final private boolean jj_3R_833() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_scan_token(78)) {
    jj_scanpos = xsp;
    if (jj_3R_862()) {
    jj_scanpos = xsp;
    if (jj_3R_863()) return true;
    }
    }
    if (jj_3R_130()) return true;
    return false;
  }

  final private boolean jj_3R_832() {
    if (jj_scan_token(FROM)) return true;
    if (jj_3R_130()) return true;
    return false;
  }

  final private boolean jj_3_61() {
    if (jj_3R_148()) return true;
    return false;
  }

  final private boolean jj_3R_586() {
    if (jj_scan_token(IDENTIFIER)) return true;
    if (jj_scan_token(IN)) return true;
    if (jj_3R_318()) return true;
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3_61()) jj_scanpos = xsp;
    xsp = jj_scanpos;
    if (jj_3R_832()) jj_scanpos = xsp;
    xsp = jj_scanpos;
    if (jj_3R_833()) jj_scanpos = xsp;
    xsp = jj_scanpos;
    if (jj_3R_834()) jj_scanpos = xsp;
    return false;
  }

  final private boolean jj_3R_605() {
    if (jj_3R_104()) return true;
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_856()) jj_scanpos = xsp;
    return false;
  }

  final private boolean jj_3R_838() {
    if (jj_3R_148()) return true;
    if (jj_3R_130()) return true;
    return false;
  }

  final private boolean jj_3R_825() {
    if (jj_scan_token(COMMA)) return true;
    if (jj_3R_104()) return true;
    return false;
  }

  final private boolean jj_3R_837() {
    if (jj_scan_token(DOWNTO)) return true;
    return false;
  }

  final private boolean jj_3R_836() {
    if (jj_scan_token(UPTO)) return true;
    return false;
  }

  final private boolean jj_3R_823() {
    if (jj_scan_token(COMMA)) return true;
    if (jj_3R_605()) return true;
    return false;
  }

  final private boolean jj_3R_824() {
    if (jj_scan_token(COMMA)) return true;
    if (jj_scan_token(CONST_NAME)) return true;
    return false;
  }

  final private boolean jj_3R_497() {
    if (jj_scan_token(DEFINEJAVAPACKAGES)) return true;
    Token xsp;
    xsp = jj_scanpos;
    if (jj_scan_token(251)) jj_scanpos = xsp;
    if (jj_3R_88()) return true;
    xsp = jj_scanpos;
    if (jj_scan_token(250)) jj_scanpos = xsp;
    if (jj_scan_token(LBRACE)) return true;
    if (jj_3R_104()) return true;
    while (true) {
      xsp = jj_scanpos;
      if (jj_3R_825()) { jj_scanpos = xsp; break; }
    }
    if (jj_scan_token(RBRACE)) return true;
    return false;
  }

  final private boolean jj_3R_835() {
    if (jj_scan_token(FROM)) return true;
    if (jj_3R_130()) return true;
    return false;
  }

  final private boolean jj_3R_581() {
    if (jj_scan_token(JAVAPACKAGES)) return true;
    if (jj_scan_token(LT)) return true;
    if (jj_3R_88()) return true;
    if (jj_scan_token(GT)) return true;
    return false;
  }

  final private boolean jj_3R_587() {
    if (jj_scan_token(IDENTIFIER)) return true;
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_835()) jj_scanpos = xsp;
    xsp = jj_scanpos;
    if (jj_scan_token(78)) {
    jj_scanpos = xsp;
    if (jj_3R_836()) {
    jj_scanpos = xsp;
    if (jj_3R_837()) return true;
    }
    }
    if (jj_3R_130()) return true;
    xsp = jj_scanpos;
    if (jj_3R_838()) jj_scanpos = xsp;
    return false;
  }

  final private boolean jj_3R_580() {
    if (jj_scan_token(JCOMCLASS)) return true;
    return false;
  }

  final private boolean jj_3R_579() {
    if (jj_scan_token(JAVACORBACLASS)) return true;
    return false;
  }

  final private boolean jj_3R_578() {
    if (jj_scan_token(JAVAENTERPRISECLASS)) return true;
    return false;
  }

  final private boolean jj_3R_577() {
    if (jj_scan_token(JAVABASECLASS)) return true;
    return false;
  }

  final private boolean jj_3R_576() {
    if (jj_scan_token(JAVAGUICLASS)) return true;
    return false;
  }

  final private boolean jj_3R_496() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_576()) {
    jj_scanpos = xsp;
    if (jj_3R_577()) {
    jj_scanpos = xsp;
    if (jj_3R_578()) {
    jj_scanpos = xsp;
    if (jj_3R_579()) {
    jj_scanpos = xsp;
    if (jj_3R_580()) {
    jj_scanpos = xsp;
    if (jj_3R_581()) return true;
    }
    }
    }
    }
    }
    if (jj_scan_token(CONST_NAME)) return true;
    while (true) {
      xsp = jj_scanpos;
      if (jj_3R_824()) { jj_scanpos = xsp; break; }
    }
    return false;
  }

  final private boolean jj_3R_495() {
    if (jj_scan_token(PRAGMA)) return true;
    if (jj_3R_104()) return true;
    Token xsp;
    xsp = jj_scanpos;
    if (jj_scan_token(248)) jj_scanpos = xsp;
    if (jj_3R_96()) return true;
    return false;
  }

  final private boolean jj_3R_840() {
    if (jj_3R_244()) return true;
    return false;
  }

  final private boolean jj_3R_607() {
    if (jj_scan_token(LT)) return true;
    if (jj_scan_token(STRING_LITERAL)) return true;
    if (jj_scan_token(GT)) return true;
    return false;
  }

  final private boolean jj_3R_675() {
    if (jj_scan_token(IFEXISTS)) return true;
    return false;
  }

  final private boolean jj_3R_839() {
    if (jj_3R_130()) return true;
    return false;
  }

  final private boolean jj_3R_674() {
    if (jj_scan_token(IF)) return true;
    if (jj_3R_130()) return true;
    return false;
  }

  final private boolean jj_3R_673() {
    if (jj_scan_token(IFDEF)) return true;
    if (jj_scan_token(CONST_NAME)) return true;
    return false;
  }

  final private boolean jj_3R_672() {
    if (jj_scan_token(IFNDEF)) return true;
    if (jj_scan_token(CONST_NAME)) return true;
    return false;
  }

  final private boolean jj_3R_606() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_672()) {
    jj_scanpos = xsp;
    if (jj_3R_673()) {
    jj_scanpos = xsp;
    if (jj_3R_674()) {
    jj_scanpos = xsp;
    if (jj_3R_675()) return true;
    }
    }
    }
    return false;
  }

  final private boolean jj_3R_650() {
    if (jj_3R_244()) return true;
    return false;
  }

  final private boolean jj_3R_588() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_650()) jj_scanpos = xsp;
    if (jj_scan_token(SEMICOLON)) return true;
    xsp = jj_scanpos;
    if (jj_3R_839()) jj_scanpos = xsp;
    if (jj_scan_token(SEMICOLON)) return true;
    xsp = jj_scanpos;
    if (jj_3R_840()) jj_scanpos = xsp;
    return false;
  }

  final private boolean jj_3R_494() {
    if (jj_scan_token(INCLUDE)) return true;
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_606()) jj_scanpos = xsp;
    xsp = jj_scanpos;
    if (jj_3R_607()) jj_scanpos = xsp;
    if (jj_scan_token(STRING_LITERAL)) return true;
    return false;
  }

  final private boolean jj_3R_493() {
    if (jj_scan_token(IMPORT)) return true;
    if (jj_3R_605()) return true;
    Token xsp;
    while (true) {
      xsp = jj_scanpos;
      if (jj_3R_823()) { jj_scanpos = xsp; break; }
    }
    if (jj_scan_token(SEMICOLON)) return true;
    return false;
  }

  final private boolean jj_3R_147() {
    if (jj_3R_244()) return true;
    return false;
  }

  final private boolean jj_3R_425() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_493()) {
    jj_scanpos = xsp;
    if (jj_3R_494()) {
    jj_scanpos = xsp;
    if (jj_3R_495()) {
    jj_scanpos = xsp;
    if (jj_3R_496()) {
    jj_scanpos = xsp;
    if (jj_3R_497()) return true;
    }
    }
    }
    }
    return false;
  }

  final private boolean jj_3_60() {
    if (jj_scan_token(LPAREN)) return true;
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_147()) jj_scanpos = xsp;
    if (jj_scan_token(SEMICOLON)) return true;
    return false;
  }

  final private boolean jj_3_59() {
    if (jj_scan_token(LPAREN)) return true;
    if (jj_scan_token(IDENTIFIER)) return true;
    Token xsp;
    xsp = jj_scanpos;
    if (jj_scan_token(40)) {
    jj_scanpos = xsp;
    if (jj_scan_token(78)) {
    jj_scanpos = xsp;
    if (jj_scan_token(79)) {
    jj_scanpos = xsp;
    if (jj_scan_token(83)) return true;
    }
    }
    }
    return false;
  }

  final private boolean jj_3_102() {
    if (jj_scan_token(OUTPUT)) return true;
    if (jj_scan_token(LBRACE)) return true;
    return false;
  }

  final private boolean jj_3_58() {
    if (jj_scan_token(IDENTIFIER)) return true;
    Token xsp;
    xsp = jj_scanpos;
    if (jj_scan_token(40)) {
    jj_scanpos = xsp;
    if (jj_scan_token(78)) {
    jj_scanpos = xsp;
    if (jj_scan_token(79)) {
    jj_scanpos = xsp;
    if (jj_scan_token(83)) return true;
    }
    }
    }
    return false;
  }

  final private boolean jj_3R_514() {
    if (jj_3R_588()) return true;
    if (jj_3R_123()) return true;
    return false;
  }

  final private boolean jj_3R_808() {
    if (jj_scan_token(OUTPUT)) return true;
    if (jj_3R_124()) return true;
    return false;
  }

  final private boolean jj_3R_513() {
    if (jj_scan_token(LPAREN)) return true;
    if (jj_3R_588()) return true;
    if (jj_scan_token(RPAREN)) return true;
    if (jj_3R_145()) return true;
    return false;
  }

  final private boolean jj_3_57() {
    if (jj_scan_token(LPAREN)) return true;
    if (jj_scan_token(IDENTIFIER)) return true;
    if (jj_scan_token(IN)) return true;
    return false;
  }

  final private boolean jj_3R_807() {
    if (jj_scan_token(NEEDSYSTEMIN)) return true;
    return false;
  }

  final private boolean jj_3_56() {
    if (jj_scan_token(IDENTIFIER)) return true;
    if (jj_scan_token(IN)) return true;
    return false;
  }

  final private boolean jj_3R_512() {
    if (jj_scan_token(LPAREN)) return true;
    if (jj_3R_587()) return true;
    if (jj_scan_token(RPAREN)) return true;
    if (jj_3R_145()) return true;
    return false;
  }

  final private boolean jj_3R_773() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_807()) jj_scanpos = xsp;
    xsp = jj_scanpos;
    if (jj_scan_token(313)) {
    jj_scanpos = xsp;
    if (jj_3R_808()) return true;
    }
    return false;
  }

  final private boolean jj_3R_806() {
    if (jj_scan_token(OUTPUT)) return true;
    if (jj_3R_124()) return true;
    return false;
  }

  final private boolean jj_3R_511() {
    if (jj_3R_587()) return true;
    if (jj_3R_123()) return true;
    return false;
  }

  final private boolean jj_3R_844() {
    if (jj_3R_130()) return true;
    return false;
  }

  final private boolean jj_3R_772() {
    if (jj_scan_token(INPUT)) return true;
    if (jj_3R_124()) return true;
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_806()) jj_scanpos = xsp;
    return false;
  }

  final private boolean jj_3R_864() {
    if (jj_scan_token(COMMA)) return true;
    if (jj_3R_88()) return true;
    if (jj_scan_token(ASSIGN)) return true;
    if (jj_3R_130()) return true;
    return false;
  }

  final private boolean jj_3R_521() {
    if (jj_3R_248()) return true;
    return false;
  }

  final private boolean jj_3R_510() {
    if (jj_scan_token(LPAREN)) return true;
    if (jj_3R_586()) return true;
    if (jj_scan_token(RPAREN)) return true;
    if (jj_3R_145()) return true;
    return false;
  }

  final private boolean jj_3_101() {
    if (jj_scan_token(LT)) return true;
    if (jj_scan_token(NEW)) return true;
    if (jj_scan_token(GT)) return true;
    Token xsp;
    xsp = jj_scanpos;
    if (jj_scan_token(131)) {
    jj_scanpos = xsp;
    if (jj_scan_token(132)) {
    jj_scanpos = xsp;
    if (jj_scan_token(133)) {
    jj_scanpos = xsp;
    if (jj_scan_token(313)) return true;
    }
    }
    }
    return false;
  }

  final private boolean jj_3R_509() {
    if (jj_3R_586()) return true;
    if (jj_3R_123()) return true;
    return false;
  }

  final private boolean jj_3_100() {
    if (jj_3R_88()) return true;
    if (jj_scan_token(ASSIGN)) return true;
    if (jj_3R_130()) return true;
    Token xsp;
    while (true) {
      xsp = jj_scanpos;
      if (jj_3R_864()) { jj_scanpos = xsp; break; }
    }
    return false;
  }

  final private boolean jj_3R_843() {
    if (jj_scan_token(LT)) return true;
    if (jj_scan_token(NEW)) return true;
    if (jj_scan_token(GT)) return true;
    return false;
  }

  final private boolean jj_3R_471() {
    if (jj_3R_119()) return true;
    if (jj_scan_token(COLON)) return true;
    return false;
  }

  final private boolean jj_3R_805() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_843()) jj_scanpos = xsp;
    xsp = jj_scanpos;
    if (jj_3_100()) {
    jj_scanpos = xsp;
    if (jj_3R_844()) return true;
    }
    return false;
  }

  final private boolean jj_3R_407() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_471()) jj_scanpos = xsp;
    if (jj_scan_token(FOR)) return true;
    xsp = jj_scanpos;
    if (jj_3R_509()) {
    jj_scanpos = xsp;
    if (jj_3R_510()) {
    jj_scanpos = xsp;
    if (jj_3R_511()) {
    jj_scanpos = xsp;
    if (jj_3R_512()) {
    jj_scanpos = xsp;
    if (jj_3R_513()) {
    jj_scanpos = xsp;
    if (jj_3R_514()) return true;
    }
    }
    }
    }
    }
    return false;
  }

  final private boolean jj_3R_804() {
    if (jj_scan_token(LT)) return true;
    if (jj_scan_token(NEW)) return true;
    if (jj_scan_token(GT)) return true;
    return false;
  }

  final private boolean jj_3R_842() {
    if (jj_scan_token(IDENTIFIER)) return true;
    return false;
  }

  final private boolean jj_3R_771() {
    if (jj_scan_token(WITH)) return true;
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_804()) {
    jj_scanpos = xsp;
    if (jj_3R_805()) return true;
    }
    return false;
  }

  final private boolean jj_3R_770() {
    if (jj_scan_token(FROM)) return true;
    if (jj_3R_130()) return true;
    return false;
  }

  final private boolean jj_3R_520() {
    if (jj_3R_130()) return true;
    return false;
  }

  final private boolean jj_3R_592() {
    if (jj_scan_token(SC_AND)) return true;
    return false;
  }

  final private boolean jj_3R_591() {
    if (jj_scan_token(LT)) return true;
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_842()) jj_scanpos = xsp;
    if (jj_scan_token(GT)) return true;
    return false;
  }

  final private boolean jj_3R_519() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_591()) {
    jj_scanpos = xsp;
    if (jj_3R_592()) return true;
    }
    return false;
  }

  final private boolean jj_3R_768() {
    if (jj_3R_148()) return true;
    return false;
  }

  final private boolean jj_3R_473() {
    if (jj_3R_119()) return true;
    if (jj_scan_token(COLON)) return true;
    return false;
  }

  final private boolean jj_3R_409() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_473()) jj_scanpos = xsp;
    if (jj_scan_token(REPEAT)) return true;
    if (jj_3R_130()) return true;
    xsp = jj_scanpos;
    if (jj_3R_768()) jj_scanpos = xsp;
    if (jj_3R_123()) return true;
    return false;
  }

  final private boolean jj_3R_518() {
    if (jj_scan_token(SLASH)) return true;
    if (jj_scan_token(IDENTIFIER)) return true;
    return false;
  }

  final private boolean jj_3R_413() {
    if (jj_scan_token(EXEC)) return true;
    Token xsp;
    while (true) {
      xsp = jj_scanpos;
      if (jj_3R_518()) { jj_scanpos = xsp; break; }
    }
    xsp = jj_scanpos;
    if (jj_3R_519()) jj_scanpos = xsp;
    xsp = jj_scanpos;
    if (jj_3R_520()) {
    jj_scanpos = xsp;
    if (jj_3R_521()) return true;
    }
    xsp = jj_scanpos;
    if (jj_3R_770()) jj_scanpos = xsp;
    xsp = jj_scanpos;
    if (jj_3R_771()) jj_scanpos = xsp;
    xsp = jj_scanpos;
    if (jj_3R_772()) {
    jj_scanpos = xsp;
    if (jj_3R_773()) return true;
    }
    return false;
  }

  final private boolean jj_3R_472() {
    if (jj_3R_119()) return true;
    if (jj_scan_token(COLON)) return true;
    return false;
  }

  final private boolean jj_3R_408() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_472()) jj_scanpos = xsp;
    if (jj_scan_token(DO)) return true;
    if (jj_3R_123()) return true;
    if (jj_scan_token(WHILE)) return true;
    if (jj_3R_130()) return true;
    if (jj_scan_token(SEMICOLON)) return true;
    return false;
  }

  final private boolean jj_3R_687() {
    if (jj_3R_145()) return true;
    return false;
  }

  final private boolean jj_3R_146() {
    if (jj_3R_130()) return true;
    return false;
  }

  final private boolean jj_3_55() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_146()) jj_scanpos = xsp;
    if (jj_scan_token(LBRACE)) return true;
    return false;
  }

  final private boolean jj_3R_585() {
    if (jj_3R_130()) return true;
    return false;
  }

  final private boolean jj_3R_508() {
    if (jj_scan_token(LPAREN)) return true;
    if (jj_3R_130()) return true;
    if (jj_scan_token(RPAREN)) return true;
    if (jj_3R_287()) return true;
    return false;
  }

  final private boolean jj_3R_507() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_585()) jj_scanpos = xsp;
    if (jj_3R_123()) return true;
    return false;
  }

  final private boolean jj_3R_470() {
    if (jj_3R_119()) return true;
    if (jj_scan_token(COLON)) return true;
    return false;
  }

  final private boolean jj_3R_406() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_470()) jj_scanpos = xsp;
    if (jj_scan_token(WHILE)) return true;
    xsp = jj_scanpos;
    if (jj_3R_507()) {
    jj_scanpos = xsp;
    if (jj_3R_508()) return true;
    }
    return false;
  }

  final private boolean jj_3R_142() {
    if (jj_scan_token(ELSE)) return true;
    if (jj_scan_token(IF)) return true;
    return false;
  }

  final private boolean jj_3_53() {
    if (jj_3R_130()) return true;
    if (jj_scan_token(LBRACE)) return true;
    return false;
  }

  final private boolean jj_3_99() {
    if (jj_scan_token(COMMA)) return true;
    if (jj_3R_88()) return true;
    return false;
  }

  final private boolean jj_3_51() {
    if (jj_3R_130()) return true;
    if (jj_scan_token(LBRACE)) return true;
    return false;
  }

  final private boolean jj_3R_919() {
    if (jj_scan_token(COMMA)) return true;
    if (jj_3R_98()) return true;
    return false;
  }

  final private boolean jj_3R_903() {
    if (jj_3R_98()) return true;
    Token xsp;
    while (true) {
      xsp = jj_scanpos;
      if (jj_3R_919()) { jj_scanpos = xsp; break; }
    }
    return false;
  }

  final private boolean jj_3R_879() {
    if (jj_scan_token(COMMA)) return true;
    if (jj_3R_878()) return true;
    return false;
  }

  final private boolean jj_3R_688() {
    if (jj_3R_145()) return true;
    return false;
  }

  final private boolean jj_3R_144() {
    if (jj_scan_token(LPAREN)) return true;
    if (jj_3R_130()) return true;
    if (jj_scan_token(RPAREN)) return true;
    if (jj_3R_145()) return true;
    return false;
  }

  final private boolean jj_3R_902() {
    if (jj_scan_token(HOOK)) return true;
    if (jj_3R_88()) return true;
    return false;
  }

  final private boolean jj_3R_143() {
    if (jj_3R_130()) return true;
    if (jj_3R_123()) return true;
    return false;
  }

  final private boolean jj_3_54() {
    if (jj_scan_token(ELSE)) return true;
    if (jj_3R_145()) return true;
    return false;
  }

  final private boolean jj_3R_878() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_902()) {
    jj_scanpos = xsp;
    if (jj_3R_903()) return true;
    }
    if (jj_scan_token(COLON)) return true;
    if (jj_3R_88()) return true;
    if (jj_scan_token(COLON)) return true;
    if (jj_3R_88()) return true;
    while (true) {
      xsp = jj_scanpos;
      if (jj_3_99()) { jj_scanpos = xsp; break; }
    }
    return false;
  }

  final private boolean jj_3R_516() {
    if (jj_scan_token(LPAREN)) return true;
    if (jj_3R_130()) return true;
    if (jj_scan_token(RPAREN)) return true;
    if (jj_3R_287()) return true;
    return false;
  }

  final private boolean jj_3R_515() {
    if (jj_3R_130()) return true;
    if (jj_3R_123()) return true;
    return false;
  }

  final private boolean jj_3_52() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_scan_token(32)) {
    jj_scanpos = xsp;
    if (jj_3R_142()) return true;
    }
    xsp = jj_scanpos;
    if (jj_3R_143()) {
    jj_scanpos = xsp;
    if (jj_3R_144()) return true;
    }
    return false;
  }

  final private boolean jj_3R_410() {
    if (jj_scan_token(IF)) return true;
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_515()) {
    jj_scanpos = xsp;
    if (jj_3R_516()) return true;
    }
    while (true) {
      xsp = jj_scanpos;
      if (jj_3_52()) { jj_scanpos = xsp; break; }
    }
    xsp = jj_scanpos;
    if (jj_3_54()) jj_scanpos = xsp;
    return false;
  }

  final private boolean jj_3R_852() {
    if (jj_3R_878()) return true;
    Token xsp;
    while (true) {
      xsp = jj_scanpos;
      if (jj_3R_879()) { jj_scanpos = xsp; break; }
    }
    return false;
  }

  final private boolean jj_3R_141() {
    if (jj_scan_token(IDENTIFIER)) return true;
    return false;
  }

  final private boolean jj_3R_803() {
    if (jj_3R_145()) return true;
    return false;
  }

  final private boolean jj_3R_841() {
    if (jj_scan_token(COMMA)) return true;
    if (jj_3R_130()) return true;
    return false;
  }

  final private boolean jj_3R_802() {
    if (jj_scan_token(_DEFAULT)) return true;
    return false;
  }

  final private boolean jj_3R_801() {
    if (jj_scan_token(CASE)) return true;
    if (jj_3R_130()) return true;
    Token xsp;
    while (true) {
      xsp = jj_scanpos;
      if (jj_3R_841()) { jj_scanpos = xsp; break; }
    }
    return false;
  }

  final private boolean jj_3R_769() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_801()) {
    jj_scanpos = xsp;
    if (jj_3R_802()) return true;
    }
    if (jj_scan_token(COLON)) return true;
    while (true) {
      xsp = jj_scanpos;
      if (jj_3R_803()) { jj_scanpos = xsp; break; }
    }
    return false;
  }

  final private boolean jj_3R_489() {
    if (jj_scan_token(GUIEVENTS)) return true;
    return false;
  }

  final private boolean jj_3R_853() {
    if (jj_3R_145()) return true;
    return false;
  }

  final private boolean jj_3R_280() {
    if (jj_3R_91()) return true;
    return false;
  }

  final private boolean jj_3R_411() {
    if (jj_scan_token(SWITCH)) return true;
    if (jj_3R_130()) return true;
    if (jj_scan_token(LBRACE)) return true;
    Token xsp;
    while (true) {
      xsp = jj_scanpos;
      if (jj_3R_769()) { jj_scanpos = xsp; break; }
    }
    if (jj_scan_token(RBRACE)) return true;
    return false;
  }

  final private boolean jj_3R_822() {
    if (jj_scan_token(LT)) return true;
    if (jj_3R_852()) return true;
    if (jj_scan_token(GT)) return true;
    if (jj_scan_token(COLON)) return true;
    Token xsp;
    if (jj_3R_853()) return true;
    while (true) {
      xsp = jj_scanpos;
      if (jj_3R_853()) { jj_scanpos = xsp; break; }
    }
    return false;
  }

  final private boolean jj_3R_136() {
    if (jj_3R_241()) return true;
    return false;
  }

  final private boolean jj_3R_228() {
    if (jj_scan_token(FINALLY)) return true;
    if (jj_scan_token(COLON)) return true;
    Token xsp;
    if (jj_3R_688()) return true;
    while (true) {
      xsp = jj_scanpos;
      if (jj_3R_688()) { jj_scanpos = xsp; break; }
    }
    return false;
  }

  final private boolean jj_3R_786() {
    if (jj_3R_822()) return true;
    return false;
  }

  final private boolean jj_3_50() {
    if (jj_scan_token(CATCH)) return true;
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_141()) jj_scanpos = xsp;
    if (jj_scan_token(COLON)) return true;
    if (jj_3R_687()) return true;
    while (true) {
      xsp = jj_scanpos;
      if (jj_3R_687()) { jj_scanpos = xsp; break; }
    }
    return false;
  }

  final private boolean jj_3R_227() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_279()) {
    jj_scanpos = xsp;
    if (jj_3R_280()) return true;
    }
    return false;
  }

  final private boolean jj_3R_279() {
    if (jj_3R_145()) return true;
    return false;
  }

  final private boolean jj_3R_750() {
    if (jj_3R_91()) return true;
    return false;
  }

  final private boolean jj_3R_133() {
    if (jj_scan_token(SYSTEMID)) return true;
    if (jj_3R_130()) return true;
    return false;
  }

  final private boolean jj_3R_124() {
    if (jj_scan_token(LBRACE)) return true;
    Token xsp;
    while (true) {
      xsp = jj_scanpos;
      if (jj_3R_227()) { jj_scanpos = xsp; break; }
    }
    xsp = jj_scanpos;
    if (jj_3_50()) jj_scanpos = xsp;
    xsp = jj_scanpos;
    if (jj_3R_228()) jj_scanpos = xsp;
    if (jj_scan_token(RBRACE)) return true;
    return false;
  }

  final private boolean jj_3R_422() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_scan_token(218)) {
    jj_scanpos = xsp;
    if (jj_3R_489()) return true;
    }
    if (jj_scan_token(LBRACE)) return true;
    while (true) {
      xsp = jj_scanpos;
      if (jj_3R_786()) { jj_scanpos = xsp; break; }
    }
    if (jj_scan_token(RBRACE)) return true;
    return false;
  }

  final private boolean jj_3R_918() {
    if (jj_scan_token(LTPERC)) return true;
    if (jj_scan_token(GT)) return true;
    return false;
  }

  final private boolean jj_3R_917() {
    if (jj_scan_token(LTPERCDASHDASH)) return true;
    if (jj_scan_token(GT)) return true;
    return false;
  }

  final private boolean jj_3R_916() {
    if (jj_scan_token(LTPERCEQ)) return true;
    if (jj_scan_token(GT)) return true;
    return false;
  }

  final private boolean jj_3R_749() {
    if (jj_3R_145()) return true;
    return false;
  }

  final private boolean jj_3R_742() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_749()) {
    jj_scanpos = xsp;
    if (jj_3R_750()) return true;
    }
    return false;
  }

  final private boolean jj_3R_135() {
    if (jj_scan_token(IN)) return true;
    if (jj_3R_130()) return true;
    return false;
  }

  final private boolean jj_3R_132() {
    if (jj_3R_241()) return true;
    return false;
  }

  final private boolean jj_3R_925() {
    if (jj_3R_88()) return true;
    return false;
  }

  final private boolean jj_3R_915() {
    if (jj_scan_token(LTPERCBAN)) return true;
    if (jj_scan_token(GT)) return true;
    return false;
  }

  final private boolean jj_3R_914() {
    if (jj_scan_token(LTPERCAMP)) return true;
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_925()) jj_scanpos = xsp;
    if (jj_scan_token(GT)) return true;
    return false;
  }

  final private boolean jj_3R_901() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_914()) {
    jj_scanpos = xsp;
    if (jj_3R_915()) {
    jj_scanpos = xsp;
    if (jj_3R_916()) {
    jj_scanpos = xsp;
    if (jj_3R_917()) {
    jj_scanpos = xsp;
    if (jj_3R_918()) return true;
    }
    }
    }
    }
    return false;
  }

  final private boolean jj_3R_123() {
    if (jj_scan_token(LBRACE)) return true;
    Token xsp;
    while (true) {
      xsp = jj_scanpos;
      if (jj_3R_742()) { jj_scanpos = xsp; break; }
    }
    if (jj_scan_token(RBRACE)) return true;
    return false;
  }

  final private boolean jj_3R_913() {
    if (jj_scan_token(LTQUES)) return true;
    if (jj_scan_token(GT)) return true;
    return false;
  }

  final private boolean jj_3R_912() {
    if (jj_scan_token(LTBAN)) return true;
    if (jj_scan_token(GT)) return true;
    return false;
  }

  final private boolean jj_3R_911() {
    if (jj_scan_token(SGML_COMMENT)) return true;
    if (jj_scan_token(GT)) return true;
    return false;
  }

  final private boolean jj_3R_900() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_911()) {
    jj_scanpos = xsp;
    if (jj_3R_912()) {
    jj_scanpos = xsp;
    if (jj_3R_913()) return true;
    }
    }
    return false;
  }

  final private boolean jj_3R_899() {
    if (jj_scan_token(COLON)) return true;
    if (jj_scan_token(IDENTIFIER)) return true;
    return false;
  }

  final private boolean jj_3R_924() {
    if (jj_scan_token(COLON)) return true;
    if (jj_3R_88()) return true;
    return false;
  }

  final private boolean jj_3R_131() {
    if (jj_scan_token(IN)) return true;
    if (jj_3R_130()) return true;
    return false;
  }

  final private boolean jj_3R_910() {
    if (jj_3R_88()) return true;
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_924()) jj_scanpos = xsp;
    return false;
  }

  final private boolean jj_3R_898() {
    if (jj_scan_token(LT)) return true;
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_910()) jj_scanpos = xsp;
    if (jj_scan_token(GT)) return true;
    return false;
  }

  final private boolean jj_3R_357() {
    if (jj_scan_token(ANTTASK__)) return true;
    if (true) { jj_la = 0; jj_scanpos = jj_lastpos; return false;}
    return false;
  }

  final private boolean jj_3R_909() {
    if (jj_scan_token(COLON)) return true;
    if (jj_3R_88()) return true;
    return false;
  }

  final private boolean jj_3R_356() {
    if (jj_3R_425()) return true;
    return false;
  }

  final private boolean jj_3R_355() {
    if (jj_scan_token(USE)) return true;
    if (jj_scan_token(NAMESPACE)) return true;
    if (jj_3R_119()) return true;
    if (jj_scan_token(SEMICOLON)) return true;
    return false;
  }

  final private boolean jj_3R_354() {
    if (jj_3R_424()) return true;
    return false;
  }

  final private boolean jj_3R_353() {
    if (jj_3R_423()) return true;
    return false;
  }

  final private boolean jj_3R_897() {
    if (jj_scan_token(LTSLASH)) return true;
    if (jj_3R_88()) return true;
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_909()) jj_scanpos = xsp;
    if (jj_scan_token(GT)) return true;
    return false;
  }

  final private boolean jj_3R_352() {
    if (jj_3R_422()) return true;
    return false;
  }

  final private boolean jj_3R_876() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_897()) {
    jj_scanpos = xsp;
    if (jj_3R_898()) {
    jj_scanpos = xsp;
    if (jj_3R_899()) {
    jj_scanpos = xsp;
    if (jj_3R_900()) {
    jj_scanpos = xsp;
    if (jj_3R_901()) return true;
    }
    }
    }
    }
    return false;
  }

  final private boolean jj_3R_140() {
    if (jj_3R_119()) return true;
    if (jj_scan_token(COLON)) return true;
    return false;
  }

  final private boolean jj_3R_351() {
    if (jj_3R_421()) return true;
    return false;
  }

  final private boolean jj_3R_139() {
    if (jj_3R_119()) return true;
    if (jj_scan_token(COLON)) return true;
    return false;
  }

  final private boolean jj_3_49() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_140()) jj_scanpos = xsp;
    if (jj_scan_token(REPEAT)) return true;
    return false;
  }

  final private boolean jj_3R_350() {
    if (jj_3R_420()) return true;
    return false;
  }

  final private boolean jj_3R_138() {
    if (jj_3R_119()) return true;
    if (jj_scan_token(COLON)) return true;
    return false;
  }

  final private boolean jj_3_48() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_139()) jj_scanpos = xsp;
    if (jj_scan_token(DO)) return true;
    if (jj_scan_token(LBRACE)) return true;
    return false;
  }

  final private boolean jj_3R_349() {
    if (jj_3R_419()) return true;
    return false;
  }

  final private boolean jj_3R_137() {
    if (jj_3R_119()) return true;
    if (jj_scan_token(COLON)) return true;
    return false;
  }

  final private boolean jj_3_47() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_138()) jj_scanpos = xsp;
    if (jj_scan_token(FOR)) return true;
    return false;
  }

  final private boolean jj_3R_348() {
    if (jj_3R_418()) return true;
    return false;
  }

  final private boolean jj_3_46() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_137()) jj_scanpos = xsp;
    if (jj_scan_token(WHILE)) return true;
    return false;
  }

  final private boolean jj_3R_347() {
    if (jj_3R_417()) return true;
    return false;
  }

  final private boolean jj_3R_134() {
    if (jj_3R_119()) return true;
    if (jj_scan_token(COLON)) return true;
    return false;
  }

  final private boolean jj_3R_346() {
    if (jj_3R_416()) return true;
    return false;
  }

  final private boolean jj_3_45() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_134()) jj_scanpos = xsp;
    if (jj_scan_token(DO)) return true;
    if (jj_3R_130()) return true;
    xsp = jj_scanpos;
    if (jj_3R_135()) jj_scanpos = xsp;
    xsp = jj_scanpos;
    if (jj_3R_136()) jj_scanpos = xsp;
    if (jj_scan_token(AS)) return true;
    if (jj_scan_token(IDENTIFIER)) return true;
    return false;
  }

  final private boolean jj_3R_345() {
    if (jj_3R_415()) return true;
    return false;
  }

  final private boolean jj_3_98() {
    if (jj_3R_145()) return true;
    return false;
  }

  final private boolean jj_3R_344() {
    if (jj_3R_414()) return true;
    return false;
  }

  final private boolean jj_3_44() {
    if (jj_scan_token(DO)) return true;
    if (jj_3R_130()) return true;
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_131()) jj_scanpos = xsp;
    xsp = jj_scanpos;
    if (jj_3R_132()) jj_scanpos = xsp;
    xsp = jj_scanpos;
    if (jj_3R_133()) jj_scanpos = xsp;
    if (jj_scan_token(AS)) return true;
    if (jj_scan_token(XML)) return true;
    return false;
  }

  final private boolean jj_3R_343() {
    if (jj_3R_413()) return true;
    return false;
  }

  final private boolean jj_3R_342() {
    if (jj_3R_412()) return true;
    return false;
  }

  final private boolean jj_3R_341() {
    if (jj_3R_411()) return true;
    return false;
  }

  final private boolean jj_3R_340() {
    if (jj_3R_410()) return true;
    return false;
  }

  final private boolean jj_3R_339() {
    if (jj_3R_409()) return true;
    return false;
  }

  final private boolean jj_3R_338() {
    if (jj_3R_408()) return true;
    return false;
  }

  final private boolean jj_3R_877() {
    if (jj_scan_token(COMMA)) return true;
    if (jj_3R_876()) return true;
    return false;
  }

  final private boolean jj_3R_337() {
    if (jj_3R_407()) return true;
    return false;
  }

  final private boolean jj_3R_336() {
    if (jj_3R_406()) return true;
    return false;
  }

  final private boolean jj_3R_851() {
    if (jj_3R_876()) return true;
    Token xsp;
    while (true) {
      xsp = jj_scanpos;
      if (jj_3R_877()) { jj_scanpos = xsp; break; }
    }
    if (jj_scan_token(COLON)) return true;
    if (jj_3_98()) return true;
    while (true) {
      xsp = jj_scanpos;
      if (jj_3_98()) { jj_scanpos = xsp; break; }
    }
    return false;
  }

  final private boolean jj_3R_335() {
    if (jj_3R_405()) return true;
    return false;
  }

  final private boolean jj_3R_334() {
    if (jj_3R_404()) return true;
    return false;
  }

  final private boolean jj_3R_129() {
    if (jj_scan_token(COMMA)) return true;
    if (jj_scan_token(IDENTIFIER)) return true;
    return false;
  }

  final private boolean jj_3R_333() {
    if (jj_scan_token(WITH)) return true;
    if (jj_3R_130()) return true;
    if (jj_3R_124()) return true;
    return false;
  }

  final private boolean jj_3R_332() {
    if (jj_scan_token(DELETE)) return true;
    if (jj_3R_98()) return true;
    if (jj_scan_token(SEMICOLON)) return true;
    return false;
  }

  final private boolean jj_3R_331() {
    if (jj_scan_token(RESUME)) return true;
    if (jj_scan_token(SEMICOLON)) return true;
    return false;
  }

  final private boolean jj_3R_433() {
    if (jj_3R_318()) return true;
    return false;
  }

  final private boolean jj_3R_330() {
    if (jj_scan_token(RETURN)) return true;
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_433()) jj_scanpos = xsp;
    if (jj_scan_token(SEMICOLON)) return true;
    return false;
  }

  final private boolean jj_3R_506() {
    if (jj_scan_token(SCHEDULE)) return true;
    return false;
  }

  final private boolean jj_3R_505() {
    if (jj_3R_119()) return true;
    return false;
  }

  final private boolean jj_3R_432() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_505()) {
    jj_scanpos = xsp;
    if (jj_3R_506()) return true;
    }
    return false;
  }

  final private boolean jj_3R_329() {
    if (jj_scan_token(CONTINUE)) return true;
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_432()) jj_scanpos = xsp;
    if (jj_scan_token(SEMICOLON)) return true;
    return false;
  }

  final private boolean jj_3R_504() {
    if (jj_scan_token(SCHEDULE)) return true;
    return false;
  }

  final private boolean jj_3R_503() {
    if (jj_3R_119()) return true;
    return false;
  }

  final private boolean jj_3R_431() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_503()) {
    jj_scanpos = xsp;
    if (jj_3R_504()) return true;
    }
    return false;
  }

  final private boolean jj_3R_328() {
    if (jj_scan_token(BREAK)) return true;
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_431()) jj_scanpos = xsp;
    if (jj_scan_token(SEMICOLON)) return true;
    return false;
  }

  final private boolean jj_3_42() {
    if (jj_scan_token(LPAREN)) return true;
    if (jj_scan_token(IDENTIFIER)) return true;
    Token xsp;
    while (true) {
      xsp = jj_scanpos;
      if (jj_3R_129()) { jj_scanpos = xsp; break; }
    }
    if (jj_scan_token(RPAREN)) return true;
    if (jj_scan_token(ASSIGN)) return true;
    return false;
  }

  final private boolean jj_3R_327() {
    if (jj_scan_token(SEMICOLON)) return true;
    return false;
  }

  final private boolean jj_3_41() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_scan_token(90)) {
    jj_scanpos = xsp;
    if (jj_scan_token(54)) return true;
    }
    xsp = jj_scanpos;
    if (jj_scan_token(303)) jj_scanpos = xsp;
    if (jj_scan_token(IDENTIFIER)) return true;
    return false;
  }

  final private boolean jj_3R_818() {
    if (jj_3R_851()) return true;
    return false;
  }

  final private boolean jj_3R_816() {
    if (jj_scan_token(CASE)) return true;
    return false;
  }

  final private boolean jj_3R_241() {
    if (jj_scan_token(LBRACE)) return true;
    if (jj_3R_130()) return true;
    if (jj_scan_token(RBRACE)) return true;
    return false;
  }

  final private boolean jj_3_43() {
    if (jj_3R_130()) return true;
    if (jj_scan_token(SEMICOLON)) return true;
    return false;
  }

  final private boolean jj_3_39() {
    if (jj_3R_126()) return true;
    if (jj_3R_128()) return true;
    if (jj_scan_token(SEMICOLON)) return true;
    return false;
  }

  final private boolean jj_3R_817() {
    if (jj_scan_token(EXTENDS)) return true;
    if (jj_scan_token(IDENTIFIER)) return true;
    return false;
  }

  final private boolean jj_3R_326() {
    if (jj_3R_403()) return true;
    return false;
  }

  final private boolean jj_3R_779() {
    if (jj_scan_token(JSP)) return true;
    return false;
  }

  final private boolean jj_3R_325() {
    if (jj_3R_402()) return true;
    return false;
  }

  final private boolean jj_3R_781() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_817()) jj_scanpos = xsp;
    if (jj_scan_token(LBRACE)) return true;
    while (true) {
      xsp = jj_scanpos;
      if (jj_3R_818()) { jj_scanpos = xsp; break; }
    }
    if (jj_scan_token(RBRACE)) return true;
    return false;
  }

  final private boolean jj_3_38() {
    if (jj_3R_126()) return true;
    if (jj_3R_127()) return true;
    if (jj_scan_token(SEMICOLON)) return true;
    return false;
  }

  final private boolean jj_3R_780() {
    if (jj_scan_token(WITH)) return true;
    if (jj_scan_token(IDENTIFIER)) return true;
    if (jj_scan_token(SEMICOLON)) return true;
    return false;
  }

  final private boolean jj_3R_778() {
    if (jj_scan_token(SGML)) return true;
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_816()) jj_scanpos = xsp;
    return false;
  }

  final private boolean jj_3_40() {
    if (jj_scan_token(SUPER)) return true;
    if (jj_3R_128()) return true;
    return false;
  }

  final private boolean jj_3_37() {
    if (jj_3R_126()) return true;
    Token xsp;
    xsp = jj_scanpos;
    if (jj_scan_token(257)) {
    jj_scanpos = xsp;
    if (jj_scan_token(258)) return true;
    }
    return false;
  }

  final private boolean jj_3R_324() {
    if (jj_3R_126()) return true;
    if (jj_3R_128()) return true;
    if (jj_scan_token(SEMICOLON)) return true;
    return false;
  }

  final private boolean jj_3R_777() {
    if (jj_3R_241()) return true;
    return false;
  }

  final private boolean jj_3R_776() {
    if (jj_scan_token(IN)) return true;
    if (jj_3R_130()) return true;
    return false;
  }

  final private boolean jj_3R_323() {
    if (jj_3R_126()) return true;
    if (jj_3R_127()) return true;
    if (jj_scan_token(SEMICOLON)) return true;
    return false;
  }

  final private boolean jj_3_36() {
    if (jj_3R_119()) return true;
    if (jj_scan_token(COLONCOLON)) return true;
    return false;
  }

  final private boolean jj_3R_122() {
    if (jj_scan_token(IDENTIFIER)) return true;
    return false;
  }

  final private boolean jj_3R_420() {
    if (jj_scan_token(DO)) return true;
    if (jj_3R_130()) return true;
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_776()) jj_scanpos = xsp;
    xsp = jj_scanpos;
    if (jj_3R_777()) jj_scanpos = xsp;
    if (jj_scan_token(AS)) return true;
    xsp = jj_scanpos;
    if (jj_3R_778()) {
    jj_scanpos = xsp;
    if (jj_scan_token(214)) {
    jj_scanpos = xsp;
    if (jj_3R_779()) return true;
    }
    }
    xsp = jj_scanpos;
    if (jj_3R_780()) {
    jj_scanpos = xsp;
    if (jj_3R_781()) return true;
    }
    return false;
  }

  final private boolean jj_3R_322() {
    if (jj_3R_126()) return true;
    if (jj_3R_127()) return true;
    if (jj_scan_token(SEMICOLON)) return true;
    return false;
  }

  final private boolean jj_3R_321() {
    if (jj_3R_130()) return true;
    if (jj_scan_token(SEMICOLON)) return true;
    return false;
  }

  final private boolean jj_3_35() {
    if (jj_3R_125()) return true;
    return false;
  }

  final private boolean jj_3R_287() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3_35()) {
    jj_scanpos = xsp;
    if (jj_3R_321()) {
    jj_scanpos = xsp;
    if (jj_3R_322()) {
    jj_scanpos = xsp;
    if (jj_3R_323()) {
    jj_scanpos = xsp;
    if (jj_3R_324()) {
    jj_scanpos = xsp;
    if (jj_3_40()) {
    jj_scanpos = xsp;
    if (jj_3R_325()) {
    jj_scanpos = xsp;
    if (jj_3R_326()) {
    jj_scanpos = xsp;
    if (jj_3_43()) {
    jj_scanpos = xsp;
    if (jj_3R_327()) {
    jj_scanpos = xsp;
    if (jj_3R_328()) {
    jj_scanpos = xsp;
    if (jj_3R_329()) {
    jj_scanpos = xsp;
    if (jj_3R_330()) {
    jj_scanpos = xsp;
    if (jj_3R_331()) {
    jj_scanpos = xsp;
    if (jj_3R_332()) {
    jj_scanpos = xsp;
    if (jj_3R_333()) {
    jj_scanpos = xsp;
    if (jj_3R_334()) {
    jj_scanpos = xsp;
    if (jj_3R_335()) {
    jj_scanpos = xsp;
    if (jj_3R_336()) {
    jj_scanpos = xsp;
    if (jj_3R_337()) {
    jj_scanpos = xsp;
    if (jj_3R_338()) {
    jj_scanpos = xsp;
    if (jj_3R_339()) {
    jj_scanpos = xsp;
    if (jj_3R_340()) {
    jj_scanpos = xsp;
    if (jj_3R_341()) {
    jj_scanpos = xsp;
    if (jj_3R_342()) {
    jj_scanpos = xsp;
    if (jj_3R_343()) {
    jj_scanpos = xsp;
    if (jj_3R_344()) {
    jj_scanpos = xsp;
    if (jj_3R_345()) {
    jj_scanpos = xsp;
    if (jj_3R_346()) {
    jj_scanpos = xsp;
    if (jj_3R_347()) {
    jj_scanpos = xsp;
    if (jj_3R_348()) {
    jj_scanpos = xsp;
    if (jj_3R_349()) {
    jj_scanpos = xsp;
    if (jj_3R_350()) {
    jj_scanpos = xsp;
    if (jj_3R_351()) {
    jj_scanpos = xsp;
    if (jj_3R_352()) {
    jj_scanpos = xsp;
    if (jj_3R_353()) {
    jj_scanpos = xsp;
    if (jj_3R_354()) {
    jj_scanpos = xsp;
    if (jj_3R_355()) {
    jj_scanpos = xsp;
    if (jj_3R_356()) {
    jj_scanpos = xsp;
    if (jj_3R_357()) return true;
    }
    }
    }
    }
    }
    }
    }
    }
    }
    }
    }
    }
    }
    }
    }
    }
    }
    }
    }
    }
    }
    }
    }
    }
    }
    }
    }
    }
    }
    }
    }
    }
    }
    }
    }
    }
    }
    }
    }
    return false;
  }

  final private boolean jj_3R_888() {
    if (jj_scan_token(COLON)) return true;
    if (jj_3R_88()) return true;
    return false;
  }

  final private boolean jj_3R_263() {
    if (jj_3R_88()) return true;
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_888()) jj_scanpos = xsp;
    return false;
  }

  final private boolean jj_3_33() {
    if (jj_scan_token(FINALLY)) return true;
    if (jj_3R_123()) return true;
    return false;
  }

  final private boolean jj_3_32() {
    if (jj_scan_token(CATCH)) return true;
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_122()) jj_scanpos = xsp;
    if (jj_3R_123()) return true;
    return false;
  }

  final private boolean jj_3_97() {
    if (jj_3R_145()) return true;
    return false;
  }

  final private boolean jj_3R_243() {
    if (jj_scan_token(TRY)) return true;
    if (jj_3R_123()) return true;
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3_32()) jj_scanpos = xsp;
    xsp = jj_scanpos;
    if (jj_3_33()) jj_scanpos = xsp;
    return false;
  }

  final private boolean jj_3R_908() {
    if (jj_scan_token(MINUS)) return true;
    return false;
  }

  final private boolean jj_3R_242() {
    if (jj_3R_287()) return true;
    return false;
  }

  final private boolean jj_3R_907() {
    if (jj_scan_token(PLUS)) return true;
    return false;
  }

  final private boolean jj_3R_889() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_907()) {
    jj_scanpos = xsp;
    if (jj_3R_908()) return true;
    }
    return false;
  }

  final private boolean jj_3R_145() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3_34()) {
    jj_scanpos = xsp;
    if (jj_3R_242()) {
    jj_scanpos = xsp;
    if (jj_3R_243()) return true;
    }
    }
    return false;
  }

  final private boolean jj_3_34() {
    if (jj_3R_124()) return true;
    return false;
  }

  final private boolean jj_3R_262() {
    if (jj_scan_token(LTSLASH)) return true;
    return false;
  }

  final private boolean jj_3R_861() {
    if (jj_scan_token(IDENTIFIER)) return true;
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_889()) jj_scanpos = xsp;
    return false;
  }

  final private boolean jj_3R_167() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_scan_token(251)) {
    jj_scanpos = xsp;
    if (jj_3R_262()) return true;
    }
    if (jj_3R_263()) return true;
    if (jj_scan_token(GT)) return true;
    xsp = jj_scanpos;
    if (jj_3R_861()) jj_scanpos = xsp;
    if (jj_scan_token(COLON)) return true;
    if (jj_3_97()) return true;
    while (true) {
      xsp = jj_scanpos;
      if (jj_3_97()) { jj_scanpos = xsp; break; }
    }
    return false;
  }

  final private boolean jj_3R_217() {
    if (jj_3R_148()) return true;
    return false;
  }

  final private boolean jj_3R_216() {
    if (jj_3R_251()) return true;
    return false;
  }

  final private boolean jj_3R_215() {
    if (jj_scan_token(DOUBLE)) return true;
    return false;
  }

  final private boolean jj_3R_214() {
    if (jj_scan_token(FLOAT)) return true;
    return false;
  }

  final private boolean jj_3R_213() {
    if (jj_scan_token(LONG)) return true;
    return false;
  }

  final private boolean jj_3R_212() {
    if (jj_scan_token(INT)) return true;
    return false;
  }

  final private boolean jj_3R_211() {
    if (jj_scan_token(SHORT)) return true;
    return false;
  }

  final private boolean jj_3R_210() {
    if (jj_scan_token(CHAR)) return true;
    return false;
  }

  final private boolean jj_3R_209() {
    if (jj_scan_token(BYTE)) return true;
    return false;
  }

  final private boolean jj_3R_283() {
    if (jj_scan_token(COMMA)) return true;
    if (jj_3R_282()) return true;
    return false;
  }

  final private boolean jj_3R_821() {
    if (jj_scan_token(PARAMETERS)) return true;
    if (jj_3R_294()) return true;
    return false;
  }

  final private boolean jj_3R_208() {
    if (jj_scan_token(BOOLEAN)) return true;
    return false;
  }

  final private boolean jj_3R_100() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_208()) {
    jj_scanpos = xsp;
    if (jj_3R_209()) {
    jj_scanpos = xsp;
    if (jj_3R_210()) {
    jj_scanpos = xsp;
    if (jj_3R_211()) {
    jj_scanpos = xsp;
    if (jj_3R_212()) {
    jj_scanpos = xsp;
    if (jj_3R_213()) {
    jj_scanpos = xsp;
    if (jj_3R_214()) {
    jj_scanpos = xsp;
    if (jj_3R_215()) {
    jj_scanpos = xsp;
    if (jj_3R_216()) {
    jj_scanpos = xsp;
    if (jj_3R_217()) return true;
    }
    }
    }
    }
    }
    }
    }
    }
    }
    return false;
  }

  final private boolean jj_3R_820() {
    if (jj_scan_token(OUTPUTPROPERTIES)) return true;
    if (jj_3R_294()) return true;
    return false;
  }

  final private boolean jj_3R_785() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_820()) {
    jj_scanpos = xsp;
    if (jj_3R_821()) return true;
    }
    return false;
  }

  final private boolean jj_3R_819() {
    if (jj_scan_token(SYSTEMID)) return true;
    if (jj_3R_130()) return true;
    return false;
  }

  final private boolean jj_3R_784() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_scan_token(78)) {
    jj_scanpos = xsp;
    if (jj_scan_token(52)) return true;
    }
    if (jj_3R_130()) return true;
    xsp = jj_scanpos;
    if (jj_3R_819()) jj_scanpos = xsp;
    return false;
  }

  final private boolean jj_3_31() {
    if (jj_scan_token(LPAREN)) return true;
    if (jj_3R_100()) return true;
    if (jj_scan_token(RPAREN)) return true;
    return false;
  }

  final private boolean jj_3R_783() {
    if (jj_scan_token(AS)) return true;
    if (jj_scan_token(DOM)) return true;
    return false;
  }

  final private boolean jj_3R_282() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3_31()) jj_scanpos = xsp;
    if (jj_3R_318()) return true;
    return false;
  }

  final private boolean jj_3R_782() {
    if (jj_scan_token(SYSTEMID)) return true;
    if (jj_3R_130()) return true;
    return false;
  }

  final private boolean jj_3_96() {
    if (jj_scan_token(SYSTEMID)) return true;
    if (jj_3R_130()) return true;
    return false;
  }

  final private boolean jj_3R_232() {
    if (jj_3R_282()) return true;
    Token xsp;
    while (true) {
      xsp = jj_scanpos;
      if (jj_3R_283()) { jj_scanpos = xsp; break; }
    }
    return false;
  }

  final private boolean jj_3R_127() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_232()) jj_scanpos = xsp;
    return false;
  }

  final private boolean jj_3R_604() {
    if (jj_scan_token(XPATH)) return true;
    if (jj_scan_token(LPAREN)) return true;
    return false;
  }

  final private boolean jj_3R_531() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_604()) jj_scanpos = xsp;
    if (jj_3R_130()) return true;
    xsp = jj_scanpos;
    if (jj_3_96()) jj_scanpos = xsp;
    xsp = jj_scanpos;
    if (jj_scan_token(304)) jj_scanpos = xsp;
    if (jj_scan_token(ON)) return true;
    return false;
  }

  final private boolean jj_3R_530() {
    if (jj_scan_token(COPY)) return true;
    return false;
  }

  final private boolean jj_3R_233() {
    if (jj_scan_token(LLBRACE)) return true;
    return false;
  }

  final private boolean jj_3R_421() {
    if (jj_scan_token(XSLT)) return true;
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_530()) {
    jj_scanpos = xsp;
    if (jj_3R_531()) return true;
    }
    if (jj_3R_130()) return true;
    xsp = jj_scanpos;
    if (jj_3R_782()) jj_scanpos = xsp;
    xsp = jj_scanpos;
    if (jj_3R_783()) {
    jj_scanpos = xsp;
    if (jj_3R_784()) return true;
    }
    while (true) {
      xsp = jj_scanpos;
      if (jj_3R_785()) { jj_scanpos = xsp; break; }
    }
    if (jj_scan_token(SEMICOLON)) return true;
    return false;
  }

  final private boolean jj_3_94() {
    if (jj_scan_token(COMMA)) return true;
    if (jj_3R_169()) return true;
    return false;
  }

  final private boolean jj_3R_128() {
    if (jj_scan_token(LPAREN)) return true;
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_233()) jj_scanpos = xsp;
    if (jj_3R_127()) return true;
    xsp = jj_scanpos;
    if (jj_scan_token(302)) jj_scanpos = xsp;
    if (jj_scan_token(RPAREN)) return true;
    return false;
  }

  final private boolean jj_3R_268() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_scan_token(84)) {
    jj_scanpos = xsp;
    if (jj_scan_token(37)) return true;
    }
    return false;
  }

  final private boolean jj_3R_745() {
    if (jj_scan_token(ASSIGN)) return true;
    if (jj_3R_268()) return true;
    return false;
  }

  final private boolean jj_3R_264() {
    if (jj_3R_88()) return true;
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_745()) jj_scanpos = xsp;
    return false;
  }

  final private boolean jj_3R_170() {
    if (jj_scan_token(COLON)) return true;
    if (jj_3R_88()) return true;
    return false;
  }

  final private boolean jj_3R_187() {
    if (jj_scan_token(NL)) return true;
    return false;
  }

  final private boolean jj_3R_186() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_scan_token(17)) {
    jj_scanpos = xsp;
    if (jj_scan_token(18)) return true;
    }
    return false;
  }

  final private boolean jj_3R_169() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3_95()) {
    jj_scanpos = xsp;
    if (jj_3R_264()) return true;
    }
    return false;
  }

  final private boolean jj_3_95() {
    if (jj_scan_token(XMLNS)) return true;
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_170()) jj_scanpos = xsp;
    if (jj_scan_token(ASSIGN)) return true;
    if (jj_scan_token(STRING_LITERAL)) return true;
    return false;
  }

  final private boolean jj_3R_185() {
    if (jj_scan_token(INFINITY)) return true;
    return false;
  }

  final private boolean jj_3R_121() {
    if (jj_3R_104()) return true;
    return false;
  }

  final private boolean jj_3R_184() {
    if (jj_scan_token(MIN_NUMBER)) return true;
    return false;
  }

  final private boolean jj_3R_183() {
    if (jj_scan_token(MAX_NUMBER)) return true;
    return false;
  }

  final private boolean jj_3R_182() {
    if (jj_scan_token(UNDEFINED)) return true;
    return false;
  }

  final private boolean jj_3R_181() {
    if (jj_scan_token(NULL)) return true;
    return false;
  }

  final private boolean jj_3R_180() {
    if (jj_3R_268()) return true;
    return false;
  }

  final private boolean jj_3R_179() {
    if (jj_scan_token(STRING_LITERAL)) return true;
    return false;
  }

  final private boolean jj_3_30() {
    if (jj_scan_token(LPAREN)) return true;
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_121()) {
    jj_scanpos = xsp;
    if (jj_scan_token(235)) return true;
    }
    xsp = jj_scanpos;
    if (jj_scan_token(248)) {
    jj_scanpos = xsp;
    if (jj_scan_token(260)) return true;
    }
    return false;
  }

  final private boolean jj_3R_178() {
    if (jj_scan_token(FLOATING_POINT_LITERAL)) return true;
    return false;
  }

  final private boolean jj_3R_177() {
    if (jj_scan_token(INTEGER_LITERAL)) return true;
    return false;
  }

  final private boolean jj_3R_96() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_177()) {
    jj_scanpos = xsp;
    if (jj_3R_178()) {
    jj_scanpos = xsp;
    if (jj_3R_179()) {
    jj_scanpos = xsp;
    if (jj_3R_180()) {
    jj_scanpos = xsp;
    if (jj_3R_181()) {
    jj_scanpos = xsp;
    if (jj_3R_182()) {
    jj_scanpos = xsp;
    if (jj_3R_183()) {
    jj_scanpos = xsp;
    if (jj_3R_184()) {
    jj_scanpos = xsp;
    if (jj_3R_185()) {
    jj_scanpos = xsp;
    if (jj_3R_186()) {
    jj_scanpos = xsp;
    if (jj_3R_187()) return true;
    }
    }
    }
    }
    }
    }
    }
    }
    }
    }
    return false;
  }

  final private boolean jj_3R_166() {
    if (jj_scan_token(WITH)) return true;
    if (jj_3R_169()) return true;
    Token xsp;
    while (true) {
      xsp = jj_scanpos;
      if (jj_3_94()) { jj_scanpos = xsp; break; }
    }
    return false;
  }

  final private boolean jj_3_91() {
    if (jj_3R_145()) return true;
    return false;
  }

  final private boolean jj_3R_547() {
    if (jj_scan_token(SINGLE_ARROW)) return true;
    return false;
  }

  final private boolean jj_3R_456() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_547()) jj_scanpos = xsp;
    if (jj_3R_128()) return true;
    return false;
  }

  final private boolean jj_3R_615() {
    if (jj_scan_token(COLON)) return true;
    if (jj_3R_88()) return true;
    return false;
  }

  final private boolean jj_3R_455() {
    if (jj_3R_294()) return true;
    return false;
  }

  final private boolean jj_3R_546() {
    if (jj_scan_token(LT)) return true;
    if (jj_3R_88()) return true;
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_615()) jj_scanpos = xsp;
    if (jj_scan_token(GT)) return true;
    return false;
  }

  final private boolean jj_3_90() {
    if (jj_3R_145()) return true;
    return false;
  }

  final private boolean jj_3R_545() {
    if (jj_scan_token(LPAREN)) return true;
    if (jj_3R_130()) return true;
    if (jj_scan_token(RPAREN)) return true;
    return false;
  }

  final private boolean jj_3R_544() {
    if (jj_scan_token(STRING_LITERAL)) return true;
    return false;
  }

  final private boolean jj_3R_543() {
    if (jj_3R_88()) return true;
    return false;
  }

  final private boolean jj_3R_681() {
    if (jj_scan_token(COMMA)) return true;
    if (jj_3R_130()) return true;
    return false;
  }

  final private boolean jj_3R_542() {
    if (jj_scan_token(COLONCOLON)) return true;
    return false;
  }

  final private boolean jj_3R_614() {
    Token xsp;
    while (true) {
      xsp = jj_scanpos;
      if (jj_3R_681()) { jj_scanpos = xsp; break; }
    }
    return false;
  }

  final private boolean jj_3R_680() {
    if (jj_3R_130()) return true;
    return false;
  }

  final private boolean jj_3R_454() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_scan_token(308)) {
    jj_scanpos = xsp;
    if (jj_3R_542()) return true;
    }
    xsp = jj_scanpos;
    if (jj_3R_543()) {
    jj_scanpos = xsp;
    if (jj_3R_544()) {
    jj_scanpos = xsp;
    if (jj_3R_545()) {
    jj_scanpos = xsp;
    if (jj_3R_546()) return true;
    }
    }
    }
    return false;
  }

  final private boolean jj_3R_613() {
    if (jj_scan_token(COLON)) return true;
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_680()) jj_scanpos = xsp;
    return false;
  }

  final private boolean jj_3R_541() {
    if (jj_3R_130()) return true;
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_613()) {
    jj_scanpos = xsp;
    if (jj_3R_614()) return true;
    }
    return false;
  }

  final private boolean jj_3R_168() {
    if (jj_scan_token(LT)) return true;
    if (jj_scan_token(GT)) return true;
    return false;
  }

  final private boolean jj_3_93() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_168()) {
    jj_scanpos = xsp;
    if (jj_scan_token(260)) {
    jj_scanpos = xsp;
    if (jj_scan_token(238)) return true;
    }
    }
    if (jj_scan_token(COLON)) return true;
    return false;
  }

  final private boolean jj_3R_540() {
    if (jj_scan_token(COLON)) return true;
    if (jj_3R_130()) return true;
    return false;
  }

  final private boolean jj_3R_120() {
    if (jj_scan_token(DOT)) return true;
    if (jj_3R_88()) return true;
    return false;
  }

  final private boolean jj_3R_453() {
    if (jj_scan_token(LBRACKET)) return true;
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_540()) {
    jj_scanpos = xsp;
    if (jj_3R_541()) return true;
    }
    if (jj_scan_token(RBRACKET)) return true;
    return false;
  }

  final private boolean jj_3R_383() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_453()) {
    jj_scanpos = xsp;
    if (jj_3R_454()) {
    jj_scanpos = xsp;
    if (jj_3R_455()) {
    jj_scanpos = xsp;
    if (jj_3R_456()) return true;
    }
    }
    }
    return false;
  }

  final private boolean jj_3R_831() {
    if (jj_scan_token(COLON)) return true;
    if (jj_scan_token(IDENTIFIER)) return true;
    return false;
  }

  final private boolean jj_3R_830() {
    if (jj_scan_token(LT)) return true;
    if (jj_scan_token(GT)) return true;
    return false;
  }

  final private boolean jj_3R_799() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_830()) {
    jj_scanpos = xsp;
    if (jj_3R_831()) return true;
    }
    if (jj_scan_token(COLON)) return true;
    if (jj_3_90()) return true;
    while (true) {
      xsp = jj_scanpos;
      if (jj_3_90()) { jj_scanpos = xsp; break; }
    }
    if (jj_scan_token(COLON)) return true;
    if (jj_3_91()) return true;
    while (true) {
      xsp = jj_scanpos;
      if (jj_3_91()) { jj_scanpos = xsp; break; }
    }
    return false;
  }

  final private boolean jj_3R_763() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3_92()) {
    jj_scanpos = xsp;
    if (jj_3R_799()) return true;
    }
    return false;
  }

  final private boolean jj_3_92() {
    if (jj_3R_167()) return true;
    return false;
  }

  final private boolean jj_3_29() {
    if (jj_3R_119()) return true;
    Token xsp;
    while (true) {
      xsp = jj_scanpos;
      if (jj_3R_120()) { jj_scanpos = xsp; break; }
    }
    if (jj_scan_token(COLONCOLON)) return true;
    return false;
  }

  final private boolean jj_3R_762() {
    if (jj_3R_166()) return true;
    return false;
  }

  final private boolean jj_3R_382() {
    if (jj_scan_token(STRING_LITERAL)) return true;
    return false;
  }

  final private boolean jj_3R_761() {
    if (jj_scan_token(SYSTEMID)) return true;
    if (jj_3R_130()) return true;
    return false;
  }

  final private boolean jj_3R_452() {
    if (jj_scan_token(COLONCOLON)) return true;
    return false;
  }

  final private boolean jj_3R_760() {
    if (jj_3R_241()) return true;
    return false;
  }

  final private boolean jj_3R_381() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_452()) jj_scanpos = xsp;
    if (jj_3R_126()) return true;
    return false;
  }

  final private boolean jj_3R_451() {
    if (jj_scan_token(DOT)) return true;
    if (jj_3R_88()) return true;
    return false;
  }

  final private boolean jj_3R_759() {
    if (jj_scan_token(IN)) return true;
    if (jj_3R_130()) return true;
    return false;
  }

  final private boolean jj_3R_380() {
    if (jj_3R_119()) return true;
    Token xsp;
    while (true) {
      xsp = jj_scanpos;
      if (jj_3R_451()) { jj_scanpos = xsp; break; }
    }
    if (jj_scan_token(COLONCOLON)) return true;
    if (jj_3R_88()) return true;
    return false;
  }

  final private boolean jj_3R_404() {
    if (jj_scan_token(DO)) return true;
    if (jj_3R_130()) return true;
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_759()) jj_scanpos = xsp;
    xsp = jj_scanpos;
    if (jj_3R_760()) jj_scanpos = xsp;
    xsp = jj_scanpos;
    if (jj_3R_761()) jj_scanpos = xsp;
    if (jj_scan_token(AS)) return true;
    if (jj_scan_token(XML)) return true;
    xsp = jj_scanpos;
    if (jj_3R_762()) jj_scanpos = xsp;
    if (jj_scan_token(LBRACE)) return true;
    if (jj_3R_763()) return true;
    while (true) {
      xsp = jj_scanpos;
      if (jj_3R_763()) { jj_scanpos = xsp; break; }
    }
    if (jj_scan_token(RBRACE)) return true;
    return false;
  }

  final private boolean jj_3R_379() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_scan_token(94)) {
    jj_scanpos = xsp;
    if (jj_scan_token(95)) {
    jj_scanpos = xsp;
    if (jj_scan_token(96)) {
    jj_scanpos = xsp;
    if (jj_scan_token(97)) {
    jj_scanpos = xsp;
    if (jj_scan_token(98)) {
    jj_scanpos = xsp;
    if (jj_scan_token(99)) {
    jj_scanpos = xsp;
    if (jj_scan_token(100)) {
    jj_scanpos = xsp;
    if (jj_scan_token(101)) return true;
    }
    }
    }
    }
    }
    }
    }
    if (jj_scan_token(LPAREN)) return true;
    if (jj_3R_130()) return true;
    if (jj_scan_token(RPAREN)) return true;
    return false;
  }

  final private boolean jj_3_89() {
    if (jj_3R_166()) return true;
    return false;
  }

  final private boolean jj_3R_450() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_scan_token(256)) {
    jj_scanpos = xsp;
    if (jj_scan_token(308)) {
    jj_scanpos = xsp;
    if (jj_scan_token(260)) {
    jj_scanpos = xsp;
    if (jj_scan_token(275)) return true;
    }
    }
    }
    return false;
  }

  final private boolean jj_3R_539() {
    if (jj_scan_token(DOT)) return true;
    if (jj_3R_88()) return true;
    return false;
  }

  final private boolean jj_3R_538() {
    if (jj_scan_token(COLONCOLON)) return true;
    return false;
  }

  final private boolean jj_3R_449() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_538()) jj_scanpos = xsp;
    if (jj_3R_88()) return true;
    while (true) {
      xsp = jj_scanpos;
      if (jj_3R_539()) { jj_scanpos = xsp; break; }
    }
    return false;
  }

  final private boolean jj_3R_378() {
    if (jj_scan_token(DOLLARLBRACE)) return true;
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_449()) {
    jj_scanpos = xsp;
    if (jj_3R_450()) return true;
    }
    if (jj_scan_token(RBRACE)) return true;
    return false;
  }

  final private boolean jj_3R_377() {
    if (jj_scan_token(LPAREN)) return true;
    if (jj_3R_130()) return true;
    if (jj_scan_token(RPAREN)) return true;
    return false;
  }

  final private boolean jj_3R_376() {
    if (jj_scan_token(THIS)) return true;
    return false;
  }

  final private boolean jj_3R_558() {
    if (jj_scan_token(SYSTEMID)) return true;
    if (jj_3R_130()) return true;
    return false;
  }

  final private boolean jj_3R_375() {
    if (jj_scan_token(SUPER)) return true;
    if (jj_scan_token(DOT)) return true;
    if (jj_3R_88()) return true;
    return false;
  }

  final private boolean jj_3R_249() {
    if (jj_scan_token(DO)) return true;
    if (jj_3R_130()) return true;
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_558()) jj_scanpos = xsp;
    if (jj_scan_token(AS)) return true;
    if (jj_scan_token(DOM)) return true;
    xsp = jj_scanpos;
    if (jj_3_89()) jj_scanpos = xsp;
    return false;
  }

  final private boolean jj_3R_374() {
    if (jj_3R_252()) return true;
    return false;
  }

  final private boolean jj_3R_373() {
    if (jj_scan_token(CONST_NAME)) return true;
    return false;
  }

  final private boolean jj_3R_448() {
    if (jj_scan_token(INTEGER_LITERAL)) return true;
    return false;
  }

  final private boolean jj_3R_447() {
    if (jj_scan_token(STRING_LITERAL)) return true;
    return false;
  }

  final private boolean jj_3_28() {
    if (jj_scan_token(COLUMN)) return true;
    if (jj_scan_token(LPAREN)) return true;
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_447()) {
    jj_scanpos = xsp;
    if (jj_3R_448()) return true;
    }
    if (jj_scan_token(RPAREN)) return true;
    return false;
  }

  final private boolean jj_3R_304() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3_28()) {
    jj_scanpos = xsp;
    if (jj_3R_373()) {
    jj_scanpos = xsp;
    if (jj_3R_374()) {
    jj_scanpos = xsp;
    if (jj_3R_375()) {
    jj_scanpos = xsp;
    if (jj_3R_376()) {
    jj_scanpos = xsp;
    if (jj_3R_377()) {
    jj_scanpos = xsp;
    if (jj_3R_378()) {
    jj_scanpos = xsp;
    if (jj_3R_379()) {
    jj_scanpos = xsp;
    if (jj_3R_380()) {
    jj_scanpos = xsp;
    if (jj_3R_381()) {
    jj_scanpos = xsp;
    if (jj_3R_382()) return true;
    }
    }
    }
    }
    }
    }
    }
    }
    }
    }
    return false;
  }

  final private boolean jj_3R_815() {
    if (jj_scan_token(IDENTIFIER)) return true;
    if (jj_3R_130()) return true;
    return false;
  }

  final private boolean jj_3R_274() {
    if (jj_scan_token(DECR)) return true;
    return false;
  }

  final private boolean jj_3_88() {
    if (jj_3R_148()) return true;
    if (jj_scan_token(ON)) return true;
    if (jj_3R_130()) return true;
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_815()) jj_scanpos = xsp;
    if (jj_3R_123()) return true;
    return false;
  }

  final private boolean jj_3R_529() {
    if (jj_scan_token(REPEAT)) return true;
    if (jj_3R_130()) return true;
    return false;
  }

  final private boolean jj_3R_603() {
    if (jj_scan_token(AFTER)) return true;
    return false;
  }

  final private boolean jj_3R_305() {
    if (jj_3R_383()) return true;
    return false;
  }

  final private boolean jj_3R_602() {
    if (jj_scan_token(STARTING)) return true;
    return false;
  }

  final private boolean jj_3R_528() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_602()) {
    jj_scanpos = xsp;
    if (jj_3R_603()) return true;
    }
    if (jj_3R_130()) return true;
    return false;
  }

  final private boolean jj_3R_527() {
    if (jj_3R_148()) return true;
    return false;
  }

  final private boolean jj_3R_419() {
    if (jj_scan_token(SCHEDULE)) return true;
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_527()) jj_scanpos = xsp;
    xsp = jj_scanpos;
    if (jj_3R_528()) jj_scanpos = xsp;
    xsp = jj_scanpos;
    if (jj_3R_529()) jj_scanpos = xsp;
    if (jj_3R_123()) return true;
    xsp = jj_scanpos;
    if (jj_3_88()) jj_scanpos = xsp;
    return false;
  }

  final private boolean jj_3R_270() {
    if (jj_scan_token(JAVACLASS)) return true;
    return false;
  }

  final private boolean jj_3R_271() {
    if (jj_3R_304()) return true;
    Token xsp;
    while (true) {
      xsp = jj_scanpos;
      if (jj_3R_305()) { jj_scanpos = xsp; break; }
    }
    return false;
  }

  final private boolean jj_3R_223() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_273()) {
    jj_scanpos = xsp;
    if (jj_3R_274()) return true;
    }
    return false;
  }

  final private boolean jj_3R_273() {
    if (jj_scan_token(INCR)) return true;
    return false;
  }

  final private boolean jj_3R_767() {
    if (jj_3R_145()) return true;
    return false;
  }

  final private boolean jj_3R_191() {
    if (jj_3R_271()) return true;
    return false;
  }

  final private boolean jj_3R_800() {
    if (jj_scan_token(EXCEPT)) return true;
    return false;
  }

  final private boolean jj_3R_190() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_scan_token(13)) {
    jj_scanpos = xsp;
    if (jj_3R_270()) return true;
    }
    if (jj_3R_104()) return true;
    return false;
  }

  final private boolean jj_3R_189() {
    if (jj_3R_269()) return true;
    return false;
  }

  final private boolean jj_3R_766() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_scan_token(39)) {
    jj_scanpos = xsp;
    if (jj_3R_800()) return true;
    }
    if (jj_3R_130()) return true;
    return false;
  }

  final private boolean jj_3_27() {
    if (jj_3R_118()) return true;
    return false;
  }

  final private boolean jj_3_26() {
    if (jj_3R_117()) return true;
    return false;
  }

  final private boolean jj_3R_188() {
    if (jj_scan_token(BIT_AND)) return true;
    if (jj_3R_88()) return true;
    return false;
  }

  final private boolean jj_3R_98() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_188()) {
    jj_scanpos = xsp;
    if (jj_3_26()) {
    jj_scanpos = xsp;
    if (jj_3_27()) {
    jj_scanpos = xsp;
    if (jj_3R_189()) {
    jj_scanpos = xsp;
    if (jj_3R_190()) {
    jj_scanpos = xsp;
    if (jj_3R_191()) return true;
    }
    }
    }
    }
    }
    return false;
  }

  final private boolean jj_3R_765() {
    if (jj_3R_241()) return true;
    return false;
  }

  final private boolean jj_3R_764() {
    if (jj_scan_token(IN)) return true;
    if (jj_3R_130()) return true;
    return false;
  }

  final private boolean jj_3R_469() {
    if (jj_3R_119()) return true;
    if (jj_scan_token(COLON)) return true;
    return false;
  }

  final private boolean jj_3R_405() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_469()) jj_scanpos = xsp;
    if (jj_scan_token(DO)) return true;
    if (jj_3R_130()) return true;
    xsp = jj_scanpos;
    if (jj_3R_764()) jj_scanpos = xsp;
    xsp = jj_scanpos;
    if (jj_3R_765()) jj_scanpos = xsp;
    if (jj_scan_token(AS)) return true;
    if (jj_3R_148()) return true;
    xsp = jj_scanpos;
    if (jj_3R_766()) jj_scanpos = xsp;
    if (jj_scan_token(LBRACE)) return true;
    if (jj_3R_767()) return true;
    while (true) {
      xsp = jj_scanpos;
      if (jj_3R_767()) { jj_scanpos = xsp; break; }
    }
    if (jj_scan_token(RBRACE)) return true;
    return false;
  }

  final private boolean jj_3R_116() {
    if (jj_3R_98()) return true;
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_223()) jj_scanpos = xsp;
    return false;
  }

  final private boolean jj_3R_682() {
    if (jj_scan_token(BANG)) return true;
    return false;
  }

  final private boolean jj_3R_618() {
    if (jj_3R_96()) return true;
    return false;
  }

  final private boolean jj_3_25() {
    if (jj_3R_116()) return true;
    return false;
  }

  final private boolean jj_3R_617() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_scan_token(256)) {
    jj_scanpos = xsp;
    if (jj_3R_682()) return true;
    }
    if (jj_3R_384()) return true;
    return false;
  }

  final private boolean jj_3R_616() {
    if (jj_scan_token(DECR)) return true;
    return false;
  }

  final private boolean jj_3R_550() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_617()) {
    jj_scanpos = xsp;
    if (jj_3_25()) {
    jj_scanpos = xsp;
    if (jj_3R_618()) return true;
    }
    }
    return false;
  }

  final private boolean jj_3R_549() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_scan_token(270)) {
    jj_scanpos = xsp;
    if (jj_3R_616()) return true;
    }
    if (jj_3R_98()) return true;
    return false;
  }

  final private boolean jj_3R_548() {
    if (jj_scan_token(MINUS)) return true;
    return false;
  }

  final private boolean jj_3R_459() {
    if (jj_3R_550()) return true;
    return false;
  }

  final private boolean jj_3R_458() {
    if (jj_3R_549()) return true;
    return false;
  }

  final private boolean jj_3R_457() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_scan_token(272)) {
    jj_scanpos = xsp;
    if (jj_3R_548()) return true;
    }
    if (jj_3R_384()) return true;
    return false;
  }

  final private boolean jj_3R_384() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_457()) {
    jj_scanpos = xsp;
    if (jj_3R_458()) {
    jj_scanpos = xsp;
    if (jj_3R_459()) return true;
    }
    }
    return false;
  }

  final private boolean jj_3R_857() {
    if (jj_scan_token(STARSTAR)) return true;
    if (jj_3R_384()) return true;
    return false;
  }

  final private boolean jj_3R_306() {
    if (jj_3R_384()) return true;
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_857()) jj_scanpos = xsp;
    return false;
  }

  final private boolean jj_3R_860() {
    if (jj_scan_token(REM)) return true;
    return false;
  }

  final private boolean jj_3R_859() {
    if (jj_scan_token(SLASH)) return true;
    return false;
  }

  final private boolean jj_3R_858() {
    if (jj_scan_token(STAR)) return true;
    return false;
  }

  final private boolean jj_3R_826() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_858()) {
    jj_scanpos = xsp;
    if (jj_3R_859()) {
    jj_scanpos = xsp;
    if (jj_3R_860()) return true;
    }
    }
    if (jj_3R_306()) return true;
    return false;
  }

  final private boolean jj_3R_272() {
    if (jj_3R_306()) return true;
    Token xsp;
    while (true) {
      xsp = jj_scanpos;
      if (jj_3R_826()) { jj_scanpos = xsp; break; }
    }
    return false;
  }

  final private boolean jj_3R_828() {
    if (jj_scan_token(MINUS)) return true;
    return false;
  }

  final private boolean jj_3R_827() {
    if (jj_scan_token(PLUS)) return true;
    return false;
  }

  final private boolean jj_3R_794() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_827()) {
    jj_scanpos = xsp;
    if (jj_3R_828()) return true;
    }
    if (jj_3R_272()) return true;
    return false;
  }

  final private boolean jj_3R_222() {
    if (jj_3R_272()) return true;
    Token xsp;
    while (true) {
      xsp = jj_scanpos;
      if (jj_3R_794()) { jj_scanpos = xsp; break; }
    }
    return false;
  }

  final private boolean jj_3R_797() {
    if (jj_scan_token(RUNSIGNEDSHIFT)) return true;
    return false;
  }

  final private boolean jj_3R_796() {
    if (jj_scan_token(RSIGNEDSHIFT)) return true;
    return false;
  }

  final private boolean jj_3R_795() {
    if (jj_scan_token(LSHIFT)) return true;
    return false;
  }

  final private boolean jj_3R_757() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_795()) {
    jj_scanpos = xsp;
    if (jj_3R_796()) {
    jj_scanpos = xsp;
    if (jj_3R_797()) return true;
    }
    }
    if (jj_3R_222()) return true;
    return false;
  }

  final private boolean jj_3R_115() {
    if (jj_3R_222()) return true;
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_757()) jj_scanpos = xsp;
    return false;
  }

  final private boolean jj_3R_114() {
    if (jj_scan_token(GE)) return true;
    return false;
  }

  final private boolean jj_3R_113() {
    if (jj_scan_token(LE)) return true;
    return false;
  }

  final private boolean jj_3R_112() {
    if (jj_scan_token(GT)) return true;
    return false;
  }

  final private boolean jj_3R_111() {
    if (jj_scan_token(LT)) return true;
    return false;
  }

  final private boolean jj_3_24() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_111()) {
    jj_scanpos = xsp;
    if (jj_3R_112()) {
    jj_scanpos = xsp;
    if (jj_3R_113()) {
    jj_scanpos = xsp;
    if (jj_3R_114()) return true;
    }
    }
    }
    if (jj_3R_115()) return true;
    return false;
  }

  final private boolean jj_3R_728() {
    if (jj_3R_115()) return true;
    Token xsp;
    while (true) {
      xsp = jj_scanpos;
      if (jj_3_24()) { jj_scanpos = xsp; break; }
    }
    return false;
  }

  final private boolean jj_3R_690() {
    if (jj_scan_token(BIT_AND)) return true;
    if (jj_3R_689()) return true;
    return false;
  }

  final private boolean jj_3R_747() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_scan_token(266)) {
    jj_scanpos = xsp;
    if (jj_scan_token(267)) return true;
    }
    return false;
  }

  final private boolean jj_3R_746() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_scan_token(262)) {
    jj_scanpos = xsp;
    if (jj_scan_token(263)) return true;
    }
    return false;
  }

  final private boolean jj_3R_729() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_746()) {
    jj_scanpos = xsp;
    if (jj_3R_747()) return true;
    }
    if (jj_3R_728()) return true;
    return false;
  }

  final private boolean jj_3R_689() {
    if (jj_3R_728()) return true;
    Token xsp;
    while (true) {
      xsp = jj_scanpos;
      if (jj_3R_729()) { jj_scanpos = xsp; break; }
    }
    return false;
  }

  final private boolean jj_3R_625() {
    if (jj_scan_token(XOR)) return true;
    if (jj_3R_624()) return true;
    return false;
  }

  final private boolean jj_3R_560() {
    if (jj_scan_token(BIT_OR)) return true;
    if (jj_3R_559()) return true;
    return false;
  }

  final private boolean jj_3R_624() {
    if (jj_3R_689()) return true;
    Token xsp;
    while (true) {
      xsp = jj_scanpos;
      if (jj_3R_690()) { jj_scanpos = xsp; break; }
    }
    return false;
  }

  final private boolean jj_3R_467() {
    if (jj_scan_token(SC_AND)) return true;
    if (jj_3R_466()) return true;
    return false;
  }

  final private boolean jj_3R_401() {
    if (jj_3R_130()) return true;
    return false;
  }

  final private boolean jj_3R_559() {
    if (jj_3R_624()) return true;
    Token xsp;
    while (true) {
      xsp = jj_scanpos;
      if (jj_3R_625()) { jj_scanpos = xsp; break; }
    }
    return false;
  }

  final private boolean jj_3R_399() {
    if (jj_scan_token(SC_OR)) return true;
    if (jj_3R_398()) return true;
    return false;
  }

  final private boolean jj_3R_466() {
    if (jj_3R_559()) return true;
    Token xsp;
    while (true) {
      xsp = jj_scanpos;
      if (jj_3R_560()) { jj_scanpos = xsp; break; }
    }
    return false;
  }

  final private boolean jj_3R_400() {
    if (jj_3R_248()) return true;
    return false;
  }

  final private boolean jj_3R_320() {
    if (jj_scan_token(HOOK)) return true;
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_400()) {
    jj_scanpos = xsp;
    if (jj_3R_401()) return true;
    }
    if (jj_scan_token(COLON)) return true;
    if (jj_3R_285()) return true;
    return false;
  }

  final private boolean jj_3R_710() {
    if (jj_scan_token(LBRACE)) return true;
    if (true) { jj_la = 0; jj_scanpos = jj_lastpos; return false;}
    return false;
  }

  final private boolean jj_3R_398() {
    if (jj_3R_466()) return true;
    Token xsp;
    while (true) {
      xsp = jj_scanpos;
      if (jj_3R_467()) { jj_scanpos = xsp; break; }
    }
    return false;
  }

  final private boolean jj_3R_319() {
    if (jj_3R_398()) return true;
    Token xsp;
    while (true) {
      xsp = jj_scanpos;
      if (jj_3R_399()) { jj_scanpos = xsp; break; }
    }
    return false;
  }

  final private boolean jj_3R_623() {
    if (jj_scan_token(COMMA)) return true;
    if (jj_3R_498()) return true;
    return false;
  }

  final private boolean jj_3R_679() {
    if (jj_3R_130()) return true;
    return false;
  }

  final private boolean jj_3R_285() {
    if (jj_3R_319()) return true;
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_320()) jj_scanpos = xsp;
    return false;
  }

  final private boolean jj_3R_207() {
    if (jj_scan_token(ORORASSIGN)) return true;
    return false;
  }

  final private boolean jj_3R_206() {
    if (jj_scan_token(ANDANDASSIGN)) return true;
    return false;
  }

  final private boolean jj_3R_205() {
    if (jj_scan_token(ORASSIGN)) return true;
    return false;
  }

  final private boolean jj_3R_204() {
    if (jj_scan_token(XORASSIGN)) return true;
    return false;
  }

  final private boolean jj_3R_203() {
    if (jj_scan_token(ANDASSIGN)) return true;
    return false;
  }

  final private boolean jj_3R_202() {
    if (jj_scan_token(RUNSIGNEDSHIFTASSIGN)) return true;
    return false;
  }

  final private boolean jj_3R_427() {
    if (jj_3R_498()) return true;
    Token xsp;
    while (true) {
      xsp = jj_scanpos;
      if (jj_3R_623()) { jj_scanpos = xsp; break; }
    }
    return false;
  }

  final private boolean jj_3R_201() {
    if (jj_scan_token(RSIGNEDSHIFTASSIGN)) return true;
    return false;
  }

  final private boolean jj_3R_200() {
    if (jj_scan_token(LSHIFTASSIGN)) return true;
    return false;
  }

  final private boolean jj_3R_360() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_427()) jj_scanpos = xsp;
    return false;
  }

  final private boolean jj_3R_678() {
    if (jj_3R_439()) return true;
    return false;
  }

  final private boolean jj_3R_611() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_678()) {
    jj_scanpos = xsp;
    if (jj_3R_679()) return true;
    }
    return false;
  }

  final private boolean jj_3R_199() {
    if (jj_scan_token(MINUSASSIGN)) return true;
    return false;
  }

  final private boolean jj_3R_848() {
    if (true) { jj_la = 0; jj_scanpos = jj_lastpos; return false;}
    return false;
  }

  final private boolean jj_3R_198() {
    if (jj_scan_token(PLUSASSIGN)) return true;
    return false;
  }

  final private boolean jj_3R_197() {
    if (jj_scan_token(REMASSIGN)) return true;
    return false;
  }

  final private boolean jj_3R_294() {
    if (jj_scan_token(LPAREN)) return true;
    if (jj_3R_360()) return true;
    if (jj_scan_token(RPAREN)) return true;
    return false;
  }

  final private boolean jj_3R_196() {
    if (jj_scan_token(SLASHASSIGN)) return true;
    return false;
  }

  final private boolean jj_3R_195() {
    if (jj_scan_token(STARASSIGN)) return true;
    return false;
  }

  final private boolean jj_3R_194() {
    if (jj_scan_token(ATASSIGN)) return true;
    return false;
  }

  final private boolean jj_3R_193() {
    if (jj_scan_token(_COPY)) return true;
    return false;
  }

  final private boolean jj_3R_192() {
    if (jj_scan_token(ASSIGN)) return true;
    return false;
  }

  final private boolean jj_3R_99() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_192()) {
    jj_scanpos = xsp;
    if (jj_3R_193()) {
    jj_scanpos = xsp;
    if (jj_3R_194()) {
    jj_scanpos = xsp;
    if (jj_3R_195()) {
    jj_scanpos = xsp;
    if (jj_3R_196()) {
    jj_scanpos = xsp;
    if (jj_3R_197()) {
    jj_scanpos = xsp;
    if (jj_3R_198()) {
    jj_scanpos = xsp;
    if (jj_3R_199()) {
    jj_scanpos = xsp;
    if (jj_3R_200()) {
    jj_scanpos = xsp;
    if (jj_3R_201()) {
    jj_scanpos = xsp;
    if (jj_3R_202()) {
    jj_scanpos = xsp;
    if (jj_3R_203()) {
    jj_scanpos = xsp;
    if (jj_3R_204()) {
    jj_scanpos = xsp;
    if (jj_3R_205()) {
    jj_scanpos = xsp;
    if (jj_3R_206()) {
    jj_scanpos = xsp;
    if (jj_3R_207()) return true;
    }
    }
    }
    }
    }
    }
    }
    }
    }
    }
    }
    }
    }
    }
    }
    return false;
  }

  final private boolean jj_3R_584() {
    if (jj_scan_token(ATSIGN)) return true;
    if (jj_3R_271()) return true;
    return false;
  }

  final private boolean jj_3R_583() {
    if (jj_3R_104()) return true;
    return false;
  }

  final private boolean jj_3R_582() {
    if (jj_scan_token(STRING_LITERAL)) return true;
    return false;
  }

  final private boolean jj_3R_498() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_582()) {
    jj_scanpos = xsp;
    if (jj_3R_583()) {
    jj_scanpos = xsp;
    if (jj_3R_584()) return true;
    }
    }
    xsp = jj_scanpos;
    if (jj_scan_token(248)) {
    jj_scanpos = xsp;
    if (jj_scan_token(260)) return true;
    }
    if (jj_3R_318()) return true;
    return false;
  }

  final private boolean jj_3R_248() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_scan_token(257)) {
    jj_scanpos = xsp;
    if (jj_scan_token(258)) return true;
    }
    if (true) { jj_la = 0; jj_scanpos = jj_lastpos; return false;}
    return false;
  }

  final private boolean jj_3R_612() {
    if (jj_scan_token(COMMA)) return true;
    if (jj_3R_611()) return true;
    return false;
  }

  final private boolean jj_3_86() {
    if (jj_3R_164()) return true;
    return false;
  }

  final private boolean jj_3R_537() {
    if (jj_3R_611()) return true;
    Token xsp;
    while (true) {
      xsp = jj_scanpos;
      if (jj_3R_612()) { jj_scanpos = xsp; break; }
    }
    return false;
  }

  final private boolean jj_3R_439() {
    if (jj_scan_token(LBRACE)) return true;
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_537()) jj_scanpos = xsp;
    if (jj_scan_token(RBRACE)) return true;
    return false;
  }

  final private boolean jj_3R_737() {
    if (jj_scan_token(IN)) return true;
    if (jj_3R_130()) return true;
    return false;
  }

  final private boolean jj_3R_736() {
    if (jj_scan_token(LIMIT)) return true;
    if (jj_3R_130()) return true;
    return false;
  }

  final private boolean jj_3R_735() {
    if (jj_scan_token(FROM)) return true;
    if (jj_3R_130()) return true;
    return false;
  }

  final private boolean jj_3R_718() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_735()) {
    jj_scanpos = xsp;
    if (jj_3R_736()) {
    jj_scanpos = xsp;
    if (jj_3R_737()) return true;
    }
    }
    return false;
  }

  final private boolean jj_3R_717() {
    if (jj_scan_token(IDENTIFIER)) return true;
    return false;
  }

  final private boolean jj_3R_106() {
    if (jj_3R_104()) return true;
    return false;
  }

  final private boolean jj_3R_303() {
    if (jj_scan_token(COLON)) return true;
    if (jj_3R_88()) return true;
    return false;
  }

  final private boolean jj_3R_716() {
    if (jj_scan_token(LT)) return true;
    if (jj_3R_88()) return true;
    if (jj_scan_token(GT)) return true;
    return false;
  }

  final private boolean jj_3R_302() {
    if (jj_scan_token(STRING_LITERAL)) return true;
    return false;
  }

  final private boolean jj_3_87() {
    if (jj_scan_token(HIB__DELETE)) return true;
    if (jj_3R_127()) return true;
    if (jj_scan_token(SEMICOLON)) return true;
    return false;
  }

  final private boolean jj_3R_301() {
    if (jj_3R_104()) return true;
    return false;
  }

  final private boolean jj_3R_692() {
    if (jj_scan_token(HIB__DELETE)) return true;
    return false;
  }

  final private boolean jj_3R_691() {
    if (jj_scan_token(HIB__ITERATE)) return true;
    return false;
  }

  final private boolean jj_3R_269() {
    if (jj_scan_token(NEW)) return true;
    if (jj_scan_token(COM__)) return true;
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_301()) {
    jj_scanpos = xsp;
    if (jj_3R_302()) {
    jj_scanpos = xsp;
    if (jj_3R_303()) return true;
    }
    }
    return false;
  }

  final private boolean jj_3_22() {
    if (jj_scan_token(LPAREN)) return true;
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_106()) {
    jj_scanpos = xsp;
    if (jj_scan_token(235)) return true;
    }
    xsp = jj_scanpos;
    if (jj_scan_token(248)) {
    jj_scanpos = xsp;
    if (jj_scan_token(260)) return true;
    }
    return false;
  }

  final private boolean jj_3R_647() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_scan_token(193)) {
    jj_scanpos = xsp;
    if (jj_3R_691()) {
    jj_scanpos = xsp;
    if (jj_3R_692()) return true;
    }
    }
    xsp = jj_scanpos;
    if (jj_3R_716()) jj_scanpos = xsp;
    xsp = jj_scanpos;
    if (jj_3R_717()) jj_scanpos = xsp;
    while (true) {
      xsp = jj_scanpos;
      if (jj_3R_718()) { jj_scanpos = xsp; break; }
    }
    if (jj_scan_token(COLON)) return true;
    if (jj_3R_848()) return true;
    return false;
  }

  final private boolean jj_3R_715() {
    if (jj_scan_token(LT)) return true;
    if (jj_3R_88()) return true;
    if (jj_scan_token(GT)) return true;
    return false;
  }

  public JudoParserTokenManager token_source;
  public Token token, jj_nt;
  private int jj_ntk;
  private Token jj_scanpos, jj_lastpos;
  private int jj_la;
  public boolean lookingAhead = false;
  private boolean jj_semLA;
  private int jj_gen;
  final private int[] jj_la1 = new int[435];
  static private int[] jj_la1_0;
  static private int[] jj_la1_1;
  static private int[] jj_la1_2;
  static private int[] jj_la1_3;
  static private int[] jj_la1_4;
  static private int[] jj_la1_5;
  static private int[] jj_la1_6;
  static private int[] jj_la1_7;
  static private int[] jj_la1_8;
  static private int[] jj_la1_9;
  static {
      jj_la1_0();
      jj_la1_1();
      jj_la1_2();
      jj_la1_3();
      jj_la1_4();
      jj_la1_5();
      jj_la1_6();
      jj_la1_7();
      jj_la1_8();
      jj_la1_9();
   }
   private static void jj_la1_0() {
      jj_la1_0 = new int[] {0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0xf1de3800,0x0,0x600f0800,0x0,0x10000800,0xe15e3000,0x10001,0x600f0800,0x0,0x600f0800,0x0,0x0,0x0,0x0,0xffff0800,0x0,0xe71e3000,0x6000000,0xe11e3000,0x0,0x0,0x2000,0x660f0800,0x6000000,0x600f0800,0x0,0x600f0800,0x0,0x600f0800,0x0,0x6000000,0x0,0x0,0x2000,0x0,0x0,0x0,0x0,0x600f0800,0x0,0x0,0xe11e3000,0x0,0xe11e3000,0xe11e3000,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x20000000,0xe2000,0x0,0x0,0x0,0x0,0xffff0800,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0xffff0800,0x0,0x600f0800,0x0,0x0,0x0,0x0,0x600f0800,0x0,0x0,0x0,0x0,0x0,0x600f0800,0x0,0x200e2000,0x200e2000,0x0,0x600f0800,0x600f0800,0x0,0x0,0x200e2000,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0xe2000,0x0,0x0,0x0,0x60000,0x0,0x0,0x2000,0x0,0x82000,0x0,0x0,0x0,0x0,0x0,0xffff0800,0x0,0x0,0x0,0x0,0x80000,0x200e2000,0x0,0x0,0x200e2000,0x0,0x0,0xffff0800,0x0,0x0,0x0,0x60000,0x60000,0x0,0x0,0x0,0x0,0xa00ea000,0x0,0x0,0xe11e3000,0x80000,0x80000,0x80000,0x80000,0xa00ea000,0x41100000,0x80001000,0xe11e3000,0xe11e3000,0xe11e3000,0xe11e3000,0x0,0xe11e3000,0xe11e3000,0x0,0x8200000,0x0,0x8200000,0xe11e3000,0x0,0x0,0x0,0x80000,0x200e2000,0x0,0x80000,0x80000,0x0,0x80000,0x200e2000,0x200e2000,0x200e2000,0x200e2000,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x200e2000,0x0,0xa00ea000,0x0,0xa00e2000,0xa00e2000,0xa00e2000,0x0,0x0,0x0,0x0,0x200e2000,0x200e2000,0x0,0x0,0x0,0x0,0x82000,0x0,0x200e2000,0x0,0x200e2000,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x82000,0x0,0x0,0x0,0x200e2000,0x200e2000,0x0,0x0,0x200e2000,0x200e2000,0x0,0x0,0x0,0x80000,0x80000,0x0,0x0,0x0,0x0,0x80000,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x80000,0x0,0x0,0x0,0x0,0x80000,0x0,0x80000,0x0,0x80000,0x0,0x0,0x0,0x0,0x80000,0x0,0x80000,0x0,0x0,0x0,0x200e2000,0x0,0x0,0x0,0x0,0x0,0xffff0800,0xffff0800,0x0,0x0,0x0,0x0,0x200e2000,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x2000,0x600f2800,0x0,0x2000,0x600f2800,0x600f2800,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x80000,0x0,0x0,0x0,0x0,0xe11e3000,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0xffff0800,0x0,0x0,0x200e2000,0x0,0x0,0x0,0x80000,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x200000,0x0,0x0,0x0,0x0,0x200000,0x0,0x0,0x0,0x0,0x0,0x0,0xffff0800,0x0,0xffff0800,0x0,0x0,0x0,0x0,0xe11e3000,0x0,0x0,0x82000,0x0,0x0,0x0,0x0,0x200e2000,0x0,0x0,0x0,0x200e2000,0xffff2800,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x80000,0x0,0x0,0x80000,0x200e2000,0x200e2000,0x0,0x0,0x0,0x80000,0x0,0x200e2000,0x80000,0x0,0x0,0x0,0x0,0x80000,0x600f0800,0xffff0800,0x80000,};
   }
   private static void jj_la1_1() {
      jj_la1_1 = new int[] {0x400000,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0xfffffaf5,0x0,0x5dd615,0x0,0x0,0xfffffaf5,0x0,0x5dd615,0x0,0x5dd615,0x0,0xa000,0xa000,0x18,0xedfffff,0x8,0xfffff2b5,0x0,0xfffff0b5,0x8,0x0,0x0,0x5dd615,0x0,0x5dd615,0x0,0x5dd615,0x0,0x5dd615,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x80,0x0,0x5dd615,0x600,0x0,0xfffff0b5,0x0,0xfffff0b5,0xfffff0b5,0x40,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0xf9dd031,0x0,0x0,0x0,0x0,0xedfffff,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0xedfffff,0x1800000,0x5dd615,0x0,0x0,0x0,0x0,0x5dd615,0x0,0x0,0x0,0x0,0x800000,0x5dd615,0x0,0xf9dd031,0xf9dd031,0x0,0x5dd615,0x5dd615,0x0,0x0,0xf9dd031,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0xf9dd031,0x0,0x0,0x0,0xe080020,0x0,0x0,0x1000,0x0,0x95d011,0x0,0x0,0x0,0x0,0x0,0xedfffff,0x0,0x0,0x0,0x0,0x15c011,0xf9dd031,0x0,0x0,0xf9dd031,0x0,0x0,0xedfffff,0x0,0x0,0x0,0x0,0xe080020,0x20,0x0,0x0,0x0,0xf9dd631,0x0,0x0,0xfffff0b5,0x15c011,0x15c011,0x15c011,0x15c011,0xf9dd631,0x0,0xf0222004,0xfffff2b5,0xfffff2b5,0xfffff2b5,0xfffff2b5,0x0,0xfffff0b5,0xfffff0b5,0x40,0x0,0x0,0x0,0xfffff0b5,0x0,0x3,0x0,0x15c011,0xf9dd031,0x0,0x15c011,0x15c011,0x0,0x15c011,0xf9dd031,0xf9dd031,0xf9dd031,0xf9dd031,0x100,0x0,0x0,0x100,0x0,0x0,0x0,0x0,0xf9dd031,0x0,0xf9dd631,0x0,0xf9dd031,0xf9dd031,0xf9dd031,0x0,0x0,0x0,0x0,0xf9dd031,0xf9dd031,0x0,0x0,0x0,0x0,0x195d011,0x0,0xf9dd031,0x0,0xf9dd031,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x195d011,0x0,0x0,0x0,0xf9dd031,0xf9dd031,0x0,0x100,0xf9dd031,0xf9dd031,0x100,0x0,0x0,0x15c011,0x15c011,0x0,0x0,0x0,0x0,0x15c011,0x0,0x0,0x0,0x0,0x0,0x0,0x100000,0x100000,0x0,0x0,0x15c011,0x0,0x0,0x0,0x0,0x15c011,0x0,0x15c011,0x0,0x15c011,0x0,0x0,0x0,0x0,0x15c011,0x0,0x15c011,0x0,0x0,0x0,0xf9dd031,0x0,0x0,0x0,0x0,0x0,0xedfffff,0xedfffff,0x0,0x0,0x0,0x0,0xf9dd031,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x5dd615,0x0,0x0,0x5dd615,0x5dd615,0x0,0x0,0x0,0x0,0x40100,0x40100,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x15c011,0x40000,0x0,0x80,0x80,0xfffff0b5,0x0,0x0,0x0,0x0,0x0,0x0,0x40000,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0xedfffff,0x0,0x0,0xf9dd031,0x0,0x100000,0x0,0x100000,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x40000,0x0,0x0,0x0,0x8,0x0,0x8,0x0,0x0,0x8,0x0,0x0,0x0,0x0,0xedfffff,0x0,0xedfffff,0x0,0x0,0x0,0x0,0xfffff0b5,0x0,0x0,0x195d011,0x0,0x0,0x0,0x0,0xf9dd031,0x100,0x0,0x0,0xf9dd031,0xfdfffff,0x0,0x0,0x0,0x0,0x0,0x1e000,0x1e000,0x0,0x0,0xe0000000,0x0,0x0,0x0,0x0,0xf0220000,0x0,0x0,0x400000,0x0,0x0,0x0,0x0,0x0,0x40000,0x0,0x0,0x40000,0xf9dd031,0xf9dd031,0x4,0x4,0x4,0x140000,0x100000,0xf9dd031,0x140000,0x0,0x0,0x0,0x0,0x15c011,0x5dd615,0xedfffff,0x15c011,};
   }
   private static void jj_la1_2() {
      jj_la1_2 = new int[] {0x4000000,0x0,0x0,0x0,0x0,0x0,0x0,0x3000000,0xf6b33dff,0x0,0x2fc302f0,0x0,0x0,0xf6b33dff,0x0,0x2fc302f0,0x0,0xefc302f0,0xc0000000,0x0,0x0,0x0,0xfffffff0,0x0,0xf6b33dff,0x0,0xf6b33dff,0x0,0x0,0x0,0xefc302f0,0x0,0xefc302f0,0x0,0xefc302f0,0x0,0xefc302f0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x2fc302f0,0x0,0x0,0xf6b33dff,0x0,0xf6b33dff,0xf6b33dff,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x30000,0xc0901470,0x0,0x0,0x0,0x0,0xfffffff0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0xfffffff0,0x0,0xefc302f0,0x0,0x0,0x0,0x0,0xefc302f0,0x0,0x0,0x0,0x0,0x0,0x2fc302f0,0x0,0xc0931470,0xc0931470,0x0,0x2fc302f0,0x2fc302f0,0x0,0x0,0xc0931470,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0xc0901470,0x0,0x0,0x0,0x900000,0x0,0x0,0x0,0x0,0xc0001470,0x0,0x0,0x0,0x0,0x0,0xfffffff0,0xc0000000,0x0,0x0,0xc0001400,0x70,0xc0931470,0x0,0x0,0xc0931470,0x0,0x0,0xfffffff0,0x0,0x0,0x0,0x0,0x900000,0x100000,0x0,0x0,0x0,0xc0931470,0xc0000000,0x0,0xf6b33dff,0x70,0x70,0x70,0x70,0xc0931470,0x20000180,0x200280f,0xf6b33dff,0xf6b33dff,0xf6b33dff,0xf6b33dff,0x0,0xf6b33dff,0xf6b33dff,0x0,0x0,0x0,0x0,0xf6b33dff,0x0,0x0,0x0,0x70,0xc0931470,0x0,0x70,0x70,0x0,0x70,0xc0931470,0xc0931470,0xc0931470,0xc0931470,0x0,0x8c000,0x0,0x0,0x8c000,0x8c000,0x0,0x0,0xc0931470,0x0,0xc0931470,0x0,0xc0931470,0xc0931470,0xc0931470,0x0,0x0,0x0,0x0,0xc0931470,0xc0931470,0x0,0x0,0x0,0x0,0xc0001470,0x0,0xc0931470,0x0,0xc0931470,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0xc0001470,0x0,0x40,0x10,0xc0931470,0xc0931470,0x0,0x4000,0xc0931470,0xc0931470,0x4000,0x0,0x0,0x70,0x70,0x0,0x0,0x0,0x0,0x70,0x0,0x0,0x3000000,0x0,0x4000,0x0,0x3000010,0x3000010,0x8000000,0x0,0x70,0x20000000,0x0,0x0,0x20000000,0x3000070,0x0,0x70,0x20000000,0x3000070,0x0,0x3000000,0x3000000,0x0,0x70,0x20000000,0x23000070,0x0,0x3000000,0x3000000,0xc0931470,0x0,0x3000000,0x3000000,0x3000000,0x0,0xfffffff0,0xfffffff0,0xc0000000,0x0,0xc0000000,0x0,0xc0931470,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x2fc302f0,0x0,0x0,0x2fc302f0,0x2fc302f0,0x0,0x0,0x0,0x0,0x10,0x10,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x70,0x0,0x0,0x0,0x0,0xf6b33dff,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x20000000,0x0,0x0,0x0,0x0,0xfffffff0,0x0,0x0,0xc0931470,0x0,0x4000,0x0,0x4000,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x20000000,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0xfffffff0,0x0,0xfffffff0,0x0,0x0,0x0,0x0,0xf6b33dff,0x0,0x0,0xc0001470,0x0,0x0,0x0,0x0,0xc0931470,0x0,0x0,0x0,0xc0931470,0xfffffff0,0x20000000,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x7,0x0,0x0,0x0,0x0,0xf,0x0,0x0,0x0,0x4000,0x0,0x0,0x0,0x0,0x10,0x0,0x0,0x10,0xc0931470,0xc0931470,0x0,0x0,0x0,0x404200,0x4000,0xc0931470,0x404200,0x0,0x0,0x0,0x0,0x70,0x2fc302f0,0xfffffff0,0x70,};
   }
   private static void jj_la1_3() {
      jj_la1_3 = new int[] {0x0,0x180000,0x600000,0x1800000,0x6000000,0xc0,0x18000000,0x0,0xf607fe3f,0x0,0xffffe0c0,0x0,0x0,0xf607fe3f,0x0,0xffffe0c0,0xc0,0xffffe0ff,0x3f,0x0,0x0,0x0,0xffffe1ff,0x0,0xf607fe3f,0x0,0xf607fe3f,0x0,0x0,0x0,0xffffe1ff,0x0,0xffffe1ff,0x0,0xffffe1ff,0x0,0xffffe1ff,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0xffffe0c0,0x0,0x0,0xf607fe3f,0x0,0xf607fe3f,0xf607fe3f,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0xf607ec3f,0x0,0x0,0x0,0x0,0xffffe1ff,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0xffffe1ff,0x0,0xffffe0ff,0x0,0x0,0x0,0x0,0xffffe0ff,0x0,0x0,0x0,0x0,0x0,0xffffe0c0,0x0,0xf607ec3f,0xf607ec3f,0x0,0xffffe0c0,0xffffe0c0,0x0,0x0,0xf607ec3f,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0xf607ec3f,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0xf607ec3f,0x0,0x0,0x0,0x0,0x0,0xffffe1ff,0x3f,0x0,0x0,0x600003f,0xf007ec00,0xf607ec3f,0x0,0x0,0xf607ec3f,0x0,0x0,0xffffe1ff,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0xf67fed3f,0xff,0x0,0xf607fe3f,0xf007e000,0xf007e000,0xf007e000,0xf007e000,0xf67fed3f,0x0,0x1200,0xf607fe3f,0xf607fe3f,0xf607fe3f,0xf607fe3f,0x0,0xf607fe3f,0xf607fe3f,0x0,0x0,0x0,0x0,0xf607fe3f,0x0,0x0,0x0,0xf007e000,0xf607ec3f,0x0,0xf007e000,0xf007e000,0x0,0xf007e000,0xf607ec3f,0xf607ec3f,0xf607ec3f,0xf607ec3f,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0xf607ec3f,0x0,0xf667ed3f,0x180000,0xf61fec3f,0xf61fec3f,0xf61fec3f,0x0,0x1e0000c0,0x0,0x0,0xf607ec3f,0xfe07ecff,0x0,0x0,0x0,0x0,0xf607ec3f,0x0,0xf607ec3f,0x0,0xf607ec3f,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0xf607ec3f,0x0,0x0,0x0,0xf607ec3f,0xf607ec3f,0x1200,0x7e000,0xf607ec3f,0xf607ec3f,0x7e000,0x0,0x0,0xf007e000,0xf007e000,0x0,0x0,0x0,0x0,0xf007e000,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0xf007e000,0x0,0x0,0x0,0x0,0xf007e000,0x0,0xf007e000,0x0,0xf007e000,0x0,0x0,0x0,0x0,0xf007e000,0x0,0xf007e000,0x0,0x0,0x0,0xf607ec3f,0x0,0x0,0x0,0x0,0x0,0xffffe1ff,0xffffe1ff,0x1e0000ff,0x0,0x1e0000ff,0x0,0xf607ec3f,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0xffffe0c0,0x0,0x0,0xffffe0c0,0xffffe0c0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0xf007e000,0x0,0x0,0x0,0x0,0xf607fe3f,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0xffffe1ff,0x0,0x0,0xf607ec3f,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0xffffe1ff,0x0,0xffffe1ff,0x0,0x0,0x0,0x0,0xf607fe3f,0x0,0x0,0xf607ec3f,0x0,0x0,0x0,0x0,0xf607ec3f,0x0,0x0,0x0,0xf607ec3f,0xffffedff,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x2000000,0x0,0x0,0xf607ec3f,0xf607ec3f,0x0,0x0,0x0,0x0,0x0,0xf607ec3f,0x0,0x0,0x0,0x0,0x0,0xf007e000,0xffffe0c0,0xffffe1ff,0xf007ec00,};
   }
   private static void jj_la1_4() {
      jj_la1_4 = new int[] {0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0xfffcffff,0x0,0xfffffe,0x0,0x0,0xfffcffff,0x0,0xfffffe,0x0,0xfffffe,0x0,0x0,0x0,0x0,0xfffffe,0x0,0xfffcffff,0x0,0xfffcffff,0x0,0x0,0x0,0xfffffe,0x0,0xfffffe,0x0,0xfffffe,0x0,0xfffffe,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0xfffffe,0x0,0x0,0xfffcffff,0x0,0xfffcffff,0xfffcffff,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0xf8203f,0x0,0x0,0x0,0x0,0xfffffe,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0xfffffe,0x0,0xfffffe,0x0,0x0,0x0,0x0,0xfffffe,0x0,0x0,0x0,0x0,0x0,0xfffffe,0x0,0xf8203f,0xf8203f,0x0,0xfffffe,0xfffffe,0x0,0x0,0xf8203f,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0xf8203f,0x0,0x0,0x0,0x1,0x0,0x0,0x0,0x0,0xf8203e,0x0,0x0,0x0,0x0,0x0,0xfffffe,0x0,0x0,0x0,0x0,0xf8203e,0xf8203f,0x0,0x0,0xf8203f,0x0,0x0,0xfffffe,0x0,0x0,0x0,0x0,0x1,0x0,0x0,0x0,0x0,0xf8203f,0x0,0x0,0xfffcffff,0xf8203e,0xf8203e,0xf8203e,0xf8203e,0xf8203f,0x0,0xff04dfc0,0xfffcffff,0xfffcffff,0xfffcffff,0xfffcffff,0x0,0xfffcffff,0xfffcffff,0x0,0x0,0x0,0x0,0xfffcffff,0x0,0x0,0x0,0xf8203e,0xf8203f,0x0,0xf8203e,0xf8203e,0x0,0xf8203e,0xf8203f,0xf8203f,0xf8203f,0xf8203f,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0xf8203f,0x0,0xf8203f,0x0,0xf8203f,0xf8203f,0xf8203f,0x0,0x0,0x0,0x0,0xf8203f,0xf8203f,0x1c0,0x0,0x0,0x0,0xf8203e,0x0,0xf8203f,0x0,0xf8203f,0x0,0x0,0x0,0x0,0x0,0x0,0x600,0xf8203e,0x0,0x0,0x0,0xf8203f,0xf8203f,0x0,0x0,0xf8203f,0xf8203f,0x0,0xff000000,0x2000000,0xf8203e,0xf8203e,0x0,0x0,0x0,0x0,0xf8203e,0x0,0x0,0x0,0x1000000,0x0,0x0,0x0,0x0,0x0,0x18000000,0xf8203e,0x0,0x0,0x0,0x0,0xf8203e,0x80000000,0xf8203e,0x0,0xf8203e,0x40000000,0x0,0x0,0x0,0xf8203e,0x0,0xf8203e,0x20000000,0x0,0x0,0xf8203f,0x4000000,0x0,0x0,0x0,0x0,0xfffffe,0xfffffe,0x0,0x0,0x0,0x0,0xf8203f,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0xfffffe,0x0,0x0,0xfffffe,0xfffffe,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0xf8203e,0x0,0x0,0x80000,0x80000,0xfffcffff,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0xfffffe,0x0,0x0,0xf8303f,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0xfffffe,0x0,0xfffffe,0x0,0x0,0x0,0x0,0xfffcffff,0x0,0x0,0xf8203e,0x0,0x0,0x0,0x0,0xf8203f,0x0,0x0,0x0,0xf8203f,0xffffff,0x0,0x20,0x10,0x38,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x4d000,0x0,0xc000,0x90000,0x0,0x20000,0x90000,0xf8203f,0xf8203f,0x300000,0x300000,0x300000,0x82000,0x0,0xf8203f,0x82000,0x0,0x0,0x0,0x0,0xf8203e,0xfffffe,0xfffffe,0xf8203e,};
   }
   private static void jj_la1_5() {
      jj_la1_5 = new int[] {0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0xfefffffd,0x0,0x1000000,0x0,0x0,0xfefffffd,0x0,0x1000000,0x0,0x1000000,0x0,0x0,0x0,0x0,0x1000000,0x0,0xfefffffd,0x0,0xfefffffd,0x0,0x0,0x0,0x1000000,0x0,0x1000000,0x0,0x1000000,0x0,0x1000000,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x1000000,0x0,0x0,0xfefffffd,0x0,0xfefffffd,0xfefffffd,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0xfc002000,0x0,0x0,0x0,0x0,0x1000000,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x1000000,0x0,0x1000000,0x0,0x0,0x0,0x0,0x1000000,0x0,0x0,0x0,0x0,0x0,0x1000000,0x0,0xfc002000,0xfc002000,0x0,0x1000000,0x1000000,0x0,0x0,0xfc002000,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0xfc002000,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0xfc002000,0x0,0x0,0x0,0x0,0x0,0x1000000,0x0,0x0,0x0,0x0,0xfc002000,0xfc002000,0x0,0x0,0xfc002000,0x0,0x0,0x1000000,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0xfc002000,0x0,0x0,0xfefffffd,0x0,0x0,0x0,0x0,0xfc002000,0x0,0x2ffdffd,0xfefffffd,0xfefffffd,0xfefffffd,0xfefffffd,0x0,0xfefffffd,0xfefffffd,0x0,0x0,0x0,0x0,0xfefffffd,0x0,0x0,0x0,0x0,0xfc002000,0x0,0x0,0x0,0x0,0x0,0xfc002000,0xfc002000,0xfc002000,0xfc002000,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0xfc002000,0x0,0xfc002000,0x0,0xfc002000,0xfc002000,0xfc002000,0x0,0x0,0x0,0x0,0xfc002000,0xfc002000,0x0,0x0,0x0,0x0,0xfc002000,0x0,0xfc002000,0x0,0xfc002000,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0xfc002000,0x0,0x0,0x0,0xfc002000,0xfc002000,0x0,0x0,0xfc002000,0xfc002000,0x0,0xffdffd,0x1000,0x0,0x0,0x0,0x0,0xc0000c,0x0,0x0,0x0,0x0,0x0,0x800,0x0,0x0,0x0,0x0,0x0,0x180c0,0x0,0x0,0x2,0x2,0x2,0x0,0x300301,0x0,0x0,0x0,0xc0030,0x0,0x0,0x0,0x0,0x0,0x0,0x20000,0x0,0x0,0xfc002000,0x4000,0x0,0x0,0x0,0x0,0x1000000,0x1000000,0x0,0x0,0x0,0x0,0xfc002000,0x0,0x0,0x0,0x0,0x2000000,0x0,0x0,0x0,0x1000000,0x0,0x0,0x1000000,0x1000000,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0xfefffffd,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x1000000,0x0,0x0,0xfc002000,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x1000000,0x0,0x1000000,0x0,0x0,0x0,0x0,0xfefffffd,0x0,0x0,0xfc002000,0x0,0x0,0x0,0x0,0xfc002000,0x0,0x0,0x0,0xfc002000,0xfd002000,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0xfc002000,0xfc002000,0x0,0x0,0x0,0x0,0x0,0xfc002000,0x0,0x0,0x0,0x0,0x0,0x0,0x1000000,0x1000000,0xfc002000,};
   }
   private static void jj_la1_6() {
      jj_la1_6 = new int[] {0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x76efdff,0x0,0x1fffc00,0x0,0x0,0x76efdff,0x0,0x1fffc00,0x0,0x1fffc00,0x0,0x0,0x0,0x0,0x1fffc00,0x0,0x62efdff,0x0,0x62efdff,0x0,0x0,0x0,0x1fffc00,0x0,0x1fffc00,0x0,0x1fffc00,0x0,0x1fffc00,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x1fffc00,0x0,0x0,0x62efdff,0x0,0x62efdff,0x62efdff,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x2e65f9,0x0,0x0,0x0,0x0,0x1fffc00,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x1fffc00,0x0,0x1fffc00,0x0,0x0,0x0,0x0,0x1fffc00,0x0,0x0,0x0,0x0,0x0,0x1fffc00,0x0,0x2e65f9,0x2e65f9,0x0,0x1fffc00,0x1fffc00,0x0,0x0,0x2e65f9,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x2e65f9,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x2e65f9,0x0,0x0,0x0,0x0,0x0,0x1fffc00,0x0,0x0,0x0,0x0,0x2e65f9,0x2e65f9,0x0,0x0,0x2e65f9,0x0,0x0,0x1fffc00,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x2e67f9,0x0,0x0,0x62efdff,0x2e7400,0x2e7400,0x2e7400,0x2e7400,0x2e67f9,0x0,0x600900e,0x62efdff,0x62efdff,0x62efdff,0x62efdff,0x0,0x62efdff,0x62efdff,0x0,0x0,0x0,0x0,0x62efdff,0x0,0x0,0x0,0x2e6400,0x2e65f9,0x0,0x2e6400,0x2e6400,0x0,0x2e6400,0x2e65f9,0x2e65f9,0x2e65f9,0x2e65f9,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x2e65f9,0x0,0x2e67f9,0x0,0x2e65f9,0x2e65f9,0x2e65f9,0x0,0x0,0x0,0x0,0x2e65f9,0x2e65f9,0x0,0x0,0x0,0x0,0x2e65f9,0x0,0x2e65f9,0x0,0x2e65f9,0x0,0x0,0x0,0x0,0x800,0x800,0x0,0x2e65f9,0x0,0x0,0x0,0x2e65f9,0x2e65f9,0x0,0x0,0x2e65f9,0x2e65f9,0x0,0x0,0x0,0x2e6400,0x2e6400,0x0,0x0,0x0,0x0,0x2e6400,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x2e6400,0x0,0x0,0x0,0x0,0x2e6400,0x0,0x2e6400,0x0,0x2e6400,0x0,0x0,0x0,0x0,0x2e6400,0x0,0x2e6400,0x0,0x0,0x0,0x2e65f9,0x0,0x0,0x0,0x0,0x0,0x1fffc00,0x1fffc00,0x0,0x0,0x0,0x0,0x2e65f9,0x0,0x0,0x0,0x0,0xe,0x0,0x0,0x0,0x1fffc00,0x0,0x0,0x1fffc00,0x1fffc00,0x0,0xe,0x0,0x0,0x0,0x0,0xe,0x0,0x0,0x0,0x0,0x0,0x0,0x2e6400,0x0,0x0,0x0,0x0,0x62efdff,0x0,0x2400,0x2400,0x800,0x0,0x20000,0x0,0x0,0x20000,0x0,0x0,0x0,0x0,0x0,0x1fffc00,0x10000,0x0,0x2f65f9,0x20000,0x0,0x20000,0x0,0xc0000,0xc0000,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x1c00000,0x0,0xf8000000,0x0,0x0,0x1400000,0x0,0xf8000000,0x0,0x0,0x0,0x1fffc00,0x38000000,0x1fffc00,0xc0000000,0xf8000000,0x6000000,0x0,0x62efdff,0x0,0x0,0x2e65f9,0x0,0x0,0x0,0x0,0x2e65f9,0x0,0x0,0x0,0x2e65f9,0x1fffdf9,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x2e65f9,0x2e65f9,0x0,0x0,0x0,0x0,0x0,0x2e65f9,0x0,0x0,0x0,0x0,0x0,0x2e6400,0x1fffc00,0x1fffc00,0x2e65f9,};
   }
   private static void jj_la1_7() {
      jj_la1_7 = new int[] {0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x2000f908,0x0,0x8000c800,0x4000,0x0,0x2000f908,0x0,0xc000,0x0,0xc000,0x0,0x0,0x0,0x0,0x4000,0x0,0x2000f908,0x0,0x2000f908,0x0,0x0,0x0,0xc000,0x0,0xc000,0x0,0xc000,0x0,0xc000,0x0,0x0,0x0,0x8000000,0x0,0x0,0x0,0x4000,0x1000000,0xc000,0x0,0x0,0x2000f908,0x4000,0x2000f908,0x2000f908,0x0,0x0,0x0,0x1000000,0x1000000,0x0,0x4000,0x0,0x0,0x4000,0x0,0x80000000,0x3000,0x2000c908,0x0,0x0,0x4000,0x1000000,0x4000,0x0,0x0,0x8000,0x0,0x0,0x0,0x0,0xc000,0x0,0xc000,0x0,0x0,0x0,0x0,0xc000,0x0,0x0,0x0,0x0,0x0,0xc800,0x0,0x2000f908,0x2000f908,0x0,0x8000c800,0x8000c800,0x1000000,0x3000000,0x2000f908,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0xc000000,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x2000c908,0x0,0x20000000,0x20000000,0x908,0x0,0x0,0x0,0x0,0xc800,0x200000,0x808,0x0,0x0,0x0,0x4000,0x0,0x0,0x0,0x8000,0x4800,0x2000f908,0x0,0x0,0x2000f908,0x0,0x0,0x8004800,0x200000,0x0,0x200000,0x0,0x908,0x0,0x0,0x0,0x0,0x2000f908,0x4000,0x4000,0x2000f908,0x4000,0x4000,0x4000,0x4000,0x2000f908,0x0,0x0,0x2000f908,0x2000f908,0x2000f908,0x2000f908,0x4000,0x2000f908,0x2000f908,0x0,0x0,0x0,0x0,0x2000f908,0x0,0x0,0x0,0x4000,0x2000f908,0x0,0x4000,0x4000,0x4000,0x4000,0x2000f908,0x2000f908,0x2000f908,0x2000f908,0x0,0x0,0x4000,0x0,0x0,0x0,0x4000,0x0,0x2000f908,0x0,0x2000f908,0x0,0x2000f908,0x2000f908,0x2000f908,0x0,0x0,0x0,0x0,0x2000f908,0x2000f908,0x0,0x0,0x0,0x0,0xc800,0x8000000,0x2000f908,0x0,0x2000f908,0xc000000,0xc000000,0x20000000,0x0,0x0,0x0,0x0,0xc800,0x8000000,0x0,0x0,0x2000f908,0x2000f908,0x0,0x0,0x2000f908,0x2000f908,0x0,0x0,0x0,0x8004000,0x8004000,0x0,0x0,0x0,0x8000000,0x4000,0x0,0x0,0x0,0x0,0x0,0x8000000,0x4000,0x4000,0x0,0x0,0x4000,0x0,0x0,0x0,0x0,0x8004000,0x0,0x4000,0x0,0x8004000,0x0,0x8000000,0x8000000,0x0,0x4000,0x0,0x8004000,0x0,0x8000000,0x8000000,0x2000f908,0x0,0x8000000,0x8000000,0x8004000,0x0,0x4008,0x80004000,0x0,0x0,0x4000,0x0,0x2000f908,0xc00000,0x1c00000,0x1c00000,0x1c00000,0x0,0x8000000,0x0,0x0,0xc800,0x0,0x0,0xc800,0xc800,0x8000000,0x0,0x8000000,0x4000,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x4000,0x0,0x0,0x0,0x0,0x2000f908,0x4000,0x0,0x0,0x0,0x4000,0x0,0x0,0x0,0x0,0x0,0x8000000,0x18000000,0x0,0x1000000,0x4000,0x0,0x0,0x2000f908,0x0,0x0,0x0,0x0,0x0,0x0,0x18000000,0x0,0x0,0x4000,0x0,0x0,0x0,0x0,0x0,0x0,0x18000007,0x0,0x0,0x0,0x0,0x18000007,0x0,0x0,0x0,0x4000,0x0,0x4000,0x7,0x18000007,0x0,0x8000000,0x2000f908,0x0,0x0,0xc800,0x0,0x4000,0x8000000,0x8000000,0x2000f908,0x0,0x8000000,0x0,0x2000f908,0x2800f908,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x8000000,0x1000000,0x0,0x0,0x8000000,0x4000000,0x0,0x0,0x0,0x0,0x4000,0x0,0x4000,0x0,0x8000000,0x0,0x4000,0x4000,0x0,0x4000,0x2000f908,0x2000f908,0x0,0x0,0x0,0x4000,0x0,0x2000f908,0x4000,0x4000,0x4000,0x0,0x4000,0x4000,0x4000,0x4000,0x4000,};
   }
   private static void jj_la1_8() {
      jj_la1_8 = new int[] {0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x23c021,0x0,0x0,0x0,0x0,0x23c021,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x23c021,0x0,0x23c021,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x20,0x0,0x0,0x10,0x0,0x0,0x0,0x23c021,0x0,0x23c021,0x23c021,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x23c021,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x10,0x0,0x0,0x0,0x0,0x10,0x0,0x10,0x0,0x0,0x0,0x0,0x10,0x0,0x0,0x0,0x0,0x0,0x10,0x0,0x23c021,0x23c021,0x0,0x0,0x0,0x10,0xf0000000,0x23c027,0x8,0x1000,0x2000,0x400000,0x800000,0x200000,0xcc0,0xc0,0xc00,0xcc0,0x300,0xe000000,0xe000000,0x30000,0x30000,0x10c0000,0x10c0000,0x100000,0x30000,0x23c021,0xc000,0x1,0x1,0x0,0xc000,0xc000,0x0,0x200000,0x20,0x20,0x0,0x20,0x0,0x80011,0x80031,0x0,0x0,0x20,0x0,0x20,0x23c021,0x0,0x10,0x23c031,0x20,0x10,0x0,0x0,0x20,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x23c027,0x0,0x0,0x23c021,0x0,0x0,0x0,0x0,0x23c027,0x0,0x0,0x23c021,0x23c021,0x23c021,0x23c021,0x0,0x23c021,0x23c021,0x0,0x0,0x0,0x0,0x23c021,0x0,0x0,0x0,0x0,0x23c021,0x0,0x0,0x0,0x0,0x0,0x23c021,0x23c021,0x23c021,0x23c021,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x23c021,0x0,0x23c027,0x0,0x23c027,0x23c027,0x23c027,0x0,0x0,0x30000,0x30000,0x23c021,0x23c021,0x0,0x0,0x0,0x10,0x200020,0x0,0x23c027,0x0,0x23c027,0x40000,0x40000,0x0,0x10,0x0,0x0,0x0,0x200020,0x0,0x0,0x0,0x23c027,0x23c027,0x0,0x0,0x23c021,0x23c027,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x10,0x0,0x0,0x0,0x10,0x0,0x0,0x0,0x10,0x0,0x0,0x10,0x0,0x0,0x0,0x23c027,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x10,0x23c027,0x0,0x0,0x10,0x10,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x6,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x23c021,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x10,0x10,0x10,0x0,0x0,0x0,0x0,0x23c021,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x30000,0x30000,0x0,0x10,0x0,0x0,0x0,0x0,0x0,0x10,0x0,0x0,0x0,0x0,0x10,0x0,0x10,0x10,0x0,0x0,0x0,0x0,0x10,0x0,0x0,0x23c021,0x0,0x0,0x200028,0x80000,0x0,0x2000,0x2000,0x23c027,0x0,0x0,0x0,0x23c021,0x23c021,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x23c021,0x23c021,0x0,0x0,0x0,0x0,0x0,0x23c027,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,};
   }
   private static void jj_la1_9() {
      jj_la1_9 = new int[] {0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x2108c00,0x2080000,0x0,0x0,0x0,0x2108c00,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x2108c00,0x0,0x2108c00,0x800,0x80000,0x0,0x0,0x0,0x0,0x20000,0x0,0x80000,0x0,0x8000,0x0,0x80000,0x0,0x0,0x0,0x8000,0x218800,0x0,0x0,0x0,0x8000,0x2108c00,0x0,0x2108c00,0x2108c00,0x0,0x8000,0x10000,0x0,0x0,0x80000,0x0,0x200000,0x80000,0x0,0x200000,0x0,0x0,0x8400,0x80000,0x80000,0x8000,0x0,0x0,0x8000,0x8000,0x0,0x20000,0x20000,0x8000,0x20000,0x0,0x0,0x0,0x20000,0x20000,0x8000,0x20000,0x0,0x20000,0x20000,0x8000,0x20000,0x0,0x0,0x80000,0x8c00,0x8c00,0x80000,0x0,0x0,0x0,0x3ff,0x8400,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x8400,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x8400,0x128000,0x0,0x0,0x100000,0x100000,0x100000,0x0,0x100000,0x0,0x8400,0x0,0x8400,0x80000,0x0,0x8400,0x100000,0x0,0x8000,0x0,0x120000,0x8000,0x0,0x0,0x0,0x2000,0x4000,0x80000,0x28c00,0x0,0x0,0x2108400,0x0,0x0,0x0,0x0,0x28c00,0x2000000,0x100000,0x2108c00,0x2108c00,0x2108c00,0x2108c00,0x0,0x2108c00,0x2108c00,0x0,0x0,0x80000,0x0,0x2108c00,0x8000,0x0,0x8000,0x0,0x8400,0x8000,0x0,0x0,0x0,0x0,0x2008400,0x8400,0x8400,0x8400,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x80000,0x8400,0x80000,0x8c00,0x0,0x28400,0x28400,0x28400,0x80000,0x0,0x0,0x0,0x8400,0x8400,0x100000,0x800,0x8000,0x0,0x8400,0x0,0x8400,0x80000,0x8400,0x0,0x0,0x0,0x0,0x800,0x800,0x0,0x8400,0x0,0x0,0x0,0x8400,0x8400,0x0,0x0,0x8400,0x8400,0x0,0x0,0x0,0x8000,0x8000,0x80000,0x80000,0x0,0x0,0x0,0x80000,0x8000,0x0,0x0,0x0,0x0,0x0,0x0,0x2000000,0x0,0x0,0x0,0x2000000,0x2000000,0x0,0x8000,0x0,0x0,0x0,0x8000,0x0,0x0,0x0,0x800,0x0,0x0,0x2000800,0x0,0x0,0x0,0x8400,0x0,0x0,0x0,0x800,0x80000,0x0,0x0,0x0,0x8000,0x0,0x0,0x8400,0x0,0x0,0x100000,0x100000,0x0,0x0,0x8000,0x0,0x0,0x80000,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x8400000,0x8400000,0x1400000,0x1400000,0x1400000,0x0,0x0,0x800,0x0,0x0,0x2108c00,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x800,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x10000,0x8400,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x800,0x0,0x0,0x0,0x0,0x800,0x0,0x0,0x0,0x0,0x80000,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x2108c00,0x80000,0x80000,0x8400,0x0,0x0,0x0,0x0,0x8400,0x0,0x0,0x80000,0x8400,0x8400,0x0,0x0,0x2000000,0x2000000,0x80000,0x0,0x0,0x0,0x0,0x0,0x80000,0x0,0x0,0x80000,0x0,0x100000,0x80000,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x8400,0x8400,0x0,0x0,0x2000800,0x0,0x0,0x8400,0x0,0x0,0x0,0x8000,0x218800,0x0,0x0,0x0,0x0,};
   }
  final private JJCalls[] jj_2_rtns = new JJCalls[104];
  private boolean jj_rescan = false;
  private int jj_gc = 0;

  public JudoParser(CharStream stream) {
    token_source = new JudoParserTokenManager(stream);
    token = new Token();
    jj_ntk = -1;
    jj_gen = 0;
    for (int i = 0; i < 435; i++) jj_la1[i] = -1;
    for (int i = 0; i < jj_2_rtns.length; i++) jj_2_rtns[i] = new JJCalls();
  }

  public void ReInit(CharStream stream) {
    token_source.ReInit(stream);
    token = new Token();
    jj_ntk = -1;
    jj_gen = 0;
    for (int i = 0; i < 435; i++) jj_la1[i] = -1;
    for (int i = 0; i < jj_2_rtns.length; i++) jj_2_rtns[i] = new JJCalls();
  }

  public JudoParser(JudoParserTokenManager tm) {
    token_source = tm;
    token = new Token();
    jj_ntk = -1;
    jj_gen = 0;
    for (int i = 0; i < 435; i++) jj_la1[i] = -1;
    for (int i = 0; i < jj_2_rtns.length; i++) jj_2_rtns[i] = new JJCalls();
  }

  public void ReInit(JudoParserTokenManager tm) {
    token_source = tm;
    token = new Token();
    jj_ntk = -1;
    jj_gen = 0;
    for (int i = 0; i < 435; i++) jj_la1[i] = -1;
    for (int i = 0; i < jj_2_rtns.length; i++) jj_2_rtns[i] = new JJCalls();
  }

  final private Token jj_consume_token(int kind) throws ParseException {
    Token oldToken;
    if ((oldToken = token).next != null) token = token.next;
    else token = token.next = token_source.getNextToken();
    jj_ntk = -1;
    if (token.kind == kind) {
      jj_gen++;
      if (++jj_gc > 100) {
        jj_gc = 0;
        for (int i = 0; i < jj_2_rtns.length; i++) {
          JJCalls c = jj_2_rtns[i];
          while (c != null) {
            if (c.gen < jj_gen) c.first = null;
            c = c.next;
          }
        }
      }
      return token;
    }
    token = oldToken;
    jj_kind = kind;
    throw generateParseException();
  }

  static private final class LookaheadSuccess extends java.lang.Error { }
  final private LookaheadSuccess jj_ls = new LookaheadSuccess();
  final private boolean jj_scan_token(int kind) {
    if (jj_scanpos == jj_lastpos) {
      jj_la--;
      if (jj_scanpos.next == null) {
        jj_lastpos = jj_scanpos = jj_scanpos.next = token_source.getNextToken();
      } else {
        jj_lastpos = jj_scanpos = jj_scanpos.next;
      }
    } else {
      jj_scanpos = jj_scanpos.next;
    }
    if (jj_rescan) {
      int i = 0; Token tok = token;
      while (tok != null && tok != jj_scanpos) { i++; tok = tok.next; }
      if (tok != null) jj_add_error_token(kind, i);
    }
    if (jj_scanpos.kind != kind) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) throw jj_ls;
    return false;
  }

  final public Token getNextToken() {
    if (token.next != null) token = token.next;
    else token = token.next = token_source.getNextToken();
    jj_ntk = -1;
    jj_gen++;
    return token;
  }

  final public Token getToken(int index) {
    Token t = lookingAhead ? jj_scanpos : token;
    for (int i = 0; i < index; i++) {
      if (t.next != null) t = t.next;
      else t = t.next = token_source.getNextToken();
    }
    return t;
  }

  final private int jj_ntk() {
    if ((jj_nt=token.next) == null)
      return (jj_ntk = (token.next=token_source.getNextToken()).kind);
    else
      return (jj_ntk = jj_nt.kind);
  }

  private java.util.Vector jj_expentries = new java.util.Vector();
  private int[] jj_expentry;
  private int jj_kind = -1;
  private int[] jj_lasttokens = new int[100];
  private int jj_endpos;

  private void jj_add_error_token(int kind, int pos) {
    if (pos >= 100) return;
    if (pos == jj_endpos + 1) {
      jj_lasttokens[jj_endpos++] = kind;
    } else if (jj_endpos != 0) {
      jj_expentry = new int[jj_endpos];
      for (int i = 0; i < jj_endpos; i++) {
        jj_expentry[i] = jj_lasttokens[i];
      }
      boolean exists = false;
      for (java.util.Enumeration e = jj_expentries.elements(); e.hasMoreElements();) {
        int[] oldentry = (int[])(e.nextElement());
        if (oldentry.length == jj_expentry.length) {
          exists = true;
          for (int i = 0; i < jj_expentry.length; i++) {
            if (oldentry[i] != jj_expentry[i]) {
              exists = false;
              break;
            }
          }
          if (exists) break;
        }
      }
      if (!exists) jj_expentries.addElement(jj_expentry);
      if (pos != 0) jj_lasttokens[(jj_endpos = pos) - 1] = kind;
    }
  }

  public ParseException generateParseException() {
    jj_expentries.removeAllElements();
    boolean[] la1tokens = new boolean[317];
    for (int i = 0; i < 317; i++) {
      la1tokens[i] = false;
    }
    if (jj_kind >= 0) {
      la1tokens[jj_kind] = true;
      jj_kind = -1;
    }
    for (int i = 0; i < 435; i++) {
      if (jj_la1[i] == jj_gen) {
        for (int j = 0; j < 32; j++) {
          if ((jj_la1_0[i] & (1<<j)) != 0) {
            la1tokens[j] = true;
          }
          if ((jj_la1_1[i] & (1<<j)) != 0) {
            la1tokens[32+j] = true;
          }
          if ((jj_la1_2[i] & (1<<j)) != 0) {
            la1tokens[64+j] = true;
          }
          if ((jj_la1_3[i] & (1<<j)) != 0) {
            la1tokens[96+j] = true;
          }
          if ((jj_la1_4[i] & (1<<j)) != 0) {
            la1tokens[128+j] = true;
          }
          if ((jj_la1_5[i] & (1<<j)) != 0) {
            la1tokens[160+j] = true;
          }
          if ((jj_la1_6[i] & (1<<j)) != 0) {
            la1tokens[192+j] = true;
          }
          if ((jj_la1_7[i] & (1<<j)) != 0) {
            la1tokens[224+j] = true;
          }
          if ((jj_la1_8[i] & (1<<j)) != 0) {
            la1tokens[256+j] = true;
          }
          if ((jj_la1_9[i] & (1<<j)) != 0) {
            la1tokens[288+j] = true;
          }
        }
      }
    }
    for (int i = 0; i < 317; i++) {
      if (la1tokens[i]) {
        jj_expentry = new int[1];
        jj_expentry[0] = i;
        jj_expentries.addElement(jj_expentry);
      }
    }
    jj_endpos = 0;
    jj_rescan_token();
    jj_add_error_token(0, 0);
    int[][] exptokseq = new int[jj_expentries.size()][];
    for (int i = 0; i < jj_expentries.size(); i++) {
      exptokseq[i] = (int[])jj_expentries.elementAt(i);
    }
    return new ParseException(token, exptokseq, tokenImage);
  }

  final public void enable_tracing() {
  }

  final public void disable_tracing() {
  }

  final private void jj_rescan_token() {
    jj_rescan = true;
    for (int i = 0; i < 104; i++) {
      JJCalls p = jj_2_rtns[i];
      do {
        if (p.gen > jj_gen) {
          jj_la = p.arg; jj_lastpos = jj_scanpos = p.first;
          switch (i) {
            case 0: jj_3_1(); break;
            case 1: jj_3_2(); break;
            case 2: jj_3_3(); break;
            case 3: jj_3_4(); break;
            case 4: jj_3_5(); break;
            case 5: jj_3_6(); break;
            case 6: jj_3_7(); break;
            case 7: jj_3_8(); break;
            case 8: jj_3_9(); break;
            case 9: jj_3_10(); break;
            case 10: jj_3_11(); break;
            case 11: jj_3_12(); break;
            case 12: jj_3_13(); break;
            case 13: jj_3_14(); break;
            case 14: jj_3_15(); break;
            case 15: jj_3_16(); break;
            case 16: jj_3_17(); break;
            case 17: jj_3_18(); break;
            case 18: jj_3_19(); break;
            case 19: jj_3_20(); break;
            case 20: jj_3_21(); break;
            case 21: jj_3_22(); break;
            case 22: jj_3_23(); break;
            case 23: jj_3_24(); break;
            case 24: jj_3_25(); break;
            case 25: jj_3_26(); break;
            case 26: jj_3_27(); break;
            case 27: jj_3_28(); break;
            case 28: jj_3_29(); break;
            case 29: jj_3_30(); break;
            case 30: jj_3_31(); break;
            case 31: jj_3_32(); break;
            case 32: jj_3_33(); break;
            case 33: jj_3_34(); break;
            case 34: jj_3_35(); break;
            case 35: jj_3_36(); break;
            case 36: jj_3_37(); break;
            case 37: jj_3_38(); break;
            case 38: jj_3_39(); break;
            case 39: jj_3_40(); break;
            case 40: jj_3_41(); break;
            case 41: jj_3_42(); break;
            case 42: jj_3_43(); break;
            case 43: jj_3_44(); break;
            case 44: jj_3_45(); break;
            case 45: jj_3_46(); break;
            case 46: jj_3_47(); break;
            case 47: jj_3_48(); break;
            case 48: jj_3_49(); break;
            case 49: jj_3_50(); break;
            case 50: jj_3_51(); break;
            case 51: jj_3_52(); break;
            case 52: jj_3_53(); break;
            case 53: jj_3_54(); break;
            case 54: jj_3_55(); break;
            case 55: jj_3_56(); break;
            case 56: jj_3_57(); break;
            case 57: jj_3_58(); break;
            case 58: jj_3_59(); break;
            case 59: jj_3_60(); break;
            case 60: jj_3_61(); break;
            case 61: jj_3_62(); break;
            case 62: jj_3_63(); break;
            case 63: jj_3_64(); break;
            case 64: jj_3_65(); break;
            case 65: jj_3_66(); break;
            case 66: jj_3_67(); break;
            case 67: jj_3_68(); break;
            case 68: jj_3_69(); break;
            case 69: jj_3_70(); break;
            case 70: jj_3_71(); break;
            case 71: jj_3_72(); break;
            case 72: jj_3_73(); break;
            case 73: jj_3_74(); break;
            case 74: jj_3_75(); break;
            case 75: jj_3_76(); break;
            case 76: jj_3_77(); break;
            case 77: jj_3_78(); break;
            case 78: jj_3_79(); break;
            case 79: jj_3_80(); break;
            case 80: jj_3_81(); break;
            case 81: jj_3_82(); break;
            case 82: jj_3_83(); break;
            case 83: jj_3_84(); break;
            case 84: jj_3_85(); break;
            case 85: jj_3_86(); break;
            case 86: jj_3_87(); break;
            case 87: jj_3_88(); break;
            case 88: jj_3_89(); break;
            case 89: jj_3_90(); break;
            case 90: jj_3_91(); break;
            case 91: jj_3_92(); break;
            case 92: jj_3_93(); break;
            case 93: jj_3_94(); break;
            case 94: jj_3_95(); break;
            case 95: jj_3_96(); break;
            case 96: jj_3_97(); break;
            case 97: jj_3_98(); break;
            case 98: jj_3_99(); break;
            case 99: jj_3_100(); break;
            case 100: jj_3_101(); break;
            case 101: jj_3_102(); break;
            case 102: jj_3_103(); break;
            case 103: jj_3_104(); break;
          }
        }
        p = p.next;
      } while (p != null);
    }
    jj_rescan = false;
  }

  final private void jj_save(int index, int xla) {
    JJCalls p = jj_2_rtns[index];
    while (p.gen > jj_gen) {
      if (p.next == null) { p = p.next = new JJCalls(); break; }
      p = p.next;
    }
    p.gen = jj_gen + xla - jj_la; p.first = token; p.arg = xla;
  }

  static final class JJCalls {
    int gen;
    Token first;
    int arg;
    JJCalls next;
  }

}
