/* Generated By:JavaCC: Do not edit this line. JudoParserTokenManager.java */
package com.judoscript.parser;
import java.util.*;
import java.io.*;
import java.sql.Types;
import com.judoscript.*;
import com.judoscript.bio.*;
import com.judoscript.db.*;
import com.judoscript.xml.*;
import com.judoscript.util.*;
import com.judoscript.parser.helper.*;

public class JudoParserTokenManager implements JudoParserConstants
{
  // lexical state director --
  boolean inHereDoc = false;

  // Returns the input_stream for use by MixtureList().
//used to be:  public ASCII_UCodeESC_CharStream getInputStream() { return input_stream; }
  public CharStream getInputStream() { return input_stream; }

  // Include support -- How does include work?
  //
  //  It is obvious that a stack is needed. Methods switchToNewFileStream()
  //  and restorePreviousFileStream() are self-explanatory, too.
  //  What's interesting is how the file info is kept with the parsed structure.
  //
  // ArrayList JudoParser.super.fileNames keeps all the file names.
  // Each statement object has a line number and a file name index.
  // During parsing, JudoParser.super.curFileIndex keeps the current
  // file name index, updated (by the token manager) when a file
  // stream is pushed or popped.
  //
  // The parser invokes JudoParserTokenManager.switchToNewFileStream()
  // when a new include appears and the file name is recorded into
  // JudoParser.fileNames; when JudoParserTokenManager sees EOF, if the
  // stack is not empty, it invokes its own restorePreviousFileStream().
  // In both cases, the JudoParser.curFileIndex is updated to the size
  // of the stack.

  JudoParser judoParser = null; // set by JudoParser asap.
  Stack fileStreamStack = new Stack();

  int currentFileStreamIndex() { return fileStreamStack.size(); }

  boolean isMain() { return fileStreamStack.size() == 1; }

  void switchToNewFileStream(String incFile, String enc) throws ParseException {
//    judoParser.addFile(incFile);

    fileStreamStack.push(input_stream);
    try {
      Reader r;
      if (Lib.isAbsolutePath(incFile))
        r = JudoUtil.findFile(null, incFile, enc);
      else
        r = JudoUtil.findFile(judoParser.getScriptBasePath(), incFile, enc);
      CharStream new_stream = new JudoCharStream(r);
      ReInit(new_stream);
      judoParser.curFileIndex = fileStreamStack.size();
    } catch(IOException ioe) {
      throw new ParseException(Lib.getExceptionMsg("Failed to open included file",ioe));
    }
  }

  void restorePreviousFileStream() {
    ReInit( (CharStream)fileStreamStack.pop() );
    judoParser.curFileIndex = fileStreamStack.size();
  }

  void CommonTokenAction(Token t) {
    if (t.kind == EOF && !fileStreamStack.isEmpty()) {
      restorePreviousFileStream();

      Token new_t = getNextToken();
      t.kind = new_t.kind;
      t.beginLine = new_t.beginLine;
      t.beginColumn = new_t.beginColumn;
      t.endLine = new_t.endLine;
      t.endColumn = new_t.endColumn;
      t.image = new_t.image;
      t.next = new_t.next;
      t.specialToken = new_t.specialToken;
    }
  }
  public  java.io.PrintStream debugStream = System.out;
  public  void setDebugStream(java.io.PrintStream ds) { debugStream = ds; }
private final int jjStopStringLiteralDfa_0(int pos, long active0, long active1, long active2, long active3, long active4)
{
   switch (pos)
   {
      case 0:
         if ((active0 & 0xfdffffffffff800L) != 0L || (active1 & 0xfffffffffffffff0L) != 0L || (active2 & 0xffffffffffffffffL) != 0L || (active3 & 0x7ffffffL) != 0L || (active4 & 0x40000000000L) != 0L)
         {
            jjmatchedKind = 238;
            return 73;
         }
         if ((active4 & 0x100080000L) != 0L)
            return 97;
         if ((active4 & 0x30000000000000L) != 0L)
            return 9;
         return -1;
      case 1:
         if ((active0 & 0x1de00080080000L) != 0L || (active1 & 0x2024800c4000L) != 0L || (active2 & 0x200028009L) != 0L || (active3 & 0x100000L) != 0L)
            return 73;
         if ((active0 & 0xfc21fff7ff7f800L) != 0L || (active1 & 0xffffdfdb7ff3bff0L) != 0L || (active2 & 0xfffffffdfffd7ff6L) != 0L || (active3 & 0x7efffffL) != 0L)
         {
            if (jjmatchedPos != 1)
            {
               jjmatchedKind = 238;
               jjmatchedPos = 1;
            }
            return 73;
         }
         return -1;
      case 2:
         if ((active0 & 0xf4bdf7f7ff17800L) != 0L || (active1 & 0x3f9f9ffbf9dbbff0L) != 0L || (active2 & 0xff0003ffff8d77ecL) != 0L || (active3 & 0x74bbfffL) != 0L)
         {
            if (jjmatchedPos != 2)
            {
               jjmatchedKind = 238;
               jjmatchedPos = 2;
            }
            return 73;
         }
         if ((active0 & 0x90008000068000L) != 0L || (active1 & 0xc060400406200000L) != 0L || (active2 & 0x700812L) != 0L || (active3 & 0xb44000L) != 0L)
            return 73;
         if ((active2 & 0xfffc0000000000L) != 0L)
         {
            if (jjmatchedPos < 1)
            {
               jjmatchedKind = 238;
               jjmatchedPos = 1;
            }
            return -1;
         }
         return -1;
      case 3:
         if ((active0 & 0x810010704200000L) != 0L || (active1 & 0x6060109a0109040L) != 0L || (active2 & 0x1fc001004L) != 0L || (active3 & 0x1408000L) != 0L)
            return 73;
         if ((active0 & 0x74bde787bd13800L) != 0L || (active1 & 0x39999ef259cb2fb0L) != 0L || (active2 & 0x10003fe03fd67f8L) != 0L || (active3 & 0x22f3e00L) != 0L)
         {
            if (jjmatchedPos != 3)
            {
               jjmatchedKind = 238;
               jjmatchedPos = 3;
            }
            return 73;
         }
         if ((active2 & 0xfffc0000000000L) != 0L)
         {
            if (jjmatchedPos < 1)
            {
               jjmatchedKind = 238;
               jjmatchedPos = 1;
            }
            return -1;
         }
         if ((active0 & 0x4000L) != 0L || (active2 & 0xfe00000000000000L) != 0L || (active3 & 0x40001ffL) != 0L)
         {
            if (jjmatchedPos < 2)
            {
               jjmatchedKind = 238;
               jjmatchedPos = 2;
            }
            return -1;
         }
         return -1;
      case 4:
         if ((active0 & 0x40402012d00800L) != 0L || (active1 & 0x1219402610L) != 0L || (active2 & 0x1000000000407c8L) != 0L || (active3 & 0x210400L) != 0L)
            return 73;
         if ((active2 & 0xfffc0000000000L) != 0L)
         {
            if (jjmatchedPos < 1)
            {
               jjmatchedKind = 238;
               jjmatchedPos = 1;
            }
            return -1;
         }
         if ((active0 & 0x4000L) != 0L || (active2 & 0xfe00000000000000L) != 0L || (active3 & 0x40001ffL) != 0L)
         {
            if (jjmatchedPos < 2)
            {
               jjmatchedKind = 238;
               jjmatchedPos = 2;
            }
            return -1;
         }
         if ((active0 & 0x2000L) != 0L || (active1 & 0xe0000000000L) != 0L || (active3 & 0x200L) != 0L)
         {
            if (jjmatchedPos < 3)
            {
               jjmatchedKind = 238;
               jjmatchedPos = 3;
            }
            return -1;
         }
         if ((active0 & 0x70b9e5869011000L) != 0L || (active1 & 0x399d90e0408b09a0L) != 0L || (active2 & 0x3fffff96030L) != 0L || (active3 & 0x20e3800L) != 0L)
         {
            if (jjmatchedPos != 4)
            {
               jjmatchedKind = 238;
               jjmatchedPos = 4;
            }
            return 73;
         }
         return -1;
      case 5:
         if ((active0 & 0x70912582b011000L) != 0L || (active1 & 0x19d100040820020L) != 0L || (active2 & 0x3ffff716720L) != 0L || (active3 & 0x20a3000L) != 0L)
         {
            if (jjmatchedPos != 5)
            {
               jjmatchedKind = 238;
               jjmatchedPos = 5;
            }
            return 73;
         }
         if ((active0 & 0x28c0040000000L) != 0L || (active1 & 0x380080e000090980L) != 0L || (active2 & 0x880010L) != 0L || (active3 & 0x40800L) != 0L)
            return 73;
         if ((active2 & 0xfe00000000000000L) != 0L || (active3 & 0x40001ffL) != 0L)
         {
            if (jjmatchedPos < 2)
            {
               jjmatchedKind = 238;
               jjmatchedPos = 2;
            }
            return -1;
         }
         if ((active2 & 0xfffc0000000000L) != 0L)
         {
            if (jjmatchedPos < 1)
            {
               jjmatchedKind = 238;
               jjmatchedPos = 1;
            }
            return -1;
         }
         if ((active0 & 0x2000L) != 0L || (active1 & 0xe0000000000L) != 0L || (active3 & 0x200L) != 0L)
         {
            if (jjmatchedPos < 3)
            {
               jjmatchedKind = 238;
               jjmatchedPos = 3;
            }
            return -1;
         }
         return -1;
      case 6:
         if ((active0 & 0x100005828000000L) != 0L || (active1 & 0x1000040000000L) != 0L || (active2 & 0x3fc02010100L) != 0L)
            return 73;
         if ((active0 & 0x609120003011000L) != 0L || (active1 & 0x19c100000820020L) != 0L || (active2 & 0x3fd706620L) != 0L || (active3 & 0x20e3000L) != 0L)
         {
            if (jjmatchedPos != 6)
            {
               jjmatchedKind = 238;
               jjmatchedPos = 6;
            }
            return 73;
         }
         if ((active2 & 0xfe00000000000000L) != 0L || (active3 & 0x40001ffL) != 0L)
         {
            if (jjmatchedPos < 2)
            {
               jjmatchedKind = 238;
               jjmatchedPos = 2;
            }
            return -1;
         }
         if ((active2 & 0xfffc0000000000L) != 0L)
         {
            if (jjmatchedPos < 1)
            {
               jjmatchedKind = 238;
               jjmatchedPos = 1;
            }
            return -1;
         }
         if ((active1 & 0xe0000000000L) != 0L)
         {
            if (jjmatchedPos < 3)
            {
               jjmatchedKind = 238;
               jjmatchedPos = 3;
            }
            return -1;
         }
         return -1;
      case 7:
         if ((active0 & 0x9020001000000L) != 0L || (active1 & 0x4100000000000L) != 0L || (active2 & 0x1002000L) != 0L || (active3 & 0x23000L) != 0L)
            return 73;
         if ((active0 & 0x1000L) != 0L)
         {
            if (jjmatchedPos < 6)
            {
               jjmatchedKind = 238;
               jjmatchedPos = 6;
            }
            return -1;
         }
         if ((active2 & 0xfe00000000000000L) != 0L || (active3 & 0x40001ffL) != 0L)
         {
            if (jjmatchedPos < 2)
            {
               jjmatchedKind = 238;
               jjmatchedPos = 2;
            }
            return -1;
         }
         if ((active2 & 0xf9fc0000000000L) != 0L)
         {
            if (jjmatchedPos < 1)
            {
               jjmatchedKind = 238;
               jjmatchedPos = 1;
            }
            return -1;
         }
         if ((active1 & 0xe0000000000L) != 0L)
         {
            if (jjmatchedPos < 3)
            {
               jjmatchedKind = 238;
               jjmatchedPos = 3;
            }
            return -1;
         }
         if ((active0 & 0x600101002010000L) != 0L || (active1 & 0x198000000820020L) != 0L || (active2 & 0x3fbfc704620L) != 0L || (active3 & 0x20c0000L) != 0L)
         {
            jjmatchedKind = 238;
            jjmatchedPos = 7;
            return 73;
         }
         return -1;
      case 8:
         if ((active0 & 0x100000010000L) != 0L || (active1 & 0x180000000800020L) != 0L || (active2 & 0x200004000L) != 0L || (active3 & 0x2000000L) != 0L)
            return 73;
         if ((active0 & 0x1000L) != 0L)
         {
            if (jjmatchedPos < 6)
            {
               jjmatchedKind = 238;
               jjmatchedPos = 6;
            }
            return -1;
         }
         if ((active2 & 0xfe00000000000000L) != 0L || (active3 & 0x40001efL) != 0L)
         {
            if (jjmatchedPos < 2)
            {
               jjmatchedKind = 238;
               jjmatchedPos = 2;
            }
            return -1;
         }
         if ((active2 & 0xf1fc0000000000L) != 0L)
         {
            if (jjmatchedPos < 1)
            {
               jjmatchedKind = 238;
               jjmatchedPos = 1;
            }
            return -1;
         }
         if ((active1 & 0xe0000000000L) != 0L)
         {
            if (jjmatchedPos < 3)
            {
               jjmatchedKind = 238;
               jjmatchedPos = 3;
            }
            return -1;
         }
         if ((active0 & 0x600001002000000L) != 0L || (active1 & 0x18000000020000L) != 0L || (active2 & 0x3f9fc700620L) != 0L || (active3 & 0xc0000L) != 0L)
         {
            if (jjmatchedPos != 8)
            {
               jjmatchedKind = 238;
               jjmatchedPos = 8;
            }
            return 73;
         }
         return -1;
      case 9:
         if ((active0 & 0x600000000000000L) != 0L || (active1 & 0x18000000000000L) != 0L || (active2 & 0x60000600L) != 0L || (active3 & 0x80000L) != 0L)
            return 73;
         if ((active0 & 0x1002000000L) != 0L || (active1 & 0x20000L) != 0L || (active2 & 0x3f99c700020L) != 0L || (active3 & 0x40000L) != 0L)
         {
            if (jjmatchedPos != 9)
            {
               jjmatchedKind = 238;
               jjmatchedPos = 9;
            }
            return 73;
         }
         if ((active2 & 0xfe00000000000000L) != 0L || (active3 & 0x40001ceL) != 0L)
         {
            if (jjmatchedPos < 2)
            {
               jjmatchedKind = 238;
               jjmatchedPos = 2;
            }
            return -1;
         }
         if ((active2 & 0xf13c0000000000L) != 0L)
         {
            if (jjmatchedPos < 1)
            {
               jjmatchedKind = 238;
               jjmatchedPos = 1;
            }
            return -1;
         }
         if ((active1 & 0xe0000000000L) != 0L)
         {
            if (jjmatchedPos < 3)
            {
               jjmatchedKind = 238;
               jjmatchedPos = 3;
            }
            return -1;
         }
         return -1;
      case 10:
         if ((active0 & 0x1002000000L) != 0L || (active2 & 0x800300000L) != 0L)
            return 73;
         if ((active1 & 0x20000L) != 0L || (active2 & 0x3f19c400420L) != 0L || (active3 & 0x40000L) != 0L)
         {
            if (jjmatchedPos != 10)
            {
               jjmatchedKind = 238;
               jjmatchedPos = 10;
            }
            return 73;
         }
         if ((active2 & 0xac00000000000000L) != 0L || (active3 & 0x40001ccL) != 0L)
         {
            if (jjmatchedPos < 2)
            {
               jjmatchedKind = 238;
               jjmatchedPos = 2;
            }
            return -1;
         }
         if ((active2 & 0xe13c0000000000L) != 0L)
         {
            if (jjmatchedPos < 1)
            {
               jjmatchedKind = 238;
               jjmatchedPos = 1;
            }
            return -1;
         }
         if ((active1 & 0xc0000000000L) != 0L)
         {
            if (jjmatchedPos < 3)
            {
               jjmatchedKind = 238;
               jjmatchedPos = 3;
            }
            return -1;
         }
         return -1;
      case 11:
         if ((active1 & 0x20000L) != 0L || (active2 & 0x1c400020L) != 0L)
            return 73;
         if ((active2 & 0xac00000000000000L) != 0L || (active3 & 0x44L) != 0L)
         {
            if (jjmatchedPos < 2)
            {
               jjmatchedKind = 238;
               jjmatchedPos = 2;
            }
            return -1;
         }
         if ((active2 & 0xa12c0000000000L) != 0L)
         {
            if (jjmatchedPos < 1)
            {
               jjmatchedKind = 238;
               jjmatchedPos = 1;
            }
            return -1;
         }
         if ((active2 & 0x3f180000400L) != 0L || (active3 & 0x40000L) != 0L)
         {
            if (jjmatchedPos != 11)
            {
               jjmatchedKind = 238;
               jjmatchedPos = 11;
            }
            return 73;
         }
         if ((active1 & 0xc0000000000L) != 0L)
         {
            if (jjmatchedPos < 3)
            {
               jjmatchedKind = 238;
               jjmatchedPos = 3;
            }
            return -1;
         }
         return -1;
      case 12:
         if ((active2 & 0x180000000L) != 0L)
            return 73;
         if ((active2 & 0xc00000000000000L) != 0L || (active3 & 0x40L) != 0L)
         {
            if (jjmatchedPos < 2)
            {
               jjmatchedKind = 238;
               jjmatchedPos = 2;
            }
            return -1;
         }
         if ((active2 & 0xa1240000000000L) != 0L)
         {
            if (jjmatchedPos < 1)
            {
               jjmatchedKind = 238;
               jjmatchedPos = 1;
            }
            return -1;
         }
         if ((active1 & 0xc0000000000L) != 0L)
         {
            if (jjmatchedPos < 3)
            {
               jjmatchedKind = 238;
               jjmatchedPos = 3;
            }
            return -1;
         }
         if ((active2 & 0x3f010000400L) != 0L || (active3 & 0x40000L) != 0L)
         {
            if (jjmatchedPos != 12)
            {
               jjmatchedKind = 238;
               jjmatchedPos = 12;
            }
            return 73;
         }
         return -1;
      case 13:
         if ((active2 & 0x400L) != 0L)
            return 73;
         if ((active2 & 0x3f110000000L) != 0L || (active3 & 0x40000L) != 0L)
         {
            jjmatchedKind = 238;
            jjmatchedPos = 13;
            return 73;
         }
         if ((active2 & 0x800000000000000L) != 0L || (active3 & 0x40L) != 0L)
         {
            if (jjmatchedPos < 2)
            {
               jjmatchedKind = 238;
               jjmatchedPos = 2;
            }
            return -1;
         }
         if ((active2 & 0xa0200000000000L) != 0L)
         {
            if (jjmatchedPos < 1)
            {
               jjmatchedKind = 238;
               jjmatchedPos = 1;
            }
            return -1;
         }
         if ((active1 & 0x80000000000L) != 0L)
         {
            if (jjmatchedPos < 3)
            {
               jjmatchedKind = 238;
               jjmatchedPos = 3;
            }
            return -1;
         }
         return -1;
      case 14:
         if ((active2 & 0x3f000000000L) != 0L)
            return 73;
         if ((active2 & 0x800000000000000L) != 0L || (active3 & 0x40L) != 0L)
         {
            if (jjmatchedPos < 2)
            {
               jjmatchedKind = 238;
               jjmatchedPos = 2;
            }
            return -1;
         }
         if ((active2 & 0x80000000000000L) != 0L)
         {
            if (jjmatchedPos < 1)
            {
               jjmatchedKind = 238;
               jjmatchedPos = 1;
            }
            return -1;
         }
         if ((active2 & 0x110000000L) != 0L || (active3 & 0x40000L) != 0L)
         {
            if (jjmatchedPos != 14)
            {
               jjmatchedKind = 238;
               jjmatchedPos = 14;
            }
            return 73;
         }
         if ((active1 & 0x80000000000L) != 0L)
         {
            if (jjmatchedPos < 3)
            {
               jjmatchedKind = 238;
               jjmatchedPos = 3;
            }
            return -1;
         }
         return -1;
      case 15:
         if ((active2 & 0x10000000L) != 0L || (active3 & 0x40000L) != 0L)
            return 73;
         if ((active2 & 0x800000000000000L) != 0L || (active3 & 0x40L) != 0L)
         {
            if (jjmatchedPos < 2)
            {
               jjmatchedKind = 238;
               jjmatchedPos = 2;
            }
            return -1;
         }
         if ((active1 & 0x80000000000L) != 0L)
         {
            if (jjmatchedPos < 3)
            {
               jjmatchedKind = 238;
               jjmatchedPos = 3;
            }
            return -1;
         }
         if ((active2 & 0x3e100000000L) != 0L)
         {
            jjmatchedKind = 238;
            jjmatchedPos = 15;
            return 73;
         }
         return -1;
      case 16:
         if ((active2 & 0x3e000000000L) != 0L)
         {
            jjmatchedKind = 238;
            jjmatchedPos = 16;
            return 73;
         }
         if ((active2 & 0x100000000L) != 0L)
            return 73;
         if ((active3 & 0x40L) != 0L)
         {
            if (jjmatchedPos < 2)
            {
               jjmatchedKind = 238;
               jjmatchedPos = 2;
            }
            return -1;
         }
         return -1;
      case 17:
         if ((active2 & 0x3e000000000L) != 0L)
         {
            jjmatchedKind = 238;
            jjmatchedPos = 17;
            return 73;
         }
         if ((active3 & 0x40L) != 0L)
         {
            if (jjmatchedPos < 2)
            {
               jjmatchedKind = 238;
               jjmatchedPos = 2;
            }
            return -1;
         }
         return -1;
      case 18:
         if ((active2 & 0x2000000000L) != 0L)
            return 73;
         if ((active3 & 0x40L) != 0L)
         {
            if (jjmatchedPos < 2)
            {
               jjmatchedKind = 238;
               jjmatchedPos = 2;
            }
            return -1;
         }
         if ((active2 & 0x3c000000000L) != 0L)
         {
            jjmatchedKind = 238;
            jjmatchedPos = 18;
            return 73;
         }
         return -1;
      case 19:
         if ((active2 & 0x30000000000L) != 0L)
         {
            if (jjmatchedPos != 19)
            {
               jjmatchedKind = 238;
               jjmatchedPos = 19;
            }
            return 73;
         }
         if ((active2 & 0xc000000000L) != 0L)
            return 73;
         if ((active3 & 0x40L) != 0L)
         {
            if (jjmatchedPos < 2)
            {
               jjmatchedKind = 238;
               jjmatchedPos = 2;
            }
            return -1;
         }
         return -1;
      case 20:
         if ((active2 & 0x30000000000L) != 0L)
            return 73;
         if ((active3 & 0x40L) != 0L)
         {
            if (jjmatchedPos < 2)
            {
               jjmatchedKind = 238;
               jjmatchedPos = 2;
            }
            return -1;
         }
         if ((active2 & 0x8000000000L) != 0L)
         {
            if (jjmatchedPos != 20)
            {
               jjmatchedKind = 238;
               jjmatchedPos = 20;
            }
            return 73;
         }
         return -1;
      case 21:
         if ((active2 & 0x28000000000L) != 0L)
         {
            jjmatchedKind = 238;
            jjmatchedPos = 21;
            return 73;
         }
         return -1;
      case 22:
         if ((active2 & 0x28000000000L) != 0L)
         {
            jjmatchedKind = 238;
            jjmatchedPos = 22;
            return 73;
         }
         return -1;
      case 23:
         if ((active2 & 0x8000000000L) != 0L)
            return 73;
         if ((active2 & 0x20000000000L) != 0L)
         {
            jjmatchedKind = 238;
            jjmatchedPos = 23;
            return 73;
         }
         return -1;
      default :
         return -1;
   }
}
private final int jjStartNfa_0(int pos, long active0, long active1, long active2, long active3, long active4)
{
   return jjMoveNfa_0(jjStopStringLiteralDfa_0(pos, active0, active1, active2, active3, active4), pos + 1);
}
private final int jjStopAtPos(int pos, int kind)
{
   jjmatchedKind = kind;
   jjmatchedPos = pos;
   return pos + 1;
}
private final int jjStartNfaWithStates_0(int pos, int kind, int state)
{
   jjmatchedKind = kind;
   jjmatchedPos = pos;
   try { curChar = input_stream.readChar(); }
   catch(java.io.IOException e) { return pos + 1; }
   return jjMoveNfa_0(state, pos + 1);
}
private final int jjMoveStringLiteralDfa0_0()
{
   switch(curChar)
   {
      case 33:
         jjmatchedKind = 253;
         return jjMoveStringLiteralDfa1_0(0xf020000000000000L, 0xfL, 0x0L, 0x4000000000000000L, 0xc00L);
      case 36:
         return jjMoveStringLiteralDfa1_0(0x0L, 0x0L, 0x0L, 0x0L, 0x40000000000L);
      case 37:
         jjmatchedKind = 280;
         return jjMoveStringLiteralDfa1_0(0x0L, 0x0L, 0x0L, 0x0L, 0x4000000000L);
      case 38:
         jjmatchedKind = 277;
         return jjMoveStringLiteralDfa1_0(0x0L, 0x0L, 0x0L, 0x0L, 0x600002000L);
      case 40:
         jjmatchedKind = 303;
         return jjMoveStringLiteralDfa1_0(0x0L, 0x0L, 0x0L, 0x0L, 0x40000000000000L);
      case 41:
         return jjStopAtPos(0, 304);
      case 42:
         jjmatchedKind = 274;
         return jjMoveStringLiteralDfa1_0(0x0L, 0x0L, 0x0L, 0x0L, 0x1080000080100000L);
      case 43:
         jjmatchedKind = 272;
         return jjMoveStringLiteralDfa1_0(0x0L, 0x0L, 0x0L, 0x0L, 0x20004000L);
      case 44:
         return jjStopAtPos(0, 307);
      case 45:
         jjmatchedKind = 273;
         return jjMoveStringLiteralDfa1_0(0x0L, 0x0L, 0x0L, 0x20000000000000L, 0x40008000L);
      case 46:
         jjmatchedKind = 308;
         return jjMoveStringLiteralDfa1_0(0x0L, 0x0L, 0x0L, 0x0L, 0x20000000000000L);
      case 47:
         jjmatchedKind = 275;
         return jjMoveStringLiteralDfa1_0(0x0L, 0x0L, 0x0L, 0x0L, 0x100000000L);
      case 58:
         jjmatchedKind = 260;
         return jjMoveStringLiteralDfa1_0(0x0L, 0x0L, 0x0L, 0x200000000000000L, 0x20L);
      case 59:
         return jjStopAtPos(0, 313);
      case 60:
         jjmatchedKind = 251;
         return jjMoveStringLiteralDfa1_0(0x0L, 0x0L, 0x0L, 0x10800007f8000000L, 0x8002000100L);
      case 61:
         jjmatchedKind = 248;
         return jjMoveStringLiteralDfa1_0(0x0L, 0x0L, 0x0L, 0x40000000000000L, 0xc0L);
      case 62:
         jjmatchedKind = 250;
         return jjMoveStringLiteralDfa1_0(0x0L, 0x0L, 0x0L, 0x0L, 0x3000c000200L);
      case 63:
         return jjStopAtPos(0, 259);
      case 64:
         jjmatchedKind = 255;
         return jjMoveStringLiteralDfa1_0(0x0L, 0x0L, 0x0L, 0x0L, 0x10000000L);
      case 68:
         return jjMoveStringLiteralDfa1_0(0x0L, 0x400000000000000L, 0x0L, 0x0L, 0x0L);
      case 69:
         return jjMoveStringLiteralDfa1_0(0x50000L, 0x0L, 0x0L, 0x0L, 0x0L);
      case 76:
         return jjMoveStringLiteralDfa1_0(0x0L, 0x10000000000000L, 0x0L, 0x0L, 0x0L);
      case 78:
         return jjMoveStringLiteralDfa1_0(0x0L, 0x1000000000000000L, 0x0L, 0x0L, 0x0L);
      case 83:
         return jjMoveStringLiteralDfa1_0(0x0L, 0x140004000000000L, 0x0L, 0x0L, 0x0L);
      case 91:
         jjmatchedKind = 305;
         return jjMoveStringLiteralDfa1_0(0x0L, 0x0L, 0x0L, 0x0L, 0x6L);
      case 93:
         return jjStopAtPos(0, 306);
      case 94:
         jjmatchedKind = 279;
         return jjMoveStringLiteralDfa1_0(0x0L, 0x0L, 0x0L, 0x0L, 0x2000000000L);
      case 97:
         return jjMoveStringLiteralDfa1_0(0x81000L, 0x800000020000L, 0x1000000L, 0x400L, 0x0L);
      case 98:
         return jjMoveStringLiteralDfa1_0(0x100000L, 0x24000c0000000L, 0x20000L, 0x0L, 0x0L);
      case 99:
         return jjMoveStringLiteralDfa1_0(0x17e04000L, 0x2000200100000000L, 0x2001000L, 0x0L, 0x0L);
      case 100:
         return jjMoveStringLiteralDfa1_0(0xe8000000L, 0x200002000080000L, 0xfffc0000000000L, 0x100000L, 0x0L);
      case 101:
         return jjMoveStringLiteralDfa1_0(0x1f00020000L, 0x4000000000000000L, 0x1000001fc080000L, 0x0L, 0x0L);
      case 102:
         return jjMoveStringLiteralDfa1_0(0x3e000000000L, 0x1000000000L, 0x40L, 0x0L, 0x0L);
      case 103:
         return jjMoveStringLiteralDfa1_0(0x0L, 0x0L, 0x0L, 0x6000000L, 0x0L);
      case 104:
         return jjMoveStringLiteralDfa1_0(0x0L, 0x4000000000000L, 0xfe00000000000000L, 0x4001ffL, 0x0L);
      case 105:
         return jjMoveStringLiteralDfa1_0(0x1fe00000000000L, 0x400000000L, 0x8L, 0x0L, 0x0L);
      case 106:
         return jjMoveStringLiteralDfa1_0(0x100100000002000L, 0x0L, 0x0L, 0x800000L, 0x0L);
      case 108:
         return jjMoveStringLiteralDfa1_0(0x40040000000000L, 0x8008000800000010L, 0xc000L, 0x0L, 0x0L);
      case 109:
         return jjMoveStringLiteralDfa1_0(0x600000000000000L, 0xe0000000000L, 0x2000L, 0x0L, 0x0L);
      case 110:
         return jjMoveStringLiteralDfa1_0(0x880000000000000L, 0x800000000000020L, 0x21L, 0x0L, 0x0L);
      case 111:
         return jjMoveStringLiteralDfa1_0(0x0L, 0x40000L, 0x200010012L, 0x40000L, 0x0L);
      case 112:
         return jjMoveStringLiteralDfa1_0(0x0L, 0x0L, 0x3fc00000784L, 0x80000L, 0x0L);
      case 114:
         return jjMoveStringLiteralDfa1_0(0x0L, 0x180L, 0x40000L, 0x800L, 0x0L);
      case 115:
         return jjMoveStringLiteralDfa1_0(0x0L, 0xa1108200000e40L, 0x700800L, 0x1023000L, 0x0L);
      case 116:
         return jjMoveStringLiteralDfa1_0(0x80000000000L, 0x317000L, 0x800000L, 0x0L, 0x0L);
      case 117:
         return jjMoveStringLiteralDfa1_0(0x800L, 0x3c08000L, 0x0L, 0x0L, 0x0L);
      case 118:
         return jjMoveStringLiteralDfa1_0(0x0L, 0x10004000000L, 0x0L, 0x0L, 0x0L);
      case 119:
         return jjMoveStringLiteralDfa1_0(0x0L, 0x38000000L, 0x0L, 0x200L, 0x0L);
      case 120:
         return jjMoveStringLiteralDfa1_0(0x8000L, 0x0L, 0x0L, 0x21c000L, 0x0L);
      case 123:
         jjmatchedKind = 299;
         return jjMoveStringLiteralDfa1_0(0x0L, 0x0L, 0x0L, 0x0L, 0x200000000000L);
      case 124:
         jjmatchedKind = 278;
         return jjMoveStringLiteralDfa1_0(0x0L, 0x0L, 0x0L, 0x0L, 0x1800001000L);
      case 125:
         jjmatchedKind = 300;
         return jjMoveStringLiteralDfa1_0(0x0L, 0x0L, 0x0L, 0x0L, 0x400000000000L);
      case 126:
         return jjStopAtPos(0, 256);
      default :
         return jjMoveNfa_0(5, 0);
   }
}
private final int jjMoveStringLiteralDfa1_0(long active0, long active1, long active2, long active3, long active4)
{
   try { curChar = input_stream.readChar(); }
   catch(java.io.IOException e) {
      jjStopStringLiteralDfa_0(0, active0, active1, active2, active3, active4);
      return 1;
   }
   switch(curChar)
   {
      case 33:
         if ((active3 & 0x10000000L) != 0L)
         {
            jjmatchedKind = 220;
            jjmatchedPos = 1;
         }
         else if ((active3 & 0x4000000000000000L) != 0L)
            return jjStopAtPos(1, 254);
         return jjMoveStringLiteralDfa2_0(active0, 0L, active1, 0L, active2, 0L, active3, 0x8000000L, active4, 0L);
      case 37:
         if ((active3 & 0x400000000L) != 0L)
         {
            jjmatchedKind = 226;
            jjmatchedPos = 1;
         }
         return jjMoveStringLiteralDfa2_0(active0, 0L, active1, 0L, active2, 0L, active3, 0x3c0000000L, active4, 0L);
      case 38:
         if ((active4 & 0x2000L) != 0L)
         {
            jjmatchedKind = 269;
            jjmatchedPos = 1;
         }
         return jjMoveStringLiteralDfa2_0(active0, 0L, active1, 0L, active2, 0L, active3, 0L, active4, 0x400000000L);
      case 41:
         if ((active4 & 0x80000000000000L) != 0L)
            return jjStopAtPos(1, 311);
         break;
      case 42:
         if ((active4 & 0x100000L) != 0L)
            return jjStopAtPos(1, 276);
         else if ((active4 & 0x40000000000000L) != 0L)
            return jjStopAtPos(1, 310);
         break;
      case 43:
         if ((active4 & 0x4000L) != 0L)
            return jjStopAtPos(1, 270);
         break;
      case 45:
         if ((active4 & 0x8000L) != 0L)
            return jjStopAtPos(1, 271);
         break;
      case 46:
         if ((active4 & 0x20000000000000L) != 0L)
            return jjStopAtPos(1, 309);
         break;
      case 47:
         if ((active3 & 0x1000000000000000L) != 0L)
            return jjStopAtPos(1, 252);
         break;
      case 58:
         if ((active4 & 0x20L) != 0L)
            return jjStopAtPos(1, 261);
         break;
      case 60:
         if ((active4 & 0x2000000L) != 0L)
         {
            jjmatchedKind = 281;
            jjmatchedPos = 1;
         }
         return jjMoveStringLiteralDfa2_0(active0, 0L, active1, 0L, active2, 0L, active3, 0L, active4, 0x8000000000L);
      case 61:
         if ((active3 & 0x200000000000000L) != 0L)
            return jjStopAtPos(1, 249);
         else if ((active4 & 0x40L) != 0L)
         {
            jjmatchedKind = 262;
            jjmatchedPos = 1;
         }
         else if ((active4 & 0x100L) != 0L)
         {
            jjmatchedKind = 264;
            jjmatchedPos = 1;
         }
         else if ((active4 & 0x200L) != 0L)
            return jjStopAtPos(1, 265);
         else if ((active4 & 0x400L) != 0L)
         {
            jjmatchedKind = 266;
            jjmatchedPos = 1;
         }
         else if ((active4 & 0x10000000L) != 0L)
            return jjStopAtPos(1, 284);
         else if ((active4 & 0x20000000L) != 0L)
            return jjStopAtPos(1, 285);
         else if ((active4 & 0x40000000L) != 0L)
            return jjStopAtPos(1, 286);
         else if ((active4 & 0x80000000L) != 0L)
            return jjStopAtPos(1, 287);
         else if ((active4 & 0x100000000L) != 0L)
            return jjStopAtPos(1, 288);
         else if ((active4 & 0x200000000L) != 0L)
            return jjStopAtPos(1, 289);
         else if ((active4 & 0x800000000L) != 0L)
            return jjStopAtPos(1, 291);
         else if ((active4 & 0x2000000000L) != 0L)
            return jjStopAtPos(1, 293);
         else if ((active4 & 0x4000000000L) != 0L)
            return jjStopAtPos(1, 294);
         return jjMoveStringLiteralDfa2_0(active0, 0L, active1, 0L, active2, 0L, active3, 0x80000000000000L, active4, 0x880L);
      case 62:
         if ((active3 & 0x20000000000000L) != 0L)
            return jjStopAtPos(1, 245);
         else if ((active3 & 0x40000000000000L) != 0L)
            return jjStopAtPos(1, 246);
         else if ((active4 & 0x4000000L) != 0L)
         {
            jjmatchedKind = 282;
            jjmatchedPos = 1;
         }
         return jjMoveStringLiteralDfa2_0(active0, 0L, active1, 0L, active2, 0L, active3, 0L, active4, 0x30008000000L);
      case 63:
         if ((active3 & 0x20000000L) != 0L)
            return jjStopAtPos(1, 221);
         break;
      case 68:
         return jjMoveStringLiteralDfa2_0(active0, 0L, active1, 0x8L, active2, 0L, active3, 0L, active4, 0L);
      case 74:
         return jjMoveStringLiteralDfa2_0(active0, 0xe000000000000000L, active1, 0x7L, active2, 0L, active3, 0L, active4, 0L);
      case 79:
         return jjMoveStringLiteralDfa2_0(active0, 0x40000L, active1, 0L, active2, 0L, active3, 0L, active4, 0L);
      case 91:
         return jjMoveStringLiteralDfa2_0(active0, 0L, active1, 0L, active2, 0L, active3, 0L, active4, 0x6L);
      case 93:
         return jjMoveStringLiteralDfa2_0(active0, 0L, active1, 0L, active2, 0L, active3, 0L, active4, 0x1000000000000000L);
      case 97:
         return jjMoveStringLiteralDfa2_0(active0, 0x300142000602000L, active1, 0x6000e0004000020L, active2, 0x802000L, active3, 0x80000L, active4, 0L);
      case 98:
         return jjMoveStringLiteralDfa2_0(active0, 0L, active1, 0L, active2, 0xfffc0000000000L, active3, 0L, active4, 0L);
      case 99:
         if ((active1 & 0x200000000000L) != 0L)
            return jjStartNfaWithStates_0(1, 109, 73);
         return jjMoveStringLiteralDfa2_0(active0, 0L, active1, 0x400000000000L, active2, 0x800L, active3, 0x1000L, active4, 0L);
      case 100:
         return jjMoveStringLiteralDfa2_0(active0, 0L, active1, 0L, active2, 0x1000000L, active3, 0L, active4, 0L);
      case 101:
         return jjMoveStringLiteralDfa2_0(active0, 0x80000068000000L, active1, 0x60100000000180L, active2, 0x700020L, active3, 0x800L, active4, 0L);
      case 102:
         if ((active0 & 0x200000000000L) != 0L)
         {
            jjmatchedKind = 45;
            jjmatchedPos = 1;
         }
         return jjMoveStringLiteralDfa2_0(active0, 0x1c00000000000L, active1, 0L, active2, 0L, active3, 0x400L, active4, 0L);
      case 103:
         return jjMoveStringLiteralDfa2_0(active0, 0L, active1, 0L, active2, 0L, active3, 0x1000000L, active4, 0L);
      case 104:
         return jjMoveStringLiteralDfa2_0(active0, 0x80000000000L, active1, 0x318003000L, active2, 0L, active3, 0L, active4, 0L);
      case 105:
         return jjMoveStringLiteralDfa2_0(active0, 0x420004000000000L, active1, 0x18000020000010L, active2, 0xfe00000000004004L, active3, 0x1ffL, active4, 0L);
      case 106:
         return jjMoveStringLiteralDfa2_0(active0, 0L, active1, 0L, active2, 0x100000000000000L, active3, 0L, active4, 0L);
      case 107:
         return jjMoveStringLiteralDfa2_0(active0, 0L, active1, 0x40L, active2, 0L, active3, 0L, active4, 0L);
      case 108:
         if ((active2 & 0x1L) != 0L)
            return jjStartNfaWithStates_0(1, 128, 73);
         return jjMoveStringLiteralDfa2_0(active0, 0x310000000L, active1, 0x1000000000L, active2, 0x40L, active3, 0L, active4, 0L);
      case 109:
         return jjMoveStringLiteralDfa2_0(active0, 0x2000000008000L, active1, 0L, active2, 0x40000L, active3, 0x204000L, active4, 0L);
      case 110:
         if ((active0 & 0x4000000000000L) != 0L)
         {
            jjmatchedKind = 50;
            jjmatchedPos = 1;
         }
         else if ((active1 & 0x40000L) != 0L)
         {
            jjmatchedKind = 82;
            jjmatchedPos = 1;
         }
         return jjMoveStringLiteralDfa2_0(active0, 0x18000000011000L, active1, 0x400c00000L, active2, 0x200000008L, active3, 0L, active4, 0L);
      case 111:
         if ((active0 & 0x80000000L) != 0L)
         {
            jjmatchedKind = 31;
            jjmatchedPos = 1;
         }
         else if ((active1 & 0x4000L) != 0L)
            return jjStartNfaWithStates_0(1, 78, 73);
         return jjMoveStringLiteralDfa2_0(active0, 0x40008003824000L, active1, 0xa182012840080000L, active2, 0x2001000L, active3, 0x100000L, active4, 0L);
      case 112:
         return jjMoveStringLiteralDfa2_0(active0, 0x1000000000000000L, active1, 0x8000L, active2, 0L, active3, 0x10000L, active4, 0L);
      case 114:
         return jjMoveStringLiteralDfa2_0(active0, 0x10000100000L, active1, 0x4000000000300000L, active2, 0x3fc00010780L, active3, 0L, active4, 0L);
      case 115:
         if ((active0 & 0x80000L) != 0L)
            return jjStartNfaWithStates_0(1, 19, 73);
         else if ((active2 & 0x8000L) != 0L)
            return jjStartNfaWithStates_0(1, 143, 73);
         return jjMoveStringLiteralDfa2_0(active0, 0x800L, active1, 0x3000000L, active2, 0L, active3, 0x808200L, active4, 0L);
      case 116:
         return jjMoveStringLiteralDfa2_0(active0, 0x4000000L, active1, 0x480c000020200L, active2, 0L, active3, 0x402000L, active4, 0L);
      case 117:
         return jjMoveStringLiteralDfa2_0(active0, 0x800020000000000L, active1, 0x1801000000000400L, active2, 0x12L, active3, 0x6040000L, active4, 0L);
      case 119:
         return jjMoveStringLiteralDfa2_0(active0, 0L, active1, 0x800L, active2, 0L, active3, 0L, active4, 0L);
      case 120:
         return jjMoveStringLiteralDfa2_0(active0, 0x1c00000000L, active1, 0L, active2, 0x1fc080000L, active3, 0L, active4, 0L);
      case 121:
         if ((active2 & 0x20000L) != 0L)
         {
            jjmatchedKind = 145;
            jjmatchedPos = 1;
         }
         return jjMoveStringLiteralDfa2_0(active0, 0L, active1, 0x80010000L, active2, 0L, active3, 0x20000L, active4, 0L);
      case 123:
         if ((active4 & 0x40000000000L) != 0L)
            return jjStopAtPos(1, 298);
         else if ((active4 & 0x200000000000L) != 0L)
            return jjStopAtPos(1, 301);
         break;
      case 124:
         if ((active4 & 0x1000L) != 0L)
         {
            jjmatchedKind = 268;
            jjmatchedPos = 1;
         }
         return jjMoveStringLiteralDfa2_0(active0, 0L, active1, 0L, active2, 0L, active3, 0L, active4, 0x1000000000L);
      case 125:
         if ((active4 & 0x400000000000L) != 0L)
            return jjStopAtPos(1, 302);
         break;
      default :
         break;
   }
   return jjStartNfa_0(0, active0, active1, active2, active3, active4);
}
private final int jjMoveStringLiteralDfa2_0(long old0, long active0, long old1, long active1, long old2, long active2, long old3, long active3, long old4, long active4)
{
   if (((active0 &= old0) | (active1 &= old1) | (active2 &= old2) | (active3 &= old3) | (active4 &= old4)) == 0L)
      return jjStartNfa_0(0, old0, old1, old2, old3, old4); 
   try { curChar = input_stream.readChar(); }
   catch(java.io.IOException e) {
      jjStopStringLiteralDfa_0(1, active0, active1, active2, active3, active4);
      return 2;
   }
   switch(curChar)
   {
      case 33:
         if ((active3 & 0x80000000L) != 0L)
            return jjStopAtPos(2, 223);
         break;
      case 42:
         if ((active4 & 0x2L) != 0L)
            return jjStopAtPos(2, 257);
         break;
      case 45:
         return jjMoveStringLiteralDfa3_0(active0, 0L, active1, 0L, active2, 0L, active3, 0x208000000L, active4, 0L);
      case 58:
         return jjMoveStringLiteralDfa3_0(active0, 0L, active1, 0L, active2, 0xfffc0000000000L, active3, 0L, active4, 0L);
      case 61:
         if ((active3 & 0x100000000L) != 0L)
            return jjStopAtPos(2, 224);
         else if ((active4 & 0x80L) != 0L)
            return jjStopAtPos(2, 263);
         else if ((active4 & 0x800L) != 0L)
            return jjStopAtPos(2, 267);
         else if ((active4 & 0x400000000L) != 0L)
            return jjStopAtPos(2, 290);
         else if ((active4 & 0x1000000000L) != 0L)
            return jjStopAtPos(2, 292);
         else if ((active4 & 0x8000000000L) != 0L)
            return jjStopAtPos(2, 295);
         else if ((active4 & 0x10000000000L) != 0L)
            return jjStopAtPos(2, 296);
         break;
      case 62:
         if ((active3 & 0x80000000000000L) != 0L)
            return jjStopAtPos(2, 247);
         else if ((active4 & 0x8000000L) != 0L)
         {
            jjmatchedKind = 283;
            jjmatchedPos = 2;
         }
         return jjMoveStringLiteralDfa3_0(active0, 0L, active1, 0L, active2, 0L, active3, 0L, active4, 0x20000000000L);
      case 64:
         if ((active3 & 0x40000000L) != 0L)
            return jjStopAtPos(2, 222);
         break;
      case 67:
         return jjMoveStringLiteralDfa3_0(active0, 0L, active1, 0x2L, active2, 0L, active3, 0L, active4, 0L);
      case 70:
         if ((active0 & 0x40000L) != 0L)
            return jjStartNfaWithStates_0(2, 18, 73);
         break;
      case 83:
         return jjMoveStringLiteralDfa3_0(active0, 0L, active1, 0L, active2, 0x200000000L, active3, 0L, active4, 0L);
      case 91:
         return jjMoveStringLiteralDfa3_0(active0, 0L, active1, 0L, active2, 0L, active3, 0L, active4, 0x4L);
      case 93:
         if ((active4 & 0x1000000000000000L) != 0L)
            return jjStopAtPos(2, 316);
         break;
      case 97:
         return jjMoveStringLiteralDfa3_0(active0, 0xe000000010000800L, active1, 0x100000005L, active2, 0L, active3, 0x12000L, active4, 0L);
      case 98:
         return jjMoveStringLiteralDfa3_0(active0, 0L, active1, 0x1000000000000L, active2, 0xff00000000000000L, active3, 0x1ffL, active4, 0L);
      case 99:
         if ((active1 & 0x400000000000L) != 0L)
            return jjStartNfaWithStates_0(2, 110, 73);
         return jjMoveStringLiteralDfa3_0(active0, 0x40000000000000L, active1, 0L, active2, 0x80000L, active3, 0L, active4, 0L);
      case 100:
         return jjMoveStringLiteralDfa3_0(active0, 0x400000010000L, active1, 0x2000000c00000L, active2, 0x1050000L, active3, 0x200L, active4, 0L);
      case 101:
         if ((active1 & 0x2000000L) != 0L)
            return jjStartNfaWithStates_0(2, 89, 73);
         return jjMoveStringLiteralDfa3_0(active0, 0x1000400100000L, active1, 0x8000008L, active2, 0x3fdfc000020L, active3, 0L, active4, 0L);
      case 102:
         if ((active0 & 0x20000L) != 0L)
            return jjStartNfaWithStates_0(2, 17, 73);
         return jjMoveStringLiteralDfa3_0(active0, 0x8000028000000L, active1, 0L, active2, 0L, active3, 0L, active4, 0L);
      case 103:
         if ((active1 & 0x8000000000000000L) != 0L)
            return jjStartNfaWithStates_0(2, 127, 73);
         break;
      case 104:
         return jjMoveStringLiteralDfa3_0(active0, 0L, active1, 0L, active2, 0L, active3, 0x1000L, active4, 0L);
      case 105:
         return jjMoveStringLiteralDfa3_0(active0, 0x100000000L, active1, 0xf0011001840L, active2, 0x780L, active3, 0x6000000L, active4, 0L);
      case 108:
         if ((active3 & 0x4000L) != 0L)
         {
            jjmatchedKind = 206;
            jjmatchedPos = 2;
         }
         return jjMoveStringLiteralDfa3_0(active0, 0x800002040008000L, active1, 0x2000000000000000L, active2, 0L, active3, 0x208000L, active4, 0L);
      case 109:
         if ((active3 & 0x100000L) != 0L)
            return jjStartNfaWithStates_0(2, 212, 73);
         return jjMoveStringLiteralDfa3_0(active0, 0x40000004000L, active1, 0x1804000000000030L, active2, 0L, active3, 0x1400000L, active4, 0L);
      case 110:
         return jjMoveStringLiteralDfa3_0(active0, 0x420824003800000L, active1, 0x18100800000000L, active2, 0x2002000L, active3, 0L, active4, 0L);
      case 111:
         return jjMoveStringLiteralDfa3_0(active0, 0x10004000000L, active1, 0x1240000000L, active2, 0L, active3, 0L, active4, 0L);
      case 112:
         if ((active2 & 0x800L) != 0L)
            return jjStartNfaWithStates_0(2, 139, 73);
         else if ((active3 & 0x800000L) != 0L)
            return jjStartNfaWithStates_0(2, 215, 73);
         return jjMoveStringLiteralDfa3_0(active0, 0x2000000000000L, active1, 0x10400L, active2, 0x100cL, active3, 0x800L, active4, 0L);
      case 114:
         if ((active0 & 0x8000000000L) != 0L)
            return jjStartNfaWithStates_0(2, 39, 73);
         else if ((active1 & 0x4000000L) != 0L)
            return jjStartNfaWithStates_0(2, 90, 73);
         else if ((active1 & 0x4000000000000000L) != 0L)
            return jjStartNfaWithStates_0(2, 126, 73);
         return jjMoveStringLiteralDfa3_0(active0, 0x1000080000000000L, active1, 0x18000c000002200L, active2, 0x800000L, active3, 0x80000L, active4, 0L);
      case 115:
         return jjMoveStringLiteralDfa3_0(active0, 0x200200000L, active1, 0x80L, active2, 0x4000L, active3, 0x20000L, active4, 0L);
      case 116:
         if ((active1 & 0x400000000L) != 0L)
         {
            jjmatchedKind = 98;
            jjmatchedPos = 2;
         }
         else if ((active1 & 0x20000000000000L) != 0L)
         {
            jjmatchedKind = 117;
            jjmatchedPos = 2;
         }
         else if ((active1 & 0x40000000000000L) != 0L)
            return jjStartNfaWithStates_0(2, 118, 73);
         else if ((active2 & 0x2L) != 0L)
         {
            jjmatchedKind = 129;
            jjmatchedPos = 2;
         }
         return jjMoveStringLiteralDfa3_0(active0, 0x10001800401000L, active1, 0x6008000a0028100L, active2, 0x700010L, active3, 0x40400L, active4, 0L);
      case 117:
         return jjMoveStringLiteralDfa3_0(active0, 0L, active1, 0x2000100000L, active2, 0x40L, active3, 0L, active4, 0L);
      case 118:
         return jjMoveStringLiteralDfa3_0(active0, 0x100100000002000L, active1, 0L, active2, 0L, active3, 0L, active4, 0L);
      case 119:
         if ((active0 & 0x80000000000000L) != 0L)
            return jjStartNfaWithStates_0(2, 55, 73);
         return jjMoveStringLiteralDfa3_0(active0, 0L, active1, 0x80000L, active2, 0L, active3, 0L, active4, 0L);
      case 120:
         return jjMoveStringLiteralDfa3_0(active0, 0x200000000000000L, active1, 0L, active2, 0L, active3, 0L, active4, 0L);
      case 121:
         if ((active1 & 0x200000L) != 0L)
            return jjStartNfaWithStates_0(2, 85, 73);
         break;
      default :
         break;
   }
   return jjStartNfa_0(1, active0, active1, active2, active3, active4);
}
private final int jjMoveStringLiteralDfa3_0(long old0, long active0, long old1, long active1, long old2, long active2, long old3, long active3, long old4, long active4)
{
   if (((active0 &= old0) | (active1 &= old1) | (active2 &= old2) | (active3 &= old3) | (active4 &= old4)) == 0L)
      return jjStartNfa_0(1, old0, old1, old2, old3, old4); 
   try { curChar = input_stream.readChar(); }
   catch(java.io.IOException e) {
      jjStopStringLiteralDfa_0(2, active0, active1, active2, active3, active4);
      return 3;
   }
   switch(curChar)
   {
      case 42:
         if ((active4 & 0x4L) != 0L)
            return jjStopAtPos(3, 258);
         break;
      case 45:
         if ((active3 & 0x8000000L) != 0L)
            return jjStopAtPos(3, 219);
         else if ((active3 & 0x200000000L) != 0L)
            return jjStopAtPos(3, 225);
         break;
      case 58:
         return jjMoveStringLiteralDfa4_0(active0, 0xc000L, active1, 0L, active2, 0xfefffc0000000000L, active3, 0x40001ffL, active4, 0L);
      case 61:
         if ((active4 & 0x20000000000L) != 0L)
            return jjStopAtPos(3, 297);
         break;
      case 66:
         return jjMoveStringLiteralDfa4_0(active0, 0L, active1, 0L, active2, 0x1000000L, active3, 0L, active4, 0L);
      case 69:
         return jjMoveStringLiteralDfa4_0(active0, 0L, active1, 0L, active2, 0L, active3, 0x2000000L, active4, 0L);
      case 70:
         return jjMoveStringLiteralDfa4_0(active0, 0L, active1, 0L, active2, 0x100000L, active3, 0L, active4, 0L);
      case 82:
         return jjMoveStringLiteralDfa4_0(active0, 0L, active1, 0L, active2, 0x600000L, active3, 0L, active4, 0L);
      case 83:
         return jjMoveStringLiteralDfa4_0(active0, 0x10000L, active1, 0L, active2, 0L, active3, 0L, active4, 0L);
      case 95:
         return jjMoveStringLiteralDfa4_0(active0, 0x600000000000000L, active1, 0L, active2, 0L, active3, 0L, active4, 0L);
      case 97:
         return jjMoveStringLiteralDfa4_0(active0, 0x1140104008102000L, active1, 0x801000000000L, active2, 0L, active3, 0x80000L, active4, 0L);
      case 98:
         return jjMoveStringLiteralDfa4_0(active0, 0x40000000000L, active1, 0x1800002000000000L, active2, 0L, active3, 0L, active4, 0L);
      case 99:
         if ((active0 & 0x400000000L) != 0L)
         {
            jjmatchedKind = 34;
            jjmatchedPos = 3;
         }
         return jjMoveStringLiteralDfa4_0(active0, 0x20020000400000L, active1, 0L, active2, 0x1fc000000L, active3, 0L, active4, 0L);
      case 100:
         if ((active1 & 0x10000000000L) != 0L)
            return jjStartNfaWithStates_0(3, 104, 73);
         return jjMoveStringLiteralDfa4_0(active0, 0x800000000000L, active1, 0x100000000000L, active2, 0x20L, active3, 0L, active4, 0L);
      case 101:
         if ((active0 & 0x200000L) != 0L)
            return jjStartNfaWithStates_0(3, 21, 73);
         else if ((active0 & 0x200000000L) != 0L)
            return jjStartNfaWithStates_0(3, 33, 73);
         else if ((active1 & 0x100000L) != 0L)
            return jjStartNfaWithStates_0(3, 84, 73);
         else if ((active1 & 0x80000000L) != 0L)
            return jjStartNfaWithStates_0(3, 95, 73);
         else if ((active1 & 0x200000000000000L) != 0L)
            return jjStartNfaWithStates_0(3, 121, 73);
         else if ((active1 & 0x400000000000000L) != 0L)
            return jjStartNfaWithStates_0(3, 122, 73);
         else if ((active2 & 0x4L) != 0L)
            return jjStartNfaWithStates_0(3, 130, 73);
         return jjMoveStringLiteralDfa4_0(active0, 0x481840000000L, active1, 0xc10420L, active2, 0x90000L, active3, 0x1c00L, active4, 0L);
      case 102:
         if ((active0 & 0x100000000L) != 0L)
            return jjStartNfaWithStates_0(3, 32, 73);
         return jjMoveStringLiteralDfa4_0(active0, 0L, active1, 0x8L, active2, 0L, active3, 0L, active4, 0L);
      case 103:
         if ((active1 & 0x800000000L) != 0L)
            return jjStartNfaWithStates_0(3, 99, 73);
         return jjMoveStringLiteralDfa4_0(active0, 0x800L, active1, 0L, active2, 0x800000L, active3, 0L, active4, 0L);
      case 104:
         if ((active1 & 0x20000000L) != 0L)
            return jjStartNfaWithStates_0(3, 93, 73);
         break;
      case 105:
         return jjMoveStringLiteralDfa4_0(active0, 0x8000020000000L, active1, 0xc000000210L, active2, 0x42000L, active3, 0L, active4, 0L);
      case 106:
         return jjMoveStringLiteralDfa4_0(active0, 0L, active1, 0x1000000000000L, active2, 0L, active3, 0L, active4, 0L);
      case 107:
         return jjMoveStringLiteralDfa4_0(active0, 0L, active1, 0x18000000000000L, active2, 0L, active3, 0L, active4, 0L);
      case 108:
         if ((active0 & 0x800000000000000L) != 0L)
            return jjStartNfaWithStates_0(3, 59, 73);
         else if ((active3 & 0x400000L) != 0L)
         {
            jjmatchedKind = 214;
            jjmatchedPos = 3;
         }
         else if ((active3 & 0x1000000L) != 0L)
            return jjStartNfaWithStates_0(3, 216, 73);
         return jjMoveStringLiteralDfa4_0(active0, 0L, active1, 0x40e0050000000L, active2, 0L, active3, 0x200L, active4, 0L);
      case 109:
         if ((active0 & 0x10000000000L) != 0L)
            return jjStartNfaWithStates_0(3, 40, 73);
         break;
      case 110:
         return jjMoveStringLiteralDfa4_0(active0, 0L, active1, 0x1080000L, active2, 0x2000780L, active3, 0x200000L, active4, 0L);
      case 111:
         if ((active0 & 0x10000000000000L) != 0L)
            return jjStartNfaWithStates_0(3, 52, 73);
         else if ((active1 & 0x8000L) != 0L)
            return jjStartNfaWithStates_0(3, 79, 73);
         return jjMoveStringLiteralDfa4_0(active0, 0x2000000000000L, active1, 0x2002L, active2, 0L, active3, 0L, active4, 0L);
      case 112:
         if ((active1 & 0x40L) != 0L)
            return jjStartNfaWithStates_0(3, 70, 73);
         return jjMoveStringLiteralDfa4_0(active0, 0L, active1, 0L, active2, 0x3fc00000010L, active3, 0x40000L, active4, 0L);
      case 113:
         return jjMoveStringLiteralDfa4_0(active0, 0L, active1, 0L, active2, 0x100000000000000L, active3, 0L, active4, 0L);
      case 114:
         if ((active0 & 0x4000000L) != 0L)
            return jjStartNfaWithStates_0(3, 26, 73);
         else if ((active1 & 0x100000000L) != 0L)
            return jjStartNfaWithStates_0(3, 96, 73);
         return jjMoveStringLiteralDfa4_0(active0, 0L, active1, 0x208020000L, active2, 0L, active3, 0x2000L, active4, 0L);
      case 115:
         if ((active1 & 0x1000L) != 0L)
            return jjStartNfaWithStates_0(3, 76, 73);
         return jjMoveStringLiteralDfa4_0(active0, 0x2012800000L, active1, 0L, active2, 0x40L, active3, 0L, active4, 0L);
      case 116:
         if ((active3 & 0x8000L) != 0L)
            return jjStartNfaWithStates_0(3, 207, 73);
         return jjMoveStringLiteralDfa4_0(active0, 0x1001000L, active1, 0x180000000000800L, active2, 0x4000L, active3, 0x30000L, active4, 0L);
      case 117:
         return jjMoveStringLiteralDfa4_0(active0, 0L, active1, 0x2000000000000180L, active2, 0x200000008L, active3, 0L, active4, 0L);
      case 118:
         return jjMoveStringLiteralDfa4_0(active0, 0xe000000000000000L, active1, 0x5L, active2, 0L, active3, 0L, active4, 0L);
      case 120:
         return jjMoveStringLiteralDfa4_0(active0, 0x1000000000000L, active1, 0L, active2, 0L, active3, 0L, active4, 0L);
      case 121:
         if ((active1 & 0x2000000000000L) != 0L)
            return jjStartNfaWithStates_0(3, 113, 73);
         else if ((active2 & 0x1000L) != 0L)
            return jjStartNfaWithStates_0(3, 140, 73);
         break;
      default :
         break;
   }
   return jjStartNfa_0(2, active0, active1, active2, active3, active4);
}
private final int jjMoveStringLiteralDfa4_0(long old0, long active0, long old1, long active1, long old2, long active2, long old3, long active3, long old4, long active4)
{
   if (((active0 &= old0) | (active1 &= old1) | (active2 &= old2) | (active3 &= old3) | (active4 &= old4)) == 0L)
      return jjStartNfa_0(2, old0, old1, old2, old3, old4); 
   try { curChar = input_stream.readChar(); }
   catch(java.io.IOException e) {
      jjStopStringLiteralDfa_0(3, active0, active1, active2, active3, 0L);
      return 4;
   }
   switch(curChar)
   {
      case 58:
         if ((active0 & 0x4000L) != 0L)
            return jjStopAtPos(4, 14);
         else if ((active0 & 0x8000L) != 0L)
            return jjStopAtPos(4, 15);
         return jjMoveStringLiteralDfa5_0(active0, 0x2000L, active1, 0xe0000000000L, active2, 0xfe00000000000000L, active3, 0x40003ffL);
      case 66:
         return jjMoveStringLiteralDfa5_0(active0, 0L, active1, 0x4000000000000L, active2, 0L, active3, 0L);
      case 70:
         return jjMoveStringLiteralDfa5_0(active0, 0L, active1, 0L, active2, 0x4000L, active3, 0L);
      case 77:
         return jjMoveStringLiteralDfa5_0(active0, 0L, active1, 0x100000000000L, active2, 0L, active3, 0L);
      case 83:
         return jjMoveStringLiteralDfa5_0(active0, 0L, active1, 0L, active2, 0x20L, active3, 0L);
      case 97:
         return jjMoveStringLiteralDfa5_0(active0, 0xe000080000001000L, active1, 0x5L, active2, 0x20bfc01000000L, active3, 0x800L);
      case 98:
         return jjMoveStringLiteralDfa5_0(active0, 0L, active1, 0L, active2, 0x400000000000L, active3, 0L);
      case 99:
         return jjMoveStringLiteralDfa5_0(active0, 0x100000010000L, active1, 0x800000000800L, active2, 0x8100200000000L, active3, 0L);
      case 100:
         return jjMoveStringLiteralDfa5_0(active0, 0x40000000000L, active1, 0L, active2, 0x240000000000L, active3, 0x1000L);
      case 101:
         if ((active0 & 0x800L) != 0L)
            return jjStartNfaWithStates_0(4, 11, 73);
         else if ((active0 & 0x2000000000L) != 0L)
            return jjStartNfaWithStates_0(4, 37, 73);
         else if ((active1 & 0x8000000L) != 0L)
            return jjStartNfaWithStates_0(4, 91, 73);
         else if ((active1 & 0x10000000L) != 0L)
            return jjStartNfaWithStates_0(4, 92, 73);
         return jjMoveStringLiteralDfa5_0(active0, 0x800000000000L, active1, 0x1999000040000000L, active2, 0x2e00000L, active3, 0x20000L);
      case 102:
         if ((active0 & 0x400000000000L) != 0L)
            return jjStartNfaWithStates_0(4, 46, 73);
         return jjMoveStringLiteralDfa5_0(active0, 0L, active1, 0x800000L, active2, 0x2000L, active3, 0L);
      case 103:
         if ((active1 & 0x1000000L) != 0L)
            return jjStartNfaWithStates_0(4, 88, 73);
         return jjMoveStringLiteralDfa5_0(active0, 0x1000000000000000L, active1, 0L, active2, 0L, active3, 0L);
      case 104:
         if ((active0 & 0x400000L) != 0L)
            return jjStartNfaWithStates_0(4, 22, 73);
         else if ((active2 & 0x40L) != 0L)
            return jjStartNfaWithStates_0(4, 134, 73);
         else if ((active3 & 0x10000L) != 0L)
            return jjStartNfaWithStates_0(4, 208, 73);
         break;
      case 105:
         return jjMoveStringLiteralDfa5_0(active0, 0x1000001000000L, active1, 0x20008L, active2, 0x100000L, active3, 0L);
      case 107:
         if ((active0 & 0x100000L) != 0L)
            return jjStartNfaWithStates_0(4, 20, 73);
         break;
      case 108:
         if ((active0 & 0x40000000000000L) != 0L)
            return jjStartNfaWithStates_0(4, 54, 73);
         else if ((active2 & 0x100000000000000L) != 0L)
            return jjStartNfaWithStates_0(4, 184, 73);
         return jjMoveStringLiteralDfa5_0(active0, 0x20004000000000L, active1, 0x2000000000L, active2, 0L, active3, 0L);
      case 109:
         return jjMoveStringLiteralDfa5_0(active0, 0L, active1, 0x2000000000000082L, active2, 0L, active3, 0x80000L);
      case 110:
         return jjMoveStringLiteralDfa5_0(active0, 0x708001820000000L, active1, 0xc000000000L, active2, 0L, active3, 0L);
      case 111:
         return jjMoveStringLiteralDfa5_0(active0, 0L, active1, 0x10000L, active2, 0L, active3, 0L);
      case 112:
         if ((active1 & 0x200L) != 0L)
            return jjStartNfaWithStates_0(4, 73, 73);
         return jjMoveStringLiteralDfa5_0(active0, 0L, active1, 0L, active2, 0xc0000000080000L, active3, 0L);
      case 113:
         return jjMoveStringLiteralDfa5_0(active0, 0L, active1, 0L, active2, 0x1800000000000L, active3, 0L);
      case 114:
         if ((active1 & 0x400L) != 0L)
            return jjStartNfaWithStates_0(4, 74, 73);
         else if ((active1 & 0x400000L) != 0L)
            return jjStartNfaWithStates_0(4, 86, 73);
         else if ((active2 & 0x40000L) != 0L)
            return jjStartNfaWithStates_0(4, 146, 73);
         else if ((active3 & 0x400L) != 0L)
            return jjStartNfaWithStates_0(4, 202, 73);
         return jjMoveStringLiteralDfa5_0(active0, 0x2000000000000L, active1, 0x100L, active2, 0x10000L, active3, 0L);
      case 115:
         if ((active0 & 0x10000000L) != 0L)
            return jjStartNfaWithStates_0(4, 28, 73);
         else if ((active3 & 0x200000L) != 0L)
            return jjStartNfaWithStates_0(4, 213, 73);
         return jjMoveStringLiteralDfa5_0(active0, 0L, active1, 0x20L, active2, 0x4000000000000L, active3, 0L);
      case 116:
         if ((active0 & 0x800000L) != 0L)
         {
            jjmatchedKind = 23;
            jjmatchedPos = 4;
         }
         else if ((active1 & 0x10L) != 0L)
            return jjStartNfaWithStates_0(4, 68, 73);
         else if ((active1 & 0x200000000L) != 0L)
            return jjStartNfaWithStates_0(4, 97, 73);
         else if ((active1 & 0x1000000000L) != 0L)
            return jjStartNfaWithStates_0(4, 100, 73);
         else if ((active2 & 0x8L) != 0L)
            return jjStartNfaWithStates_0(4, 131, 73);
         else if ((active2 & 0x80L) != 0L)
         {
            jjmatchedKind = 135;
            jjmatchedPos = 4;
         }
         return jjMoveStringLiteralDfa5_0(active0, 0x20042000000L, active1, 0x80000L, active2, 0x700L, active3, 0x2000L);
      case 117:
         return jjMoveStringLiteralDfa5_0(active0, 0x8000000L, active1, 0L, active2, 0x300001fc000010L, active3, 0x40000L);
      case 118:
         return jjMoveStringLiteralDfa5_0(active0, 0L, active1, 0L, active2, 0L, active3, 0x2000000L);
      case 119:
         if ((active1 & 0x2000L) != 0L)
            return jjStartNfaWithStates_0(4, 77, 73);
         break;
      default :
         break;
   }
   return jjStartNfa_0(3, active0, active1, active2, active3, 0L);
}
private final int jjMoveStringLiteralDfa5_0(long old0, long active0, long old1, long active1, long old2, long active2, long old3, long active3)
{
   if (((active0 &= old0) | (active1 &= old1) | (active2 &= old2) | (active3 &= old3)) == 0L)
      return jjStartNfa_0(3, old0, old1, old2, old3, 0L);
   try { curChar = input_stream.readChar(); }
   catch(java.io.IOException e) {
      jjStopStringLiteralDfa_0(4, active0, active1, active2, active3, 0L);
      return 5;
   }
   switch(curChar)
   {
      case 58:
         if ((active0 & 0x2000L) != 0L)
            return jjStopAtPos(5, 13);
         else if ((active3 & 0x200L) != 0L)
            return jjStopAtPos(5, 201);
         return jjMoveStringLiteralDfa6_0(active0, 0L, active1, 0xe0000000000L, active2, 0L, active3, 0L);
      case 66:
         return jjMoveStringLiteralDfa6_0(active0, 0x4000000000000000L, active1, 0L, active2, 0L, active3, 0L);
      case 67:
         return jjMoveStringLiteralDfa6_0(active0, 0L, active1, 0x3L, active2, 0L, active3, 0L);
      case 69:
         return jjMoveStringLiteralDfa6_0(active0, 0x8000000000000000L, active1, 0L, active2, 0L, active3, 0L);
      case 71:
         return jjMoveStringLiteralDfa6_0(active0, 0x2000000000000000L, active1, 0L, active2, 0L, active3, 0L);
      case 80:
         return jjMoveStringLiteralDfa6_0(active0, 0L, active1, 0x4L, active2, 0L, active3, 0L);
      case 84:
         return jjMoveStringLiteralDfa6_0(active0, 0L, active1, 0L, active2, 0x600L, active3, 0L);
      case 97:
         if ((active0 & 0x40000000000L) != 0L)
            return jjStartNfaWithStates_0(5, 42, 73);
         return jjMoveStringLiteralDfa6_0(active0, 0L, active1, 0x100040000000L, active2, 0xc08400000600000L, active3, 0L);
      case 98:
         return jjMoveStringLiteralDfa6_0(active0, 0L, active1, 0x20000L, active2, 0L, active3, 0L);
      case 99:
         return jjMoveStringLiteralDfa6_0(active0, 0L, active1, 0x1000000000000L, active2, 0x1000000202000000L, active3, 0L);
      case 100:
         if ((active0 & 0x80000000000L) != 0L)
            return jjStartNfaWithStates_0(5, 43, 73);
         return jjMoveStringLiteralDfa6_0(active0, 0x1800000000L, active1, 0x198000000000000L, active2, 0x80000000000L, active3, 0x8L);
      case 101:
         if ((active0 & 0x40000000L) != 0L)
            return jjStartNfaWithStates_0(5, 30, 73);
         else if ((active1 & 0x80L) != 0L)
            return jjStartNfaWithStates_0(5, 71, 73);
         else if ((active1 & 0x2000000000L) != 0L)
            return jjStartNfaWithStates_0(5, 101, 73);
         return jjMoveStringLiteralDfa6_0(active0, 0x100000020000000L, active1, 0L, active2, 0x12000L, active3, 0x6080000L);
      case 102:
         if ((active0 & 0x800000000000L) != 0L)
            return jjStartNfaWithStates_0(5, 47, 73);
         else if ((active1 & 0x10000L) != 0L)
            return jjStartNfaWithStates_0(5, 80, 73);
         break;
      case 103:
         if ((active1 & 0x4000000000L) != 0L)
            return jjStartNfaWithStates_0(5, 102, 73);
         else if ((active1 & 0x8000000000L) != 0L)
            return jjStartNfaWithStates_0(5, 103, 73);
         return jjMoveStringLiteralDfa6_0(active0, 0L, active1, 0L, active2, 0L, active3, 0x10L);
      case 104:
         if ((active1 & 0x800L) != 0L)
            return jjStartNfaWithStates_0(5, 75, 73);
         else if ((active1 & 0x800000000000L) != 0L)
            return jjStartNfaWithStates_0(5, 111, 73);
         break;
      case 105:
         return jjMoveStringLiteralDfa6_0(active0, 0x8020000000000L, active1, 0x800000L, active2, 0x200000004000L, active3, 0x2004L);
      case 108:
         return jjMoveStringLiteralDfa6_0(active0, 0x104008000000L, active1, 0L, active2, 0x100100L, active3, 0x1L);
      case 109:
         return jjMoveStringLiteralDfa6_0(active0, 0x1000000000000000L, active1, 0L, active2, 0L, active3, 0x20000L);
      case 110:
         if ((active1 & 0x100L) != 0L)
            return jjStartNfaWithStates_0(5, 72, 73);
         else if ((active1 & 0x2000000000000000L) != 0L)
            return jjStartNfaWithStates_0(5, 125, 73);
         return jjMoveStringLiteralDfa6_0(active0, 0x1000000L, active1, 0x8L, active2, 0x2000000000000L, active3, 0L);
      case 111:
         if ((active1 & 0x80000L) != 0L)
            return jjStartNfaWithStates_0(5, 83, 73);
         return jjMoveStringLiteralDfa6_0(active0, 0L, active1, 0x4000000000000L, active2, 0x100000000000L, active3, 0L);
      case 112:
         return jjMoveStringLiteralDfa6_0(active0, 0L, active1, 0x20L, active2, 0x30000000000000L, active3, 0L);
      case 113:
         return jjMoveStringLiteralDfa6_0(active0, 0L, active1, 0L, active2, 0x4000000000000L, active3, 0x2L);
      case 114:
         if ((active1 & 0x800000000000000L) != 0L)
            return jjStartNfaWithStates_0(5, 123, 73);
         else if ((active1 & 0x1000000000000000L) != 0L)
            return jjStartNfaWithStates_0(5, 124, 73);
         return jjMoveStringLiteralDfa6_0(active0, 0x2010000L, active1, 0L, active2, 0xc003fc00000000L, active3, 0L);
      case 115:
         return jjMoveStringLiteralDfa6_0(active0, 0x1000000001000L, active1, 0L, active2, 0x200000000000000L, active3, 0x60L);
      case 116:
         if ((active0 & 0x2000000000000L) != 0L)
            return jjStartNfaWithStates_0(5, 49, 73);
         else if ((active2 & 0x10L) != 0L)
         {
            jjmatchedKind = 132;
            jjmatchedPos = 5;
         }
         else if ((active2 & 0x80000L) != 0L)
            return jjStartNfaWithStates_0(5, 147, 73);
         else if ((active2 & 0x800000L) != 0L)
            return jjStartNfaWithStates_0(5, 151, 73);
         else if ((active3 & 0x800L) != 0L)
            return jjStartNfaWithStates_0(5, 203, 73);
         return jjMoveStringLiteralDfa6_0(active0, 0L, active1, 0L, active2, 0xe0000001fd000000L, active3, 0x40000L);
      case 117:
         return jjMoveStringLiteralDfa6_0(active0, 0x620000000000000L, active1, 0L, active2, 0x1840000000000L, active3, 0x1180L);
      case 121:
         return jjMoveStringLiteralDfa6_0(active0, 0L, active1, 0L, active2, 0x20L, active3, 0L);
      default :
         break;
   }
   return jjStartNfa_0(4, active0, active1, active2, active3, 0L);
}
private final int jjMoveStringLiteralDfa6_0(long old0, long active0, long old1, long active1, long old2, long active2, long old3, long active3)
{
   if (((active0 &= old0) | (active1 &= old1) | (active2 &= old2) | (active3 &= old3)) == 0L)
      return jjStartNfa_0(4, old0, old1, old2, old3, 0L);
   try { curChar = input_stream.readChar(); }
   catch(java.io.IOException e) {
      jjStopStringLiteralDfa_0(5, active0, active1, active2, active3, 0L);
      return 6;
   }
   switch(curChar)
   {
      case 73:
         return jjMoveStringLiteralDfa7_0(active0, 0L, active1, 0L, active2, 0L, active3, 0x20000L);
      case 76:
         return jjMoveStringLiteralDfa7_0(active0, 0L, active1, 0x18000000000000L, active2, 0L, active3, 0L);
      case 77:
         return jjMoveStringLiteralDfa7_0(active0, 0L, active1, 0x180000000000000L, active2, 0L, active3, 0L);
      case 80:
         return jjMoveStringLiteralDfa7_0(active0, 0L, active1, 0L, active2, 0L, active3, 0x40000L);
      case 97:
         if ((active0 & 0x1000000000000000L) != 0L)
            return jjStopAtPos(6, 60);
         return jjMoveStringLiteralDfa7_0(active0, 0x4000100000000000L, active1, 0x24L, active2, 0x600L, active3, 0x60L);
      case 99:
         return jjMoveStringLiteralDfa7_0(active0, 0L, active1, 0x40000000000L, active2, 0x1000000L, active3, 0L);
      case 100:
         if ((active0 & 0x20000000L) != 0L)
            return jjStartNfaWithStates_0(6, 29, 73);
         else if ((active2 & 0x10000L) != 0L)
            return jjStartNfaWithStates_0(6, 144, 73);
         return jjMoveStringLiteralDfa7_0(active0, 0x20000000000000L, active1, 0x4080000000000L, active2, 0xc30080000600000L, active3, 0L);
      case 101:
         if ((active2 & 0x400000000L) != 0L)
         {
            jjmatchedKind = 162;
            jjmatchedPos = 6;
         }
         return jjMoveStringLiteralDfa7_0(active0, 0L, active1, 0x8L, active2, 0x2c183fbfc100000L, active3, 0x18L);
      case 105:
         return jjMoveStringLiteralDfa7_0(active0, 0x10000L, active1, 0x100000000000L, active2, 0L, active3, 0L);
      case 107:
         return jjMoveStringLiteralDfa7_0(active0, 0x1000L, active1, 0L, active2, 0L, active3, 0L);
      case 108:
         if ((active2 & 0x4000000000000L) != 0L)
            return jjStopAtPos(6, 178);
         return jjMoveStringLiteralDfa7_0(active0, 0L, active1, 0x2L, active2, 0x1008000000004000L, active3, 0x1000L);
      case 109:
         return jjMoveStringLiteralDfa7_0(active0, 0x600000000000000L, active1, 0L, active2, 0x40000000000L, active3, 0L);
      case 110:
         if ((active1 & 0x40000000L) != 0L)
            return jjStartNfaWithStates_0(6, 94, 73);
         else if ((active2 & 0x100L) != 0L)
            return jjStartNfaWithStates_0(6, 136, 73);
         return jjMoveStringLiteralDfa7_0(active0, 0x8000000000000000L, active1, 0x800000L, active2, 0x100000000000L, active3, 0x2002080L);
      case 111:
         return jjMoveStringLiteralDfa7_0(active0, 0x20000000000L, active1, 0x1L, active2, 0L, active3, 0x1L);
      case 112:
         return jjMoveStringLiteralDfa7_0(active0, 0L, active1, 0L, active2, 0L, active3, 0x100L);
      case 115:
         if ((active0 & 0x800000000L) != 0L)
         {
            jjmatchedKind = 35;
            jjmatchedPos = 6;
         }
         return jjMoveStringLiteralDfa7_0(active0, 0x1000000000L, active1, 0x20000000000L, active2, 0x200000002020L, active3, 0L);
      case 116:
         if ((active0 & 0x8000000L) != 0L)
            return jjStartNfaWithStates_0(6, 27, 73);
         else if ((active1 & 0x1000000000000L) != 0L)
            return jjStartNfaWithStates_0(6, 112, 73);
         else if ((active2 & 0x2000000L) != 0L)
            return jjStartNfaWithStates_0(6, 153, 73);
         return jjMoveStringLiteralDfa7_0(active0, 0x9000000000000L, active1, 0L, active2, 0x400000000000L, active3, 0x80004L);
      case 117:
         return jjMoveStringLiteralDfa7_0(active0, 0x2000000003000000L, active1, 0x20000L, active2, 0L, active3, 0x2L);
      case 118:
         return jjMoveStringLiteralDfa7_0(active0, 0L, active1, 0L, active2, 0L, active3, 0x4000000L);
      case 119:
         if ((active0 & 0x100000000000000L) != 0L)
            return jjStartNfaWithStates_0(6, 56, 73);
         break;
      case 120:
         return jjMoveStringLiteralDfa7_0(active0, 0L, active1, 0L, active2, 0xe000000000000000L, active3, 0L);
      case 121:
         if ((active0 & 0x4000000000L) != 0L)
            return jjStartNfaWithStates_0(6, 38, 73);
         else if ((active2 & 0x2000000000000L) != 0L)
            return jjStopAtPos(6, 177);
         break;
      default :
         break;
   }
   return jjStartNfa_0(5, active0, active1, active2, active3, 0L);
}
private final int jjMoveStringLiteralDfa7_0(long old0, long active0, long old1, long active1, long old2, long active2, long old3, long active3)
{
   if (((active0 &= old0) | (active1 &= old1) | (active2 &= old2) | (active3 &= old3)) == 0L)
      return jjStartNfa_0(5, old0, old1, old2, old3, 0L);
   try { curChar = input_stream.readChar(); }
   catch(java.io.IOException e) {
      jjStopStringLiteralDfa_0(6, active0, active1, active2, active3, 0L);
      return 7;
   }
   switch(curChar)
   {
      case 58:
         return jjMoveStringLiteralDfa8_0(active0, 0x1000L, active1, 0L, active2, 0L, active3, 0L);
      case 65:
         return jjMoveStringLiteralDfa8_0(active0, 0L, active1, 0L, active2, 0x8000000020000000L, active3, 0L);
      case 66:
         return jjMoveStringLiteralDfa8_0(active0, 0L, active1, 0L, active2, 0x2000080004000000L, active3, 0L);
      case 67:
         return jjMoveStringLiteralDfa8_0(active0, 0L, active1, 0L, active2, 0x800000000L, active3, 0L);
      case 68:
         if ((active3 & 0x20000L) != 0L)
            return jjStartNfaWithStates_0(7, 209, 73);
         break;
      case 69:
         return jjMoveStringLiteralDfa8_0(active0, 0L, active1, 0L, active2, 0x4000000000000000L, active3, 0L);
      case 74:
         return jjMoveStringLiteralDfa8_0(active0, 0L, active1, 0x8L, active2, 0L, active3, 0L);
      case 79:
         return jjMoveStringLiteralDfa8_0(active0, 0L, active1, 0L, active2, 0x200000L, active3, 0L);
      case 81:
         return jjMoveStringLiteralDfa8_0(active0, 0L, active1, 0L, active2, 0x18000000L, active3, 0L);
      case 83:
         return jjMoveStringLiteralDfa8_0(active0, 0L, active1, 0L, active2, 0x40000000L, active3, 0L);
      case 84:
         return jjMoveStringLiteralDfa8_0(active0, 0L, active1, 0L, active2, 0x100000L, active3, 0L);
      case 85:
         return jjMoveStringLiteralDfa8_0(active0, 0L, active1, 0L, active2, 0x180000000L, active3, 0L);
      case 87:
         return jjMoveStringLiteralDfa8_0(active0, 0L, active1, 0L, active2, 0x400000L, active3, 0L);
      case 97:
         return jjMoveStringLiteralDfa8_0(active0, 0L, active1, 0x180000000000002L, active2, 0x30000000000000L, active3, 0L);
      case 98:
         return jjMoveStringLiteralDfa8_0(active0, 0x600000000000000L, active1, 0L, active2, 0x600L, active3, 0L);
      case 99:
         return jjMoveStringLiteralDfa8_0(active0, 0x2000000L, active1, 0x24L, active2, 0x600000000000L, active3, 0x1L);
      case 100:
         return jjMoveStringLiteralDfa8_0(active0, 0L, active1, 0L, active2, 0xc0003f000000000L, active3, 0x100L);
      case 101:
         if ((active0 & 0x1000000L) != 0L)
            return jjStartNfaWithStates_0(7, 24, 73);
         else if ((active0 & 0x20000000000000L) != 0L)
            return jjStopAtPos(7, 53);
         else if ((active3 & 0x1000L) != 0L)
            return jjStartNfaWithStates_0(7, 204, 73);
         return jjMoveStringLiteralDfa8_0(active0, 0L, active1, 0x20000800000L, active2, 0x4000L, active3, 0x4080006L);
      case 103:
         if ((active3 & 0x2000L) != 0L)
            return jjStartNfaWithStates_0(7, 205, 73);
         break;
      case 104:
         if ((active2 & 0x1000000L) != 0L)
            return jjStartNfaWithStates_0(7, 152, 73);
         break;
      case 105:
         return jjMoveStringLiteralDfa8_0(active0, 0x2000000000000000L, active1, 0x18080000000000L, active2, 0L, active3, 0L);
      case 106:
         return jjMoveStringLiteralDfa8_0(active0, 0x1000000000L, active1, 0L, active2, 0L, active3, 0L);
      case 108:
         if ((active1 & 0x100000000000L) != 0L)
            return jjStartNfaWithStates_0(7, 108, 73);
         else if ((active2 & 0x8000000000000L) != 0L)
            return jjStopAtPos(7, 179);
         return jjMoveStringLiteralDfa8_0(active0, 0L, active1, 0L, active2, 0L, active3, 0x88L);
      case 110:
         if ((active0 & 0x20000000000L) != 0L)
            return jjStartNfaWithStates_0(7, 41, 73);
         return jjMoveStringLiteralDfa8_0(active0, 0L, active1, 0L, active2, 0x100000000000L, active3, 0L);
      case 111:
         return jjMoveStringLiteralDfa8_0(active0, 0L, active1, 0x40000000000L, active2, 0x1000000000000000L, active3, 0L);
      case 112:
         return jjMoveStringLiteralDfa8_0(active0, 0x10000L, active1, 0L, active2, 0xc0040000000000L, active3, 0L);
      case 114:
         return jjMoveStringLiteralDfa8_0(active0, 0L, active1, 0x1L, active2, 0x1800000000000L, active3, 0x40000L);
      case 115:
         if ((active0 & 0x1000000000000L) != 0L)
            return jjStartNfaWithStates_0(7, 48, 73);
         return jjMoveStringLiteralDfa8_0(active0, 0x4000100000000000L, active1, 0L, active2, 0x200000000L, active3, 0L);
      case 116:
         if ((active2 & 0x2000L) != 0L)
            return jjStartNfaWithStates_0(7, 141, 73);
         else if ((active3 & 0x10L) != 0L)
            return jjStopAtPos(7, 196);
         return jjMoveStringLiteralDfa8_0(active0, 0x8000000000000000L, active1, 0x20000L, active2, 0x200000000000020L, active3, 0x2000000L);
      case 118:
         return jjMoveStringLiteralDfa8_0(active0, 0L, active1, 0L, active2, 0L, active3, 0x60L);
      case 121:
         if ((active0 & 0x8000000000000L) != 0L)
            return jjStartNfaWithStates_0(7, 51, 73);
         else if ((active1 & 0x4000000000000L) != 0L)
            return jjStartNfaWithStates_0(7, 114, 73);
         break;
      default :
         break;
   }
   return jjStartNfa_0(6, active0, active1, active2, active3, 0L);
}
private final int jjMoveStringLiteralDfa8_0(long old0, long active0, long old1, long active1, long old2, long active2, long old3, long active3)
{
   if (((active0 &= old0) | (active1 &= old1) | (active2 &= old2) | (active3 &= old3)) == 0L)
      return jjStartNfa_0(6, old0, old1, old2, old3, 0L);
   try { curChar = input_stream.readChar(); }
   catch(java.io.IOException e) {
      jjStopStringLiteralDfa_0(7, active0, active1, active2, active3, 0L);
      return 8;
   }
   switch(curChar)
   {
      case 58:
         if ((active0 & 0x1000L) != 0L)
            return jjStopAtPos(8, 12);
         break;
      case 67:
         return jjMoveStringLiteralDfa9_0(active0, 0x2000000000000000L, active1, 0L, active2, 0x400000000000000L, active3, 0L);
      case 69:
         return jjMoveStringLiteralDfa9_0(active0, 0L, active1, 0L, active2, 0x3f000000000L, active3, 0L);
      case 81:
         return jjMoveStringLiteralDfa9_0(active0, 0L, active1, 0L, active2, 0x40000000L, active3, 0L);
      case 82:
         return jjMoveStringLiteralDfa9_0(active0, 0L, active1, 0L, active2, 0x800000000000000L, active3, 0L);
      case 84:
         return jjMoveStringLiteralDfa9_0(active0, 0L, active1, 0L, active2, 0x40000000000L, active3, 0L);
      case 97:
         return jjMoveStringLiteralDfa9_0(active0, 0x1000000000L, active1, 0x8L, active2, 0xc0080804000000L, active3, 0x100L);
      case 98:
         return jjMoveStringLiteralDfa9_0(active0, 0L, active1, 0x1L, active2, 0x8000000000000000L, active3, 0L);
      case 100:
         if ((active1 & 0x800000L) != 0L)
            return jjStartNfaWithStates_0(8, 87, 73);
         break;
      case 101:
         if ((active1 & 0x20L) != 0L)
            return jjStartNfaWithStates_0(8, 69, 73);
         else if ((active3 & 0x20L) != 0L)
         {
            jjmatchedKind = 197;
            jjmatchedPos = 8;
         }
         return jjMoveStringLiteralDfa9_0(active0, 0xc600000000000000L, active1, 0x20000L, active2, 0x2000100000000020L, active3, 0x48L);
      case 104:
         if ((active2 & 0x400000000000L) != 0L)
            return jjStopAtPos(8, 174);
         break;
      case 105:
         return jjMoveStringLiteralDfa9_0(active0, 0L, active1, 0L, active2, 0x100000L, active3, 0L);
      case 107:
         if ((active3 & 0x1L) != 0L)
            return jjStopAtPos(8, 192);
         return jjMoveStringLiteralDfa9_0(active0, 0L, active1, 0x4L, active2, 0L, active3, 0L);
      case 108:
         return jjMoveStringLiteralDfa9_0(active0, 0L, active1, 0L, active2, 0x600L, active3, 0L);
      case 110:
         return jjMoveStringLiteralDfa9_0(active0, 0L, active1, 0x60000000000L, active2, 0x4000000020200000L, active3, 0x4000000L);
      case 111:
         return jjMoveStringLiteralDfa9_0(active0, 0L, active1, 0L, active2, 0x200000000000L, active3, 0x40080L);
      case 112:
         if ((active1 & 0x80000000000000L) != 0L)
            return jjStartNfaWithStates_0(8, 119, 73);
         else if ((active1 & 0x100000000000000L) != 0L)
            return jjStartNfaWithStates_0(8, 120, 73);
         return jjMoveStringLiteralDfa9_0(active0, 0L, active1, 0L, active2, 0x180000000L, active3, 0L);
      case 114:
         return jjMoveStringLiteralDfa9_0(active0, 0L, active1, 0L, active2, 0x400000L, active3, 0x80006L);
      case 115:
         if ((active0 & 0x100000000000L) != 0L)
            return jjStartNfaWithStates_0(8, 44, 73);
         else if ((active2 & 0x4000L) != 0L)
            return jjStartNfaWithStates_0(8, 142, 73);
         else if ((active2 & 0x200000000L) != 0L)
            return jjStartNfaWithStates_0(8, 161, 73);
         else if ((active3 & 0x2000000L) != 0L)
            return jjStartNfaWithStates_0(8, 217, 73);
         return jjMoveStringLiteralDfa9_0(active0, 0L, active1, 0x18080000000002L, active2, 0x1000000000000000L, active3, 0L);
      case 116:
         if ((active0 & 0x10000L) != 0L)
            return jjStartNfaWithStates_0(8, 16, 73);
         return jjMoveStringLiteralDfa9_0(active0, 0x2000000L, active1, 0L, active2, 0x30000000000000L, active3, 0L);
      case 117:
         return jjMoveStringLiteralDfa9_0(active0, 0L, active1, 0L, active2, 0x200000018000000L, active3, 0L);
      case 121:
         if ((active2 & 0x800000000000L) != 0L)
         {
            jjmatchedKind = 175;
            jjmatchedPos = 8;
         }
         return jjMoveStringLiteralDfa9_0(active0, 0L, active1, 0L, active2, 0x1000000000000L, active3, 0L);
      default :
         break;
   }
   return jjStartNfa_0(7, active0, active1, active2, active3, 0L);
}
private final int jjMoveStringLiteralDfa9_0(long old0, long active0, long old1, long active1, long old2, long active2, long old3, long active3)
{
   if (((active0 &= old0) | (active1 &= old1) | (active2 &= old2) | (active3 &= old3)) == 0L)
      return jjStartNfa_0(7, old0, old1, old2, old3, 0L);
   try { curChar = input_stream.readChar(); }
   catch(java.io.IOException e) {
      jjStopStringLiteralDfa_0(8, active0, active1, active2, active3, 0L);
      return 9;
   }
   switch(curChar)
   {
      case 67:
         return jjMoveStringLiteralDfa10_0(active0, 0x4000000000000000L, active1, 0L, active2, 0x1000000000000L, active3, 0L);
      case 76:
         if ((active2 & 0x40000000L) != 0L)
            return jjStartNfaWithStates_0(9, 158, 73);
         break;
      case 79:
         return jjMoveStringLiteralDfa10_0(active0, 0L, active1, 0L, active2, 0L, active3, 0x40L);
      case 97:
         return jjMoveStringLiteralDfa10_0(active0, 0L, active1, 0x5L, active2, 0x40000000000L, active3, 0x4L);
      case 99:
         return jjMoveStringLiteralDfa10_0(active0, 0L, active1, 0x80000000000L, active2, 0x100000000000L, active3, 0x80L);
      case 100:
         if ((active1 & 0x20000000000L) != 0L)
            return jjStopAtPos(9, 105);
         else if ((active2 & 0x4000000000000000L) != 0L)
            return jjStopAtPos(9, 190);
         return jjMoveStringLiteralDfa10_0(active0, 0L, active1, 0L, active2, 0x180000000L, active3, 0L);
      case 101:
         if ((active2 & 0x200L) != 0L)
         {
            jjmatchedKind = 137;
            jjmatchedPos = 9;
         }
         else if ((active2 & 0x10000000000000L) != 0L)
         {
            jjmatchedKind = 180;
            jjmatchedPos = 9;
         }
         else if ((active2 & 0x1000000000000000L) != 0L)
            return jjStopAtPos(9, 188);
         return jjMoveStringLiteralDfa10_0(active0, 0L, active1, 0L, active2, 0x820000018000400L, active3, 0L);
      case 103:
         return jjMoveStringLiteralDfa10_0(active0, 0L, active1, 0L, active2, 0x2000000000000000L, active3, 0L);
      case 105:
         return jjMoveStringLiteralDfa10_0(active0, 0L, active1, 0L, active2, 0x400000L, active3, 0L);
      case 108:
         return jjMoveStringLiteralDfa10_0(active0, 0x2000000000000000L, active1, 0L, active2, 0x400000800200000L, active3, 0L);
      case 109:
         return jjMoveStringLiteralDfa10_0(active0, 0L, active1, 0L, active2, 0x100020L, active3, 0L);
      case 110:
         return jjMoveStringLiteralDfa10_0(active0, 0L, active1, 0x40000000000L, active2, 0x200000000000L, active3, 0L);
      case 111:
         return jjMoveStringLiteralDfa10_0(active0, 0x2000000L, active1, 0L, active2, 0x8000000000000000L, active3, 0L);
      case 112:
         if ((active2 & 0x200000000000000L) != 0L)
            return jjStopAtPos(9, 185);
         return jjMoveStringLiteralDfa10_0(active0, 0L, active1, 0L, active2, 0L, active3, 0x40000L);
      case 114:
         if ((active0 & 0x200000000000000L) != 0L)
            return jjStartNfaWithStates_0(9, 57, 73);
         else if ((active0 & 0x400000000000000L) != 0L)
            return jjStartNfaWithStates_0(9, 58, 73);
         return jjMoveStringLiteralDfa10_0(active0, 0x8000000000000000L, active1, 0L, active2, 0xc0000000000000L, active3, 0L);
      case 115:
         if ((active1 & 0x2L) != 0L)
            return jjStopAtPos(9, 65);
         else if ((active3 & 0x80000L) != 0L)
            return jjStartNfaWithStates_0(9, 211, 73);
         return jjMoveStringLiteralDfa10_0(active0, 0L, active1, 0x20000L, active2, 0L, active3, 0L);
      case 116:
         if ((active1 & 0x8000000000000L) != 0L)
            return jjStartNfaWithStates_0(9, 115, 73);
         else if ((active1 & 0x10000000000000L) != 0L)
            return jjStartNfaWithStates_0(9, 116, 73);
         return jjMoveStringLiteralDfa10_0(active0, 0L, active1, 0L, active2, 0x80004000000L, active3, 0x4000108L);
      case 118:
         return jjMoveStringLiteralDfa10_0(active0, 0x1000000000L, active1, 0x8L, active2, 0L, active3, 0L);
      case 120:
         return jjMoveStringLiteralDfa10_0(active0, 0L, active1, 0L, active2, 0x3f000000000L, active3, 0L);
      case 121:
         if ((active2 & 0x20000000L) != 0L)
            return jjStartNfaWithStates_0(9, 157, 73);
         else if ((active3 & 0x2L) != 0L)
            return jjStopAtPos(9, 193);
         break;
      default :
         break;
   }
   return jjStartNfa_0(8, active0, active1, active2, active3, 0L);
}
private final int jjMoveStringLiteralDfa10_0(long old0, long active0, long old1, long active1, long old2, long active2, long old3, long active3)
{
   if (((active0 &= old0) | (active1 &= old1) | (active2 &= old2) | (active3 &= old3)) == 0L)
      return jjStartNfa_0(8, old0, old1, old2, old3, 0L);
   try { curChar = input_stream.readChar(); }
   catch(java.io.IOException e) {
      jjStopStringLiteralDfa_0(9, active0, active1, active2, active3, 0L);
      return 10;
   }
   switch(curChar)
   {
      case 67:
         return jjMoveStringLiteralDfa11_0(active0, 0L, active1, 0x1L, active2, 0x20000000000000L, active3, 0L);
      case 68:
         return jjMoveStringLiteralDfa11_0(active0, 0L, active1, 0L, active2, 0x400L, active3, 0L);
      case 73:
         return jjMoveStringLiteralDfa11_0(active0, 0L, active1, 0L, active2, 0x20L, active3, 0L);
      case 97:
         if ((active0 & 0x1000000000L) != 0L)
            return jjStartNfaWithStates_0(10, 36, 73);
         return jjMoveStringLiteralDfa11_0(active0, 0x2000000000000000L, active1, 0x8L, active2, 0x401000180000000L, active3, 0L);
      case 98:
         return jjMoveStringLiteralDfa11_0(active0, 0L, active1, 0L, active2, 0x40000000000L, active3, 0L);
      case 99:
         return jjMoveStringLiteralDfa11_0(active0, 0L, active1, 0L, active2, 0x80004000000L, active3, 0L);
      case 101:
         if ((active2 & 0x100000L) != 0L)
            return jjStartNfaWithStates_0(10, 148, 73);
         else if ((active2 & 0x40000000000000L) != 0L)
         {
            jjmatchedKind = 182;
            jjmatchedPos = 10;
         }
         else if ((active3 & 0x8L) != 0L)
            return jjStopAtPos(10, 195);
         else if ((active3 & 0x100L) != 0L)
            return jjStopAtPos(10, 200);
         return jjMoveStringLiteralDfa11_0(active0, 0L, active1, 0x40000000000L, active2, 0x8003f000000000L, active3, 0x40000L);
      case 103:
         return jjMoveStringLiteralDfa11_0(active0, 0L, active1, 0x4L, active2, 0L, active3, 0L);
      case 105:
         return jjMoveStringLiteralDfa11_0(active0, 0L, active1, 0L, active2, 0x2000000000000000L, active3, 0L);
      case 107:
         if ((active3 & 0x80L) != 0L)
            return jjStopAtPos(10, 199);
         break;
      case 108:
         if ((active2 & 0x800000000L) != 0L)
            return jjStartNfaWithStates_0(10, 163, 73);
         return jjMoveStringLiteralDfa11_0(active0, 0x4000000000000000L, active1, 0L, active2, 0L, active3, 0L);
      case 110:
         return jjMoveStringLiteralDfa11_0(active0, 0L, active1, 0L, active2, 0x200000000000L, active3, 0L);
      case 111:
         return jjMoveStringLiteralDfa11_0(active0, 0L, active1, 0x80000020000L, active2, 0L, active3, 0L);
      case 112:
         return jjMoveStringLiteralDfa11_0(active0, 0x8000000000000000L, active1, 0L, active2, 0L, active3, 0L);
      case 114:
         if ((active0 & 0x2000000L) != 0L)
            return jjStartNfaWithStates_0(10, 25, 73);
         return jjMoveStringLiteralDfa11_0(active0, 0L, active1, 0L, active2, 0x8000000018000000L, active3, 0x40L);
      case 115:
         if ((active3 & 0x4000000L) != 0L)
            return jjStopAtPos(10, 218);
         return jjMoveStringLiteralDfa11_0(active0, 0L, active1, 0L, active2, 0x800000000000000L, active3, 0L);
      case 116:
         if ((active2 & 0x100000000000L) != 0L)
            return jjStopAtPos(10, 172);
         return jjMoveStringLiteralDfa11_0(active0, 0L, active1, 0L, active2, 0x400000L, active3, 0x4L);
      case 121:
         if ((active2 & 0x200000L) != 0L)
            return jjStartNfaWithStates_0(10, 149, 73);
         break;
      default :
         break;
   }
   return jjStartNfa_0(9, active0, active1, active2, active3, 0L);
}
private final int jjMoveStringLiteralDfa11_0(long old0, long active0, long old1, long active1, long old2, long active2, long old3, long active3)
{
   if (((active0 &= old0) | (active1 &= old1) | (active2 &= old2) | (active3 &= old3)) == 0L)
      return jjStartNfa_0(9, old0, old1, old2, old3, 0L);
   try { curChar = input_stream.readChar(); }
   catch(java.io.IOException e) {
      jjStopStringLiteralDfa_0(10, active0, active1, active2, active3, 0L);
      return 11;
   }
   switch(curChar)
   {
      case 67:
         return jjMoveStringLiteralDfa12_0(active0, 0L, active1, 0L, active2, 0x80000000000000L, active3, 0L);
      case 80:
         return jjMoveStringLiteralDfa12_0(active0, 0L, active1, 0x8L, active2, 0L, active3, 0L);
      case 85:
         return jjMoveStringLiteralDfa12_0(active0, 0L, active1, 0L, active2, 0L, active3, 0x40L);
      case 97:
         return jjMoveStringLiteralDfa12_0(active0, 0x4000000000000000L, active1, 0L, active2, 0x20000000000400L, active3, 0L);
      case 99:
         return jjMoveStringLiteralDfa12_0(active0, 0L, active1, 0x40000000000L, active2, 0x3f000000000L, active3, 0L);
      case 101:
         if ((active2 & 0x400000L) != 0L)
            return jjStartNfaWithStates_0(11, 150, 73);
         else if ((active3 & 0x4L) != 0L)
            return jjStopAtPos(11, 194);
         return jjMoveStringLiteralDfa12_0(active0, 0L, active1, 0x4L, active2, 0x200000000000L, active3, 0L);
      case 102:
         if ((active1 & 0x20000L) != 0L)
            return jjStartNfaWithStates_0(11, 81, 73);
         break;
      case 104:
         if ((active2 & 0x4000000L) != 0L)
            return jjStartNfaWithStates_0(11, 154, 73);
         else if ((active2 & 0x80000000000L) != 0L)
            return jjStopAtPos(11, 171);
         break;
      case 108:
         return jjMoveStringLiteralDfa12_0(active0, 0L, active1, 0x1L, active2, 0x1040000000000L, active3, 0L);
      case 110:
         if ((active2 & 0x20L) != 0L)
            return jjStartNfaWithStates_0(11, 133, 73);
         else if ((active2 & 0x2000000000000000L) != 0L)
            return jjStopAtPos(11, 189);
         return jjMoveStringLiteralDfa12_0(active0, 0L, active1, 0x80000000000L, active2, 0L, active3, 0L);
      case 111:
         return jjMoveStringLiteralDfa12_0(active0, 0L, active1, 0L, active2, 0x800000000000000L, active3, 0L);
      case 114:
         return jjMoveStringLiteralDfa12_0(active0, 0x8000000000000000L, active1, 0L, active2, 0L, active3, 0x40000L);
      case 115:
         return jjMoveStringLiteralDfa12_0(active0, 0x2000000000000000L, active1, 0L, active2, 0x400000000000000L, active3, 0L);
      case 116:
         if ((active2 & 0x8000000000000000L) != 0L)
            return jjStopAtPos(11, 191);
         return jjMoveStringLiteralDfa12_0(active0, 0L, active1, 0L, active2, 0x180000000L, active3, 0L);
      case 121:
         if ((active2 & 0x8000000L) != 0L)
         {
            jjmatchedKind = 155;
            jjmatchedPos = 11;
         }
         return jjMoveStringLiteralDfa12_0(active0, 0L, active1, 0L, active2, 0x10000000L, active3, 0L);
      default :
         break;
   }
   return jjStartNfa_0(10, active0, active1, active2, active3, 0L);
}
private final int jjMoveStringLiteralDfa12_0(long old0, long active0, long old1, long active1, long old2, long active2, long old3, long active3)
{
   if (((active0 &= old0) | (active1 &= old1) | (active2 &= old2) | (active3 &= old3)) == 0L)
      return jjStartNfa_0(10, old0, old1, old2, old3, 0L);
   try { curChar = input_stream.readChar(); }
   catch(java.io.IOException e) {
      jjStopStringLiteralDfa_0(11, active0, active1, active2, active3, 0L);
      return 12;
   }
   switch(curChar)
   {
      case 67:
         return jjMoveStringLiteralDfa13_0(active0, 0L, active1, 0L, active2, 0x10000000L, active3, 0L);
      case 97:
         return jjMoveStringLiteralDfa13_0(active0, 0L, active1, 0x9L, active2, 0x80000000000000L, active3, 0L);
      case 99:
         return jjMoveStringLiteralDfa13_0(active0, 0L, active1, 0L, active2, 0x200000000000L, active3, 0L);
      case 101:
         if ((active2 & 0x80000000L) != 0L)
         {
            jjmatchedKind = 159;
            jjmatchedPos = 12;
         }
         else if ((active2 & 0x40000000000L) != 0L)
            return jjStopAtPos(12, 170);
         return jjMoveStringLiteralDfa13_0(active0, 0L, active1, 0L, active2, 0x100000000L, active3, 0L);
      case 105:
         return jjMoveStringLiteralDfa13_0(active0, 0x8000000000000000L, active1, 0L, active2, 0L, active3, 0L);
      case 108:
         if ((active2 & 0x1000000000000L) != 0L)
            return jjStopAtPos(12, 176);
         return jjMoveStringLiteralDfa13_0(active0, 0L, active1, 0L, active2, 0x20000000000000L, active3, 0L);
      case 110:
         return jjMoveStringLiteralDfa13_0(active0, 0L, active1, 0x80000000000L, active2, 0L, active3, 0L);
      case 112:
         return jjMoveStringLiteralDfa13_0(active0, 0L, active1, 0L, active2, 0L, active3, 0x40L);
      case 115:
         if ((active0 & 0x2000000000000000L) != 0L)
            return jjStopAtPos(12, 61);
         else if ((active1 & 0x4L) != 0L)
            return jjStopAtPos(12, 66);
         else if ((active2 & 0x400000000000000L) != 0L)
            return jjStopAtPos(12, 186);
         return jjMoveStringLiteralDfa13_0(active0, 0x4000000000000000L, active1, 0L, active2, 0L, active3, 0L);
      case 116:
         if ((active1 & 0x40000000000L) != 0L)
            return jjStopAtPos(12, 106);
         return jjMoveStringLiteralDfa13_0(active0, 0L, active1, 0L, active2, 0x400L, active3, 0x40000L);
      case 117:
         return jjMoveStringLiteralDfa13_0(active0, 0L, active1, 0L, active2, 0x80003f000000000L, active3, 0L);
      default :
         break;
   }
   return jjStartNfa_0(11, active0, active1, active2, active3, 0L);
}
private final int jjMoveStringLiteralDfa13_0(long old0, long active0, long old1, long active1, long old2, long active2, long old3, long active3)
{
   if (((active0 &= old0) | (active1 &= old1) | (active2 &= old2) | (active3 &= old3)) == 0L)
      return jjStartNfa_0(11, old0, old1, old2, old3, 0L);
   try { curChar = input_stream.readChar(); }
   catch(java.io.IOException e) {
      jjStopStringLiteralDfa_0(12, active0, active1, active2, active3, 0L);
      return 13;
   }
   switch(curChar)
   {
      case 67:
         return jjMoveStringLiteralDfa14_0(active0, 0L, active1, 0L, active2, 0x100000000L, active3, 0L);
      case 97:
         if ((active2 & 0x400L) != 0L)
            return jjStartNfaWithStates_0(13, 138, 73);
         return jjMoveStringLiteralDfa14_0(active0, 0L, active1, 0L, active2, 0x10000000L, active3, 0L);
      case 99:
         return jjMoveStringLiteralDfa14_0(active0, 0L, active1, 0x8L, active2, 0L, active3, 0L);
      case 100:
         return jjMoveStringLiteralDfa14_0(active0, 0L, active1, 0L, active2, 0L, active3, 0x40L);
      case 101:
         return jjMoveStringLiteralDfa14_0(active0, 0L, active1, 0x80000000000L, active2, 0L, active3, 0L);
      case 105:
         return jjMoveStringLiteralDfa14_0(active0, 0L, active1, 0L, active2, 0L, active3, 0x40000L);
      case 108:
         if ((active2 & 0x20000000000000L) != 0L)
            return jjStopAtPos(13, 181);
         return jjMoveStringLiteralDfa14_0(active0, 0L, active1, 0L, active2, 0x80000000000000L, active3, 0L);
      case 114:
         return jjMoveStringLiteralDfa14_0(active0, 0L, active1, 0L, active2, 0x800000000000000L, active3, 0L);
      case 115:
         if ((active0 & 0x4000000000000000L) != 0L)
            return jjStopAtPos(13, 62);
         return jjMoveStringLiteralDfa14_0(active0, 0x8000000000000000L, active1, 0x1L, active2, 0L, active3, 0L);
      case 116:
         if ((active2 & 0x200000000000L) != 0L)
            return jjStopAtPos(13, 173);
         return jjMoveStringLiteralDfa14_0(active0, 0L, active1, 0L, active2, 0x3f000000000L, active3, 0L);
      default :
         break;
   }
   return jjStartNfa_0(12, active0, active1, active2, active3, 0L);
}
private final int jjMoveStringLiteralDfa14_0(long old0, long active0, long old1, long active1, long old2, long active2, long old3, long active3)
{
   if (((active0 &= old0) | (active1 &= old1) | (active2 &= old2) | (active3 &= old3)) == 0L)
      return jjStartNfa_0(12, old0, old1, old2, old3, 0L);
   try { curChar = input_stream.readChar(); }
   catch(java.io.IOException e) {
      jjStopStringLiteralDfa_0(13, active0, active1, active2, active3, 0L);
      return 14;
   }
   switch(curChar)
   {
      case 97:
         return jjMoveStringLiteralDfa15_0(active0, 0L, active1, 0L, active2, 0x100000000L, active3, 0x40L);
      case 99:
         return jjMoveStringLiteralDfa15_0(active0, 0L, active1, 0x80000000000L, active2, 0x800000000000000L, active3, 0L);
      case 101:
         if ((active2 & 0x1000000000L) != 0L)
         {
            jjmatchedKind = 164;
            jjmatchedPos = 14;
         }
         return jjMoveStringLiteralDfa15_0(active0, 0x8000000000000000L, active1, 0L, active2, 0x3e000000000L, active3, 0x40000L);
      case 107:
         return jjMoveStringLiteralDfa15_0(active0, 0L, active1, 0x8L, active2, 0L, active3, 0L);
      case 108:
         if ((active2 & 0x80000000000000L) != 0L)
            return jjStopAtPos(14, 183);
         return jjMoveStringLiteralDfa15_0(active0, 0L, active1, 0L, active2, 0x10000000L, active3, 0L);
      case 115:
         if ((active1 & 0x1L) != 0L)
            return jjStopAtPos(14, 64);
         break;
      default :
         break;
   }
   return jjStartNfa_0(13, active0, active1, active2, active3, 0L);
}
private final int jjMoveStringLiteralDfa15_0(long old0, long active0, long old1, long active1, long old2, long active2, long old3, long active3)
{
   if (((active0 &= old0) | (active1 &= old1) | (active2 &= old2) | (active3 &= old3)) == 0L)
      return jjStartNfa_0(13, old0, old1, old2, old3, 0L);
   try { curChar = input_stream.readChar(); }
   catch(java.io.IOException e) {
      jjStopStringLiteralDfa_0(14, active0, active1, active2, active3, 0L);
      return 15;
   }
   switch(curChar)
   {
      case 67:
         return jjMoveStringLiteralDfa16_0(active0, 0x8000000000000000L, active1, 0L, active2, 0x2000000000L, active3, 0L);
      case 81:
         return jjMoveStringLiteralDfa16_0(active0, 0L, active1, 0L, active2, 0xc000000000L, active3, 0L);
      case 85:
         return jjMoveStringLiteralDfa16_0(active0, 0L, active1, 0L, active2, 0x30000000000L, active3, 0L);
      case 97:
         return jjMoveStringLiteralDfa16_0(active0, 0L, active1, 0x8L, active2, 0L, active3, 0L);
      case 101:
         if ((active2 & 0x800000000000000L) != 0L)
            return jjStopAtPos(15, 187);
         break;
      case 108:
         if ((active2 & 0x10000000L) != 0L)
            return jjStartNfaWithStates_0(15, 156, 73);
         return jjMoveStringLiteralDfa16_0(active0, 0L, active1, 0L, active2, 0x100000000L, active3, 0L);
      case 115:
         if ((active3 & 0x40000L) != 0L)
            return jjStartNfaWithStates_0(15, 210, 73);
         break;
      case 116:
         if ((active1 & 0x80000000000L) != 0L)
            return jjStopAtPos(15, 107);
         return jjMoveStringLiteralDfa16_0(active0, 0L, active1, 0L, active2, 0L, active3, 0x40L);
      default :
         break;
   }
   return jjStartNfa_0(14, active0, active1, active2, active3, 0L);
}
private final int jjMoveStringLiteralDfa16_0(long old0, long active0, long old1, long active1, long old2, long active2, long old3, long active3)
{
   if (((active0 &= old0) | (active1 &= old1) | (active2 &= old2) | (active3 &= old3)) == 0L)
      return jjStartNfa_0(14, old0, old1, old2, old3, 0L);
   try { curChar = input_stream.readChar(); }
   catch(java.io.IOException e) {
      jjStopStringLiteralDfa_0(15, active0, active1, active2, active3, 0L);
      return 16;
   }
   switch(curChar)
   {
      case 97:
         return jjMoveStringLiteralDfa17_0(active0, 0L, active1, 0L, active2, 0x2000000000L, active3, 0L);
      case 101:
         return jjMoveStringLiteralDfa17_0(active0, 0L, active1, 0L, active2, 0L, active3, 0x40L);
      case 103:
         return jjMoveStringLiteralDfa17_0(active0, 0L, active1, 0x8L, active2, 0L, active3, 0L);
      case 108:
         if ((active2 & 0x100000000L) != 0L)
            return jjStartNfaWithStates_0(16, 160, 73);
         return jjMoveStringLiteralDfa17_0(active0, 0x8000000000000000L, active1, 0L, active2, 0L, active3, 0L);
      case 112:
         return jjMoveStringLiteralDfa17_0(active0, 0L, active1, 0L, active2, 0x30000000000L, active3, 0L);
      case 117:
         return jjMoveStringLiteralDfa17_0(active0, 0L, active1, 0L, active2, 0xc000000000L, active3, 0L);
      default :
         break;
   }
   return jjStartNfa_0(15, active0, active1, active2, active3, 0L);
}
private final int jjMoveStringLiteralDfa17_0(long old0, long active0, long old1, long active1, long old2, long active2, long old3, long active3)
{
   if (((active0 &= old0) | (active1 &= old1) | (active2 &= old2) | (active3 &= old3)) == 0L)
      return jjStartNfa_0(15, old0, old1, old2, old3, 0L);
   try { curChar = input_stream.readChar(); }
   catch(java.io.IOException e) {
      jjStopStringLiteralDfa_0(16, active0, active1, active2, active3, 0L);
      return 17;
   }
   switch(curChar)
   {
      case 67:
         return jjMoveStringLiteralDfa18_0(active0, 0L, active1, 0L, active2, 0L, active3, 0x40L);
      case 97:
         return jjMoveStringLiteralDfa18_0(active0, 0x8000000000000000L, active1, 0L, active2, 0L, active3, 0L);
      case 100:
         return jjMoveStringLiteralDfa18_0(active0, 0L, active1, 0L, active2, 0x30000000000L, active3, 0L);
      case 101:
         return jjMoveStringLiteralDfa18_0(active0, 0L, active1, 0x8L, active2, 0xc000000000L, active3, 0L);
      case 108:
         return jjMoveStringLiteralDfa18_0(active0, 0L, active1, 0L, active2, 0x2000000000L, active3, 0L);
      default :
         break;
   }
   return jjStartNfa_0(16, active0, active1, active2, active3, 0L);
}
private final int jjMoveStringLiteralDfa18_0(long old0, long active0, long old1, long active1, long old2, long active2, long old3, long active3)
{
   if (((active0 &= old0) | (active1 &= old1) | (active2 &= old2) | (active3 &= old3)) == 0L)
      return jjStartNfa_0(16, old0, old1, old2, old3, 0L);
   try { curChar = input_stream.readChar(); }
   catch(java.io.IOException e) {
      jjStopStringLiteralDfa_0(17, active0, active1, active2, active3, 0L);
      return 18;
   }
   switch(curChar)
   {
      case 97:
         return jjMoveStringLiteralDfa19_0(active0, 0L, active1, 0L, active2, 0x30000000000L, active3, 0L);
      case 108:
         if ((active2 & 0x2000000000L) != 0L)
            return jjStartNfaWithStates_0(18, 165, 73);
         break;
      case 111:
         return jjMoveStringLiteralDfa19_0(active0, 0L, active1, 0L, active2, 0L, active3, 0x40L);
      case 114:
         return jjMoveStringLiteralDfa19_0(active0, 0L, active1, 0L, active2, 0xc000000000L, active3, 0L);
      case 115:
         if ((active1 & 0x8L) != 0L)
            return jjStopAtPos(18, 67);
         return jjMoveStringLiteralDfa19_0(active0, 0x8000000000000000L, active1, 0L, active2, 0L, active3, 0L);
      default :
         break;
   }
   return jjStartNfa_0(17, active0, active1, active2, active3, 0L);
}
private final int jjMoveStringLiteralDfa19_0(long old0, long active0, long old1, long active1, long old2, long active2, long old3, long active3)
{
   if (((active0 &= old0) | (active1 &= old1) | (active2 &= old2) | (active3 &= old3)) == 0L)
      return jjStartNfa_0(17, old0, old1, old2, old3, 0L);
   try { curChar = input_stream.readChar(); }
   catch(java.io.IOException e) {
      jjStopStringLiteralDfa_0(18, active0, 0L, active2, active3, 0L);
      return 19;
   }
   switch(curChar)
   {
      case 112:
         return jjMoveStringLiteralDfa20_0(active0, 0L, active2, 0L, active3, 0x40L);
      case 115:
         if ((active0 & 0x8000000000000000L) != 0L)
            return jjStopAtPos(19, 63);
         break;
      case 116:
         return jjMoveStringLiteralDfa20_0(active0, 0L, active2, 0x30000000000L, active3, 0L);
      case 121:
         if ((active2 & 0x4000000000L) != 0L)
         {
            jjmatchedKind = 166;
            jjmatchedPos = 19;
         }
         return jjMoveStringLiteralDfa20_0(active0, 0L, active2, 0x8000000000L, active3, 0L);
      default :
         break;
   }
   return jjStartNfa_0(18, active0, 0L, active2, active3, 0L);
}
private final int jjMoveStringLiteralDfa20_0(long old0, long active0, long old2, long active2, long old3, long active3)
{
   if (((active0 &= old0) | (active2 &= old2) | (active3 &= old3)) == 0L)
      return jjStartNfa_0(18, old0, 0L, old2, old3, 0L);
   try { curChar = input_stream.readChar(); }
   catch(java.io.IOException e) {
      jjStopStringLiteralDfa_0(19, 0L, 0L, active2, active3, 0L);
      return 20;
   }
   switch(curChar)
   {
      case 67:
         return jjMoveStringLiteralDfa21_0(active2, 0x8000000000L, active3, 0L);
      case 101:
         if ((active2 & 0x10000000000L) != 0L)
         {
            jjmatchedKind = 168;
            jjmatchedPos = 20;
         }
         return jjMoveStringLiteralDfa21_0(active2, 0x20000000000L, active3, 0L);
      case 121:
         if ((active3 & 0x40L) != 0L)
            return jjStopAtPos(20, 198);
         break;
      default :
         break;
   }
   return jjStartNfa_0(19, 0L, 0L, active2, active3, 0L);
}
private final int jjMoveStringLiteralDfa21_0(long old2, long active2, long old3, long active3)
{
   if (((active2 &= old2) | (active3 &= old3)) == 0L)
      return jjStartNfa_0(19, 0L, 0L, old2, old3, 0L);
   try { curChar = input_stream.readChar(); }
   catch(java.io.IOException e) {
      jjStopStringLiteralDfa_0(20, 0L, 0L, active2, 0L, 0L);
      return 21;
   }
   switch(curChar)
   {
      case 67:
         return jjMoveStringLiteralDfa22_0(active2, 0x20000000000L);
      case 97:
         return jjMoveStringLiteralDfa22_0(active2, 0x8000000000L);
      default :
         break;
   }
   return jjStartNfa_0(20, 0L, 0L, active2, 0L, 0L);
}
private final int jjMoveStringLiteralDfa22_0(long old2, long active2)
{
   if (((active2 &= old2)) == 0L)
      return jjStartNfa_0(20, 0L, 0L, old2, 0L, 0L);
   try { curChar = input_stream.readChar(); }
   catch(java.io.IOException e) {
      jjStopStringLiteralDfa_0(21, 0L, 0L, active2, 0L, 0L);
      return 22;
   }
   switch(curChar)
   {
      case 97:
         return jjMoveStringLiteralDfa23_0(active2, 0x20000000000L);
      case 108:
         return jjMoveStringLiteralDfa23_0(active2, 0x8000000000L);
      default :
         break;
   }
   return jjStartNfa_0(21, 0L, 0L, active2, 0L, 0L);
}
private final int jjMoveStringLiteralDfa23_0(long old2, long active2)
{
   if (((active2 &= old2)) == 0L)
      return jjStartNfa_0(21, 0L, 0L, old2, 0L, 0L);
   try { curChar = input_stream.readChar(); }
   catch(java.io.IOException e) {
      jjStopStringLiteralDfa_0(22, 0L, 0L, active2, 0L, 0L);
      return 23;
   }
   switch(curChar)
   {
      case 108:
         if ((active2 & 0x8000000000L) != 0L)
            return jjStartNfaWithStates_0(23, 167, 73);
         return jjMoveStringLiteralDfa24_0(active2, 0x20000000000L);
      default :
         break;
   }
   return jjStartNfa_0(22, 0L, 0L, active2, 0L, 0L);
}
private final int jjMoveStringLiteralDfa24_0(long old2, long active2)
{
   if (((active2 &= old2)) == 0L)
      return jjStartNfa_0(22, 0L, 0L, old2, 0L, 0L);
   try { curChar = input_stream.readChar(); }
   catch(java.io.IOException e) {
      jjStopStringLiteralDfa_0(23, 0L, 0L, active2, 0L, 0L);
      return 24;
   }
   switch(curChar)
   {
      case 108:
         if ((active2 & 0x20000000000L) != 0L)
            return jjStartNfaWithStates_0(24, 169, 73);
         break;
      default :
         break;
   }
   return jjStartNfa_0(23, 0L, 0L, active2, 0L, 0L);
}
private final void jjCheckNAdd(int state)
{
   if (jjrounds[state] != jjround)
   {
      jjstateSet[jjnewStateCnt++] = state;
      jjrounds[state] = jjround;
   }
}
private final void jjAddStates(int start, int end)
{
   do {
      jjstateSet[jjnewStateCnt++] = jjnextStates[start];
   } while (start++ != end);
}
private final void jjCheckNAddTwoStates(int state1, int state2)
{
   jjCheckNAdd(state1);
   jjCheckNAdd(state2);
}
private final void jjCheckNAddStates(int start, int end)
{
   do {
      jjCheckNAdd(jjnextStates[start]);
   } while (start++ != end);
}
private final void jjCheckNAddStates(int start)
{
   jjCheckNAdd(jjnextStates[start]);
   jjCheckNAdd(jjnextStates[start + 1]);
}
static final long[] jjbitVec0 = {
   0xfffffffffffffffeL, 0xffffffffffffffffL, 0xffffffffffffffffL, 0xffffffffffffffffL
};
static final long[] jjbitVec2 = {
   0x0L, 0x0L, 0xffffffffffffffffL, 0xffffffffffffffffL
};
static final long[] jjbitVec3 = {
   0x1ff00000fffffffeL, 0xffffffffffffc000L, 0xffffffffL, 0x600000000000000L
};
static final long[] jjbitVec4 = {
   0x0L, 0x0L, 0x0L, 0xff7fffffff7fffffL
};
static final long[] jjbitVec5 = {
   0x0L, 0xffffffffffffffffL, 0xffffffffffffffffL, 0xffffffffffffffffL
};
static final long[] jjbitVec6 = {
   0xffffffffffffffffL, 0xffffffffffffffffL, 0xffffL, 0x0L
};
static final long[] jjbitVec7 = {
   0xffffffffffffffffL, 0xffffffffffffffffL, 0x0L, 0x0L
};
static final long[] jjbitVec8 = {
   0x3fffffffffffL, 0x0L, 0x0L, 0x0L
};
private final int jjMoveNfa_0(int startState, int curPos)
{
   int[] nextStates;
   int startsAt = 0;
   jjnewStateCnt = 121;
   int i = 1;
   jjstateSet[0] = startState;
   int j, kind = 0x7fffffff;
   for (;;)
   {
      if (++jjround == 0x7fffffff)
         ReInitRounds();
      if (curChar < 64)
      {
         long l = 1L << curChar;
         MatchLoop: do
         {
            switch(jjstateSet[--i])
            {
               case 5:
                  if ((0x3ff000000000000L & l) != 0L)
                     jjCheckNAddStates(0, 6);
                  else if (curChar == 47)
                     jjAddStates(7, 10);
                  else if (curChar == 35)
                     jjstateSet[jjnewStateCnt++] = 75;
                  else if (curChar == 36)
                  {
                     if (kind > 238)
                        kind = 238;
                     jjCheckNAdd(73);
                  }
                  else if (curChar == 39)
                     jjCheckNAddStates(11, 13);
                  else if (curChar == 34)
                     jjCheckNAddStates(14, 16);
                  else if (curChar == 46)
                     jjCheckNAdd(9);
                  if ((0x3fe000000000000L & l) != 0L)
                  {
                     if (kind > 227)
                        kind = 227;
                     jjCheckNAdd(7);
                  }
                  else if (curChar == 48)
                  {
                     if (kind > 227)
                        kind = 227;
                     jjCheckNAddTwoStates(93, 95);
                  }
                  else if (curChar == 35)
                     jjstateSet[jjnewStateCnt++] = 0;
                  break;
               case 97:
                  if (curChar == 42)
                     jjCheckNAddTwoStates(110, 111);
                  else if (curChar == 47)
                     jjCheckNAddStates(17, 19);
                  else if (curChar == 63)
                     jjCheckNAddTwoStates(116, 117);
                  if (curChar == 42)
                     jjstateSet[jjnewStateCnt++] = 102;
                  break;
               case 0:
                  if (curChar == 33)
                     jjCheckNAddStates(20, 22);
                  break;
               case 1:
                  if ((0xffffffffffffdbffL & l) != 0L)
                     jjCheckNAddStates(20, 22);
                  break;
               case 2:
                  if ((0x2400L & l) != 0L && kind > 7)
                     kind = 7;
                  break;
               case 3:
                  if (curChar == 10 && kind > 7)
                     kind = 7;
                  break;
               case 4:
                  if (curChar == 13)
                     jjstateSet[jjnewStateCnt++] = 3;
                  break;
               case 6:
                  if ((0x3fe000000000000L & l) == 0L)
                     break;
                  if (kind > 227)
                     kind = 227;
                  jjCheckNAdd(7);
                  break;
               case 7:
                  if ((0x3ff000000000000L & l) == 0L)
                     break;
                  if (kind > 227)
                     kind = 227;
                  jjCheckNAdd(7);
                  break;
               case 8:
                  if (curChar == 46)
                     jjCheckNAdd(9);
                  break;
               case 9:
                  if ((0x3ff000000000000L & l) == 0L)
                     break;
                  if (kind > 232)
                     kind = 232;
                  jjCheckNAddStates(23, 25);
                  break;
               case 11:
                  if ((0x280000000000L & l) != 0L)
                     jjCheckNAdd(12);
                  break;
               case 12:
                  if ((0x3ff000000000000L & l) == 0L)
                     break;
                  if (kind > 232)
                     kind = 232;
                  jjCheckNAddTwoStates(12, 13);
                  break;
               case 14:
                  if (curChar == 34)
                     jjCheckNAddStates(14, 16);
                  break;
               case 15:
                  if ((0xfffffffbffffdbffL & l) != 0L)
                     jjCheckNAddStates(14, 16);
                  break;
               case 18:
                  if ((0x3ff000000000000L & l) != 0L)
                     jjstateSet[jjnewStateCnt++] = 19;
                  break;
               case 19:
                  if ((0x3ff000000000000L & l) != 0L)
                     jjstateSet[jjnewStateCnt++] = 20;
                  break;
               case 20:
                  if ((0x3ff000000000000L & l) != 0L)
                     jjstateSet[jjnewStateCnt++] = 21;
                  break;
               case 21:
                  if ((0x3ff000000000000L & l) != 0L)
                     jjCheckNAddStates(14, 16);
                  break;
               case 22:
                  if (curChar == 34 && kind > 235)
                     kind = 235;
                  break;
               case 23:
                  if ((0xf000000000000L & l) != 0L)
                     jjstateSet[jjnewStateCnt++] = 24;
                  break;
               case 24:
                  if ((0xff000000000000L & l) != 0L)
                     jjCheckNAdd(25);
                  break;
               case 25:
                  if ((0xff000000000000L & l) != 0L)
                     jjCheckNAddStates(14, 16);
                  break;
               case 26:
                  if ((0xff000000000000L & l) != 0L)
                     jjCheckNAddStates(26, 29);
                  break;
               case 27:
                  if ((0x9400000000L & l) != 0L)
                     jjCheckNAddStates(14, 16);
                  break;
               case 28:
                  if (curChar == 39)
                     jjCheckNAddStates(11, 13);
                  break;
               case 29:
                  if ((0xffffff7fffffdbffL & l) != 0L)
                     jjCheckNAddStates(11, 13);
                  break;
               case 32:
                  if ((0x3ff000000000000L & l) != 0L)
                     jjstateSet[jjnewStateCnt++] = 33;
                  break;
               case 33:
                  if ((0x3ff000000000000L & l) != 0L)
                     jjstateSet[jjnewStateCnt++] = 34;
                  break;
               case 34:
                  if ((0x3ff000000000000L & l) != 0L)
                     jjstateSet[jjnewStateCnt++] = 35;
                  break;
               case 35:
                  if ((0x3ff000000000000L & l) != 0L)
                     jjCheckNAddStates(11, 13);
                  break;
               case 36:
                  if (curChar == 39 && kind > 235)
                     kind = 235;
                  break;
               case 37:
                  if ((0xf000000000000L & l) != 0L)
                     jjstateSet[jjnewStateCnt++] = 38;
                  break;
               case 38:
                  if ((0xff000000000000L & l) != 0L)
                     jjCheckNAdd(39);
                  break;
               case 39:
                  if ((0xff000000000000L & l) != 0L)
                     jjCheckNAddStates(11, 13);
                  break;
               case 40:
                  if ((0xff000000000000L & l) != 0L)
                     jjCheckNAddStates(30, 33);
                  break;
               case 41:
                  if ((0x9400000000L & l) != 0L)
                     jjCheckNAddStates(11, 13);
                  break;
               case 43:
                  if ((0xffffffffffffdbffL & l) != 0L)
                     jjCheckNAddStates(34, 36);
                  break;
               case 46:
                  if ((0x3ff000000000000L & l) != 0L)
                     jjstateSet[jjnewStateCnt++] = 47;
                  break;
               case 47:
                  if ((0x3ff000000000000L & l) != 0L)
                     jjstateSet[jjnewStateCnt++] = 48;
                  break;
               case 48:
                  if ((0x3ff000000000000L & l) != 0L)
                     jjstateSet[jjnewStateCnt++] = 49;
                  break;
               case 49:
                  if ((0x3ff000000000000L & l) != 0L)
                     jjCheckNAddStates(34, 36);
                  break;
               case 51:
                  if ((0xf000000000000L & l) != 0L)
                     jjstateSet[jjnewStateCnt++] = 52;
                  break;
               case 52:
                  if ((0xff000000000000L & l) != 0L)
                     jjCheckNAdd(53);
                  break;
               case 53:
                  if ((0xff000000000000L & l) != 0L)
                     jjCheckNAddStates(34, 36);
                  break;
               case 54:
                  if ((0xff000000000000L & l) != 0L)
                     jjCheckNAddStates(37, 40);
                  break;
               case 55:
                  if ((0x9400000000L & l) != 0L)
                     jjCheckNAddStates(34, 36);
                  break;
               case 57:
                  if ((0xffffffffffffdbffL & l) != 0L)
                     jjCheckNAddStates(41, 43);
                  break;
               case 60:
                  if ((0x3ff000000000000L & l) != 0L)
                     jjstateSet[jjnewStateCnt++] = 61;
                  break;
               case 61:
                  if ((0x3ff000000000000L & l) != 0L)
                     jjstateSet[jjnewStateCnt++] = 62;
                  break;
               case 62:
                  if ((0x3ff000000000000L & l) != 0L)
                     jjstateSet[jjnewStateCnt++] = 63;
                  break;
               case 63:
                  if ((0x3ff000000000000L & l) != 0L)
                     jjCheckNAddStates(41, 43);
                  break;
               case 66:
                  if ((0xf000000000000L & l) != 0L)
                     jjstateSet[jjnewStateCnt++] = 67;
                  break;
               case 67:
                  if ((0xff000000000000L & l) != 0L)
                     jjCheckNAdd(68);
                  break;
               case 68:
                  if ((0xff000000000000L & l) != 0L)
                     jjCheckNAddStates(41, 43);
                  break;
               case 69:
                  if ((0xff000000000000L & l) != 0L)
                     jjCheckNAddStates(44, 47);
                  break;
               case 70:
                  if ((0x9400000000L & l) != 0L)
                     jjCheckNAddStates(41, 43);
                  break;
               case 72:
                  if (curChar != 36)
                     break;
                  if (kind > 238)
                     kind = 238;
                  jjCheckNAdd(73);
                  break;
               case 73:
                  if ((0x3ff001800000000L & l) == 0L)
                     break;
                  if (kind > 238)
                     kind = 238;
                  jjCheckNAdd(73);
                  break;
               case 74:
                  if (curChar == 35)
                     jjstateSet[jjnewStateCnt++] = 75;
                  break;
               case 75:
                  if (curChar != 36)
                     break;
                  if (kind > 239)
                     kind = 239;
                  jjCheckNAdd(76);
                  break;
               case 76:
                  if ((0x3ff001800000000L & l) == 0L)
                     break;
                  if (kind > 239)
                     kind = 239;
                  jjCheckNAdd(76);
                  break;
               case 77:
                  if ((0x3ff000000000000L & l) != 0L)
                     jjCheckNAddStates(0, 6);
                  break;
               case 78:
                  if ((0x3ff000000000000L & l) != 0L)
                     jjCheckNAddTwoStates(78, 79);
                  break;
               case 79:
                  if (curChar != 46)
                     break;
                  if (kind > 232)
                     kind = 232;
                  jjCheckNAddStates(48, 50);
                  break;
               case 80:
                  if ((0x3ff000000000000L & l) == 0L)
                     break;
                  if (kind > 232)
                     kind = 232;
                  jjCheckNAddStates(48, 50);
                  break;
               case 82:
                  if ((0x280000000000L & l) != 0L)
                     jjCheckNAdd(83);
                  break;
               case 83:
                  if ((0x3ff000000000000L & l) == 0L)
                     break;
                  if (kind > 232)
                     kind = 232;
                  jjCheckNAddTwoStates(83, 13);
                  break;
               case 84:
                  if ((0x3ff000000000000L & l) != 0L)
                     jjCheckNAddTwoStates(84, 85);
                  break;
               case 86:
                  if ((0x280000000000L & l) != 0L)
                     jjCheckNAdd(87);
                  break;
               case 87:
                  if ((0x3ff000000000000L & l) == 0L)
                     break;
                  if (kind > 232)
                     kind = 232;
                  jjCheckNAddTwoStates(87, 13);
                  break;
               case 88:
                  if ((0x3ff000000000000L & l) != 0L)
                     jjCheckNAddStates(51, 53);
                  break;
               case 90:
                  if ((0x280000000000L & l) != 0L)
                     jjCheckNAdd(91);
                  break;
               case 91:
                  if ((0x3ff000000000000L & l) != 0L)
                     jjCheckNAddTwoStates(91, 13);
                  break;
               case 92:
                  if (curChar != 48)
                     break;
                  if (kind > 227)
                     kind = 227;
                  jjCheckNAddTwoStates(93, 95);
                  break;
               case 94:
                  if ((0x3ff000000000000L & l) == 0L)
                     break;
                  if (kind > 227)
                     kind = 227;
                  jjstateSet[jjnewStateCnt++] = 94;
                  break;
               case 95:
                  if ((0xff000000000000L & l) == 0L)
                     break;
                  if (kind > 227)
                     kind = 227;
                  jjCheckNAdd(95);
                  break;
               case 96:
                  if (curChar == 47)
                     jjAddStates(7, 10);
                  break;
               case 98:
                  if ((0xffffffffffffdbffL & l) != 0L)
                     jjCheckNAddStates(17, 19);
                  break;
               case 99:
                  if ((0x2400L & l) != 0L && kind > 6)
                     kind = 6;
                  break;
               case 100:
                  if (curChar == 10 && kind > 6)
                     kind = 6;
                  break;
               case 101:
                  if (curChar == 13)
                     jjstateSet[jjnewStateCnt++] = 100;
                  break;
               case 102:
                  if (curChar == 42)
                     jjCheckNAddTwoStates(103, 104);
                  break;
               case 103:
                  if ((0xfffffbffffffffffL & l) != 0L)
                     jjCheckNAddTwoStates(103, 104);
                  break;
               case 104:
                  if (curChar == 42)
                     jjCheckNAddStates(54, 56);
                  break;
               case 105:
                  if ((0xffff7bffffffffffL & l) != 0L)
                     jjCheckNAddTwoStates(106, 104);
                  break;
               case 106:
                  if ((0xfffffbffffffffffL & l) != 0L)
                     jjCheckNAddTwoStates(106, 104);
                  break;
               case 107:
                  if (curChar == 47 && kind > 8)
                     kind = 8;
                  break;
               case 108:
                  if (curChar == 42)
                     jjstateSet[jjnewStateCnt++] = 102;
                  break;
               case 109:
                  if (curChar == 42)
                     jjCheckNAddTwoStates(110, 111);
                  break;
               case 110:
                  if ((0xfffffbffffffffffL & l) != 0L)
                     jjCheckNAddTwoStates(110, 111);
                  break;
               case 111:
                  if (curChar == 42)
                     jjCheckNAddStates(57, 59);
                  break;
               case 112:
                  if ((0xffff7bffffffffffL & l) != 0L)
                     jjCheckNAddTwoStates(113, 111);
                  break;
               case 113:
                  if ((0xfffffbffffffffffL & l) != 0L)
                     jjCheckNAddTwoStates(113, 111);
                  break;
               case 114:
                  if (curChar == 47 && kind > 9)
                     kind = 9;
                  break;
               case 115:
                  if (curChar == 63)
                     jjCheckNAddTwoStates(116, 117);
                  break;
               case 116:
                  if ((0x7fffffffffffffffL & l) != 0L)
                     jjCheckNAddTwoStates(116, 117);
                  break;
               case 117:
                  if (curChar == 63)
                     jjCheckNAddStates(60, 62);
                  break;
               case 118:
                  if ((0x7fff7fffffffffffL & l) != 0L)
                     jjCheckNAddTwoStates(119, 117);
                  break;
               case 119:
                  if ((0x7fffffffffffffffL & l) != 0L)
                     jjCheckNAddTwoStates(119, 117);
                  break;
               case 120:
                  if (curChar == 47 && kind > 10)
                     kind = 10;
                  break;
               default : break;
            }
         } while(i != startsAt);
      }
      else if (curChar < 128)
      {
         long l = 1L << (curChar & 077);
         MatchLoop: do
         {
            switch(jjstateSet[--i])
            {
               case 5:
                  if ((0x7fffffe87fffffeL & l) != 0L)
                  {
                     if (kind > 238)
                        kind = 238;
                     jjCheckNAdd(73);
                  }
                  else if (curChar == 96)
                     jjstateSet[jjnewStateCnt++] = 56;
                  if (curChar == 96)
                     jjCheckNAddStates(34, 36);
                  break;
               case 1:
                  jjAddStates(20, 22);
                  break;
               case 10:
                  if ((0x2000000020L & l) != 0L)
                     jjAddStates(63, 64);
                  break;
               case 13:
                  if ((0x5000000050L & l) != 0L && kind > 232)
                     kind = 232;
                  break;
               case 15:
                  if ((0xffffffffefffffffL & l) != 0L)
                     jjCheckNAddStates(14, 16);
                  break;
               case 16:
                  if (curChar == 92)
                     jjAddStates(65, 68);
                  break;
               case 17:
                  if (curChar == 117)
                     jjstateSet[jjnewStateCnt++] = 18;
                  break;
               case 18:
                  if ((0x7e0000007eL & l) != 0L)
                     jjstateSet[jjnewStateCnt++] = 19;
                  break;
               case 19:
                  if ((0x7e0000007eL & l) != 0L)
                     jjstateSet[jjnewStateCnt++] = 20;
                  break;
               case 20:
                  if ((0x7e0000007eL & l) != 0L)
                     jjstateSet[jjnewStateCnt++] = 21;
                  break;
               case 21:
                  if ((0x7e0000007eL & l) != 0L)
                     jjCheckNAddStates(14, 16);
                  break;
               case 27:
                  if ((0x7fffffe17fffffeL & l) != 0L)
                     jjCheckNAddStates(14, 16);
                  break;
               case 29:
                  if ((0xffffffffefffffffL & l) != 0L)
                     jjCheckNAddStates(11, 13);
                  break;
               case 30:
                  if (curChar == 92)
                     jjAddStates(69, 72);
                  break;
               case 31:
                  if (curChar == 117)
                     jjstateSet[jjnewStateCnt++] = 32;
                  break;
               case 32:
                  if ((0x7e0000007eL & l) != 0L)
                     jjstateSet[jjnewStateCnt++] = 33;
                  break;
               case 33:
                  if ((0x7e0000007eL & l) != 0L)
                     jjstateSet[jjnewStateCnt++] = 34;
                  break;
               case 34:
                  if ((0x7e0000007eL & l) != 0L)
                     jjstateSet[jjnewStateCnt++] = 35;
                  break;
               case 35:
                  if ((0x7e0000007eL & l) != 0L)
                     jjCheckNAddStates(11, 13);
                  break;
               case 41:
                  if ((0x7fffffe17fffffeL & l) != 0L)
                     jjCheckNAddStates(11, 13);
                  break;
               case 42:
                  if (curChar == 96)
                     jjCheckNAddStates(34, 36);
                  break;
               case 43:
                  if ((0xfffffffeefffffffL & l) != 0L)
                     jjCheckNAddStates(34, 36);
                  break;
               case 44:
                  if (curChar == 92)
                     jjAddStates(73, 76);
                  break;
               case 45:
                  if (curChar == 117)
                     jjstateSet[jjnewStateCnt++] = 46;
                  break;
               case 46:
                  if ((0x7e0000007eL & l) != 0L)
                     jjstateSet[jjnewStateCnt++] = 47;
                  break;
               case 47:
                  if ((0x7e0000007eL & l) != 0L)
                     jjstateSet[jjnewStateCnt++] = 48;
                  break;
               case 48:
                  if ((0x7e0000007eL & l) != 0L)
                     jjstateSet[jjnewStateCnt++] = 49;
                  break;
               case 49:
                  if ((0x7e0000007eL & l) != 0L)
                     jjCheckNAddStates(34, 36);
                  break;
               case 50:
                  if (curChar == 96 && kind > 236)
                     kind = 236;
                  break;
               case 55:
                  if ((0x7fffffe17fffffeL & l) != 0L)
                     jjCheckNAddStates(34, 36);
                  break;
               case 56:
                  if (curChar == 96)
                     jjCheckNAddStates(41, 43);
                  break;
               case 57:
                  if ((0xfffffffeefffffffL & l) != 0L)
                     jjCheckNAddStates(41, 43);
                  break;
               case 58:
                  if (curChar == 92)
                     jjAddStates(77, 80);
                  break;
               case 59:
                  if (curChar == 117)
                     jjstateSet[jjnewStateCnt++] = 60;
                  break;
               case 60:
                  if ((0x7e0000007eL & l) != 0L)
                     jjstateSet[jjnewStateCnt++] = 61;
                  break;
               case 61:
                  if ((0x7e0000007eL & l) != 0L)
                     jjstateSet[jjnewStateCnt++] = 62;
                  break;
               case 62:
                  if ((0x7e0000007eL & l) != 0L)
                     jjstateSet[jjnewStateCnt++] = 63;
                  break;
               case 63:
                  if ((0x7e0000007eL & l) != 0L)
                     jjCheckNAddStates(41, 43);
                  break;
               case 64:
                  if (curChar == 96 && kind > 237)
                     kind = 237;
                  break;
               case 65:
                  if (curChar == 96)
                     jjstateSet[jjnewStateCnt++] = 64;
                  break;
               case 70:
                  if ((0x7fffffe17fffffeL & l) != 0L)
                     jjCheckNAddStates(41, 43);
                  break;
               case 71:
                  if (curChar == 96)
                     jjstateSet[jjnewStateCnt++] = 56;
                  break;
               case 72:
               case 73:
                  if ((0x7fffffe87fffffeL & l) == 0L)
                     break;
                  if (kind > 238)
                     kind = 238;
                  jjCheckNAdd(73);
                  break;
               case 75:
               case 76:
                  if ((0x7fffffe87fffffeL & l) == 0L)
                     break;
                  if (kind > 239)
                     kind = 239;
                  jjCheckNAdd(76);
                  break;
               case 81:
                  if ((0x2000000020L & l) != 0L)
                     jjAddStates(81, 82);
                  break;
               case 85:
                  if ((0x2000000020L & l) != 0L)
                     jjAddStates(83, 84);
                  break;
               case 89:
                  if ((0x2000000020L & l) != 0L)
                     jjAddStates(85, 86);
                  break;
               case 93:
                  if ((0x100000001000000L & l) != 0L)
                     jjCheckNAdd(94);
                  break;
               case 94:
                  if ((0x7e0000007eL & l) == 0L)
                     break;
                  if (kind > 227)
                     kind = 227;
                  jjCheckNAdd(94);
                  break;
               case 98:
                  jjAddStates(17, 19);
                  break;
               case 103:
                  jjCheckNAddTwoStates(103, 104);
                  break;
               case 105:
               case 106:
                  jjCheckNAddTwoStates(106, 104);
                  break;
               case 110:
                  jjCheckNAddTwoStates(110, 111);
                  break;
               case 112:
               case 113:
                  jjCheckNAddTwoStates(113, 111);
                  break;
               case 116:
                  jjCheckNAddTwoStates(116, 117);
                  break;
               case 118:
               case 119:
                  jjCheckNAddTwoStates(119, 117);
                  break;
               default : break;
            }
         } while(i != startsAt);
      }
      else
      {
         int hiByte = (int)(curChar >> 8);
         int i1 = hiByte >> 6;
         long l1 = 1L << (hiByte & 077);
         int i2 = (curChar & 0xff) >> 6;
         long l2 = 1L << (curChar & 077);
         MatchLoop: do
         {
            switch(jjstateSet[--i])
            {
               case 5:
               case 73:
                  if (!jjCanMove_1(hiByte, i1, i2, l1, l2))
                     break;
                  if (kind > 238)
                     kind = 238;
                  jjCheckNAdd(73);
                  break;
               case 1:
                  if (jjCanMove_0(hiByte, i1, i2, l1, l2))
                     jjAddStates(20, 22);
                  break;
               case 15:
                  if (jjCanMove_0(hiByte, i1, i2, l1, l2))
                     jjAddStates(14, 16);
                  break;
               case 29:
                  if (jjCanMove_0(hiByte, i1, i2, l1, l2))
                     jjAddStates(11, 13);
                  break;
               case 43:
                  if (jjCanMove_0(hiByte, i1, i2, l1, l2))
                     jjAddStates(34, 36);
                  break;
               case 57:
                  if (jjCanMove_0(hiByte, i1, i2, l1, l2))
                     jjAddStates(41, 43);
                  break;
               case 75:
               case 76:
                  if (!jjCanMove_1(hiByte, i1, i2, l1, l2))
                     break;
                  if (kind > 239)
                     kind = 239;
                  jjCheckNAdd(76);
                  break;
               case 98:
                  if (jjCanMove_0(hiByte, i1, i2, l1, l2))
                     jjAddStates(17, 19);
                  break;
               case 103:
                  if (jjCanMove_0(hiByte, i1, i2, l1, l2))
                     jjCheckNAddTwoStates(103, 104);
                  break;
               case 105:
               case 106:
                  if (jjCanMove_0(hiByte, i1, i2, l1, l2))
                     jjCheckNAddTwoStates(106, 104);
                  break;
               case 110:
                  if (jjCanMove_0(hiByte, i1, i2, l1, l2))
                     jjCheckNAddTwoStates(110, 111);
                  break;
               case 112:
               case 113:
                  if (jjCanMove_0(hiByte, i1, i2, l1, l2))
                     jjCheckNAddTwoStates(113, 111);
                  break;
               case 116:
                  if (jjCanMove_0(hiByte, i1, i2, l1, l2))
                     jjCheckNAddTwoStates(116, 117);
                  break;
               case 118:
               case 119:
                  if (jjCanMove_0(hiByte, i1, i2, l1, l2))
                     jjCheckNAddTwoStates(119, 117);
                  break;
               default : break;
            }
         } while(i != startsAt);
      }
      if (kind != 0x7fffffff)
      {
         jjmatchedKind = kind;
         jjmatchedPos = curPos;
         kind = 0x7fffffff;
      }
      ++curPos;
      if ((i = jjnewStateCnt) == (startsAt = 121 - (jjnewStateCnt = startsAt)))
         return curPos;
      try { curChar = input_stream.readChar(); }
      catch(java.io.IOException e) { return curPos; }
   }
}
private final int jjStopStringLiteralDfa_2(int pos, long active0, long active1, long active2, long active3, long active4)
{
   switch (pos)
   {
      case 0:
         if ((active4 & 0x400000000000000L) != 0L)
            return 4;
         return -1;
      case 1:
         if ((active4 & 0x400000000000000L) != 0L)
            return 5;
         return -1;
      default :
         return -1;
   }
}
private final int jjStartNfa_2(int pos, long active0, long active1, long active2, long active3, long active4)
{
   return jjMoveNfa_2(jjStopStringLiteralDfa_2(pos, active0, active1, active2, active3, active4), pos + 1);
}
private final int jjStartNfaWithStates_2(int pos, int kind, int state)
{
   jjmatchedKind = kind;
   jjmatchedPos = pos;
   try { curChar = input_stream.readChar(); }
   catch(java.io.IOException e) { return pos + 1; }
   return jjMoveNfa_2(state, pos + 1);
}
private final int jjMoveStringLiteralDfa0_2()
{
   switch(curChar)
   {
      case 42:
         return jjMoveStringLiteralDfa1_2(0x400000000000000L);
      default :
         return jjMoveNfa_2(6, 0);
   }
}
private final int jjMoveStringLiteralDfa1_2(long active4)
{
   try { curChar = input_stream.readChar(); }
   catch(java.io.IOException e) {
      jjStopStringLiteralDfa_2(0, 0L, 0L, 0L, 0L, active4);
      return 1;
   }
   switch(curChar)
   {
      case 93:
         return jjMoveStringLiteralDfa2_2(active4, 0x400000000000000L);
      default :
         break;
   }
   return jjStartNfa_2(0, 0L, 0L, 0L, 0L, active4);
}
private final int jjMoveStringLiteralDfa2_2(long old4, long active4)
{
   if (((active4 &= old4)) == 0L)
      return jjStartNfa_2(0, 0L, 0L, 0L, 0L, old4); 
   try { curChar = input_stream.readChar(); }
   catch(java.io.IOException e) {
      jjStopStringLiteralDfa_2(1, 0L, 0L, 0L, 0L, active4);
      return 2;
   }
   switch(curChar)
   {
      case 93:
         if ((active4 & 0x400000000000000L) != 0L)
            return jjStopAtPos(2, 314);
         break;
      default :
         break;
   }
   return jjStartNfa_2(1, 0L, 0L, 0L, 0L, active4);
}
private final int jjMoveNfa_2(int startState, int curPos)
{
   int[] nextStates;
   int startsAt = 0;
   jjnewStateCnt = 6;
   int i = 1;
   jjstateSet[0] = startState;
   int j, kind = 0x7fffffff;
   for (;;)
   {
      if (++jjround == 0x7fffffff)
         ReInitRounds();
      if (curChar < 64)
      {
         long l = 1L << curChar;
         MatchLoop: do
         {
            switch(jjstateSet[--i])
            {
               case 6:
                  if ((0xfffffaffffffffffL & l) != 0L)
                  {
                     if (kind > 315)
                        kind = 315;
                     jjCheckNAddStates(87, 89);
                  }
                  else if (curChar == 42)
                     jjAddStates(90, 91);
                  else if (curChar == 40)
                     jjstateSet[jjnewStateCnt++] = 2;
                  break;
               case 4:
               case 5:
                  if (kind > 315)
                     kind = 315;
                  jjCheckNAddStates(87, 89);
                  break;
               case 0:
                  if ((0xfffffaffffffffffL & l) == 0L)
                     break;
                  if (kind > 315)
                     kind = 315;
                  jjCheckNAddStates(87, 89);
                  break;
               case 1:
                  if (curChar == 40)
                     jjstateSet[jjnewStateCnt++] = 2;
                  break;
               case 2:
                  if ((0xfffffbffffffffffL & l) == 0L)
                     break;
                  if (kind > 315)
                     kind = 315;
                  jjCheckNAddStates(87, 89);
                  break;
               case 3:
                  if (curChar == 42)
                     jjAddStates(90, 91);
                  break;
               default : break;
            }
         } while(i != startsAt);
      }
      else if (curChar < 128)
      {
         long l = 1L << (curChar & 077);
         MatchLoop: do
         {
            switch(jjstateSet[--i])
            {
               case 6:
               case 0:
               case 2:
                  if (kind > 315)
                     kind = 315;
                  jjCheckNAddStates(87, 89);
                  break;
               case 4:
                  if ((0xffffffffdfffffffL & l) != 0L)
                  {
                     if (kind > 315)
                        kind = 315;
                     jjCheckNAddStates(87, 89);
                  }
                  else if (curChar == 93)
                     jjstateSet[jjnewStateCnt++] = 5;
                  break;
               case 5:
                  if ((0xffffffffdfffffffL & l) == 0L)
                     break;
                  if (kind > 315)
                     kind = 315;
                  jjCheckNAddStates(87, 89);
                  break;
               default : break;
            }
         } while(i != startsAt);
      }
      else
      {
         int hiByte = (int)(curChar >> 8);
         int i1 = hiByte >> 6;
         long l1 = 1L << (hiByte & 077);
         int i2 = (curChar & 0xff) >> 6;
         long l2 = 1L << (curChar & 077);
         MatchLoop: do
         {
            switch(jjstateSet[--i])
            {
               case 6:
               case 0:
               case 2:
                  if (!jjCanMove_0(hiByte, i1, i2, l1, l2))
                     break;
                  if (kind > 315)
                     kind = 315;
                  jjCheckNAddStates(87, 89);
                  break;
               case 4:
               case 5:
                  if (!jjCanMove_0(hiByte, i1, i2, l1, l2))
                     break;
                  if (kind > 315)
                     kind = 315;
                  jjCheckNAddStates(87, 89);
                  break;
               default : break;
            }
         } while(i != startsAt);
      }
      if (kind != 0x7fffffff)
      {
         jjmatchedKind = kind;
         jjmatchedPos = curPos;
         kind = 0x7fffffff;
      }
      ++curPos;
      if ((i = jjnewStateCnt) == (startsAt = 6 - (jjnewStateCnt = startsAt)))
         return curPos;
      try { curChar = input_stream.readChar(); }
      catch(java.io.IOException e) { return curPos; }
   }
}
private final int jjStopStringLiteralDfa_1(int pos, long active0, long active1, long active2, long active3, long active4)
{
   switch (pos)
   {
      default :
         return -1;
   }
}
private final int jjStartNfa_1(int pos, long active0, long active1, long active2, long active3, long active4)
{
   return jjMoveNfa_1(jjStopStringLiteralDfa_1(pos, active0, active1, active2, active3, active4), pos + 1);
}
private final int jjStartNfaWithStates_1(int pos, int kind, int state)
{
   jjmatchedKind = kind;
   jjmatchedPos = pos;
   try { curChar = input_stream.readChar(); }
   catch(java.io.IOException e) { return pos + 1; }
   return jjMoveNfa_1(state, pos + 1);
}
private final int jjMoveStringLiteralDfa0_1()
{
   switch(curChar)
   {
      case 9:
         return jjStartNfaWithStates_1(0, 2, 118);
      case 10:
         return jjStartNfaWithStates_1(0, 3, 118);
      case 12:
         return jjStartNfaWithStates_1(0, 5, 118);
      case 13:
         return jjStartNfaWithStates_1(0, 4, 118);
      case 32:
         return jjStartNfaWithStates_1(0, 1, 118);
      case 59:
         return jjStopAtPos(0, 313);
      default :
         return jjMoveNfa_1(0, 0);
   }
}
private final int jjMoveNfa_1(int startState, int curPos)
{
   int[] nextStates;
   int startsAt = 0;
   jjnewStateCnt = 118;
   int i = 1;
   jjstateSet[0] = startState;
   int j, kind = 0x7fffffff;
   for (;;)
   {
      if (++jjround == 0x7fffffff)
         ReInitRounds();
      if (curChar < 64)
      {
         long l = 1L << curChar;
         MatchLoop: do
         {
            switch(jjstateSet[--i])
            {
               case 0:
                  if ((0xf7fffeffffffffffL & l) != 0L)
                  {
                     if (kind > 312)
                        kind = 312;
                     jjCheckNAddStates(92, 95);
                  }
                  else if (curChar == 40)
                     jjAddStates(96, 97);
                  if ((0x3ff000000000000L & l) != 0L)
                     jjCheckNAddStates(98, 104);
                  else if (curChar == 39)
                     jjCheckNAddStates(105, 110);
                  else if (curChar == 34)
                     jjCheckNAddStates(111, 116);
                  else if (curChar == 46)
                     jjCheckNAdd(3);
                  if ((0x3fe000000000000L & l) != 0L)
                  {
                     if (kind > 227)
                        kind = 227;
                     jjCheckNAdd(1);
                  }
                  else if (curChar == 48)
                  {
                     if (kind > 227)
                        kind = 227;
                     jjCheckNAddTwoStates(87, 89);
                  }
                  break;
               case 118:
                  if ((0xf7fffeffffffffffL & l) != 0L)
                  {
                     if (kind > 312)
                        kind = 312;
                     jjCheckNAddStates(92, 95);
                  }
                  else if (curChar == 40)
                     jjAddStates(96, 97);
                  if (curChar == 34)
                     jjCheckNAddStates(117, 119);
                  else if (curChar == 39)
                     jjCheckNAddStates(120, 122);
                  break;
               case 1:
                  if ((0x3ff000000000000L & l) == 0L)
                     break;
                  if (kind > 227)
                     kind = 227;
                  jjCheckNAdd(1);
                  break;
               case 2:
                  if (curChar == 46)
                     jjCheckNAdd(3);
                  break;
               case 3:
                  if ((0x3ff000000000000L & l) == 0L)
                     break;
                  if (kind > 232)
                     kind = 232;
                  jjCheckNAddStates(123, 125);
                  break;
               case 5:
                  if ((0x280000000000L & l) != 0L)
                     jjCheckNAdd(6);
                  break;
               case 6:
                  if ((0x3ff000000000000L & l) == 0L)
                     break;
                  if (kind > 232)
                     kind = 232;
                  jjCheckNAddTwoStates(6, 7);
                  break;
               case 9:
                  if ((0xffffffffffffdbffL & l) != 0L)
                     jjCheckNAddStates(126, 128);
                  break;
               case 12:
                  if ((0x3ff000000000000L & l) != 0L)
                     jjstateSet[jjnewStateCnt++] = 13;
                  break;
               case 13:
                  if ((0x3ff000000000000L & l) != 0L)
                     jjstateSet[jjnewStateCnt++] = 14;
                  break;
               case 14:
                  if ((0x3ff000000000000L & l) != 0L)
                     jjstateSet[jjnewStateCnt++] = 15;
                  break;
               case 15:
                  if ((0x3ff000000000000L & l) != 0L)
                     jjCheckNAddStates(126, 128);
                  break;
               case 17:
                  if ((0xf000000000000L & l) != 0L)
                     jjstateSet[jjnewStateCnt++] = 18;
                  break;
               case 18:
                  if ((0xff000000000000L & l) != 0L)
                     jjCheckNAdd(19);
                  break;
               case 19:
                  if ((0xff000000000000L & l) != 0L)
                     jjCheckNAddStates(126, 128);
                  break;
               case 20:
                  if ((0xff000000000000L & l) != 0L)
                     jjCheckNAddStates(129, 132);
                  break;
               case 21:
                  if ((0x9400000000L & l) != 0L)
                     jjCheckNAddStates(126, 128);
                  break;
               case 23:
                  if ((0xffffffffffffdbffL & l) != 0L)
                     jjCheckNAddStates(133, 135);
                  break;
               case 26:
                  if ((0x3ff000000000000L & l) != 0L)
                     jjstateSet[jjnewStateCnt++] = 27;
                  break;
               case 27:
                  if ((0x3ff000000000000L & l) != 0L)
                     jjstateSet[jjnewStateCnt++] = 28;
                  break;
               case 28:
                  if ((0x3ff000000000000L & l) != 0L)
                     jjstateSet[jjnewStateCnt++] = 29;
                  break;
               case 29:
                  if ((0x3ff000000000000L & l) != 0L)
                     jjCheckNAddStates(133, 135);
                  break;
               case 32:
                  if ((0xf000000000000L & l) != 0L)
                     jjstateSet[jjnewStateCnt++] = 33;
                  break;
               case 33:
                  if ((0xff000000000000L & l) != 0L)
                     jjCheckNAdd(34);
                  break;
               case 34:
                  if ((0xff000000000000L & l) != 0L)
                     jjCheckNAddStates(133, 135);
                  break;
               case 35:
                  if ((0xff000000000000L & l) != 0L)
                     jjCheckNAddStates(136, 139);
                  break;
               case 36:
                  if ((0x9400000000L & l) != 0L)
                     jjCheckNAddStates(133, 135);
                  break;
               case 38:
                  if ((0xf7fffeffffffffffL & l) == 0L)
                     break;
                  if (kind > 312)
                     kind = 312;
                  jjCheckNAddStates(92, 95);
                  break;
               case 39:
                  if (curChar == 40)
                     jjAddStates(96, 97);
                  break;
               case 40:
                  if ((0xf7fffbffffffffffL & l) == 0L)
                     break;
                  if (kind > 312)
                     kind = 312;
                  jjCheckNAddStates(92, 95);
                  break;
               case 41:
                  if (curChar == 39)
                     jjCheckNAddStates(120, 122);
                  break;
               case 42:
                  if ((0xffffff7fffffdbffL & l) != 0L)
                     jjCheckNAddStates(120, 122);
                  break;
               case 45:
                  if ((0x3ff000000000000L & l) != 0L)
                     jjstateSet[jjnewStateCnt++] = 46;
                  break;
               case 46:
                  if ((0x3ff000000000000L & l) != 0L)
                     jjstateSet[jjnewStateCnt++] = 47;
                  break;
               case 47:
                  if ((0x3ff000000000000L & l) != 0L)
                     jjstateSet[jjnewStateCnt++] = 48;
                  break;
               case 48:
                  if ((0x3ff000000000000L & l) != 0L)
                     jjCheckNAddStates(120, 122);
                  break;
               case 49:
                  if (curChar != 39)
                     break;
                  if (kind > 312)
                     kind = 312;
                  jjCheckNAddStates(92, 95);
                  break;
               case 50:
                  if (curChar == 34)
                     jjCheckNAddStates(117, 119);
                  break;
               case 51:
                  if ((0xfffffffbffffdbffL & l) != 0L)
                     jjCheckNAddStates(117, 119);
                  break;
               case 54:
                  if ((0x3ff000000000000L & l) != 0L)
                     jjstateSet[jjnewStateCnt++] = 55;
                  break;
               case 55:
                  if ((0x3ff000000000000L & l) != 0L)
                     jjstateSet[jjnewStateCnt++] = 56;
                  break;
               case 56:
                  if ((0x3ff000000000000L & l) != 0L)
                     jjstateSet[jjnewStateCnt++] = 57;
                  break;
               case 57:
                  if ((0x3ff000000000000L & l) != 0L)
                     jjCheckNAddStates(117, 119);
                  break;
               case 58:
                  if (curChar != 34)
                     break;
                  if (kind > 312)
                     kind = 312;
                  jjCheckNAddStates(92, 95);
                  break;
               case 59:
                  if ((0xf000000000000L & l) != 0L)
                     jjstateSet[jjnewStateCnt++] = 60;
                  break;
               case 60:
                  if ((0xff000000000000L & l) != 0L)
                     jjCheckNAdd(61);
                  break;
               case 61:
                  if ((0xff000000000000L & l) != 0L)
                     jjCheckNAddStates(117, 119);
                  break;
               case 62:
                  if ((0xff000000000000L & l) != 0L)
                     jjCheckNAddStates(140, 143);
                  break;
               case 63:
                  if ((0x9400000000L & l) != 0L)
                     jjCheckNAddStates(117, 119);
                  break;
               case 64:
                  if ((0xf000000000000L & l) != 0L)
                     jjstateSet[jjnewStateCnt++] = 65;
                  break;
               case 65:
                  if ((0xff000000000000L & l) != 0L)
                     jjCheckNAdd(66);
                  break;
               case 66:
                  if ((0xff000000000000L & l) != 0L)
                     jjCheckNAddStates(120, 122);
                  break;
               case 67:
                  if ((0xff000000000000L & l) != 0L)
                     jjCheckNAddStates(144, 147);
                  break;
               case 68:
                  if ((0x9400000000L & l) != 0L)
                     jjCheckNAddStates(120, 122);
                  break;
               case 69:
                  if (curChar == 42)
                     jjstateSet[jjnewStateCnt++] = 70;
                  break;
               case 70:
                  if (curChar != 41)
                     break;
                  if (kind > 312)
                     kind = 312;
                  jjCheckNAddStates(92, 95);
                  break;
               case 71:
                  if ((0x3ff000000000000L & l) != 0L)
                     jjCheckNAddStates(98, 104);
                  break;
               case 72:
                  if ((0x3ff000000000000L & l) != 0L)
                     jjCheckNAddTwoStates(72, 73);
                  break;
               case 73:
                  if (curChar != 46)
                     break;
                  if (kind > 232)
                     kind = 232;
                  jjCheckNAddStates(148, 150);
                  break;
               case 74:
                  if ((0x3ff000000000000L & l) == 0L)
                     break;
                  if (kind > 232)
                     kind = 232;
                  jjCheckNAddStates(148, 150);
                  break;
               case 76:
                  if ((0x280000000000L & l) != 0L)
                     jjCheckNAdd(77);
                  break;
               case 77:
                  if ((0x3ff000000000000L & l) == 0L)
                     break;
                  if (kind > 232)
                     kind = 232;
                  jjCheckNAddTwoStates(77, 7);
                  break;
               case 78:
                  if ((0x3ff000000000000L & l) != 0L)
                     jjCheckNAddTwoStates(78, 79);
                  break;
               case 80:
                  if ((0x280000000000L & l) != 0L)
                     jjCheckNAdd(81);
                  break;
               case 81:
                  if ((0x3ff000000000000L & l) == 0L)
                     break;
                  if (kind > 232)
                     kind = 232;
                  jjCheckNAddTwoStates(81, 7);
                  break;
               case 82:
                  if ((0x3ff000000000000L & l) != 0L)
                     jjCheckNAddStates(151, 153);
                  break;
               case 84:
                  if ((0x280000000000L & l) != 0L)
                     jjCheckNAdd(85);
                  break;
               case 85:
                  if ((0x3ff000000000000L & l) != 0L)
                     jjCheckNAddTwoStates(85, 7);
                  break;
               case 86:
                  if (curChar != 48)
                     break;
                  if (kind > 227)
                     kind = 227;
                  jjCheckNAddTwoStates(87, 89);
                  break;
               case 88:
                  if ((0x3ff000000000000L & l) == 0L)
                     break;
                  if (kind > 227)
                     kind = 227;
                  jjstateSet[jjnewStateCnt++] = 88;
                  break;
               case 89:
                  if ((0xff000000000000L & l) == 0L)
                     break;
                  if (kind > 227)
                     kind = 227;
                  jjCheckNAdd(89);
                  break;
               case 90:
                  if (curChar == 34)
                     jjCheckNAddStates(111, 116);
                  break;
               case 91:
                  if ((0xfffffffbffffdbffL & l) != 0L)
                     jjCheckNAddStates(154, 156);
                  break;
               case 94:
                  if ((0x3ff000000000000L & l) != 0L)
                     jjstateSet[jjnewStateCnt++] = 95;
                  break;
               case 95:
                  if ((0x3ff000000000000L & l) != 0L)
                     jjstateSet[jjnewStateCnt++] = 96;
                  break;
               case 96:
                  if ((0x3ff000000000000L & l) != 0L)
                     jjstateSet[jjnewStateCnt++] = 97;
                  break;
               case 97:
                  if ((0x3ff000000000000L & l) != 0L)
                     jjCheckNAddStates(154, 156);
                  break;
               case 98:
                  if (curChar == 34 && kind > 235)
                     kind = 235;
                  break;
               case 99:
                  if ((0xf000000000000L & l) != 0L)
                     jjstateSet[jjnewStateCnt++] = 100;
                  break;
               case 100:
                  if ((0xff000000000000L & l) != 0L)
                     jjCheckNAdd(101);
                  break;
               case 101:
                  if ((0xff000000000000L & l) != 0L)
                     jjCheckNAddStates(154, 156);
                  break;
               case 102:
                  if ((0xff000000000000L & l) != 0L)
                     jjCheckNAddStates(157, 160);
                  break;
               case 103:
                  if ((0x9400000000L & l) != 0L)
                     jjCheckNAddStates(154, 156);
                  break;
               case 104:
                  if (curChar == 39)
                     jjCheckNAddStates(105, 110);
                  break;
               case 105:
                  if ((0xffffff7fffffdbffL & l) != 0L)
                     jjCheckNAddStates(161, 163);
                  break;
               case 108:
                  if ((0x3ff000000000000L & l) != 0L)
                     jjstateSet[jjnewStateCnt++] = 109;
                  break;
               case 109:
                  if ((0x3ff000000000000L & l) != 0L)
                     jjstateSet[jjnewStateCnt++] = 110;
                  break;
               case 110:
                  if ((0x3ff000000000000L & l) != 0L)
                     jjstateSet[jjnewStateCnt++] = 111;
                  break;
               case 111:
                  if ((0x3ff000000000000L & l) != 0L)
                     jjCheckNAddStates(161, 163);
                  break;
               case 112:
                  if (curChar == 39 && kind > 235)
                     kind = 235;
                  break;
               case 113:
                  if ((0xf000000000000L & l) != 0L)
                     jjstateSet[jjnewStateCnt++] = 114;
                  break;
               case 114:
                  if ((0xff000000000000L & l) != 0L)
                     jjCheckNAdd(115);
                  break;
               case 115:
                  if ((0xff000000000000L & l) != 0L)
                     jjCheckNAddStates(161, 163);
                  break;
               case 116:
                  if ((0xff000000000000L & l) != 0L)
                     jjCheckNAddStates(164, 167);
                  break;
               case 117:
                  if ((0x9400000000L & l) != 0L)
                     jjCheckNAddStates(161, 163);
                  break;
               default : break;
            }
         } while(i != startsAt);
      }
      else if (curChar < 128)
      {
         long l = 1L << (curChar & 077);
         MatchLoop: do
         {
            switch(jjstateSet[--i])
            {
               case 0:
                  if (kind > 312)
                     kind = 312;
                  jjCheckNAddStates(92, 95);
                  if (curChar == 96)
                     jjstateSet[jjnewStateCnt++] = 22;
                  if (curChar == 96)
                     jjCheckNAddStates(126, 128);
                  break;
               case 118:
               case 38:
               case 40:
                  if (kind > 312)
                     kind = 312;
                  jjCheckNAddStates(92, 95);
                  break;
               case 4:
                  if ((0x2000000020L & l) != 0L)
                     jjAddStates(168, 169);
                  break;
               case 7:
                  if ((0x5000000050L & l) != 0L && kind > 232)
                     kind = 232;
                  break;
               case 8:
                  if (curChar == 96)
                     jjCheckNAddStates(126, 128);
                  break;
               case 9:
                  if ((0xfffffffeefffffffL & l) != 0L)
                     jjCheckNAddStates(126, 128);
                  break;
               case 10:
                  if (curChar == 92)
                     jjAddStates(170, 173);
                  break;
               case 11:
                  if (curChar == 117)
                     jjstateSet[jjnewStateCnt++] = 12;
                  break;
               case 12:
                  if ((0x7e0000007eL & l) != 0L)
                     jjstateSet[jjnewStateCnt++] = 13;
                  break;
               case 13:
                  if ((0x7e0000007eL & l) != 0L)
                     jjstateSet[jjnewStateCnt++] = 14;
                  break;
               case 14:
                  if ((0x7e0000007eL & l) != 0L)
                     jjstateSet[jjnewStateCnt++] = 15;
                  break;
               case 15:
                  if ((0x7e0000007eL & l) != 0L)
                     jjCheckNAddStates(126, 128);
                  break;
               case 16:
                  if (curChar == 96 && kind > 236)
                     kind = 236;
                  break;
               case 21:
                  if ((0x7fffffe17fffffeL & l) != 0L)
                     jjCheckNAddStates(126, 128);
                  break;
               case 22:
                  if (curChar == 96)
                     jjCheckNAddStates(133, 135);
                  break;
               case 23:
                  if ((0xfffffffeefffffffL & l) != 0L)
                     jjCheckNAddStates(133, 135);
                  break;
               case 24:
                  if (curChar == 92)
                     jjAddStates(174, 177);
                  break;
               case 25:
                  if (curChar == 117)
                     jjstateSet[jjnewStateCnt++] = 26;
                  break;
               case 26:
                  if ((0x7e0000007eL & l) != 0L)
                     jjstateSet[jjnewStateCnt++] = 27;
                  break;
               case 27:
                  if ((0x7e0000007eL & l) != 0L)
                     jjstateSet[jjnewStateCnt++] = 28;
                  break;
               case 28:
                  if ((0x7e0000007eL & l) != 0L)
                     jjstateSet[jjnewStateCnt++] = 29;
                  break;
               case 29:
                  if ((0x7e0000007eL & l) != 0L)
                     jjCheckNAddStates(133, 135);
                  break;
               case 30:
                  if (curChar == 96 && kind > 237)
                     kind = 237;
                  break;
               case 31:
                  if (curChar == 96)
                     jjstateSet[jjnewStateCnt++] = 30;
                  break;
               case 36:
                  if ((0x7fffffe17fffffeL & l) != 0L)
                     jjCheckNAddStates(133, 135);
                  break;
               case 37:
                  if (curChar == 96)
                     jjstateSet[jjnewStateCnt++] = 22;
                  break;
               case 42:
                  if ((0xffffffffefffffffL & l) != 0L)
                     jjCheckNAddStates(120, 122);
                  break;
               case 43:
                  if (curChar == 92)
                     jjAddStates(178, 181);
                  break;
               case 44:
                  if (curChar == 117)
                     jjstateSet[jjnewStateCnt++] = 45;
                  break;
               case 45:
                  if ((0x7e0000007eL & l) != 0L)
                     jjstateSet[jjnewStateCnt++] = 46;
                  break;
               case 46:
                  if ((0x7e0000007eL & l) != 0L)
                     jjstateSet[jjnewStateCnt++] = 47;
                  break;
               case 47:
                  if ((0x7e0000007eL & l) != 0L)
                     jjstateSet[jjnewStateCnt++] = 48;
                  break;
               case 48:
                  if ((0x7e0000007eL & l) != 0L)
                     jjCheckNAddStates(120, 122);
                  break;
               case 51:
                  if ((0xffffffffefffffffL & l) != 0L)
                     jjCheckNAddStates(117, 119);
                  break;
               case 52:
                  if (curChar == 92)
                     jjAddStates(182, 185);
                  break;
               case 53:
                  if (curChar == 117)
                     jjstateSet[jjnewStateCnt++] = 54;
                  break;
               case 54:
                  if ((0x7e0000007eL & l) != 0L)
                     jjstateSet[jjnewStateCnt++] = 55;
                  break;
               case 55:
                  if ((0x7e0000007eL & l) != 0L)
                     jjstateSet[jjnewStateCnt++] = 56;
                  break;
               case 56:
                  if ((0x7e0000007eL & l) != 0L)
                     jjstateSet[jjnewStateCnt++] = 57;
                  break;
               case 57:
                  if ((0x7e0000007eL & l) != 0L)
                     jjCheckNAddStates(117, 119);
                  break;
               case 63:
                  if ((0x7fffffe17fffffeL & l) != 0L)
                     jjCheckNAddStates(117, 119);
                  break;
               case 68:
                  if ((0x7fffffe17fffffeL & l) != 0L)
                     jjCheckNAddStates(120, 122);
                  break;
               case 75:
                  if ((0x2000000020L & l) != 0L)
                     jjAddStates(186, 187);
                  break;
               case 79:
                  if ((0x2000000020L & l) != 0L)
                     jjAddStates(188, 189);
                  break;
               case 83:
                  if ((0x2000000020L & l) != 0L)
                     jjAddStates(190, 191);
                  break;
               case 87:
                  if ((0x100000001000000L & l) != 0L)
                     jjCheckNAdd(88);
                  break;
               case 88:
                  if ((0x7e0000007eL & l) == 0L)
                     break;
                  if (kind > 227)
                     kind = 227;
                  jjCheckNAdd(88);
                  break;
               case 91:
                  if ((0xffffffffefffffffL & l) != 0L)
                     jjCheckNAddStates(154, 156);
                  break;
               case 92:
                  if (curChar == 92)
                     jjAddStates(192, 195);
                  break;
               case 93:
                  if (curChar == 117)
                     jjstateSet[jjnewStateCnt++] = 94;
                  break;
               case 94:
                  if ((0x7e0000007eL & l) != 0L)
                     jjstateSet[jjnewStateCnt++] = 95;
                  break;
               case 95:
                  if ((0x7e0000007eL & l) != 0L)
                     jjstateSet[jjnewStateCnt++] = 96;
                  break;
               case 96:
                  if ((0x7e0000007eL & l) != 0L)
                     jjstateSet[jjnewStateCnt++] = 97;
                  break;
               case 97:
                  if ((0x7e0000007eL & l) != 0L)
                     jjCheckNAddStates(154, 156);
                  break;
               case 103:
                  if ((0x7fffffe17fffffeL & l) != 0L)
                     jjCheckNAddStates(154, 156);
                  break;
               case 105:
                  if ((0xffffffffefffffffL & l) != 0L)
                     jjCheckNAddStates(161, 163);
                  break;
               case 106:
                  if (curChar == 92)
                     jjAddStates(196, 199);
                  break;
               case 107:
                  if (curChar == 117)
                     jjstateSet[jjnewStateCnt++] = 108;
                  break;
               case 108:
                  if ((0x7e0000007eL & l) != 0L)
                     jjstateSet[jjnewStateCnt++] = 109;
                  break;
               case 109:
                  if ((0x7e0000007eL & l) != 0L)
                     jjstateSet[jjnewStateCnt++] = 110;
                  break;
               case 110:
                  if ((0x7e0000007eL & l) != 0L)
                     jjstateSet[jjnewStateCnt++] = 111;
                  break;
               case 111:
                  if ((0x7e0000007eL & l) != 0L)
                     jjCheckNAddStates(161, 163);
                  break;
               case 117:
                  if ((0x7fffffe17fffffeL & l) != 0L)
                     jjCheckNAddStates(161, 163);
                  break;
               default : break;
            }
         } while(i != startsAt);
      }
      else
      {
         int hiByte = (int)(curChar >> 8);
         int i1 = hiByte >> 6;
         long l1 = 1L << (hiByte & 077);
         int i2 = (curChar & 0xff) >> 6;
         long l2 = 1L << (curChar & 077);
         MatchLoop: do
         {
            switch(jjstateSet[--i])
            {
               case 0:
               case 38:
               case 40:
                  if (!jjCanMove_0(hiByte, i1, i2, l1, l2))
                     break;
                  if (kind > 312)
                     kind = 312;
                  jjCheckNAddStates(92, 95);
                  break;
               case 118:
                  if (!jjCanMove_0(hiByte, i1, i2, l1, l2))
                     break;
                  if (kind > 312)
                     kind = 312;
                  jjCheckNAddStates(92, 95);
                  break;
               case 9:
                  if (jjCanMove_0(hiByte, i1, i2, l1, l2))
                     jjAddStates(126, 128);
                  break;
               case 23:
                  if (jjCanMove_0(hiByte, i1, i2, l1, l2))
                     jjAddStates(133, 135);
                  break;
               case 42:
                  if (jjCanMove_0(hiByte, i1, i2, l1, l2))
                     jjAddStates(120, 122);
                  break;
               case 51:
                  if (jjCanMove_0(hiByte, i1, i2, l1, l2))
                     jjAddStates(117, 119);
                  break;
               case 91:
                  if (jjCanMove_0(hiByte, i1, i2, l1, l2))
                     jjAddStates(154, 156);
                  break;
               case 105:
                  if (jjCanMove_0(hiByte, i1, i2, l1, l2))
                     jjAddStates(161, 163);
                  break;
               default : break;
            }
         } while(i != startsAt);
      }
      if (kind != 0x7fffffff)
      {
         jjmatchedKind = kind;
         jjmatchedPos = curPos;
         kind = 0x7fffffff;
      }
      ++curPos;
      if ((i = jjnewStateCnt) == (startsAt = 118 - (jjnewStateCnt = startsAt)))
         return curPos;
      try { curChar = input_stream.readChar(); }
      catch(java.io.IOException e) { return curPos; }
   }
}
static final int[] jjnextStates = {
   78, 79, 84, 85, 88, 89, 13, 97, 108, 109, 115, 29, 30, 36, 15, 16, 
   22, 98, 99, 101, 1, 2, 4, 9, 10, 13, 15, 16, 25, 22, 29, 30, 
   39, 36, 43, 44, 50, 43, 44, 53, 50, 57, 58, 65, 57, 58, 68, 65, 
   80, 81, 13, 88, 89, 13, 104, 105, 107, 111, 112, 114, 117, 118, 120, 11, 
   12, 17, 23, 26, 27, 31, 37, 40, 41, 45, 51, 54, 55, 59, 66, 69, 
   70, 82, 83, 86, 87, 90, 91, 0, 1, 3, 4, 5, 38, 39, 41, 50, 
   40, 69, 72, 73, 78, 79, 82, 83, 7, 105, 106, 112, 42, 43, 49, 91, 
   92, 98, 51, 52, 58, 51, 52, 58, 42, 43, 49, 3, 4, 7, 9, 10, 
   16, 9, 10, 19, 16, 23, 24, 31, 23, 24, 34, 31, 51, 52, 61, 58, 
   42, 43, 66, 49, 74, 75, 7, 82, 83, 7, 91, 92, 98, 91, 92, 101, 
   98, 105, 106, 112, 105, 106, 115, 112, 5, 6, 11, 17, 20, 21, 25, 32, 
   35, 36, 44, 64, 67, 68, 53, 59, 62, 63, 76, 77, 80, 81, 84, 85, 
   93, 99, 102, 103, 107, 113, 116, 117, 
};
private static final boolean jjCanMove_0(int hiByte, int i1, int i2, long l1, long l2)
{
   switch(hiByte)
   {
      case 0:
         return ((jjbitVec2[i2] & l2) != 0L);
      default : 
         if ((jjbitVec0[i1] & l1) != 0L)
            return true;
         return false;
   }
}
private static final boolean jjCanMove_1(int hiByte, int i1, int i2, long l1, long l2)
{
   switch(hiByte)
   {
      case 0:
         return ((jjbitVec4[i2] & l2) != 0L);
      case 48:
         return ((jjbitVec5[i2] & l2) != 0L);
      case 49:
         return ((jjbitVec6[i2] & l2) != 0L);
      case 51:
         return ((jjbitVec7[i2] & l2) != 0L);
      case 61:
         return ((jjbitVec8[i2] & l2) != 0L);
      default : 
         if ((jjbitVec3[i1] & l1) != 0L)
            return true;
         return false;
   }
}
public static final String[] jjstrLiteralImages = {
"", null, null, null, null, null, null, null, null, null, null, 
"\165\163\141\147\145", "\141\156\164\164\141\163\153\72\72", "\152\141\166\141\72\72", 
"\143\157\155\72\72", "\170\155\154\72\72", "\105\156\144\123\143\162\151\160\164", "\145\157\146", 
"\105\117\106", "\141\163", "\142\162\145\141\153", "\143\141\163\145", 
"\143\141\164\143\150", "\143\157\156\163\164", "\143\157\156\164\151\156\165\145", 
"\143\157\156\163\164\162\165\143\164\157\162", "\143\164\157\162", "\144\145\146\141\165\154\164", "\143\154\141\163\163", 
"\144\145\146\151\156\145\144", "\144\145\154\145\164\145", "\144\157", "\145\154\151\146", 
"\145\154\163\145", "\145\170\145\143", "\145\170\164\145\156\144\163", 
"\145\170\164\145\156\144\163\152\141\166\141", "\146\141\154\163\145", "\146\151\156\141\154\154\171", "\146\157\162", 
"\146\162\157\155", "\146\165\156\143\164\151\157\156", "\154\141\155\142\144\141", 
"\164\150\162\145\141\144", "\152\141\166\141\143\154\141\163\163", "\151\146", "\151\146\144\145\146", 
"\151\146\156\144\145\146", "\151\146\145\170\151\163\164\163", "\151\155\160\157\162\164", "\151\156", 
"\151\156\146\151\156\151\164\171", "\151\156\164\157", "\41\151\156\143\154\165\144\145", "\154\157\143\141\154", 
"\156\145\167", "\152\141\166\141\156\145\167", "\155\141\170\137\156\165\155\142\145\162", 
"\155\151\156\137\156\165\155\142\145\162", "\156\165\154\154", "\41\160\162\141\147\155\141", 
"\41\112\141\166\141\107\165\151\103\154\141\163\163", "\41\112\141\166\141\102\141\163\145\103\154\141\163\163", 
"\41\112\141\166\141\105\156\164\145\162\160\162\151\163\145\103\154\141\163\163", "\41\112\141\166\141\103\157\162\142\141\103\154\141\163\163", 
"\41\112\103\157\155\103\154\141\163\163", "\41\112\141\166\141\120\141\143\153\141\147\145\163", 
"\41\104\145\146\151\156\145\112\141\166\141\120\141\143\153\141\147\145\163", "\154\151\155\151\164", "\156\141\155\145\163\160\141\143\145", 
"\163\153\151\160", "\162\145\163\165\155\145", "\162\145\164\165\162\156", 
"\163\164\162\151\160", "\163\165\160\145\162", "\163\167\151\164\143\150", "\164\150\151\163", 
"\164\150\162\157\167", "\164\157", "\165\160\164\157", "\164\171\160\145\157\146", 
"\141\164\164\162\151\142\165\164\145\163\157\146", "\157\156", "\144\157\167\156\164\157", "\164\162\165\145", "\164\162\171", 
"\165\156\144\145\162", "\165\156\144\145\146\151\156\145\144", "\165\163\151\156\147", 
"\165\163\145", "\166\141\162", "\167\150\145\162\145", "\167\150\151\154\145", 
"\167\151\164\150", "\142\157\157\154\145\141\156", "\142\171\164\145", "\143\150\141\162", 
"\163\150\157\162\164", "\151\156\164", "\154\157\156\147", "\146\154\157\141\164", 
"\144\157\165\142\154\145", "\123\164\162\151\156\147", "\163\164\162\151\156\147", "\166\157\151\144", 
"\155\141\151\154\72\72\163\145\156\144", "\155\141\151\154\72\72\143\157\156\156\145\143\164", 
"\155\141\151\154\72\72\144\151\163\143\157\156\156\145\143\164", "\163\145\156\144\115\141\151\154", "\143\143", "\142\143\143", 
"\141\164\164\141\143\150", "\163\165\142\152\145\143\164", "\142\157\144\171", 
"\150\164\155\154\102\157\144\171", "\154\151\156\153\145\144\114\151\163\164", 
"\114\151\156\153\145\144\114\151\163\164", "\163\145\164", "\123\145\164", "\163\157\162\164\145\144\115\141\160", 
"\123\157\162\164\145\144\115\141\160", "\144\141\164\145", "\104\141\164\145", "\156\165\155\142\145\162", 
"\116\165\155\142\145\162", "\143\157\154\165\155\156", "\145\162\162", "\154\157\147", "\156\154", 
"\157\165\164", "\160\151\160\145", "\151\156\160\165\164", "\157\165\164\160\165\164", 
"\156\145\145\144\123\171\163\164\145\155\111\156", "\146\154\165\163\150", "\160\162\151\156\164", 
"\160\162\151\156\164\154\156", "\160\162\151\156\164\124\141\142\154\145", 
"\160\162\151\156\164\124\141\142\154\145\104\141\164\141", "\163\143\160", "\143\157\160\171", "\155\141\156\151\146\145\163\164", 
"\154\151\163\164\106\151\154\145\163", "\154\163", "\157\162\144\145\162\145\144", "\142\171", 
"\162\155\144\151\162", "\145\170\143\145\160\164", "\163\145\164\106\151\154\145\124\151\155\145", 
"\163\145\164\122\145\141\144\117\156\154\171", "\163\145\164\122\145\141\144\127\162\151\164\145", 
"\164\141\162\147\145\164", "\141\144\144\102\141\164\143\150", "\143\157\156\156\145\143\164", 
"\145\170\145\143\165\164\145\102\141\164\143\150", "\145\170\145\143\165\164\145\121\165\145\162\171", 
"\145\170\145\143\165\164\145\121\165\145\162\171\103\141\154\154", "\145\170\145\143\165\164\145\101\156\171", 
"\145\170\145\143\165\164\145\123\121\114", "\145\170\145\143\165\164\145\125\160\144\141\164\145", 
"\145\170\145\143\165\164\145\125\160\144\141\164\145\103\141\154\154", "\157\156\123\165\143\143\145\163\163", "\160\162\145\160\141\162\145", 
"\160\162\145\160\141\162\145\103\141\154\154", "\160\162\145\160\141\162\145\144\105\170\145\143\165\164\145", 
"\160\162\145\160\141\162\145\144\105\170\145\143\165\164\145\103\141\154\154", 
"\160\162\145\160\141\162\145\144\105\170\145\143\165\164\145\121\165\145\162\171", 
"\160\162\145\160\141\162\145\144\105\170\145\143\165\164\145\121\165\145\162\171\103\141\154\154", 
"\160\162\145\160\141\162\145\144\105\170\145\143\165\164\145\125\160\144\141\164\145", 
"\160\162\145\160\141\162\145\144\105\170\145\143\165\164\145\125\160\144\141\164\145\103\141\154\154", "\144\142\72\72\144\165\155\160\124\141\142\154\145", 
"\144\142\72\72\141\144\144\102\141\164\143\150", "\144\142\72\72\143\157\156\156\145\143\164", 
"\144\142\72\72\144\151\163\143\157\156\156\145\143\164", "\144\142\72\72\142\141\164\143\150", "\144\142\72\72\161\165\145\162\171", 
"\144\142\72\72\161\165\145\162\171\103\141\154\154", "\144\142\72\72\141\156\171", "\144\142\72\72\163\161\154", 
"\144\142\72\72\143\141\154\154", "\144\142\72\72\165\160\144\141\164\145", 
"\144\142\72\72\165\160\144\141\164\145\103\141\154\154", "\144\142\72\72\160\162\145\160\141\162\145", 
"\144\142\72\72\160\162\145\160\141\162\145\103\141\154\154", "\145\152\142\161\154", "\150\151\142\72\72\163\145\164\165\160", 
"\150\151\142\72\72\141\144\144\103\154\141\163\163", "\150\151\142\72\72\141\144\144\122\145\163\157\165\162\143\145", 
"\150\151\142\72\72\143\154\157\163\145", "\150\151\142\72\72\164\170\102\145\147\151\156", 
"\150\151\142\72\72\164\170\105\156\144", "\150\151\142\72\72\164\170\101\142\157\162\164", 
"\150\151\142\72\72\154\157\143\153", "\150\151\142\72\72\161\165\145\162\171", 
"\150\151\142\72\72\151\164\145\162\141\164\145", "\150\151\142\72\72\144\145\154\145\164\145", 
"\150\151\142\72\72\147\145\164", "\150\151\142\72\72\163\141\166\145", 
"\150\151\142\72\72\163\141\166\145\117\162\125\160\144\141\164\145\103\157\160\171", "\150\151\142\72\72\165\156\154\157\143\153", 
"\150\151\142\72\72\165\160\144\141\164\145", "\167\163\144\154\72\72", "\141\146\164\145\162", "\162\145\160\145\141\164", 
"\163\143\150\145\144\165\154\145", "\163\164\141\162\164\151\156\147", "\170\155\154", "\170\163\154\164", 
"\170\160\141\164\150", "\163\171\163\164\145\155\111\104", 
"\157\165\164\160\165\164\120\162\157\160\145\162\164\151\145\163", "\160\141\162\141\155\145\164\145\162\163", "\144\157\155", 
"\170\155\154\156\163", "\150\164\155\154", "\152\163\160", "\163\147\155\154", 
"\147\165\151\105\166\145\156\164\163", "\147\165\151\72\72\145\166\145\156\164\163", "\74\41\55\55", "\74\41", 
"\74\77", "\74\45\100", "\74\45\41", "\74\45\75", "\74\45\55\55", "\74\45", null, null, 
null, null, null, null, null, null, null, null, null, null, null, null, null, null, 
null, null, "\55\76", "\75\76", "\74\75\76", "\75", "\72\75", "\76", "\74", 
"\74\57", "\41", "\41\41", "\100", "\176", "\133\133\52", "\133\133\133\52", "\77", 
"\72", "\72\72", "\75\75", "\75\75\75", "\74\75", "\76\75", "\41\75", "\41\75\75", 
"\174\174", "\46\46", "\53\53", "\55\55", "\53", "\55", "\52", "\57", "\52\52", "\46", 
"\174", "\136", "\45", "\74\74", "\76\76", "\76\76\76", "\100\75", "\53\75", "\55\75", 
"\52\75", "\57\75", "\46\75", "\46\46\75", "\174\75", "\174\174\75", "\136\75", 
"\45\75", "\74\74\75", "\76\76\75", "\76\76\76\75", "\44\173", "\173", "\175", 
"\173\173", "\175\175", "\50", "\51", "\133", "\135", "\54", "\56", "\56\56", "\50\52", 
"\52\51", null, "\73", "\52\135\135", null, "\52\135\135", };
public static final String[] lexStateNames = {
   "DEFAULT", 
   "MIXTURE", 
   "HEREDOC", 
};
public static final int[] jjnewLexState = {
   -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, 
   -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, 
   -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, 
   -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, 
   -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, 
   -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, 
   -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, 
   -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, 
   -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, 
   -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, 
   -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, 
   -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, 
   -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, 0, 0, 0, 0, -1, 
};
static final long[] jjtoToken = {
   0xfffffffffffff801L, 0xffffffffffffffffL, 0xffffffffffffffffL, 0xffe0f90fffffffffL, 
   0x1fffffffffffffffL, 
};
static final long[] jjtoSkip = {
   0x7feL, 0x0L, 0x0L, 0x0L, 
   0x0L, 
};
static final long[] jjtoSpecial = {
   0x7c0L, 0x0L, 0x0L, 0x0L, 
   0x0L, 
};
protected CharStream input_stream;
private final int[] jjrounds = new int[121];
private final int[] jjstateSet = new int[242];
StringBuffer image;
int jjimageLen;
int lengthOfMatch;
protected char curChar;
public JudoParserTokenManager(CharStream stream)
{
   input_stream = stream;
}
public JudoParserTokenManager(CharStream stream, int lexState)
{
   this(stream);
   SwitchTo(lexState);
}
public void ReInit(CharStream stream)
{
   jjmatchedPos = jjnewStateCnt = 0;
   curLexState = defaultLexState;
   input_stream = stream;
   ReInitRounds();
}
private final void ReInitRounds()
{
   int i;
   jjround = 0x80000001;
   for (i = 121; i-- > 0;)
      jjrounds[i] = 0x80000000;
}
public void ReInit(CharStream stream, int lexState)
{
   ReInit(stream);
   SwitchTo(lexState);
}
public void SwitchTo(int lexState)
{
   if (lexState >= 3 || lexState < 0)
      throw new TokenMgrError("Error: Ignoring invalid lexical state : " + lexState + ". State unchanged.", TokenMgrError.INVALID_LEXICAL_STATE);
   else
      curLexState = lexState;
}

protected Token jjFillToken()
{
   Token t = Token.newToken(jjmatchedKind);
   t.kind = jjmatchedKind;
   if (jjmatchedPos < 0)
   {
      if (image == null)
         t.image = "";
      else
         t.image = image.toString();
      t.beginLine = t.endLine = input_stream.getBeginLine();
      t.beginColumn = t.endColumn = input_stream.getBeginColumn();
   }
   else
   {
      String im = jjstrLiteralImages[jjmatchedKind];
      t.image = (im == null) ? input_stream.GetImage() : im;
      t.beginLine = input_stream.getBeginLine();
      t.beginColumn = input_stream.getBeginColumn();
      t.endLine = input_stream.getEndLine();
      t.endColumn = input_stream.getEndColumn();
   }
   return t;
}

int curLexState = 0;
int defaultLexState = 0;
int jjnewStateCnt;
int jjround;
int jjmatchedPos;
int jjmatchedKind;

public Token getNextToken() 
{
  int kind;
  Token specialToken = null;
  Token matchedToken;
  int curPos = 0;

  EOFLoop :
  for (;;)
  {   
   try   
   {     
      curChar = input_stream.BeginToken();
   }     
   catch(java.io.IOException e)
   {        
      jjmatchedKind = 0;
      matchedToken = jjFillToken();
      matchedToken.specialToken = specialToken;
      CommonTokenAction(matchedToken);
      return matchedToken;
   }
   image = null;
   jjimageLen = 0;

   switch(curLexState)
   {
     case 0:
       try { input_stream.backup(0);
          while (curChar <= 32 && (0x100003600L & (1L << curChar)) != 0L)
             curChar = input_stream.BeginToken();
       }
       catch (java.io.IOException e1) { continue EOFLoop; }
       jjmatchedKind = 0x7fffffff;
       jjmatchedPos = 0;
       curPos = jjMoveStringLiteralDfa0_0();
       break;
     case 1:
       jjmatchedKind = 312;
       jjmatchedPos = -1;
       curPos = 0;
       curPos = jjMoveStringLiteralDfa0_1();
       break;
     case 2:
       jjmatchedKind = 315;
       jjmatchedPos = -1;
       curPos = 0;
       curPos = jjMoveStringLiteralDfa0_2();
       break;
   }
     if (jjmatchedKind != 0x7fffffff)
     {
        if (jjmatchedPos + 1 < curPos)
           input_stream.backup(curPos - jjmatchedPos - 1);
        if ((jjtoToken[jjmatchedKind >> 6] & (1L << (jjmatchedKind & 077))) != 0L)
        {
           matchedToken = jjFillToken();
           matchedToken.specialToken = specialToken;
           TokenLexicalActions(matchedToken);
       if (jjnewLexState[jjmatchedKind] != -1)
         curLexState = jjnewLexState[jjmatchedKind];
           CommonTokenAction(matchedToken);
           return matchedToken;
        }
        else
        {
           if ((jjtoSpecial[jjmatchedKind >> 6] & (1L << (jjmatchedKind & 077))) != 0L)
           {
              matchedToken = jjFillToken();
              if (specialToken == null)
                 specialToken = matchedToken;
              else
              {
                 matchedToken.specialToken = specialToken;
                 specialToken = (specialToken.next = matchedToken);
              }
           }
         if (jjnewLexState[jjmatchedKind] != -1)
           curLexState = jjnewLexState[jjmatchedKind];
           continue EOFLoop;
        }
     }
     int error_line = input_stream.getEndLine();
     int error_column = input_stream.getEndColumn();
     String error_after = null;
     boolean EOFSeen = false;
     try { input_stream.readChar(); input_stream.backup(1); }
     catch (java.io.IOException e1) {
        EOFSeen = true;
        error_after = curPos <= 1 ? "" : input_stream.GetImage();
        if (curChar == '\n' || curChar == '\r') {
           error_line++;
           error_column = 0;
        }
        else
           error_column++;
     }
     if (!EOFSeen) {
        input_stream.backup(1);
        error_after = curPos <= 1 ? "" : input_stream.GetImage();
     }
     throw new TokenMgrError(EOFSeen, curLexState, error_line, error_column, error_after, curChar, TokenMgrError.LEXICAL_ERROR);
  }
}

void TokenLexicalActions(Token matchedToken)
{
   switch(jjmatchedKind)
   {
      case 311 :
        if (image == null)
            image = new StringBuffer(jjstrLiteralImages[311]);
         else
            image.append(jjstrLiteralImages[311]);
                          SwitchTo(inHereDoc ? HEREDOC : MIXTURE);
         break;
      default : 
         break;
   }
}
}
